/**
 * <copyright>
 * </copyright>
 *
 * $Id: IdlmmItemProviderAdapterFactory.java,v 1.32 2008/08/22 12:04:53 je Exp $
 */
package com.prismtech.idt.idlmm.provider;

import com.prismtech.idt.idlmm.util.IdlmmAdapterFactory;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;


/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class IdlmmItemProviderAdapterFactory extends IdlmmAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier,
      IDisposable
{
   /**
    * This keeps track of the root adapter factory that delegates to this adapter factory.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected ComposedAdapterFactory parentAdapterFactory;

   /**
    * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected IChangeNotifier changeNotifier = new ChangeNotifier ();

   /**
    * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected Collection<Object> supportedTypes = new ArrayList<Object> ();

   /**
    * This constructs an instance.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public IdlmmItemProviderAdapterFactory ()
   {
      supportedTypes.add (IEditingDomainItemProvider.class);
      supportedTypes.add (IStructuredItemContentProvider.class);
      supportedTypes.add (ITreeItemContentProvider.class);
      supportedTypes.add (IItemLabelProvider.class);
      supportedTypes.add (IItemPropertySource.class);
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.ModuleDef} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected ModuleDefItemProvider moduleDefItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.ModuleDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createModuleDefAdapter ()
   {
      if (moduleDefItemProvider == null)
      {
         moduleDefItemProvider = new ModuleDefItemProvider (this);
      }

      return moduleDefItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.Repository} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected RepositoryItemProvider repositoryItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.Repository}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createRepositoryAdapter ()
   {
      if (repositoryItemProvider == null)
      {
         repositoryItemProvider = new RepositoryItemProvider (this);
      }

      return repositoryItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.StringDef} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected StringDefItemProvider stringDefItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.StringDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createStringDefAdapter ()
   {
      if (stringDefItemProvider == null)
      {
         stringDefItemProvider = new StringDefItemProvider (this);
      }

      return stringDefItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.AliasDef} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected AliasDefItemProvider aliasDefItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.AliasDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createAliasDefAdapter ()
   {
      if (aliasDefItemProvider == null)
      {
         aliasDefItemProvider = new AliasDefItemProvider (this);
      }

      return aliasDefItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.PrimitiveDef} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected PrimitiveDefItemProvider primitiveDefItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.PrimitiveDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createPrimitiveDefAdapter ()
   {
      if (primitiveDefItemProvider == null)
      {
         primitiveDefItemProvider = new PrimitiveDefItemProvider (this);
      }

      return primitiveDefItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.WStringDef} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected WStringDefItemProvider wStringDefItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.WStringDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createWStringDefAdapter ()
   {
      if (wStringDefItemProvider == null)
      {
         wStringDefItemProvider = new WStringDefItemProvider (this);
      }

      return wStringDefItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.SequenceDef} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected SequenceDefItemProvider sequenceDefItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.SequenceDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createSequenceDefAdapter ()
   {
      if (sequenceDefItemProvider == null)
      {
         sequenceDefItemProvider = new SequenceDefItemProvider (this);
      }

      return sequenceDefItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.ArrayDef} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected ArrayDefItemProvider arrayDefItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.ArrayDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createArrayDefAdapter ()
   {
      if (arrayDefItemProvider == null)
      {
         arrayDefItemProvider = new ArrayDefItemProvider (this);
      }

      return arrayDefItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.FixedDef} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected FixedDefItemProvider fixedDefItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.FixedDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createFixedDefAdapter ()
   {
      if (fixedDefItemProvider == null)
      {
         fixedDefItemProvider = new FixedDefItemProvider (this);
      }

      return fixedDefItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.StructDef} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected StructDefItemProvider structDefItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.StructDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createStructDefAdapter ()
   {
      if (structDefItemProvider == null)
      {
         structDefItemProvider = new StructDefItemProvider (this);
      }

      return structDefItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.StructMember} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected StructMemberItemProvider structMemberItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.StructMember}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createStructMemberAdapter ()
   {
      if (structMemberItemProvider == null)
      {
         structMemberItemProvider = new StructMemberItemProvider (this);
      }

      return structMemberItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.InterfaceDef} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected InterfaceDefItemProvider interfaceDefItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.InterfaceDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createInterfaceDefAdapter ()
   {
      if (interfaceDefItemProvider == null)
      {
         interfaceDefItemProvider = new InterfaceDefItemProvider (this);
      }

      return interfaceDefItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.UnionDef} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected UnionDefItemProvider unionDefItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.UnionDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createUnionDefAdapter ()
   {
      if (unionDefItemProvider == null)
      {
         unionDefItemProvider = new UnionDefItemProvider (this);
      }

      return unionDefItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.EnumDef} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected EnumDefItemProvider enumDefItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.EnumDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createEnumDefAdapter ()
   {
      if (enumDefItemProvider == null)
      {
         enumDefItemProvider = new EnumDefItemProvider (this);
      }

      return enumDefItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.ConstantDef} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected ConstantDefItemProvider constantDefItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.ConstantDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createConstantDefAdapter ()
   {
      if (constantDefItemProvider == null)
      {
         constantDefItemProvider = new ConstantDefItemProvider (this);
      }

      return constantDefItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.EnumMember} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected EnumMemberItemProvider enumMemberItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.EnumMember}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createEnumMemberAdapter ()
   {
      if (enumMemberItemProvider == null)
      {
         enumMemberItemProvider = new EnumMemberItemProvider (this);
      }

      return enumMemberItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.UnionMember} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected UnionMemberItemProvider unionMemberItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.UnionMember}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createUnionMemberAdapter ()
   {
      if (unionMemberItemProvider == null)
      {
         unionMemberItemProvider = new UnionMemberItemProvider (this);
      }

      return unionMemberItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.ExceptionDef} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected ExceptionDefItemProvider exceptionDefItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.ExceptionDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createExceptionDefAdapter ()
   {
      if (exceptionDefItemProvider == null)
      {
         exceptionDefItemProvider = new ExceptionDefItemProvider (this);
      }

      return exceptionDefItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.AttributeDef} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected AttributeDefItemProvider attributeDefItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.AttributeDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createAttributeDefAdapter ()
   {
      if (attributeDefItemProvider == null)
      {
         attributeDefItemProvider = new AttributeDefItemProvider (this);
      }

      return attributeDefItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.ParameterDef} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected ParameterDefItemProvider parameterDefItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.ParameterDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createParameterDefAdapter ()
   {
      if (parameterDefItemProvider == null)
      {
         parameterDefItemProvider = new ParameterDefItemProvider (this);
      }

      return parameterDefItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.OperationDef} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected OperationDefItemProvider operationDefItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.OperationDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createOperationDefAdapter ()
   {
      if (operationDefItemProvider == null)
      {
         operationDefItemProvider = new OperationDefItemProvider (this);
      }

      return operationDefItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.ValueMemberDef} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected ValueMemberDefItemProvider valueMemberDefItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.ValueMemberDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createValueMemberDefAdapter ()
   {
      if (valueMemberDefItemProvider == null)
      {
         valueMemberDefItemProvider = new ValueMemberDefItemProvider (this);
      }

      return valueMemberDefItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.ValueDef} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected ValueDefItemProvider valueDefItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.ValueDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createValueDefAdapter ()
   {
      if (valueDefItemProvider == null)
      {
         valueDefItemProvider = new ValueDefItemProvider (this);
      }

      return valueDefItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.Initializer} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected InitializerItemProvider initializerItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.Initializer}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createInitializerAdapter ()
   {
      if (initializerItemProvider == null)
      {
         initializerItemProvider = new InitializerItemProvider (this);
      }

      return initializerItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.ValueBoxDef} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected ValueBoxDefItemProvider valueBoxDefItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.ValueBoxDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createValueBoxDefAdapter ()
   {
      if (valueBoxDefItemProvider == null)
      {
         valueBoxDefItemProvider = new ValueBoxDefItemProvider (this);
      }

      return valueBoxDefItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.NativeDef} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected NativeDefItemProvider nativeDefItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.NativeDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createNativeDefAdapter ()
   {
      if (nativeDefItemProvider == null)
      {
         nativeDefItemProvider = new NativeDefItemProvider (this);
      }

      return nativeDefItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.ExceptionMember} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected ExceptionMemberItemProvider exceptionMemberItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.ExceptionMember}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createExceptionMemberAdapter ()
   {
      if (exceptionMemberItemProvider == null)
      {
         exceptionMemberItemProvider = new ExceptionMemberItemProvider (this);
      }

      return exceptionMemberItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.BitwiseComplementOperator} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected BitwiseComplementOperatorItemProvider bitwiseComplementOperatorItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.BitwiseComplementOperator}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createBitwiseComplementOperatorAdapter ()
   {
      if (bitwiseComplementOperatorItemProvider == null)
      {
         bitwiseComplementOperatorItemProvider = new BitwiseComplementOperatorItemProvider (this);
      }

      return bitwiseComplementOperatorItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.BitwiseRightShiftOperator} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected BitwiseRightShiftOperatorItemProvider bitwiseRightShiftOperatorItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.BitwiseRightShiftOperator}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createBitwiseRightShiftOperatorAdapter ()
   {
      if (bitwiseRightShiftOperatorItemProvider == null)
      {
         bitwiseRightShiftOperatorItemProvider = new BitwiseRightShiftOperatorItemProvider (this);
      }

      return bitwiseRightShiftOperatorItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.BitwiseLeftShiftOperator} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected BitwiseLeftShiftOperatorItemProvider bitwiseLeftShiftOperatorItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.BitwiseLeftShiftOperator}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createBitwiseLeftShiftOperatorAdapter ()
   {
      if (bitwiseLeftShiftOperatorItemProvider == null)
      {
         bitwiseLeftShiftOperatorItemProvider = new BitwiseLeftShiftOperatorItemProvider (this);
      }

      return bitwiseLeftShiftOperatorItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.BitwiseAndOperator} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected BitwiseAndOperatorItemProvider bitwiseAndOperatorItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.BitwiseAndOperator}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createBitwiseAndOperatorAdapter ()
   {
      if (bitwiseAndOperatorItemProvider == null)
      {
         bitwiseAndOperatorItemProvider = new BitwiseAndOperatorItemProvider (this);
      }

      return bitwiseAndOperatorItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.AddOperator} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected AddOperatorItemProvider addOperatorItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.AddOperator}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createAddOperatorAdapter ()
   {
      if (addOperatorItemProvider == null)
      {
         addOperatorItemProvider = new AddOperatorItemProvider (this);
      }

      return addOperatorItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.BitwiseXorOperator} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected BitwiseXorOperatorItemProvider bitwiseXorOperatorItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.BitwiseXorOperator}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createBitwiseXorOperatorAdapter ()
   {
      if (bitwiseXorOperatorItemProvider == null)
      {
         bitwiseXorOperatorItemProvider = new BitwiseXorOperatorItemProvider (this);
      }

      return bitwiseXorOperatorItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.PositiveOperator} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected PositiveOperatorItemProvider positiveOperatorItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.PositiveOperator}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createPositiveOperatorAdapter ()
   {
      if (positiveOperatorItemProvider == null)
      {
         positiveOperatorItemProvider = new PositiveOperatorItemProvider (this);
      }

      return positiveOperatorItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.NegativeOperator} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected NegativeOperatorItemProvider negativeOperatorItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.NegativeOperator}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createNegativeOperatorAdapter ()
   {
      if (negativeOperatorItemProvider == null)
      {
         negativeOperatorItemProvider = new NegativeOperatorItemProvider (this);
      }

      return negativeOperatorItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.BitwiseOrOperator} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected BitwiseOrOperatorItemProvider bitwiseOrOperatorItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.BitwiseOrOperator}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createBitwiseOrOperatorAdapter ()
   {
      if (bitwiseOrOperatorItemProvider == null)
      {
         bitwiseOrOperatorItemProvider = new BitwiseOrOperatorItemProvider (this);
      }

      return bitwiseOrOperatorItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.SubtractOperator} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected SubtractOperatorItemProvider subtractOperatorItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.SubtractOperator}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createSubtractOperatorAdapter ()
   {
      if (subtractOperatorItemProvider == null)
      {
         subtractOperatorItemProvider = new SubtractOperatorItemProvider (this);
      }

      return subtractOperatorItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.MultiplyOperator} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected MultiplyOperatorItemProvider multiplyOperatorItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.MultiplyOperator}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createMultiplyOperatorAdapter ()
   {
      if (multiplyOperatorItemProvider == null)
      {
         multiplyOperatorItemProvider = new MultiplyOperatorItemProvider (this);
      }

      return multiplyOperatorItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.ModuloOperator} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected ModuloOperatorItemProvider moduloOperatorItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.ModuloOperator}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createModuloOperatorAdapter ()
   {
      if (moduloOperatorItemProvider == null)
      {
         moduloOperatorItemProvider = new ModuloOperatorItemProvider (this);
      }

      return moduloOperatorItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.DivideOperator} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected DivideOperatorItemProvider divideOperatorItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.DivideOperator}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createDivideOperatorAdapter ()
   {
      if (divideOperatorItemProvider == null)
      {
         divideOperatorItemProvider = new DivideOperatorItemProvider (this);
      }

      return divideOperatorItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.InterfaceDecl} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected InterfaceDeclItemProvider interfaceDeclItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.InterfaceDecl}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createInterfaceDeclAdapter ()
   {
      if (interfaceDeclItemProvider == null)
      {
         interfaceDeclItemProvider = new InterfaceDeclItemProvider (this);
      }

      return interfaceDeclItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.PrePragma} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected PrePragmaItemProvider prePragmaItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.PrePragma}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createPrePragmaAdapter ()
   {
      if (prePragmaItemProvider == null)
      {
         prePragmaItemProvider = new PrePragmaItemProvider (this);
      }

      return prePragmaItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.PostPragma} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected PostPragmaItemProvider postPragmaItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.PostPragma}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createPostPragmaAdapter ()
   {
      if (postPragmaItemProvider == null)
      {
         postPragmaItemProvider = new PostPragmaItemProvider (this);
      }

      return postPragmaItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.ScopePragma} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected ScopePragmaItemProvider scopePragmaItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.ScopePragma}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createScopePragmaAdapter ()
   {
      if (scopePragmaItemProvider == null)
      {
         scopePragmaItemProvider = new ScopePragmaItemProvider (this);
      }

      return scopePragmaItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.BooleanLiteral} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected BooleanLiteralItemProvider booleanLiteralItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.BooleanLiteral}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createBooleanLiteralAdapter ()
   {
      if (booleanLiteralItemProvider == null)
      {
         booleanLiteralItemProvider = new BooleanLiteralItemProvider (this);
      }

      return booleanLiteralItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.CharacterLiteral} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected CharacterLiteralItemProvider characterLiteralItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.CharacterLiteral}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createCharacterLiteralAdapter ()
   {
      if (characterLiteralItemProvider == null)
      {
         characterLiteralItemProvider = new CharacterLiteralItemProvider (this);
      }

      return characterLiteralItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.FixedPointLiteral} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected FixedPointLiteralItemProvider fixedPointLiteralItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.FixedPointLiteral}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createFixedPointLiteralAdapter ()
   {
      if (fixedPointLiteralItemProvider == null)
      {
         fixedPointLiteralItemProvider = new FixedPointLiteralItemProvider (this);
      }

      return fixedPointLiteralItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.FloatingPointLiteral} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected FloatingPointLiteralItemProvider floatingPointLiteralItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.FloatingPointLiteral}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createFloatingPointLiteralAdapter ()
   {
      if (floatingPointLiteralItemProvider == null)
      {
         floatingPointLiteralItemProvider = new FloatingPointLiteralItemProvider (this);
      }

      return floatingPointLiteralItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.IntegerLiteral} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected IntegerLiteralItemProvider integerLiteralItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.IntegerLiteral}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createIntegerLiteralAdapter ()
   {
      if (integerLiteralItemProvider == null)
      {
         integerLiteralItemProvider = new IntegerLiteralItemProvider (this);
      }

      return integerLiteralItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.StringLiteral} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected StringLiteralItemProvider stringLiteralItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.StringLiteral}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createStringLiteralAdapter ()
   {
      if (stringLiteralItemProvider == null)
      {
         stringLiteralItemProvider = new StringLiteralItemProvider (this);
      }

      return stringLiteralItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.WCharacterLiteral} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected WCharacterLiteralItemProvider wCharacterLiteralItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.WCharacterLiteral}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createWCharacterLiteralAdapter ()
   {
      if (wCharacterLiteralItemProvider == null)
      {
         wCharacterLiteralItemProvider = new WCharacterLiteralItemProvider (this);
      }

      return wCharacterLiteralItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.WStringLiteral} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected WStringLiteralItemProvider wStringLiteralItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.WStringLiteral}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createWStringLiteralAdapter ()
   {
      if (wStringLiteralItemProvider == null)
      {
         wStringLiteralItemProvider = new WStringLiteralItemProvider (this);
      }

      return wStringLiteralItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.ValueDecl} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected ValueDeclItemProvider valueDeclItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.ValueDecl}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createValueDeclAdapter ()
   {
      if (valueDeclItemProvider == null)
      {
         valueDeclItemProvider = new ValueDeclItemProvider (this);
      }

      return valueDeclItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.InitializerParameterDef} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected InitializerParameterDefItemProvider initializerParameterDefItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.InitializerParameterDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createInitializerParameterDefAdapter ()
   {
      if (initializerParameterDefItemProvider == null)
      {
         initializerParameterDefItemProvider = new InitializerParameterDefItemProvider (this);
      }

      return initializerParameterDefItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.ComponentDef} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected ComponentDefItemProvider componentDefItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.ComponentDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createComponentDefAdapter ()
   {
      if (componentDefItemProvider == null)
      {
         componentDefItemProvider = new ComponentDefItemProvider (this);
      }

      return componentDefItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.ComponentDecl} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected ComponentDeclItemProvider componentDeclItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.ComponentDecl}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createComponentDeclAdapter ()
   {
      if (componentDeclItemProvider == null)
      {
         componentDeclItemProvider = new ComponentDeclItemProvider (this);
      }

      return componentDeclItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.HomeDef} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected HomeDefItemProvider homeDefItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.HomeDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createHomeDefAdapter ()
   {
      if (homeDefItemProvider == null)
      {
         homeDefItemProvider = new HomeDefItemProvider (this);
      }

      return homeDefItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.FactoryOperation} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected FactoryOperationItemProvider factoryOperationItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.FactoryOperation}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createFactoryOperationAdapter ()
   {
      if (factoryOperationItemProvider == null)
      {
         factoryOperationItemProvider = new FactoryOperationItemProvider (this);
      }

      return factoryOperationItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.FinderOperation} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected FinderOperationItemProvider finderOperationItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.FinderOperation}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createFinderOperationAdapter ()
   {
      if (finderOperationItemProvider == null)
      {
         finderOperationItemProvider = new FinderOperationItemProvider (this);
      }

      return finderOperationItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.ProvidesDef} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected ProvidesDefItemProvider providesDefItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.ProvidesDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createProvidesDefAdapter ()
   {
      if (providesDefItemProvider == null)
      {
         providesDefItemProvider = new ProvidesDefItemProvider (this);
      }

      return providesDefItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.UsesDef} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected UsesDefItemProvider usesDefItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.UsesDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createUsesDefAdapter ()
   {
      if (usesDefItemProvider == null)
      {
         usesDefItemProvider = new UsesDefItemProvider (this);
      }

      return usesDefItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.ConsumesDef} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected ConsumesDefItemProvider consumesDefItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.ConsumesDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createConsumesDefAdapter ()
   {
      if (consumesDefItemProvider == null)
      {
         consumesDefItemProvider = new ConsumesDefItemProvider (this);
      }

      return consumesDefItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.PublishesDef} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected PublishesDefItemProvider publishesDefItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.PublishesDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createPublishesDefAdapter ()
   {
      if (publishesDefItemProvider == null)
      {
         publishesDefItemProvider = new PublishesDefItemProvider (this);
      }

      return publishesDefItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.EmitsDef} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected EmitsDefItemProvider emitsDefItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.EmitsDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createEmitsDefAdapter ()
   {
      if (emitsDefItemProvider == null)
      {
         emitsDefItemProvider = new EmitsDefItemProvider (this);
      }

      return emitsDefItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.EventDecl} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected EventDeclItemProvider eventDeclItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.EventDecl}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createEventDeclAdapter ()
   {
      if (eventDeclItemProvider == null)
      {
         eventDeclItemProvider = new EventDeclItemProvider (this);
      }

      return eventDeclItemProvider;
   }

   /**
    * This keeps track of the one adapter used for all {@link com.prismtech.idt.idlmm.EventDef} instances.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected EventDefItemProvider eventDefItemProvider;

   /**
    * This creates an adapter for a {@link com.prismtech.idt.idlmm.EventDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter createEventDefAdapter ()
   {
      if (eventDefItemProvider == null)
      {
         eventDefItemProvider = new EventDefItemProvider (this);
      }

      return eventDefItemProvider;
   }

   /**
    * This returns the root adapter factory that contains this factory.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public ComposeableAdapterFactory getRootAdapterFactory ()
   {
      return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory ();
   }

   /**
    * This sets the composed adapter factory that contains this factory.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setParentAdapterFactory (ComposedAdapterFactory parentAdapterFactory)
   {
      this.parentAdapterFactory = parentAdapterFactory;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public boolean isFactoryForType (Object type)
   {
      return supportedTypes.contains (type) || super.isFactoryForType (type);
   }

   /**
    * This implementation substitutes the factory itself as the key for the adapter.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Adapter adapt (Notifier notifier, Object type)
   {
      return super.adapt (notifier, this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Object adapt (Object object, Object type)
   {
      if (isFactoryForType (type))
      {
         Object adapter = super.adapt (object, type);
         if (! (type instanceof Class) || ( ((Class<?>) type).isInstance (adapter)))
         {
            return adapter;
         }
      }

      return null;
   }

   /**
    * This adds a listener.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void addListener (INotifyChangedListener notifyChangedListener)
   {
      changeNotifier.addListener (notifyChangedListener);
   }

   /**
    * This removes a listener.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void removeListener (INotifyChangedListener notifyChangedListener)
   {
      changeNotifier.removeListener (notifyChangedListener);
   }

   /**
    * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void fireNotifyChanged (Notification notification)
   {
      changeNotifier.fireNotifyChanged (notification);

      if (parentAdapterFactory != null)
      {
         parentAdapterFactory.fireNotifyChanged (notification);
      }
   }

   /**
    * This disposes all of the item providers created by this factory. 
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void dispose ()
   {
      if (moduleDefItemProvider != null)
         moduleDefItemProvider.dispose ();
      if (repositoryItemProvider != null)
         repositoryItemProvider.dispose ();
      if (stringDefItemProvider != null)
         stringDefItemProvider.dispose ();
      if (aliasDefItemProvider != null)
         aliasDefItemProvider.dispose ();
      if (primitiveDefItemProvider != null)
         primitiveDefItemProvider.dispose ();
      if (wStringDefItemProvider != null)
         wStringDefItemProvider.dispose ();
      if (sequenceDefItemProvider != null)
         sequenceDefItemProvider.dispose ();
      if (arrayDefItemProvider != null)
         arrayDefItemProvider.dispose ();
      if (fixedDefItemProvider != null)
         fixedDefItemProvider.dispose ();
      if (structDefItemProvider != null)
         structDefItemProvider.dispose ();
      if (structMemberItemProvider != null)
         structMemberItemProvider.dispose ();
      if (interfaceDefItemProvider != null)
         interfaceDefItemProvider.dispose ();
      if (unionDefItemProvider != null)
         unionDefItemProvider.dispose ();
      if (enumDefItemProvider != null)
         enumDefItemProvider.dispose ();
      if (constantDefItemProvider != null)
         constantDefItemProvider.dispose ();
      if (enumMemberItemProvider != null)
         enumMemberItemProvider.dispose ();
      if (unionMemberItemProvider != null)
         unionMemberItemProvider.dispose ();
      if (exceptionDefItemProvider != null)
         exceptionDefItemProvider.dispose ();
      if (attributeDefItemProvider != null)
         attributeDefItemProvider.dispose ();
      if (parameterDefItemProvider != null)
         parameterDefItemProvider.dispose ();
      if (operationDefItemProvider != null)
         operationDefItemProvider.dispose ();
      if (valueMemberDefItemProvider != null)
         valueMemberDefItemProvider.dispose ();
      if (valueDefItemProvider != null)
         valueDefItemProvider.dispose ();
      if (initializerItemProvider != null)
         initializerItemProvider.dispose ();
      if (valueBoxDefItemProvider != null)
         valueBoxDefItemProvider.dispose ();
      if (nativeDefItemProvider != null)
         nativeDefItemProvider.dispose ();
      if (exceptionMemberItemProvider != null)
         exceptionMemberItemProvider.dispose ();
      if (bitwiseComplementOperatorItemProvider != null)
         bitwiseComplementOperatorItemProvider.dispose ();
      if (bitwiseRightShiftOperatorItemProvider != null)
         bitwiseRightShiftOperatorItemProvider.dispose ();
      if (bitwiseLeftShiftOperatorItemProvider != null)
         bitwiseLeftShiftOperatorItemProvider.dispose ();
      if (bitwiseAndOperatorItemProvider != null)
         bitwiseAndOperatorItemProvider.dispose ();
      if (addOperatorItemProvider != null)
         addOperatorItemProvider.dispose ();
      if (bitwiseXorOperatorItemProvider != null)
         bitwiseXorOperatorItemProvider.dispose ();
      if (positiveOperatorItemProvider != null)
         positiveOperatorItemProvider.dispose ();
      if (negativeOperatorItemProvider != null)
         negativeOperatorItemProvider.dispose ();
      if (bitwiseOrOperatorItemProvider != null)
         bitwiseOrOperatorItemProvider.dispose ();
      if (subtractOperatorItemProvider != null)
         subtractOperatorItemProvider.dispose ();
      if (multiplyOperatorItemProvider != null)
         multiplyOperatorItemProvider.dispose ();
      if (moduloOperatorItemProvider != null)
         moduloOperatorItemProvider.dispose ();
      if (divideOperatorItemProvider != null)
         divideOperatorItemProvider.dispose ();
      if (interfaceDeclItemProvider != null)
         interfaceDeclItemProvider.dispose ();
      if (prePragmaItemProvider != null)
         prePragmaItemProvider.dispose ();
      if (postPragmaItemProvider != null)
         postPragmaItemProvider.dispose ();
      if (scopePragmaItemProvider != null)
         scopePragmaItemProvider.dispose ();
      if (booleanLiteralItemProvider != null)
         booleanLiteralItemProvider.dispose ();
      if (characterLiteralItemProvider != null)
         characterLiteralItemProvider.dispose ();
      if (fixedPointLiteralItemProvider != null)
         fixedPointLiteralItemProvider.dispose ();
      if (floatingPointLiteralItemProvider != null)
         floatingPointLiteralItemProvider.dispose ();
      if (integerLiteralItemProvider != null)
         integerLiteralItemProvider.dispose ();
      if (stringLiteralItemProvider != null)
         stringLiteralItemProvider.dispose ();
      if (wCharacterLiteralItemProvider != null)
         wCharacterLiteralItemProvider.dispose ();
      if (wStringLiteralItemProvider != null)
         wStringLiteralItemProvider.dispose ();
      if (valueDeclItemProvider != null)
         valueDeclItemProvider.dispose ();
      if (initializerParameterDefItemProvider != null)
         initializerParameterDefItemProvider.dispose ();
      if (componentDefItemProvider != null)
         componentDefItemProvider.dispose ();
      if (componentDeclItemProvider != null)
         componentDeclItemProvider.dispose ();
      if (homeDefItemProvider != null)
         homeDefItemProvider.dispose ();
      if (factoryOperationItemProvider != null)
         factoryOperationItemProvider.dispose ();
      if (finderOperationItemProvider != null)
         finderOperationItemProvider.dispose ();
      if (providesDefItemProvider != null)
         providesDefItemProvider.dispose ();
      if (usesDefItemProvider != null)
         usesDefItemProvider.dispose ();
      if (consumesDefItemProvider != null)
         consumesDefItemProvider.dispose ();
      if (publishesDefItemProvider != null)
         publishesDefItemProvider.dispose ();
      if (emitsDefItemProvider != null)
         emitsDefItemProvider.dispose ();
      if (eventDeclItemProvider != null)
         eventDeclItemProvider.dispose ();
      if (eventDefItemProvider != null)
         eventDefItemProvider.dispose ();
   }

}
