/**
 * <copyright>
 * </copyright>
 *
 * $Id: TypedItemProvider.java,v 1.25 2008/07/02 14:58:31 gm Exp $
 */
package com.prismtech.idt.idlmm.provider;

import com.prismtech.idt.idlmm.IdlmmFactory;
import com.prismtech.idt.idlmm.IdlmmPackage;
import com.prismtech.idt.idlmm.Typed;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ViewerNotification;


/**
 * This is the item provider adapter for a {@link com.prismtech.idt.idlmm.Typed} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class TypedItemProvider extends IRObjectItemProvider implements IEditingDomainItemProvider, IStructuredItemContentProvider,
      ITreeItemContentProvider, IItemLabelProvider, IItemPropertySource
{
   /**
    * This constructs an instance from a factory and a notifier.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public TypedItemProvider (AdapterFactory adapterFactory)
   {
      super (adapterFactory);
   }

   /**
    * This returns the property descriptors for the adapted class.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public List<IItemPropertyDescriptor> getPropertyDescriptors (Object object)
   {
      if (itemPropertyDescriptors == null)
      {
         super.getPropertyDescriptors (object);

         addTypePropertyDescriptor (object);
         addSharedTypePropertyDescriptor (object);
      }
      return itemPropertyDescriptors;
   }

   /**
    * This adds a property descriptor for the Type feature.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected void addTypePropertyDescriptor (Object object)
   {
      itemPropertyDescriptors.add (createItemPropertyDescriptor ( ((ComposeableAdapterFactory) adapterFactory)
            .getRootAdapterFactory (), getResourceLocator (), getString ("_UI_Typed_type_feature"), getString (
            "_UI_PropertyDescriptor_description", "_UI_Typed_type_feature", "_UI_Typed_type"), IdlmmPackage.Literals.TYPED__TYPE,
            true, false, true, null, null, null));
   }

   /**
    * This adds a property descriptor for the Shared Type feature.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected void addSharedTypePropertyDescriptor (Object object)
   {
      itemPropertyDescriptors.add (createItemPropertyDescriptor ( ((ComposeableAdapterFactory) adapterFactory)
            .getRootAdapterFactory (), getResourceLocator (), getString ("_UI_Typed_sharedType_feature"), getString (
            "_UI_PropertyDescriptor_description", "_UI_Typed_sharedType_feature", "_UI_Typed_type"),
            IdlmmPackage.Literals.TYPED__SHARED_TYPE, true, false, true, null, null, null));
   }

   /**
    * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
    * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
    * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Collection<? extends EStructuralFeature> getChildrenFeatures (Object object)
   {
      if (childrenFeatures == null)
      {
         super.getChildrenFeatures (object);
         childrenFeatures.add (IdlmmPackage.Literals.TYPED__OWNED_TYPE);
      }
      return childrenFeatures;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   protected EStructuralFeature getChildFeature (Object object, Object child)
   {
      // Check the type of the specified child object and return the proper feature to use for
      // adding (see {@link AddCommand}) it as a child.

      return super.getChildFeature (object, child);
   }

   /**
    * This returns the label text for the adapted class.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public String getText (Object object)
   {
      String label = ((Typed) object).getSource ();
      return label == null || label.length () == 0 ? getString ("_UI_Typed_type") : getString ("_UI_Typed_type") + " " + label;
   }

   /**
    * This handles model notifications by calling {@link #updateChildren} to update any cached
    * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public void notifyChanged (Notification notification)
   {
      updateChildren (notification);

      switch (notification.getFeatureID (Typed.class))
      {
         case IdlmmPackage.TYPED__OWNED_TYPE:
            fireNotifyChanged (new ViewerNotification (notification, notification.getNotifier (), true, false));
            return;
      }
      super.notifyChanged (notification);
   }

   /**
    * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
    * that can be created under this object.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   protected void collectNewChildDescriptors (Collection<Object> newChildDescriptors, Object object)
   {
      super.collectNewChildDescriptors (newChildDescriptors, object);

      newChildDescriptors.add (createChildParameter (IdlmmPackage.Literals.TYPED__OWNED_TYPE, IdlmmFactory.eINSTANCE
            .createStringDef ()));

      newChildDescriptors.add (createChildParameter (IdlmmPackage.Literals.TYPED__OWNED_TYPE, IdlmmFactory.eINSTANCE
            .createPrimitiveDef ()));

      newChildDescriptors.add (createChildParameter (IdlmmPackage.Literals.TYPED__OWNED_TYPE, IdlmmFactory.eINSTANCE
            .createWStringDef ()));

      newChildDescriptors.add (createChildParameter (IdlmmPackage.Literals.TYPED__OWNED_TYPE, IdlmmFactory.eINSTANCE
            .createSequenceDef ()));

      newChildDescriptors.add (createChildParameter (IdlmmPackage.Literals.TYPED__OWNED_TYPE, IdlmmFactory.eINSTANCE
            .createArrayDef ()));

      newChildDescriptors.add (createChildParameter (IdlmmPackage.Literals.TYPED__OWNED_TYPE, IdlmmFactory.eINSTANCE
            .createFixedDef ()));
   }

   /**
    * Return the resource locator for this item provider's resources.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public ResourceLocator getResourceLocator ()
   {
      return IdlmmEditPlugin.INSTANCE;
   }

}
