/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package com.prismtech.idt.idlmm.provider;

import com.prismtech.idt.idlmm.IdlmmFactory;
import com.prismtech.idt.idlmm.IdlmmPackage;
import com.prismtech.idt.idlmm.UnaryOperator;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ViewerNotification;


/**
 * This is the item provider adapter for a {@link com.prismtech.idt.idlmm.UnaryOperator} object.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class UnaryOperatorItemProvider extends OperatorItemProvider implements IEditingDomainItemProvider,
      IStructuredItemContentProvider, ITreeItemContentProvider, IItemLabelProvider, IItemPropertySource
{
   /**
    * This constructs an instance from a factory and a notifier.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public UnaryOperatorItemProvider (AdapterFactory adapterFactory)
   {
      super (adapterFactory);
   }

   /**
    * This returns the property descriptors for the adapted class.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public List<IItemPropertyDescriptor> getPropertyDescriptors (Object object)
   {
      if (itemPropertyDescriptors == null)
      {
         super.getPropertyDescriptors (object);

         addOperandPropertyDescriptor (object);
      }
      return itemPropertyDescriptors;
   }

   /**
    * This adds a property descriptor for the Operand feature.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected void addOperandPropertyDescriptor (Object object)
   {
      itemPropertyDescriptors.add (createItemPropertyDescriptor ( ((ComposeableAdapterFactory) adapterFactory)
            .getRootAdapterFactory (), getResourceLocator (), getString ("_UI_UnaryOperator_operand_feature"), getString (
            "_UI_PropertyDescriptor_description", "_UI_UnaryOperator_operand_feature", "_UI_UnaryOperator_type"),
            IdlmmPackage.Literals.UNARY_OPERATOR__OPERAND, true, false, true, null, null, null));
   }

   /**
    * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
    * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
    * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Collection<? extends EStructuralFeature> getChildrenFeatures (Object object)
   {
      if (childrenFeatures == null)
      {
         super.getChildrenFeatures (object);
         childrenFeatures.add (IdlmmPackage.Literals.UNARY_OPERATOR__OWNED_OPERAND);
      }
      return childrenFeatures;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   protected EStructuralFeature getChildFeature (Object object, Object child)
   {
      // Check the type of the specified child object and return the proper feature to use for
      // adding (see {@link AddCommand}) it as a child.

      return super.getChildFeature (object, child);
   }

   /**
    * This returns the label text for the adapted class.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public String getText (Object object)
   {
      String label = ((UnaryOperator) object).getSource ();
      return label == null || label.length () == 0 ? getString ("_UI_UnaryOperator_type") : getString ("_UI_UnaryOperator_type")
            + " " + label;
   }

   /**
    * This handles model notifications by calling {@link #updateChildren} to update any cached
    * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public void notifyChanged (Notification notification)
   {
      updateChildren (notification);

      switch (notification.getFeatureID (UnaryOperator.class))
      {
         case IdlmmPackage.UNARY_OPERATOR__OWNED_OPERAND:
            fireNotifyChanged (new ViewerNotification (notification, notification.getNotifier (), true, false));
            return;
      }
      super.notifyChanged (notification);
   }

   /**
    * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
    * that can be created under this object.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   protected void collectNewChildDescriptors (Collection<Object> newChildDescriptors, Object object)
   {
      super.collectNewChildDescriptors (newChildDescriptors, object);

      newChildDescriptors.add (createChildParameter (IdlmmPackage.Literals.UNARY_OPERATOR__OWNED_OPERAND, IdlmmFactory.eINSTANCE
            .createBitwiseComplementOperator ()));

      newChildDescriptors.add (createChildParameter (IdlmmPackage.Literals.UNARY_OPERATOR__OWNED_OPERAND, IdlmmFactory.eINSTANCE
            .createBitwiseRightShiftOperator ()));

      newChildDescriptors.add (createChildParameter (IdlmmPackage.Literals.UNARY_OPERATOR__OWNED_OPERAND, IdlmmFactory.eINSTANCE
            .createBitwiseLeftShiftOperator ()));

      newChildDescriptors.add (createChildParameter (IdlmmPackage.Literals.UNARY_OPERATOR__OWNED_OPERAND, IdlmmFactory.eINSTANCE
            .createBitwiseAndOperator ()));

      newChildDescriptors.add (createChildParameter (IdlmmPackage.Literals.UNARY_OPERATOR__OWNED_OPERAND, IdlmmFactory.eINSTANCE
            .createAddOperator ()));

      newChildDescriptors.add (createChildParameter (IdlmmPackage.Literals.UNARY_OPERATOR__OWNED_OPERAND, IdlmmFactory.eINSTANCE
            .createBitwiseXorOperator ()));

      newChildDescriptors.add (createChildParameter (IdlmmPackage.Literals.UNARY_OPERATOR__OWNED_OPERAND, IdlmmFactory.eINSTANCE
            .createPositiveOperator ()));

      newChildDescriptors.add (createChildParameter (IdlmmPackage.Literals.UNARY_OPERATOR__OWNED_OPERAND, IdlmmFactory.eINSTANCE
            .createNegativeOperator ()));

      newChildDescriptors.add (createChildParameter (IdlmmPackage.Literals.UNARY_OPERATOR__OWNED_OPERAND, IdlmmFactory.eINSTANCE
            .createBitwiseOrOperator ()));

      newChildDescriptors.add (createChildParameter (IdlmmPackage.Literals.UNARY_OPERATOR__OWNED_OPERAND, IdlmmFactory.eINSTANCE
            .createSubtractOperator ()));

      newChildDescriptors.add (createChildParameter (IdlmmPackage.Literals.UNARY_OPERATOR__OWNED_OPERAND, IdlmmFactory.eINSTANCE
            .createMultiplyOperator ()));

      newChildDescriptors.add (createChildParameter (IdlmmPackage.Literals.UNARY_OPERATOR__OWNED_OPERAND, IdlmmFactory.eINSTANCE
            .createModuloOperator ()));

      newChildDescriptors.add (createChildParameter (IdlmmPackage.Literals.UNARY_OPERATOR__OWNED_OPERAND, IdlmmFactory.eINSTANCE
            .createDivideOperator ()));

      newChildDescriptors.add (createChildParameter (IdlmmPackage.Literals.UNARY_OPERATOR__OWNED_OPERAND, IdlmmFactory.eINSTANCE
            .createBooleanLiteral ()));

      newChildDescriptors.add (createChildParameter (IdlmmPackage.Literals.UNARY_OPERATOR__OWNED_OPERAND, IdlmmFactory.eINSTANCE
            .createCharacterLiteral ()));

      newChildDescriptors.add (createChildParameter (IdlmmPackage.Literals.UNARY_OPERATOR__OWNED_OPERAND, IdlmmFactory.eINSTANCE
            .createFixedPointLiteral ()));

      newChildDescriptors.add (createChildParameter (IdlmmPackage.Literals.UNARY_OPERATOR__OWNED_OPERAND, IdlmmFactory.eINSTANCE
            .createFloatingPointLiteral ()));

      newChildDescriptors.add (createChildParameter (IdlmmPackage.Literals.UNARY_OPERATOR__OWNED_OPERAND, IdlmmFactory.eINSTANCE
            .createIntegerLiteral ()));

      newChildDescriptors.add (createChildParameter (IdlmmPackage.Literals.UNARY_OPERATOR__OWNED_OPERAND, IdlmmFactory.eINSTANCE
            .createStringLiteral ()));

      newChildDescriptors.add (createChildParameter (IdlmmPackage.Literals.UNARY_OPERATOR__OWNED_OPERAND, IdlmmFactory.eINSTANCE
            .createWCharacterLiteral ()));

      newChildDescriptors.add (createChildParameter (IdlmmPackage.Literals.UNARY_OPERATOR__OWNED_OPERAND, IdlmmFactory.eINSTANCE
            .createWStringLiteral ()));
   }

   /**
    * Return the resource locator for this item provider's resources.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public ResourceLocator getResourceLocator ()
   {
      return IdlmmEditPlugin.INSTANCE;
   }

}
