/*
 * COPYRIGHT NOTICE 
 *
 * The information contained herein and which follows is proprietary
 * information and is the property of PrismTech Corporation.  This
 * information is not to be divulged, released, copied, reproduced, or
 * conveyed to unauthorized personnel, companies, or other institutions
 * without the direct and expressed approval in writing of PrismTech
 * Corporation.
 *
 * DISCLAIMER
 * 
 * Neither PrismTech Limited nor PrismTech Corporation ("PrismTech")
 * are under any obligation to support the use of this code which is
 * provided without warranty of any kind. PrismTech shall (except as
 * otherwise prohibited by law) have no liability whatsoever in relation
 * to its use.
 */
package com.prismtech.idt.idlmm.constraints;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.emf.validation.IValidationContext;

import com.prismtech.idt.idlmm.Contained;
import com.prismtech.idt.idlmm.Container;
import com.prismtech.idt.idlmm.Named;

/**
 * Checks that Container does not contain any Contained elements with the same name as Container.
 */
public class CheckContainerAndItContainedUniqueNames extends CheckContainerUniqueContainedNames
{
   /* (non-Javadoc)
    * @see com.prismtech.idt.idlmm.constraints.CheckContainerUniqueContainedNames#validate(org.eclipse.emf.validation.IValidationContext)
    */
   @Override
   public IStatus validate (IValidationContext ctx)
   {
      Contained target = (Contained) ctx.getTarget ();
      
      Container container = target.getContainer ();
      
      if (container instanceof Named)
      {
         Named namedContainer = (Named) container;
         
         if (target.getName ().equalsIgnoreCase (namedContainer.getName ()))
         {
            Object[] args = new Object[]
            {
                  describe (target), describe (container)
            };

            return ctx.createFailureStatus (args);
         }
      }
      
      return ctx.createSuccessStatus ();
   }
}
