/*
 * COPYRIGHT NOTICE The information contained herein and which follows is
 * proprietary information and is the property of PrismTech Corporation. This
 * information is not to be divulged, released, copied, reproduced, or conveyed
 * to unauthorized personnel, companies, or other institutions without the
 * direct and expressed approval in writing of PrismTech Corporation. DISCLAIMER
 * Neither PrismTech Limited nor PrismTech Corporation ("PrismTech") are under
 * any obligation to support the use of this code which is provided without
 * warranty of any kind. PrismTech shall (except as otherwise prohibited by law)
 * have no liability whatsoever in relation to its use.
 */
package com.prismtech.idt.idlmm.constraints;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.emf.validation.IValidationContext;

import com.prismtech.idt.idlmm.OwnedExpression;


/**
 * Checks that the constant has valid expression value with corresponding type.
 */
public class CheckExpressionValue extends IdlmmConstraint
{

   /*
    * (non-Javadoc)
    * 
    * @see org.eclipse.emf.validation.AbstractModelConstraint#validate(org.eclipse.emf.validation.IValidationContext)
    */
   @Override
   public IStatus validate (IValidationContext ctx)
   {
      OwnedExpression target = OwnedExpression.class.cast (ctx.getTarget ());

      if (target.getExpressionValue () == null)
      {
         return ctx.createFailureStatus (new Object[]
         {
            describe (target)
         });
      }
      return ctx.createSuccessStatus ();
   }

}
