package com.prismtech.idt.idlmm.constraints;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.emf.validation.IValidationContext;

import com.prismtech.idt.idlmm.OperationDef;
import com.prismtech.idt.idlmm.OperationMode;


public class CheckOnewayOpHasNoException extends IdlmmConstraint
{

   /*
    * (non-Javadoc)
    * 
    * @see org.eclipse.emf.validation.AbstractModelConstraint#validate(org.eclipse.emf.validation.IValidationContext)
    */
   @Override
   public IStatus validate (IValidationContext ctx)
   {
      OperationDef op = (OperationDef) ctx.getTarget ();
      if (op.getMode ().equals (OperationMode.OP_ONEWAY) && !op.getExceptions ().isEmpty ())
      {
         return ctx.createFailureStatus (new Object[]
         {
            describe (op)
         });
      }
      return ctx.createSuccessStatus ();
   }

}
