package com.prismtech.idt.idlmm.constraints;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.validation.IValidationContext;

import com.prismtech.idt.idlmm.EventDef;
import com.prismtech.idt.idlmm.ValueDef;

/**
 * A Value may not inherit from Event type.
 * 
 */

public class CheckValueInheritance extends IdlmmConstraint
{
   @Override
   public IStatus validate (IValidationContext ctx)
   {
      ValueDef target = (ValueDef) ctx.getTarget ();
      EList<ValueDef> targetBaseValues = target.getBaseValues ();
      for(ValueDef base : targetBaseValues){
         if(base instanceof EventDef)
         {
            Object[] args = new Object[]
            {
                describe (target), describe (base)
            };

            return ctx.createFailureStatus (args);
         }
      }

      return ctx.createSuccessStatus ();
      
   }

}
