/*
 * COPYRIGHT NOTICE 
 *
 * The information contained herein and which follows is proprietary
 * information and is the property of PrismTech Corporation.  This
 * information is not to be divulged, released, copied, reproduced, or
 * conveyed to unauthorized personnel, companies, or other institutions
 * without the direct and expressed approval in writing of PrismTech
 * Corporation.
 *
 * DISCLAIMER
 * 
 * Neither PrismTech Limited nor PrismTech Corporation ("PrismTech")
 * are under any obligation to support the use of this code which is
 * provided without warranty of any kind. PrismTech shall (except as
 * otherwise prohibited by law) have no liability whatsoever in relation
 * to its use.
 */
package com.prismtech.idt.idlmm.constraints;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.validation.model.IClientSelector;

import com.prismtech.idt.idlmm.IdlmmPackage;


public class IdlmmContextSelector implements IClientSelector
{
   public static final String CONTEXT_ID = "com.prismtech.idl.idlmm.constraints.context";

   /**
    * Returns <code>true</code> if the specified <code>object</code> is an
    * instance of any class (or subclass of a class) from the
    * {@link IdlmmPackage}.
    */
   public boolean selects (Object object)
   {
      boolean result = false;

      if (object instanceof EObject)
      {
         result = selects ( ((EObject) object).eClass ());
      }

      return result;
   }

   private boolean selects (EClass eclass)
   {
      if (eclass.getEPackage () == IdlmmPackage.eINSTANCE)
      {
         return true;
      }
      else
      {
         for (Object o : eclass.getESuperTypes ())
         {
            if (selects ((EClass) o) == true)
            {
               return true;
            }
         }
      }

      return false;
   }
}
