package com.prismtech.idt.idlmm.constraints;

import java.math.BigInteger;


public class IntegerLiteralHelper
{
   public static final BigInteger OCTET_LOWER_BOUND = new BigInteger ("0");

   public static final BigInteger OCTET_UPPER_BOUND = new BigInteger ("255");

   public static final BigInteger SHORT_LOWER_BOUND = new BigInteger ("-32768");

   public static final BigInteger SHORT_UPPER_BOUND = new BigInteger ("32767");

   public static final BigInteger UNSIGNED_SHORT_LOWER_BOUND = new BigInteger ("0");

   public static final BigInteger UNSIGNED_SHORT_UPPER_BOUND = new BigInteger ("65535");

   public static final BigInteger LONG_LOWER_BOUND = new BigInteger ("-2147483648");

   public static final BigInteger LONG_UPPER_BOUND = new BigInteger ("2147483647");

   public static final BigInteger UNSIGNED_LONG_LOWER_BOUND = new BigInteger ("0");

   public static final BigInteger UNSIGNED_LONG_UPPER_BOUND = new BigInteger ("4294967295");

   public static final BigInteger LONG_LONG_LOWER_BOUND = new BigInteger ("-9223372036854775808");

   public static final BigInteger LONG_LONG_UPPER_BOUND = new BigInteger ("9223372036854775807");

   public static final BigInteger UNSIGNED_LONG_LONG_LOWER_BOUND = new BigInteger ("0");

   public static final BigInteger UNSIGNED_LONG_LONG_UPPER_BOUND = new BigInteger ("18446744073709551615");

   public static boolean isValidOctet (BigInteger number)
   {
      return checkRange (number, OCTET_LOWER_BOUND, OCTET_UPPER_BOUND);
   }

   public static boolean isValidShort (BigInteger number)
   {
      return checkRange (number, SHORT_LOWER_BOUND, SHORT_UPPER_BOUND);
   }

   public static boolean isValidUnsignedShort (BigInteger number)
   {
      return checkRange (number, UNSIGNED_SHORT_LOWER_BOUND, UNSIGNED_SHORT_UPPER_BOUND);
   }

   public static boolean isValidLong (BigInteger number)
   {
      return checkRange (number, LONG_LOWER_BOUND, LONG_UPPER_BOUND);
   }

   public static boolean isValidUnsignedLong (BigInteger number)
   {
      return checkRange (number, UNSIGNED_LONG_LOWER_BOUND, UNSIGNED_LONG_UPPER_BOUND);
   }

   public static boolean isValidLongLong (BigInteger number)
   {
      return checkRange (number, LONG_LONG_LOWER_BOUND, LONG_LONG_UPPER_BOUND);
   }

   public static boolean isValidUnsignedLongLong (BigInteger number)
   {
      return checkRange (number, UNSIGNED_LONG_LONG_LOWER_BOUND, UNSIGNED_LONG_LONG_UPPER_BOUND);
   }

   private static boolean checkRange (BigInteger number, BigInteger lower, BigInteger upper)
   {
      return (number.compareTo (lower) >= 0) && (number.compareTo (upper) <= 0);
   }
}
