/**
 * <copyright>
 * </copyright>
 *
 * $Id: Container.java,v 1.48 2008/08/22 11:55:33 je Exp $
 */
package com.prismtech.idt.idlmm;

import org.eclipse.emf.common.util.EList;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Container</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * The base interface Container is used to form a containment hierarchy in the Interface Repository. A Container can contain any number of objects derived from the Contained interface. All Containers, except for Repository, are also derived from Contained.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.prismtech.idt.idlmm.Container#getContents <em>Contents</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.prismtech.idt.idlmm.IdlmmPackage#getContainer()
 * @model abstract="true"
 * @generated
 */
public interface Container extends IRObject
{
   /**
    * Returns the value of the '<em><b>Contents</b></em>' reference list.
    * The list contents are of type {@link com.prismtech.idt.idlmm.Contained}.
    * It is bidirectional and its opposite is '{@link com.prismtech.idt.idlmm.Contained#getContainer <em>Container</em>}'.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @return the value of the '<em>Contents</em>' reference list.
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getContainer_Contents()
    * @see com.prismtech.idt.idlmm.Contained#getContainer
    * @model opposite="container" transient="true" changeable="false" volatile="true" derived="true"
    * @generated
    */
   EList<Contained> getContents ();

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * <!-- begin-model-doc -->
    * The lookup operation locates a definition relative to this container given a scoped name using OMG IDL’s name scoping rules. This method lookups names only within this container and not implements whole IDL scoped name resolution mechanism. If no object is found, a nil object reference is returned.
    * @param name The relative or absolute scoped name to lookup.
    * <!-- end-model-doc -->
    * @model required="true" nameRequired="true"
    *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return ContainerExt.lookup (this, name);'"
    * @generated
    */
   Contained lookup (String name);

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @model kind="operation"
    *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return ContainerExt.getPrerequisites (this);'"
    * @generated
    */
   EList<IRObject> getPrerequisites ();

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * <!-- begin-model-doc -->
    * The lookup operation locates a definition relative to this container given a scoped name using OMG IDL’s name scoping rules. This method lookups names only within this container and not implements whole IDL scoped name resolution mechanism. If no object is found, a nil object reference is returned.
    * @param name The relative or absolute scoped name to lookup.
    * <!-- end-model-doc -->
    * @model required="true" nameRequired="true" inheritedRequired="true" globalRequired="true"
    *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return ContainerExt.lookup (this, name, inherited, global);'"
    * @generated
    */
   Contained lookup (String name, boolean inherited, boolean global);

} // Container
