/**
 * <copyright>
 * </copyright>
 *
 * $Id: Repository.java,v 1.48 2008/08/22 11:55:33 je Exp $
 */
package com.prismtech.idt.idlmm;

import org.eclipse.emf.common.util.EList;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Repository</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * Repository is an interface that provides global access to the Interface Repository that
 * does not support access to information related to CORBA Components. The
 * Repository object can contain constants, typedefs, exceptions, interfaces, value types,
 * value boxes, native types, and modules. As it inherits from Container, it can be used
 * to look up any definition (whether globally defined or defined within a module or
 * interface) by name.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.prismtech.idt.idlmm.Repository#getRepositoryContents <em>Repository Contents</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.Repository#getIncludes <em>Includes</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.Repository#getEnums <em>Enums</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.Repository#getAliases <em>Aliases</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.Repository#getConstants <em>Constants</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.Repository#getExceptions <em>Exceptions</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.Repository#getInterfaces <em>Interfaces</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.Repository#getModules <em>Modules</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.Repository#getNatives <em>Natives</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.Repository#getStructs <em>Structs</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.Repository#getUnions <em>Unions</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.Repository#getValueTypes <em>Value Types</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.prismtech.idt.idlmm.IdlmmPackage#getRepository()
 * @model
 * @generated
 */
public interface Repository extends Container
{
   /**
    * Returns the value of the '<em><b>Repository Contents</b></em>' containment reference list.
    * The list contents are of type {@link com.prismtech.idt.idlmm.RepositoryContained}.
    * It is bidirectional and its opposite is '{@link com.prismtech.idt.idlmm.RepositoryContained#getContainingRepository <em>Containing Repository</em>}'.
    * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>Repository Contents</em>' containment reference list isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
    * @return the value of the '<em>Repository Contents</em>' containment reference list.
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getRepository_RepositoryContents()
    * @see com.prismtech.idt.idlmm.RepositoryContained#getContainingRepository
    * @model opposite="containingRepository" containment="true"
    * @generated
    */
   EList<RepositoryContained> getRepositoryContents ();

   /**
    * Returns the value of the '<em><b>Includes</b></em>' reference list.
    * The list contents are of type {@link com.prismtech.idt.idlmm.Repository}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * <!-- begin-model-doc -->
    * This is a collection of other {@link Repository}s that are included by this one. By including another repository, the contets of the including repository logically include the contents of the included repository.
    * <!-- end-model-doc -->
    * @return the value of the '<em>Includes</em>' reference list.
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getRepository_Includes()
    * @model
    * @generated
    */
   EList<Repository> getIncludes ();

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @model required="true" kindRequired="true"
    *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return RepositoryExt.createPrimitive (this, kind);'"
    * @generated
    */
   PrimitiveDef createPrimitive (PrimitiveKind kind);

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * <!-- begin-model-doc -->
    * Returns a new StringDef with the specified bound, which must be non-zero. The getPrimitive() operation is used for unbounded strings.
    * <!-- end-model-doc -->
    * @model required="true" boundRequired="true"
    *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return RepositoryExt.createString (this, bound);'"
    * @generated
    */
   StringDef createString (int bound);

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @model required="true" boundRequired="true"
    *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return RepositoryExt.createWString (this, bound);'"
    * @generated
    */
   WStringDef createWString (int bound);

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @model required="true" boundRequired="true" elementTypeRequired="true"
    *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return RepositoryExt.createSequence (this, bound, elementType);'"
    * @generated
    */
   SequenceDef createSequence (int bound, IDLType elementType);

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @model required="true" lengthRequired="true" elementTypeRequired="true"
    *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return RepositoryExt.createArray (this, length, elementType);'"
    * @generated
    */
   ArrayDef createArray (int length, IDLType elementType);

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @model required="true" digitsRequired="true" scaleRequired="true"
    *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return RepositoryExt.createFixed (this, digits, scale);'"
    * @generated
    */
   FixedDef createFixed (int digits, int scale);

   /**
    * Returns the value of the '<em><b>Aliases</b></em>' reference list.
    * The list contents are of type {@link com.prismtech.idt.idlmm.AliasDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @return the value of the '<em>Aliases</em>' reference list.
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getRepository_Aliases()
    * @model transient="true" changeable="false" volatile="true" derived="true" ordered="false"
    * @generated
    */
   EList<AliasDef> getAliases ();

   /**
    * Returns the value of the '<em><b>Constants</b></em>' reference list.
    * The list contents are of type {@link com.prismtech.idt.idlmm.ConstantDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @return the value of the '<em>Constants</em>' reference list.
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getRepository_Constants()
    * @model transient="true" changeable="false" volatile="true" derived="true"
    * @generated
    */
   EList<ConstantDef> getConstants ();

   /**
    * Returns the value of the '<em><b>Enums</b></em>' reference list.
    * The list contents are of type {@link com.prismtech.idt.idlmm.EnumDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @return the value of the '<em>Enums</em>' reference list.
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getRepository_Enums()
    * @model transient="true" changeable="false" volatile="true" derived="true" ordered="false"
    * @generated
    */
   EList<EnumDef> getEnums ();

   /**
    * Returns the value of the '<em><b>Exceptions</b></em>' reference list.
    * The list contents are of type {@link com.prismtech.idt.idlmm.ExceptionDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @return the value of the '<em>Exceptions</em>' reference list.
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getRepository_Exceptions()
    * @model transient="true" changeable="false" volatile="true" derived="true" ordered="false"
    * @generated
    */
   EList<ExceptionDef> getExceptions ();

   /**
    * Returns the value of the '<em><b>Interfaces</b></em>' reference list.
    * The list contents are of type {@link com.prismtech.idt.idlmm.InterfaceDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @return the value of the '<em>Interfaces</em>' reference list.
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getRepository_Interfaces()
    * @model transient="true" changeable="false" volatile="true" derived="true"
    * @generated
    */
   EList<InterfaceDef> getInterfaces ();

   /**
    * Returns the value of the '<em><b>Modules</b></em>' reference list.
    * The list contents are of type {@link com.prismtech.idt.idlmm.ModuleDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @return the value of the '<em>Modules</em>' reference list.
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getRepository_Modules()
    * @model transient="true" changeable="false" volatile="true" derived="true"
    * @generated
    */
   EList<ModuleDef> getModules ();

   /**
    * Returns the value of the '<em><b>Natives</b></em>' reference list.
    * The list contents are of type {@link com.prismtech.idt.idlmm.NativeDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @return the value of the '<em>Natives</em>' reference list.
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getRepository_Natives()
    * @model transient="true" changeable="false" volatile="true" derived="true" ordered="false"
    * @generated
    */
   EList<NativeDef> getNatives ();

   /**
    * Returns the value of the '<em><b>Structs</b></em>' reference list.
    * The list contents are of type {@link com.prismtech.idt.idlmm.StructDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @return the value of the '<em>Structs</em>' reference list.
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getRepository_Structs()
    * @model transient="true" changeable="false" volatile="true" derived="true"
    * @generated
    */
   EList<StructDef> getStructs ();

   /**
    * Returns the value of the '<em><b>Unions</b></em>' reference list.
    * The list contents are of type {@link com.prismtech.idt.idlmm.UnionDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @return the value of the '<em>Unions</em>' reference list.
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getRepository_Unions()
    * @model transient="true" changeable="false" volatile="true" derived="true"
    * @generated
    */
   EList<UnionDef> getUnions ();

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @model kind="operation"
    *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return RepositoryExt.getValueBoxes (this);'"
    * @generated
    */
   EList<ValueBoxDef> getValueBoxes ();

   /**
    * Returns the value of the '<em><b>Value Types</b></em>' reference list.
    * The list contents are of type {@link com.prismtech.idt.idlmm.ValueDef}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @return the value of the '<em>Value Types</em>' reference list.
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getRepository_ValueTypes()
    * @model transient="true" changeable="false" volatile="true" derived="true"
    * @generated
    */
   EList<ValueDef> getValueTypes ();

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * <!-- begin-model-doc -->
    * Returns a collection of all {@link Repository repositories} that are directly and indirectly {@link Repository#getIncludes() included} by this one.
    * @param inclusive Whether or not to include this {@link Repository} in the result.
    * <!-- end-model-doc -->
    * @model inclusiveRequired="true"
    *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return RepositoryExt.getAllIncludes (this, inclusive);'"
    * @generated
    */
   EList<Repository> getAllIncludes (boolean inclusive);

} // Repository
