/**
 * <copyright>
 * </copyright>
 *
 * $Id: StructDef.java,v 1.46 2009/09/04 09:24:29 je Exp $
 */
package com.prismtech.idt.idlmm;

import org.eclipse.emf.common.util.EList;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Struct Def</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * A StructDef represents an OMG IDL structure definition. It can contain structs, unions, and enums.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.prismtech.idt.idlmm.StructDef#getStructContents <em>Struct Contents</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.StructDef#getMembers <em>Members</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.prismtech.idt.idlmm.IdlmmPackage#getStructDef()
 * @model
 * @generated
 */
public interface StructDef extends TypedefDef, Container, RepositoryContained, ExceptionContained, UnionContained, ModuleContained,
      StructContained, InterfaceContained, StructContainer, EnumContainer, UnionContainer, HomeContained
{
   /**
    * Returns the value of the '<em><b>Struct Contents</b></em>' containment reference list.
    * The list contents are of type {@link com.prismtech.idt.idlmm.StructContained}.
    * It is bidirectional and its opposite is '{@link com.prismtech.idt.idlmm.StructContained#getContainingStruct <em>Containing Struct</em>}'.
    * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>Struct Contents</em>' containment reference list isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
    * @return the value of the '<em>Struct Contents</em>' containment reference list.
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getStructDef_StructContents()
    * @see com.prismtech.idt.idlmm.StructContained#getContainingStruct
    * @model opposite="containingStruct" containment="true"
    * @generated
    */
   EList<StructContained> getStructContents ();

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * <!-- begin-model-doc -->
    * Returns the <code>StructMember</code> with the specified name, or <code>null</code> if no such member exists.
    * @param name The name of the StructMember to return
    * <!-- end-model-doc -->
    * @model nameRequired="true"
    *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return StructDefExt.getMember (this, name);'"
    * @generated
    */
   StructMember getMember (String name);

   /**
    * Returns the value of the '<em><b>Members</b></em>' reference list.
    * The list contents are of type {@link com.prismtech.idt.idlmm.StructMember}.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @return the value of the '<em>Members</em>' reference list.
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getStructDef_Members()
    * @model transient="true" changeable="false" volatile="true" derived="true"
    * @generated
    */
   EList<StructMember> getMembers ();

} // StructDef
