/**
 * <copyright>
 * </copyright>
 *
 * $Id: Typed.java,v 1.42 2008/07/02 14:58:57 gm Exp $
 */
package com.prismtech.idt.idlmm;

import org.eclipse.emf.common.util.EList;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Typed</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This is the base class for objects that have an associated data type. Conceptually, <code>Typed</code> objects have a single relationship to an <code>IDLType</code> object that describes their data type. However, because of the mapping onto EMF, this single relationship has had to be represented by two separate relationships, <code>sharedType</code> and <code>ownedType</code>, only one of which must be set at any time. 
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link com.prismtech.idt.idlmm.Typed#getOwnedType <em>Owned Type</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.Typed#getType <em>Type</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.Typed#getSharedType <em>Shared Type</em>}</li>
 * </ul>
 * </p>
 *
 * @see com.prismtech.idt.idlmm.IdlmmPackage#getTyped()
 * @model abstract="true"
 * @generated
 */
public interface Typed extends IRObject
{
   /**
    * Returns the value of the '<em><b>Owned Type</b></em>' containment reference.
    * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>Owned Type</em>' containment reference isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
    * <!-- begin-model-doc -->
    * This reference will have the same value as the {@link Typed#type} reference, if the referenced {@link IDLType} object is an {@link OwnedIDLType}. This is effectively an implementation detail and not really part of the logical model.
    * <!-- end-model-doc -->
    * @return the value of the '<em>Owned Type</em>' containment reference.
    * @see #setOwnedType(OwnedIDLType)
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getTyped_OwnedType()
    * @model containment="true" ordered="false"
    * @generated
    */
   OwnedIDLType getOwnedType ();

   /**
    * Sets the value of the '{@link com.prismtech.idt.idlmm.Typed#getOwnedType <em>Owned Type</em>}' containment reference.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @param value the new value of the '<em>Owned Type</em>' containment reference.
    * @see #getOwnedType()
    * @generated
    */
   void setOwnedType (OwnedIDLType value);

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * <!-- begin-model-doc -->
    * Shortcut method that sets the type of this <code>Typed</code> object to be a <code>PrimitiveDef</code> with the specified <code>PrimitiveKind</code>.
    * <!-- end-model-doc -->
    * @model required="true" kindRequired="true"
    *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return TypedExt.setType (this, kind);'"
    * @generated
    */
   IDLType setType (PrimitiveKind kind);

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * <!-- begin-model-doc -->
    * Sets the associated type of this object to the <code>IDLType</code> with the specified <code>name</code>.
    * @param name
    *   The name of the required <code>IDLType</code>. This may be one of the following:
    *   <ul>
    *   <li>float</li>
    *   <li>double</li>
    *   <li>long double</li>
    *   <li>short</li>
    *   <li>long</li>
    *   <li>long long</li>
    *   <li>unsigned short</li>
    *   <li>unsigned long</li>
    *   <li>unsigned long long</li>
    *   <li>char</li>
    *   <li>wchar</li>
    *   <li>boolean</li>
    *   <li>octet</li>
    *   <li>any</li>
    *   <li><scoped name></li>
    *   </ul>
    *   <p>
    *   If a scoped name is specified, it will be resolved using the <code>Container::lookup()</code> operation, called on this object, if it is a <code>Container</code>, or the closest enclosing <code>Container</code>.
    *   <p>
    *   If the specified name is not a valid primitive type name or cannot be resolved, then the type of this object will be set to <code>null</code>.
    * <!-- end-model-doc -->
    * @model required="true" nameRequired="true"
    *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return TypedExt.setType (this, name);'"
    * @generated
    */
   IDLType setType (String name);

   /**
    * Returns the value of the '<em><b>Type</b></em>' reference.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @return the value of the '<em>Type</em>' reference.
    * @see #setType(IDLType)
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getTyped_Type()
    * @model required="true" transient="true" volatile="true" derived="true" ordered="false"
    * @generated
    */
   IDLType getType ();

   /**
    * Returns the value of the '<em><b>Shared Type</b></em>' reference.
    * <!-- begin-user-doc -->
    * <p>
    * If the meaning of the '<em>Shared Type</em>' reference isn't clear,
    * there really should be more of a description here...
    * </p>
    * <!-- end-user-doc -->
    * @return the value of the '<em>Shared Type</em>' reference.
    * @see #setSharedType(SharedIDLType)
    * @see com.prismtech.idt.idlmm.IdlmmPackage#getTyped_SharedType()
    * @model ordered="false"
    * @generated
    */
   SharedIDLType getSharedType ();

   /**
    * Sets the value of the '{@link com.prismtech.idt.idlmm.Typed#getSharedType <em>Shared Type</em>}' reference.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @param value the new value of the '<em>Shared Type</em>' reference.
    * @see #getSharedType()
    * @generated
    */
   void setSharedType (SharedIDLType value);

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @model kind="operation"
    *        annotation="http://www.eclipse.org/emf/2002/GenModel body='return TypedExt.getPrerequisites (this);'"
    * @generated
    */
   EList<IRObject> getPrerequisites ();

   /**
    * Sets the value of the '{@link com.prismtech.idt.idlmm.Typed#getType <em>Type</em>}' reference.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @param value the new value of the '<em>Type</em>' reference.
    * @see #getType()
    * @generated
    */
   void setType (IDLType value);

} // Typed
