/**
 * <copyright>
 * </copyright>
 *
 * $Id: InterfaceDefImpl.java,v 1.54 2008/08/22 11:55:33 je Exp $
 */
package com.prismtech.idt.idlmm.impl;

import com.prismtech.idt.idlmm.AliasContainer;
import com.prismtech.idt.idlmm.AliasDef;
import com.prismtech.idt.idlmm.AttributeContainer;
import com.prismtech.idt.idlmm.AttributeDef;
import com.prismtech.idt.idlmm.ConstantContainer;
import com.prismtech.idt.idlmm.ConstantDef;
import com.prismtech.idt.idlmm.Contained;
import com.prismtech.idt.idlmm.Container;
import com.prismtech.idt.idlmm.EnumContainer;
import com.prismtech.idt.idlmm.EnumDef;
import com.prismtech.idt.idlmm.ExceptionContainer;
import com.prismtech.idt.idlmm.ExceptionDef;
import com.prismtech.idt.idlmm.IDLType;
import com.prismtech.idt.idlmm.IRObject;
import com.prismtech.idt.idlmm.IdlmmPackage;
import com.prismtech.idt.idlmm.Interface;
import com.prismtech.idt.idlmm.InterfaceContained;
import com.prismtech.idt.idlmm.InterfaceDef;
import com.prismtech.idt.idlmm.InterfaceModifier;
import com.prismtech.idt.idlmm.ModuleContained;
import com.prismtech.idt.idlmm.ModuleDef;
import com.prismtech.idt.idlmm.Named;
import com.prismtech.idt.idlmm.NativeContainer;
import com.prismtech.idt.idlmm.NativeDef;
import com.prismtech.idt.idlmm.OperationContainer;
import com.prismtech.idt.idlmm.OperationDef;
import com.prismtech.idt.idlmm.Repository;
import com.prismtech.idt.idlmm.RepositoryContained;
import com.prismtech.idt.idlmm.SharedIDLType;
import com.prismtech.idt.idlmm.StructContainer;
import com.prismtech.idt.idlmm.StructDef;
import com.prismtech.idt.idlmm.UnionContainer;
import com.prismtech.idt.idlmm.UnionDef;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.uml2.common.util.DerivedUnionEObjectEList;


/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Interface Def</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceDefImpl#getName <em>Name</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceDefImpl#getKey <em>Key</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceDefImpl#getContainer <em>Container</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceDefImpl#getAbsoluteName <em>Absolute Name</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceDefImpl#getPrefix <em>Prefix</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceDefImpl#getID <em>ID</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceDefImpl#getVersion <em>Version</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceDefImpl#getContainingModule <em>Containing Module</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceDefImpl#getContainingRepository <em>Containing Repository</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceDefImpl#getModifier <em>Modifier</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceDefImpl#getAttributes <em>Attributes</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceDefImpl#getAllAttributes <em>All Attributes</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceDefImpl#getOperations <em>Operations</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceDefImpl#getAllOperations <em>All Operations</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceDefImpl#getExceptions <em>Exceptions</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceDefImpl#getAllExceptions <em>All Exceptions</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceDefImpl#getStructs <em>Structs</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceDefImpl#getAllStructs <em>All Structs</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceDefImpl#getEnums <em>Enums</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceDefImpl#getAllEnums <em>All Enums</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceDefImpl#getUnions <em>Unions</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceDefImpl#getAllUnions <em>All Unions</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceDefImpl#getNatives <em>Natives</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceDefImpl#getAllNatives <em>All Natives</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceDefImpl#getAliases <em>Aliases</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceDefImpl#getAllAliases <em>All Aliases</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceDefImpl#getConstants <em>Constants</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceDefImpl#getAllConstants <em>All Constants</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceDefImpl#getContents <em>Contents</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceDefImpl#getInterfaceContents <em>Interface Contents</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceDefImpl#getBaseInterfaces <em>Base Interfaces</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceDefImpl#getAllBaseInterfaces <em>All Base Interfaces</em>}</li>
 *   <li>{@link com.prismtech.idt.idlmm.impl.InterfaceDefImpl#getAllContents <em>All Contents</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class InterfaceDefImpl extends ContainerImpl implements InterfaceDef
{
   /**
    * The default value of the '{@link #getName() <em>Name</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getName()
    * @generated
    * @ordered
    */
   protected static final String NAME_EDEFAULT = null;

   /**
    * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getName()
    * @generated
    * @ordered
    */
   protected String name = NAME_EDEFAULT;

   /**
    * The default value of the '{@link #getKey() <em>Key</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getKey()
    * @generated
    * @ordered
    */
   protected static final String KEY_EDEFAULT = null;

   /**
    * The default value of the '{@link #getAbsoluteName() <em>Absolute Name</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getAbsoluteName()
    * @generated
    * @ordered
    */
   protected static final String ABSOLUTE_NAME_EDEFAULT = null;

   /**
    * The default value of the '{@link #getPrefix() <em>Prefix</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getPrefix()
    * @generated
    * @ordered
    */
   protected static final String PREFIX_EDEFAULT = null;

   /**
    * The cached value of the '{@link #getPrefix() <em>Prefix</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getPrefix()
    * @generated
    * @ordered
    */
   protected String prefix = PREFIX_EDEFAULT;

   /**
    * The default value of the '{@link #getID() <em>ID</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getID()
    * @generated
    * @ordered
    */
   protected static final String ID_EDEFAULT = null;

   /**
    * The cached value of the '{@link #getID() <em>ID</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getID()
    * @generated
    * @ordered
    */
   protected String id = ID_EDEFAULT;

   /**
    * The default value of the '{@link #getVersion() <em>Version</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getVersion()
    * @generated
    * @ordered
    */
   protected static final String VERSION_EDEFAULT = null;

   /**
    * The cached value of the '{@link #getVersion() <em>Version</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getVersion()
    * @generated
    * @ordered
    */
   protected String version = VERSION_EDEFAULT;

   /**
    * The default value of the '{@link #getModifier() <em>Modifier</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getModifier()
    * @generated
    * @ordered
    */
   protected static final InterfaceModifier MODIFIER_EDEFAULT = InterfaceModifier.IF_REGULAR;

   /**
    * The cached value of the '{@link #getModifier() <em>Modifier</em>}' attribute.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getModifier()
    * @generated
    * @ordered
    */
   protected InterfaceModifier modifier = MODIFIER_EDEFAULT;

   /**
    * The cached value of the '{@link #getInterfaceContents() <em>Interface Contents</em>}' containment reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getInterfaceContents()
    * @generated
    * @ordered
    */
   protected EList<InterfaceContained> interfaceContents;

   /**
    * The cached value of the '{@link #getBaseInterfaces() <em>Base Interfaces</em>}' reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getBaseInterfaces()
    * @generated
    * @ordered
    */
   protected EList<InterfaceDef> baseInterfaces;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected InterfaceDefImpl ()
   {
      super ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   protected EClass eStaticClass ()
   {
      return IdlmmPackage.Literals.INTERFACE_DEF;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public String getName ()
   {
      return name;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setName (String newName)
   {
      String oldName = name;
      name = newName;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.INTERFACE_DEF__NAME, oldName, name));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public String getKey ()
   {
      return NamedExt.getKey (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public InterfaceModifier getModifier ()
   {
      return modifier;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setModifier (InterfaceModifier newModifier)
   {
      InterfaceModifier oldModifier = modifier;
      modifier = newModifier == null ? MODIFIER_EDEFAULT : newModifier;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.INTERFACE_DEF__MODIFIER, oldModifier, modifier));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EList<Contained> getContents ()
   {
      return new DerivedUnionEObjectEList<Contained> (Contained.class, this, IdlmmPackage.INTERFACE_DEF__CONTENTS,
            CONTENTS_ESUBSETS);
   }

   /**
    * The array of subset feature identifiers for the '{@link #getContents() <em>Contents</em>}' reference list.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @see #getContents()
    * @generated
    * @ordered
    */
   protected static final int[] CONTENTS_ESUBSETS = new int[]
   {
      IdlmmPackage.INTERFACE_DEF__INTERFACE_CONTENTS
   };

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<InterfaceContained> getInterfaceContents ()
   {
      if (interfaceContents == null)
      {
         interfaceContents = new EObjectContainmentWithInverseEList<InterfaceContained> (InterfaceContained.class, this,
               IdlmmPackage.INTERFACE_DEF__INTERFACE_CONTENTS, IdlmmPackage.INTERFACE_CONTAINED__CONTAINING_INTERFACE);
      }
      return interfaceContents;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<InterfaceDef> getBaseInterfaces ()
   {
      if (baseInterfaces == null)
      {
         baseInterfaces = new EObjectResolvingEList<InterfaceDef> (InterfaceDef.class, this,
               IdlmmPackage.INTERFACE_DEF__BASE_INTERFACES);
      }
      return baseInterfaces;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public void setContainer (Container newContainer)
   {
      ContainedExt.setContainer (this, newContainer);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Container getContainer ()
   {
      Container container = basicGetContainer ();
      return container != null && container.eIsProxy () ? (Container) eResolveProxy ((InternalEObject) container) : container;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Container basicGetContainer ()
   {
      ModuleDef containingModule = getContainingModule ();
      if (containingModule != null)
      {
         return containingModule;
      }
      Repository containingRepository = getContainingRepository ();
      if (containingRepository != null)
      {
         return containingRepository;
      }
      return null;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public String getAbsoluteName ()
   {
      return ContainedExt.getAbsoluteName (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public String getPrefix ()
   {
      return prefix;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setPrefix (String newPrefix)
   {
      String oldPrefix = prefix;
      prefix = newPrefix;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.INTERFACE_DEF__PREFIX, oldPrefix, prefix));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public String getID ()
   {
      return ContainedExt.getID (this, id);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setID (String newID)
   {
      String oldID = id;
      id = newID;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.INTERFACE_DEF__ID, oldID, id));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public String getVersion ()
   {
      return version;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setVersion (String newVersion)
   {
      String oldVersion = version;
      version = newVersion;
      if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.INTERFACE_DEF__VERSION, oldVersion, version));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public ModuleDef getContainingModule ()
   {
      if (eContainerFeatureID != IdlmmPackage.INTERFACE_DEF__CONTAINING_MODULE)
         return null;
      return (ModuleDef) eContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingModule (ModuleDef newContainingModule, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingModule, IdlmmPackage.INTERFACE_DEF__CONTAINING_MODULE, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setContainingModule (ModuleDef newContainingModule)
   {
      if (newContainingModule != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.INTERFACE_DEF__CONTAINING_MODULE && newContainingModule != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingModule))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingModule != null)
            msgs = ((InternalEObject) newContainingModule).eInverseAdd (this, IdlmmPackage.MODULE_DEF__MODULE_CONTENTS,
                  ModuleDef.class, msgs);
         msgs = basicSetContainingModule (newContainingModule, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.INTERFACE_DEF__CONTAINING_MODULE,
               newContainingModule, newContainingModule));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Repository getContainingRepository ()
   {
      if (eContainerFeatureID != IdlmmPackage.INTERFACE_DEF__CONTAINING_REPOSITORY)
         return null;
      return (Repository) eContainer ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public NotificationChain basicSetContainingRepository (Repository newContainingRepository, NotificationChain msgs)
   {
      msgs = eBasicSetContainer ((InternalEObject) newContainingRepository, IdlmmPackage.INTERFACE_DEF__CONTAINING_REPOSITORY, msgs);
      return msgs;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void setContainingRepository (Repository newContainingRepository)
   {
      if (newContainingRepository != eInternalContainer ()
            || (eContainerFeatureID != IdlmmPackage.INTERFACE_DEF__CONTAINING_REPOSITORY && newContainingRepository != null))
      {
         if (EcoreUtil.isAncestor (this, newContainingRepository))
            throw new IllegalArgumentException ("Recursive containment not allowed for " + toString ());
         NotificationChain msgs = null;
         if (eInternalContainer () != null)
            msgs = eBasicRemoveFromContainer (msgs);
         if (newContainingRepository != null)
            msgs = ((InternalEObject) newContainingRepository).eInverseAdd (this, IdlmmPackage.REPOSITORY__REPOSITORY_CONTENTS,
                  Repository.class, msgs);
         msgs = basicSetContainingRepository (newContainingRepository, msgs);
         if (msgs != null)
            msgs.dispatch ();
      }
      else if (eNotificationRequired ())
         eNotify (new ENotificationImpl (this, Notification.SET, IdlmmPackage.INTERFACE_DEF__CONTAINING_REPOSITORY,
               newContainingRepository, newContainingRepository));
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<InterfaceDef> getAllBaseInterfaces ()
   {
      return InterfaceDefExt.getAllBaseInterfaces (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EList<IRObject> getPrerequisites ()
   {
      return InterfaceDefExt.getPrerequisites (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<AliasDef> getAliases ()
   {
      return InterfaceDefExt.getAliases (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<AliasDef> getAllAliases ()
   {
      return InterfaceDefExt.getAllAliases (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<ConstantDef> getConstants ()
   {
      return InterfaceDefExt.getConstants (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<ConstantDef> getAllConstants ()
   {
      return InterfaceDefExt.getAllConstants (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<NativeDef> getNatives ()
   {
      return InterfaceDefExt.getNatives (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<NativeDef> getAllNatives ()
   {
      return InterfaceDefExt.getAllNatives (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<StructDef> getStructs ()
   {
      return InterfaceDefExt.getStructs (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<StructDef> getAllStructs ()
   {
      return InterfaceDefExt.getAllStructs (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<EnumDef> getEnums ()
   {
      return InterfaceDefExt.getEnums (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<EnumDef> getAllEnums ()
   {
      return InterfaceDefExt.getAllEnums (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<UnionDef> getUnions ()
   {
      return InterfaceDefExt.getUnions (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<UnionDef> getAllUnions ()
   {
      return InterfaceDefExt.getAllUnions (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<ExceptionDef> getExceptions ()
   {
      return InterfaceDefExt.getExceptions (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<ExceptionDef> getAllExceptions ()
   {
      return InterfaceDefExt.getAllExceptions (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<AttributeDef> getAttributes ()
   {
      return InterfaceDefExt.getAttributes (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<OperationDef> getOperations ()
   {
      return InterfaceDefExt.getOperations (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @SuppressWarnings("unchecked")
   @Override
   public NotificationChain eInverseAdd (InternalEObject otherEnd, int featureID, NotificationChain msgs)
   {
      switch (featureID)
      {
         case IdlmmPackage.INTERFACE_DEF__CONTAINING_MODULE:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingModule ((ModuleDef) otherEnd, msgs);
         case IdlmmPackage.INTERFACE_DEF__CONTAINING_REPOSITORY:
            if (eInternalContainer () != null)
               msgs = eBasicRemoveFromContainer (msgs);
            return basicSetContainingRepository ((Repository) otherEnd, msgs);
         case IdlmmPackage.INTERFACE_DEF__INTERFACE_CONTENTS:
            return ((InternalEList<InternalEObject>) (InternalEList<?>) getInterfaceContents ()).basicAdd (otherEnd, msgs);
      }
      return super.eInverseAdd (otherEnd, featureID, msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<AttributeDef> getAllAttributes ()
   {
      return InterfaceDefExt.getAllAttributes (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<OperationDef> getAllOperations ()
   {
      return InterfaceDefExt.getAllOperations (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated NOT
    */
   public EList<Contained> getAllContents ()
   {
      return InterfaceDefExt.getAllContents (this);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public NotificationChain eInverseRemove (InternalEObject otherEnd, int featureID, NotificationChain msgs)
   {
      switch (featureID)
      {
         case IdlmmPackage.INTERFACE_DEF__CONTAINING_MODULE:
            return basicSetContainingModule (null, msgs);
         case IdlmmPackage.INTERFACE_DEF__CONTAINING_REPOSITORY:
            return basicSetContainingRepository (null, msgs);
         case IdlmmPackage.INTERFACE_DEF__INTERFACE_CONTENTS:
            return ((InternalEList<?>) getInterfaceContents ()).basicRemove (otherEnd, msgs);
      }
      return super.eInverseRemove (otherEnd, featureID, msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public NotificationChain eBasicRemoveFromContainerFeature (NotificationChain msgs)
   {
      switch (eContainerFeatureID)
      {
         case IdlmmPackage.INTERFACE_DEF__CONTAINING_MODULE:
            return eInternalContainer ().eInverseRemove (this, IdlmmPackage.MODULE_DEF__MODULE_CONTENTS, ModuleDef.class, msgs);
         case IdlmmPackage.INTERFACE_DEF__CONTAINING_REPOSITORY:
            return eInternalContainer ()
                  .eInverseRemove (this, IdlmmPackage.REPOSITORY__REPOSITORY_CONTENTS, Repository.class, msgs);
      }
      return super.eBasicRemoveFromContainerFeature (msgs);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Object eGet (int featureID, boolean resolve, boolean coreType)
   {
      switch (featureID)
      {
         case IdlmmPackage.INTERFACE_DEF__NAME:
            return getName ();
         case IdlmmPackage.INTERFACE_DEF__KEY:
            return getKey ();
         case IdlmmPackage.INTERFACE_DEF__CONTAINER:
            if (resolve)
               return getContainer ();
            return basicGetContainer ();
         case IdlmmPackage.INTERFACE_DEF__ABSOLUTE_NAME:
            return getAbsoluteName ();
         case IdlmmPackage.INTERFACE_DEF__PREFIX:
            return getPrefix ();
         case IdlmmPackage.INTERFACE_DEF__ID:
            return getID ();
         case IdlmmPackage.INTERFACE_DEF__VERSION:
            return getVersion ();
         case IdlmmPackage.INTERFACE_DEF__CONTAINING_MODULE:
            return getContainingModule ();
         case IdlmmPackage.INTERFACE_DEF__CONTAINING_REPOSITORY:
            return getContainingRepository ();
         case IdlmmPackage.INTERFACE_DEF__MODIFIER:
            return getModifier ();
         case IdlmmPackage.INTERFACE_DEF__ATTRIBUTES:
            return getAttributes ();
         case IdlmmPackage.INTERFACE_DEF__ALL_ATTRIBUTES:
            return getAllAttributes ();
         case IdlmmPackage.INTERFACE_DEF__OPERATIONS:
            return getOperations ();
         case IdlmmPackage.INTERFACE_DEF__ALL_OPERATIONS:
            return getAllOperations ();
         case IdlmmPackage.INTERFACE_DEF__EXCEPTIONS:
            return getExceptions ();
         case IdlmmPackage.INTERFACE_DEF__ALL_EXCEPTIONS:
            return getAllExceptions ();
         case IdlmmPackage.INTERFACE_DEF__STRUCTS:
            return getStructs ();
         case IdlmmPackage.INTERFACE_DEF__ALL_STRUCTS:
            return getAllStructs ();
         case IdlmmPackage.INTERFACE_DEF__ENUMS:
            return getEnums ();
         case IdlmmPackage.INTERFACE_DEF__ALL_ENUMS:
            return getAllEnums ();
         case IdlmmPackage.INTERFACE_DEF__UNIONS:
            return getUnions ();
         case IdlmmPackage.INTERFACE_DEF__ALL_UNIONS:
            return getAllUnions ();
         case IdlmmPackage.INTERFACE_DEF__NATIVES:
            return getNatives ();
         case IdlmmPackage.INTERFACE_DEF__ALL_NATIVES:
            return getAllNatives ();
         case IdlmmPackage.INTERFACE_DEF__ALIASES:
            return getAliases ();
         case IdlmmPackage.INTERFACE_DEF__ALL_ALIASES:
            return getAllAliases ();
         case IdlmmPackage.INTERFACE_DEF__CONSTANTS:
            return getConstants ();
         case IdlmmPackage.INTERFACE_DEF__ALL_CONSTANTS:
            return getAllConstants ();
         case IdlmmPackage.INTERFACE_DEF__INTERFACE_CONTENTS:
            return getInterfaceContents ();
         case IdlmmPackage.INTERFACE_DEF__BASE_INTERFACES:
            return getBaseInterfaces ();
         case IdlmmPackage.INTERFACE_DEF__ALL_BASE_INTERFACES:
            return getAllBaseInterfaces ();
         case IdlmmPackage.INTERFACE_DEF__ALL_CONTENTS:
            return getAllContents ();
      }
      return super.eGet (featureID, resolve, coreType);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @SuppressWarnings("unchecked")
   @Override
   public void eSet (int featureID, Object newValue)
   {
      switch (featureID)
      {
         case IdlmmPackage.INTERFACE_DEF__NAME:
            setName ((String) newValue);
            return;
         case IdlmmPackage.INTERFACE_DEF__CONTAINER:
            setContainer ((Container) newValue);
            return;
         case IdlmmPackage.INTERFACE_DEF__PREFIX:
            setPrefix ((String) newValue);
            return;
         case IdlmmPackage.INTERFACE_DEF__ID:
            setID ((String) newValue);
            return;
         case IdlmmPackage.INTERFACE_DEF__VERSION:
            setVersion ((String) newValue);
            return;
         case IdlmmPackage.INTERFACE_DEF__CONTAINING_MODULE:
            setContainingModule ((ModuleDef) newValue);
            return;
         case IdlmmPackage.INTERFACE_DEF__CONTAINING_REPOSITORY:
            setContainingRepository ((Repository) newValue);
            return;
         case IdlmmPackage.INTERFACE_DEF__MODIFIER:
            setModifier ((InterfaceModifier) newValue);
            return;
         case IdlmmPackage.INTERFACE_DEF__INTERFACE_CONTENTS:
            getInterfaceContents ().clear ();
            getInterfaceContents ().addAll ((Collection<? extends InterfaceContained>) newValue);
            return;
         case IdlmmPackage.INTERFACE_DEF__BASE_INTERFACES:
            getBaseInterfaces ().clear ();
            getBaseInterfaces ().addAll ((Collection<? extends InterfaceDef>) newValue);
            return;
      }
      super.eSet (featureID, newValue);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public void eUnset (int featureID)
   {
      switch (featureID)
      {
         case IdlmmPackage.INTERFACE_DEF__NAME:
            setName (NAME_EDEFAULT);
            return;
         case IdlmmPackage.INTERFACE_DEF__CONTAINER:
            setContainer ((Container) null);
            return;
         case IdlmmPackage.INTERFACE_DEF__PREFIX:
            setPrefix (PREFIX_EDEFAULT);
            return;
         case IdlmmPackage.INTERFACE_DEF__ID:
            setID (ID_EDEFAULT);
            return;
         case IdlmmPackage.INTERFACE_DEF__VERSION:
            setVersion (VERSION_EDEFAULT);
            return;
         case IdlmmPackage.INTERFACE_DEF__CONTAINING_MODULE:
            setContainingModule ((ModuleDef) null);
            return;
         case IdlmmPackage.INTERFACE_DEF__CONTAINING_REPOSITORY:
            setContainingRepository ((Repository) null);
            return;
         case IdlmmPackage.INTERFACE_DEF__MODIFIER:
            setModifier (MODIFIER_EDEFAULT);
            return;
         case IdlmmPackage.INTERFACE_DEF__INTERFACE_CONTENTS:
            getInterfaceContents ().clear ();
            return;
         case IdlmmPackage.INTERFACE_DEF__BASE_INTERFACES:
            getBaseInterfaces ().clear ();
            return;
      }
      super.eUnset (featureID);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public boolean eIsSet (int featureID)
   {
      switch (featureID)
      {
         case IdlmmPackage.INTERFACE_DEF__NAME:
            return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals (name);
         case IdlmmPackage.INTERFACE_DEF__KEY:
            return KEY_EDEFAULT == null ? getKey () != null : !KEY_EDEFAULT.equals (getKey ());
         case IdlmmPackage.INTERFACE_DEF__CONTAINER:
            return isSetContainer ();
         case IdlmmPackage.INTERFACE_DEF__ABSOLUTE_NAME:
            return ABSOLUTE_NAME_EDEFAULT == null ? getAbsoluteName () != null : !ABSOLUTE_NAME_EDEFAULT
                  .equals (getAbsoluteName ());
         case IdlmmPackage.INTERFACE_DEF__PREFIX:
            return PREFIX_EDEFAULT == null ? prefix != null : !PREFIX_EDEFAULT.equals (prefix);
         case IdlmmPackage.INTERFACE_DEF__ID:
            return ID_EDEFAULT == null ? id != null : !ID_EDEFAULT.equals (id);
         case IdlmmPackage.INTERFACE_DEF__VERSION:
            return VERSION_EDEFAULT == null ? version != null : !VERSION_EDEFAULT.equals (version);
         case IdlmmPackage.INTERFACE_DEF__CONTAINING_MODULE:
            return getContainingModule () != null;
         case IdlmmPackage.INTERFACE_DEF__CONTAINING_REPOSITORY:
            return getContainingRepository () != null;
         case IdlmmPackage.INTERFACE_DEF__MODIFIER:
            return modifier != MODIFIER_EDEFAULT;
         case IdlmmPackage.INTERFACE_DEF__ATTRIBUTES:
            return !getAttributes ().isEmpty ();
         case IdlmmPackage.INTERFACE_DEF__ALL_ATTRIBUTES:
            return !getAllAttributes ().isEmpty ();
         case IdlmmPackage.INTERFACE_DEF__OPERATIONS:
            return !getOperations ().isEmpty ();
         case IdlmmPackage.INTERFACE_DEF__ALL_OPERATIONS:
            return !getAllOperations ().isEmpty ();
         case IdlmmPackage.INTERFACE_DEF__EXCEPTIONS:
            return !getExceptions ().isEmpty ();
         case IdlmmPackage.INTERFACE_DEF__ALL_EXCEPTIONS:
            return !getAllExceptions ().isEmpty ();
         case IdlmmPackage.INTERFACE_DEF__STRUCTS:
            return !getStructs ().isEmpty ();
         case IdlmmPackage.INTERFACE_DEF__ALL_STRUCTS:
            return !getAllStructs ().isEmpty ();
         case IdlmmPackage.INTERFACE_DEF__ENUMS:
            return !getEnums ().isEmpty ();
         case IdlmmPackage.INTERFACE_DEF__ALL_ENUMS:
            return !getAllEnums ().isEmpty ();
         case IdlmmPackage.INTERFACE_DEF__UNIONS:
            return !getUnions ().isEmpty ();
         case IdlmmPackage.INTERFACE_DEF__ALL_UNIONS:
            return !getAllUnions ().isEmpty ();
         case IdlmmPackage.INTERFACE_DEF__NATIVES:
            return !getNatives ().isEmpty ();
         case IdlmmPackage.INTERFACE_DEF__ALL_NATIVES:
            return !getAllNatives ().isEmpty ();
         case IdlmmPackage.INTERFACE_DEF__ALIASES:
            return !getAliases ().isEmpty ();
         case IdlmmPackage.INTERFACE_DEF__ALL_ALIASES:
            return !getAllAliases ().isEmpty ();
         case IdlmmPackage.INTERFACE_DEF__CONSTANTS:
            return !getConstants ().isEmpty ();
         case IdlmmPackage.INTERFACE_DEF__ALL_CONSTANTS:
            return !getAllConstants ().isEmpty ();
         case IdlmmPackage.INTERFACE_DEF__INTERFACE_CONTENTS:
            return interfaceContents != null && !interfaceContents.isEmpty ();
         case IdlmmPackage.INTERFACE_DEF__BASE_INTERFACES:
            return baseInterfaces != null && !baseInterfaces.isEmpty ();
         case IdlmmPackage.INTERFACE_DEF__ALL_BASE_INTERFACES:
            return !getAllBaseInterfaces ().isEmpty ();
         case IdlmmPackage.INTERFACE_DEF__ALL_CONTENTS:
            return !getAllContents ().isEmpty ();
      }
      return super.eIsSet (featureID);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public int eBaseStructuralFeatureID (int derivedFeatureID, Class<?> baseClass)
   {
      if (baseClass == IDLType.class)
      {
         switch (derivedFeatureID)
         {
            default:
               return -1;
         }
      }
      if (baseClass == SharedIDLType.class)
      {
         switch (derivedFeatureID)
         {
            default:
               return -1;
         }
      }
      if (baseClass == Named.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.INTERFACE_DEF__NAME:
               return IdlmmPackage.NAMED__NAME;
            case IdlmmPackage.INTERFACE_DEF__KEY:
               return IdlmmPackage.NAMED__KEY;
            default:
               return -1;
         }
      }
      if (baseClass == Contained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.INTERFACE_DEF__ABSOLUTE_NAME:
               return IdlmmPackage.CONTAINED__ABSOLUTE_NAME;
            case IdlmmPackage.INTERFACE_DEF__PREFIX:
               return IdlmmPackage.CONTAINED__PREFIX;
            case IdlmmPackage.INTERFACE_DEF__ID:
               return IdlmmPackage.CONTAINED__ID;
            case IdlmmPackage.INTERFACE_DEF__VERSION:
               return IdlmmPackage.CONTAINED__VERSION;
            case IdlmmPackage.INTERFACE_DEF__CONTAINER:
               return IdlmmPackage.CONTAINED__CONTAINER;
            default:
               return -1;
         }
      }
      if (baseClass == ModuleContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.INTERFACE_DEF__CONTAINING_MODULE:
               return IdlmmPackage.MODULE_CONTAINED__CONTAINING_MODULE;
            default:
               return -1;
         }
      }
      if (baseClass == RepositoryContained.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.INTERFACE_DEF__CONTAINING_REPOSITORY:
               return IdlmmPackage.REPOSITORY_CONTAINED__CONTAINING_REPOSITORY;
            default:
               return -1;
         }
      }
      if (baseClass == Interface.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.INTERFACE_DEF__MODIFIER:
               return IdlmmPackage.INTERFACE__MODIFIER;
            default:
               return -1;
         }
      }
      if (baseClass == AttributeContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.INTERFACE_DEF__ATTRIBUTES:
               return IdlmmPackage.ATTRIBUTE_CONTAINER__ATTRIBUTES;
            case IdlmmPackage.INTERFACE_DEF__ALL_ATTRIBUTES:
               return IdlmmPackage.ATTRIBUTE_CONTAINER__ALL_ATTRIBUTES;
            default:
               return -1;
         }
      }
      if (baseClass == OperationContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.INTERFACE_DEF__OPERATIONS:
               return IdlmmPackage.OPERATION_CONTAINER__OPERATIONS;
            case IdlmmPackage.INTERFACE_DEF__ALL_OPERATIONS:
               return IdlmmPackage.OPERATION_CONTAINER__ALL_OPERATIONS;
            default:
               return -1;
         }
      }
      if (baseClass == ExceptionContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.INTERFACE_DEF__EXCEPTIONS:
               return IdlmmPackage.EXCEPTION_CONTAINER__EXCEPTIONS;
            case IdlmmPackage.INTERFACE_DEF__ALL_EXCEPTIONS:
               return IdlmmPackage.EXCEPTION_CONTAINER__ALL_EXCEPTIONS;
            default:
               return -1;
         }
      }
      if (baseClass == StructContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.INTERFACE_DEF__STRUCTS:
               return IdlmmPackage.STRUCT_CONTAINER__STRUCTS;
            case IdlmmPackage.INTERFACE_DEF__ALL_STRUCTS:
               return IdlmmPackage.STRUCT_CONTAINER__ALL_STRUCTS;
            default:
               return -1;
         }
      }
      if (baseClass == EnumContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.INTERFACE_DEF__ENUMS:
               return IdlmmPackage.ENUM_CONTAINER__ENUMS;
            case IdlmmPackage.INTERFACE_DEF__ALL_ENUMS:
               return IdlmmPackage.ENUM_CONTAINER__ALL_ENUMS;
            default:
               return -1;
         }
      }
      if (baseClass == UnionContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.INTERFACE_DEF__UNIONS:
               return IdlmmPackage.UNION_CONTAINER__UNIONS;
            case IdlmmPackage.INTERFACE_DEF__ALL_UNIONS:
               return IdlmmPackage.UNION_CONTAINER__ALL_UNIONS;
            default:
               return -1;
         }
      }
      if (baseClass == NativeContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.INTERFACE_DEF__NATIVES:
               return IdlmmPackage.NATIVE_CONTAINER__NATIVES;
            case IdlmmPackage.INTERFACE_DEF__ALL_NATIVES:
               return IdlmmPackage.NATIVE_CONTAINER__ALL_NATIVES;
            default:
               return -1;
         }
      }
      if (baseClass == AliasContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.INTERFACE_DEF__ALIASES:
               return IdlmmPackage.ALIAS_CONTAINER__ALIASES;
            case IdlmmPackage.INTERFACE_DEF__ALL_ALIASES:
               return IdlmmPackage.ALIAS_CONTAINER__ALL_ALIASES;
            default:
               return -1;
         }
      }
      if (baseClass == ConstantContainer.class)
      {
         switch (derivedFeatureID)
         {
            case IdlmmPackage.INTERFACE_DEF__CONSTANTS:
               return IdlmmPackage.CONSTANT_CONTAINER__CONSTANTS;
            case IdlmmPackage.INTERFACE_DEF__ALL_CONSTANTS:
               return IdlmmPackage.CONSTANT_CONTAINER__ALL_CONSTANTS;
            default:
               return -1;
         }
      }
      return super.eBaseStructuralFeatureID (derivedFeatureID, baseClass);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public int eDerivedStructuralFeatureID (int baseFeatureID, Class<?> baseClass)
   {
      if (baseClass == IDLType.class)
      {
         switch (baseFeatureID)
         {
            default:
               return -1;
         }
      }
      if (baseClass == SharedIDLType.class)
      {
         switch (baseFeatureID)
         {
            default:
               return -1;
         }
      }
      if (baseClass == Named.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.NAMED__NAME:
               return IdlmmPackage.INTERFACE_DEF__NAME;
            case IdlmmPackage.NAMED__KEY:
               return IdlmmPackage.INTERFACE_DEF__KEY;
            default:
               return -1;
         }
      }
      if (baseClass == Contained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.CONTAINED__ABSOLUTE_NAME:
               return IdlmmPackage.INTERFACE_DEF__ABSOLUTE_NAME;
            case IdlmmPackage.CONTAINED__PREFIX:
               return IdlmmPackage.INTERFACE_DEF__PREFIX;
            case IdlmmPackage.CONTAINED__ID:
               return IdlmmPackage.INTERFACE_DEF__ID;
            case IdlmmPackage.CONTAINED__VERSION:
               return IdlmmPackage.INTERFACE_DEF__VERSION;
            case IdlmmPackage.CONTAINED__CONTAINER:
               return IdlmmPackage.INTERFACE_DEF__CONTAINER;
            default:
               return -1;
         }
      }
      if (baseClass == ModuleContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.MODULE_CONTAINED__CONTAINING_MODULE:
               return IdlmmPackage.INTERFACE_DEF__CONTAINING_MODULE;
            default:
               return -1;
         }
      }
      if (baseClass == RepositoryContained.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.REPOSITORY_CONTAINED__CONTAINING_REPOSITORY:
               return IdlmmPackage.INTERFACE_DEF__CONTAINING_REPOSITORY;
            default:
               return -1;
         }
      }
      if (baseClass == Interface.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.INTERFACE__MODIFIER:
               return IdlmmPackage.INTERFACE_DEF__MODIFIER;
            default:
               return -1;
         }
      }
      if (baseClass == AttributeContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.ATTRIBUTE_CONTAINER__ATTRIBUTES:
               return IdlmmPackage.INTERFACE_DEF__ATTRIBUTES;
            case IdlmmPackage.ATTRIBUTE_CONTAINER__ALL_ATTRIBUTES:
               return IdlmmPackage.INTERFACE_DEF__ALL_ATTRIBUTES;
            default:
               return -1;
         }
      }
      if (baseClass == OperationContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.OPERATION_CONTAINER__OPERATIONS:
               return IdlmmPackage.INTERFACE_DEF__OPERATIONS;
            case IdlmmPackage.OPERATION_CONTAINER__ALL_OPERATIONS:
               return IdlmmPackage.INTERFACE_DEF__ALL_OPERATIONS;
            default:
               return -1;
         }
      }
      if (baseClass == ExceptionContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.EXCEPTION_CONTAINER__EXCEPTIONS:
               return IdlmmPackage.INTERFACE_DEF__EXCEPTIONS;
            case IdlmmPackage.EXCEPTION_CONTAINER__ALL_EXCEPTIONS:
               return IdlmmPackage.INTERFACE_DEF__ALL_EXCEPTIONS;
            default:
               return -1;
         }
      }
      if (baseClass == StructContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.STRUCT_CONTAINER__STRUCTS:
               return IdlmmPackage.INTERFACE_DEF__STRUCTS;
            case IdlmmPackage.STRUCT_CONTAINER__ALL_STRUCTS:
               return IdlmmPackage.INTERFACE_DEF__ALL_STRUCTS;
            default:
               return -1;
         }
      }
      if (baseClass == EnumContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.ENUM_CONTAINER__ENUMS:
               return IdlmmPackage.INTERFACE_DEF__ENUMS;
            case IdlmmPackage.ENUM_CONTAINER__ALL_ENUMS:
               return IdlmmPackage.INTERFACE_DEF__ALL_ENUMS;
            default:
               return -1;
         }
      }
      if (baseClass == UnionContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.UNION_CONTAINER__UNIONS:
               return IdlmmPackage.INTERFACE_DEF__UNIONS;
            case IdlmmPackage.UNION_CONTAINER__ALL_UNIONS:
               return IdlmmPackage.INTERFACE_DEF__ALL_UNIONS;
            default:
               return -1;
         }
      }
      if (baseClass == NativeContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.NATIVE_CONTAINER__NATIVES:
               return IdlmmPackage.INTERFACE_DEF__NATIVES;
            case IdlmmPackage.NATIVE_CONTAINER__ALL_NATIVES:
               return IdlmmPackage.INTERFACE_DEF__ALL_NATIVES;
            default:
               return -1;
         }
      }
      if (baseClass == AliasContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.ALIAS_CONTAINER__ALIASES:
               return IdlmmPackage.INTERFACE_DEF__ALIASES;
            case IdlmmPackage.ALIAS_CONTAINER__ALL_ALIASES:
               return IdlmmPackage.INTERFACE_DEF__ALL_ALIASES;
            default:
               return -1;
         }
      }
      if (baseClass == ConstantContainer.class)
      {
         switch (baseFeatureID)
         {
            case IdlmmPackage.CONSTANT_CONTAINER__CONSTANTS:
               return IdlmmPackage.INTERFACE_DEF__CONSTANTS;
            case IdlmmPackage.CONSTANT_CONTAINER__ALL_CONSTANTS:
               return IdlmmPackage.INTERFACE_DEF__ALL_CONSTANTS;
            default:
               return -1;
         }
      }
      return super.eDerivedStructuralFeatureID (baseFeatureID, baseClass);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public String toString ()
   {
      if (eIsProxy ())
         return super.toString ();

      StringBuffer result = new StringBuffer (super.toString ());
      result.append (" (name: ");
      result.append (name);
      result.append (", prefix: ");
      result.append (prefix);
      result.append (", ID: ");
      result.append (id);
      result.append (", version: ");
      result.append (version);
      result.append (", modifier: ");
      result.append (modifier);
      result.append (')');
      return result.toString ();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public boolean isSetContainer ()
   {
      return eIsSet (IdlmmPackage.INTERFACE_DEF__CONTAINING_MODULE) || eIsSet (IdlmmPackage.INTERFACE_DEF__CONTAINING_REPOSITORY);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public boolean isSetContents ()
   {
      return super.isSetContents () || eIsSet (IdlmmPackage.INTERFACE_DEF__INTERFACE_CONTENTS);
   }

} //InterfaceDefImpl
