/**
 * <copyright>
 * </copyright>
 *
 * $Id: IdlmmAdapterFactory.java,v 1.51 2008/08/22 11:55:34 je Exp $
 */
package com.prismtech.idt.idlmm.util;

import com.prismtech.idt.idlmm.*;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;


/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see com.prismtech.idt.idlmm.IdlmmPackage
 * @generated
 */
public class IdlmmAdapterFactory extends AdapterFactoryImpl
{
   /**
    * The cached model package.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected static IdlmmPackage modelPackage;

   /**
    * Creates an instance of the adapter factory.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public IdlmmAdapterFactory ()
   {
      if (modelPackage == null)
      {
         modelPackage = IdlmmPackage.eINSTANCE;
      }
   }

   /**
    * Returns whether this factory is applicable for the type of the object.
    * <!-- begin-user-doc -->
    * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
    * <!-- end-user-doc -->
    * @return whether this factory is applicable for the type of the object.
    * @generated
    */
   @Override
   public boolean isFactoryForType (Object object)
   {
      if (object == modelPackage)
      {
         return true;
      }
      if (object instanceof EObject)
      {
         return ((EObject) object).eClass ().getEPackage () == modelPackage;
      }
      return false;
   }

   /**
    * The switch the delegates to the <code>createXXX</code> methods.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected IdlmmSwitch<Adapter> modelSwitch = new IdlmmSwitch<Adapter> ()
   {
      @Override
      public Adapter caseModuleDef (ModuleDef object)
      {
         return createModuleDefAdapter ();
      }

      @Override
      public Adapter caseContainer (Container object)
      {
         return createContainerAdapter ();
      }

      @Override
      public Adapter caseIRObject (IRObject object)
      {
         return createIRObjectAdapter ();
      }

      @Override
      public Adapter caseContained (Contained object)
      {
         return createContainedAdapter ();
      }

      @Override
      public Adapter caseRepository (Repository object)
      {
         return createRepositoryAdapter ();
      }

      @Override
      public Adapter caseStringDef (StringDef object)
      {
         return createStringDefAdapter ();
      }

      @Override
      public Adapter caseIDLType (IDLType object)
      {
         return createIDLTypeAdapter ();
      }

      @Override
      public Adapter caseTypedefDef (TypedefDef object)
      {
         return createTypedefDefAdapter ();
      }

      @Override
      public Adapter caseAliasDef (AliasDef object)
      {
         return createAliasDefAdapter ();
      }

      @Override
      public Adapter casePrimitiveDef (PrimitiveDef object)
      {
         return createPrimitiveDefAdapter ();
      }

      @Override
      public Adapter casePragma (Pragma object)
      {
         return createPragmaAdapter ();
      }

      @Override
      public Adapter caseWStringDef (WStringDef object)
      {
         return createWStringDefAdapter ();
      }

      @Override
      public Adapter caseSequenceDef (SequenceDef object)
      {
         return createSequenceDefAdapter ();
      }

      @Override
      public Adapter caseArrayDef (ArrayDef object)
      {
         return createArrayDefAdapter ();
      }

      @Override
      public Adapter caseFixedDef (FixedDef object)
      {
         return createFixedDefAdapter ();
      }

      @Override
      public Adapter caseStructDef (StructDef object)
      {
         return createStructDefAdapter ();
      }

      @Override
      public Adapter caseStructMember (StructMember object)
      {
         return createStructMemberAdapter ();
      }

      @Override
      public Adapter caseInterfaceDef (InterfaceDef object)
      {
         return createInterfaceDefAdapter ();
      }

      @Override
      public Adapter caseOwnedIDLType (OwnedIDLType object)
      {
         return createOwnedIDLTypeAdapter ();
      }

      @Override
      public Adapter caseSharedIDLType (SharedIDLType object)
      {
         return createSharedIDLTypeAdapter ();
      }

      @Override
      public Adapter caseTyped (Typed object)
      {
         return createTypedAdapter ();
      }

      @Override
      public Adapter caseUnionDef (UnionDef object)
      {
         return createUnionDefAdapter ();
      }

      @Override
      public Adapter caseEnumDef (EnumDef object)
      {
         return createEnumDefAdapter ();
      }

      @Override
      public Adapter caseConstantDef (ConstantDef object)
      {
         return createConstantDefAdapter ();
      }

      @Override
      public Adapter caseEnumMember (EnumMember object)
      {
         return createEnumMemberAdapter ();
      }

      @Override
      public Adapter caseUnionMember (UnionMember object)
      {
         return createUnionMemberAdapter ();
      }

      @Override
      public Adapter caseExceptionDef (ExceptionDef object)
      {
         return createExceptionDefAdapter ();
      }

      @Override
      public Adapter caseAttributeDef (AttributeDef object)
      {
         return createAttributeDefAdapter ();
      }

      @Override
      public Adapter caseParameterDef (ParameterDef object)
      {
         return createParameterDefAdapter ();
      }

      @Override
      public Adapter caseOperationDef (OperationDef object)
      {
         return createOperationDefAdapter ();
      }

      @Override
      public Adapter caseValueMemberDef (ValueMemberDef object)
      {
         return createValueMemberDefAdapter ();
      }

      @Override
      public Adapter caseValueDef (ValueDef object)
      {
         return createValueDefAdapter ();
      }

      @Override
      public Adapter caseInitializer (Initializer object)
      {
         return createInitializerAdapter ();
      }

      @Override
      public Adapter caseValueBoxDef (ValueBoxDef object)
      {
         return createValueBoxDefAdapter ();
      }

      @Override
      public Adapter caseNativeDef (NativeDef object)
      {
         return createNativeDefAdapter ();
      }

      @Override
      public Adapter caseNamed (Named object)
      {
         return createNamedAdapter ();
      }

      @Override
      public Adapter caseMember (Member object)
      {
         return createMemberAdapter ();
      }

      @Override
      public Adapter caseExceptionMember (ExceptionMember object)
      {
         return createExceptionMemberAdapter ();
      }

      @Override
      public Adapter caseRepositoryContained (RepositoryContained object)
      {
         return createRepositoryContainedAdapter ();
      }

      @Override
      public Adapter caseModuleContained (ModuleContained object)
      {
         return createModuleContainedAdapter ();
      }

      @Override
      public Adapter caseExceptionContained (ExceptionContained object)
      {
         return createExceptionContainedAdapter ();
      }

      @Override
      public Adapter caseInterfaceContained (InterfaceContained object)
      {
         return createInterfaceContainedAdapter ();
      }

      @Override
      public Adapter caseStructContained (StructContained object)
      {
         return createStructContainedAdapter ();
      }

      @Override
      public Adapter caseUnionContained (UnionContained object)
      {
         return createUnionContainedAdapter ();
      }

      @Override
      public Adapter caseValueContained (ValueContained object)
      {
         return createValueContainedAdapter ();
      }

      @Override
      public Adapter caseSharedExpression (SharedExpression object)
      {
         return createSharedExpressionAdapter ();
      }

      @Override
      public Adapter caseOwnedExpression (OwnedExpression object)
      {
         return createOwnedExpressionAdapter ();
      }

      @Override
      public Adapter caseExpression (Expression object)
      {
         return createExpressionAdapter ();
      }

      @Override
      public Adapter caseOperator (Operator object)
      {
         return createOperatorAdapter ();
      }

      @Override
      public Adapter caseLiteral (Literal object)
      {
         return createLiteralAdapter ();
      }

      @Override
      public Adapter caseBitwiseComplementOperator (BitwiseComplementOperator object)
      {
         return createBitwiseComplementOperatorAdapter ();
      }

      @Override
      public Adapter caseBitwiseRightShiftOperator (BitwiseRightShiftOperator object)
      {
         return createBitwiseRightShiftOperatorAdapter ();
      }

      @Override
      public Adapter caseBitwiseLeftShiftOperator (BitwiseLeftShiftOperator object)
      {
         return createBitwiseLeftShiftOperatorAdapter ();
      }

      @Override
      public Adapter caseBitwiseAndOperator (BitwiseAndOperator object)
      {
         return createBitwiseAndOperatorAdapter ();
      }

      @Override
      public Adapter caseAddOperator (AddOperator object)
      {
         return createAddOperatorAdapter ();
      }

      @Override
      public Adapter caseBitwiseXorOperator (BitwiseXorOperator object)
      {
         return createBitwiseXorOperatorAdapter ();
      }

      @Override
      public Adapter casePositiveOperator (PositiveOperator object)
      {
         return createPositiveOperatorAdapter ();
      }

      @Override
      public Adapter caseNegativeOperator (NegativeOperator object)
      {
         return createNegativeOperatorAdapter ();
      }

      @Override
      public Adapter caseBitwiseOrOperator (BitwiseOrOperator object)
      {
         return createBitwiseOrOperatorAdapter ();
      }

      @Override
      public Adapter caseSubtractOperator (SubtractOperator object)
      {
         return createSubtractOperatorAdapter ();
      }

      @Override
      public Adapter caseMultiplyOperator (MultiplyOperator object)
      {
         return createMultiplyOperatorAdapter ();
      }

      @Override
      public Adapter caseBinaryOperator (BinaryOperator object)
      {
         return createBinaryOperatorAdapter ();
      }

      @Override
      public Adapter caseModuloOperator (ModuloOperator object)
      {
         return createModuloOperatorAdapter ();
      }

      @Override
      public Adapter caseUnaryOperator (UnaryOperator object)
      {
         return createUnaryOperatorAdapter ();
      }

      @Override
      public Adapter caseDivideOperator (DivideOperator object)
      {
         return createDivideOperatorAdapter ();
      }

      @Override
      public Adapter caseEnumContained (EnumContained object)
      {
         return createEnumContainedAdapter ();
      }

      @Override
      public Adapter caseInterfaceDecl (InterfaceDecl object)
      {
         return createInterfaceDeclAdapter ();
      }

      @Override
      public Adapter caseInterface (Interface object)
      {
         return createInterfaceAdapter ();
      }

      @Override
      public Adapter casePrePragma (PrePragma object)
      {
         return createPrePragmaAdapter ();
      }

      @Override
      public Adapter casePostPragma (PostPragma object)
      {
         return createPostPragmaAdapter ();
      }

      @Override
      public Adapter caseScopePragma (ScopePragma object)
      {
         return createScopePragmaAdapter ();
      }

      @Override
      public Adapter caseBooleanLiteral (BooleanLiteral object)
      {
         return createBooleanLiteralAdapter ();
      }

      @Override
      public Adapter caseCharacterLiteral (CharacterLiteral object)
      {
         return createCharacterLiteralAdapter ();
      }

      @Override
      public Adapter caseFixedPointLiteral (FixedPointLiteral object)
      {
         return createFixedPointLiteralAdapter ();
      }

      @Override
      public Adapter caseFloatingPointLiteral (FloatingPointLiteral object)
      {
         return createFloatingPointLiteralAdapter ();
      }

      @Override
      public Adapter caseIntegerLiteral (IntegerLiteral object)
      {
         return createIntegerLiteralAdapter ();
      }

      @Override
      public Adapter caseStringLiteral (StringLiteral object)
      {
         return createStringLiteralAdapter ();
      }

      @Override
      public Adapter caseWCharacterLiteral (WCharacterLiteral object)
      {
         return createWCharacterLiteralAdapter ();
      }

      @Override
      public Adapter caseWStringLiteral (WStringLiteral object)
      {
         return createWStringLiteralAdapter ();
      }

      @Override
      public Adapter caseExpressionContext (ExpressionContext object)
      {
         return createExpressionContextAdapter ();
      }

      @Override
      public Adapter caseValue (Value object)
      {
         return createValueAdapter ();
      }

      @Override
      public Adapter caseValueDecl (ValueDecl object)
      {
         return createValueDeclAdapter ();
      }

      @Override
      public Adapter caseInitializerParameterDef (InitializerParameterDef object)
      {
         return createInitializerParameterDefAdapter ();
      }

      @Override
      public Adapter caseComponent (Component object)
      {
         return createComponentAdapter ();
      }

      @Override
      public Adapter caseComponentDef (ComponentDef object)
      {
         return createComponentDefAdapter ();
      }

      @Override
      public Adapter caseComponentDecl (ComponentDecl object)
      {
         return createComponentDeclAdapter ();
      }

      @Override
      public Adapter caseComponentContained (ComponentContained object)
      {
         return createComponentContainedAdapter ();
      }

      @Override
      public Adapter caseComponentPortDef (ComponentPortDef object)
      {
         return createComponentPortDefAdapter ();
      }

      @Override
      public Adapter caseHome (Home object)
      {
         return createHomeAdapter ();
      }

      @Override
      public Adapter caseHomeDef (HomeDef object)
      {
         return createHomeDefAdapter ();
      }

      @Override
      public Adapter caseHomeContained (HomeContained object)
      {
         return createHomeContainedAdapter ();
      }

      @Override
      public Adapter caseFactoryOperation (FactoryOperation object)
      {
         return createFactoryOperationAdapter ();
      }

      @Override
      public Adapter caseFinderOperation (FinderOperation object)
      {
         return createFinderOperationAdapter ();
      }

      @Override
      public Adapter caseInterfacePortDef (InterfacePortDef object)
      {
         return createInterfacePortDefAdapter ();
      }

      @Override
      public Adapter caseEventPortDef (EventPortDef object)
      {
         return createEventPortDefAdapter ();
      }

      @Override
      public Adapter caseProvidesDef (ProvidesDef object)
      {
         return createProvidesDefAdapter ();
      }

      @Override
      public Adapter caseUsesDef (UsesDef object)
      {
         return createUsesDefAdapter ();
      }

      @Override
      public Adapter caseConsumesDef (ConsumesDef object)
      {
         return createConsumesDefAdapter ();
      }

      @Override
      public Adapter casePublishesDef (PublishesDef object)
      {
         return createPublishesDefAdapter ();
      }

      @Override
      public Adapter caseEmitsDef (EmitsDef object)
      {
         return createEmitsDefAdapter ();
      }

      @Override
      public Adapter caseEvent (Event object)
      {
         return createEventAdapter ();
      }

      @Override
      public Adapter caseEventDecl (EventDecl object)
      {
         return createEventDeclAdapter ();
      }

      @Override
      public Adapter caseEventDef (EventDef object)
      {
         return createEventDefAdapter ();
      }

      @Override
      public Adapter caseAttributeContainer (AttributeContainer object)
      {
         return createAttributeContainerAdapter ();
      }

      @Override
      public Adapter caseOperationContainer (OperationContainer object)
      {
         return createOperationContainerAdapter ();
      }

      @Override
      public Adapter caseConstantContainer (ConstantContainer object)
      {
         return createConstantContainerAdapter ();
      }

      @Override
      public Adapter caseAliasContainer (AliasContainer object)
      {
         return createAliasContainerAdapter ();
      }

      @Override
      public Adapter caseNativeContainer (NativeContainer object)
      {
         return createNativeContainerAdapter ();
      }

      @Override
      public Adapter caseUnionContainer (UnionContainer object)
      {
         return createUnionContainerAdapter ();
      }

      @Override
      public Adapter caseStructContainer (StructContainer object)
      {
         return createStructContainerAdapter ();
      }

      @Override
      public Adapter caseEnumContainer (EnumContainer object)
      {
         return createEnumContainerAdapter ();
      }

      @Override
      public Adapter caseExceptionContainer (ExceptionContainer object)
      {
         return createExceptionContainerAdapter ();
      }

      @Override
      public Adapter defaultCase (EObject object)
      {
         return createEObjectAdapter ();
      }
   };

   /**
    * Creates an adapter for the <code>target</code>.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @param target the object to adapt.
    * @return the adapter for the <code>target</code>.
    * @generated
    */
   @Override
   public Adapter createAdapter (Notifier target)
   {
      return modelSwitch.doSwitch ((EObject) target);
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.ModuleDef <em>Module Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.ModuleDef
    * @generated
    */
   public Adapter createModuleDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.Container <em>Container</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.Container
    * @generated
    */
   public Adapter createContainerAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.IRObject <em>IR Object</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.IRObject
    * @generated
    */
   public Adapter createIRObjectAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.Contained <em>Contained</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.Contained
    * @generated
    */
   public Adapter createContainedAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.Repository <em>Repository</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.Repository
    * @generated
    */
   public Adapter createRepositoryAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.StringDef <em>String Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.StringDef
    * @generated
    */
   public Adapter createStringDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.IDLType <em>IDL Type</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.IDLType
    * @generated
    */
   public Adapter createIDLTypeAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.TypedefDef <em>Typedef Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.TypedefDef
    * @generated
    */
   public Adapter createTypedefDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.AliasDef <em>Alias Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.AliasDef
    * @generated
    */
   public Adapter createAliasDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.PrimitiveDef <em>Primitive Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.PrimitiveDef
    * @generated
    */
   public Adapter createPrimitiveDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.Pragma <em>Pragma</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.Pragma
    * @generated
    */
   public Adapter createPragmaAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.WStringDef <em>WString Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.WStringDef
    * @generated
    */
   public Adapter createWStringDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.SequenceDef <em>Sequence Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.SequenceDef
    * @generated
    */
   public Adapter createSequenceDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.ArrayDef <em>Array Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.ArrayDef
    * @generated
    */
   public Adapter createArrayDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.FixedDef <em>Fixed Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.FixedDef
    * @generated
    */
   public Adapter createFixedDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.StructDef <em>Struct Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.StructDef
    * @generated
    */
   public Adapter createStructDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.StructMember <em>Struct Member</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.StructMember
    * @generated
    */
   public Adapter createStructMemberAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.InterfaceDef <em>Interface Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.InterfaceDef
    * @generated
    */
   public Adapter createInterfaceDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.OwnedIDLType <em>Owned IDL Type</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.OwnedIDLType
    * @generated
    */
   public Adapter createOwnedIDLTypeAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.SharedIDLType <em>Shared IDL Type</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.SharedIDLType
    * @generated
    */
   public Adapter createSharedIDLTypeAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.Typed <em>Typed</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.Typed
    * @generated
    */
   public Adapter createTypedAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.UnionDef <em>Union Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.UnionDef
    * @generated
    */
   public Adapter createUnionDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.EnumDef <em>Enum Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.EnumDef
    * @generated
    */
   public Adapter createEnumDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.ConstantDef <em>Constant Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.ConstantDef
    * @generated
    */
   public Adapter createConstantDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.EnumMember <em>Enum Member</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.EnumMember
    * @generated
    */
   public Adapter createEnumMemberAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.UnionMember <em>Union Member</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.UnionMember
    * @generated
    */
   public Adapter createUnionMemberAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.ExceptionDef <em>Exception Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.ExceptionDef
    * @generated
    */
   public Adapter createExceptionDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.AttributeDef <em>Attribute Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.AttributeDef
    * @generated
    */
   public Adapter createAttributeDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.ParameterDef <em>Parameter Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.ParameterDef
    * @generated
    */
   public Adapter createParameterDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.OperationDef <em>Operation Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.OperationDef
    * @generated
    */
   public Adapter createOperationDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.ValueMemberDef <em>Value Member Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.ValueMemberDef
    * @generated
    */
   public Adapter createValueMemberDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.ValueDef <em>Value Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.ValueDef
    * @generated
    */
   public Adapter createValueDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.Initializer <em>Initializer</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.Initializer
    * @generated
    */
   public Adapter createInitializerAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.ValueBoxDef <em>Value Box Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.ValueBoxDef
    * @generated
    */
   public Adapter createValueBoxDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.NativeDef <em>Native Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.NativeDef
    * @generated
    */
   public Adapter createNativeDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.Named <em>Named</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.Named
    * @generated
    */
   public Adapter createNamedAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.Member <em>Member</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.Member
    * @generated
    */
   public Adapter createMemberAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.ExceptionMember <em>Exception Member</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.ExceptionMember
    * @generated
    */
   public Adapter createExceptionMemberAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.RepositoryContained <em>Repository Contained</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.RepositoryContained
    * @generated
    */
   public Adapter createRepositoryContainedAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.ModuleContained <em>Module Contained</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.ModuleContained
    * @generated
    */
   public Adapter createModuleContainedAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.ExceptionContained <em>Exception Contained</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.ExceptionContained
    * @generated
    */
   public Adapter createExceptionContainedAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.InterfaceContained <em>Interface Contained</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.InterfaceContained
    * @generated
    */
   public Adapter createInterfaceContainedAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.StructContained <em>Struct Contained</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.StructContained
    * @generated
    */
   public Adapter createStructContainedAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.UnionContained <em>Union Contained</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.UnionContained
    * @generated
    */
   public Adapter createUnionContainedAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.ValueContained <em>Value Contained</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.ValueContained
    * @generated
    */
   public Adapter createValueContainedAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.SharedExpression <em>Shared Expression</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.SharedExpression
    * @generated
    */
   public Adapter createSharedExpressionAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.OwnedExpression <em>Owned Expression</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.OwnedExpression
    * @generated
    */
   public Adapter createOwnedExpressionAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.Expression <em>Expression</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.Expression
    * @generated
    */
   public Adapter createExpressionAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.Operator <em>Operator</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.Operator
    * @generated
    */
   public Adapter createOperatorAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.Literal <em>Literal</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.Literal
    * @generated
    */
   public Adapter createLiteralAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.BitwiseComplementOperator <em>Bitwise Complement Operator</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.BitwiseComplementOperator
    * @generated
    */
   public Adapter createBitwiseComplementOperatorAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.BitwiseRightShiftOperator <em>Bitwise Right Shift Operator</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.BitwiseRightShiftOperator
    * @generated
    */
   public Adapter createBitwiseRightShiftOperatorAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.BitwiseLeftShiftOperator <em>Bitwise Left Shift Operator</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.BitwiseLeftShiftOperator
    * @generated
    */
   public Adapter createBitwiseLeftShiftOperatorAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.BitwiseAndOperator <em>Bitwise And Operator</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.BitwiseAndOperator
    * @generated
    */
   public Adapter createBitwiseAndOperatorAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.AddOperator <em>Add Operator</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.AddOperator
    * @generated
    */
   public Adapter createAddOperatorAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.BitwiseXorOperator <em>Bitwise Xor Operator</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.BitwiseXorOperator
    * @generated
    */
   public Adapter createBitwiseXorOperatorAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.PositiveOperator <em>Positive Operator</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.PositiveOperator
    * @generated
    */
   public Adapter createPositiveOperatorAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.NegativeOperator <em>Negative Operator</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.NegativeOperator
    * @generated
    */
   public Adapter createNegativeOperatorAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.BitwiseOrOperator <em>Bitwise Or Operator</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.BitwiseOrOperator
    * @generated
    */
   public Adapter createBitwiseOrOperatorAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.SubtractOperator <em>Subtract Operator</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.SubtractOperator
    * @generated
    */
   public Adapter createSubtractOperatorAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.MultiplyOperator <em>Multiply Operator</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.MultiplyOperator
    * @generated
    */
   public Adapter createMultiplyOperatorAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.BinaryOperator <em>Binary Operator</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.BinaryOperator
    * @generated
    */
   public Adapter createBinaryOperatorAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.ModuloOperator <em>Modulo Operator</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.ModuloOperator
    * @generated
    */
   public Adapter createModuloOperatorAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.UnaryOperator <em>Unary Operator</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.UnaryOperator
    * @generated
    */
   public Adapter createUnaryOperatorAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.DivideOperator <em>Divide Operator</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.DivideOperator
    * @generated
    */
   public Adapter createDivideOperatorAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.EnumContained <em>Enum Contained</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.EnumContained
    * @generated
    */
   public Adapter createEnumContainedAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.InterfaceDecl <em>Interface Decl</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.InterfaceDecl
    * @generated
    */
   public Adapter createInterfaceDeclAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.Interface <em>Interface</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.Interface
    * @generated
    */
   public Adapter createInterfaceAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.PrePragma <em>Pre Pragma</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.PrePragma
    * @generated
    */
   public Adapter createPrePragmaAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.PostPragma <em>Post Pragma</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.PostPragma
    * @generated
    */
   public Adapter createPostPragmaAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.ScopePragma <em>Scope Pragma</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.ScopePragma
    * @generated
    */
   public Adapter createScopePragmaAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.BooleanLiteral <em>Boolean Literal</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.BooleanLiteral
    * @generated
    */
   public Adapter createBooleanLiteralAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.CharacterLiteral <em>Character Literal</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.CharacterLiteral
    * @generated
    */
   public Adapter createCharacterLiteralAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.FixedPointLiteral <em>Fixed Point Literal</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.FixedPointLiteral
    * @generated
    */
   public Adapter createFixedPointLiteralAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.FloatingPointLiteral <em>Floating Point Literal</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.FloatingPointLiteral
    * @generated
    */
   public Adapter createFloatingPointLiteralAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.IntegerLiteral <em>Integer Literal</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.IntegerLiteral
    * @generated
    */
   public Adapter createIntegerLiteralAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.StringLiteral <em>String Literal</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.StringLiteral
    * @generated
    */
   public Adapter createStringLiteralAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.WCharacterLiteral <em>WCharacter Literal</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.WCharacterLiteral
    * @generated
    */
   public Adapter createWCharacterLiteralAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.WStringLiteral <em>WString Literal</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.WStringLiteral
    * @generated
    */
   public Adapter createWStringLiteralAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.ExpressionContext <em>Expression Context</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.ExpressionContext
    * @generated
    */
   public Adapter createExpressionContextAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.Value <em>Value</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.Value
    * @generated
    */
   public Adapter createValueAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.ValueDecl <em>Value Decl</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.ValueDecl
    * @generated
    */
   public Adapter createValueDeclAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.InitializerParameterDef <em>Initializer Parameter Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.InitializerParameterDef
    * @generated
    */
   public Adapter createInitializerParameterDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.Component <em>Component</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.Component
    * @generated
    */
   public Adapter createComponentAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.ComponentDef <em>Component Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.ComponentDef
    * @generated
    */
   public Adapter createComponentDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.ComponentDecl <em>Component Decl</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.ComponentDecl
    * @generated
    */
   public Adapter createComponentDeclAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.ComponentContained <em>Component Contained</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.ComponentContained
    * @generated
    */
   public Adapter createComponentContainedAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.ComponentPortDef <em>Component Port Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.ComponentPortDef
    * @generated
    */
   public Adapter createComponentPortDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.Home <em>Home</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.Home
    * @generated
    */
   public Adapter createHomeAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.HomeDef <em>Home Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.HomeDef
    * @generated
    */
   public Adapter createHomeDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.HomeContained <em>Home Contained</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.HomeContained
    * @generated
    */
   public Adapter createHomeContainedAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.FactoryOperation <em>Factory Operation</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.FactoryOperation
    * @generated
    */
   public Adapter createFactoryOperationAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.FinderOperation <em>Finder Operation</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.FinderOperation
    * @generated
    */
   public Adapter createFinderOperationAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.InterfacePortDef <em>Interface Port Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.InterfacePortDef
    * @generated
    */
   public Adapter createInterfacePortDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.EventPortDef <em>Event Port Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.EventPortDef
    * @generated
    */
   public Adapter createEventPortDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.ProvidesDef <em>Provides Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.ProvidesDef
    * @generated
    */
   public Adapter createProvidesDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.UsesDef <em>Uses Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.UsesDef
    * @generated
    */
   public Adapter createUsesDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.ConsumesDef <em>Consumes Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.ConsumesDef
    * @generated
    */
   public Adapter createConsumesDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.PublishesDef <em>Publishes Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.PublishesDef
    * @generated
    */
   public Adapter createPublishesDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.EmitsDef <em>Emits Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.EmitsDef
    * @generated
    */
   public Adapter createEmitsDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.Event <em>Event</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.Event
    * @generated
    */
   public Adapter createEventAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.EventDecl <em>Event Decl</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.EventDecl
    * @generated
    */
   public Adapter createEventDeclAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.EventDef <em>Event Def</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.EventDef
    * @generated
    */
   public Adapter createEventDefAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.AttributeContainer <em>Attribute Container</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.AttributeContainer
    * @generated
    */
   public Adapter createAttributeContainerAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.OperationContainer <em>Operation Container</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.OperationContainer
    * @generated
    */
   public Adapter createOperationContainerAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.ConstantContainer <em>Constant Container</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.ConstantContainer
    * @generated
    */
   public Adapter createConstantContainerAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.AliasContainer <em>Alias Container</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.AliasContainer
    * @generated
    */
   public Adapter createAliasContainerAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.NativeContainer <em>Native Container</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.NativeContainer
    * @generated
    */
   public Adapter createNativeContainerAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.UnionContainer <em>Union Container</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.UnionContainer
    * @generated
    */
   public Adapter createUnionContainerAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.StructContainer <em>Struct Container</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.StructContainer
    * @generated
    */
   public Adapter createStructContainerAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.EnumContainer <em>Enum Container</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.EnumContainer
    * @generated
    */
   public Adapter createEnumContainerAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for an object of class '{@link com.prismtech.idt.idlmm.ExceptionContainer <em>Exception Container</em>}'.
    * <!-- begin-user-doc -->
    * This default implementation returns null so that we can easily ignore cases;
    * it's useful to ignore a case when inheritance will catch all the cases anyway.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @see com.prismtech.idt.idlmm.ExceptionContainer
    * @generated
    */
   public Adapter createExceptionContainerAdapter ()
   {
      return null;
   }

   /**
    * Creates a new adapter for the default case.
    * <!-- begin-user-doc -->
    * This default implementation returns null.
    * <!-- end-user-doc -->
    * @return the new adapter.
    * @generated
    */
   public Adapter createEObjectAdapter ()
   {
      return null;
   }

} //IdlmmAdapterFactory
