/**
 * <copyright>
 * </copyright>
 *
 * $Id: IdlmmSwitch.java,v 1.62 2009/09/04 09:24:29 je Exp $
 */
package com.prismtech.idt.idlmm.util;

import com.prismtech.idt.idlmm.*;

import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;


/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see com.prismtech.idt.idlmm.IdlmmPackage
 * @generated
 */
public class IdlmmSwitch<T>
{
   /**
    * The cached model package
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected static IdlmmPackage modelPackage;

   /**
    * Creates an instance of the switch.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public IdlmmSwitch ()
   {
      if (modelPackage == null)
      {
         modelPackage = IdlmmPackage.eINSTANCE;
      }
   }

   /**
    * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @return the first non-null result returned by a <code>caseXXX</code> call.
    * @generated
    */
   public T doSwitch (EObject theEObject)
   {
      return doSwitch (theEObject.eClass (), theEObject);
   }

   /**
    * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @return the first non-null result returned by a <code>caseXXX</code> call.
    * @generated
    */
   protected T doSwitch (EClass theEClass, EObject theEObject)
   {
      if (theEClass.eContainer () == modelPackage)
      {
         return doSwitch (theEClass.getClassifierID (), theEObject);
      }
      else
      {
         List<EClass> eSuperTypes = theEClass.getESuperTypes ();
         return eSuperTypes.isEmpty () ? defaultCase (theEObject) : doSwitch (eSuperTypes.get (0), theEObject);
      }
   }

   /**
    * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @return the first non-null result returned by a <code>caseXXX</code> call.
    * @generated
    */
   protected T doSwitch (int classifierID, EObject theEObject)
   {
      switch (classifierID)
      {
         case IdlmmPackage.MODULE_DEF:
         {
            ModuleDef moduleDef = (ModuleDef) theEObject;
            T result = caseModuleDef (moduleDef);
            if (result == null)
               result = caseRepositoryContained (moduleDef);
            if (result == null)
               result = caseModuleContained (moduleDef);
            if (result == null)
               result = caseContainer (moduleDef);
            if (result == null)
               result = caseExceptionContainer (moduleDef);
            if (result == null)
               result = caseStructContainer (moduleDef);
            if (result == null)
               result = caseEnumContainer (moduleDef);
            if (result == null)
               result = caseUnionContainer (moduleDef);
            if (result == null)
               result = caseNativeContainer (moduleDef);
            if (result == null)
               result = caseAliasContainer (moduleDef);
            if (result == null)
               result = caseConstantContainer (moduleDef);
            if (result == null)
               result = caseContained (moduleDef);
            if (result == null)
               result = caseIRObject (moduleDef);
            if (result == null)
               result = caseNamed (moduleDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.CONTAINER:
         {
            Container container = (Container) theEObject;
            T result = caseContainer (container);
            if (result == null)
               result = caseIRObject (container);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.IR_OBJECT:
         {
            IRObject irObject = (IRObject) theEObject;
            T result = caseIRObject (irObject);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.CONTAINED:
         {
            Contained contained = (Contained) theEObject;
            T result = caseContained (contained);
            if (result == null)
               result = caseIRObject (contained);
            if (result == null)
               result = caseNamed (contained);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.REPOSITORY:
         {
            Repository repository = (Repository) theEObject;
            T result = caseRepository (repository);
            if (result == null)
               result = caseContainer (repository);
            if (result == null)
               result = caseIRObject (repository);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.STRING_DEF:
         {
            StringDef stringDef = (StringDef) theEObject;
            T result = caseStringDef (stringDef);
            if (result == null)
               result = caseOwnedIDLType (stringDef);
            if (result == null)
               result = caseExpressionContext (stringDef);
            if (result == null)
               result = caseIDLType (stringDef);
            if (result == null)
               result = caseIRObject (stringDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.IDL_TYPE:
         {
            IDLType idlType = (IDLType) theEObject;
            T result = caseIDLType (idlType);
            if (result == null)
               result = caseIRObject (idlType);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.TYPEDEF_DEF:
         {
            TypedefDef typedefDef = (TypedefDef) theEObject;
            T result = caseTypedefDef (typedefDef);
            if (result == null)
               result = caseSharedIDLType (typedefDef);
            if (result == null)
               result = caseContained (typedefDef);
            if (result == null)
               result = caseIDLType (typedefDef);
            if (result == null)
               result = caseIRObject (typedefDef);
            if (result == null)
               result = caseNamed (typedefDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.ALIAS_DEF:
         {
            AliasDef aliasDef = (AliasDef) theEObject;
            T result = caseAliasDef (aliasDef);
            if (result == null)
               result = caseTypedefDef (aliasDef);
            if (result == null)
               result = caseTyped (aliasDef);
            if (result == null)
               result = caseRepositoryContained (aliasDef);
            if (result == null)
               result = caseModuleContained (aliasDef);
            if (result == null)
               result = caseInterfaceContained (aliasDef);
            if (result == null)
               result = caseHomeContained (aliasDef);
            if (result == null)
               result = caseSharedIDLType (aliasDef);
            if (result == null)
               result = caseContained (aliasDef);
            if (result == null)
               result = caseIRObject (aliasDef);
            if (result == null)
               result = caseIDLType (aliasDef);
            if (result == null)
               result = caseNamed (aliasDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.PRIMITIVE_DEF:
         {
            PrimitiveDef primitiveDef = (PrimitiveDef) theEObject;
            T result = casePrimitiveDef (primitiveDef);
            if (result == null)
               result = caseOwnedIDLType (primitiveDef);
            if (result == null)
               result = caseIDLType (primitiveDef);
            if (result == null)
               result = caseIRObject (primitiveDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.PRAGMA:
         {
            Pragma pragma = (Pragma) theEObject;
            T result = casePragma (pragma);
            if (result == null)
               result = caseIRObject (pragma);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.WSTRING_DEF:
         {
            WStringDef wStringDef = (WStringDef) theEObject;
            T result = caseWStringDef (wStringDef);
            if (result == null)
               result = caseOwnedIDLType (wStringDef);
            if (result == null)
               result = caseExpressionContext (wStringDef);
            if (result == null)
               result = caseIDLType (wStringDef);
            if (result == null)
               result = caseIRObject (wStringDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.SEQUENCE_DEF:
         {
            SequenceDef sequenceDef = (SequenceDef) theEObject;
            T result = caseSequenceDef (sequenceDef);
            if (result == null)
               result = caseOwnedIDLType (sequenceDef);
            if (result == null)
               result = caseTyped (sequenceDef);
            if (result == null)
               result = caseExpressionContext (sequenceDef);
            if (result == null)
               result = caseIDLType (sequenceDef);
            if (result == null)
               result = caseIRObject (sequenceDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.ARRAY_DEF:
         {
            ArrayDef arrayDef = (ArrayDef) theEObject;
            T result = caseArrayDef (arrayDef);
            if (result == null)
               result = caseOwnedIDLType (arrayDef);
            if (result == null)
               result = caseTyped (arrayDef);
            if (result == null)
               result = caseExpressionContext (arrayDef);
            if (result == null)
               result = caseIDLType (arrayDef);
            if (result == null)
               result = caseIRObject (arrayDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.FIXED_DEF:
         {
            FixedDef fixedDef = (FixedDef) theEObject;
            T result = caseFixedDef (fixedDef);
            if (result == null)
               result = caseOwnedIDLType (fixedDef);
            if (result == null)
               result = caseExpressionContext (fixedDef);
            if (result == null)
               result = caseIDLType (fixedDef);
            if (result == null)
               result = caseIRObject (fixedDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.STRUCT_DEF:
         {
            StructDef structDef = (StructDef) theEObject;
            T result = caseStructDef (structDef);
            if (result == null)
               result = caseTypedefDef (structDef);
            if (result == null)
               result = caseContainer (structDef);
            if (result == null)
               result = caseRepositoryContained (structDef);
            if (result == null)
               result = caseExceptionContained (structDef);
            if (result == null)
               result = caseUnionContained (structDef);
            if (result == null)
               result = caseModuleContained (structDef);
            if (result == null)
               result = caseStructContained (structDef);
            if (result == null)
               result = caseInterfaceContained (structDef);
            if (result == null)
               result = caseStructContainer (structDef);
            if (result == null)
               result = caseEnumContainer (structDef);
            if (result == null)
               result = caseUnionContainer (structDef);
            if (result == null)
               result = caseHomeContained (structDef);
            if (result == null)
               result = caseSharedIDLType (structDef);
            if (result == null)
               result = caseContained (structDef);
            if (result == null)
               result = caseIRObject (structDef);
            if (result == null)
               result = caseIDLType (structDef);
            if (result == null)
               result = caseNamed (structDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.STRUCT_MEMBER:
         {
            StructMember structMember = (StructMember) theEObject;
            T result = caseStructMember (structMember);
            if (result == null)
               result = caseMember (structMember);
            if (result == null)
               result = caseStructContained (structMember);
            if (result == null)
               result = caseSharedExpression (structMember);
            if (result == null)
               result = caseTyped (structMember);
            if (result == null)
               result = caseContained (structMember);
            if (result == null)
               result = caseExpression (structMember);
            if (result == null)
               result = caseIRObject (structMember);
            if (result == null)
               result = caseNamed (structMember);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.INTERFACE_DEF:
         {
            InterfaceDef interfaceDef = (InterfaceDef) theEObject;
            T result = caseInterfaceDef (interfaceDef);
            if (result == null)
               result = caseContainer (interfaceDef);
            if (result == null)
               result = caseInterface (interfaceDef);
            if (result == null)
               result = caseAttributeContainer (interfaceDef);
            if (result == null)
               result = caseOperationContainer (interfaceDef);
            if (result == null)
               result = caseExceptionContainer (interfaceDef);
            if (result == null)
               result = caseStructContainer (interfaceDef);
            if (result == null)
               result = caseEnumContainer (interfaceDef);
            if (result == null)
               result = caseUnionContainer (interfaceDef);
            if (result == null)
               result = caseNativeContainer (interfaceDef);
            if (result == null)
               result = caseAliasContainer (interfaceDef);
            if (result == null)
               result = caseConstantContainer (interfaceDef);
            if (result == null)
               result = caseIRObject (interfaceDef);
            if (result == null)
               result = caseSharedIDLType (interfaceDef);
            if (result == null)
               result = caseModuleContained (interfaceDef);
            if (result == null)
               result = caseRepositoryContained (interfaceDef);
            if (result == null)
               result = caseIDLType (interfaceDef);
            if (result == null)
               result = caseContained (interfaceDef);
            if (result == null)
               result = caseNamed (interfaceDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.OWNED_IDL_TYPE:
         {
            OwnedIDLType ownedIDLType = (OwnedIDLType) theEObject;
            T result = caseOwnedIDLType (ownedIDLType);
            if (result == null)
               result = caseIDLType (ownedIDLType);
            if (result == null)
               result = caseIRObject (ownedIDLType);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.SHARED_IDL_TYPE:
         {
            SharedIDLType sharedIDLType = (SharedIDLType) theEObject;
            T result = caseSharedIDLType (sharedIDLType);
            if (result == null)
               result = caseIDLType (sharedIDLType);
            if (result == null)
               result = caseIRObject (sharedIDLType);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.TYPED:
         {
            Typed typed = (Typed) theEObject;
            T result = caseTyped (typed);
            if (result == null)
               result = caseIRObject (typed);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.UNION_DEF:
         {
            UnionDef unionDef = (UnionDef) theEObject;
            T result = caseUnionDef (unionDef);
            if (result == null)
               result = caseTypedefDef (unionDef);
            if (result == null)
               result = caseContainer (unionDef);
            if (result == null)
               result = caseUnionContained (unionDef);
            if (result == null)
               result = caseRepositoryContained (unionDef);
            if (result == null)
               result = caseExceptionContained (unionDef);
            if (result == null)
               result = caseModuleContained (unionDef);
            if (result == null)
               result = caseStructContained (unionDef);
            if (result == null)
               result = caseTyped (unionDef);
            if (result == null)
               result = caseInterfaceContained (unionDef);
            if (result == null)
               result = caseUnionContainer (unionDef);
            if (result == null)
               result = caseStructContainer (unionDef);
            if (result == null)
               result = caseEnumContainer (unionDef);
            if (result == null)
               result = caseHomeContained (unionDef);
            if (result == null)
               result = caseSharedIDLType (unionDef);
            if (result == null)
               result = caseContained (unionDef);
            if (result == null)
               result = caseIRObject (unionDef);
            if (result == null)
               result = caseIDLType (unionDef);
            if (result == null)
               result = caseNamed (unionDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.ENUM_DEF:
         {
            EnumDef enumDef = (EnumDef) theEObject;
            T result = caseEnumDef (enumDef);
            if (result == null)
               result = caseTypedefDef (enumDef);
            if (result == null)
               result = caseRepositoryContained (enumDef);
            if (result == null)
               result = caseModuleContained (enumDef);
            if (result == null)
               result = caseExceptionContained (enumDef);
            if (result == null)
               result = caseStructContained (enumDef);
            if (result == null)
               result = caseUnionContained (enumDef);
            if (result == null)
               result = caseInterfaceContained (enumDef);
            if (result == null)
               result = caseContainer (enumDef);
            if (result == null)
               result = caseHomeContained (enumDef);
            if (result == null)
               result = caseSharedIDLType (enumDef);
            if (result == null)
               result = caseContained (enumDef);
            if (result == null)
               result = caseIRObject (enumDef);
            if (result == null)
               result = caseIDLType (enumDef);
            if (result == null)
               result = caseNamed (enumDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.CONSTANT_DEF:
         {
            ConstantDef constantDef = (ConstantDef) theEObject;
            T result = caseConstantDef (constantDef);
            if (result == null)
               result = caseTyped (constantDef);
            if (result == null)
               result = caseRepositoryContained (constantDef);
            if (result == null)
               result = caseModuleContained (constantDef);
            if (result == null)
               result = caseInterfaceContained (constantDef);
            if (result == null)
               result = caseSharedExpression (constantDef);
            if (result == null)
               result = caseExpressionContext (constantDef);
            if (result == null)
               result = caseHomeContained (constantDef);
            if (result == null)
               result = caseIRObject (constantDef);
            if (result == null)
               result = caseContained (constantDef);
            if (result == null)
               result = caseExpression (constantDef);
            if (result == null)
               result = caseNamed (constantDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.ENUM_MEMBER:
         {
            EnumMember enumMember = (EnumMember) theEObject;
            T result = caseEnumMember (enumMember);
            if (result == null)
               result = caseNamed (enumMember);
            if (result == null)
               result = caseSharedExpression (enumMember);
            if (result == null)
               result = caseEnumContained (enumMember);
            if (result == null)
               result = caseExpression (enumMember);
            if (result == null)
               result = caseContained (enumMember);
            if (result == null)
               result = caseIRObject (enumMember);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.UNION_MEMBER:
         {
            UnionMember unionMember = (UnionMember) theEObject;
            T result = caseUnionMember (unionMember);
            if (result == null)
               result = caseMember (unionMember);
            if (result == null)
               result = caseUnionContained (unionMember);
            if (result == null)
               result = caseExpressionContext (unionMember);
            if (result == null)
               result = caseTyped (unionMember);
            if (result == null)
               result = caseContained (unionMember);
            if (result == null)
               result = caseIRObject (unionMember);
            if (result == null)
               result = caseNamed (unionMember);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.EXCEPTION_DEF:
         {
            ExceptionDef exceptionDef = (ExceptionDef) theEObject;
            T result = caseExceptionDef (exceptionDef);
            if (result == null)
               result = caseContainer (exceptionDef);
            if (result == null)
               result = caseModuleContained (exceptionDef);
            if (result == null)
               result = caseInterfaceContained (exceptionDef);
            if (result == null)
               result = caseRepositoryContained (exceptionDef);
            if (result == null)
               result = caseStructContainer (exceptionDef);
            if (result == null)
               result = caseEnumContainer (exceptionDef);
            if (result == null)
               result = caseUnionContainer (exceptionDef);
            if (result == null)
               result = caseHomeContained (exceptionDef);
            if (result == null)
               result = caseIRObject (exceptionDef);
            if (result == null)
               result = caseContained (exceptionDef);
            if (result == null)
               result = caseNamed (exceptionDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.ATTRIBUTE_DEF:
         {
            AttributeDef attributeDef = (AttributeDef) theEObject;
            T result = caseAttributeDef (attributeDef);
            if (result == null)
               result = caseTyped (attributeDef);
            if (result == null)
               result = caseInterfaceContained (attributeDef);
            if (result == null)
               result = caseValueContained (attributeDef);
            if (result == null)
               result = caseComponentContained (attributeDef);
            if (result == null)
               result = caseHomeContained (attributeDef);
            if (result == null)
               result = caseIRObject (attributeDef);
            if (result == null)
               result = caseContained (attributeDef);
            if (result == null)
               result = caseNamed (attributeDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.PARAMETER_DEF:
         {
            ParameterDef parameterDef = (ParameterDef) theEObject;
            T result = caseParameterDef (parameterDef);
            if (result == null)
               result = caseTyped (parameterDef);
            if (result == null)
               result = caseNamed (parameterDef);
            if (result == null)
               result = caseIRObject (parameterDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.OPERATION_DEF:
         {
            OperationDef operationDef = (OperationDef) theEObject;
            T result = caseOperationDef (operationDef);
            if (result == null)
               result = caseTyped (operationDef);
            if (result == null)
               result = caseValueContained (operationDef);
            if (result == null)
               result = caseInterfaceContained (operationDef);
            if (result == null)
               result = caseHomeContained (operationDef);
            if (result == null)
               result = caseIRObject (operationDef);
            if (result == null)
               result = caseContained (operationDef);
            if (result == null)
               result = caseNamed (operationDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.VALUE_MEMBER_DEF:
         {
            ValueMemberDef valueMemberDef = (ValueMemberDef) theEObject;
            T result = caseValueMemberDef (valueMemberDef);
            if (result == null)
               result = caseMember (valueMemberDef);
            if (result == null)
               result = caseValueContained (valueMemberDef);
            if (result == null)
               result = caseTyped (valueMemberDef);
            if (result == null)
               result = caseContained (valueMemberDef);
            if (result == null)
               result = caseIRObject (valueMemberDef);
            if (result == null)
               result = caseNamed (valueMemberDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.VALUE_DEF:
         {
            ValueDef valueDef = (ValueDef) theEObject;
            T result = caseValueDef (valueDef);
            if (result == null)
               result = caseContainer (valueDef);
            if (result == null)
               result = caseValue (valueDef);
            if (result == null)
               result = caseOperationContainer (valueDef);
            if (result == null)
               result = caseAttributeContainer (valueDef);
            if (result == null)
               result = caseIRObject (valueDef);
            if (result == null)
               result = caseModuleContained (valueDef);
            if (result == null)
               result = caseRepositoryContained (valueDef);
            if (result == null)
               result = caseSharedIDLType (valueDef);
            if (result == null)
               result = caseContained (valueDef);
            if (result == null)
               result = caseIDLType (valueDef);
            if (result == null)
               result = caseNamed (valueDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.INITIALIZER:
         {
            Initializer initializer = (Initializer) theEObject;
            T result = caseInitializer (initializer);
            if (result == null)
               result = caseValueContained (initializer);
            if (result == null)
               result = caseContained (initializer);
            if (result == null)
               result = caseIRObject (initializer);
            if (result == null)
               result = caseNamed (initializer);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.VALUE_BOX_DEF:
         {
            ValueBoxDef valueBoxDef = (ValueBoxDef) theEObject;
            T result = caseValueBoxDef (valueBoxDef);
            if (result == null)
               result = caseTypedefDef (valueBoxDef);
            if (result == null)
               result = caseTyped (valueBoxDef);
            if (result == null)
               result = caseRepositoryContained (valueBoxDef);
            if (result == null)
               result = caseModuleContained (valueBoxDef);
            if (result == null)
               result = caseSharedIDLType (valueBoxDef);
            if (result == null)
               result = caseContained (valueBoxDef);
            if (result == null)
               result = caseIRObject (valueBoxDef);
            if (result == null)
               result = caseIDLType (valueBoxDef);
            if (result == null)
               result = caseNamed (valueBoxDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.NATIVE_DEF:
         {
            NativeDef nativeDef = (NativeDef) theEObject;
            T result = caseNativeDef (nativeDef);
            if (result == null)
               result = caseTypedefDef (nativeDef);
            if (result == null)
               result = caseRepositoryContained (nativeDef);
            if (result == null)
               result = caseModuleContained (nativeDef);
            if (result == null)
               result = caseInterfaceContained (nativeDef);
            if (result == null)
               result = caseHomeContained (nativeDef);
            if (result == null)
               result = caseSharedIDLType (nativeDef);
            if (result == null)
               result = caseContained (nativeDef);
            if (result == null)
               result = caseIDLType (nativeDef);
            if (result == null)
               result = caseIRObject (nativeDef);
            if (result == null)
               result = caseNamed (nativeDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.NAMED:
         {
            Named named = (Named) theEObject;
            T result = caseNamed (named);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.MEMBER:
         {
            Member member = (Member) theEObject;
            T result = caseMember (member);
            if (result == null)
               result = caseTyped (member);
            if (result == null)
               result = caseContained (member);
            if (result == null)
               result = caseIRObject (member);
            if (result == null)
               result = caseNamed (member);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.EXCEPTION_MEMBER:
         {
            ExceptionMember exceptionMember = (ExceptionMember) theEObject;
            T result = caseExceptionMember (exceptionMember);
            if (result == null)
               result = caseMember (exceptionMember);
            if (result == null)
               result = caseExceptionContained (exceptionMember);
            if (result == null)
               result = caseTyped (exceptionMember);
            if (result == null)
               result = caseContained (exceptionMember);
            if (result == null)
               result = caseIRObject (exceptionMember);
            if (result == null)
               result = caseNamed (exceptionMember);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.REPOSITORY_CONTAINED:
         {
            RepositoryContained repositoryContained = (RepositoryContained) theEObject;
            T result = caseRepositoryContained (repositoryContained);
            if (result == null)
               result = caseContained (repositoryContained);
            if (result == null)
               result = caseIRObject (repositoryContained);
            if (result == null)
               result = caseNamed (repositoryContained);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.MODULE_CONTAINED:
         {
            ModuleContained moduleContained = (ModuleContained) theEObject;
            T result = caseModuleContained (moduleContained);
            if (result == null)
               result = caseContained (moduleContained);
            if (result == null)
               result = caseIRObject (moduleContained);
            if (result == null)
               result = caseNamed (moduleContained);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.EXCEPTION_CONTAINED:
         {
            ExceptionContained exceptionContained = (ExceptionContained) theEObject;
            T result = caseExceptionContained (exceptionContained);
            if (result == null)
               result = caseContained (exceptionContained);
            if (result == null)
               result = caseIRObject (exceptionContained);
            if (result == null)
               result = caseNamed (exceptionContained);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.INTERFACE_CONTAINED:
         {
            InterfaceContained interfaceContained = (InterfaceContained) theEObject;
            T result = caseInterfaceContained (interfaceContained);
            if (result == null)
               result = caseContained (interfaceContained);
            if (result == null)
               result = caseIRObject (interfaceContained);
            if (result == null)
               result = caseNamed (interfaceContained);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.STRUCT_CONTAINED:
         {
            StructContained structContained = (StructContained) theEObject;
            T result = caseStructContained (structContained);
            if (result == null)
               result = caseContained (structContained);
            if (result == null)
               result = caseIRObject (structContained);
            if (result == null)
               result = caseNamed (structContained);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.UNION_CONTAINED:
         {
            UnionContained unionContained = (UnionContained) theEObject;
            T result = caseUnionContained (unionContained);
            if (result == null)
               result = caseContained (unionContained);
            if (result == null)
               result = caseIRObject (unionContained);
            if (result == null)
               result = caseNamed (unionContained);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.VALUE_CONTAINED:
         {
            ValueContained valueContained = (ValueContained) theEObject;
            T result = caseValueContained (valueContained);
            if (result == null)
               result = caseContained (valueContained);
            if (result == null)
               result = caseIRObject (valueContained);
            if (result == null)
               result = caseNamed (valueContained);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.SHARED_EXPRESSION:
         {
            SharedExpression sharedExpression = (SharedExpression) theEObject;
            T result = caseSharedExpression (sharedExpression);
            if (result == null)
               result = caseExpression (sharedExpression);
            if (result == null)
               result = caseIRObject (sharedExpression);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.OWNED_EXPRESSION:
         {
            OwnedExpression ownedExpression = (OwnedExpression) theEObject;
            T result = caseOwnedExpression (ownedExpression);
            if (result == null)
               result = caseExpression (ownedExpression);
            if (result == null)
               result = caseIRObject (ownedExpression);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.EXPRESSION:
         {
            Expression expression = (Expression) theEObject;
            T result = caseExpression (expression);
            if (result == null)
               result = caseIRObject (expression);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.OPERATOR:
         {
            Operator operator = (Operator) theEObject;
            T result = caseOperator (operator);
            if (result == null)
               result = caseOwnedExpression (operator);
            if (result == null)
               result = caseExpression (operator);
            if (result == null)
               result = caseIRObject (operator);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.LITERAL:
         {
            Literal literal = (Literal) theEObject;
            T result = caseLiteral (literal);
            if (result == null)
               result = caseOwnedExpression (literal);
            if (result == null)
               result = caseExpression (literal);
            if (result == null)
               result = caseIRObject (literal);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.BITWISE_COMPLEMENT_OPERATOR:
         {
            BitwiseComplementOperator bitwiseComplementOperator = (BitwiseComplementOperator) theEObject;
            T result = caseBitwiseComplementOperator (bitwiseComplementOperator);
            if (result == null)
               result = caseUnaryOperator (bitwiseComplementOperator);
            if (result == null)
               result = caseOperator (bitwiseComplementOperator);
            if (result == null)
               result = caseOwnedExpression (bitwiseComplementOperator);
            if (result == null)
               result = caseExpression (bitwiseComplementOperator);
            if (result == null)
               result = caseIRObject (bitwiseComplementOperator);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.BITWISE_RIGHT_SHIFT_OPERATOR:
         {
            BitwiseRightShiftOperator bitwiseRightShiftOperator = (BitwiseRightShiftOperator) theEObject;
            T result = caseBitwiseRightShiftOperator (bitwiseRightShiftOperator);
            if (result == null)
               result = caseBinaryOperator (bitwiseRightShiftOperator);
            if (result == null)
               result = caseOperator (bitwiseRightShiftOperator);
            if (result == null)
               result = caseOwnedExpression (bitwiseRightShiftOperator);
            if (result == null)
               result = caseExpression (bitwiseRightShiftOperator);
            if (result == null)
               result = caseIRObject (bitwiseRightShiftOperator);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.BITWISE_LEFT_SHIFT_OPERATOR:
         {
            BitwiseLeftShiftOperator bitwiseLeftShiftOperator = (BitwiseLeftShiftOperator) theEObject;
            T result = caseBitwiseLeftShiftOperator (bitwiseLeftShiftOperator);
            if (result == null)
               result = caseBinaryOperator (bitwiseLeftShiftOperator);
            if (result == null)
               result = caseOperator (bitwiseLeftShiftOperator);
            if (result == null)
               result = caseOwnedExpression (bitwiseLeftShiftOperator);
            if (result == null)
               result = caseExpression (bitwiseLeftShiftOperator);
            if (result == null)
               result = caseIRObject (bitwiseLeftShiftOperator);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.BITWISE_AND_OPERATOR:
         {
            BitwiseAndOperator bitwiseAndOperator = (BitwiseAndOperator) theEObject;
            T result = caseBitwiseAndOperator (bitwiseAndOperator);
            if (result == null)
               result = caseBinaryOperator (bitwiseAndOperator);
            if (result == null)
               result = caseOperator (bitwiseAndOperator);
            if (result == null)
               result = caseOwnedExpression (bitwiseAndOperator);
            if (result == null)
               result = caseExpression (bitwiseAndOperator);
            if (result == null)
               result = caseIRObject (bitwiseAndOperator);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.ADD_OPERATOR:
         {
            AddOperator addOperator = (AddOperator) theEObject;
            T result = caseAddOperator (addOperator);
            if (result == null)
               result = caseBinaryOperator (addOperator);
            if (result == null)
               result = caseOperator (addOperator);
            if (result == null)
               result = caseOwnedExpression (addOperator);
            if (result == null)
               result = caseExpression (addOperator);
            if (result == null)
               result = caseIRObject (addOperator);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.BITWISE_XOR_OPERATOR:
         {
            BitwiseXorOperator bitwiseXorOperator = (BitwiseXorOperator) theEObject;
            T result = caseBitwiseXorOperator (bitwiseXorOperator);
            if (result == null)
               result = caseBinaryOperator (bitwiseXorOperator);
            if (result == null)
               result = caseOperator (bitwiseXorOperator);
            if (result == null)
               result = caseOwnedExpression (bitwiseXorOperator);
            if (result == null)
               result = caseExpression (bitwiseXorOperator);
            if (result == null)
               result = caseIRObject (bitwiseXorOperator);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.POSITIVE_OPERATOR:
         {
            PositiveOperator positiveOperator = (PositiveOperator) theEObject;
            T result = casePositiveOperator (positiveOperator);
            if (result == null)
               result = caseUnaryOperator (positiveOperator);
            if (result == null)
               result = caseOperator (positiveOperator);
            if (result == null)
               result = caseOwnedExpression (positiveOperator);
            if (result == null)
               result = caseExpression (positiveOperator);
            if (result == null)
               result = caseIRObject (positiveOperator);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.NEGATIVE_OPERATOR:
         {
            NegativeOperator negativeOperator = (NegativeOperator) theEObject;
            T result = caseNegativeOperator (negativeOperator);
            if (result == null)
               result = caseUnaryOperator (negativeOperator);
            if (result == null)
               result = caseOperator (negativeOperator);
            if (result == null)
               result = caseOwnedExpression (negativeOperator);
            if (result == null)
               result = caseExpression (negativeOperator);
            if (result == null)
               result = caseIRObject (negativeOperator);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.BITWISE_OR_OPERATOR:
         {
            BitwiseOrOperator bitwiseOrOperator = (BitwiseOrOperator) theEObject;
            T result = caseBitwiseOrOperator (bitwiseOrOperator);
            if (result == null)
               result = caseBinaryOperator (bitwiseOrOperator);
            if (result == null)
               result = caseOperator (bitwiseOrOperator);
            if (result == null)
               result = caseOwnedExpression (bitwiseOrOperator);
            if (result == null)
               result = caseExpression (bitwiseOrOperator);
            if (result == null)
               result = caseIRObject (bitwiseOrOperator);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.SUBTRACT_OPERATOR:
         {
            SubtractOperator subtractOperator = (SubtractOperator) theEObject;
            T result = caseSubtractOperator (subtractOperator);
            if (result == null)
               result = caseBinaryOperator (subtractOperator);
            if (result == null)
               result = caseOperator (subtractOperator);
            if (result == null)
               result = caseOwnedExpression (subtractOperator);
            if (result == null)
               result = caseExpression (subtractOperator);
            if (result == null)
               result = caseIRObject (subtractOperator);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.MULTIPLY_OPERATOR:
         {
            MultiplyOperator multiplyOperator = (MultiplyOperator) theEObject;
            T result = caseMultiplyOperator (multiplyOperator);
            if (result == null)
               result = caseBinaryOperator (multiplyOperator);
            if (result == null)
               result = caseOperator (multiplyOperator);
            if (result == null)
               result = caseOwnedExpression (multiplyOperator);
            if (result == null)
               result = caseExpression (multiplyOperator);
            if (result == null)
               result = caseIRObject (multiplyOperator);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.BINARY_OPERATOR:
         {
            BinaryOperator binaryOperator = (BinaryOperator) theEObject;
            T result = caseBinaryOperator (binaryOperator);
            if (result == null)
               result = caseOperator (binaryOperator);
            if (result == null)
               result = caseOwnedExpression (binaryOperator);
            if (result == null)
               result = caseExpression (binaryOperator);
            if (result == null)
               result = caseIRObject (binaryOperator);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.MODULO_OPERATOR:
         {
            ModuloOperator moduloOperator = (ModuloOperator) theEObject;
            T result = caseModuloOperator (moduloOperator);
            if (result == null)
               result = caseBinaryOperator (moduloOperator);
            if (result == null)
               result = caseOperator (moduloOperator);
            if (result == null)
               result = caseOwnedExpression (moduloOperator);
            if (result == null)
               result = caseExpression (moduloOperator);
            if (result == null)
               result = caseIRObject (moduloOperator);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.UNARY_OPERATOR:
         {
            UnaryOperator unaryOperator = (UnaryOperator) theEObject;
            T result = caseUnaryOperator (unaryOperator);
            if (result == null)
               result = caseOperator (unaryOperator);
            if (result == null)
               result = caseOwnedExpression (unaryOperator);
            if (result == null)
               result = caseExpression (unaryOperator);
            if (result == null)
               result = caseIRObject (unaryOperator);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.DIVIDE_OPERATOR:
         {
            DivideOperator divideOperator = (DivideOperator) theEObject;
            T result = caseDivideOperator (divideOperator);
            if (result == null)
               result = caseBinaryOperator (divideOperator);
            if (result == null)
               result = caseOperator (divideOperator);
            if (result == null)
               result = caseOwnedExpression (divideOperator);
            if (result == null)
               result = caseExpression (divideOperator);
            if (result == null)
               result = caseIRObject (divideOperator);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.ENUM_CONTAINED:
         {
            EnumContained enumContained = (EnumContained) theEObject;
            T result = caseEnumContained (enumContained);
            if (result == null)
               result = caseContained (enumContained);
            if (result == null)
               result = caseIRObject (enumContained);
            if (result == null)
               result = caseNamed (enumContained);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.INTERFACE_DECL:
         {
            InterfaceDecl interfaceDecl = (InterfaceDecl) theEObject;
            T result = caseInterfaceDecl (interfaceDecl);
            if (result == null)
               result = caseInterface (interfaceDecl);
            if (result == null)
               result = caseSharedIDLType (interfaceDecl);
            if (result == null)
               result = caseModuleContained (interfaceDecl);
            if (result == null)
               result = caseRepositoryContained (interfaceDecl);
            if (result == null)
               result = caseIDLType (interfaceDecl);
            if (result == null)
               result = caseContained (interfaceDecl);
            if (result == null)
               result = caseIRObject (interfaceDecl);
            if (result == null)
               result = caseNamed (interfaceDecl);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.INTERFACE:
         {
            Interface interface_ = (Interface) theEObject;
            T result = caseInterface (interface_);
            if (result == null)
               result = caseSharedIDLType (interface_);
            if (result == null)
               result = caseModuleContained (interface_);
            if (result == null)
               result = caseRepositoryContained (interface_);
            if (result == null)
               result = caseIDLType (interface_);
            if (result == null)
               result = caseContained (interface_);
            if (result == null)
               result = caseIRObject (interface_);
            if (result == null)
               result = caseNamed (interface_);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.PRE_PRAGMA:
         {
            PrePragma prePragma = (PrePragma) theEObject;
            T result = casePrePragma (prePragma);
            if (result == null)
               result = casePragma (prePragma);
            if (result == null)
               result = caseIRObject (prePragma);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.POST_PRAGMA:
         {
            PostPragma postPragma = (PostPragma) theEObject;
            T result = casePostPragma (postPragma);
            if (result == null)
               result = casePragma (postPragma);
            if (result == null)
               result = caseIRObject (postPragma);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.SCOPE_PRAGMA:
         {
            ScopePragma scopePragma = (ScopePragma) theEObject;
            T result = caseScopePragma (scopePragma);
            if (result == null)
               result = casePragma (scopePragma);
            if (result == null)
               result = caseIRObject (scopePragma);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.BOOLEAN_LITERAL:
         {
            BooleanLiteral booleanLiteral = (BooleanLiteral) theEObject;
            T result = caseBooleanLiteral (booleanLiteral);
            if (result == null)
               result = caseLiteral (booleanLiteral);
            if (result == null)
               result = caseOwnedExpression (booleanLiteral);
            if (result == null)
               result = caseExpression (booleanLiteral);
            if (result == null)
               result = caseIRObject (booleanLiteral);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.CHARACTER_LITERAL:
         {
            CharacterLiteral characterLiteral = (CharacterLiteral) theEObject;
            T result = caseCharacterLiteral (characterLiteral);
            if (result == null)
               result = caseLiteral (characterLiteral);
            if (result == null)
               result = caseOwnedExpression (characterLiteral);
            if (result == null)
               result = caseExpression (characterLiteral);
            if (result == null)
               result = caseIRObject (characterLiteral);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.FIXED_POINT_LITERAL:
         {
            FixedPointLiteral fixedPointLiteral = (FixedPointLiteral) theEObject;
            T result = caseFixedPointLiteral (fixedPointLiteral);
            if (result == null)
               result = caseLiteral (fixedPointLiteral);
            if (result == null)
               result = caseOwnedExpression (fixedPointLiteral);
            if (result == null)
               result = caseExpression (fixedPointLiteral);
            if (result == null)
               result = caseIRObject (fixedPointLiteral);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.FLOATING_POINT_LITERAL:
         {
            FloatingPointLiteral floatingPointLiteral = (FloatingPointLiteral) theEObject;
            T result = caseFloatingPointLiteral (floatingPointLiteral);
            if (result == null)
               result = caseLiteral (floatingPointLiteral);
            if (result == null)
               result = caseOwnedExpression (floatingPointLiteral);
            if (result == null)
               result = caseExpression (floatingPointLiteral);
            if (result == null)
               result = caseIRObject (floatingPointLiteral);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.INTEGER_LITERAL:
         {
            IntegerLiteral integerLiteral = (IntegerLiteral) theEObject;
            T result = caseIntegerLiteral (integerLiteral);
            if (result == null)
               result = caseLiteral (integerLiteral);
            if (result == null)
               result = caseOwnedExpression (integerLiteral);
            if (result == null)
               result = caseExpression (integerLiteral);
            if (result == null)
               result = caseIRObject (integerLiteral);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.STRING_LITERAL:
         {
            StringLiteral stringLiteral = (StringLiteral) theEObject;
            T result = caseStringLiteral (stringLiteral);
            if (result == null)
               result = caseLiteral (stringLiteral);
            if (result == null)
               result = caseOwnedExpression (stringLiteral);
            if (result == null)
               result = caseExpression (stringLiteral);
            if (result == null)
               result = caseIRObject (stringLiteral);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.WCHARACTER_LITERAL:
         {
            WCharacterLiteral wCharacterLiteral = (WCharacterLiteral) theEObject;
            T result = caseWCharacterLiteral (wCharacterLiteral);
            if (result == null)
               result = caseLiteral (wCharacterLiteral);
            if (result == null)
               result = caseOwnedExpression (wCharacterLiteral);
            if (result == null)
               result = caseExpression (wCharacterLiteral);
            if (result == null)
               result = caseIRObject (wCharacterLiteral);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.WSTRING_LITERAL:
         {
            WStringLiteral wStringLiteral = (WStringLiteral) theEObject;
            T result = caseWStringLiteral (wStringLiteral);
            if (result == null)
               result = caseLiteral (wStringLiteral);
            if (result == null)
               result = caseOwnedExpression (wStringLiteral);
            if (result == null)
               result = caseExpression (wStringLiteral);
            if (result == null)
               result = caseIRObject (wStringLiteral);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.EXPRESSION_CONTEXT:
         {
            ExpressionContext expressionContext = (ExpressionContext) theEObject;
            T result = caseExpressionContext (expressionContext);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.VALUE:
         {
            Value value = (Value) theEObject;
            T result = caseValue (value);
            if (result == null)
               result = caseModuleContained (value);
            if (result == null)
               result = caseRepositoryContained (value);
            if (result == null)
               result = caseSharedIDLType (value);
            if (result == null)
               result = caseContained (value);
            if (result == null)
               result = caseIDLType (value);
            if (result == null)
               result = caseIRObject (value);
            if (result == null)
               result = caseNamed (value);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.VALUE_DECL:
         {
            ValueDecl valueDecl = (ValueDecl) theEObject;
            T result = caseValueDecl (valueDecl);
            if (result == null)
               result = caseValue (valueDecl);
            if (result == null)
               result = caseModuleContained (valueDecl);
            if (result == null)
               result = caseRepositoryContained (valueDecl);
            if (result == null)
               result = caseSharedIDLType (valueDecl);
            if (result == null)
               result = caseContained (valueDecl);
            if (result == null)
               result = caseIDLType (valueDecl);
            if (result == null)
               result = caseIRObject (valueDecl);
            if (result == null)
               result = caseNamed (valueDecl);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.INITIALIZER_PARAMETER_DEF:
         {
            InitializerParameterDef initializerParameterDef = (InitializerParameterDef) theEObject;
            T result = caseInitializerParameterDef (initializerParameterDef);
            if (result == null)
               result = caseTyped (initializerParameterDef);
            if (result == null)
               result = caseNamed (initializerParameterDef);
            if (result == null)
               result = caseIRObject (initializerParameterDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.COMPONENT:
         {
            Component component = (Component) theEObject;
            T result = caseComponent (component);
            if (result == null)
               result = caseModuleContained (component);
            if (result == null)
               result = caseRepositoryContained (component);
            if (result == null)
               result = caseSharedIDLType (component);
            if (result == null)
               result = caseContained (component);
            if (result == null)
               result = caseIDLType (component);
            if (result == null)
               result = caseIRObject (component);
            if (result == null)
               result = caseNamed (component);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.COMPONENT_DEF:
         {
            ComponentDef componentDef = (ComponentDef) theEObject;
            T result = caseComponentDef (componentDef);
            if (result == null)
               result = caseComponent (componentDef);
            if (result == null)
               result = caseContainer (componentDef);
            if (result == null)
               result = caseAttributeContainer (componentDef);
            if (result == null)
               result = caseModuleContained (componentDef);
            if (result == null)
               result = caseRepositoryContained (componentDef);
            if (result == null)
               result = caseSharedIDLType (componentDef);
            if (result == null)
               result = caseIRObject (componentDef);
            if (result == null)
               result = caseContained (componentDef);
            if (result == null)
               result = caseIDLType (componentDef);
            if (result == null)
               result = caseNamed (componentDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.COMPONENT_DECL:
         {
            ComponentDecl componentDecl = (ComponentDecl) theEObject;
            T result = caseComponentDecl (componentDecl);
            if (result == null)
               result = caseComponent (componentDecl);
            if (result == null)
               result = caseModuleContained (componentDecl);
            if (result == null)
               result = caseRepositoryContained (componentDecl);
            if (result == null)
               result = caseSharedIDLType (componentDecl);
            if (result == null)
               result = caseContained (componentDecl);
            if (result == null)
               result = caseIDLType (componentDecl);
            if (result == null)
               result = caseIRObject (componentDecl);
            if (result == null)
               result = caseNamed (componentDecl);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.COMPONENT_CONTAINED:
         {
            ComponentContained componentContained = (ComponentContained) theEObject;
            T result = caseComponentContained (componentContained);
            if (result == null)
               result = caseContained (componentContained);
            if (result == null)
               result = caseIRObject (componentContained);
            if (result == null)
               result = caseNamed (componentContained);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.COMPONENT_PORT_DEF:
         {
            ComponentPortDef componentPortDef = (ComponentPortDef) theEObject;
            T result = caseComponentPortDef (componentPortDef);
            if (result == null)
               result = caseComponentContained (componentPortDef);
            if (result == null)
               result = caseContained (componentPortDef);
            if (result == null)
               result = caseIRObject (componentPortDef);
            if (result == null)
               result = caseNamed (componentPortDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.HOME:
         {
            Home home = (Home) theEObject;
            T result = caseHome (home);
            if (result == null)
               result = caseModuleContained (home);
            if (result == null)
               result = caseRepositoryContained (home);
            if (result == null)
               result = caseSharedIDLType (home);
            if (result == null)
               result = caseContained (home);
            if (result == null)
               result = caseIDLType (home);
            if (result == null)
               result = caseIRObject (home);
            if (result == null)
               result = caseNamed (home);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.HOME_DEF:
         {
            HomeDef homeDef = (HomeDef) theEObject;
            T result = caseHomeDef (homeDef);
            if (result == null)
               result = caseHome (homeDef);
            if (result == null)
               result = caseContainer (homeDef);
            if (result == null)
               result = caseAttributeContainer (homeDef);
            if (result == null)
               result = caseOperationContainer (homeDef);
            if (result == null)
               result = caseConstantContainer (homeDef);
            if (result == null)
               result = caseExceptionContainer (homeDef);
            if (result == null)
               result = caseAliasContainer (homeDef);
            if (result == null)
               result = caseStructContainer (homeDef);
            if (result == null)
               result = caseUnionContainer (homeDef);
            if (result == null)
               result = caseEnumContainer (homeDef);
            if (result == null)
               result = caseNativeContainer (homeDef);
            if (result == null)
               result = caseModuleContained (homeDef);
            if (result == null)
               result = caseRepositoryContained (homeDef);
            if (result == null)
               result = caseSharedIDLType (homeDef);
            if (result == null)
               result = caseIRObject (homeDef);
            if (result == null)
               result = caseContained (homeDef);
            if (result == null)
               result = caseIDLType (homeDef);
            if (result == null)
               result = caseNamed (homeDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.HOME_CONTAINED:
         {
            HomeContained homeContained = (HomeContained) theEObject;
            T result = caseHomeContained (homeContained);
            if (result == null)
               result = caseContained (homeContained);
            if (result == null)
               result = caseIRObject (homeContained);
            if (result == null)
               result = caseNamed (homeContained);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.FACTORY_OPERATION:
         {
            FactoryOperation factoryOperation = (FactoryOperation) theEObject;
            T result = caseFactoryOperation (factoryOperation);
            if (result == null)
               result = caseHomeContained (factoryOperation);
            if (result == null)
               result = caseContained (factoryOperation);
            if (result == null)
               result = caseIRObject (factoryOperation);
            if (result == null)
               result = caseNamed (factoryOperation);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.FINDER_OPERATION:
         {
            FinderOperation finderOperation = (FinderOperation) theEObject;
            T result = caseFinderOperation (finderOperation);
            if (result == null)
               result = caseHomeContained (finderOperation);
            if (result == null)
               result = caseContained (finderOperation);
            if (result == null)
               result = caseIRObject (finderOperation);
            if (result == null)
               result = caseNamed (finderOperation);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.INTERFACE_PORT_DEF:
         {
            InterfacePortDef interfacePortDef = (InterfacePortDef) theEObject;
            T result = caseInterfacePortDef (interfacePortDef);
            if (result == null)
               result = caseComponentPortDef (interfacePortDef);
            if (result == null)
               result = caseComponentContained (interfacePortDef);
            if (result == null)
               result = caseContained (interfacePortDef);
            if (result == null)
               result = caseIRObject (interfacePortDef);
            if (result == null)
               result = caseNamed (interfacePortDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.EVENT_PORT_DEF:
         {
            EventPortDef eventPortDef = (EventPortDef) theEObject;
            T result = caseEventPortDef (eventPortDef);
            if (result == null)
               result = caseComponentPortDef (eventPortDef);
            if (result == null)
               result = caseComponentContained (eventPortDef);
            if (result == null)
               result = caseContained (eventPortDef);
            if (result == null)
               result = caseIRObject (eventPortDef);
            if (result == null)
               result = caseNamed (eventPortDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.PROVIDES_DEF:
         {
            ProvidesDef providesDef = (ProvidesDef) theEObject;
            T result = caseProvidesDef (providesDef);
            if (result == null)
               result = caseInterfacePortDef (providesDef);
            if (result == null)
               result = caseComponentPortDef (providesDef);
            if (result == null)
               result = caseComponentContained (providesDef);
            if (result == null)
               result = caseContained (providesDef);
            if (result == null)
               result = caseIRObject (providesDef);
            if (result == null)
               result = caseNamed (providesDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.USES_DEF:
         {
            UsesDef usesDef = (UsesDef) theEObject;
            T result = caseUsesDef (usesDef);
            if (result == null)
               result = caseInterfacePortDef (usesDef);
            if (result == null)
               result = caseComponentPortDef (usesDef);
            if (result == null)
               result = caseComponentContained (usesDef);
            if (result == null)
               result = caseContained (usesDef);
            if (result == null)
               result = caseIRObject (usesDef);
            if (result == null)
               result = caseNamed (usesDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.CONSUMES_DEF:
         {
            ConsumesDef consumesDef = (ConsumesDef) theEObject;
            T result = caseConsumesDef (consumesDef);
            if (result == null)
               result = caseEventPortDef (consumesDef);
            if (result == null)
               result = caseComponentPortDef (consumesDef);
            if (result == null)
               result = caseComponentContained (consumesDef);
            if (result == null)
               result = caseContained (consumesDef);
            if (result == null)
               result = caseIRObject (consumesDef);
            if (result == null)
               result = caseNamed (consumesDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.PUBLISHES_DEF:
         {
            PublishesDef publishesDef = (PublishesDef) theEObject;
            T result = casePublishesDef (publishesDef);
            if (result == null)
               result = caseEventPortDef (publishesDef);
            if (result == null)
               result = caseComponentPortDef (publishesDef);
            if (result == null)
               result = caseComponentContained (publishesDef);
            if (result == null)
               result = caseContained (publishesDef);
            if (result == null)
               result = caseIRObject (publishesDef);
            if (result == null)
               result = caseNamed (publishesDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.EMITS_DEF:
         {
            EmitsDef emitsDef = (EmitsDef) theEObject;
            T result = caseEmitsDef (emitsDef);
            if (result == null)
               result = caseEventPortDef (emitsDef);
            if (result == null)
               result = caseComponentPortDef (emitsDef);
            if (result == null)
               result = caseComponentContained (emitsDef);
            if (result == null)
               result = caseContained (emitsDef);
            if (result == null)
               result = caseIRObject (emitsDef);
            if (result == null)
               result = caseNamed (emitsDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.EVENT:
         {
            Event event = (Event) theEObject;
            T result = caseEvent (event);
            if (result == null)
               result = caseValue (event);
            if (result == null)
               result = caseModuleContained (event);
            if (result == null)
               result = caseRepositoryContained (event);
            if (result == null)
               result = caseSharedIDLType (event);
            if (result == null)
               result = caseContained (event);
            if (result == null)
               result = caseIDLType (event);
            if (result == null)
               result = caseIRObject (event);
            if (result == null)
               result = caseNamed (event);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.EVENT_DECL:
         {
            EventDecl eventDecl = (EventDecl) theEObject;
            T result = caseEventDecl (eventDecl);
            if (result == null)
               result = caseEvent (eventDecl);
            if (result == null)
               result = caseValueDecl (eventDecl);
            if (result == null)
               result = caseValue (eventDecl);
            if (result == null)
               result = caseModuleContained (eventDecl);
            if (result == null)
               result = caseRepositoryContained (eventDecl);
            if (result == null)
               result = caseSharedIDLType (eventDecl);
            if (result == null)
               result = caseContained (eventDecl);
            if (result == null)
               result = caseIDLType (eventDecl);
            if (result == null)
               result = caseIRObject (eventDecl);
            if (result == null)
               result = caseNamed (eventDecl);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.EVENT_DEF:
         {
            EventDef eventDef = (EventDef) theEObject;
            T result = caseEventDef (eventDef);
            if (result == null)
               result = caseEvent (eventDef);
            if (result == null)
               result = caseValueDef (eventDef);
            if (result == null)
               result = caseValue (eventDef);
            if (result == null)
               result = caseContainer (eventDef);
            if (result == null)
               result = caseOperationContainer (eventDef);
            if (result == null)
               result = caseAttributeContainer (eventDef);
            if (result == null)
               result = caseModuleContained (eventDef);
            if (result == null)
               result = caseRepositoryContained (eventDef);
            if (result == null)
               result = caseSharedIDLType (eventDef);
            if (result == null)
               result = caseIRObject (eventDef);
            if (result == null)
               result = caseContained (eventDef);
            if (result == null)
               result = caseIDLType (eventDef);
            if (result == null)
               result = caseNamed (eventDef);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.ATTRIBUTE_CONTAINER:
         {
            AttributeContainer attributeContainer = (AttributeContainer) theEObject;
            T result = caseAttributeContainer (attributeContainer);
            if (result == null)
               result = caseContainer (attributeContainer);
            if (result == null)
               result = caseIRObject (attributeContainer);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.OPERATION_CONTAINER:
         {
            OperationContainer operationContainer = (OperationContainer) theEObject;
            T result = caseOperationContainer (operationContainer);
            if (result == null)
               result = caseContainer (operationContainer);
            if (result == null)
               result = caseIRObject (operationContainer);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.CONSTANT_CONTAINER:
         {
            ConstantContainer constantContainer = (ConstantContainer) theEObject;
            T result = caseConstantContainer (constantContainer);
            if (result == null)
               result = caseContainer (constantContainer);
            if (result == null)
               result = caseIRObject (constantContainer);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.ALIAS_CONTAINER:
         {
            AliasContainer aliasContainer = (AliasContainer) theEObject;
            T result = caseAliasContainer (aliasContainer);
            if (result == null)
               result = caseContainer (aliasContainer);
            if (result == null)
               result = caseIRObject (aliasContainer);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.NATIVE_CONTAINER:
         {
            NativeContainer nativeContainer = (NativeContainer) theEObject;
            T result = caseNativeContainer (nativeContainer);
            if (result == null)
               result = caseContainer (nativeContainer);
            if (result == null)
               result = caseIRObject (nativeContainer);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.UNION_CONTAINER:
         {
            UnionContainer unionContainer = (UnionContainer) theEObject;
            T result = caseUnionContainer (unionContainer);
            if (result == null)
               result = caseContainer (unionContainer);
            if (result == null)
               result = caseIRObject (unionContainer);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.STRUCT_CONTAINER:
         {
            StructContainer structContainer = (StructContainer) theEObject;
            T result = caseStructContainer (structContainer);
            if (result == null)
               result = caseContainer (structContainer);
            if (result == null)
               result = caseIRObject (structContainer);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.ENUM_CONTAINER:
         {
            EnumContainer enumContainer = (EnumContainer) theEObject;
            T result = caseEnumContainer (enumContainer);
            if (result == null)
               result = caseContainer (enumContainer);
            if (result == null)
               result = caseIRObject (enumContainer);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         case IdlmmPackage.EXCEPTION_CONTAINER:
         {
            ExceptionContainer exceptionContainer = (ExceptionContainer) theEObject;
            T result = caseExceptionContainer (exceptionContainer);
            if (result == null)
               result = caseContainer (exceptionContainer);
            if (result == null)
               result = caseIRObject (exceptionContainer);
            if (result == null)
               result = defaultCase (theEObject);
            return result;
         }
         default:
            return defaultCase (theEObject);
      }
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Module Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Module Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseModuleDef (ModuleDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Container</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Container</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseContainer (Container object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>IR Object</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>IR Object</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseIRObject (IRObject object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Contained</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Contained</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseContained (Contained object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Repository</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Repository</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseRepository (Repository object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>String Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>String Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseStringDef (StringDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>IDL Type</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>IDL Type</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseIDLType (IDLType object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Typedef Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Typedef Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseTypedefDef (TypedefDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Alias Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Alias Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseAliasDef (AliasDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Primitive Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Primitive Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T casePrimitiveDef (PrimitiveDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Pragma</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Pragma</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T casePragma (Pragma object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>WString Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>WString Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseWStringDef (WStringDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Sequence Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Sequence Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseSequenceDef (SequenceDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Array Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Array Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseArrayDef (ArrayDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Fixed Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Fixed Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseFixedDef (FixedDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Struct Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Struct Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseStructDef (StructDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Struct Member</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Struct Member</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseStructMember (StructMember object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Interface Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Interface Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseInterfaceDef (InterfaceDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Owned IDL Type</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Owned IDL Type</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseOwnedIDLType (OwnedIDLType object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Shared IDL Type</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Shared IDL Type</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseSharedIDLType (SharedIDLType object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Typed</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Typed</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseTyped (Typed object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Union Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Union Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseUnionDef (UnionDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Enum Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Enum Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseEnumDef (EnumDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Constant Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Constant Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseConstantDef (ConstantDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Enum Member</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Enum Member</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseEnumMember (EnumMember object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Union Member</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Union Member</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseUnionMember (UnionMember object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Exception Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Exception Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseExceptionDef (ExceptionDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Attribute Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Attribute Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseAttributeDef (AttributeDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Parameter Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Parameter Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseParameterDef (ParameterDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Operation Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Operation Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseOperationDef (OperationDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Value Member Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Value Member Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseValueMemberDef (ValueMemberDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Value Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Value Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseValueDef (ValueDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Initializer</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Initializer</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseInitializer (Initializer object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Value Box Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Value Box Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseValueBoxDef (ValueBoxDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Native Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Native Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseNativeDef (NativeDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Named</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Named</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseNamed (Named object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Member</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Member</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseMember (Member object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Exception Member</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Exception Member</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseExceptionMember (ExceptionMember object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Repository Contained</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Repository Contained</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseRepositoryContained (RepositoryContained object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Module Contained</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Module Contained</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseModuleContained (ModuleContained object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Exception Contained</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Exception Contained</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseExceptionContained (ExceptionContained object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Interface Contained</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Interface Contained</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseInterfaceContained (InterfaceContained object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Struct Contained</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Struct Contained</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseStructContained (StructContained object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Union Contained</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Union Contained</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseUnionContained (UnionContained object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Value Contained</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Value Contained</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseValueContained (ValueContained object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Shared Expression</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Shared Expression</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseSharedExpression (SharedExpression object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Owned Expression</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Owned Expression</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseOwnedExpression (OwnedExpression object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Expression</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Expression</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseExpression (Expression object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Operator</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Operator</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseOperator (Operator object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Literal</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Literal</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseLiteral (Literal object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Bitwise Complement Operator</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Bitwise Complement Operator</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseBitwiseComplementOperator (BitwiseComplementOperator object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Bitwise Right Shift Operator</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Bitwise Right Shift Operator</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseBitwiseRightShiftOperator (BitwiseRightShiftOperator object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Bitwise Left Shift Operator</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Bitwise Left Shift Operator</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseBitwiseLeftShiftOperator (BitwiseLeftShiftOperator object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Bitwise And Operator</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Bitwise And Operator</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseBitwiseAndOperator (BitwiseAndOperator object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Add Operator</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Add Operator</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseAddOperator (AddOperator object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Bitwise Xor Operator</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Bitwise Xor Operator</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseBitwiseXorOperator (BitwiseXorOperator object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Positive Operator</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Positive Operator</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T casePositiveOperator (PositiveOperator object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Negative Operator</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Negative Operator</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseNegativeOperator (NegativeOperator object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Bitwise Or Operator</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Bitwise Or Operator</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseBitwiseOrOperator (BitwiseOrOperator object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Subtract Operator</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Subtract Operator</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseSubtractOperator (SubtractOperator object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Multiply Operator</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Multiply Operator</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseMultiplyOperator (MultiplyOperator object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Binary Operator</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Binary Operator</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseBinaryOperator (BinaryOperator object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Modulo Operator</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Modulo Operator</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseModuloOperator (ModuloOperator object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Unary Operator</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Unary Operator</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseUnaryOperator (UnaryOperator object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Divide Operator</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Divide Operator</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseDivideOperator (DivideOperator object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Enum Contained</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Enum Contained</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseEnumContained (EnumContained object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Interface Decl</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Interface Decl</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseInterfaceDecl (InterfaceDecl object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Interface</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Interface</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseInterface (Interface object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Pre Pragma</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Pre Pragma</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T casePrePragma (PrePragma object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Post Pragma</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Post Pragma</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T casePostPragma (PostPragma object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Scope Pragma</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Scope Pragma</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseScopePragma (ScopePragma object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Boolean Literal</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Boolean Literal</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseBooleanLiteral (BooleanLiteral object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Character Literal</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Character Literal</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseCharacterLiteral (CharacterLiteral object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Fixed Point Literal</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Fixed Point Literal</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseFixedPointLiteral (FixedPointLiteral object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Floating Point Literal</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Floating Point Literal</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseFloatingPointLiteral (FloatingPointLiteral object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Integer Literal</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Integer Literal</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseIntegerLiteral (IntegerLiteral object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>String Literal</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>String Literal</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseStringLiteral (StringLiteral object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>WCharacter Literal</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>WCharacter Literal</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseWCharacterLiteral (WCharacterLiteral object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>WString Literal</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>WString Literal</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseWStringLiteral (WStringLiteral object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Expression Context</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Expression Context</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseExpressionContext (ExpressionContext object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Value</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Value</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseValue (Value object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Value Decl</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Value Decl</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseValueDecl (ValueDecl object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Initializer Parameter Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Initializer Parameter Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseInitializerParameterDef (InitializerParameterDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Component</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Component</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseComponent (Component object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Component Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Component Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseComponentDef (ComponentDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Component Decl</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Component Decl</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseComponentDecl (ComponentDecl object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Component Contained</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Component Contained</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseComponentContained (ComponentContained object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Component Port Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Component Port Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseComponentPortDef (ComponentPortDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Home</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Home</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseHome (Home object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Home Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Home Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseHomeDef (HomeDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Home Contained</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Home Contained</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseHomeContained (HomeContained object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Factory Operation</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Factory Operation</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseFactoryOperation (FactoryOperation object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Finder Operation</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Finder Operation</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseFinderOperation (FinderOperation object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Interface Port Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Interface Port Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseInterfacePortDef (InterfacePortDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Event Port Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Event Port Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseEventPortDef (EventPortDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Provides Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Provides Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseProvidesDef (ProvidesDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Uses Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Uses Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseUsesDef (UsesDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Consumes Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Consumes Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseConsumesDef (ConsumesDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Publishes Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Publishes Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T casePublishesDef (PublishesDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Emits Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Emits Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseEmitsDef (EmitsDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Event</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Event</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseEvent (Event object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Event Decl</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Event Decl</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseEventDecl (EventDecl object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Event Def</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Event Def</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseEventDef (EventDef object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Attribute Container</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Attribute Container</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseAttributeContainer (AttributeContainer object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Operation Container</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Operation Container</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseOperationContainer (OperationContainer object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Constant Container</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Constant Container</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseConstantContainer (ConstantContainer object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Alias Container</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Alias Container</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseAliasContainer (AliasContainer object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Native Container</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Native Container</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseNativeContainer (NativeContainer object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Union Container</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Union Container</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseUnionContainer (UnionContainer object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Struct Container</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Struct Container</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseStructContainer (StructContainer object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Enum Container</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Enum Container</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseEnumContainer (EnumContainer object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>Exception Container</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>Exception Container</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
    * @generated
    */
   public T caseExceptionContainer (ExceptionContainer object)
   {
      return null;
   }

   /**
    * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
    * <!-- begin-user-doc -->
    * This implementation returns null;
    * returning a non-null result will terminate the switch, but this is the last case anyway.
    * <!-- end-user-doc -->
    * @param object the target of the switch.
    * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
    * @see #doSwitch(org.eclipse.emf.ecore.EObject)
    * @generated
    */
   public T defaultCase (EObject object)
   {
      return null;
   }

} //IdlmmSwitch
