package com.prismtech.idt.idlmm.impl;

import java.util.Set;

import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.EList;

import com.prismtech.idt.idlmm.BinaryOperator;
import com.prismtech.idt.idlmm.Expression;
import com.prismtech.idt.idlmm.IRObject;


public class BinaryOperatorExt
{
   static Object getLeftOperand (BinaryOperator self)
   {
      return self.getLhs ().getExpressionValue ();
   }

   static Object getRightOperand (BinaryOperator self)
   {
      return self.getRhs ().getExpressionValue ();
   }

   public static Expression setLhs (BinaryOperator self, Expression lhs)
   {
      self.setLhs (lhs);
      return lhs;
   }

   public static Expression setRhs (BinaryOperator self, Expression rhs)
   {
      self.setRhs (rhs);
      return rhs;
   }

   public static EList<IRObject> getPrerequisites (BinaryOperator self)
   {
      Set<IRObject> result = new ArraySet<IRObject> ();
      result.add (self.getLhs ());
      result.add (self.getRhs ());
      result.addAll (self.getLhs ().getPrerequisites ());
      result.addAll (self.getRhs ().getPrerequisites ());
      return new BasicEList<IRObject> (result);
   }
}
