package com.prismtech.idt.idlmm.impl;

import java.math.BigInteger;

import org.eclipse.emf.ecore.EObject;

import com.prismtech.idt.idlmm.BitwiseComplementOperator;
import com.prismtech.idt.idlmm.ExpressionContext;
import com.prismtech.idt.idlmm.IDLType;
import com.prismtech.idt.idlmm.PrimitiveDef;
import com.prismtech.idt.idlmm.PrimitiveKind;


public class BitwiseComplementOperatorExt
{
   public static Object getExpressionValue (BitwiseComplementOperator self)
   {
      Object operand = UnaryOperatorExt.getOperand (self);

      IDLType context = null;
      EObject parent = self.eContainer ();
      while (parent != null)
      {
         if (parent instanceof ExpressionContext)
         {
            context = ((ExpressionContext) parent).getExpressionType ();
            break;
         }
         parent = parent.eContainer ();
      }

      if (operand instanceof BigInteger)
      {
         if (context != null && context instanceof PrimitiveDef)
         {
            switch ( ((PrimitiveDef) context).getKind ())
            {
               case PK_OCTET:
               case PK_SHORT:
               case PK_LONG:
               case PK_LONGLONG:
                  return ((BigInteger) operand).add (BigInteger.ONE).negate ();
               case PK_USHORT:
                  return BigInteger.valueOf (2).pow (16).subtract (BigInteger.ONE).subtract ((BigInteger) operand);
               case PK_ULONG:
                  return BigInteger.valueOf (2).pow (32).subtract (BigInteger.ONE).subtract ((BigInteger) operand);
               case PK_ULONGLONG:
                  return BigInteger.valueOf (2).pow (64).subtract (BigInteger.ONE).subtract ((BigInteger) operand);
            }
         }
      }
      return null;
   }
}
