package com.prismtech.idt.idlmm.impl;

import org.eclipse.emf.common.util.EList;

import com.prismtech.idt.idlmm.Contained;
import com.prismtech.idt.idlmm.EnumDef;
import com.prismtech.idt.idlmm.ExceptionDef;
import com.prismtech.idt.idlmm.ExceptionMember;
import com.prismtech.idt.idlmm.StructDef;
import com.prismtech.idt.idlmm.UnionDef;


public class ExceptionDefExt
{
   /**
    * Implementation of {@link ExceptionDef#getMember(String)}
    */
   public static ExceptionMember getMember (ExceptionDef self, String name)
   {
      assert (self != null);
      assert (name != null);
      assert (name.length () > 0);

      for (Contained member : self.getContents ())
      {
         if (member instanceof ExceptionMember)
         {
            if (name.equals ( ((ExceptionMember) member).getName ()))
            {
               return (ExceptionMember) member;
            }
         }
      }

      return null;
   }

   public static EList<EnumDef> getEnums (ExceptionDef self)
   {
      return ContainerExt.getContents (self, EnumDef.class);
   }

   public static EList<EnumDef> getAllEnums (ExceptionDef self)
   {
      // For ExceptionDef, no difference with getEnums().
      return getEnums (self);
   }

   public static EList<StructDef> getStructs (ExceptionDef self)
   {
      return ContainerExt.getContents (self, StructDef.class);
   }

   public static EList<StructDef> getAllStructs (ExceptionDef self)
   {
      // For ExceptionDef, no difference with getStructs().
      return getStructs (self);
   }

   public static EList<UnionDef> getUnions (ExceptionDef self)
   {
      return ContainerExt.getContents (self, UnionDef.class);
   }

   public static EList<UnionDef> getAllUnions (ExceptionDef self)
   {
      // For ExceptionDef, no difference with getUnions().
      return getUnions (self);
   }

   public static EList<ExceptionMember> getMembers (ExceptionDef self)
   {
      return ContainerExt.getContents (self, ExceptionMember.class);
   }

}
