package com.prismtech.idt.idlmm.impl;

import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.DelegatingEcoreEList.UnmodifiableEList;

import com.prismtech.idt.idlmm.AliasDef;
import com.prismtech.idt.idlmm.ConstantDef;
import com.prismtech.idt.idlmm.Contained;
import com.prismtech.idt.idlmm.EnumDef;
import com.prismtech.idt.idlmm.ExceptionDef;
import com.prismtech.idt.idlmm.IdlmmPackage;
import com.prismtech.idt.idlmm.InterfaceDef;
import com.prismtech.idt.idlmm.ModuleDef;
import com.prismtech.idt.idlmm.NativeDef;
import com.prismtech.idt.idlmm.Repository;
import com.prismtech.idt.idlmm.StructDef;
import com.prismtech.idt.idlmm.UnionDef;
import com.prismtech.idt.idlmm.ValueBoxDef;
import com.prismtech.idt.idlmm.ValueDef;


public class ModuleDefExt
{
   public static EList<AliasDef> getAliases (ModuleDef self)
   {
      return new UnmodifiableEList<AliasDef>(
            (EObjectImpl)self, 
            (EStructuralFeature)IdlmmPackageImpl.init ().getAliasContainer_Aliases (), 
            ContainerExt.getContents (self, AliasDef.class));
   }

   public static EList<AliasDef> getAllAliases (ModuleDef self)
   {
      // For ModuleDef, no difference with getAliases().
      return new UnmodifiableEList<AliasDef>(
            (EObjectImpl)self, 
            (EStructuralFeature)IdlmmPackageImpl.init ().getAliasContainer_AllAliases (), 
            ContainerExt.getContents (self, AliasDef.class));
   }

   public static EList<ConstantDef> getConstants (ModuleDef self)
   {
      return new UnmodifiableEList<ConstantDef>(
            (EObjectImpl)self, 
            (EStructuralFeature)IdlmmPackageImpl.init ().getConstantContainer_Constants (), 
            ContainerExt.getContents (self, ConstantDef.class));      
   }

   public static EList<ConstantDef> getAllConstants (ModuleDef self)
   {
      // For ModuleDef, no difference with getAllConstants().
      return new UnmodifiableEList<ConstantDef>(
            (EObjectImpl)self, 
            (EStructuralFeature)IdlmmPackageImpl.init ().getConstantContainer_AllConstants (), 
            ContainerExt.getContents (self, ConstantDef.class));      
   }

  public static EList<EnumDef> getEnums (ModuleDef self)
   {
      return new UnmodifiableEList<EnumDef>(
            (EObjectImpl)self, 
            (EStructuralFeature)IdlmmPackageImpl.init ().getEnumContainer_Enums (), 
            ContainerExt.getContents (self, EnumDef.class));   
   }

   public static EList<ExceptionDef> getExceptions (ModuleDef self)
   {
      return new UnmodifiableEList<ExceptionDef>(
            (EObjectImpl)self, 
            (EStructuralFeature)IdlmmPackageImpl.init ().getExceptionContainer_Exceptions (), 
            ContainerExt.getContents (self, ExceptionDef.class));  
   }

   public static EList<ExceptionDef> getAllExceptions (ModuleDef self)
   {
      // For ModuleDef, no difference with getExceptions().
      return new UnmodifiableEList<ExceptionDef>(
            (EObjectImpl)self, 
            (EStructuralFeature)IdlmmPackageImpl.init ().getExceptionContainer_AllExceptions (), 
            ContainerExt.getContents (self, ExceptionDef.class));  
   }

   public static EList<InterfaceDef> getInterfaces (ModuleDef self)
   {
      return new UnmodifiableEList<InterfaceDef>(
            (EObjectImpl)self, 
            (EStructuralFeature)IdlmmPackageImpl.init ().getModuleDef_Interfaces (), 
            ContainerExt.getContents (self, InterfaceDef.class));  
   }

   public static EList<ModuleDef> getModules (ModuleDef self)
   {
      return new UnmodifiableEList<ModuleDef>(
            (EObjectImpl)self, 
            (EStructuralFeature)IdlmmPackageImpl.init ().getModuleDef_Modules (), 
            ContainerExt.getContents (self, ModuleDef.class));  
   }

   public static EList<NativeDef> getNatives (ModuleDef self)
   {
      return new UnmodifiableEList<NativeDef>(
            (EObjectImpl)self, 
            (EStructuralFeature)IdlmmPackageImpl.init ().getNativeContainer_Natives (), 
            ContainerExt.getContents (self, NativeDef.class));        
   }

   public static EList<NativeDef> getAllNatives (ModuleDef self)
   {
      // For ModuleDef, no difference with getNatives().
      return new UnmodifiableEList<NativeDef>(
            (EObjectImpl)self, 
            (EStructuralFeature)IdlmmPackageImpl.init ().getNativeContainer_AllNatives (), 
            ContainerExt.getContents (self, NativeDef.class));  
   }

   public static EList<StructDef> getStructs (ModuleDef self)
   {
      return new UnmodifiableEList<StructDef>(
            (EObjectImpl)self, 
            (EStructuralFeature)IdlmmPackageImpl.init ().getStructContainer_Structs (), 
            ContainerExt.getContents (self, StructDef.class));  
   }

   public static EList<StructDef> getAllStructs (ModuleDef self)
   {
      // For ModuleDef, no difference with getStructs().
      return new UnmodifiableEList<StructDef>(
            (EObjectImpl)self, 
            (EStructuralFeature)IdlmmPackageImpl.init ().getStructContainer_AllStructs (), 
            ContainerExt.getContents (self, StructDef.class));  
   }

   public static EList<UnionDef> getUnions (ModuleDef self)
   {
      return new UnmodifiableEList<UnionDef>(
            (EObjectImpl)self, 
            (EStructuralFeature)IdlmmPackageImpl.init ().getUnionContainer_Unions (), 
            ContainerExt.getContents (self, UnionDef.class));  
   }

   public static EList<UnionDef> getAllUnions (ModuleDef self)
   {
      // For ModuleDef, no difference with getUnions().
      return new UnmodifiableEList<UnionDef>(
            (EObjectImpl)self, 
            (EStructuralFeature)IdlmmPackageImpl.init ().getUnionContainer_AllUnions (), 
            ContainerExt.getContents (self, UnionDef.class));
   }

   public static EList<ValueBoxDef> getValueBoxes (ModuleDef self)
   {
      return ContainerExt.getContents (self, ValueBoxDef.class);
   }

   public static EList<ValueDef> getValueTypes (ModuleDef self)
   {
      return new UnmodifiableEList<ValueDef>(
            (EObjectImpl)self, 
            (EStructuralFeature)IdlmmPackageImpl.init ().getModuleDef_ValueTypes (), 
            ContainerExt.getContents (self, ValueDef.class));
   }

   /**
    * @see ModuleDef#getAllModules(boolean)
    */
   public static EList<ModuleDef> getAllModules (ModuleDef self, boolean inclusive)
   {
      EList<ModuleDef> result = new BasicEList<ModuleDef> ();
      EList<Repository> repositories = self.getRepository ().getAllIncludes (inclusive);

      String fullname = self.getAbsoluteName ();

      for (Repository repository : repositories)
      {
         Contained o = repository.lookup (fullname, false, false);

         if (o instanceof ModuleDef)
         {
            result.add ((ModuleDef) o);
         }
         else
         {
            /*
             * There's something with the same name but isn't a ModuleDef. This
             * should be detected and reported elsewhere as an error by a model
             * constraint.
             */
         }
      }

      return result;
   }
}
