package com.prismtech.idt.idlmm.impl;

import org.eclipse.emf.common.util.EList;

import com.prismtech.idt.idlmm.Contained;
import com.prismtech.idt.idlmm.EnumDef;
import com.prismtech.idt.idlmm.StructDef;
import com.prismtech.idt.idlmm.StructMember;
import com.prismtech.idt.idlmm.UnionDef;


public class StructDefExt
{
   /**
    * Implementation of {@link StructDef#getMember(String)}
    */
   public static StructMember getMember (StructDef self, String name)
   {
      assert (self != null);
      assert (name != null);
      assert (name.length () > 0);

      for (Contained member : self.getContents ())
      {
         if (member instanceof StructMember)
         {
            if (name.equals ( ((StructMember) member).getName ()))
            {
               return (StructMember) member;
            }
         }
      }

      return null;
   }

   public static EList<EnumDef> getEnums (StructDef self)
   {
      return ContainerExt.getContents (self, EnumDef.class);
   }

   public static EList<EnumDef> getAllEnums (StructDef self)
   {
      // For StructDef, no difference with getEnums().
      return getEnums (self);
   }

   public static EList<StructDef> getStructs (StructDef self)
   {
      return ContainerExt.getContents (self, StructDef.class);
   }

   public static EList<StructDef> getAllStructs (StructDef self)
   {
      // For StructDef, no difference with getStructs().
      return getStructs (self);
   }

   public static EList<UnionDef> getUnions (StructDef self)
   {
      return ContainerExt.getContents (self, UnionDef.class);
   }

   public static EList<UnionDef> getAllUnions (StructDef self)
   {
      // For StructDef, no difference with getUnions().
      return getUnions (self);
   }

   public static EList<StructMember> getMembers (StructDef self)
   {
      return ContainerExt.getContents (self, StructMember.class);
   }
}
