/*******************************************************************************
 * - COPYRIGHT NOTICE - * * The information contained herein and which follows
 * is proprietary * information and is the property of PrismTech Corporation.
 * This * information is not to be divulged, released, copied, reproduced, or *
 * conveyed to unauthorized personnel, companies, or other institutions *
 * without the direct and expressed approval in writing of PrismTech *
 * Corporation. * * * - DISCLAIMER - * Neither PrismTech Limited nor PrismTech
 * Corporation ("PrismTech") * are under any obligation to support the use of
 * this code which is * provided without warranty of any kind. PrismTech shall
 * (except as * otherwise prohibited by law) have no liability whatsoever in
 * relation * to its use. * *
 ******************************************************************************/
package com.prismtech.idt.idlmm.impl;

import java.math.BigDecimal;
import java.math.BigInteger;

import com.prismtech.idt.idlmm.SubtractOperator;


/**
 * @since 27.07.2007 - 14:16:19
 * @author Aleksey Yashchenko
 * @version $Revision: 1.4 $
 */
public class SubtractOperatorExt
{
   public static Object getExpressionValue (SubtractOperator self)
   {
      Object left = BinaryOperatorExt.getLeftOperand (self);
      Object right = BinaryOperatorExt.getRightOperand (self);

      if (left instanceof BigInteger && right instanceof BigInteger)
      {
         return ((BigInteger) left).subtract ((BigInteger) right);
      }
      else if (left instanceof BigDecimal && right instanceof BigDecimal)
      {
         return ((BigDecimal) left).subtract ((BigDecimal) right);
      }
      else
      {
         return null;
      }
   }
}
