package com.prismtech.idt.idlmm.impl;

import java.util.Set;

import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.EList;

import com.prismtech.idt.idlmm.EnumDef;
import com.prismtech.idt.idlmm.Expression;
import com.prismtech.idt.idlmm.IRObject;
import com.prismtech.idt.idlmm.StructDef;
import com.prismtech.idt.idlmm.UnionDef;
import com.prismtech.idt.idlmm.UnionMember;


public class UnionDefExt
{
   public static EList<EnumDef> getEnums (UnionDef self)
   {
      return ContainerExt.getContents (self, EnumDef.class);
   }

   public static EList<EnumDef> getAllEnums (UnionDef self)
   {
      // For UnionDef, no difference with getEnums().
      return getEnums (self);
   }

   public static EList<StructDef> getStructs (UnionDef self)
   {
      return ContainerExt.getContents (self, StructDef.class);
   }

   public static EList<StructDef> getAllStructs (UnionDef self)
   {
      // For UnionDef, no difference with getStructs().
      return getStructs (self);
   }

   public static EList<UnionDef> getUnions (UnionDef self)
   {
      return ContainerExt.getContents (self, UnionDef.class);
   }

   public static EList<UnionDef> getAllUnions (UnionDef self)
   {
      // For UnionDef, no difference with getUnions().
      return getUnions (self);
   }

   public static EList<UnionMember> getMembers (UnionDef self)
   {
      return ContainerExt.getContents (self, UnionMember.class);
   }

   public static EList<IRObject> getPrerequisites (UnionDef self)
   {
      Set<IRObject> result = new ArraySet<IRObject> (TypedExt.getPrerequisites (self));
      for (UnionMember member : self.getMembers ())
      {
         result.addAll (member.getPrerequisites ());
         for (Expression label : member.getLabels ())
         {
            result.addAll (label.getPrerequisites ());
         }
      }
      return new BasicEList<IRObject> (result);
   }
}
