package com.prismtech.idt.idlmm.impl;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import com.prismtech.idt.idlmm.Expression;
import com.prismtech.idt.idlmm.IdlmmPackage;
import com.prismtech.idt.idlmm.OwnedExpression;
import com.prismtech.idt.idlmm.ArrayDef;


public class ArrayDefOwnedLengthAdapter implements Adapter
{
   private ArrayDef m_array_def = null;

   private boolean m_sync = true;

   public void setTarget (Notifier target)
   {
      m_array_def = (ArrayDef) target;
      m_sync = true;
   }

   public Notifier getTarget ()
   {
      return m_array_def;
   }

   public boolean isAdapterForType (Object type)
   {
      return false;
   }

   public void notifyChanged (Notification notification)
   {
      switch (notification.getFeatureID (ArrayDef.class))
      {
         case IdlmmPackage.ARRAY_DEF__LENGTH:
         {
            if (m_sync == true)
            {
               m_sync = false;

               ArrayDef array_def = (ArrayDef) notification.getNotifier ();
               Expression length = (Expression) notification.getNewValue ();

               if (length instanceof OwnedExpression)
               {
                  array_def.setOwnedLength ((OwnedExpression) length);
               }
               else
               {
                  array_def.setOwnedLength (null);
               }

               m_sync = true;
            }

            break;
         }

         case IdlmmPackage.ARRAY_DEF__OWNED_LENGTH:
         {
            if (m_sync == true)
            {
               m_sync = false;

               ArrayDef array_def = (ArrayDef) notification.getNotifier ();
               Expression length = (Expression) notification.getNewValue ();

               array_def.setLength (length);

               m_sync = true;
            }

            break;
         }

         default:
         {
            break;
         }
      }
   }
}
