package com.prismtech.idt.idlmm.impl;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import com.prismtech.idt.idlmm.Expression;
import com.prismtech.idt.idlmm.IdlmmPackage;
import com.prismtech.idt.idlmm.OwnedExpression;
import com.prismtech.idt.idlmm.BinaryOperator;


public class BinaryOperatorOwnedExpressionAdapter implements Adapter
{
   private BinaryOperator m_binaryOperator = null;

   private boolean m_sync = true;

   public void setTarget (Notifier target)
   {
      m_binaryOperator = (BinaryOperator) target;
      m_sync = true;
   }

   public Notifier getTarget ()
   {
      return m_binaryOperator;
   }

   public boolean isAdapterForType (Object type)
   {
      return false;
   }

   public void notifyChanged (Notification notification)
   {
      switch (notification.getFeatureID (BinaryOperator.class))
      {
         case IdlmmPackage.BINARY_OPERATOR__RHS:
         {
            if (m_sync == true)
            {
               m_sync = false;

               BinaryOperator binaryOperator = (BinaryOperator) notification.getNotifier ();
               Expression rhs = (Expression) notification.getNewValue ();

               if (rhs instanceof OwnedExpression)
               {
                  binaryOperator.setOwnedRhs ((OwnedExpression) rhs);
               }
               else
               {
                  binaryOperator.setOwnedRhs (null);
               }

               m_sync = true;
            }

            break;
         }

         case IdlmmPackage.BINARY_OPERATOR__OWNED_RHS:
         {
            if (m_sync == true)
            {
               m_sync = false;

               BinaryOperator binaryOperator = (BinaryOperator) notification.getNotifier ();
               Expression rhs = (Expression) notification.getNewValue ();

               binaryOperator.setRhs (rhs);

               m_sync = true;
            }

            break;
         }

         case IdlmmPackage.BINARY_OPERATOR__LHS:
         {
            if (m_sync == true)
            {
               m_sync = false;

               BinaryOperator binaryOperator = (BinaryOperator) notification.getNotifier ();
               Expression lhs = (Expression) notification.getNewValue ();

               if (lhs instanceof OwnedExpression)
               {
                  binaryOperator.setOwnedLhs ((OwnedExpression) lhs);
               }
               else
               {
                  binaryOperator.setOwnedLhs (null);
               }

               m_sync = true;
            }

            break;
         }

         case IdlmmPackage.BINARY_OPERATOR__OWNED_LHS:
         {
            if (m_sync == true)
            {
               m_sync = false;

               BinaryOperator binaryOperator = (BinaryOperator) notification.getNotifier ();
               Expression lhs = (Expression) notification.getNewValue ();

               binaryOperator.setLhs (lhs);

               m_sync = true;
            }

            break;
         }

         default:
         {
            break;
         }
      }
   }
}
