package com.prismtech.idt.idlmm.impl;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import com.prismtech.idt.idlmm.Expression;
import com.prismtech.idt.idlmm.IdlmmPackage;
import com.prismtech.idt.idlmm.OwnedExpression;
import com.prismtech.idt.idlmm.ConstantDef;


public class ConstantDefOwnedValueAdapter implements Adapter
{
   private ConstantDef m_constant_def = null;

   private boolean m_sync = true;

   public void setTarget (Notifier target)
   {
      m_constant_def = (ConstantDef) target;
      m_sync = true;
   }

   public Notifier getTarget ()
   {
      return m_constant_def;
   }

   public boolean isAdapterForType (Object type)
   {
      return false;
   }

   public void notifyChanged (Notification notification)
   {
      switch (notification.getFeatureID (ConstantDef.class))
      {
         case IdlmmPackage.CONSTANT_DEF__VALUE:
         {
            if (m_sync == true)
            {
               m_sync = false;

               ConstantDef constant_def = (ConstantDef) notification.getNotifier ();
               Expression value = (Expression) notification.getNewValue ();

               if (value instanceof OwnedExpression)
               {
                  constant_def.setOwnedValue ((OwnedExpression) value);
               }
               else
               {
                  constant_def.setOwnedValue (null);
               }

               m_sync = true;
            }

            break;
         }

         case IdlmmPackage.CONSTANT_DEF__OWNED_VALUE:
         {
            if (m_sync == true)
            {
               m_sync = false;

               ConstantDef constant_def = (ConstantDef) notification.getNotifier ();
               Expression value = (Expression) notification.getNewValue ();

               constant_def.setValue (value);

               m_sync = true;
            }

            break;
         }

         default:
         {
            break;
         }
      }
   }
}
