package com.prismtech.idt.idlmm.impl;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import com.prismtech.idt.idlmm.Expression;
import com.prismtech.idt.idlmm.IdlmmPackage;
import com.prismtech.idt.idlmm.OwnedExpression;
import com.prismtech.idt.idlmm.FixedDef;


public class FixedDefOwnedExpressionAdapter implements Adapter
{
   private FixedDef m_fixed_def = null;

   private boolean m_sync = true;

   public void setTarget (Notifier target)
   {
      m_fixed_def = (FixedDef) target;
      m_sync = true;
   }

   public Notifier getTarget ()
   {
      return m_fixed_def;
   }

   public boolean isAdapterForType (Object type)
   {
      return false;
   }

   public void notifyChanged (Notification notification)
   {
      switch (notification.getFeatureID (FixedDef.class))
      {
         case IdlmmPackage.FIXED_DEF__SCALE:
         {
            if (m_sync == true)
            {
               m_sync = false;

               FixedDef fixed_def = (FixedDef) notification.getNotifier ();
               Expression scale = (Expression) notification.getNewValue ();

               if (scale instanceof OwnedExpression)
               {
                  fixed_def.setOwnedScale ((OwnedExpression) scale);
               }
               else
               {
                  fixed_def.setOwnedScale (null);
               }

               m_sync = true;
            }

            break;
         }

         case IdlmmPackage.FIXED_DEF__OWNED_SCALE:
         {
            if (m_sync == true)
            {
               m_sync = false;

               FixedDef fixed_def = (FixedDef) notification.getNotifier ();
               Expression scale = (Expression) notification.getNewValue ();

               fixed_def.setScale (scale);

               m_sync = true;
            }

            break;
         }

         case IdlmmPackage.FIXED_DEF__DIGITS:
         {
            if (m_sync == true)
            {
               m_sync = false;

               FixedDef fixed_def = (FixedDef) notification.getNotifier ();
               Expression digits = (Expression) notification.getNewValue ();

               if (digits instanceof OwnedExpression)
               {
                  fixed_def.setOwnedDigits ((OwnedExpression) digits);
               }
               else
               {
                  fixed_def.setOwnedDigits (null);
               }

               m_sync = true;
            }

            break;
         }

         case IdlmmPackage.FIXED_DEF__OWNED_DIGITS:
         {
            if (m_sync == true)
            {
               m_sync = false;

               FixedDef fixed_def = (FixedDef) notification.getNotifier ();
               Expression digits = (Expression) notification.getNewValue ();

               fixed_def.setDigits (digits);

               m_sync = true;
            }

            break;
         }

         default:
         {
            break;
         }
      }
   }
}
