package com.prismtech.idt.idlmm.impl;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import com.prismtech.idt.idlmm.Expression;
import com.prismtech.idt.idlmm.IdlmmPackage;
import com.prismtech.idt.idlmm.OwnedExpression;
import com.prismtech.idt.idlmm.UnaryOperator;


public class UnaryOperatorOwnedOperandAdapter implements Adapter
{
   private UnaryOperator m_unaryOperator = null;

   private boolean m_sync = true;

   public void setTarget (Notifier target)
   {
      m_unaryOperator = (UnaryOperator) target;
      m_sync = true;
   }

   public Notifier getTarget ()
   {
      return m_unaryOperator;
   }

   public boolean isAdapterForType (Object type)
   {
      return false;
   }

   public void notifyChanged (Notification notification)
   {
      switch (notification.getFeatureID (UnaryOperator.class))
      {
         case IdlmmPackage.UNARY_OPERATOR__OPERAND:
         {
            if (m_sync == true)
            {
               m_sync = false;

               UnaryOperator unaryOperator_def = (UnaryOperator) notification.getNotifier ();
               Expression operand = (Expression) notification.getNewValue ();

               if (operand instanceof OwnedExpression)
               {
                  unaryOperator_def.setOwnedOperand ((OwnedExpression) operand);
               }
               else
               {
                  unaryOperator_def.setOwnedOperand (null);
               }

               m_sync = true;
            }

            break;
         }

         case IdlmmPackage.UNARY_OPERATOR__OWNED_OPERAND:
         {
            if (m_sync == true)
            {
               m_sync = false;

               UnaryOperator unaryOperator_def = (UnaryOperator) notification.getNotifier ();
               Expression operand = (Expression) notification.getNewValue ();

               unaryOperator_def.setOperand (operand);

               m_sync = true;
            }

            break;
         }

         default:
         {
            break;
         }
      }
   }
}
