package com.prismtech.idt.idlmm.impl;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import com.prismtech.idt.idlmm.Expression;
import com.prismtech.idt.idlmm.IDLType;
import com.prismtech.idt.idlmm.IdlmmPackage;
import com.prismtech.idt.idlmm.OwnedExpression;
import com.prismtech.idt.idlmm.OwnedIDLType;
import com.prismtech.idt.idlmm.Typed;
import com.prismtech.idt.idlmm.UnionMember;


public class UnionMemberOwnedLabelAdapter implements Adapter
{
   private UnionMember m_member = null;

   private boolean m_sync = true;

   public void setTarget (Notifier target)
   {
      m_member = (UnionMember) target;
      m_sync = true;
   }

   public Notifier getTarget ()
   {
      return m_member;
   }

   public boolean isAdapterForType (Object type)
   {
      return false;
   }

   public void notifyChanged (Notification notification)
   {
      switch (notification.getFeatureID (UnionMember.class))
      {
         case IdlmmPackage.UNION_MEMBER__LABELS:
         {
            if (m_sync == true)
            {
               m_sync = false;

               UnionMember member = (UnionMember) notification.getNotifier ();
               Expression label = (Expression) notification.getNewValue ();
               if (label instanceof OwnedExpression)
               {
                  member.getOwnedLabels ().add ((OwnedExpression)label);
               }

               m_sync = true;
            }

            break;
         }

         default:
         {
            break;
         }
      }
   }
}
