package com.prismtech.idt.idlmm.impl;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import com.prismtech.idt.idlmm.Expression;
import com.prismtech.idt.idlmm.IdlmmPackage;
import com.prismtech.idt.idlmm.OwnedExpression;
import com.prismtech.idt.idlmm.WStringDef;


public class WStringDefOwnedBoundAdapter implements Adapter
{
   private WStringDef m_string_def = null;

   private boolean m_sync = true;

   public void setTarget (Notifier target)
   {
      m_string_def = (WStringDef) target;
      m_sync = true;
   }

   public Notifier getTarget ()
   {
      return m_string_def;
   }

   public boolean isAdapterForType (Object type)
   {
      return false;
   }

   public void notifyChanged (Notification notification)
   {
      switch (notification.getFeatureID (WStringDef.class))
      {
         case IdlmmPackage.WSTRING_DEF__BOUND:
         {
            if (m_sync == true)
            {
               m_sync = false;

               WStringDef string_def = (WStringDef) notification.getNotifier ();
               Expression bound = (Expression) notification.getNewValue ();

               if (bound instanceof OwnedExpression)
               {
                  string_def.setOwnedBound ((OwnedExpression) bound);
               }
               else
               {
                  string_def.setOwnedBound (null);
               }

               m_sync = true;
            }

            break;
         }

         case IdlmmPackage.WSTRING_DEF__OWNED_BOUND:
         {
            if (m_sync == true)
            {
               m_sync = false;

               WStringDef string_def = (WStringDef) notification.getNotifier ();
               Expression bound = (Expression) notification.getNewValue ();

               string_def.setBound (bound);

               m_sync = true;
            }

            break;
         }

         default:
         {
            break;
         }
      }
   }
}
