package com.prismtech.idt.imports.idl.driver;

import java.io.File;


/**
 * This interface encapsulates all of the input and output arguments involved in an invocation of
 * {@link IIdlImportDriver#build(IIdlImportDriverParams)}. This is essentially a list of which IDL
 * files are to be processed, where each IDL file is represented by an {@link IIdlImportDriverParam}
 * object.
 * <p>
 * This interface is not designed to be implemented by clients. Instances can be created using the
 * {@link IIdlImportDriver#createDriverParams()} method.
 * 
 * @see IIdlImportDriver#createDriverParams(File...)
 * @see IIdlImportDriver#build(IIdlImportDriverParams)
 */
public interface IIdlImportDriverParams extends Iterable<IIdlImportDriverParam>
{
   public IIdlImportDriverParam add (File idlfile);

   public IIdlImportDriverParam get (File idlfile);
   
   public boolean remove (File idlfile);
   
   public boolean contains (File idlfile);
   
   public int size ();
}
