package com.prismtech.idt.imports.idl.internal.driver;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.MultiStatus;

import com.prismtech.idt.imports.idl.preprocessor.IIdlPreprocessor;
import com.prismtech.idt.imports.idl.preprocessor.IIdlPreprocessorStatus;

public class IdlPreprocessorStatusAdapter extends MultiStatus implements IIdlPreprocessorStatus
{
   private final IIdlPreprocessorStatus m_status;
   
   public IdlPreprocessorStatusAdapter(IIdlPreprocessorStatus status)
   {
      super(IIdlPreprocessor.PLUGIN_ID, 0, status.getMessage (), status.getException ());
      m_status = status;
      if(status.isMultiStatus ())
      {
         for(IIdlPreprocessorStatus child : status.getChildStati ())
         {
            this.add(new IdlPreprocessorStatusAdapter(child));
         }
      }
      else
      {
         switch(status.getSeverity())
         {
            case IIdlPreprocessorStatus.OK:
               setSeverity (IStatus.OK);
               break;
            case IIdlPreprocessorStatus.INFO:
               setSeverity (IStatus.INFO);
               break;
            case IIdlPreprocessorStatus.WARNING:
               setSeverity (IStatus.WARNING);
               break;
            case IIdlPreprocessorStatus.ERROR:
               setSeverity (IStatus.ERROR);
               break;
            case IIdlPreprocessorStatus.CANCEL:
               setSeverity (IStatus.CANCEL);
               break;
         }
      }
   }

   public boolean isMultiStatus ()
   {
      return m_status.isMultiStatus ();
   }

   public IIdlPreprocessorStatus[] getChildStati ()
   {
      return m_status.getChildStati ();
   }

   public int getColumn ()
   {
      return m_status.getColumn ();
   }

   public String getFilename ()
   {
      return m_status.getFilename ();
   }

   public int getLine ()
   {
      return m_status.getLine ();
   }
}
