package com.prismtech.idt.imports.idl.importer;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;

import com.prismtech.idt.idlmm.IRObject;
import com.prismtech.idt.idlmm.IdlmmFactory;
import com.prismtech.idt.idlmm.Pragma;
import com.prismtech.idt.imports.idl.internal.importer.IdlImporterStatus;


public abstract class BasePostPragmaHandler implements IIdlPragmaHandler
{
   protected static final IdlmmFactory FACTORY = IdlmmFactory.eINSTANCE;

   public abstract boolean matches (String pragmaText);

   public IStatus create (CreateContext ctx)
   {
      Pragma def = FACTORY.createPostPragma ();
      def.setText (ctx.getPragmaText ());
      ctx.setPragma (def);
      int index = ctx.getParent ().getContents ().size () - 1;
      if (index < 0)
         return new IdlImporterStatus (ctx.getAst (), IStatus.ERROR, "No IRObjects in scope preceeding #pragma "
               + ctx.getPragmaText ());
      ctx.setData ("INDEX", index);
      return new Status (IStatus.OK, IdlImporterPlugin.PLUGIN_ID, "");
   }

   public IStatus bind (CreateContext ctx)
   {
      int index = (Integer) ctx.getData ("INDEX");
      IRObject owner = ctx.getParent ().getContents ().get (index);
      owner.getPragmas ().add (ctx.getPragma ());
      return new Status (IStatus.OK, IdlImporterPlugin.PLUGIN_ID, "");
   }
}
