package com.prismtech.idt.imports.idl.importer;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.emf.common.util.EList;

import com.prismtech.idt.idlmm.Contained;
import com.prismtech.idt.idlmm.IRObject;
import com.prismtech.idt.idlmm.IdlmmFactory;
import com.prismtech.idt.idlmm.Pragma;
import com.prismtech.idt.imports.idl.internal.importer.IdlImporterStatus;


public abstract class BasePrePragmaHandler implements IIdlPragmaHandler
{
   protected static final IdlmmFactory FACTORY = IdlmmFactory.eINSTANCE;

   public abstract boolean matches (String pragmaText);

   public IStatus create (CreateContext ctx)
   {
      Pragma def = FACTORY.createPrePragma ();
      def.setText (ctx.getPragmaText ());
      ctx.setPragma (def);
      ctx.setData ("INDEX", ctx.getParent ().getContents ().size ());
      return new Status (IStatus.OK, IdlImporterPlugin.PLUGIN_ID, "");
   }

   public IStatus bind (CreateContext ctx)
   {
      int index = (Integer) ctx.getData ("INDEX");
      EList<Contained> contents = ctx.getParent ().getContents ();
      if (index >= contents.size ())
         return new IdlImporterStatus (ctx.getAst (), IStatus.ERROR, "No IRObjects in scope following #pragma "
               + ctx.getPragmaText ());
      IRObject owner = contents.get (index);
      owner.getPragmas ().add (ctx.getPragma ());
      return new Status (IStatus.OK, IdlImporterPlugin.PLUGIN_ID, "");
   }
}
