package com.prismtech.idt.imports.idl.importer;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;

import com.prismtech.idt.idlmm.IdlmmFactory;
import com.prismtech.idt.idlmm.Pragma;


public abstract class BaseScopePragmaHandler implements IIdlPragmaHandler
{
   protected static final IdlmmFactory FACTORY = IdlmmFactory.eINSTANCE;

   public abstract boolean matches (String pragmaText);

   public IStatus create (CreateContext ctx)
   {
      Pragma def = FACTORY.createScopePragma ();
      def.setText (ctx.getPragmaText ());
      ctx.setPragma (def);
      return new Status (IStatus.OK, IdlImporterPlugin.PLUGIN_ID, "");
   }

   public IStatus bind (CreateContext ctx)
   {
      ctx.getParent ().getPragmas ().add (ctx.getPragma ());
      return new Status (IStatus.OK, IdlImporterPlugin.PLUGIN_ID, "");
   }
}
