/*
 * COPYRIGHT NOTICE The information contained herein and which follows is
 * proprietary information and is the property of PrismTech Corporation. This
 * information is not to be divulged, released, copied, reproduced, or conveyed
 * to unauthorized personnel, companies, or other institutions without the
 * direct and expressed approval in writing of PrismTech Corporation. DISCLAIMER
 * Neither PrismTech Limited nor PrismTech Corporation ("PrismTech") are under
 * any obligation to support the use of this code which is provided without
 * warranty of any kind. PrismTech shall (except as otherwise prohibited by law)
 * have no liability whatsoever in relation to its use.
 */

package com.prismtech.idt.imports.idl.importer;

import com.prismtech.idt.imports.idl.parser.IdlParserAST;


/**
 * Used by the {@link IIdlImporter} to encode information from the
 * {@link IdlParserAST} into a {@link String}. Typically,
 * {@link IdlParserAST#getFilename()}, {@link IdlParserAST#getLine()} and
 * {@link IdlParserAST#getColumn()} will be used to construct some kind of URI.
 * 
 * @see IIdlImporter#setSourceComposer(ISourceComposer)
 */
public interface IIdlSourceComposer
{
   public String compose (IdlParserAST ast) throws Exception;
}
