package com.prismtech.idt.imports.idl.internal.importer;

import com.prismtech.idt.imports.idl.importer.IIdlImporter;
import com.prismtech.idt.imports.idl.importer.IIdlSourceComposer;
import com.prismtech.idt.imports.idl.parser.IdlParserAST;


/**
 * This is the default {@link IIdlSourceComposer} implementation used by the
 * {@link IIdlImporter}.
 * 
 * @see IIdlImporter#setSourceComposer(IIdlSourceComposer)
 */
public class DefaultIdlSourceComposer implements IIdlSourceComposer
{
   public String compose (IdlParserAST ast) throws Exception
   {
      StringBuilder builder = new StringBuilder ();

      builder.append (ast.getFilename ());
      builder.append ('#');
      builder.append (ast.getLine ());
      builder.append (',');
      builder.append (ast.getColumn ());

      return builder.toString ();
   }
}
