package com.prismtech.idt.imports.idl.internal.importer;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.emf.common.util.EList;

import com.prismtech.idt.idlmm.Contained;
import com.prismtech.idt.idlmm.IRObject;
import com.prismtech.idt.idlmm.IdlmmFactory;
import com.prismtech.idt.idlmm.Pragma;
import com.prismtech.idt.imports.idl.importer.IIdlPragmaHandler;
import com.prismtech.idt.imports.idl.importer.IdlImporterPlugin;


public class UnknownPragmaHandler implements IIdlPragmaHandler
{
   protected static final IdlmmFactory FACTORY = IdlmmFactory.eINSTANCE;

   public boolean matches (String pragmaText)
   {
      return true;
   }

   public IStatus create (CreateContext ctx)
   {
      int index = ctx.getParent ().getContents ().size () - 1;
      ctx.setData ("INDEX", index);
      if (index >= 0)
      {
         Pragma def = FACTORY.createPostPragma ();
         def.setText (ctx.getPragmaText ());
         ctx.setPragma (def);
      }
      else
      {
         Pragma def = FACTORY.createPrePragma ();
         def.setText (ctx.getPragmaText ());
         ctx.setPragma (def);
      }
      return new Status (IStatus.OK, IdlImporterPlugin.PLUGIN_ID, "");
   }

   public IStatus bind (CreateContext ctx)
   {
      int index = (Integer) ctx.getData ("INDEX");
      EList<Contained> contents = ctx.getParent ().getContents ();
      Pragma def = ctx.getPragma ();
      if (index >= 0)
      {
         IRObject owner = contents.get (index);
         owner.getPragmas ().add (def);
      }
      else
      {
         IRObject owner = contents.get (index + 1);
         owner.getPragmas ().add (def);
      }
      return new Status (IStatus.OK, IdlImporterPlugin.PLUGIN_ID, "");
   }
}
