/*
 * COPYRIGHT NOTICE The information contained herein and which follows is
 * proprietary information and is the property of PrismTech Corporation. This
 * information is not to be divulged, released, copied, reproduced, or conveyed
 * to unauthorized personnel, companies, or other institutions without the
 * direct and expressed approval in writing of PrismTech Corporation. DISCLAIMER
 * Neither PrismTech Limited nor PrismTech Corporation ("PrismTech") are under
 * any obligation to support the use of this code which is provided without
 * warranty of any kind. PrismTech shall (except as otherwise prohibited by law)
 * have no liability whatsoever in relation to its use.
 */

package com.prismtech.idt.imports.idl.internal.importer.builderutil;

import com.prismtech.idt.idlmm.ExceptionDef;


/**
 * @author Yuriy Kravchenko
 */

/**
 * This interface is used for working with exceptions declared in attrubutes.
 * The only one method is declared in this interface since
 * ExceptionDeclarant.addException() method is used for passing " "get"
 * exceptions " (exceptions which are defined at readonly attributes and defined
 * using "getraises" declaration)
 */
public interface AttributeExceptionDeclarant extends ExceptionDeclarant
{
   public void addRaisedSetException (ExceptionDef ex);
}
