/*
 * COPYRIGHT NOTICE The information contained herein and which follows is
 * proprietary information and is the property of PrismTech Corporation. This
 * information is not to be divulged, released, copied, reproduced, or conveyed
 * to unauthorized personnel, companies, or other institutions without the
 * direct and expressed approval in writing of PrismTech Corporation. DISCLAIMER
 * Neither PrismTech Limited nor PrismTech Corporation ("PrismTech") are under
 * any obligation to support the use of this code which is provided without
 * warranty of any kind. PrismTech shall (except as otherwise prohibited by law)
 * have no liability whatsoever in relation to its use.
 */

package com.prismtech.idt.imports.idl.internal.importer.builderutil;

import com.prismtech.idt.imports.idl.parser.IdlParserAST;


/**
 * @author Yuriy Kravchenko
 */

public class CompoundNodePropertiesHolder extends TypeDeclarationPropertiesHolder
{
   protected TypePropertiesHolder m_innerTypeHolder;

   public CompoundNodePropertiesHolder ()
   {
   }

   public CompoundNodePropertiesHolder (String sourceVal, IdlParserAST... asts)
   {
      super (sourceVal, asts);
   }

   public CompoundNodePropertiesHolder (TypePropertiesHolder nh, IdlParserAST... asts)
   {
      super (asts);
      m_innerTypeHolder = nh;
   }

   public CompoundNodePropertiesHolder (TypePropertiesHolder nh, String sourceVal, IdlParserAST... asts)
   {
      super (sourceVal, asts);
      m_innerTypeHolder = nh;

   }

   public void setTypeHolder (TypePropertiesHolder typeHolder)
   {
      this.m_innerTypeHolder = typeHolder;
   }

   public TypePropertiesHolder getTypeHolder ()
   {
      return this.m_innerTypeHolder;
   }

}
