/*
 * COPYRIGHT NOTICE The information contained herein and which follows is
 * proprietary information and is the property of PrismTech Corporation. This
 * information is not to be divulged, released, copied, reproduced, or conveyed
 * to unauthorized personnel, companies, or other institutions without the
 * direct and expressed approval in writing of PrismTech Corporation. DISCLAIMER
 * Neither PrismTech Limited nor PrismTech Corporation ("PrismTech") are under
 * any obligation to support the use of this code which is provided without
 * warranty of any kind. PrismTech shall (except as otherwise prohibited by law)
 * have no liability whatsoever in relation to its use.
 */

package com.prismtech.idt.imports.idl.internal.importer.builderutil;

import com.prismtech.idt.imports.idl.parser.IdlParserAST;


/**
 * @author Yuriy Kravchenko
 */
public class DeclaratorHolder
{
   private final IdlParserAST m_AST;

   private final String m_sourceVal;

   public DeclaratorHolder (IdlParserAST ast, String sourceVal)
   {
      m_AST = ast;
      m_sourceVal = sourceVal;
   }

   public String getName ()
   {
      return m_AST.getText ();
   }

   public String getSourceAttrValue ()
   {
      return m_sourceVal;
   }

   public IdlParserAST getAST ()
   {
      return m_AST;
   }

}
