/*
 * COPYRIGHT NOTICE The information contained herein and which follows is
 * proprietary information and is the property of PrismTech Corporation. This
 * information is not to be divulged, released, copied, reproduced, or conveyed
 * to unauthorized personnel, companies, or other institutions without the
 * direct and expressed approval in writing of PrismTech Corporation. DISCLAIMER
 * Neither PrismTech Limited nor PrismTech Corporation ("PrismTech") are under
 * any obligation to support the use of this code which is provided without
 * warranty of any kind. PrismTech shall (except as otherwise prohibited by law)
 * have no liability whatsoever in relation to its use.
 */

package com.prismtech.idt.imports.idl.internal.importer.builderutil;

import com.prismtech.idt.idlmm.BinaryOperator;
import com.prismtech.idt.idlmm.Expression;
import com.prismtech.idt.idlmm.Operator;
import com.prismtech.idt.idlmm.UnaryOperator;


/**
 * @author Yuriy Kravchenko
 */

public class ExpressionHolder implements NodePropertiesHolder
{
   private Expression m_operator;

   private int m_operatorsSubmitted = 0;

   public ExpressionHolder (Operator op, String sourceVal)
   {
      m_operator = op;
      m_operator.setSource (sourceVal);
   }

   // public void addOperand(Value val)
   // {
   // if (this.m_operator instanceof BinaryOperator)
   // {
   // BinaryOperator bo = (BinaryOperator) this.m_operator;
   // switch(m_operatorsSubmitted)
   // {
   // case 0:
   // bo.setLhs (val);
   // break;
   // case 1:
   // bo.setRhs (val);
   // break;
   // default:
   // throw new IllegalStateException("Can't add third operand for binary
   // operator");
   // }
   // }
   // else if (this.m_operator instanceof UnaryOperator)
   // {
   // if (m_operatorsSubmitted > 0)
   // {
   // throw new IllegalStateException("Can't add second operand for unary
   // operator");
   // }
   // ((UnaryOperator) this.m_operator).setOperand (val);
   // }
   // m_operatorsSubmitted++;
   // }

   public void addOperand (Expression exp)
   {
      if (this.m_operator instanceof BinaryOperator)
      {
         BinaryOperator bo = (BinaryOperator) this.m_operator;
         switch (m_operatorsSubmitted)
         {
            case 0:
               bo.setLhs (exp);
               break;
            case 1:
               bo.setRhs (exp);
               break;
            default:
               throw new IllegalStateException ("Can't add third operand for binary operator");
         }
      }
      else if (this.m_operator instanceof UnaryOperator)
      {
         if (m_operatorsSubmitted > 0)
         {
            throw new IllegalStateException ("Can't add second operand for unary operator");
         }
         ((UnaryOperator) this.m_operator).setOperand (exp);
      }
      m_operatorsSubmitted++;
   }

   public Expression getExpression ()
   {
      return this.m_operator;
   }

   public void setExpression (Expression exp)
   {
      m_operator = exp;
   }
}
