/*
 * COPYRIGHT NOTICE The information contained herein and which follows is
 * proprietary information and is the property of PrismTech Corporation. This
 * information is not to be divulged, released, copied, reproduced, or conveyed
 * to unauthorized personnel, companies, or other institutions without the
 * direct and expressed approval in writing of PrismTech Corporation. DISCLAIMER
 * Neither PrismTech Limited nor PrismTech Corporation ("PrismTech") are under
 * any obligation to support the use of this code which is provided without
 * warranty of any kind. PrismTech shall (except as otherwise prohibited by law)
 * have no liability whatsoever in relation to its use.
 */

package com.prismtech.idt.imports.idl.internal.importer.builderutil;

/**
 * @author Yuriy Kravchenko
 */

import org.eclipse.emf.common.util.EList;

import com.prismtech.idt.idlmm.ExceptionDef;
import com.prismtech.idt.idlmm.FactoryOperation;
import com.prismtech.idt.idlmm.IRObject;
import com.prismtech.idt.idlmm.InitializerParameterDef;
import com.prismtech.idt.imports.idl.parser.IdlParserAST;


public class FactoryOperationPropertiesHolder extends InitializerDeclPropertiesHolder
{
   public FactoryOperationPropertiesHolder (String name, String sourceVal, IdlParserAST... asts)
   {
      super (name, sourceVal, asts);
   }

   @Override
   protected IRObject createDefinitionImpl ()
   {
      FactoryOperation factoryOp = FACTORY.createFactoryOperation ();
      factoryOp.setName (this.m_name);
      for (InitializerParamDeclHolder paramHolder : this.m_parameters)
      {
         InitializerParameterDef param = this.createParameter (paramHolder);
         param.setFactoryOperation (factoryOp);
         factoryOp.getParameters ().add (param);
      }
      this.addRaisedExceptionsToFactoryOperation (factoryOp);
      return factoryOp;
   }

   private void addRaisedExceptionsToFactoryOperation (FactoryOperation factoryOp)
   {
      if (this.m_exceptionList == null)
      {
         return;
      }

      EList<ExceptionDef> el = factoryOp.getExceptions ();

      for (ExceptionDef ex : this.m_exceptionList)
      {
         el.add (ex);
      }
   }

}
