/*
 * COPYRIGHT NOTICE The information contained herein and which follows is
 * proprietary information and is the property of PrismTech Corporation. This
 * information is not to be divulged, released, copied, reproduced, or conveyed
 * to unauthorized personnel, companies, or other institutions without the
 * direct and expressed approval in writing of PrismTech Corporation. DISCLAIMER
 * Neither PrismTech Limited nor PrismTech Corporation ("PrismTech") are under
 * any obligation to support the use of this code which is provided without
 * warranty of any kind. PrismTech shall (except as otherwise prohibited by law)
 * have no liability whatsoever in relation to its use.
 */

package com.prismtech.idt.imports.idl.internal.importer.builderutil;

import com.prismtech.idt.imports.idl.parser.IdlParserAST;


/**
 * @author Yuriy Kravchenko
 */

public class InitializerParamDeclHolder
{
   private final TypePropertiesHolder m_typeHolder;

   private final String m_name;

   private final String m_sourceVal;

   private final IdlParserAST[] m_asts;

   public InitializerParamDeclHolder (TypePropertiesHolder typeHolder, String name, String sourceVal, IdlParserAST... asts)
   {
      m_typeHolder = typeHolder;
      m_name = name;
      m_sourceVal = sourceVal;
      m_asts = asts;

   }

   public TypePropertiesHolder getTypeHolder ()
   {
      return this.m_typeHolder;
   }

   public String getName ()
   {
      return this.m_name;
   }

   public String getSourceVal ()
   {
      return m_sourceVal;
   }

   public IdlParserAST[] getIdlParserASTs ()
   {
      return m_asts;
   }

}
