/*
 * COPYRIGHT NOTICE The information contained herein and which follows is
 * proprietary information and is the property of PrismTech Corporation. This
 * information is not to be divulged, released, copied, reproduced, or conveyed
 * to unauthorized personnel, companies, or other institutions without the
 * direct and expressed approval in writing of PrismTech Corporation. DISCLAIMER
 * Neither PrismTech Limited nor PrismTech Corporation ("PrismTech") are under
 * any obligation to support the use of this code which is provided without
 * warranty of any kind. PrismTech shall (except as otherwise prohibited by law)
 * have no liability whatsoever in relation to its use.
 */

package com.prismtech.idt.imports.idl.internal.importer.builderutil;

import com.prismtech.idt.idlmm.IRObject;
import com.prismtech.idt.idlmm.PrimitiveKind;
import com.prismtech.idt.idlmm.Repository;
import com.prismtech.idt.imports.idl.parser.IdlParserAST;


/**
 * @author Yuriy Kravchenko
 */
public class PrimitiveDefPropertiesHolder extends TypePropertiesHolder
{

   private final Repository m_repository;

   private final PrimitiveKind m_kind;

   /**
    * @param kind
    *           kind of the primitive type
    */
   public PrimitiveDefPropertiesHolder (PrimitiveKind kind, Repository rep, String sourceVal, IdlParserAST... ast)
   {
      super (sourceVal, ast);

      m_kind = kind;
      m_repository = rep;
   }

   @Override
   protected IRObject createDefinitionImpl ()
   {
      return this.m_repository.createPrimitive (m_kind);
   }

   /**
    * overriding is neeeded as a new instance of PrimitiveDef should be returned
    * at every invocation of getDefinition() method Without overriding a new
    * instance of PrimitiveDef is returned only at first invocation of
    * getDefinition()
    */
   @Override
   public IRObject getDefinition ()
   {
      return this.createDefinition ();
   }

}
