package com.prismtech.idt.imports.idl.internal.importer.builderutil;

public class RepositoryIDHelper
{
   public static boolean validRepositoryID(String repID)
   {
      if(repID.startsWith("IDL:"))
      {
         return validIDLRepositoryID(repID);
      }
      else
      {
         return repID.contains (":");
      }
   }
   
   public static boolean validIDLRepositoryID(String repID)
   {
      String[] repIDElements = repID.split (":");
      if(repIDElements.length != 3)
      {
         return false;
      }
      else
      {
         return repIDElements[0].equals ("IDL") && validIdentifiers(repIDElements[1]) && validVersion(repIDElements[2]);
      }
   }
   
   public static boolean validIdentifiers(String identifiers)
   {
      return identifiers.matches ("[\\w-\\.]+(/[\\w-\\.]+)*");
   }
   
   public static boolean validPrefix(String prefix)
   {
      return (prefix.length () == 0 || validIdentifiers (prefix));
   }
   
   public static boolean validVersion(String version)
   {
      return version.matches ("\\d+\\.\\d+");
   }
}
