/*
 * COPYRIGHT NOTICE The information contained herein and which follows is
 * proprietary information and is the property of PrismTech Corporation. This
 * information is not to be divulged, released, copied, reproduced, or conveyed
 * to unauthorized personnel, companies, or other institutions without the
 * direct and expressed approval in writing of PrismTech Corporation. DISCLAIMER
 * Neither PrismTech Limited nor PrismTech Corporation ("PrismTech") are under
 * any obligation to support the use of this code which is provided without
 * warranty of any kind. PrismTech shall (except as otherwise prohibited by law)
 * have no liability whatsoever in relation to its use.
 */

package com.prismtech.idt.imports.idl.internal.importer.builderutil;

import java.util.Stack;

import com.prismtech.idt.idlmm.Container;


/**
 * @author Yuriy Kravchenko
 */
public class ResolvingContext
{
   private final Stack<Container> m_namespaceContext = new Stack<Container> ();

   public void setCurrentContext (Container container)
   {
      m_namespaceContext.push (container);
   }

   public void leaveCurrentContext ()
   {
      m_namespaceContext.pop ();
   }

   public Container getCurrentContext ()
   {
      return m_namespaceContext.peek ();
   }

   public int getSize ()
   {
      return m_namespaceContext.size ();
   }
}
