/*
 * COPYRIGHT NOTICE The information contained herein and which follows is
 * proprietary information and is the property of PrismTech Corporation. This
 * information is not to be divulged, released, copied, reproduced, or conveyed
 * to unauthorized personnel, companies, or other institutions without the
 * direct and expressed approval in writing of PrismTech Corporation. DISCLAIMER
 * Neither PrismTech Limited nor PrismTech Corporation ("PrismTech") are under
 * any obligation to support the use of this code which is provided without
 * warranty of any kind. PrismTech shall (except as otherwise prohibited by law)
 * have no liability whatsoever in relation to its use.
 */

package com.prismtech.idt.imports.idl.internal.importer.builderutil;

/**
 * @author Yuriy Kravchenko
 */

import com.prismtech.idt.idlmm.IRObject;
import com.prismtech.idt.imports.idl.parser.IdlParserAST;


public class ScopedNameNodePropertiesHolder extends TypePropertiesHolder
{
   private final String m_name;

   private final ScopedNameResolver m_scNameResolver;

   public ScopedNameNodePropertiesHolder (String name, ScopedNameResolver scResolver, String sourceVal, IdlParserAST... asts)
   {
      super (sourceVal, asts);

      m_name = name;
      m_scNameResolver = scResolver;

   }

   @Override
   public IRObject createDefinitionImpl ()
   {
      return m_scNameResolver.resolveType (this);
   }

   /**
    * overriding is needed because the IRObject which is passed to
    * setSourceAttribute() method is obtained via
    * ScopedNameResolver.resolveType() method. Thus this type is already defined
    * and obviously has "source" attribute info. And this info should not be
    * overridden by "source" info of ScopedName holder.
    */
   @Override
   protected void setSourceAttribute (IRObject obj)
   {
      // do nothing intentionally
   }

   public String getScopedName ()
   {
      return m_name;
   }

   public String getSourceValue ()
   {
      return m_sourceAttrValue;
   }

   public IdlParserAST[] getASTs ()
   {
      return m_asts;
   }
}
