/*
 * COPYRIGHT NOTICE The information contained herein and which follows is
 * proprietary information and is the property of PrismTech Corporation. This
 * information is not to be divulged, released, copied, reproduced, or conveyed
 * to unauthorized personnel, companies, or other institutions without the
 * direct and expressed approval in writing of PrismTech Corporation. DISCLAIMER
 * Neither PrismTech Limited nor PrismTech Corporation ("PrismTech") are under
 * any obligation to support the use of this code which is provided without
 * warranty of any kind. PrismTech shall (except as otherwise prohibited by law)
 * have no liability whatsoever in relation to its use.
 */

package com.prismtech.idt.imports.idl.internal.importer.builderutil;

/**
 * @author Yuriy Kravchenko
 */

import com.prismtech.idt.idlmm.Expression;
import com.prismtech.idt.idlmm.IDLType;
import com.prismtech.idt.idlmm.IRObject;
import com.prismtech.idt.idlmm.SequenceDef;
import com.prismtech.idt.imports.idl.parser.IdlParserAST;


public class SequenceTypePropertiesHolder extends CompoundNodePropertiesHolder implements ExpressionOperable
{
   private Expression m_bound = null;

   public SequenceTypePropertiesHolder (TypePropertiesHolder nh, String sourceVal, IdlParserAST... ast)
   {
      super (nh, sourceVal, ast);
   }

   /**
    * overriding is needed as a new instance of StringDef should be returned at
    * every invocation of getDefinition() method Without overriding new instance
    * of StringDef is returned only at first invocation of getDefinition()
    */
   @Override
   public IRObject getDefinition ()
   {
      return this.createDefinition ();
   }

   @Override
   protected IRObject createDefinitionImpl ()
   {
      return this.createSequenceDef ();
   }

   public Expression getExpression ()
   {
      return m_bound;
   }

   public void setExpression (Expression expr)
   {
      m_bound = expr;
   }

   private SequenceDef createSequenceDef ()
   {
      IDLType type = (IDLType) m_innerTypeHolder.getDefinition ();

      Expression bound =  ( (m_bound != null) ? m_bound : LiteralHelper.createIntegerLiteral ("0", m_sourceAttrValue));

      SequenceDef def = FACTORY.createSequenceDef ();
      def.setBound (bound);

      // TODO: check for unknown type?
      def.setType (type);

      m_bound = null;

      return def;
   }

}
