/*
 * COPYRIGHT NOTICE The information contained herein and which follows is
 * proprietary information and is the property of PrismTech Corporation. This
 * information is not to be divulged, released, copied, reproduced, or conveyed
 * to unauthorized personnel, companies, or other institutions without the
 * direct and expressed approval in writing of PrismTech Corporation. DISCLAIMER
 * Neither PrismTech Limited nor PrismTech Corporation ("PrismTech") are under
 * any obligation to support the use of this code which is provided without
 * warranty of any kind. PrismTech shall (except as otherwise prohibited by law)
 * have no liability whatsoever in relation to its use.
 */

package com.prismtech.idt.imports.idl.internal.importer.builderutil;

import java.util.ArrayList;
import java.util.List;

import com.prismtech.idt.idlmm.Expression;
import com.prismtech.idt.idlmm.UnionDef;
import com.prismtech.idt.imports.idl.parser.IdlParserAST;


/**
 * @since 26.07.2007 - 16:19:30
 * @author Aleksey Yashchenko
 * @version $Revision: 1.3 $
 * @version $Revision: 1.3 $
 */
public class UnionDeclPropertiesHolder extends ContainerTypeHolder implements ExpressionOperable
{
   private List<Expression> m_labels = new ArrayList<Expression> ();

   private List<IdlParserAST> m_caseASTs = new ArrayList<IdlParserAST> ();

   public UnionDeclPropertiesHolder (String name, String sourceValue, IdlParserAST... ast)
   {
      super (name, ContainerType.UNION, sourceValue, ast);
   }

   public UnionDeclPropertiesHolder (UnionDef union, String sourceValue, IdlParserAST... ast)
   {
      super (union, sourceValue, ast);
   }

   public Expression getExpression ()
   {
      throw new AbstractMethodError ("Not implemented");
   }

   public void setExpression (Expression expr)
   {
      if (expr != null)
      {
         m_labels.add (expr);
      }
   }

   public List<Expression> getCurrentLabels ()
   {
      return m_labels;
   }

   public void endUnionMember ()
   {
      m_labels.clear ();
      m_caseASTs.clear ();
   }

   public void addCaseAST (IdlParserAST ast)
   {
      m_caseASTs.add (ast);
   }

   public IdlParserAST[] getCaseASTs ()
   {
      return m_caseASTs.toArray (new IdlParserAST[m_caseASTs.size ()]);
   }
}
