/*
 * COPYRIGHT NOTICE The information contained herein and which follows is
 * proprietary information and is the property of PrismTech Corporation. This
 * information is not to be divulged, released, copied, reproduced, or conveyed
 * to unauthorized personnel, companies, or other institutions without the
 * direct and expressed approval in writing of PrismTech Corporation. DISCLAIMER
 * Neither PrismTech Limited nor PrismTech Corporation ("PrismTech") are under
 * any obligation to support the use of this code which is provided without
 * warranty of any kind. PrismTech shall (except as otherwise prohibited by law)
 * have no liability whatsoever in relation to its use.
 */

package com.prismtech.idt.imports.idl.internal.importer.builderutil;

/**
 * @author Yuriy Kravchenko
 */

import java.util.Collections;
import java.util.List;

import com.prismtech.idt.idlmm.IDLType;
import com.prismtech.idt.idlmm.IRObject;
import com.prismtech.idt.idlmm.ValueBoxDef;
import com.prismtech.idt.imports.idl.parser.IdlParserAST;


public class ValueBoxDclPropertiesHolder extends TypeDeclarationPropertiesHolder
{
   private String m_name;

   private TypePropertiesHolder m_typeHolder;

   public ValueBoxDclPropertiesHolder (TypePropertiesHolder typeHolder, IdlParserAST id, IdlParserAST ast)
   {
      super (ast, id);
      this.m_name = id.getText ();
      this.m_typeHolder = typeHolder;
   }

   @Override
   public List<IRObject> getDefinitions ()
   {
      if (this.m_definitions == null)
      {
         this.m_definitions = Collections.singletonList (this.createDefinition ());
      }

      return this.m_definitions;
   }

   @Override
   public IRObject getDefinition ()
   {
      if (this.m_definitions == null)
      {
         this.m_definitions = Collections.singletonList (this.createDefinition ());
      }
      return this.m_definitions.get (0);
   }

   @Override
   protected IRObject createDefinition ()
   {
      ValueBoxDef def = FACTORY.createValueBoxDef ();
      def.setName (m_name);
      def.setType ((IDLType) m_typeHolder.getDefinition ());
      return def;
   }

   @Override
   public String toString ()
   {
      return super.toString () + " " + String.valueOf (m_declarators);
   }

}
