/*
 * COPYRIGHT NOTICE The information contained herein and which follows is proprietary information
 * and is the property of PrismTech Corporation. This information is not to be divulged, released,
 * copied, reproduced, or conveyed to unauthorized personnel, companies, or other institutions
 * without the direct and expressed approval in writing of PrismTech Corporation. DISCLAIMER Neither
 * PrismTech Limited nor PrismTech Corporation ("PrismTech") are under any obligation to support the
 * use of this code which is provided without warranty of any kind. PrismTech shall (except as
 * otherwise prohibited by law) have no liability whatsoever in relation to its use.
 */
package com.prismtech.idt.imports.idl.parser;

/**
 * This interface describes the IDLPragma object. It contains file name, column and line numbers and
 * text of the corresponding pragma.
 */
public interface IIdlPragma
{
   /**
    * File name.<br/>
    * 
    * @return <code>{@link String}</code>
    */
   public String getFilename ();

   /**
    * Line number.<br/>
    * 
    * @return line number
    */
   public int getLine ();

   /**
    * Column number.<br/>
    * 
    * @return
    */
   public int getColumn ();

   /**
    * Pragma text.<br/>
    * 
    * @return <code>{@link String}</code>
    */
   public String getText ();

   /**
    * Pragma type.<br/>
    * 
    * @return <code>{@link String}</code>
    */
   public String getType ();

}
