package com.prismtech.idt.imports.idl.parser;

import antlr.CommonAST;
import antlr.Token;
import antlr.collections.AST;


/**
 * Extends the ANTLR {@link CommonAST} class to store {@link #getFilename() filename},
 * {@link #getLine() line} and {@link #getColumn() column} number information.
 */
public class IdlParserAST extends CommonAST
{
   private String m_filename;

   private int m_line;

   private int m_column;


   public IdlParserAST ()
   {
      super ();

      this.m_filename = "";
      this.m_line = -1;
      this.m_column = -1;
   }

   public IdlParserAST (Token arg0)
   {
      super (arg0);

      this.m_filename = arg0.getFilename ();
      this.m_line = arg0.getLine ();
      this.m_column = arg0.getColumn ();
   }

   @Override
   public IdlParserAST getFirstChild ()
   {
      return (IdlParserAST) super.getFirstChild ();
   }

   @Override
   public IdlParserAST getNextSibling ()
   {
      return (IdlParserAST) super.getNextSibling ();
   }

   public void initialize (AST arg0)
   {
      super.initialize (arg0);

      if (arg0 instanceof IdlParserAST)
      {
         this.m_filename = ((IdlParserAST) arg0).getFilename ();
         this.m_line = ((IdlParserAST) arg0).getLine ();
         this.m_column = ((IdlParserAST) arg0).getColumn ();
      }
   }

   public void initialize (Token arg0)
   {
      super.initialize (arg0);

      this.m_filename = arg0.getFilename ();
      this.m_line = arg0.getLine ();
      this.m_column = arg0.getColumn ();
   }

   public String getFilename ()
   {
      return m_filename;
   }

   public void setFilename (String filename)
   {
      m_filename = filename;
   }

   public int getLine ()
   {
      return this.m_line;
   }

   public int getColumn ()
   {
      return this.m_column;
   }
}
