package com.prismtech.idt.imports.idl.parser.util;

import java.io.PrintStream;

import com.prismtech.idt.imports.idl.parser.IdlParserAST;


public class ASTDumper
{
   public static void dump (PrintStream str, IdlParserAST ast)
   {
      dump (str, "", ast);
   }

   private static void dump (PrintStream str, String indent, IdlParserAST ast)
   {
      if (ast == null)
      {
         str.print (indent);
         str.println ("null");
      }
      else
      {

         str.print (indent);
         str.print ("[" + ast.getType () + "] \"" + ast.getText () + "\"");
         str.println (" : " + ast.getFilename () + " (" + ast.getLine () + ":" + ast.getColumn () + ")");

         IdlParserAST child = ast.getFirstChild ();

         while (child != null)
         {
            dump (str, indent + "  ", child);
            child = child.getNextSibling ();
         }
      }
   }

   public static void fullDump (PrintStream str, IdlParserAST ast)
   {
      fullDump (str, "", ast);
   }

   private static void fullDump (PrintStream str, String indent, IdlParserAST ast)
   {
      if (ast == null)
      {
         str.print (indent);
         str.println ("null");
      }
      else
      {

         str.print (indent);
         str.print ("[" + ast.getType () + "] \"" + ast.getText () + "\"");
         str.println (" : " + ast.getFilename () + " (" + ast.getLine () + ":" + ast.getColumn () + ")");

         IdlParserAST child = ast.getFirstChild ();
         while (child != null)
         {
            fullDump (str, indent + "  ", child);
            child = child.getNextSibling ();
         }
      }
   }
}
