// $ANTLR 2.7.7 (2006-11-01): "CppLexer.g" -> "CppLexer.java"$

  package com.prismtech.idt.imports.idl.internal.preprocessor;

import java.io.InputStream;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.TokenStreamRecognitionException;
import antlr.CharStreamException;
import antlr.CharStreamIOException;
import antlr.ANTLRException;
import java.io.Reader;
import java.util.Hashtable;
import antlr.CharScanner;
import antlr.InputBuffer;
import antlr.ByteBuffer;
import antlr.CharBuffer;
import antlr.Token;
import antlr.CommonToken;
import antlr.RecognitionException;
import antlr.NoViableAltForCharException;
import antlr.MismatchedCharException;
import antlr.TokenStream;
import antlr.ANTLRHashString;
import antlr.LexerSharedInputState;
import antlr.collections.impl.BitSet;
import antlr.SemanticException;

  import java.io.*;
  import java.util.*;
  import antlr.*;
  import com.prismtech.idt.imports.idl.preprocessor.IIdlPreprocessor;
  import com.prismtech.idt.imports.idl.preprocessor.IIdlPreprocessorStatus;

public class CppLexer extends antlr.CharScanner implements CppLexerTokenTypes, TokenStream
 {

  private List<IIdlPreprocessorStatus> m_status = new ArrayList<IIdlPreprocessorStatus> ();
  
  protected TokenStreamSelector selector;
  protected Integer ifState = 1; // -1: no-else false, 0: false, 1: true
  protected List<Integer> ifStates = new ArrayList<Integer>(); // holds nested if conditions
  protected List<File> includePath = new ArrayList<File>();
  protected List<PreprocessorFile> openFiles = new ArrayList<PreprocessorFile>();
  protected Map<String, List<String>> defines    = new HashMap<String, List<String>>(); // holds the defines
  protected Map<String, List<String>> defineArgs = new HashMap<String, List<String>>(); // holds the args for a macro call
  protected Map<File, List<File>> dependencies   = new HashMap<File, List<File>>();
  protected boolean stripComments    = true;
  protected boolean generateHashLine = true;
  protected boolean processIncludes  = true;
  protected boolean inIncludeFile    = false;
  protected boolean concat = false;
  protected boolean inMacro = false;
  protected String escaped = "";
  protected String stripped = "";
  protected PreprocessorFile currentFile;
  protected File baseDir;
  protected CppLexer parent;
  
  public CppLexer(PreprocessorFile file, File baseDir, Map<File, List<File>> dependencies, boolean generateHashLine) throws FileNotFoundException
  {
    this(file.getInputStream());
    this.setFilename(file.getOriginalPath());
    this.currentFile = file;
    this.openFiles.add(currentFile);
    this.baseDir = baseDir;
    if(dependencies != null)
      this.dependencies = dependencies;
    this.dependencies.put(file.getOriginalFile(), new ArrayList<File>());
    this.generateHashLine = generateHashLine;

    selector = new TokenStreamSelector();
    selector.select(this);
    String line = "# " + getLine() + " \"" + getFilename() + "\"\n";
    CppLexer sublexer = new CppLexer(line, this);
    selector.push(sublexer);
  }
  
  private CppLexer(String str, CppLexer parent)
  {
    this(new ByteArrayInputStream(str.getBytes()));
    this.selector = parent.selector;
    this.ifState = parent.ifState;
    this.ifStates = parent.ifStates;
    this.defines = parent.defines;
    this.defineArgs = parent.defineArgs;
    this.stripComments = parent.stripComments;
    this.generateHashLine = parent.generateHashLine;
    this.processIncludes = parent.processIncludes;
    this.inIncludeFile = parent.inIncludeFile;
    this.inMacro = parent.inMacro;
    this.m_status = parent.m_status;
    selector.push(this);
  }
  
  private CppLexer(PreprocessorFile file, CppLexer parent) throws FileNotFoundException
  {
    this(file.getInputStream());
    this.setFilename(file.getOriginalPath());
    this.dependencies = parent.dependencies;
    dependencies.put(file.getOriginalFile(), new ArrayList<File>());
    this.currentFile = file;
    this.openFiles = parent.openFiles;
    this.openFiles.add(currentFile);
    this.baseDir = parent.baseDir;

    this.includePath = parent.includePath;
    this.selector = parent.selector;
    this.ifState = parent.ifState;
    this.ifStates = parent.ifStates;
    this.defines = parent.defines;
    this.stripComments = parent.stripComments;
    this.generateHashLine = parent.generateHashLine;
    this.processIncludes = parent.processIncludes;
    this.inIncludeFile = true;
    this.m_status = parent.m_status;
    this.parent = parent;
    
    if(cycleCheck(file))
    {
      m_status.add(new PreprocessorStatus(parent, IIdlPreprocessorStatus.ERROR, "Cycle in includes; " + file + " included with itself", null));
    }
    else  
    {
      selector.push(this);
      String line = "# " + getLine() + " \"" + getFilename() + "\" 1\n";
      CppLexer sublexer = new CppLexer(line, this);
    }
  }
  
  private boolean cycleCheck(PreprocessorFile file)
  {
    if(parent == null)
      return false;
    else if(parent.currentFile.equals(file))
      return true;
    else
      return parent.cycleCheck(file);
  }
  
  private void include(String name)
  {
    PreprocessorFile toInclude = null;
    File temp = null;
    File currentDir = null;
        
    //Evaluate included file against directory containing the current file
    String currentFilePath = currentFile.getOriginalPath();
    if(currentFilePath.contains("/"))
    {
      currentDir = new File(currentFilePath.substring(0, currentFilePath.lastIndexOf("/"))); 
    }
    temp = new File(currentDir, name);
    if(currentDir != null && currentDir.isAbsolute())
    {
      toInclude = new PreprocessorFile(null, temp.getPath());
    }
    else
    {
      toInclude = new PreprocessorFile(baseDir, temp.getPath());
    }
        
    //Search include paths for included file
    if(!toInclude.exists())
    {       
      for(File dir:includePath)
      {
        temp = new File(dir, name);
        if(dir.isAbsolute())
        {
          toInclude = new PreprocessorFile(null, temp.getPath());
        }
        else
        {
          toInclude = new PreprocessorFile(baseDir, temp.getPath());
        }
          
        if(toInclude.exists())
        {    
          break;
        }
      }
    }
 
    List<File> deps = dependencies.get(currentFile.getOriginalFile());
    deps.add(toInclude.getOriginalFile());        
    try
    {  
      String line = "# " + getLine() + " \"" + getFilename() + "\" 2\n";
      CppLexer sublexer = new CppLexer(line, this);
      sublexer = new CppLexer(toInclude, this);
    } 
    catch (FileNotFoundException fnf) 
    {
      setLine(getLine()-1);
      reportError("Could not find file " + name);
      newline();
    }
  }
  
  public void close()
  {
    for(PreprocessorFile toClose : openFiles)
    {
      toClose.close();
    }
  }
  
  public void setTokenStreamSelector(TokenStreamSelector selector)
  {
    this.selector = selector;
  }

  public void setProcessIncludes(boolean processIncludes)
  {
    this.processIncludes = processIncludes;
  }
  
  public void setCurrentFile(PreprocessorFile currentFile)
  {
   this.currentFile = currentFile;
  }
  
  public void setDefines(Map defines)
  {
    this.defines = defines;
  }
  
  public void setDependencies(Map dependencies)
  {
    this.dependencies = dependencies;
  }
  
  public void setIncludePath(List includePath)
  {
    this.includePath = includePath;
  }
  
  public void setBaseDir(File baseDir)
  {
   this.baseDir = baseDir;
  }
  
  public void setStripComments(boolean stripComments)
  {
    this.stripComments = stripComments;
  }
  
  public Map<File, List<File>> getDependencies()
  {
    return dependencies;
  }

  public boolean evaluateExpression(String expr) throws TokenStreamException, RecognitionException, PreprocessorException
  {
    //Perform macro substitution on the expression
    expr = subLex(expr);
    //Parse the expression
    ExpLexer lexer = new ExpLexer(new ByteArrayInputStream(expr.getBytes()));
    ExpParser parser = new ExpParser(this, lexer);
    IIdlPreprocessorStatus parseStatus = parser.parse();

    if(!parseStatus.isOK())
    {
      m_status.add(parseStatus);
      throw new PreprocessorException();
    }

    //Evaluate the expression
    ExpTreeParser treeParser = new ExpTreeParser(this);
    boolean result = treeParser.expression(parser.getAST());
    IIdlPreprocessorStatus treeParseStatus = treeParser.getStatus();

    if(!treeParseStatus.isOK())
    {
      m_status.add(treeParseStatus);
      throw new PreprocessorException();
    }

    return result;
  }
  
  public String subLex(String str) throws TokenStreamException, RecognitionException, PreprocessorException
  {
   CppLexer cppLexer = new CppLexer(new ByteArrayInputStream(str.getBytes()));
    cppLexer.defines = defines;
    cppLexer.selector = new TokenStreamSelector();
    cppLexer.selector.select(cppLexer);  
    
    IIdlPreprocessorStatus cppStatus = cppLexer.getStatus();
    if(!cppStatus.isOK())
    {
      m_status.add(cppStatus);
      throw new PreprocessorException();
    }

    str = "";
    for (;;)
    {
      Token t = cppLexer.getNextToken();
      if (t.getType() == Token.EOF_TYPE)
      {
        break;
      }
      str += t.getText();
    }
   return str;
  }
  
  public void consumeConditionBody() throws TokenStreamException
  {
   String consumed = "";
   int lineNo = getLine();
   for (;;) 
    {
      try 
      {
       consumeUntil('#');
        Token t = selector.nextToken();
        if (t.getType() == ENDIF || t.getType() == EOF) 
        {
          break;
        }
      }
      catch (ANTLRException r) 
      {
        // just continue if someone tried retry
      }
    } 
    for(int i = lineNo; i < getLine(); i++)
    {
     consumed += "\n";
    }
    CppLexer subLexer = new CppLexer(consumed, this);    
  }

  public Token getNextToken() throws TokenStreamException
  {
   try
   {
     Token t = selector.nextToken();
     return t;
   }
    catch (TokenStreamException e)
    {
      m_status.add(new PreprocessorStatus(this, IIdlPreprocessorStatus.ERROR, e.getMessage(), e));
      throw e;
    }
  }
  
  public void uponEOF() throws TokenStreamException
  {
    try 
    {
      selector.pop(); // return to old lexer/stream
      selector.retry();
    } 
    catch (NoSuchElementException e) 
    {
      // return a real EOF if nothing in stack
    }
    if(ifStates.size() != 0)
    {
      ifStates.remove(ifStates.size()-1);
      reportError("Reached EOF expecting #endif");
    }
  }
  
  public IIdlPreprocessorStatus getStatus()
  {
    switch (m_status.size())
    {
      case 0 :
      {
        return new PreprocessorStatus(IIdlPreprocessorStatus.OK);
      }
      case 1 :
      {
        return m_status.get(0);
      }
      default :
      {
        PreprocessorStatus status = new PreprocessorStatus();
        for (IIdlPreprocessorStatus s : m_status)
          status.add (s);
        return status;
      }
    }
  } 
  
  @Override
  public void reportError(RecognitionException recex)
  {
    m_status.add(new PreprocessorStatus(this, IIdlPreprocessorStatus.ERROR, recex.getMessage(), recex));
  }
  
  @Override
  public void reportError(String message)
  {
    m_status.add(new PreprocessorStatus(this, IIdlPreprocessorStatus.ERROR, message, null));
  }
  
  @Override
  public void reportWarning(String message)
  {
    m_status.add(new PreprocessorStatus(this, IIdlPreprocessorStatus.WARNING, message, null));
  }
public CppLexer(InputStream in) {
 this(new ByteBuffer(in));
}
public CppLexer(Reader in) {
 this(new CharBuffer(in));
}
public CppLexer(InputBuffer ib) {
 this(new LexerSharedInputState(ib));
}
public CppLexer(LexerSharedInputState state) {
 super(state);
 caseSensitiveLiterals = true;
 setCaseSensitive(true);
 literals = new Hashtable();
}

public Token nextToken() throws TokenStreamException {
 Token theRetToken=null;
tryAgain:
 for (;;) {
  Token _token = null;
  int _ttype = Token.INVALID_TYPE;
  resetText();
  try {   // for char stream error handling
   try {   // for lexical error handling
    switch ( LA(1)) {
    case '#':
    {
     mDIRECTIVE(true);
     theRetToken=_returnToken;
     break;
    }
    case '\t':  case '\u000c':  case ' ':  case '!':
    case '"':  case '$':  case '%':  case '&':
    case '\'':  case '(':  case ')':  case '*':
    case '+':  case ',':  case '-':  case '.':
    case '/':  case '0':  case '1':  case '2':
    case '3':  case '4':  case '5':  case '6':
    case '7':  case '8':  case '9':  case ':':
    case ';':  case '<':  case '=':  case '>':
    case '?':  case '@':  case '[':  case '\\':
    case ']':  case '^':  case '`':  case '{':
    case '|':  case '}':  case '~':
    {
     mNON_DIRECTIVE(true);
     theRetToken=_returnToken;
     break;
    }
    default:
     if ((LA(1)=='d') && (LA(2)=='e') && (LA(3)=='f') && (LA(4)=='i') && (LA(5)=='n') && (LA(6)=='e') && (LA(7)=='d') && (_tokenSet_0.member(LA(8))) && (_tokenSet_1.member(LA(9)))) {
      mDEFINED(true);
      theRetToken=_returnToken;
     }
     else if ((LA(1)=='\n'||LA(1)=='\r') && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true)) {
      mNL(true);
      theRetToken=_returnToken;
     }
     else if ((_tokenSet_2.member(LA(1))) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true)) {
      mIDENTIFIER(true);
      theRetToken=_returnToken;
     }
     else if ((LA(1)=='\r') && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true)) {
      mCR(true);
      theRetToken=_returnToken;
     }
    else {
     if (LA(1)==EOF_CHAR) {uponEOF(); _returnToken = makeToken(Token.EOF_TYPE);}
    else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
    }
    }
    if ( _returnToken==null ) continue tryAgain; // found SKIP token
    _ttype = _returnToken.getType();
    _returnToken.setType(_ttype);
    return _returnToken;
   }
   catch (RecognitionException e) {
    throw new TokenStreamRecognitionException(e);
   }
  }
  catch (CharStreamException cse) {
   if ( cse instanceof CharStreamIOException ) {
    throw new TokenStreamIOException(((CharStreamIOException)cse).io);
   }
   else {
    throw new TokenStreamException(cse.getMessage());
   }
  }
 }
}

 public final void mDIRECTIVE(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = DIRECTIVE;
  int _saveIndex;
  Token hashExpr=null;
  Token includeFile=null;
  Token defineMacro=null;
  Token defineArg0=null;
  Token defineArg1=null;
  Token defineText=null;
  Token undefMacro=null;
  Token ifMacro=null;
  Token ifExpr=null;
  Token expr=null;
  Token ln=null;
  Token file=null;
  Token errMsg=null;
  Token warnMsg=null;
  Token pragma=null;
  Token l=null;
  Token f=null;
  Token flag=null;
  
  List<String> args = new ArrayList<String>();
  boolean condition = true;
  
  
  _saveIndex=text.length();
  match("#");
  text.setLength(_saveIndex);
  {
  if ((_tokenSet_3.member(LA(1))) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true)) {
   {
   _loop6:
   do {
    if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ')) {
     mWS(false);
    }
    else {
     break _loop6;
    }
    
   } while (true);
   }
   {
   switch ( LA(1)) {
   case 'd':
   {
    match("define");
    {
    int _cnt13=0;
    _loop13:
    do {
     if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ')) {
      mWS(false);
     }
     else {
      if ( _cnt13>=1 ) { break _loop13; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
     }
     
     _cnt13++;
    } while (true);
    }
    mRAW_IDENTIFIER(true);
    defineMacro=_returnToken;
    {
    _loop15:
    do {
     if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ') && (_tokenSet_4.member(LA(2))) && (true) && (true) && (true) && (true) && (true) && (true) && (true)) {
      mWS(false);
     }
     else {
      break _loop15;
     }
     
    } while (true);
    }
    args.add("");
    {
    switch ( LA(1)) {
    case '\t':  case '\u000c':  case ' ':  case '(':
    {
     {
     switch ( LA(1)) {
     case '(':
     {
      match('(');
      {
      _loop19:
      do {
       if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ')) {
        mWS(false);
       }
       else {
        break _loop19;
       }
       
      } while (true);
      }
      mRAW_IDENTIFIER(true);
      defineArg0=_returnToken;
      {
      _loop21:
      do {
       if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ')) {
        mWS(false);
       }
       else {
        break _loop21;
       }
       
      } while (true);
      }
      args.add(defineArg0.getText());
      {
      _loop27:
      do {
       if ((LA(1)==',')) {
        mCOMMA(false);
        {
        _loop24:
        do {
         if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ')) {
          mWS(false);
         }
         else {
          break _loop24;
         }
         
        } while (true);
        }
        mRAW_IDENTIFIER(true);
        defineArg1=_returnToken;
        {
        _loop26:
        do {
         if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ')) {
          mWS(false);
         }
         else {
          break _loop26;
         }
         
        } while (true);
        }
        args.add(defineArg1.getText());
       }
       else {
        break _loop27;
       }
       
      } while (true);
      }
      match(')');
      break;
     }
     case '\t':  case '\u000c':  case ' ':
     {
      mWS(false);
      break;
     }
     default:
     {
      throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
     }
     }
     }
     {
     _loop29:
     do {
      if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ') && ((LA(2) >= '\u0003' && LA(2) <= '\u00ff')) && ((LA(3) >= '\u0003' && LA(3) <= '\u00ff')) && (true) && (true) && (true) && (true) && (true) && (true)) {
       mWS(false);
      }
      else {
       break _loop29;
      }
      
     } while (true);
     }
     mMACRO_TEXT(true);
     defineText=_returnToken;
     args.set(0,defineText.getText());
     break;
    }
    case '\n':  case '\r':
    {
     break;
    }
    default:
    {
     throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
    }
    }
    }
    mNL(false);
    
    if (ifState==1) 
    {
    defines.put( defineMacro.getText(), args );
    }
    text.setLength(_begin); text.append("\n" + escaped);
    escaped = "";
    
    break;
   }
   case 'u':
   {
    match("undef");
    {
    int _cnt31=0;
    _loop31:
    do {
     if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ')) {
      mWS(false);
     }
     else {
      if ( _cnt31>=1 ) { break _loop31; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
     }
     
     _cnt31++;
    } while (true);
    }
    mRAW_IDENTIFIER(true);
    undefMacro=_returnToken;
    {
    _loop33:
    do {
     if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ')) {
      mWS(false);
     }
     else {
      break _loop33;
     }
     
    } while (true);
    }
    mDNL(false);
    
    if (ifState==1) 
    {
    defines.remove(undefMacro.getText());
    }
    text.setLength(_begin); text.append("\n");
    
    break;
   }
   case 'l':
   {
    match("line");
    {
    int _cnt49=0;
    _loop49:
    do {
     if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ')) {
      mWS(false);
     }
     else {
      if ( _cnt49>=1 ) { break _loop49; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
     }
     
     _cnt49++;
    } while (true);
    }
    mNUMBER(true);
    ln=_returnToken;
    {
    if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ') && (_tokenSet_5.member(LA(2))) && ((LA(3) >= '\u0003' && LA(3) <= '\u00ff')) && ((LA(4) >= '\u0003' && LA(4) <= '\u00ff')) && (true) && (true) && (true) && (true) && (true)) {
     {
     int _cnt52=0;
     _loop52:
     do {
      if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ')) {
       mWS(false);
      }
      else {
       if ( _cnt52>=1 ) { break _loop52; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
      }
      
      _cnt52++;
     } while (true);
     }
     mSTRING(true);
     file=_returnToken;
    }
    else if ((_tokenSet_6.member(LA(1))) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true)) {
    }
    else {
     throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
    }
    
    }
    {
    _loop54:
    do {
     if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ')) {
      mWS(false);
     }
     else {
      break _loop54;
     }
     
    } while (true);
    }
    mDNL(false);
    
    if(ifState==1)
    {
    _ttype = Token.SKIP;
    String line = "# " + ln.getText();
    if(file != null)
    {
    String filename = file.getText();
    line += " " + filename;
    setFilename(filename.substring(1,filename.length()-1));
    }
    else
    {
    line += " \"" + getFilename() + "\"";
    }
    line += "\n";
    setLine(Integer.parseInt(ln.getText()));
    
    CppLexer subLexer = new CppLexer(line, this);
    selector.retry();
    }
    
    break;
   }
   case 'w':
   {
    match("warning");
    {
    int _cnt58=0;
    _loop58:
    do {
     if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ') && ((LA(2) >= '\u0003' && LA(2) <= '\u00ff')) && ((LA(3) >= '\u0003' && LA(3) <= '\u00ff')) && (true) && (true) && (true) && (true) && (true) && (true)) {
      mWS(false);
     }
     else {
      if ( _cnt58>=1 ) { break _loop58; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
     }
     
     _cnt58++;
    } while (true);
    }
    mMACRO_TEXT(true);
    warnMsg=_returnToken;
    mNL(false);
    
    if(ifState == 1)
    {
    text.setLength(_begin); text.append("\n" + escaped);
    escaped = "";
    reportWarning(warnMsg.getText());
    }
    
    break;
   }
   case 'p':
   {
    match("pragma");
    {
    int _cnt60=0;
    _loop60:
    do {
     if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ') && ((LA(2) >= '\u0003' && LA(2) <= '\u00ff')) && ((LA(3) >= '\u0003' && LA(3) <= '\u00ff')) && (true) && (true) && (true) && (true) && (true) && (true)) {
      mWS(false);
     }
     else {
      if ( _cnt60>=1 ) { break _loop60; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
     }
     
     _cnt60++;
    } while (true);
    }
    mMACRO_TEXT(true);
    pragma=_returnToken;
    mNL(false);
    
    if(inIncludeFile && !processIncludes)
    {
    _ttype = Token.SKIP;
    }
    else
    {
    try
    {
    String pText = pragma.getText() + '\n';
    text.setLength(_begin); text.append("#pragma " + subLex(pText));
    }
    catch(PreprocessorException e)
    {
    //Status already updated ignore error and continue
    text.setLength(_begin); text.append('\n');
    }
    }
    
    break;
   }
   case '0':  case '1':  case '2':  case '3':
   case '4':  case '5':  case '6':  case '7':
   case '8':  case '9':
   {
    mNUMBER(true);
    l=_returnToken;
    {
    int _cnt62=0;
    _loop62:
    do {
     if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ')) {
      mWS(false);
     }
     else {
      if ( _cnt62>=1 ) { break _loop62; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
     }
     
     _cnt62++;
    } while (true);
    }
    mSTRING(true);
    f=_returnToken;
    {
    if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ') && (_tokenSet_7.member(LA(2))) && (_tokenSet_8.member(LA(3))) && (true) && (true) && (true) && (true) && (true) && (true)) {
     {
     int _cnt65=0;
     _loop65:
     do {
      if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ')) {
       mWS(false);
      }
      else {
       if ( _cnt65>=1 ) { break _loop65; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
      }
      
      _cnt65++;
     } while (true);
     }
     mNUMBER(true);
     flag=_returnToken;
    }
    else if ((_tokenSet_6.member(LA(1))) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true)) {
    }
    else {
     throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
    }
    
    }
    {
    _loop67:
    do {
     if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ')) {
      mWS(false);
     }
     else {
      break _loop67;
     }
     
    } while (true);
    }
    mDNL(false);
    
    if(!generateHashLine) 
    {
    text.setLength(_begin); text.append('\n');
    }
    else
    {
    String fl = (flag == null) ? "" : " " + flag.getText();
    text.setLength(_begin); text.append("# " + l.getText() + " " + f.getText() + fl+ '\n');
    }
    
    break;
   }
   case '\n':  case '\r':  case '/':
   {
    mDNL(false);
    
    text.setLength(_begin); text.append('\n');
    
    break;
   }
   default:
    if ((LA(1)=='i') && (LA(2)=='f') && (LA(3)=='d'||LA(3)=='n')) {
     {
     if ((LA(1)=='i') && (LA(2)=='f') && (LA(3)=='d')) {
      match("ifdef");
     }
     else if ((LA(1)=='i') && (LA(2)=='f') && (LA(3)=='n')) {
      match("ifndef");
      condition=false;
     }
     else {
      throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
     }
     
     }
     {
     int _cnt36=0;
     _loop36:
     do {
      if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ')) {
       mWS(false);
      }
      else {
       if ( _cnt36>=1 ) { break _loop36; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
      }
      
      _cnt36++;
     } while (true);
     }
     mRAW_IDENTIFIER(true);
     ifMacro=_returnToken;
     {
     _loop38:
     do {
      if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ')) {
       mWS(false);
      }
      else {
       break _loop38;
      }
      
     } while (true);
     }
     mDNL(false);
     
     ifStates.add(ifState);
     if (ifState==1) 
     {
     condition = (defines.containsKey(ifMacro.getText())==condition);
     ifState = condition?1:0;
     }
     else 
     {
     ifState = -1;
     }
     if (ifState==1) 
     {
     text.setLength(_begin); text.append("\n");
     } 
     else 
     {
     // gobble up tokens until ENDIF (could be caused by else)
     consumeConditionBody();
     }
     
    }
    else if ((LA(1)=='i') && (LA(2)=='f') && (LA(3)=='\t'||LA(3)=='\u000c'||LA(3)==' ')) {
     match("if");
     {
     int _cnt40=0;
     _loop40:
     do {
      if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ') && ((LA(2) >= '\u0003' && LA(2) <= '\u00ff')) && ((LA(3) >= '\u0003' && LA(3) <= '\u00ff')) && (true) && (true) && (true) && (true) && (true) && (true)) {
       mWS(false);
      }
      else {
       if ( _cnt40>=1 ) { break _loop40; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
      }
      
      _cnt40++;
     } while (true);
     }
     mMACRO_TEXT(true);
     ifExpr=_returnToken;
     mNL(false);
     
     ifStates.add(ifState);
     if (ifState==1) 
     {
     try
     {
     condition = evaluateExpression(ifExpr.getText());;
     ifState = condition?1:0;
     }
     catch(PreprocessorException p)
     {
     // failed to evaluate expression set ifState so the rest of the ifstatement is discarded 
     ifState = -1;
     }
     }
     else 
     {
     ifState = -1;
     }
     if (ifState==1) 
     {
     text.setLength(_begin); text.append("\n");
     } 
     else 
     {
     // gobble up tokens until ENDIF (could be caused by else)
     consumeConditionBody();
     } 
     
    }
    else if ((LA(1)=='i') && (LA(2)=='n')) {
     match("include");
     {
     int _cnt9=0;
     _loop9:
     do {
      if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ')) {
       mWS(false);
      }
      else {
       if ( _cnt9>=1 ) { break _loop9; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
      }
      
      _cnt9++;
     } while (true);
     }
     mINCLUDE_STRING(true);
     includeFile=_returnToken;
     {
     _loop11:
     do {
      if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ')) {
       mWS(false);
      }
      else {
       break _loop11;
      }
      
     } while (true);
     }
     mDNL(false);
     
     if (ifState==1)
     {
     _ttype = Token.SKIP;
     String name = includeFile.getText();
     name = name.substring(1,name.length()-1);
     include(name);        
     selector.retry();   
     }       
     
    }
    else if ((LA(1)=='e') && (LA(2)=='l')) {
     {
     if ((LA(1)=='e') && (LA(2)=='l') && (LA(3)=='s')) {
      match("else");
      condition=true;
      {
      _loop43:
      do {
       if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ')) {
        mWS(false);
       }
       else {
        break _loop43;
       }
       
      } while (true);
      }
      mDNL(false);
     }
     else if ((LA(1)=='e') && (LA(2)=='l') && (LA(3)=='i')) {
      match("elif");
      {
      int _cnt45=0;
      _loop45:
      do {
       if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ') && ((LA(2) >= '\u0003' && LA(2) <= '\u00ff')) && ((LA(3) >= '\u0003' && LA(3) <= '\u00ff')) && (true) && (true) && (true) && (true) && (true) && (true)) {
        mWS(false);
       }
       else {
        if ( _cnt45>=1 ) { break _loop45; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
       }
       
       _cnt45++;
      } while (true);
      }
      mMACRO_TEXT(true);
      expr=_returnToken;
      mNL(false);
      
      try
      {
      condition=evaluateExpression(expr.getText());
      }
      catch(PreprocessorException p)
      {
      // failed to evaluate expression set ifState so the rest of the ifstatement is discarded 
      ifState = 1;
      }
      
     }
     else {
      throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
     }
     
     }
     
     if (ifState==1) 
     {
     // previous if/elif was taken - discard rest
     ifState = -1;
     consumeConditionBody();
     } 
     else if (ifState==0 && condition) 
     {
     // "elif" (true) or "else"
     text.setLength(_begin); text.append("\n");
     _ttype = ENDIF;
     ifState = 1;
     }
     
    }
    else if ((LA(1)=='e') && (LA(2)=='n')) {
     match("endif");
     {
     _loop47:
     do {
      if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ')) {
       mWS(false);
      }
      else {
       break _loop47;
      }
      
     } while (true);
     }
     mDNL(false);
     
     condition = (ifState==1);
     try 
     {
     // return to previous if state
     ifState = ifStates.remove(ifStates.size()-1);
     text.setLength(_begin); text.append("\n");
     if (!condition)
     {
     // tell if/else/elif to stop discarding tokens
     _ttype = ENDIF;
     }
     } 
     catch (ArrayIndexOutOfBoundsException e) 
     {
     reportError("#endif without matching #if");
     }
     
    }
    else if ((LA(1)=='e') && (LA(2)=='r')) {
     match("error");
     {
     int _cnt56=0;
     _loop56:
     do {
      if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ') && ((LA(2) >= '\u0003' && LA(2) <= '\u00ff')) && ((LA(3) >= '\u0003' && LA(3) <= '\u00ff')) && (true) && (true) && (true) && (true) && (true) && (true)) {
       mWS(false);
      }
      else {
       if ( _cnt56>=1 ) { break _loop56; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
      }
      
      _cnt56++;
     } while (true);
     }
     mMACRO_TEXT(true);
     errMsg=_returnToken;
     mNL(false);
     
     if(ifState == 1)
     {
     reportError(errMsg.getText());
     }
     
    }
   else {
    throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
   }
   }
   }
  }
  else if (( true )&&( inMacro && LA(1)=='#')) {
   
   concat = true;
   
  }
  else if (( true )&&( inMacro )) {
   {
   _loop4:
   do {
    if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ') && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true)) {
     mWS(false);
    }
    else {
     break _loop4;
    }
    
   } while (true);
   }
   _saveIndex=text.length();
   mEXPR(true);
   text.setLength(_saveIndex);
   hashExpr=_returnToken;
   
   if(ifState == 1)
   {
   if(concat)
   {
   concat = false;
   CppLexer subLexer = new CppLexer(hashExpr.getText(), this);
   }
   else
   {
   CppLexer subLexer = new CppLexer('"' + hashExpr.getText() + '"', this);
   }
   }     
   
  }
  else {
   throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
  }
  
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mWS(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = WS;
  int _saveIndex;
  
  {
  switch ( LA(1)) {
  case ' ':
  {
   match(' ');
   break;
  }
  case '\t':
  {
   match('\t');
   break;
  }
  case '\u000c':
  {
   match('\f');
   break;
  }
  default:
  {
   throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
  }
  }
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mEXPR(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = EXPR;
  int _saveIndex;
  
  {
  if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ') && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true)) {
   mWS(false);
  }
  else {
  }
  
  }
  {
  switch ( LA(1)) {
  case '0':  case '1':  case '2':  case '3':
  case '4':  case '5':  case '6':  case '7':
  case '8':  case '9':
  {
   mNUMBER(false);
   break;
  }
  case 'A':  case 'B':  case 'C':  case 'D':
  case 'E':  case 'F':  case 'G':  case 'H':
  case 'I':  case 'J':  case 'K':  case 'L':
  case 'M':  case 'N':  case 'O':  case 'P':
  case 'Q':  case 'R':  case 'S':  case 'T':
  case 'U':  case 'V':  case 'W':  case 'X':
  case 'Y':  case 'Z':  case '_':  case 'a':
  case 'b':  case 'c':  case 'd':  case 'e':
  case 'f':  case 'g':  case 'h':  case 'i':
  case 'j':  case 'k':  case 'l':  case 'm':
  case 'n':  case 'o':  case 'p':  case 'q':
  case 'r':  case 's':  case 't':  case 'u':
  case 'v':  case 'w':  case 'x':  case 'y':
  case 'z':
  {
   mIDENTIFIER(false);
   break;
  }
  default:
   {
   }
  }
  }
  {
  if ((_tokenSet_9.member(LA(1))) && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true)) {
   {
   switch ( LA(1)) {
   case '(':  case '[':  case '{':
   {
    mLEFT(false);
    mEXPR(false);
    {
    _loop156:
    do {
     if ((LA(1)==',')) {
      mCOMMA(false);
      mEXPR(false);
     }
     else {
      break _loop156;
     }
     
    } while (true);
    }
    mRIGHT(false);
    break;
   }
   case '"':  case '\'':
   {
    mSTRING(false);
    break;
   }
   case '!':  case '$':  case '%':  case '&':
   case '*':  case '+':  case '-':  case '.':
   case '/':  case ':':  case ';':  case '<':
   case '=':  case '>':  case '?':  case '@':
   case '\\':  case '^':  case '`':  case '|':
   case '~':
   {
    mOPERATOR(false);
    break;
   }
   case '\t':  case '\u000c':  case ' ':
   {
    mWS(false);
    break;
   }
   default:
   {
    throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
   }
   }
   }
   mEXPR(false);
  }
  else {
  }
  
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mINCLUDE_STRING(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = INCLUDE_STRING;
  int _saveIndex;
  
  switch ( LA(1)) {
  case '<':
  {
   match('<');
   {
   _loop93:
   do {
    if ((_tokenSet_10.member(LA(1)))) {
     matchNot('>');
    }
    else {
     break _loop93;
    }
    
   } while (true);
   }
   match('>');
   break;
  }
  case '"':  case '\'':
  {
   mSTRING(false);
   break;
  }
  default:
  {
   throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
  }
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mDNL(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = DNL;
  int _saveIndex;
  
  {
  switch ( LA(1)) {
  case '/':
  {
   mCOMMENT(false);
   break;
  }
  case '\n':  case '\r':
  {
   mNL(false);
   break;
  }
  default:
  {
   throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
  }
  }
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mRAW_IDENTIFIER(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = RAW_IDENTIFIER;
  int _saveIndex;
  
  {
  switch ( LA(1)) {
  case 'a':  case 'b':  case 'c':  case 'd':
  case 'e':  case 'f':  case 'g':  case 'h':
  case 'i':  case 'j':  case 'k':  case 'l':
  case 'm':  case 'n':  case 'o':  case 'p':
  case 'q':  case 'r':  case 's':  case 't':
  case 'u':  case 'v':  case 'w':  case 'x':
  case 'y':  case 'z':
  {
   matchRange('a','z');
   break;
  }
  case 'A':  case 'B':  case 'C':  case 'D':
  case 'E':  case 'F':  case 'G':  case 'H':
  case 'I':  case 'J':  case 'K':  case 'L':
  case 'M':  case 'N':  case 'O':  case 'P':
  case 'Q':  case 'R':  case 'S':  case 'T':
  case 'U':  case 'V':  case 'W':  case 'X':
  case 'Y':  case 'Z':
  {
   matchRange('A','Z');
   break;
  }
  case '_':
  {
   match('_');
   break;
  }
  default:
  {
   throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
  }
  }
  }
  {
  _loop116:
  do {
   switch ( LA(1)) {
   case 'a':  case 'b':  case 'c':  case 'd':
   case 'e':  case 'f':  case 'g':  case 'h':
   case 'i':  case 'j':  case 'k':  case 'l':
   case 'm':  case 'n':  case 'o':  case 'p':
   case 'q':  case 'r':  case 's':  case 't':
   case 'u':  case 'v':  case 'w':  case 'x':
   case 'y':  case 'z':
   {
    matchRange('a','z');
    break;
   }
   case 'A':  case 'B':  case 'C':  case 'D':
   case 'E':  case 'F':  case 'G':  case 'H':
   case 'I':  case 'J':  case 'K':  case 'L':
   case 'M':  case 'N':  case 'O':  case 'P':
   case 'Q':  case 'R':  case 'S':  case 'T':
   case 'U':  case 'V':  case 'W':  case 'X':
   case 'Y':  case 'Z':
   {
    matchRange('A','Z');
    break;
   }
   case '_':
   {
    match('_');
    break;
   }
   case '0':  case '1':  case '2':  case '3':
   case '4':  case '5':  case '6':  case '7':
   case '8':  case '9':
   {
    matchRange('0','9');
    break;
   }
   default:
   {
    break _loop116;
   }
   }
  } while (true);
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mCOMMA(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = COMMA;
  int _saveIndex;
  
  match(',');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mMACRO_TEXT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = MACRO_TEXT;
  int _saveIndex;
  
  {
  int _cnt96=0;
  _loop96:
  do {
   // nongreedy exit test
   if ( _cnt96>=1 && (LA(1)=='\n'||LA(1)=='\r') && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true)) break _loop96;
   if ((LA(1)=='\\') && (LA(2)=='\n'||LA(2)=='\r') && ((LA(3) >= '\u0003' && LA(3) <= '\u00ff')) && (true) && (true) && (true) && (true) && (true) && (true)) {
    mESC_NL(false);
   }
   else if (((LA(1) >= '\u0003' && LA(1) <= '\u00ff')) && ((LA(2) >= '\u0003' && LA(2) <= '\u00ff')) && (true) && (true) && (true) && (true) && (true) && (true) && (true)) {
    matchNot(EOF_CHAR);
   }
   else {
    if ( _cnt96>=1 ) { break _loop96; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
   }
   
   _cnt96++;
  } while (true);
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mNL(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = NL;
  int _saveIndex;
  
  {
  switch ( LA(1)) {
  case '\r':
  {
   mCR(false);
   break;
  }
  case '\n':
  {
   break;
  }
  default:
  {
   throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
  }
  }
  }
  match('\n');
  newline();
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mNUMBER(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = NUMBER;
  int _saveIndex;
  
  {
  if ((LA(1)=='0') && (LA(2)=='X'||LA(2)=='x')) {
   mHEX_INT(false);
  }
  else if (((LA(1) >= '1' && LA(1) <= '9'))) {
   mDEC_INT(false);
  }
  else if ((LA(1)=='0') && (true)) {
   mOCT_INT(false);
  }
  else {
   throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
  }
  
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mSTRING(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = STRING;
  int _saveIndex;
  
  switch ( LA(1)) {
  case '"':
  {
   match('"');
   {
   _loop87:
   do {
    if ((LA(1)=='\\')) {
     match('\\');
     matchNot(EOF_CHAR);
    }
    else if ((_tokenSet_11.member(LA(1)))) {
     {
     match(_tokenSet_11);
     }
    }
    else {
     break _loop87;
    }
    
   } while (true);
   }
   match('"');
   break;
  }
  case '\'':
  {
   match('\'');
   {
   _loop90:
   do {
    if ((LA(1)=='\\')) {
     match('\\');
     matchNot(EOF_CHAR);
    }
    else if ((_tokenSet_12.member(LA(1)))) {
     {
     match(_tokenSet_12);
     }
    }
    else {
     break _loop90;
    }
    
   } while (true);
   }
   match('\'');
   break;
  }
  default:
  {
   throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
  }
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mNON_DIRECTIVE(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = NON_DIRECTIVE;
  int _saveIndex;
  
  if(inIncludeFile && !processIncludes)
  _ttype = Token.SKIP;
  
  
  {
  switch ( LA(1)) {
  case '"':  case '\'':
  {
   mSTRING(false);
   break;
  }
  case '0':  case '1':  case '2':  case '3':
  case '4':  case '5':  case '6':  case '7':
  case '8':  case '9':
  {
   mNUMBER(false);
   break;
  }
  case '(':  case '[':  case '{':
  {
   mLEFT(false);
   break;
  }
  case ')':  case ']':  case '}':
  {
   mRIGHT(false);
   break;
  }
  case ',':
  {
   mCOMMA(false);
   break;
  }
  case '\t':  case '\u000c':  case ' ':
  {
   mWS(false);
   break;
  }
  default:
   if ((LA(1)=='/') && (LA(2)=='*'||LA(2)=='/')) {
    mCOMMENT(false);
   }
   else if ((_tokenSet_13.member(LA(1))) && (true)) {
    mOPERATOR(false);
   }
  else {
   throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
  }
  }
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mCOMMENT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = COMMENT;
  int _saveIndex;
  
  {
  if ((LA(1)=='/') && (LA(2)=='/')) {
   match("//");
   {
   _loop110:
   do {
    // nongreedy exit test
    if ((LA(1)=='\n'||LA(1)=='\r') && (true) && (true) && (true) && (true) && (true) && (true) && (true) && (true)) break _loop110;
    if (((LA(1) >= '\u0003' && LA(1) <= '\u00ff')) && ((LA(2) >= '\u0003' && LA(2) <= '\u00ff')) && (true) && (true) && (true) && (true) && (true) && (true) && (true)) {
     matchNot(EOF_CHAR);
    }
    else {
     break _loop110;
    }
    
   } while (true);
   }
   mNL(false);
   if(stripComments || (inIncludeFile && !processIncludes))stripped+="\n";
  }
  else if ((LA(1)=='/') && (LA(2)=='*')) {
   match("/*");
   {
   _loop112:
   do {
    // nongreedy exit test
    if ((LA(1)=='*') && (LA(2)=='/') && (true)) break _loop112;
    if ((LA(1)=='\n'||LA(1)=='\r') && ((LA(2) >= '\u0003' && LA(2) <= '\u00ff')) && ((LA(3) >= '\u0003' && LA(3) <= '\u00ff')) && (true) && (true) && (true) && (true) && (true) && (true)) {
     mNL(false);
     if(stripComments || (inIncludeFile && !processIncludes))stripped+="\n";
    }
    else if (((LA(1) >= '\u0003' && LA(1) <= '\u00ff')) && ((LA(2) >= '\u0003' && LA(2) <= '\u00ff')) && ((LA(3) >= '\u0003' && LA(3) <= '\u00ff')) && (true) && (true) && (true) && (true) && (true) && (true)) {
     matchNot(EOF_CHAR);
     if(stripComments || (inIncludeFile && !processIncludes))stripped+=" ";
    }
    else {
     break _loop112;
    }
    
   } while (true);
   }
   match("*/");
  }
  else {
   throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
  }
  
  }
  
  if(stripComments || (inIncludeFile && !processIncludes))
  {
  text.setLength(_begin); text.append(stripped); 
  stripped="";
  }
  
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mLEFT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = LEFT;
  int _saveIndex;
  
  switch ( LA(1)) {
  case '(':
  {
   match('(');
   break;
  }
  case '[':
  {
   match('[');
   break;
  }
  case '{':
  {
   match('{');
   break;
  }
  default:
  {
   throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
  }
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mRIGHT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = RIGHT;
  int _saveIndex;
  
  switch ( LA(1)) {
  case ')':
  {
   match(')');
   break;
  }
  case ']':
  {
   match(']');
   break;
  }
  case '}':
  {
   match('}');
   break;
  }
  default:
  {
   throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
  }
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mOPERATOR(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = OPERATOR;
  int _saveIndex;
  
  switch ( LA(1)) {
  case '!':
  {
   match('!');
   break;
  }
  case '$':
  {
   match('$');
   break;
  }
  case '%':
  {
   match('%');
   break;
  }
  case '&':
  {
   match('&');
   break;
  }
  case '*':
  {
   match('*');
   break;
  }
  case '+':
  {
   match('+');
   break;
  }
  case '-':
  {
   match('-');
   break;
  }
  case '.':
  {
   match('.');
   break;
  }
  case '/':
  {
   match('/');
   break;
  }
  case ':':
  {
   match(':');
   break;
  }
  case ';':
  {
   match(';');
   break;
  }
  case '<':
  {
   match('<');
   break;
  }
  case '=':
  {
   match('=');
   break;
  }
  case '>':
  {
   match('>');
   break;
  }
  case '?':
  {
   match('?');
   break;
  }
  case '@':
  {
   match('@');
   break;
  }
  case '\\':
  {
   match('\\');
   break;
  }
  case '^':
  {
   match('^');
   break;
  }
  case '`':
  {
   match('`');
   break;
  }
  case '|':
  {
   match('|');
   break;
  }
  case '~':
  {
   match('~');
   break;
  }
  default:
  {
   throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
  }
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mIDENTIFIER(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = IDENTIFIER;
  int _saveIndex;
  Token identifier=null;
  Token callArg0=null;
  Token callArg1=null;
  
  List<String> define = new ArrayList<String>();
  List<String> args = new ArrayList<String>();
  if(inIncludeFile && !processIncludes)
  _ttype = Token.SKIP;
  
  
  mRAW_IDENTIFIER(true);
  identifier=_returnToken;
  
  define = defineArgs.get(identifier.getText());
  if (_createToken && define==null) 
  {
  define = defines.get(identifier.getText());
  }
  
  {
  if (((_tokenSet_14.member(LA(1))) && (_tokenSet_15.member(LA(2))) && (true) && (true) && (true) && (true) && (true) && (true) && (true))&&( (define!=null) && (define.size()>1) )) {
   {
   _loop73:
   do {
    if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ')) {
     mWS(false);
    }
    else {
     break _loop73;
    }
    
   } while (true);
   }
   match('(');
   {
   _loop75:
   do {
    if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ') && (_tokenSet_15.member(LA(2))) && (true) && (true) && (true) && (true) && (true) && (true) && (true)) {
     mWS(false);
    }
    else {
     break _loop75;
    }
    
   } while (true);
   }
   mEXPR(true);
   callArg0=_returnToken;
   args.add(callArg0.getText());
   {
   _loop81:
   do {
    if ((_tokenSet_16.member(LA(1))) && (_tokenSet_15.member(LA(2))) && (true) && (true) && (true) && (true) && (true) && (true) && (true)) {
     {
     _loop78:
     do {
      if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ')) {
       mWS(false);
      }
      else {
       break _loop78;
      }
      
     } while (true);
     }
     mCOMMA(false);
     {
     _loop80:
     do {
      if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ') && (_tokenSet_15.member(LA(2))) && (true) && (true) && (true) && (true) && (true) && (true) && (true)) {
       mWS(false);
      }
      else {
       break _loop80;
      }
      
     } while (true);
     }
     mEXPR(true);
     callArg1=_returnToken;
     args.add(callArg1.getText());
    }
    else {
     break _loop81;
    }
    
   } while (true);
   }
   if (!( args.size()==define.size()-1 ))
     throw new SemanticException(" args.size()==define.size()-1 ");
   {
   _loop83:
   do {
    if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ')) {
     mWS(false);
    }
    else {
     break _loop83;
    }
    
   } while (true);
   }
   match(')');
  }
  else if (( true )&&( !((define!=null) && (define.size()>1)) )) {
  }
  else {
   throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
  }
  
  }
  
  if (define!=null) 
  {
  String defineText = define.get(0);
  if (!_createToken) 
  {
  text.setLength(_begin); text.append(defineText);
  } 
  else 
  {
  for (int i=0;i<args.size();++i) 
  {
  List<String> arg = new ArrayList<String>();
  arg.add(args.get(i));
  defineArgs.put(define.get(1+i), arg);
  }
  inMacro=true;
  CppLexer sublexer = new CppLexer(defineText, this);
  selector.retry();
  inMacro=false;
  }
  }
  
  _ttype = testLiteralsTable(_ttype);
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mESC_NL(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = ESC_NL;
  int _saveIndex;
  
  _saveIndex=text.length();
  match('\\');
  text.setLength(_saveIndex);
  _saveIndex=text.length();
  mNL(false);
  text.setLength(_saveIndex);
  escaped += "\n";
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mCR(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = CR;
  int _saveIndex;
  
  {
  int _cnt105=0;
  _loop105:
  do {
   if ((LA(1)=='\r')) {
    _saveIndex=text.length();
    match('\r');
    text.setLength(_saveIndex);
   }
   else {
    if ( _cnt105>=1 ) { break _loop105; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
   }
   
   _cnt105++;
  } while (true);
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mINT_SUFFIX(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = INT_SUFFIX;
  int _saveIndex;
  
  {
  if ((LA(1)=='l') && (LA(2)=='u')) {
   match("lu");
  }
  else if ((LA(1)=='L') && (LA(2)=='u')) {
   match("Lu");
  }
  else if ((LA(1)=='l') && (LA(2)=='U')) {
   match("lU");
  }
  else if ((LA(1)=='L') && (LA(2)=='U')) {
   match("LU");
  }
  else if ((LA(1)=='u') && (LA(2)=='l')) {
   match("ul");
  }
  else if ((LA(1)=='U') && (LA(2)=='l')) {
   match("Ul");
  }
  else if ((LA(1)=='u') && (LA(2)=='L')) {
   match("uL");
  }
  else if ((LA(1)=='U') && (LA(2)=='L')) {
   match("UL");
  }
  else if ((LA(1)=='l') && (true)) {
   match("l");
  }
  else if ((LA(1)=='L') && (true)) {
   match("L");
  }
  else if ((LA(1)=='u') && (true)) {
   match("u");
  }
  else if ((LA(1)=='U') && (true)) {
   match("U");
  }
  else {
   throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
  }
  
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mDEC_DIGITS(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = DEC_DIGITS;
  int _saveIndex;
  
  {
  matchRange('1','9');
  }
  {
  _loop122:
  do {
   if (((LA(1) >= '0' && LA(1) <= '9'))) {
    matchRange('0','9');
   }
   else {
    break _loop122;
   }
   
  } while (true);
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mHEX_PREFIX(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = HEX_PREFIX;
  int _saveIndex;
  
  match('0');
  {
  switch ( LA(1)) {
  case 'x':
  {
   match('x');
   break;
  }
  case 'X':
  {
   match('X');
   break;
  }
  default:
  {
   throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
  }
  }
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mHEX_DIGITS(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = HEX_DIGITS;
  int _saveIndex;
  
  {
  int _cnt127=0;
  _loop127:
  do {
   switch ( LA(1)) {
   case '0':  case '1':  case '2':  case '3':
   case '4':  case '5':  case '6':  case '7':
   case '8':  case '9':
   {
    matchRange('0','9');
    break;
   }
   case 'a':  case 'b':  case 'c':  case 'd':
   case 'e':  case 'f':
   {
    matchRange('a','f');
    break;
   }
   case 'A':  case 'B':  case 'C':  case 'D':
   case 'E':  case 'F':
   {
    matchRange('A','F');
    break;
   }
   default:
   {
    if ( _cnt127>=1 ) { break _loop127; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
   }
   }
   _cnt127++;
  } while (true);
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mOCT_PREFIX(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = OCT_PREFIX;
  int _saveIndex;
  
  match('0');
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mOCT_DIGITS(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = OCT_DIGITS;
  int _saveIndex;
  
  {
  _loop131:
  do {
   if (((LA(1) >= '0' && LA(1) <= '7'))) {
    matchRange('0','7');
   }
   else {
    break _loop131;
   }
   
  } while (true);
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mDEC_INT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = DEC_INT;
  int _saveIndex;
  
  mDEC_DIGITS(false);
  {
  if ((_tokenSet_17.member(LA(1)))) {
   mINT_SUFFIX(false);
  }
  else {
  }
  
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mHEX_INT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = HEX_INT;
  int _saveIndex;
  
  mHEX_PREFIX(false);
  mHEX_DIGITS(false);
  {
  if ((_tokenSet_17.member(LA(1)))) {
   mINT_SUFFIX(false);
  }
  else {
  }
  
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 protected final void mOCT_INT(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = OCT_INT;
  int _saveIndex;
  
  mOCT_PREFIX(false);
  mOCT_DIGITS(false);
  {
  if ((_tokenSet_17.member(LA(1)))) {
   mINT_SUFFIX(false);
  }
  else {
  }
  
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 public final void mDEFINED(boolean _createToken) throws RecognitionException, CharStreamException, TokenStreamException {
  int _ttype; Token _token=null; int _begin=text.length();
  _ttype = DEFINED;
  int _saveIndex;
  
  match("defined");
  {
  switch ( LA(1)) {
  case '(':  case '[':  case '{':
  {
   {
   mLEFT(false);
   }
   mRAW_IDENTIFIER(false);
   {
   mRIGHT(false);
   }
   break;
  }
  case '\t':  case '\u000c':  case ' ':
  {
   {
   int _cnt149=0;
   _loop149:
   do {
    if ((LA(1)=='\t'||LA(1)=='\u000c'||LA(1)==' ')) {
     mWS(false);
    }
    else {
     if ( _cnt149>=1 ) { break _loop149; } else {throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());}
    }
    
    _cnt149++;
   } while (true);
   }
   mRAW_IDENTIFIER(false);
   break;
  }
  default:
  {
   throw new NoViableAltForCharException((char)LA(1), getFilename(), getLine(), getColumn());
  }
  }
  }
  if ( _createToken && _token==null && _ttype!=Token.SKIP ) {
   _token = makeToken(_ttype);
   _token.setText(new String(text.getBuffer(), _begin, text.length()-_begin));
  }
  _returnToken = _token;
 }
 
 
 private static final long[] mk_tokenSet_0() {
  long[] data = { 1103806599680L, 576460752437641216L, 0L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
 private static final long[] mk_tokenSet_1() {
  long[] data = { 4294971904L, 576460745995190270L, 0L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
 private static final long[] mk_tokenSet_2() {
  long[] data = { 0L, 576460745995190270L, 0L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
 private static final long[] mk_tokenSet_3() {
  long[] data = { 288089642958337536L, 45337468618145792L, 0L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_3 = new BitSet(mk_tokenSet_3());
 private static final long[] mk_tokenSet_4() {
  long[] data = { 1103806608896L, 0L, 0L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_4 = new BitSet(mk_tokenSet_4());
 private static final long[] mk_tokenSet_5() {
  long[] data = { 571230654976L, 0L, 0L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_5 = new BitSet(mk_tokenSet_5());
 private static final long[] mk_tokenSet_6() {
  long[] data = { 140741783336448L, 0L, 0L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_6 = new BitSet(mk_tokenSet_6());
 private static final long[] mk_tokenSet_7() {
  long[] data = { 287948905469972992L, 0L, 0L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_7 = new BitSet(mk_tokenSet_7());
 private static final long[] mk_tokenSet_8() {
  long[] data = { 288089642958337536L, 81082385497591808L, 0L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_8 = new BitSet(mk_tokenSet_8());
 private static final long[] mk_tokenSet_9() {
  long[] data = { -287968731039002112L, 6341068281109020673L, 0L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_9 = new BitSet(mk_tokenSet_9());
 private static final long[] mk_tokenSet_10() {
  long[] data = new long[8];
  data[0]=-4611686018427387912L;
  for (int i = 1; i<=3; i++) { data[i]=-1L; }
  return data;
 }
 public static final BitSet _tokenSet_10 = new BitSet(mk_tokenSet_10());
 private static final long[] mk_tokenSet_11() {
  long[] data = new long[8];
  data[0]=-17179869192L;
  data[1]=-268435457L;
  for (int i = 2; i<=3; i++) { data[i]=-1L; }
  return data;
 }
 public static final BitSet _tokenSet_11 = new BitSet(mk_tokenSet_11());
 private static final long[] mk_tokenSet_12() {
  long[] data = new long[8];
  data[0]=-549755813896L;
  data[1]=-268435457L;
  for (int i = 2; i<=3; i++) { data[i]=-1L; }
  return data;
 }
 public static final BitSet _tokenSet_12 = new BitSet(mk_tokenSet_12());
 private static final long[] mk_tokenSet_13() {
  long[] data = { -287970401781284864L, 5764607528671379457L, 0L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_13 = new BitSet(mk_tokenSet_13());
 private static final long[] mk_tokenSet_14() {
  long[] data = { 1103806599680L, 0L, 0L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_14 = new BitSet(mk_tokenSet_14());
 private static final long[] mk_tokenSet_15() {
  long[] data = { -38654701056L, 6917529027104210943L, 0L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_15 = new BitSet(mk_tokenSet_15());
 private static final long[] mk_tokenSet_16() {
  long[] data = { 17596481016320L, 0L, 0L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_16 = new BitSet(mk_tokenSet_16());
 private static final long[] mk_tokenSet_17() {
  long[] data = { 0L, 9024791442886656L, 0L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_17 = new BitSet(mk_tokenSet_17());
 
 }
