package com.prismtech.idt.imports.idl.internal.preprocessor;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;


public class PreprocessorFile extends File
{
   private String originalPath;

   private File originalFile;

   private FileInputStream inputStr;

   private boolean reachedEOF = false;

   public PreprocessorFile (File workingDir, String originalPath)
   {
      super (workingDir, originalPath.replace ('\\', '/'));

      this.originalPath = originalPath.replace ('\\', '/');
      this.originalFile = new File (this.originalPath);
   }

   public String getOriginalPath ()
   {
      return originalPath;
   }

   public File getOriginalFile ()
   {
      return originalFile;
   }

   public InputStream getInputStream () throws FileNotFoundException
   {
      if (inputStr == null)
      {
         inputStr = new FileInputStream (this)
         {
            @Override
            public int read () throws IOException
            {
               int i = super.read ();
               if (reachedEOF)
               {
                  return -1;
               }
               else if (i == -1)
               {
                  reachedEOF = true;
                  return '\n';
               }
               else
               {
                  return i;
               }
            }
         };
      }
      return inputStr;
   }

   public void close ()
   {
      try
      {
         inputStr.close ();
      }
      catch (Exception e)
      {
      }
   }
}
