package com.prismtech.trace;

import org.eclipse.core.runtime.IConfigurationElement;
import org.eclipse.core.runtime.IExtension;
import org.eclipse.core.runtime.IExtensionPoint;
import org.eclipse.core.runtime.IExtensionRegistry;
import org.eclipse.core.runtime.Platform;
import org.eclipse.core.runtime.Plugin;
import org.osgi.framework.BundleContext;


/**
 * The activator class controls the plug-in life cycle
 */
public class TracePlugin extends Plugin
{

   // The plug-in ID
   public static final String PLUGIN_ID = "com.prismtech.trace";

   public static final String HELPERS_EXT = PLUGIN_ID + ".helpers";

   // The shared instance
   private static TracePlugin plugin;

   /**
    * The constructor
    */
   public TracePlugin ()
   {
   }

   /*
    * (non-Javadoc)
    * 
    * @see org.eclipse.core.runtime.Plugins#start(org.osgi.framework.BundleContext)
    */
   public void start (BundleContext context) throws Exception
   {
      super.start (context);
      plugin = this;

      IExtensionRegistry registry = Platform.getExtensionRegistry ();
      IExtensionPoint extensionPoint = registry.getExtensionPoint (HELPERS_EXT);
      IExtension[] extensions = extensionPoint.getExtensions ();
      // For each extension ...
      for (int i = 0; i < extensions.length; i++)
      {
         IExtension extension = extensions[i];
         IConfigurationElement[] elements = extension.getConfigurationElements ();
         // For each member of the extension ...
         for (int j = 0; j < elements.length; j++)
         {
            IConfigurationElement element = elements[j];

            try
            {
               Object object = element.createExecutableExtension ("class");

               Trace.register ((IHelper) object);
            }
            catch (Throwable e)
            {
               e.printStackTrace ();
            }
         }
      }
   }

   /*
    * (non-Javadoc)
    * 
    * @see org.eclipse.core.runtime.Plugin#stop(org.osgi.framework.BundleContext)
    */
   public void stop (BundleContext context) throws Exception
   {
      plugin = null;
      super.stop (context);
   }

   /**
    * Returns the shared instance
    * 
    * @return the shared instance
    */
   public static TracePlugin getDefault ()
   {
      return plugin;
   }

}
