
package com.thalesgroup.cdmw.codegenerator.cdmwinit.cpp;

import java.io.File;

import org.acceleo.engine.EMT;
import fr.obeo.acceleo.gen.template.eval.LaunchManager;
import org.acceleo.gen.AcceleoGenerate;
import org.acceleo.engine.IModel;
import org.acceleo.gen.Model;
import org.acceleo.gen.extension.Extension;
import org.acceleo.tools.resources.Resources;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.ResourceSet;


/**
 * Generated using Acceleo export.
 */
public class CdmwInit {

	public static final String emtFile = "com/thalesgroup/cdmw/codegenerator/cdmwinit/cpp/CdmwInit.emt";
	
	private static ResourceSet resourceSet = getResourceSet();
	
	/**
	 * Execute com/thalesgroup/cdmw/codegenerator/cdmwinit/cpp/CdmwInit.emt template using the given model
	 * 
	 * @param args
	 *            args[0] : model resource args[1] : generation path
	 * @throws Exception
	 */
	public static void main(String[] args) throws Exception {
		if (args.length == 1) {
			generate(args[0]);
		} else if (args.length == 2) {
			generateFolder(args[0], args[1]);
		} else {
			System.out.println("args: <model_path> [<generation_directory>]");
			System.out.println("      - model_path is the path of the model to use for the generation");
			System.out.println("      - generation_directory is the path that will be used to store generated files");
		}
	}
	
	public static void generate(String modelPath) throws Exception {
		AcceleoGenerate generator = new AcceleoGenerate();
		generator.setGenRootDir(System.getProperty("user.dir") + File.separator + "generated" + File.separator);
		IModel model = loadModel(modelPath);
		generate(generator, model);
	}
	
	public static void generateFolder(String modelPath, String generatePath) throws Exception {
		AcceleoGenerate generator = new AcceleoGenerate();
		generator.setGenRootDir(generatePath);
		IModel model = loadModel(modelPath);
		generate(generator, model);
	}
	
	public static void generate(AcceleoGenerate generator, IModel model) throws Exception {
		EMT emt = new EMT(resourceSet, getEMTURI(emtFile),Thread.currentThread().getContextClassLoader());
		generator.generate(emt, model, true, LaunchManager.create("run", false));
	}

	public static IModel loadModel(String modelPath) throws Exception {
		IModel model;
		
		model = new Model(resourceSet,"com.prismtech.idt.idlmm.IdlmmPackage", getModelURI(modelPath));
		
		return model;
	}
	
	private static URI getModelURI(String name) throws Exception {
		URI ret = Resources.getResourceURI(name);
		if(ret == null){
			throw new Exception("Unable to find model " + name);
		}
		return ret;
	}
	
	private static URI getEMTURI(String name) throws Exception{
		URI ret = Resources.getResourceURI(name);
		if(ret == null){
			throw new Exception("Unable to find emt " + name);
		}
		return ret;
	}
	
	private static ResourceSet getResourceSet(){
		ResourceSet ret = Extension.getResourceSet();
		
		return ret;
	}
}
