package com.thalesgroup.cdmw.codegenerator.lifecycle;

import com.prismtech.idt.idlmm.InterfaceDef;

import fr.obeo.acceleo.gen.template.eval.ENode;

/**
 * This Acceleo Services class allows to access data
 * loaded from a XML code generation file.
 * Those data are stored in static variables and should have 
 * been set by the CdmwXMLFile class for a <factory-impl> element.
 * To store data for another <factory-impl> element, the reset()
 * operation should be called before.  
 */
public class LifeCycleServices {

	// factory/@idl-interface
	public static InterfaceDef idlInterface;
	
	// factory-impl/@classname (without scope)
	public static String factoryImplClassname;
	// factory-impl/@classname scope
	public static String factoryImplClassnameScope;
	// factory-impl/@directory
	public static String factoryImplDirectory;
	// factory-impl/@filename
	public static String factoryImplFilename;
	
	// factory-impl/@threading
	public static boolean isMultithread;
	
	// servant-provider/@classname (without scope)
	public static String servantProviderClassname;
	// servant-provider/@classname scope
	public static String servantProviderClassnameScope;
	// servant-provider/@directory
	public static String servantProviderDirectory;
	// servant-provider/@filename
	public static String servantProviderFilename;
	
	// servant-provider-allocator/@classname
	public static String servantProviderAllocatorClassname;
	// servant-provider-allocator/@filename
	public static String servantProviderAllocatorFilename;
	
	
	
	static {
		reset();
	}
	
	public static void reset() {
		idlInterface = null;
		factoryImplClassname = "";
		factoryImplClassnameScope = "";
		factoryImplDirectory = "";
		factoryImplFilename = "";
		isMultithread = false;
		servantProviderClassname = "";
		servantProviderClassnameScope = "";
		servantProviderDirectory = "";
		servantProviderFilename = "";
		servantProviderAllocatorClassname = "";
		servantProviderAllocatorFilename = "";
	}	
	
	
	public InterfaceDef idlInterface(ENode foo) {
		return idlInterface;
	}
	
	public String factoryImplClassname(ENode foo) {
		return factoryImplClassname;
	}
	
	public String factoryImplClassnameScope(ENode foo) {
		return factoryImplClassnameScope;
	}
	
	public String factoryImplDirectory(ENode foo) {
		return factoryImplDirectory;
	}
	
	public String factoryImplFilename(ENode foo) {
		return factoryImplFilename;
	}
	
	public boolean isMultithread(ENode foo) {
		return isMultithread;
	}
	
	public String servantProviderClassname(ENode foo) {
		return servantProviderClassname;
	}
	
	public String servantProviderClassnameScope(ENode foo) {
		return servantProviderClassnameScope;
	}
	
	public String servantProviderDirectory(ENode foo) {
		return servantProviderDirectory;
	}
	
	public String servantProviderFilename(ENode foo) {
		return servantProviderFilename;
	}

	public String servantProviderAllocatorClassname(ENode foo) {
		return servantProviderAllocatorClassname;
	}

	public String servantProviderAllocatorFilename(ENode foo) {
		return servantProviderAllocatorFilename;
	}

}
