<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.Utils
import com.thalesgroup.ccm.codegenerator.corba.cpp.CppMappingServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.Utils
import com.thalesgroup.ccm.codegenerator.corba.cpp.BasicTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.cpp.ComplexTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.cpp.IDLTypeFallback
import com.thalesgroup.ccm.codegenerator.container.Utils
import com.thalesgroup.ccm.codegenerator.container.cpp.Utils
import com.thalesgroup.ccm.codegenerator.container.cpp.Names
import com.thalesgroup.ccm.codegenerator.container.cpp.Facet_cpp
import com.thalesgroup.ccm.codegenerator.container.cpp.COPIUtils
%>

<%script type="idlmm.InterfaceDef" name="filePath" post="trim()"%>
<%generatedCOPIFacetServantClassname%>.cpp

<%--
  -- Generation template  
  --%>
<%script type="idlmm.InterfaceDef" name="COPIFacet_cpp" file="<%filePath%>"%>
<%copyrightHeader%>

#include <map>
#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/ExceptionMinorCodes.hpp>
#include <Foundation/logging/FunctionLogger.hpp>
#include <CCMContainer/ccmcopi/ContainerServantRequest_impl.hpp>
   
#include "<%generatedCOPIFacetServantClassname%>.hpp"


// Anonymous namespace
namespace {
    <%-- generate all request classes in anonymous namespace     --%>
    <%-- to avoid facet's/receptacle's request classes conflicts --%>
    <%self.push()%>
    <%allOperations.genRequestClass("::Cdmw::CCM::COPI::ContainerServantRequest_impl", "::Cdmw::CCM::COPI::ContainerServantRequestInfo_impl")%>
    <%pop()%>
}


<%openNamespace(generatedCOPIFacetServantPackage)%>

<%generatedCOPIFacetServantClassname%>::<%generatedCOPIFacetServantClassname%>(
        Components::ExecutorLocator_ptr exec_locator, 
        const std::string&              name,
        Context*                        ctx,
        CORBA::Object_ptr               comp_ref,
        PortableServer::Servant         component,
        CdmwLogging::Logger_ptr         logger,
        const std::string&              comp_id)
    : LifeCycleObjectBase(ctx), 
      <%generatedFacetServantClassname%>(exec_locator, name, ctx, comp_ref, component, logger),
      m_context(ctx),
      m_component_identity(comp_id)
    {
        CDMW_LOG_FUNCTION(m_logger.in(), "name="<<name);
        // TODO: in Java MOSIC there is no comp_ref argument
    }

    <%generatedCOPIFacetServantClassname%>::~<%generatedCOPIFacetServantClassname%>() throw()
    {
        CDMW_LOG_FUNCTION(m_logger.in(), "m_facet_name="<<m_facet_name);
        // no remove_ref on component while it's done in var destructor
    }

    <%--
       Create operation declarations for attributes.
       NOTA: This should also include inherited attributes.
    --%>
    <%self.push()%>
       <%-- NOTA: shouldn't be attributes operation intercepted too ??--%>
    <%allAttributes.genAttributeOperations%>
    <%pop()%>

    <%--
       Create operation declarations.
       NOTA: This should also include inherited operations.
    --%>
    <%self.push()%>
    <%allOperations.genInterceptedOperationImpl%>
    <%pop()%>

<%closeNamespace(generatedCOPIFacetServantPackage)%>


<%script type="idlmm.OperationDef" name="genInterceptedOperationImpl"%>
   <%-- REQUIRES parent interface in context
        (containingInterface cannot be used since
         attribute could come from an inherited interface) 
   --%>
<%genOperationSignatureWithClassname(peek.generatedCOPIFacetServantClassname)%>
{
    CDMW_LOG_FUNCTION(m_logger.in(), "");
    try
    {
        CORBA::Object_var obj = m_executor_locator->obtain_executor(m_facet_name.c_str());
            
        if (CORBA::is_nil(obj.in()))
        {
            CDMW_ERROR(m_logger.in(), 
                "Executor for facet " <<m_facet_name<< " is nil");
            CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST, 
                                       CORBA::COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(ex);
            throw ex;
        }

        <%peek.equivalentLocalInterface%>_var facet_exec = <%peek.equivalentLocalInterface%>::_narrow(obj.in());
    
        if (CORBA::is_nil(facet_exec.in()))
        {
            CDMW_ERROR(m_logger.in(), 
                "Executor for facet " <<m_facet_name<< " has wrong type");
            CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST, 
                                       CORBA::COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(ex);
            throw ex;
        }

        ::std::string feature_name =
            this->m_facet_name;
            
        ::CORBA::Object_var target =
            ::CORBA::Object::_duplicate(this->m_executor_locator);
       
        <%genInterceptionCode("facet_exec")%>
                  
        m_executor_locator->release_executor(facet_exec.in());

        <%genInterceptionCode2%>

        <%if (!type.isVoid){%>
        return __result<%type.forReturnSuffix%>;
        <%}%>
    }
    catch (const Components::CCMException& e )
    {
        CDMW_ERROR(m_logger.in(), 
                   "CCMException received: "<< e);
        CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, 
                           CORBA::COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(ex);
        throw ex;
    }
}


