<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.Utils
import com.thalesgroup.ccm.codegenerator.corba.cpp.CppMappingServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.Utils
import com.thalesgroup.ccm.codegenerator.corba.cpp.BasicTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.cpp.ComplexTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.cpp.IDLTypeFallback
import com.thalesgroup.ccm.codegenerator.container.Utils
import com.thalesgroup.ccm.codegenerator.container.cpp.Utils
import com.thalesgroup.ccm.codegenerator.container.cpp.Names
import com.thalesgroup.ccm.codegenerator.container.cpp.COPIUtils
%>

<%script type="idlmm.InterfaceDef" name="filePath" post="trim()"%>
<%generatedCOPIReceptacleClassname%>.cpp

<%--
  -- Generation template  
  --%>
<%script type="idlmm.InterfaceDef" name="COPIReceptacle_cpp" file="<%filePath%>"%>
<%copyrightHeader%>

#include <Foundation/logging/FunctionLogger.hpp>   
#include <Foundation/orbsupport/ExceptionMinorCodes.hpp>
#include <CCMContainer/ccmcopi/ContainerStubRequest_impl.hpp>
#include "<%generatedCOPIReceptacleClassname%>.hpp"


// Anonymous namespace
namespace {
    <%-- generate all request classes in anonymous namespace     --%>
    <%-- to avoid facet's/receptacle's request classes conflicts --%>
    <%self.push()%>
    <%allOperations.genRequestClass("::Cdmw::CCM::COPI::ContainerStubRequest_impl", "::Cdmw::CCM::COPI::ContainerStubRequestInfo_impl")%>
    <%pop()%>
}


<%openNamespace(generatedCOPIReceptaclePackage)%>

    <%generatedCOPIReceptacleClassname%>::<%generatedCOPIReceptacleClassname%>(
            const ::std::string & receptacle_name,
            const ::std::string & component_id,
            ::CORBA::Object_ptr facet_object,
            ::Cdmw::CCM::CIF::Context * context,
            CdmwLogging::Logger_ptr     logger) 
        : m_receptacle_name(receptacle_name),
          m_component_identity(component_id),
          m_facet_object(facet_object),
          m_context(context),
          m_logger(logger)
           
    {
        CDMW_LOG_FUNCTION(m_logger, "");
    };
    
    <%generatedCOPIReceptacleClassname%>::~<%generatedCOPIReceptacleClassname%>() 
        throw() 
    {
        // empty
        CDMW_LOG_FUNCTION(m_logger, "");
    }


    <%--
       Create operation declarations for attributes.
       NOTA: This should also include inherited attributes.
    --%>
    <%self.push()%>
    <%allAttributes.genAttributeOperations%>
    <%pop()%>
    
    <%--
       Create operation declarations.
       NOTA: This should also include inherited operations.
    --%>
    <%self.push()%>
    <%allOperations.genInterceptedOperationImpl%>
    <%pop()%>

<%closeNamespace(generatedCOPIReceptaclePackage)%>



<%script type="idlmm.AttributeDef" name="genAttributeOperations"%>
   <%-- REQUIRES parent interface in context
        (containingInterface cannot be used since
         attribute could come from an inherited interface) 
   --%>
<%type.asReturnParameterDef%> <%peek.generatedCOPIReceptacleClassname%>::<%cppName%>()
    throw(<%for (getExceptions){%><%cppFullClassname%>,<%}%>CORBA::SystemException)
{
}
<%if (mode != "ATTR_READONLY"){%>
void <%peek.generatedCOPIReceptacleClassname%>::<%cppName%>(<%type.asInParameterDef%>)
    throw(<%for (setExceptions){%><%cppFullClassname%>,<%}%>CORBA::SystemException)
{
}
<%}%>


<%script type="idlmm.OperationDef" name="genInterceptedOperationImpl"%>
   <%-- REQUIRES parent interface in context
        (containingInterface cannot be used since
         attribute could come from an inherited interface) 
   --%>
<%genOperationSignatureWithClassname(peek.generatedCOPIReceptacleClassname)%>
{
    CDMW_LOG_FUNCTION(m_logger, "");

    const std::string &  feature_name = this->m_receptacle_name;
    ::CORBA::Object_var target = 
        ::CORBA::Object::_duplicate(this->m_facet_object);

    <%peek.asLocalVariable%> facet_object;

    <%genReceptacleInterceptionCode("facet_object")%>
}



<%-- 
  -- Generate interception code.
  -- Required arguments:
  --   0 : name of the variable to delegate operation call
  --%>
<%script type="idlmm.OperationDef" name="genReceptacleInterceptionCode"%>
   <%-- REQUIRES parent interface in context
        (containingInterface cannot be used since
         attribute could come from an inherited interface) 
   --%>
// Create variables for all parameters and result,
// copying values for in and inout parameters
<%if (!type.isVoid){%>
<%type.asLocalVariable%> __result = <%type.getInitValue%>;
<%}%>
<%for (parameters[mode == "PARAM_IN"]){%>
<%type.asLocalVariable%> _<%cppName%> = <%type.copyOfVariable(cppName)%>;
<%}%>
<%for (parameters[mode == "PARAM_INOUT"]){%>
<%type.asLocalVariable%> _<%cppName%> = <%type.copyOfVariable(cppName)%>;
<%}%>
<%for (parameters[mode == "PARAM_OUT"]){%>
<%type.asLocalVariable%> _<%cppName%> = <%type.getInitValue%>;
<%}%>

<%generatedCOPIRequestClassname%> request(
    feature_name.c_str(), 
    m_component_identity.c_str(), 
    target.in(), 
    m_context);
   
if (request.is_read_write()) {  
    <%if (!type.isVoid){%>
    request.add_result_value(__result<%type.forInSuffix%>);
    <%}%>
    <%for (parameters[mode == "PARAM_IN"]){%>
    request.add_in_args_<%name%>(_<%cppName%><%type.forInSuffix%>);
    <%}%>
    <%for (parameters[mode == "PARAM_INOUT"]){%>
    request.add_inout_args_<%name%>(_<%cppName%><%type.forInSuffix%>);
    <%}%>
    <%for (parameters[mode == "PARAM_OUT"]){%>
    request.add_out_args_<%name%>(_<%cppName%><%type.forInSuffix%>);
    <%}%>

    <%for (exceptions){%>
    request.add_exception_<%name%>_tc();
    <%}%>
    
    request.pre_invoke();
    request.invoke();
    request.post_invoke();

    <%genUnmarshallResultCode%>
   
} else { 
    request.pre_invoke();
    try {
        <%args(0)%> =
            <%peek.cppFullClassname%>::_narrow (target);
    } catch (::CORBA::BAD_PARAM & e) {
        CDMW_ERROR(m_logger, 
                   "The facet object has wrong type");
        ::CORBA::OBJECT_NOT_EXIST ex
              (
               ::Cdmw::OrbSupport::OBJECT_NOT_EXIST, 
               ::CORBA::COMPLETED_NO
               );
        CDMW_LOG_FUNCTION_EXCEPTION(ex);
        throw ex;
    }
           
    try{  
        <%if (! type.isVoid){%>
        __result =
        <%}%>
        <%args(0)%>-><%cppName%>(<%parameters.cppName.sep(", ")%>);
    } 
    catch(::CORBA::SystemException & se){
        request.add_system_exception(se);
    <%for (exceptions){%>
    } catch (<%cppFullClassname%> & e) {
        request.add_exception_<%name%>(e);
    <%}%>
    }
  
    request.post_invoke();
    request.throw_exception();
     
} //end of else

<%if (! type.isVoid){%>
return __result<%type.forReturnSuffix%>;
<%}%>
   