<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.Utils
import com.thalesgroup.ccm.codegenerator.corba.cpp.CppMappingServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.Utils
import com.thalesgroup.ccm.codegenerator.corba.cpp.BasicTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.cpp.ComplexTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.cpp.IDLTypeFallback
import com.thalesgroup.ccm.codegenerator.container.Utils
import com.thalesgroup.ccm.codegenerator.container.CommonServices
import com.thalesgroup.ccm.codegenerator.container.cpp.Utils
import com.thalesgroup.ccm.codegenerator.container.cpp.Names
%>



<%-- 
  -- Generate interception code.
  -- Required arguments:
  --   0 : name of the variable to delegate operation call
  --%>
<%script type="idlmm.OperationDef" name="genInterceptionCode"%>
// Create variables for all parameters and result,
// copying values for in and inout parameters
// TODO: possible optimization here (no copy) ?
<%if (!type.isVoid){%>
<%type.asLocalVariable%> __result = <%type.getInitValue%>;
<%}%>
<%for (parameters[mode == "PARAM_IN"]){%>
<%type.asLocalVariable%> _<%cppName%> = <%type.copyOfVariable(cppName)%>;
<%}%>
<%for (parameters[mode == "PARAM_INOUT"]){%>
<%type.asLocalVariable%> _<%cppName%> = <%type.copyOfVariable(cppName)%>;
<%}%>
<%for (parameters[mode == "PARAM_OUT"]){%>
<%type.asLocalVariable%> _<%cppName%> = <%type.getInitValue%>;
<%}%>

<%generatedCOPIRequestClassname%> request(
    feature_name.c_str(),
    m_component_identity.c_str(),
    target,
    m_context);
            
if (request.is_read_write()) {
    // fill request object with result and all paramenters
    // (for request parameters creation)
    <%if (!type.isVoid){%>
    request.add_result_value(__result<%type.forInSuffix%>);
    <%}%>
    <%for (parameters[mode == "PARAM_IN"]){%>
    request.add_in_args_<%name%>(_<%cppName%><%type.forInSuffix%>);
    <%}%>
    <%for (parameters[mode == "PARAM_INOUT"]){%>
    request.add_inout_args_<%name%>(_<%cppName%><%type.forInSuffix%>);
    <%}%>
    <%for (parameters[mode == "PARAM_OUT"]){%>
    request.add_out_args_<%name%>(_<%cppName%><%type.forInSuffix%>);
    <%}%>
    
    <%for (exceptions){%>
    request.add_exception_<%name%>_tc();
    <%}%>
    
}
request.pre_invoke();
       
<%if ((parameters[mode == "PARAM_IN"].length > 0) || (parameters[mode == "PARAM_INOUT"].length > 0)){%>
if (request.is_read_write()) {
    // get in and inout args modified by pre_invoke()
    <%for (parameters[mode == "PARAM_IN"]){%>
    _<%cppName%> = request.get_in_args_<%name%>();
    <%}%>
    <%for (parameters[mode == "PARAM_INOUT"]){%>
    _<%cppName%> = request.get_inout_args_<%name%>();
    <%}%>
}
<%}%>
        
try {
    ::CORBA::Any_var the_exception =
        request.the_exception();
    if (true == request.m_proceed_call &&
        ::CORBA::tk_null == the_exception->type()->kind()) 
    {
        <%if (!type.isVoid){%>
        __result =
        <%}%>
        <%args(0)%>-><%cppName%>(<%parameters.genVariableArgPass.sep(", ")%>);
    
        <%if ((!type.isVoid) || (parameters[mode == "PARAM_OUT"].length > 0) || (parameters[mode == "PARAM_INOUT"].length > 0)){%>
        if (request.is_read_write()) {
            // fill request with result, inout and out parameters returned by executor
            <%if (!type.isVoid){%>
            request.add_result_value(__result<%type.forInSuffix%>);
            <%}%>
            <%for (parameters[mode == "PARAM_OUT"]){%>
            request.add_out_args_<%name%>(_<%cppName%><%type.forInSuffix%>);
            <%}%>
            <%for (parameters[mode == "PARAM_INOUT"]){%>
            request.add_inout_args_<%name%>(_<%cppName%><%type.forInSuffix%>);
            <%}%>
        }
        <%}%>
    }
}
catch(::CORBA::SystemException & se) {
    request.add_system_exception(se);
<%for (exceptions){%>
} catch (<%cppFullClassname%> & e) {
    request.add_exception_<%name%>(e);
<%}%>
}
            
request.post_invoke();
        


<%script type="idlmm.ParameterDef" name="genVariableArgPass" post="trim()"%>
_<%cppName%><%genVariableArgPassSuffix%>



<%script type="idlmm.OperationDef" name="genInterceptionCode2"%>
if (request.is_read_write()) {
    <%genUnmarshallResultCode%>
} else {
    request.throw_exception();
}
                  



<%script type="idlmm.OperationDef" name="genUnmarshallResultCode"%>
::CORBA::Any_var the_exception =
    request.the_exception();

if(::CORBA::tk_null != the_exception->type()->kind()) {
    <%for (exceptions){%>
    if (the_exception->type()->equal(<%tcName%>)) {
        <%cppFullClassname%> * user_exception = 0;
        if(!(the_exception.in() >>= user_exception)) {
            CDMW_ASSERT(0);
        }
        throw user_exception;
    } else 
    <%}%>
        throw request.the_systemException();
}                                       

<%if (!type.isVoid){%>
__result = request.result_value();
<%}%>
<%for (parameters[mode == "PARAM_INOUT"]){%>
_<%cppName%> = request.get_inout_args_<%name%>();
<%}%>
<%for (parameters[mode == "PARAM_OUT"]){%>
_<%cppName%> = request.get_out_args_<%name%>();
<%}%>

<%if ((parameters[mode == "PARAM_INOUT"].length > 0) || (parameters[mode == "PARAM_OUT"].length > 0)){%>
// update inout and out parameters
<%for (parameters[mode == "PARAM_INOUT"]){%>
<%cppName%> = _<%cppName%><%type.forInoutSuffix%>;
<%}%>
<%for (parameters[mode == "PARAM_OUT"]){%>
<%cppName%> = _<%cppName%><%type.forOutSuffix%>;
<%}%>
<%}%>



<%--
   This template generates the request marshalling class of a given operation.
   Expected arguments:
     O: the inherited class
     O: the Info class
--%>
<%script type="idlmm.OperationDef" name="genRequestClass"%>
class <%generatedCOPIRequestClassname%> : public virtual <%args(0)%>
{
    public:

        // MOSIC Java ctor has ctx as arg this is not used though
        <%generatedCOPIRequestClassname%>( 
               const char *  receptacle_name, 
               const char *  component_id,
               ::CORBA::Object_ptr facet_object,
               ::Cdmw::CCM::CIF::Context * ctx)
            : ::Cdmw::CCM::COPI::ContainerExtendedCopisRequest_impl< <%args(1)%> >(ctx),
              <%args(0)%>(ctx),
              m_index(-1)
        {
            initialise(receptacle_name, component_id, facet_object);
        }
    
        ~<%generatedCOPIRequestClassname%>()
        {
           // empty
        }
    
        char * operation()
        {
            return ::CORBA::string_dup("<%name%>");
        }
    
        <%for (parameters[mode == "PARAM_IN"]){%>
        void add_in_args_<%name%>(<%type.asInParameterDef%> <%cppName%>)
        {
            // insertion with copy
            // TODO: possible optimization (no copy) ?
            ::CORBA::Any any;
            <%type.genAnyInsertion("any", cppName)%>;
            this->add_in_args(any);
            m_arguments_indices["<%name%>"] = ++m_index;
        }
             
        <%type.asReturnParameterDef%> get_in_args_<%name%>()
        {
            ::std::map< ::std::string, int >::iterator it =
                  m_arguments_indices.find("<%name%>");
            <%type.asVarForAnyExtraction%> <%cppName%>;
            if(it != m_arguments_indices.end()) {
                ::CORBA::Any_var any =
                      get_arg(it->second);            
                if(!(<%type.genAnyExtraction("any.in()", cppName)%>)) {
                    CDMW_ASSERT(0);
                };
            } else {            
                CDMW_ASSERT(0);
            }
            // TODO: possible optimization (no copy) ?
            return <%type.copyOfVarForAnyExtraction(cppName)%>;
        }
        <%}%>
    
        <%for (parameters[mode == "PARAM_INOUT"]){%>
        void add_inout_args_<%name%>(<%type.asInParameterDef%> <%cppName%>)
        {
            // insertion with copy
            // TODO: possible optimization (no copy) ?
            ::CORBA::Any any;
            <%type.genAnyInsertion("any", cppName)%>;
            this->add_inout_args(any);
            m_arguments_indices["<%name%>"] = ++m_index;
        }
             
        <%type.asReturnParameterDef%> get_inout_args_<%name%>()
        {
            ::std::map< ::std::string, int >::iterator it =
                  m_arguments_indices.find("<%name%>");
            <%type.asVarForAnyExtraction%> <%cppName%>;
            if(it != m_arguments_indices.end()) {
                ::CORBA::Any_var any =
                      get_arg(it->second);            
                if(!(<%type.genAnyExtraction("any.in()", cppName)%>)) {
                    CDMW_ASSERT(0);
                };
            } else {            
                CDMW_ASSERT(0);
            }
            // TODO: possible optimization (no copy) ?
            return <%type.copyOfVarForAnyExtraction(cppName)%>;
        }        
        <%}%>
        
        <%for (parameters[mode == "PARAM_OUT"]){%>
        void add_out_args_<%name%>(<%type.asInParameterDef%> <%cppName%>)
        {
            // insertion with copy
            // TODO: possible optimization (no copy) ?
            ::CORBA::Any any;
            <%type.genAnyInsertion("any", cppName)%>;
            this->add_out_args(any);
            m_arguments_indices["<%name%>"] = ++m_index;
        }
             
        <%type.asReturnParameterDef%> get_out_args_<%name%>()
        {
            ::std::map< ::std::string, int >::iterator it =
                  m_arguments_indices.find("<%name%>");
            <%type.asVarForAnyExtraction%> <%cppName%>;
            if(it != m_arguments_indices.end()) {
                ::CORBA::Any_var any =
                      get_arg(it->second);            
                if(!(<%type.genAnyExtraction("any.in()", cppName)%>)) {
                    CDMW_ASSERT(0);
                };
            } else {            
                CDMW_ASSERT(0);
            }
            // TODO: possible optimization (no copy) ?
            return <%type.copyOfVarForAnyExtraction(cppName)%>;
        }
        <%}%>
    
        <%if (!type.isVoid){%>
        void add_result_value(<%type.asInParameterDef%> value)
        {
            // insertion with copy
            // TODO: possible optimization (no copy) ?
            ::CORBA::Any any;
            <%type.genAnyInsertion("any", "value")%>;
            this->add_result(any);
        }
                   
        <%type.asReturnParameterDef%> result_value()
        {
            <%type.asVarForAnyExtraction%> value;
            ::CORBA::Any_var any =
                  this->result();
            if(!(<%type.genAnyExtraction("any.in()", "value")%>)) {
                CDMW_ASSERT(0);
            };
            // TODO: possible optimization (no copy) ?
            return <%type.copyOfVarForAnyExtraction("value")%>;
        }
        <%}%>

        <%for (exceptions){%>
        void add_exception_<%name%> (<%cppFullClassname%> ex)
        {
            ::CORBA::Any ex_any;
            ex_any <<= ex;
            this->add_exception(ex_any);
        }
                  
        void add_exception_<%name%>_tc ()
        {
            this->add_exception_tc(<%tcName%>);
        }
        <%}%>
    
        void 
        throw_exception()
            throw (<%for (exceptions){%><%cppFullClassname%>, <%}%>::CORBA::SystemException)
        {
            m_request_info->throw_system_exception();
            
            ::CORBA::Any_var ex_any = this->the_exception();
        
            <%for (exceptions){%>
            if (<%tcName%>->equal(ex_any->type())) {
                <%cppFullClassname%> * ex = 0;
                if(!(ex_any.in() >>= ex)) {
                    CDMW_ASSERT(0);
                }
                throw *ex;
            }
            <%}%>   
        }
    
    private:
        ::std::map< ::std::string, int > m_arguments_indices;
        
        int m_index;
    
};   // end of <%generatedCOPIRequestClassname%> class




<%script type="idlmm.ExceptionDef" name="tcName" post="trim"%>
<%container.cppFullClassname%>::_tc_<%name%>