<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.CommonServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.CppMappingServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.BasicTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.cpp.ComplexTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.cpp.IDLTypeFallback
import com.thalesgroup.ccm.codegenerator.corba.cpp.Utils
import com.thalesgroup.ccm.codegenerator.container.Utils
import com.thalesgroup.ccm.codegenerator.container.cpp.Names
import com.thalesgroup.ccm.codegenerator.container.cpp.Utils
%>

<%script type="idlmm.EventDef" name="filePath" post="trim()"%>
<%generatedConsumerClassname%>.cpp

<%--
  -- Generation template  
  --%>
<%script type="idlmm.EventDef" name="Consumer_cpp" file="<%filePath%>"%>
<%copyrightHeader%>

#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/ExceptionMinorCodes.hpp>
#include <Foundation/orbsupport/Codec.hpp>
#include <Foundation/logging/FunctionLogger.hpp>
#include <CCMContainer/ccmcopi/COPIServiceInit.hpp>

#include "<%generatedConsumerClassname%>.hpp"

DEFINE_VALUETYPE_DATA_TRAITS(<%cppFullClassname%>)

<%openNamespace(generatedConsumerPackage)%>

    <%generatedConsumerClassname%>::<%generatedConsumerClassname%>
            (Components::ExecutorLocator_ptr exec_locator,
             const std::string&              name,
             const std::string& component_identity,
             Context*                        ctx,
             PortableServer::Servant         component,
             CdmwLogging::Logger_ptr         logger)
        : LifeCycleObjectBase(ctx),
          m_executor_locator(Components::ExecutorLocator::_duplicate(exec_locator)),
          m_sink_name(name),
          m_component_identity(component_identity),
          m_component(component),
          m_logger(CdmwLogging::Logger::_duplicate(logger)),
          m_ctx(ctx)
    {
        CDMW_LOG_FUNCTION(m_logger.in(), "name="<<name);
        // incrementation refcount of component in order to avoid destruction
        // of the component before the destruction of the facet
        m_component->_add_ref();
    }

    <%generatedConsumerClassname%>::~<%generatedConsumerClassname%>() throw ()
    {
        CDMW_LOG_FUNCTION(m_logger.in(), "m_sink_name="<<m_sink_name);
        // no remove_ref on component while it's done in var destructor
    }


    void
    <%generatedConsumerClassname%>::push_<%name%>(<%asInParameterDef%> the_<%name.toLowerCase%>)
        throw (CORBA::SystemException)
    {
        CDMW_LOG_FUNCTION(m_logger.in(), "");
        CDMW_DEBUG(m_logger.in(), 
            "Consumer " << m_sink_name << " receives an event");
        try
        {
            CORBA::Object_var obj = m_executor_locator->obtain_executor(m_sink_name.c_str());

            if (CORBA::is_nil(obj.in()))
            {
                CDMW_ERROR(m_logger.in(), 
                    "Executor for consumer " << m_sink_name << " is nil");
                CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST,
                                           CORBA::COMPLETED_NO);
                CDMW_LOG_FUNCTION_EXCEPTION(ex);
                throw ex;
            }

            <%equivalentLocalConsumer%>_var consumer_exec =
                <%equivalentLocalConsumer%>::_narrow(obj.in());

            if (!CORBA::is_nil(consumer_exec.in())) {
               consumer_exec->push(the_<%name.toLowerCase%>);
            } else {
                CDMW_ERROR(m_logger.in(), "Executor for consumer " << m_sink_name
                           << " has wrong type");
                CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST,
                                           CORBA::COMPLETED_NO);
                CDMW_LOG_FUNCTION_EXCEPTION(ex);
                throw ex;
            }

            m_executor_locator->release_executor(obj.in());

        } catch (const Components::CCMException& e) {
            CDMW_ERROR(m_logger.in(), "CCMException received: " << e);
            CORBA::INTERNAL
                ex(OrbSupport::INTERNALCCMCIFError, CORBA::COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(ex);
            throw ex;
        }
    }

    void
    <%generatedConsumerClassname%>::push_event(Components::EventBase * evt)
        throw (Components::BadEventType, CORBA::SystemException)
    {
        CDMW_LOG_FUNCTION(m_logger.in(), "");
        <%asLocalVariable%> info_evt
            = <%cppFullClassname%>::_downcast(evt);
        CORBA::add_ref(info_evt.in());

        if (!info_evt.in())
        {
            CDMW_WARN(m_logger.in(),
                "EventBase with unexpected type received");
            Components::BadEventType ex;
            CDMW_LOG_FUNCTION_EXCEPTION(ex);
            throw ex;
        }
        else
        {
            this->push_<%name%>(info_evt.in());
      }
   }

    void
    <%generatedConsumerClassname%>::push(const CORBA::Any& data)
        throw (CosEventComm::Disconnected,
               CORBA::SystemException)
    {
        CDMW_LOG_FUNCTION(m_logger.in(), "");
        <%cppFullClassname%> * event = 0;
        /* PCR-0049
        data >>= event;
        */

        bool was_decoded = false;
          
        if(Cdmw::CCM::COPI::COPIServiceInit::Is_initialized() &&
           Cdmw::CCM::COPI::COPIServiceInit::Is_COPI_requests_read_write()) 
        {
            // need to enable COPIs to access type information,
            // COPIs are not aware of a) which codec to use b) to which object to cast
            data >>= event;           
        }

        if(0 == event) {
            CDMW_DEBUG(m_logger.in(), "event extraction failed, retrying with codec");
         
            const CORBA::OctetSeq* p_encoded_data;
            data >>= p_encoded_data;
            CORBA::OctetSeq encoded_data(*p_encoded_data);
    
            Cdmw::OrbSupport::Codec< <%cppFullClassname%> > codec;
            codec.decode(encoded_data, event);
            was_decoded = true;
        }
        
    
        try
        {
            this->push_<%name%>(event);
            if(was_decoded) {
                // close leak
                <%asLocalVariable%> c = event;
            } 
        }
        catch (const CORBA::SystemException& e)
        {
            CDMW_LOG_FUNCTION_EXCEPTION(e);
            throw;
        }
    }

    void
    <%generatedConsumerClassname%>::disconnect_push_consumer()
        throw (CORBA::SystemException)
    {
        CDMW_LOG_FUNCTION(m_logger.in(), "");
    }

<%closeNamespace(generatedConsumerPackage)%>
