<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.CommonServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.CppMappingServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.BasicTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.cpp.ComplexTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.cpp.IDLTypeFallback
import com.thalesgroup.ccm.codegenerator.corba.cpp.Utils
import com.thalesgroup.ccm.codegenerator.container.Utils
import com.thalesgroup.ccm.codegenerator.container.cpp.Names
import com.thalesgroup.ccm.codegenerator.container.cpp.Utils
%>

<%script type="idlmm.EventDef" name="filePath" post="trim()"%>
<%generatedConsumerClassname%>.hpp

<%--
  -- Generation template  
  --%>
<%script type="idlmm.EventDef" name="Consumer_hpp" file="<%filePath%>"%>
<%copyrightHeader%>

<%openIfndefMacro(generatedConsumerFullClassname)%>

<%genIncludeCdmwCifSkelFile%>

#include <Foundation/orbsupport/RefCountServantBase.hpp>
#include <Foundation/logging/CdmwLogging.stub.hpp>
#include <CCMContainer/ccmcif/LifeCycleObjectBase.hpp>
#include <CCMContainer/ccmcopi/PushContainerServantRequest_impl.hpp>

<%openNamespace(generatedPackage)%>

    // Forward declaration
    class CCMObject_impl;

<%closeNamespace(generatedPackage)%>


<%openNamespace(generatedConsumerPackage)%>

    class <%generatedConsumerClassname%> : virtual public POA_<%generatedConsumerInterface.noColonPrefix%>,
            virtual public LifeCycleObjectBase,
            virtual public OrbSupport::RefCountServantBase
    {
        public:
            <%generatedConsumerClassname%>(
                Components::ExecutorLocator_ptr exec_locator, 
                const std::string&              name,
                const std::string& component_identity,
                Context*                        ctx,
                PortableServer::Servant         component,
                CdmwLogging::Logger_ptr         logger);

            ~<%generatedConsumerClassname%>() throw();     
         
            virtual void
            push_<%name%>(<%asInParameterDef%> the_<%name.toLowerCase%>)
                throw (CORBA::SystemException);

            virtual void 
            push_event(Components::EventBase * evt)
                throw (Components::BadEventType, CORBA::SystemException);

            virtual void 
            push(const CORBA::Any& data)
                throw (CosEventComm::Disconnected, CORBA::SystemException);

            virtual void 
            disconnect_push_consumer()
                throw (CORBA::SystemException);

        private:
            <%generatedConsumerClassname%>(const <%generatedConsumerClassname%>&);
            void operator=(const <%generatedConsumerClassname%>&);

            Components::ExecutorLocator_var  m_executor_locator;
            const std::string                m_sink_name;
            const std::string                m_component_identity;

            PortableServer::ServantBase_var  m_component;

            CdmwLogging::Logger_var          m_logger;

            Context *                        m_ctx;
    };

<%closeNamespace(generatedConsumerPackage)%>

<%closeIfndefMacro(generatedConsumerFullClassname)%>



