<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.cpp.CppMappingServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.Utils
import com.thalesgroup.ccm.codegenerator.container.Utils
import com.thalesgroup.ccm.codegenerator.container.cpp.Utils
import com.thalesgroup.ccm.codegenerator.container.cpp.Names
%>

<%script type="idlmm.ComponentDef" name="extensionFilePath" post="trim()"%>
<%generatedExtensionServantClassname%>.hpp    

<%--
  -- Generation template  
  --%>
<%script type="idlmm.ComponentDef" name="ExtensionComponent_hpp" file="<%extensionFilePath%>"%>
<%copyrightHeader%>

<%openIfndefMacro(generatedExtensionServantClassname)%>

<%genIncludeCdmwCifSkelFile%>

#include "<%generatedSessionServantClassname%>.hpp"
#include <CCMContainer/ccmcif/DefaultCCMObjectStates.hpp>


<%openNamespace(generatedServantPackage)%>

    /**
     * Extension component
     */
    class <%generatedExtensionServantClassname%> : virtual public <%generatedSessionServantFullClassname%>
    {
        public:
            <%generatedExtensionServantClassname%>(const std::string& comp_oid,
                    Context*                              ctx,
                    CORBA::Object_ptr                     comp_ref,
                    Components::EnterpriseComponent*      executor,
                    CdmwLifeCycle::ObjectRegistration_ptr object_registration,
                    CdmwLogging::LoggerFactory_ptr        logger_factory,
                    bool                                  is_created_by_factory_operation)
                throw (Components::CCMException,
                       CORBA::SystemException);

            ~<%generatedExtensionServantClassname%>();
            
            /**
             * Inherited CCMObject interface implemented by CCMObject_impl
             */
            virtual void
            configuration_complete()
                throw(Components::InvalidConfiguration,
                      CORBA::SystemException);

            /**
             * Purpose:
             * <p>In case of a session component, this operation will call 
             * it's executor's ccm_remove operation.
             *
             *@exception Components::CCMException Any CCMException thrown by the
             * executor's ccm_remove operation.
             *@exception CORBA::SystemException Any SystemException thrown by the
             * executor's ccm_remove operation.
             */ 
            virtual void 
            ccm_remove() 
                throw (Components::CCMException, CORBA::SystemException);


        private:
            <%generatedExtensionServantClassname%>(const <%generatedExtensionServantClassname%>&);
            void operator=(const <%generatedExtensionServantClassname%>&);

            /**
             * Attributes
             */

            /**
             * If a home, in creating a component, returns an ExecutorLocator, the cif
             * will invoke its obtain_executor operation prior to each invocation to
             * retrieve the implementation for a port. If the home returns an
             * EnterpriseComponent, we encapsulate it in an executor locator in order to
             * use same code.
             *
             */

            // <%name%> executor locator used to get component exec and facet exec
            Components::ExecutorLocator_var   m_executor_locator;
         
            // executor locator must be a extension component to be advise of its activation, passivation 
            // and removal
            Components::ExtensionComponent_var  m_extension_locator;
    
            // set to true when component is activated
            bool m_is_activated;
    
            // <%name%> context executor
            <%generatedExtensionContextInterface%>_var  m_context_executor;

            // Indicates if current component has been created via a factory operation
            bool m_is_created_by_factory_operation;
         
            CdmwLogging::Logger_var m_logger;   // Logger for logging
    
    };

<%closeNamespace(generatedServantPackage)%>

<%closeIfndefMacro(generatedExtensionServantClassname)%>


