<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.cpp.CppMappingServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.Utils
import com.thalesgroup.ccm.codegenerator.container.Utils
import com.thalesgroup.ccm.codegenerator.container.cpp.Utils
import com.thalesgroup.ccm.codegenerator.container.cpp.Names
import com.thalesgroup.ccm.codegenerator.container.cpp.SessionContext_cpp
%>

<%script type="idlmm.ComponentDef" name="extensionFilePath" post="trim()"%>
<%generatedExtensionContextClassname%>.cpp

<%--
  -- Generation template  
  --%>
<%script type="idlmm.ComponentDef" name="ExtensionContext_cpp" file="<%extensionFilePath%>"%>
<%copyrightHeader%>

#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/Codec.hpp>
#include <Foundation/orbsupport/ExceptionMinorCodes.hpp>
#include <CCMContainer/ccmcommon/CCMLoggers.hpp>
#include <CCMContainer/ccmcopi/PushContainerStubRequest_impl.hpp>
#include <CCMContainer/ccmcopi/COPIServiceInit.hpp>

#include "<%generatedExtensionContextClassname%>.hpp"

<%-- for all eventtypes used emitters or publisher ports, generate DataTraits --%>
<%for ((allEmitsPorts.event + allPublishesPorts.event).nMinimize()){%>
<%genEventDataTraits%>
<%}%>

<%openNamespace(generatedContextPackage)%>

    <%generatedExtensionContextClassname%>::<%generatedExtensionContextClassname%>
            (Components::CCMContext_ptr ctx,
             ::Cdmw::CCM::CIF::CCMObject_impl* component,
             CdmwLogging::LoggerFactory_ptr logger_factory)
        throw (CORBA::SystemException)
            : ::Cdmw::CCM::CIF::ExtensionContext_impl(ctx, component->get_component_identity(), logger_factory),
              m_component(component)
    {
        // create logger with domain for ccmcif
        m_logger = logger_factory->get_logger(CCMLoggers::CCMGENERATED_LOG_DOMAIN);
       
        CDMW_LOG_FUNCTION(m_logger.in(), "");
    }

    <%generatedExtensionContextClassname%>::~<%generatedExtensionContextClassname%>()
    {
    }
    
    <%-- push ComponentDef in context 
         (cannot be reached from sub-script if port is inherited) --%>
    <%self.push()%>

    <%--
        Receptacles.
    --%>
    
    <%allUsesPorts.genUsesCode%>
    
    
    <%--
        Emitters.
    --%>
    
    <%allEmitsPorts.genEventPortCode%>
    
    <%--
        Publishers.
    --%>
    
    <%allPublishesPorts.genEventPortCode%>

    <%-- pop ComponentDef from context --%>
    <%pop()%>

<%closeNamespace(generatedContextPackage)%>


