    <%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.CommonServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.CppMappingServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.BasicTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.cpp.ComplexTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.cpp.IDLTypeFallback
import com.thalesgroup.ccm.codegenerator.corba.cpp.Utils
import com.thalesgroup.ccm.codegenerator.container.Utils
import com.thalesgroup.ccm.codegenerator.container.cpp.Names
import com.thalesgroup.ccm.codegenerator.container.cpp.SessionHome_cpp
%>

<%script type="idlmm.HomeDef" name="extensionFilePath" post="trim()"%>
<%generatedExtensionServantClassname%>.cpp

<%--
  -- Generation template  
  --%>
<%script type="idlmm.HomeDef" name="ExtensionHome_cpp" file="<%extensionFilePath%>"%>
<%copyrightHeader%>

#include <sstream>
#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/ExceptionMinorCodes.hpp>
#include <Foundation/logging/FunctionLogger.hpp>
#include <CCMContainer/ccmcommon/CCMLoggers.hpp>
#include <CCMContainer/ccmcif/CCMUtils.hpp>
#include <Foundation/idllib/CdmwDeployment.stub.hpp>

#include "<%generatedExtensionServantClassname%>.hpp"
#include "<%managedComponent.generatedExtensionServantClassname%>.hpp"


namespace {

      const char* HOME_REP_ID = "<%generatedContainerInterfaceRepID%>";
      const char* COMP_REP_ID = "<%managedComponent.ID%>";

};  // End of anonymous namespace


<%openNamespace(generatedServantPackage)%>

    // Constructor 
    <%generatedExtensionServantClassname%>::<%generatedExtensionServantClassname%>
            (Components::HomeExecutorBase_ptr          home_exec,
             const Cdmw::LifeCycle::ObjectDeactivator& deactivator,
             CdmwLifeCycle::ObjectRegistration_ptr     object_registration,
             const Components::ConfigValues&           config)
        throw(CORBA::SystemException)
            : CCMHome_impl(HOME_REP_ID, COMP_REP_ID, deactivator, object_registration, config)
    {
        CDMW_LOG_FUNCTION(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(), "");
        try {
            m_home_executor = <%equivalentLocalInterface%>::_narrow(home_exec);

            if (CORBA::is_nil(m_home_executor.in()))
            {
                CDMW_ERROR(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(), 
                    "Executor for <%name%> is not a <%equivalentLocalInterface%>");
                CORBA::BAD_PARAM ex(OrbSupport::BAD_PARAMInvalidHomeExecutor, 
                    CORBA::COMPLETED_NO);
                CDMW_LOG_FUNCTION_EXCEPTION(ex);
                throw ex;
            }
        }
        catch (const CORBA::Exception & e)
        {
            // This is to avoid Assertion failure in debug mode as internal ref count
            // equals 1 (CORBA C++ mapping oblige!)
            _set_ref_count(0);
            CDMW_LOG_FUNCTION_EXCEPTION(e);
            throw;
        }
    }

    // Destructor
    <%generatedExtensionServantClassname%>::~<%generatedExtensionServantClassname%>() throw()
    {
        CDMW_LOG_FUNCTION(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(), "");
    }

    /**
     * Home attributes
     */
    <%allAttributes.genOperationImpl(generatedExtensionServantClassname)%>

    /**
     * Explicit interface
     */
    <%allFactoryOperations.genOperationImpl(generatedExtensionServantClassname)%>


    //
    // Implicit interface
    //
    
    <%managedComponent.asReturnParameterDef%>
    <%generatedExtensionServantClassname%>::create()
        throw(Components::CreateFailure,
              CORBA::SystemException)
    {
        CDMW_LOG_FUNCTION(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(), "");
        check_is_removed(m_oid.in());

        // Create an empty config
        Components::ConfigValues config(0L);
        config.length(0L);


        Components::CCMObject_var cmp = create_component_with_config_values(config);
        <%managedComponent.asLocalVariable%> result = <%managedComponent.equivalentInterface%>::_narrow(cmp.in());
        return result._retn();
    }

    //
    // IDL:omg.org/Components/KeylessCCMHome/create_component:1.0
    //
    Components::CCMObject_ptr
    <%generatedExtensionServantClassname%>::create_component()
        throw(Components::CreateFailure,
              CORBA::SystemException)
    {
        CDMW_LOG_FUNCTION(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(), "");
        check_is_removed(m_oid.in());

        // Create an empty config
        Components::ConfigValues config(0L);
        config.length(0L);

        Components::CCMObject_var cmp = create_component_with_config_values(config);
        <%managedComponent.asLocalVariable%> result = <%managedComponent.equivalentInterface%>::_narrow(cmp.in());
        return result._retn();
    }

    //
    // IDL:omg.org/CdmwCcmCif/KeylessCCMHome/create_component_with_config_values:1.0
    //
    Components::CCMObject_ptr
    <%generatedExtensionServantClassname%>::create_component_with_config_values(const Components::ConfigValues& config)
        throw(Components::CreateFailure,
              CORBA::SystemException)
    {
        CDMW_LOG_FUNCTION(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(), 
                          "config.length="<<config.length());
        check_is_removed(m_oid.in());
        
        CORBA::Object_var obj = create_component_ref(config);
        <%managedComponent.asLocalVariable%> result = <%managedComponent.equivalentInterface%>::_narrow(obj.in());

        if (CORBA::is_nil(result.in()))
        {
            CDMW_ERROR(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(), 
                       "Created reference is not a <%managedComponent.equivalentInterface%>!");
            CORBA::INTERNAL ex(OrbSupport::INTERNALLifeCycleFrameworkError, CORBA::COMPLETED_NO);
            throw ex;
        }

 
        if (!CORBA::is_nil(m_configurator.in()))
        {
            try
            {
                // a configurator exist!
                m_configurator->configure(result.in());
            }
            catch (const Components::WrongComponentType& )
            {
                CDMW_ERROR(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(), 
                           "Cannot configure created component: wrong component type.");
                Components::CreateFailure ex(CdmwDeployment::WRONG_COMPONENT_KIND);
                CDMW_LOG_FUNCTION_EXCEPTION(ex);
                throw ex;
            }
        }
    
        return result._retn();
    }

    //
    // IDL:omg.org/CosLifeCycle/LifeCycleObject/remove:1.0
    //
    void
    <%generatedExtensionServantClassname%>::remove()
        throw(CosLifeCycle::NotRemovable,
              CORBA::SystemException)
    {
        CDMW_LOG_FUNCTION(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(), "");
        check_is_removed(m_oid.in());

        CCMHome_impl::remove();
         
        m_home_executor = <%equivalentLocalInterface%>::_nil();
    }


    //
    // ServantProvider abstract operation implementation
    //

    /**
     * This returns an array containing repository IDs of all objects
     * supported by the current ServantProvider.
     * <B>NOTA:</B> Repository IDs should be statically allocated; thus derived classes
     * should not delete return pointer(s).
     */
    const char ** 
    <%generatedExtensionServantClassname%>::get_ids() const
        throw()
    {
        CDMW_LOG_FUNCTION(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(), "");
        static const char* ids[] = {
            "IDL:omg.org/Components/Events:1.0",
            "IDL:omg.org/Components/Receptacles:1.0",
            "IDL:omg.org/Components/Navigation:1.0",
            "IDL:omg.org/Components/CCMObject:1.0",
            "<%managedComponent.ID%>",
            <%for (managedComponent.allBaseComponents + managedComponent.allSupportedInterfaces){%>
            "<%ID%>",
            <%}%>
            0
        };

        return ids;
    }


   
    /**
     * This returns the number of repository Ids supported by the current ServantProvider.
     * <B>NOTA:</B> This should correspond to the number of null terminated strings
     * returned by get_ids() operation.
     */
   
    CORBA::Long 
    <%generatedExtensionServantClassname%>::get_number_of_ids() const
        throw()
    {
        CDMW_LOG_FUNCTION(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(), "");
        
   
        static const CORBA::Long nb = <%4 + 1  + managedComponent.allBaseComponents.nSize + managedComponent.allSupportedInterfaces.nSize%>;

        CDMW_LOG_FUNCTION_RETURN(nb);
        return nb;
    }

    //
    // CdmwCCMHome abstract operation implementation
    //

    /**
     * Purpose:
     * <p>
     *   This creates new component servant.
     *   This shall be implemented by the well typed home servant.
     *
     * @param ctx      The component context
     * @param executor The component executor. It can null if component has been
     *                 created with a standard factory operation.
     * 
     * @return The new component servant.
     */
    PortableServer::Servant 
    <%generatedExtensionServantClassname%>::create_component_servant
            (const std::string&  comp_oid,
             Context*            ctx,
             ComponentInfo&      comp_info)
        throw(Components::CreateFailure,
              CORBA::SystemException)
    {
        CDMW_LOG_FUNCTION(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(), 
                          "comp_oid="<<comp_oid);
        check_is_removed(m_oid.in());

        try
        {
            // get COMPONENT_NAME from ConfigValues
            const char* component_name = 0;
            try {
                Components::ConfigValues_var config_values = 
                    ctx->get_config_values(comp_oid);
                for( CORBA::ULong i = 0; i < config_values->length(); i++ ) {
                    if( ! strcmp (::CdmwDeployment::COMPONENT_NAME, config_values[i]->name())) 
                    {
                        // extract COMPONENT_NAME
                        config_values[i]->value() >>= component_name;
                    }
                }
             
            } catch (const Cdmw::Common::NotFoundException& e) {
                // No config values for this component.
            }
         
            // create LoggerFactory with component name
            std::ostringstream component_log_name;
            if (component_name != 0) {
                component_log_name << component_name;
            } else {
                static int counter=0;
                component_log_name << "<%managedComponent.name%>"
                                   << "#" << ++counter;
            }
            CdmwLogging::LoggerFactory_var logger_factory =
                Cdmw::CCM::CIF::CCMUtils::Create_LoggerFactory(component_log_name.str().c_str());

             
            // Check if an executor has been created at ref creation
            // that is a factory operation has been used to create ref.
            Components::EnterpriseComponent_var comp_exec = comp_info.comp_exec;
            bool is_created_by_factory_operation = false;

            if (CORBA::is_nil(comp_exec.in()))
            {
                CDMW_INFO(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(),
                          "Create component executor " << component_log_name.str()); 
             
                // Create executor
                comp_exec = m_home_executor->create();
            
                if (CORBA::is_nil(comp_exec.in()))
                {
                    CDMW_ERROR(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(), 
                               "Component executor is nil!");
                    Components::CreateFailure ex(CdmwDeployment::INVALID_COMPONENT_EXECUTOR);
                    CDMW_LOG_FUNCTION_EXCEPTION(ex);
                    throw ex;
                }
            }
            else
            {
                is_created_by_factory_operation = true;
            }

            CDMW_INFO(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(),
                      "Create component servant " << component_log_name.str()); 
             
            return new <%managedComponent.generatedExtensionServantClassname%>(
                comp_oid, 
                ctx, 
                comp_info.comp_ref.in(), 
                comp_exec.in(),
                m_object_registration.in(),
                logger_factory.in(),
                is_created_by_factory_operation);
        }
        catch (const Components::CCMException& e)
        {
            CDMW_ERROR(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(), 
                       "CCMException occured during component executor creation: " << e);
            Components::CreateFailure ex(CdmwDeployment::CREATE_FAILURE);
            CDMW_LOG_FUNCTION_EXCEPTION(ex);
            throw ex;
        }
        catch (const CORBA::SystemException& e)
        {
            CDMW_ERROR(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(), 
                       "SystemException occured during component executor creation: " << e);
            CDMW_LOG_FUNCTION_EXCEPTION(e);
            throw;
        }
    }


<%closeNamespace(generatedServantPackage)%>


<%-- HomeAllocator::allocate implementation --%>
namespace Cdmw {
namespace CCM {
namespace Container {
   
    template <>
    PortableServer::Servant
    HomeAllocator< <%generatedExtensionServantFullClassname%> >::allocate
            (Components::HomeExecutorBase_ptr            home_executor,
             const Cdmw::LifeCycle::ObjectDeactivator & deactivator,
             CdmwLifeCycle::ObjectRegistration_ptr      object_registration,
             const Components::ConfigValues& config)
    throw(CORBA::SystemException,
          std::bad_alloc)
    {
        CDMW_LOG_FUNCTION(::Cdmw::CCM::CCMLoggers::Get_ccmgenerated_logger(), "");
        return new <%generatedExtensionServantFullClassname%>(home_executor, deactivator, object_registration, config);
    }   
   
}; // end of namespace Container
}; // end of namespace CCM
}; // end of namespace Cdmw


