<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.CommonServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.CppMappingServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.BasicTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.cpp.ComplexTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.cpp.IDLTypeFallback
import com.thalesgroup.ccm.codegenerator.corba.cpp.Utils
import com.thalesgroup.ccm.codegenerator.container.Utils
import com.thalesgroup.ccm.codegenerator.container.cpp.Names
import com.thalesgroup.ccm.codegenerator.container.cpp.Utils
import com.thalesgroup.ccm.codegenerator.container.cpp.SessionHome_hpp
%>

<%script type="idlmm.HomeDef" name="extensionFilePath" post="trim()"%>
<%generatedExtensionServantClassname%>.hpp

<%--
  -- Generation template  
  --%>
<%script type="idlmm.HomeDef" name="ExtensionHome_hpp" file="<%extensionFilePath%>"%>
<%copyrightHeader%>


<%openIfndefMacro(generatedExtensionServantFullClassname)%>

<%genIncludeCdmwCifSkelFile%>

#include <CCMContainer/ccmcif/CCMHome_impl.hpp>
#include <CCMContainer/ccmcif/HomeConfiguration_impl.hpp>
#include <CCMContainer/ccmcontainer/HomeAllocator.hpp>


<%openNamespace(generatedServantPackage)%>

    class <%generatedExtensionServantClassname%> : 
        virtual public POA_<%generatedContainerInterface.noColonPrefix%>,
        public CCMHome_impl,
        virtual public HomeConfiguration_impl
    {
    
        friend class Container::HomeAllocator< <%generatedExtensionServantClassname%> >;
        
        public:
            // Destructor
            ~<%generatedExtensionServantClassname%>() throw();
    
            /**
             * Home attributes
             */
            <%allAttributes.genOperationDef%>
    
            /**
             * Explicit interface
             */
            <%allFactoryOperations.genOperationDef%>
    
            /**
             * Implicit interface
             */
            virtual <%managedComponent.asReturnParameterDef%> 
            create()
                throw(Components::CreateFailure,
                      CORBA::SystemException);
    
            // Keyless home operation
            virtual Components::CCMObject_ptr 
            create_component()
                throw(Components::CreateFailure,
                      CORBA::SystemException);
    
            // CDMW Keyless home operation
            Components::CCMObject_ptr
            create_component_with_config_values(const Components::ConfigValues& config)
                throw(Components::CreateFailure,
                      CORBA::SystemException);
    
            /**
             * Purpose:
             * <p>This method acts as a hand shaking between the Servant Provider
             * and the generated Factory implementation. It indicates whether
             * a Servant provided by this Servant Provider may incarnate multiple
             * objects (with ObjectIds provided by this Servant Provider)
             *
             * @return <B>true</B> if a servant may incarnate multiple objects,
             * <B>false</B> otherwise.
             */
            virtual bool may_incarnate_multiple_objects() const throw()
            {
                return false;
            }
    
            virtual void remove()
                throw(CosLifeCycle::NotRemovable,
                      CORBA::SystemException);
    
    
        protected:
            // Constructor
            <%generatedExtensionServantClassname%>(Components::HomeExecutorBase_ptr home_exec,
                    const Cdmw::LifeCycle::ObjectDeactivator& deactivator,
                    CdmwLifeCycle::ObjectRegistration_ptr      object_registration,
                    const Components::ConfigValues& config)
                throw(CORBA::SystemException);
    
            /**
             * This returns an array containing repository IDs of all objects
             * supported by the current ServantProvider.
             * <B>NOTA:</B> Repository IDs should be statically allocated; thus derived classes
             * should not delete return pointer(s).
             */
            virtual const char ** get_ids() const throw();
    
            /**
             * This returns the number of repository Ids supported by the current ServantProvider.
             * <B>NOTA:</B> This should correspond to the number of null terminated strings
             * returned by get_ids() operation.
             */
            virtual CORBA::Long get_number_of_ids() const throw();
    
            /**
             * Purpose:
             * <p>
             *   This creates new component servant.
             *   This shall be implemented by the well typed home servant.
             *
             * @param ctx      The component context
             * @param executor The component executor
             *
             * @return The new component servant.
             * @exception Components::CreateFailure if a problem occured when creating executor.
             * @exception Any CORBA Exception
             *
             */
            virtual PortableServer::Servant
            create_component_servant(const std::string&  comp_oid,
                                     Context*            ctx,
                                     ComponentInfo&      comp_info)
                throw(Components::CreateFailure,
                      CORBA::SystemException);
    
    
        private:
            <%generatedExtensionServantClassname%>(const <%generatedExtensionServantClassname%>&);
            void operator=(const <%generatedExtensionServantClassname%>&);
    
            // Home executor
            <%equivalentLocalInterface%>_var m_home_executor;
    };
            
<%closeNamespace(generatedServantPackage)%>



namespace Cdmw {
namespace CCM {
namespace Container {

    template <>
    PortableServer::Servant
    HomeAllocator< <%generatedExtensionServantFullClassname%> >::allocate(
            Components::HomeExecutorBase_ptr            home_executor,
            const Cdmw::LifeCycle::ObjectDeactivator & deactivator,
            CdmwLifeCycle::ObjectRegistration_ptr      object_registration,
            const Components::ConfigValues& config)
        throw(CORBA::SystemException,
              std::bad_alloc);

}; // end of namespace Container
}; // end of namespace CCM
}; // end of namespace Cdmw


<%closeIfndefMacro(generatedExtensionServantFullClassname)%>



