<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.Utils
import com.thalesgroup.ccm.codegenerator.corba.CommonServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.CppMappingServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.BasicTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.cpp.ComplexTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.cpp.IDLTypeFallback
import com.thalesgroup.ccm.codegenerator.corba.cpp.Utils
import com.thalesgroup.ccm.codegenerator.container.Utils
import com.thalesgroup.ccm.codegenerator.container.cpp.Names
import com.thalesgroup.ccm.codegenerator.container.cpp.Utils
%>

<%script type="idlmm.InterfaceDef" name="filePath" post="trim()"%>
<%generatedFacetServantClassname%>.cpp

<%--
  -- Generation template  
  --%>
<%script type="idlmm.InterfaceDef" name="Facet_cpp" file="<%filePath%>"%>
<%copyrightHeader%>

#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/ExceptionMinorCodes.hpp>
#include <Foundation/logging/FunctionLogger.hpp>

#include "<%generatedFacetServantClassname%>.hpp"

<%openNamespace(generatedFacetServantPackage)%>

    <%generatedFacetServantClassname%>::<%generatedFacetServantClassname%>
            (Components::ExecutorLocator_ptr exec_locator, 
             const std::string&              name,
             Context*                        ctx,
             CORBA::Object_ptr               comp_ref,
             PortableServer::Servant         component,
             CdmwLogging::Logger_ptr         logger)
        : LifeCycleObjectBase(ctx),
          m_executor_locator(Components::ExecutorLocator::_duplicate(exec_locator)),
            m_facet_name(name),
            m_comp_ref(CORBA::Object::_duplicate(comp_ref)),
            m_component(component),
            m_logger(CdmwLogging::Logger::_duplicate(logger))
    {
        CDMW_LOG_FUNCTION(m_logger.in(), "name="<<name);
        // incrementation refcount of component in order to avoid destruction
        // of the component before the destruction of the facet
        m_component->_add_ref();
    }

    <%generatedFacetServantClassname%>::~<%generatedFacetServantClassname%>() throw ()
    {
        CDMW_LOG_FUNCTION(m_logger.in(), "m_facet_name="<<m_facet_name);
        // no remove_ref on component while it's done in var destructor
    }

    CORBA::Object_ptr
    <%generatedFacetServantClassname%>::_get_component()
    {
        CDMW_LOG_FUNCTION(m_logger.in(), "");
        return CORBA::Object::_duplicate(m_comp_ref.in());
    }

    <%--
        Facet's attributes.
        NOTA: This should also include inherited attributes.
    --%>
    <%self.push()%>
    <%allAttributes.genAttributeOperations.sep("\n\n")%>
    <%pop()%>

    <%--
        Facet's operations.
        NOTA: This should also include inherited operations.
    --%>
    <%self.push()%>
    <%allOperations.genOperationImpl.sep("\n\n")%>
    <%pop()%>

<%closeNamespace(generatedFacetServantPackage)%>



<%script type="idlmm.AttributeDef" name="genAttributeOperations"%>
<%type.asReturnParameterDef%> <%peek.generatedFacetServantClassname%>::<%cppName%>()
    throw(<%for (getExceptions){%><%cppFullClassname%>, <%}%>CORBA::SystemException)
{
    CDMW_LOG_FUNCTION(m_logger.in(), "");
    try
    {
        CORBA::Object_var obj = m_executor_locator->obtain_executor(m_facet_name.c_str());
    
        if (CORBA::is_nil(obj.in()))
        {
            CDMW_ERROR(m_logger.in(), 
                "Executor for facet " <<m_facet_name<< " is nil");
            CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST, 
                                       CORBA::COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(ex);
            throw ex;
        }
    
        <%peek.equivalentLocalInterface%>_var facet_exec = 
            <%peek.equivalentLocalInterface%>::_narrow(obj.in());
    
        if (CORBA::is_nil(facet_exec.in()))
        {
            CDMW_ERROR(m_logger.in(), 
                "Executor for facet " <<m_facet_name<< " has wrong type");
            CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST, 
                                       CORBA::COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(ex);
            throw ex;
        }
    
        <%type.asLocalVariable%> result = facet_exec-><%cppName%>();
    
        m_executor_locator->release_executor(facet_exec.in());
    
        return result<%type.localVarReturnSuffix%>;
    }
    catch (const Components::CCMException& e )
    {
        CDMW_ERROR(m_logger.in(), 
            "CCMException received: "<< e);
        CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, 
                           CORBA::COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(ex);
        throw ex;
    }
}

<%if (mode != "ATTR_READONLY"){%>
void <%peek.generatedFacetServantClassname%>::<%cppName%>(<%type.asInParameterDef%> <%cppName%>)
    throw(<%for (setExceptions){%><%cppFullClassname%>, <%}%>CORBA::SystemException)
{
    CDMW_LOG_FUNCTION(m_logger.in(), "");
    try
    {
        CORBA::Object_var obj = m_executor_locator->obtain_executor(m_facet_name.c_str());
    
        if (CORBA::is_nil(obj.in()))
        {
            CDMW_ERROR(m_logger.in(), 
                "Executor for facet " <<m_facet_name<< " is nil");
            CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST, 
                                       CORBA::COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(ex);
            throw ex;
        }
    
        <%peek.equivalentLocalInterface%>_var facet_exec = 
            <%peek.equivalentLocalInterface%>::_narrow(obj.in());
    
        if (CORBA::is_nil(facet_exec.in()))
        {
            CDMW_ERROR(m_logger.in(), 
                "Executor for facet " <<m_facet_name<< " has wrong type");
            CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST, 
                                       CORBA::COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(ex);
            throw ex;
        }
    
        facet_exec-><%cppName%>(<%cppName%>);
    
        m_executor_locator->release_executor(facet_exec.in());
    }
    catch (const Components::CCMException& e )
    {
        CDMW_ERROR(m_logger.in(), 
            "CCMException received: "<< e);
        CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, 
                           CORBA::COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(ex);
        throw ex;
    }
}
<%}%>



<%script type="idlmm.OperationDef" name="genOperationImpl"%>
   <%-- REQUIRES parent interface in context
        (containingInterface cannot be used since
         attribute could come from an inherited interface) 
   --%>
<%genOperationSignatureWithClassname(peek.generatedFacetServantClassname)%>
{
    CDMW_LOG_FUNCTION(m_logger.in(), "");
    try
    {
        CORBA::Object_var obj = m_executor_locator->obtain_executor(m_facet_name.c_str());
    
        if (CORBA::is_nil(obj.in()))
        {
            CDMW_ERROR(m_logger.in(), 
                "Executor for facet " <<m_facet_name<< " is nil");
            CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST, 
                                       CORBA::COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(ex);
            throw ex;
        }
        
        <%peek.equivalentLocalInterface%>_var facet_exec = 
            <%peek.equivalentLocalInterface%>::_narrow(obj.in());
        
        if (CORBA::is_nil(facet_exec.in()))
        {
            CDMW_ERROR(m_logger.in(), 
                "Executor for facet " <<m_facet_name<< " has wrong type");
            CORBA::OBJECT_NOT_EXIST ex(OrbSupport::OBJECT_NOT_EXIST, 
                                       CORBA::COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(ex);
            throw ex;
        }
    
        <%if (! type.isVoid){%>
        <%type.asLocalVariable%> __result =
        <%}%>   
        facet_exec-><%cppName%>(<%parameters.cppName.sep(", ")%>);
        
        m_executor_locator->release_executor(facet_exec.in());
        
        <%if (! type.isVoid){%>
        return __result<%type.localVarReturnSuffix%>;
        <%}%>   
    }
    catch (const Components::CCMException& e )
    {
        CDMW_ERROR(m_logger.in(), 
            "CCMException received: "<< e);
        CORBA::INTERNAL ex(OrbSupport::INTERNALCCMCIFError, 
                           CORBA::COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(ex);
        throw ex;
    }
}
   