<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.CommonServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.CppMappingServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.BasicTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.cpp.ComplexTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.cpp.IDLTypeFallback
import com.thalesgroup.ccm.codegenerator.corba.cpp.Utils
import com.thalesgroup.ccm.codegenerator.container.Utils
import com.thalesgroup.ccm.codegenerator.container.cpp.Names
import com.thalesgroup.ccm.codegenerator.container.cpp.Utils
%>

<%script type="idlmm.InterfaceDef" name="filePath" post="trim()"%>
<%generatedFacetServantClassname%>.hpp

<%--
  -- Generation template  
  --%>
<%script type="idlmm.InterfaceDef" name="Facet_hpp" file="<%filePath%>"%>
<%copyrightHeader%>

<%openIfndefMacro(generatedFacetServantFullClassname)%>

<%genIncludeCdmwCifSkelFile%>

#include <Foundation/orbsupport/RefCountServantBase.hpp>
#include <Foundation/logging/CdmwLogging.stub.hpp>
#include <CCMContainer/ccmcif/LifeCycleObjectBase.hpp>


<%openNamespace(generatedPackage)%>

    // Forward declaration
    class CCMObject_impl;

<%closeNamespace(generatedPackage)%>


<%openNamespace(generatedFacetServantPackage)%>

    class <%generatedFacetServantClassname%> : virtual public POA_<%generatedContainerInterface.noColonPrefix%>,
        virtual public LifeCycleObjectBase,
        virtual public OrbSupport::RefCountServantBase
    {
        public:
            <%generatedFacetServantClassname%>(
               Components::ExecutorLocator_ptr exec_locator, 
               const std::string&              name,
               Context*                        ctx,
               CORBA::Object_ptr               comp_ref,
               PortableServer::Servant         component,
               CdmwLogging::Logger_ptr         logger);
         
            ~<%generatedFacetServantClassname%>() throw();

            virtual CORBA::Object_ptr _get_component();

            <%--
                Create operation declarations for attributes.
                NOTA: This should also include inherited attributes.
            --%>
            <%allAttributes.genAttributeOperations.sep("\n\n")%>
         
            <%--
                Create operation declarations.
                NOTA: This should also include inherited operations.
            --%>
            <%allOperations.genOperationDef.sep("\n\n")%>

        protected:
            Components::ExecutorLocator_var  m_executor_locator;
            const std::string                m_facet_name;

            CORBA::Object_var                m_comp_ref;
            PortableServer::ServantBase_var  m_component;
         
            CdmwLogging::Logger_var          m_logger;

        private:
            <%generatedFacetServantClassname%>(const <%generatedFacetServantClassname%>&);
            void operator=(const <%generatedFacetServantClassname%>&);

    };

<%closeNamespace(generatedFacetServantPackage)%>

<%closeIfndefMacro(generatedFacetServantFullClassname)%>



<%script type="idlmm.AttributeDef" name="genAttributeOperations"%>
virtual <%type.asReturnParameterDef%> <%cppName%>()
    throw(<%for (getExceptions){%><%cppFullClassname%>, <%}%>CORBA::SystemException);
<%if (mode != "ATTR_READONLY"){%>
virtual void <%cppName%>(<%type.asInParameterDef%> <%cppName%>)
    throw(<%for (setExceptions){%><%cppFullClassname%>, <%}%>CORBA::SystemException);
<%}%>


<%script type="idlmm.OperationDef" name="genOperationDef"%>
virtual <%genOperationSignature%>;
