<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.container.CommonServices
import com.thalesgroup.ccm.codegenerator.container.cpp.SessionHome_hpp
import com.thalesgroup.ccm.codegenerator.container.cpp.SessionHome_cpp
import com.thalesgroup.ccm.codegenerator.container.cpp.SessionComponent_hpp
import com.thalesgroup.ccm.codegenerator.container.cpp.SessionComponent_cpp
import com.thalesgroup.ccm.codegenerator.container.cpp.SessionContext_hpp
import com.thalesgroup.ccm.codegenerator.container.cpp.SessionContext_cpp
import com.thalesgroup.ccm.codegenerator.container.cpp.ExtensionHome_hpp
import com.thalesgroup.ccm.codegenerator.container.cpp.ExtensionHome_cpp
import com.thalesgroup.ccm.codegenerator.container.cpp.ExtensionComponent_hpp
import com.thalesgroup.ccm.codegenerator.container.cpp.ExtensionComponent_cpp
import com.thalesgroup.ccm.codegenerator.container.cpp.ExtensionContext_hpp
import com.thalesgroup.ccm.codegenerator.container.cpp.ExtensionContext_cpp
import com.thalesgroup.ccm.codegenerator.container.cpp.Facet_hpp
import com.thalesgroup.ccm.codegenerator.container.cpp.Facet_cpp
import com.thalesgroup.ccm.codegenerator.container.cpp.Consumer_hpp
import com.thalesgroup.ccm.codegenerator.container.cpp.Consumer_cpp
import com.thalesgroup.ccm.codegenerator.container.cpp.COPIFacet_hpp
import com.thalesgroup.ccm.codegenerator.container.cpp.COPIFacet_cpp
import com.thalesgroup.ccm.codegenerator.container.cpp.COPIReceptacle_hpp
import com.thalesgroup.ccm.codegenerator.container.cpp.COPIReceptacle_cpp
%>


<%script type="idlmm.Repository" name="GenerateAll"%>
<%-- store Repository in context --%>
<%put("Repository")%>

<%-- get all homes from model and store in context --%>
<%eAllContents("idlmm.Home").put("AllHomes")%>

<%-- iterate over selected homes --%>
<%for (selectedHomes){%>
    
    <%-- store selected home --%>
    <%put("selectedHome")%>
    <%trace("selectedHome")%>
    
    <%-- Search in all homes the selected one and store it in context--%>
    <%for (get("AllHomes")){%>
        <%if (absoluteName == get("selectedHome")){%>
            <%push()%>
        <%}%>
    <%}%>
    
    <%peek.trace("foundHome")%>

    <%if (peek == ""){%>
        HOME NOT FOUND: <%get("selectedHome")%>
    
    <%}else{%>
        <%-- Always generate code for session container --%>
        <%-- generate home code --%>
            <%peek.trace("generate Session Home")%>
        <%peek.SessionHome%>
        <%-- generate component code --%>
            <%peek.managedComponent.trace("generate Session Component")%>
        <%peek.managedComponent.SessionComponent_hpp%>
        <%peek.managedComponent.SessionComponent_cpp%>
        <%-- generate context code --%>
            <%peek.managedComponent.trace("generate Session Context")%>
        <%peek.managedComponent.SessionContext_hpp%>
        <%peek.managedComponent.SessionContext_cpp%>
    
        <%if (getContainerType == "EXTENSION"){%>
            <%-- generate home code --%>
                <%peek.trace("generate Extension Home")%>
            <%peek.ExtensionHome_hpp%>
            <%-- generate component code --%>
                <%peek.managedComponent.trace("generate Extension Component")%>
            <%peek.managedComponent.ExtensionComponent_hpp%>
            <%peek.managedComponent.ExtensionComponent_cpp%>
            <%-- generate context code --%>
                <%peek.managedComponent.trace("generate Extension Context")%>
            <%peek.managedComponent.ExtensionContext_hpp%>
            <%peek.managedComponent.ExtensionContext_cpp%>
        <%}%>
    
        <%-- generate all facets code --%>
            <%peek.managedComponent.allProvidesPorts.interface_type.trace("generate Facets")%>
        <%peek.managedComponent.allProvidesPorts.interface_type.Facet_hpp%>
        <%peek.managedComponent.allProvidesPorts.interface_type.Facet_cpp%>
        <%-- generate all consumers code --%>
            <%peek.managedComponent.allConsumesPorts.event.trace("generate Consumers")%>
        <%peek.managedComponent.allConsumesPorts.event.Consumer_hpp%>
        <%peek.managedComponent.allConsumesPorts.event.Consumer_cpp%>
    
        <%-- generate all facets code (with interception) --%>
            <%peek.managedComponent.allProvidesPorts.interface_type.trace("generate COPIFacets")%>
        <%peek.managedComponent.allProvidesPorts.interface_type.COPIFacet_hpp%>
        <%peek.managedComponent.allProvidesPorts.interface_type.COPIFacet_cpp%>
        <%-- generate all receptacle code (with interception) --%>
            <%peek.managedComponent.allUsesPorts.interface_type.trace("generate COPIReceptacles")%>
        <%peek.managedComponent.allUsesPorts.interface_type.COPIReceptacle_hpp%>
        <%peek.managedComponent.allUsesPorts.interface_type.COPIReceptacle_cpp%>
    
        <%-- remove selected home from context --%>
        <%pop()%>
    <%}%>
    
<%}%>

