<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.Utils
import com.thalesgroup.ccm.codegenerator.corba.cpp.Utils
import com.thalesgroup.ccm.codegenerator.corba.cpp.CppMappingServices
import com.thalesgroup.ccm.codegenerator.container.Utils
%>

<%-- 
  -- Constants prefix for Cardamom specific generated types 
  --%>
<%script type="idlmm.IRObject" name="generatedPrefix" post="trim()"%>
thalesgroup.com

<%script type="idlmm.IRObject" name="generatedPackage" post="trim()"%>
::Cdmw::CCM::CIF

<%script type="idlmm.IRObject" name="generatedEventPackage" post="trim()"%>
::Cdmw::Event


<%-- 
  -- Scripts for HomeDef
  --%>

<%-- equivalent IDL2 external interface --%>
<%script type="idlmm.HomeDef" name="equivalentInterface" post="trim()"%>
    <%cppFullClassname%>
    
<%-- equivalent IDL2 local interface for executor --%>
<%script type="idlmm.HomeDef" name="equivalentLocalInterface" post="trim()"%>
    <%cppScope%>::CCM_<%name%>
    
<%-- generated IDL2 container interface --%>
<%script type="idlmm.HomeDef" name="generatedContainerInterface" post="trim()"%>
    ::Cdmw_<%cppFullClassname.noColonPrefix%>

<%-- generated IDL2 container interface repository ID --%>
<%script type="idlmm.HomeDef" name="generatedContainerInterfaceRepID" post="trim()"%>
    <%-- add Cdmw_ before first module => replace first "/" in original RepositoryID with "/Cdmw_" --%>
    <%ID.replaceFirst("/", "/Cdmw_")%>

<%-- generated servant package --%>
<%script type="idlmm.HomeDef" name="generatedServantPackage" post="trim()"%>
    <%generatedPackage%>::Cdmw<%cppScope.noColonPrefix%>
    
<%-- generated servant classname (SESSION) --%>
<%script type="idlmm.HomeDef" name="generatedSessionServantClassname" post="trim()"%>
    Session<%name%>_impl

<%-- generated servant full classname (SESSION) --%>
<%script type="idlmm.HomeDef" name="generatedSessionServantFullClassname" post="trim()"%>
    <%generatedServantPackage%>::<%generatedSessionServantClassname%>

<%-- generated servant classname (EXTENSION) --%>
<%script type="idlmm.HomeDef" name="generatedExtensionServantClassname" post="trim()"%>
    Extension<%name%>_impl

<%-- generated servant full classname (EXTENSION) --%>
<%script type="idlmm.HomeDef" name="generatedExtensionServantFullClassname" post="trim()"%>
    <%generatedServantPackage%>::<%generatedExtensionServantClassname%>



<%-- 
  -- Scripts for ComponentDef
  --%>

<%-- equivalent IDL2 external interface --%>
<%script type="idlmm.ComponentDef" name="equivalentInterface" post="trim()"%>
    <%cppFullClassname%>
    
<%-- equivalent IDL2 local interface for executor --%>
<%script type="idlmm.ComponentDef" name="equivalentLocalInterface" post="trim()"%>
    <%cppScope%>::CCM_<%name%>
    
<%-- generated servant package --%>
<%script type="idlmm.ComponentDef" name="generatedServantPackage" post="trim()"%>
    <%generatedPackage%>::Cdmw<%cppScope.noColonPrefix%>
    
<%-- generated servant classname (SESSION) --%>
<%script type="idlmm.ComponentDef" name="generatedSessionServantClassname" post="trim()"%>
    Session<%name%>_impl

<%-- generated servant full classname (SESSION) --%>
<%script type="idlmm.ComponentDef" name="generatedSessionServantFullClassname" post="trim()"%>
    <%generatedServantPackage%>::<%generatedSessionServantClassname%>

<%-- generated servant classname (EXTENSION) --%>
<%script type="idlmm.ComponentDef" name="generatedExtensionServantClassname" post="trim()"%>
    Extension<%name%>_impl

<%-- generated servant full classname (EXTENSION) --%>
<%script type="idlmm.ComponentDef" name="generatedExtensionServantFullClassname" post="trim()"%>
    <%generatedServantPackage%>::<%generatedExtensionServantClassname%>


<%-- 
  -- Scripts for Component Context
  --%>
  
<%-- generated IDL2 local interface for session context --%>
<%script type="idlmm.ComponentDef" name="generatedSessionContextInterface" post="trim()"%>
    ::Cdmw_<%cppScope.noColonPrefix%>::CCM_<%name%>_SessionContext
    
<%-- generated IDL2 local interface for extension context --%>
<%script type="idlmm.ComponentDef" name="generatedExtensionContextInterface" post="trim()"%>
    ::Cdmw_<%cppScope.noColonPrefix%>::CCM_<%name%>_ExtensionContext
    
<%-- generated context package --%>
<%script type="idlmm.ComponentDef" name="generatedContextPackage" post="trim()"%>
    <%generatedPackage%>::Cdmw<%cppScope.noColonPrefix%>
    
<%-- generated context classname (SESSION) --%>
<%script type="idlmm.ComponentDef" name="generatedSessionContextClassname" post="trim()"%>
    CCM_<%name%>_SessionContext_impl

<%-- generated context full classname (SESSION) --%>
<%script type="idlmm.ComponentDef" name="generatedSessionContextFullClassname" post="trim()"%>
    <%generatedContextPackage%>::<%generatedSessionContextClassname%>

<%-- generated context classname (EXTENSION) --%>
<%script type="idlmm.ComponentDef" name="generatedExtensionContextClassname" post="trim()"%>
    CCM_<%name%>_ExtensionContext_impl

<%-- generated context full classname (EXTENSION) --%>
<%script type="idlmm.ComponentDef" name="generatedExtensionContextFullClassname" post="trim()"%>
    <%generatedContextPackage%>::<%generatedExtensionContextClassname%>




<%-- 
  -- Scripts for Provides ports
  --%>

<%-- equivalent IDL2 local interface for executor --%>
<%script type="idlmm.Interface" name="equivalentLocalInterface" post="trim()"%>
    <%cppScope%>::CCM_<%name%>
    
<%-- generated IDL2 container interface --%>
<%script type="idlmm.Interface" name="generatedContainerInterface" post="trim()"%>
    ::Cdmw_<%cppScope.noColonPrefix%>::<%cppName%>

<%-- generated servant package --%>
<%script type="idlmm.Interface" name="generatedFacetServantPackage" post="trim()"%>
    <%generatedPackage%>::Cdmw<%cppScope.noColonPrefix%>
    
<%-- generated servant classname --%>
<%script type="idlmm.Interface" name="generatedFacetServantClassname" post="trim()"%>
    <%name%>_impl

<%-- generated servant full classname --%>
<%script type="idlmm.Interface" name="generatedFacetServantFullClassname" post="trim()"%>
    <%generatedFacetServantPackage%>::<%generatedFacetServantClassname%>

<%-- generated servant (with interception) package --%>
<%script type="idlmm.Interface" name="generatedCOPIFacetServantPackage" post="trim()"%>
    <%generatedPackage%>::Cdmw<%cppScope.noColonPrefix%>
    
<%-- generated servant (with interception) classname --%>
<%script type="idlmm.Interface" name="generatedCOPIFacetServantClassname" post="trim()"%>
    Facet<%name%>_impl

<%-- generated servant (with interception) full classname --%>
<%script type="idlmm.Interface" name="generatedCOPIFacetServantFullClassname" post="trim()"%>
    <%generatedCOPIFacetServantPackage%>::<%generatedCOPIFacetServantClassname%>


<%-- 
  -- Scripts for Receptacle ports
  --%>

<%-- generated receptacle object (with interception) package --%>
<%script type="idlmm.Interface" name="generatedCOPIReceptaclePackage" post="trim()"%>
    <%generatedPackage%>::Cdmw<%cppScope.noColonPrefix%>
    
<%-- generated receptacle object (with interception) classname --%>
<%script type="idlmm.Interface" name="generatedCOPIReceptacleClassname" post="trim()"%>
    Receptacle<%name%>_impl

<%-- generated receptacle object (with interception) full classname --%>
<%script type="idlmm.Interface" name="generatedCOPIReceptacleFullClassname" post="trim()"%>
    <%generatedCOPIReceptaclePackage%>::<%generatedCOPIReceptacleClassname%>



<%-- 
  -- Scripts for Consumers
  --%>

<%-- equivalent IDL2 external consumer interface --%>
<%script type="idlmm.Event" name="equivalentConsumer" post="trim()"%>
    <%cppFullClassname%>Consumer
    
<%-- equivalent IDL2 local consumer interface --%>
<%script type="idlmm.Event" name="equivalentLocalConsumer" post="trim()"%>
    <%cppScope%>::CCM_<%name%>Consumer

<%-- generated IDL2 interface for consumer --%>
<%script type="idlmm.Event" name="generatedConsumerInterface" post="trim()"%>
    ::Cdmw_<%cppScope.noColonPrefix%>::<%name%>Consumer
    
<%-- generated consumer servant package --%>    
<%script type="idlmm.Event" name="generatedConsumerPackage" post="trim()"%>
    <%generatedPackage%>::Cdmw<%cppScope.noColonPrefix%>
    
<%-- generated consumer servant classname --%>  
<%script type="idlmm.Event" name="generatedConsumerClassname" post="trim()"%>
    <%name%>Consumer_impl
    
<%-- generated consumer servant full classname --%>  
<%script type="idlmm.Event" name="generatedConsumerFullClassname" post="trim()"%>
    <%generatedConsumerPackage%>::<%generatedConsumerClassname%>
    


<%--
  -- Scripts for COPI
  --%>
<%script type="idlmm.OperationDef" name="generatedCOPIRequestClassname" post="trim()"%>
   <%name.toU1Case%>Request_impl
   
 
