<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.cpp.CppMappingServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.Utils
import com.thalesgroup.ccm.codegenerator.container.Utils
import com.thalesgroup.ccm.codegenerator.container.cpp.Utils
import com.thalesgroup.ccm.codegenerator.container.cpp.Names
%>

<%script type="idlmm.ComponentDef" name="sessionFilePath" post="trim()"%>
<%generatedSessionServantClassname%>.hpp    

<%--
  -- Generation template  
  --%>
<%script type="idlmm.ComponentDef" name="SessionComponent_hpp" file="<%sessionFilePath%>"%>
<%copyrightHeader%>

<%openIfndefMacro(generatedSessionServantClassname)%>

<%genIncludeCdmwCifSkelFile%>

#include <CCMContainer/ccmcif/CCMObject_impl.hpp>
#include <CCMContainer/ccmcif/DefaultCCMObjectStates.hpp>


<%openNamespace(generatedServantPackage)%>

    /**
     * Session component
     */
    class <%generatedSessionServantClassname%> : virtual public POA_<%equivalentInterface.noColonPrefix%>,
                                                 virtual public CCMObject_impl
    {
        public:
            <%generatedSessionServantClassname%>(const std::string& comp_oid,
                    Context*                              ctx,
                    CORBA::Object_ptr                     comp_ref,
                    Components::EnterpriseComponent*      executor,
                    CdmwLifeCycle::ObjectRegistration_ptr object_registration,
                    CdmwLogging::LoggerFactory_ptr        logger_factory,
                    bool                                  is_created_by_factory_operation)
                throw (Components::CCMException,
                       CORBA::SystemException);

            ~<%generatedSessionServantClassname%>();
            
            /**
             * Component attributes
             */
            <%allAttributes.genAttributeOperations%>
            
            /**
             * Supported interfaces
             */
            <%allSupportedInterfaces.operations.genOperationDef%>

            /**
             * Equivalent IDL methods
             */

            // Facets
            <%allProvidesPorts.genEquivalentOperations.sep("\n\n")%>

            // Receptacles
            <%allUsesPorts.genEquivalentOperations.sep("\n\n")%>

            // Consumers
            <%allConsumesPorts.genEquivalentOperations.sep("\n\n")%>

            // Publishers
            <%allPublishesPorts.genEquivalentOperations.sep("\n\n")%>

            // Emitters
            <%allEmitsPorts.genEquivalentOperations.sep("\n\n")%>
    
            /**
             * Inherited CCMObject interface implemented by CCMObject_impl
             */
            virtual void
            configuration_complete()
                throw(Components::InvalidConfiguration,
                      CORBA::SystemException);

            /**
             * Inherited Events interface implemented by CCMObject_impl
             */
             
            /**
             * Purpose:
             * <p>This returns the servant for the facet specified by facet_name.
             * This operation is implemented by the well typed component servant.
             *
             * @param facet_name The facet name
             *
             * @return the facet servant.
             */
            virtual PortableServer::Servant
            get_facet_servant(const std::string& facet_name)
               throw (CORBA::SystemException);
               
            /**
             * Purpose:
             * <p>In case of a session component, this operation will call 
             * it's executor's ccm_activate operation.
             *
             *@exception Components::CCMException Any CCMException thrown by the
             * executor's ccm_activate operation.
             *@exception CORBA::SystemException Any SystemException thrown by the
             * executor's ccm_activate operation.
             */ 
            virtual void 
            ccm_activate() 
                throw (Components::CCMException, CORBA::SystemException);
               
            /**
             * Purpose:
             * <p>In case of a session component, this operation will call 
             * it's executor's ccm_passivate operation.
             *
             *@exception Components::CCMException Any CCMException thrown by the
             * executor's ccm_passivate operation.
             *@exception CORBA::SystemException Any SystemException thrown by the
             * executor's ccm_passivate operation.
             */ 
            virtual void 
            ccm_passivate() 
                throw (Components::CCMException, CORBA::SystemException);
               
            /**
             * Purpose:
             * <p>In case of a session component, this operation will call 
             * it's executor's ccm_remove operation.
             *
             *@exception Components::CCMException Any CCMException thrown by the
             * executor's ccm_remove operation.
             *@exception CORBA::SystemException Any SystemException thrown by the
             * executor's ccm_remove operation.
             */ 
            virtual void 
            ccm_remove() 
                throw (Components::CCMException, CORBA::SystemException);

            /**
             * This returns the local object for the receptacle specified by receptacle_name.
             * This operation is implemented by the well typed component servant.
             *
             * @param receptacle_name The Receptacle name
             * @param facet_object The remote facet reference 
             *
             * @return the receptacle local object or null if the component has no receptacles.
             */         
            virtual ::CORBA::LocalObject * 
            get_receptacle_object(const char * receptacle_name, CORBA::Object * facet_object)
               throw (::CORBA::SystemException);
       

        protected:
            // Return the component executor
            <%equivalentLocalInterface%>_ptr
            obtain_component_executor()
                throw (CORBA::SystemException);

            // Call ccm_passivate and ccm_remove on executor
            void advise_executor_of_remove_component()
                throw (CORBA::SystemException);

            // return true if configuration complete has already been called
            inline bool is_configured() {
                return (m_state == Cdmw::CCM::CIF::CCM_OBJECT_STATE_FULLY_ACTIVATED);
            }


        private:
            <%generatedSessionServantClassname%>(const <%generatedSessionServantClassname%>&);
            void operator=(const <%generatedSessionServantClassname%>&);

            /**
             * Attributes
             */

            /**
             * If a home, in creating a component, returns an ExecutorLocator, the cif
             * will invoke its obtain_executor operation prior to each invocation to
             * retrieve the implementation for a port. If the home returns an
             * EnterpriseComponent, we encapsulate it in an executor locator in order to
             * use same code.
             *
             */

            // <%name%> executor locator used to get component exec and facet exec
            Components::ExecutorLocator_var   m_executor_locator;
         
            // executor locator must be a session component to be advise of its activation, passivation 
            // and removal
            Components::SessionComponent_var  m_session_locator;
    
            // set to true when component is activated
            bool m_is_activated;
    
            // <%name%> context executor
            <%generatedSessionContextInterface%>_var  m_context_executor;

            // Indicates if current component has been created via a factory operation
            bool m_is_created_by_factory_operation;
         
            CdmwLogging::Logger_var m_logger;   // Logger for logging
    
            <%for (allAttributes[mode != "ATTR_READONLY"]){%>
            bool m_is_<%name%>_configured;
            <%}%>
    };

<%closeNamespace(generatedServantPackage)%>

<%closeIfndefMacro(generatedSessionServantClassname)%>




<%script type="idlmm.AttributeDef" name="genAttributeOperations"%>
virtual <%type.asReturnParameterDef%> <%cppName%>()
    throw(<%for (getExceptions){%><%cppFullClassname%>, <%}%>CORBA::SystemException);
<%if (mode != "ATTR_READONLY"){%>
virtual void <%cppName%>(<%type.asInParameterDef%>)
    throw(<%for (setExceptions){%><%cppFullClassname%>, <%}%>CORBA::SystemException);
<%}%>


<%script type="idlmm.OperationDef" name="genOperationDef"%>
virtual <%genOperationSignature%>;


<%script type="idlmm.ProvidesDef" name="genEquivalentOperations"%>
virtual <%interface_type.asReturnParameterDef%> provide_<%name%>()
    throw(CORBA::SystemException);


<%script type="idlmm.UsesDef" name="genEquivalentOperations"%>
virtual void connect_<%name%>(<%interface_type.asInParameterDef%> conxn)
    throw(Components::AlreadyConnected, Components::InvalidConnection, CORBA::SystemException);
virtual <%interface_type.asReturnParameterDef%> disconnect_<%name%>()
    throw(Components::NoConnection, CORBA::SystemException);
virtual <%interface_type.asReturnParameterDef%> get_connection_<%name%>()
    throw(CORBA::SystemException);


<%script type="idlmm.ConsumesDef" name="genEquivalentOperations"%>
virtual <%event.equivalentConsumer%>_ptr get_consumer_<%name%>()
    throw(CORBA::SystemException);

    
<%script type="idlmm.PublishesDef" name="genEquivalentOperations"%>
virtual Components::Cookie* subscribe_<%name%>(<%event.equivalentConsumer%>_ptr consumer)
    throw(Components::ExceededConnectionLimit, CORBA::SystemException);
virtual <%event.equivalentConsumer%>_ptr unsubscribe_<%name%>(Components::Cookie* ck)
    throw(Components::InvalidConnection, CORBA::SystemException);
    

<%script type="idlmm.EmitsDef" name="genEquivalentOperations"%>
virtual void connect_<%name%>(<%event.equivalentConsumer%>_ptr consumer)
    throw(::Components::AlreadyConnected, CORBA::SystemException);
virtual <%event.equivalentConsumer%>_ptr disconnect_<%name%>()
    throw(Components::NoConnection, CORBA::SystemException);

