<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.cpp.CppMappingServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.Utils
import com.thalesgroup.ccm.codegenerator.container.Utils
import com.thalesgroup.ccm.codegenerator.container.cpp.Utils
import com.thalesgroup.ccm.codegenerator.container.cpp.Names
%>

<%script type="idlmm.ComponentDef" name="filePath" post="trim()"%>
<%generatedSessionContextClassname%>.cpp

<%--
  -- Generation template  
  --%>
<%script type="idlmm.ComponentDef" name="SessionContext_cpp" file="<%filePath%>"%>
<%copyrightHeader%>

#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/orbsupport/Codec.hpp>
#include <Foundation/orbsupport/ExceptionMinorCodes.hpp>
#include <CCMContainer/ccmcommon/CCMLoggers.hpp>
#include <CCMContainer/ccmcopi/PushContainerStubRequest_impl.hpp>
#include <CCMContainer/ccmcopi/COPIServiceInit.hpp>

#include "<%generatedSessionContextClassname%>.hpp"

<%-- for all eventtypes used emitters or publisher ports, generate DataTraits --%>
<%for ((allEmitsPorts.event + allPublishesPorts.event).nMinimize()){%>
<%genEventDataTraits%>
<%}%>

<%openNamespace(generatedContextPackage)%>

    <%generatedSessionContextClassname%>::<%generatedSessionContextClassname%>
            (Components::CCMContext_ptr ctx,
             <%generatedSessionServantClassname%> * component,
             CdmwLogging::LoggerFactory_ptr logger_factory)
        throw (CORBA::SystemException)
            : SessionContext_impl(ctx, component->get_component_identity(), logger_factory),
              m_component(component)
    {
        // create logger with domain for ccmcif
        m_logger = logger_factory->get_logger(CCMLoggers::CCMGENERATED_LOG_DOMAIN);
       
        CDMW_LOG_FUNCTION(m_logger.in(), "");
    }

    <%generatedSessionContextClassname%>::~<%generatedSessionContextClassname%>()
    {
    }
    
    <%-- push ComponentDef in context 
         (cannot be reached from sub-script if port is inherited) --%>
    <%self.push()%>

    <%--
        Receptacles.
    --%>
    
    <%allUsesPorts.genUsesCode%>
    
    
    <%--
        Emitters.
    --%>
    
    <%allEmitsPorts.genEventPortCode%>
    
    <%--
        Publishers.
    --%>
    
    <%allPublishesPorts.genEventPortCode%>

    <%-- pop ComponentDef from context --%>
    <%pop()%>

<%closeNamespace(generatedContextPackage)%>




<%script type="idlmm.EventDef" name="genEventDataTraits" post="trim()"%>
DEFINE_VALUETYPE_DATA_TRAITS(<%cppFullClassname%>);


<%script type="idlmm.UsesDef" name="genUsesCode"%>
   <%-- REQUIRES parent component in context
        (containingComponent cannot be used since
         port could come from an inherited component) 
   --%>
<%interface_type.asReturnParameterDef%> <%peek.generatedSessionContextClassname%>::get_connection_<%name%>()
    throw (CORBA::SystemException)
{
    CDMW_LOG_FUNCTION(m_logger.in(), "");
    return m_component->get_connection_<%name%>();
}
    



<%script type="idlmm.EventPortDef" name="genEventPortCode"%>
   <%-- REQUIRES parent component in context
        (containingComponent cannot be used since
         port could come from an inherited component) 
   --%>
void <%peek.generatedSessionContextClassname%>::push_<%name%>(<%event.asInParameterDef%> event)
    throw (CORBA::SystemException)
{
    CORBA::Any data;
    CDMW_LOG_FUNCTION(m_logger.in(), "");

    if(Cdmw::CCM::COPI::COPIServiceInit::Is_initialized() &&
       Cdmw::CCM::COPI::COPIServiceInit::Is_COPI_requests_read_write())
    {
        // need to enable COPIs to access type information,
        // COPIs are not aware of a) which codec to use b) to which object to cast
        data <<= event;
    }
    else
    {
        Cdmw::OrbSupport::Codec< <%event.cppFullClassname%> > codec;
        CORBA::OctetSeq_var encoded_data = codec.encode(event);
        data <<= encoded_data;
    }

    // find proxy to push event
    CosEventComm::PushConsumer_var proxy_consumer =
        m_component->get_proxy_consumer("<%name%>");

    if (CORBA::is_nil(proxy_consumer.in()))
    {
        CDMW_ERROR(m_logger.in(), "ProxyConsumer for <%name%> port is nil");
        CORBA::INTERNAL ex(OrbSupport::INTERNAL, CORBA::COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(ex);
        throw ex;
    }

    if(Cdmw::CCM::COPI::COPIServiceInit::Is_initialized() &&
       Cdmw::CCM::COPI::COPIServiceInit::Is_COPI_requests_read_write()) 
    {
        Cdmw::CCM::COPI::PushContainerStubRequest_impl request 
            (
             "<%name%>",
             m_component->get_component_identity().c_str(),
             proxy_consumer.in(),
             m_component->get_context()
            );

        request.push(data);
          
    } else {
        try
        {
            proxy_consumer->push(data);
        }
        catch (const CosEventComm::Disconnected &)
        {
            CDMW_ERROR(m_logger.in(), "Cannot send event with <%name%> port since it's not connected");
            CORBA::INTERNAL ex(OrbSupport::INTERNAL, CORBA::COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(ex);
            throw ex;
        }
    }
}


