<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.cpp.CppMappingServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.Utils
import com.thalesgroup.ccm.codegenerator.container.Utils
import com.thalesgroup.ccm.codegenerator.container.cpp.Utils
import com.thalesgroup.ccm.codegenerator.container.cpp.Names
%>

<%script type="idlmm.ComponentDef" name="sessionFilePath" post="trim()"%>
<%generatedSessionContextClassname%>.hpp

<%--
  -- Generation template  
  --%>
<%script type="idlmm.ComponentDef" name="SessionContext_hpp" file="<%sessionFilePath%>"%>
<%copyrightHeader%>

<%openIfndefMacro(generatedSessionContextFullClassname)%>

<%genIncludeCdmwCifSkelFile%>

#include <CCMContainer/ccmcif/SessionContext_impl.hpp>
#include <CCMContainer/ccmcif/CCMObject_impl.hpp>
#include <Foundation/orbsupport/RefCountLocalObject.hpp>

#include "<%generatedSessionServantClassname%>.hpp"


<%openNamespace(generatedContextPackage)%>

    class <%generatedSessionContextClassname%> : virtual public <%generatedSessionContextInterface%>,
                                                 public SessionContext_impl
    {
        public:
            <%generatedSessionContextClassname%>(Components::CCMContext_ptr ctx,
                                                 <%generatedSessionServantClassname%> * component,
                                                 CdmwLogging::LoggerFactory_ptr logger_factory)
                throw (CORBA::SystemException);

            ~<%generatedSessionContextClassname%>();

            <%--
                Receptacles.
            --%>

            <%allUsesPorts.genUsesCode%>
    

            <%--
                Emitters.
            --%>
    
            <%allEmitsPorts.genEventPortCode%>

            <%--
                Publishers.
            --%>
    
            <%allPublishesPorts.genEventPortCode%>

        private:
            <%generatedSessionContextClassname%>();

            <%generatedSessionContextClassname%>(const <%generatedSessionContextClassname%>&);
            void operator=(const <%generatedSessionContextClassname%>&);

             // Component servant implementation
            <%generatedSessionServantClassname%> * m_component;

            // logger to be used in CCMContext
            CdmwLogging::Logger_var m_logger;
    };



<%closeNamespace(generatedContextPackage)%>

<%closeIfndefMacro(generatedSessionContextFullClassname)%>



<%script type="idlmm.UsesDef" name="genUsesCode"%>
virtual <%interface_type.asReturnParameterDef%> get_connection_<%name%>()
    throw (CORBA::SystemException);


<%script type="idlmm.EventPortDef" name="genEventPortCode"%>
virtual void push_<%name%>(<%event.asInParameterDef%> event)
    throw (CORBA::SystemException);

