<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.Utils
import com.thalesgroup.ccm.codegenerator.corba.java.JavaMappingServices
import com.thalesgroup.ccm.codegenerator.corba.java.Utils
import com.thalesgroup.ccm.codegenerator.corba.java.BasicTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.java.ComplexTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.java.IDLTypeFallback
import com.thalesgroup.ccm.codegenerator.container.CommonServices
import com.thalesgroup.ccm.codegenerator.container.Utils
import com.thalesgroup.ccm.codegenerator.container.java.Names
import com.thalesgroup.ccm.codegenerator.container.java.COPIUtils
import com.thalesgroup.ccm.codegenerator.container.java.Facet
%>

<%script type="idlmm.InterfaceDef" name="javaFilePath" post="trim()"%>
<%generatedCOPIFacetServantPackage.replaceAll("\.", "/")%>/<%generatedCOPIFacetServantClassname%>.java


<%--
  -- Generation template  
  --%>
<%script type="idlmm.InterfaceDef" name="COPIFacet" file="<%javaFilePath%>"%>
<%copyrightHeader%>

package <%generatedCOPIFacetServantPackage%>;

import cdmw.orbsupport.ExceptionMinorCodes;
import static cdmw.logging.Logger.*;
import static cdmw.logging.FunctionLogger.*;
import org.omg.CORBA.Any;

public class <%generatedCOPIFacetServantClassname%> 
    extends <%generatedFacetServantClassname%> {

    private cdmw.ccm.cif.Context context;

    private String component_identity;


    public <%generatedCOPIFacetServantClassname%>(
        org.omg.Components.ExecutorLocator execLocator,
        String name,
        cdmw.ccm.cif.Context ctx,
        org.omg.PortableServer.Servant component,
        com.thalesgroup.CdmwLogging.Logger logger,
        String comp_id)
    {
        super(execLocator, name, ctx, component, logger);
        CDMW_LOG_FUNCTION(logger, "name="+name);
        this.context = ctx;
        this.component_identity = comp_id;
    }

    <%--
       Create operation declarations for attributes.
       NOTA: This should also include inherited attributes.
    --%>
    <%self.push()%>
       <%-- NOTA: shouldn't be attributes operation intercepted too ??--%>
    <%allAttributes.genAttributeOperations%>
    <%pop()%>

    <%--
       Create operation declarations.
       NOTA: This should also include inherited operations.
    --%>
    <%self.push()%>
    <%allOperations.genInterceptedOperationImpl%>
    <%pop()%>
}






<%script type="idlmm.OperationDef" name="genInterceptedOperationImpl"%>
   <%-- REQUIRES parent interface in context
        (containingInterface cannot be used since
         attribute could come from an inherited interface) 
   --%>
public <%genOperationSignature%>
{
    CDMW_LOG_FUNCTION(logger, "");

    try {
        org.omg.CORBA.Object obj = this.executorLocator.obtain_executor(this.facetName);

        if (obj == null) {
            CDMW_DEBUG(logger,
                "Executor for facet " + facetName + " is null",
                new Throwable());
            org.omg.CORBA.OBJECT_NOT_EXIST ex =
                new org.omg.CORBA.OBJECT_NOT_EXIST(
                    ExceptionMinorCodes.OBJECT_NOT_EXIST,
                    org.omg.CORBA.CompletionStatus.COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
            throw ex;
        }

        <%peek.equivalentLocalInterface%> facetExec;
        try {
            facetExec = <%peek.equivalentLocalInterface%>Helper.narrow (obj);
        } catch (org.omg.CORBA.BAD_PARAM e) {
            CDMW_ERROR(logger,
                "The facet object has wrong type",
                new Throwable());
            org.omg.CORBA.OBJECT_NOT_EXIST ex =
                new org.omg.CORBA.OBJECT_NOT_EXIST(
                    ExceptionMinorCodes.OBJECT_NOT_EXIST,
                    org.omg.CORBA.CompletionStatus.COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
            throw ex;
        }

        String feature_name = this.facetName;
        <%-- Knowing that the target should be an EnterpriseComponent,
            Do we provide the component executor or the executorLocator ?
            This last option allows the COPI to get access to the facet
            executor by calling obtain_executor.
            --%>
        org.omg.CORBA.Object target = this.executorLocator;

        <%genInterceptionCode("facetExec")%>

        this.executorLocator.release_executor(obj);

        <%genInterceptionCode2%>

        <%if (!type.isVoid){%>
        return __result;
        <%}%>

    } catch(org.omg.Components.CCMException ccme) {
        CDMW_ERROR(logger,
            "CCMException received: " + ccme,
            new Throwable());
        org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNALCCMCIFError,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
        throw ex;
    }
}

<%genRequestClass("cdmw.ccm.ccmcopi.ContainerServantRequest")%>


