<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.Utils
import com.thalesgroup.ccm.codegenerator.corba.java.JavaMappingServices
import com.thalesgroup.ccm.codegenerator.corba.java.Utils
import com.thalesgroup.ccm.codegenerator.corba.java.BasicTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.java.ComplexTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.java.IDLTypeFallback
import com.thalesgroup.ccm.codegenerator.container.CommonServices
import com.thalesgroup.ccm.codegenerator.container.java.Names
%>


<%script type="idlmm.OperationDef" name="requestClassname" post="trim"%>
    <%name%>Request


<%-- 
  -- Generate interception code.
  -- Required arguments:
  --   0 : name of the variable to delegate operation call
  --%>
<%script type="idlmm.OperationDef" name="genInterceptionCode"%>
/**
 * The thrown exception if any
 */
java.lang.Exception thrownEx = null;

<%if (!type.isVoid){%>
/**
 * The return value
 */
<%type.asLocalVariable%> __result = <%type.getInitValue%>;
<%}%>

<%requestClassname%> request = new <%requestClassname%>(feature_name, component_identity, target, context);

if (request.isReadWrite()){
    <%for (parameters[mode == "PARAM_IN"]){%>
    request.add_in_args_<%name%>(<%name%>);
    <%}%>
    <%for (parameters[mode == "PARAM_INOUT"]){%>
    request.add_inout_args_<%name%>(<%name%>.value);
    <%}%>
    <%for (parameters[mode == "PARAM_OUT"]){%>
    request.add_out_args_<%name%>(<%name%>.value);
    <%}%>
    
    <%for (exceptions){%>
    request.add_exception_<%name%>_tc();
    <%}%>
    
    <%if (!type.isVoid){%>
    request.add_result_value(__result);
    <%}%>
}
request.preInvoke();

/**
 * The operation parameters
 */
<%for (parameters){%>
<%genParameterType%> _<%name%> = <%name%>;
<%}%>

<%if ((parameters[mode == "PARAM_IN"].length > 0) || (parameters[mode == "PARAM_INOUT"].length > 0)){%>
if (request.isReadWrite()) {
    <%for (parameters[mode == "PARAM_IN"]){%>
    _<%name%> = request.get_in_args_<%name%>();
    <%}%>
    <%for (parameters[mode == "PARAM_INOUT"]){%>
    _<%name%>.value = request.get_inout_args_<%name%>();
    <%}%>
}
<%}%>

try {
    if(request.proceed_call.value && request.the_exception() == null) {
        <%if (!type.isVoid){%>
        __result =
        <%}%>
        <%args(0)%>.<%name%>(<%parameters.name.prepend("_").sep(", ")%>);
    
        <%if ((!type.isVoid) || (parameters[mode == "PARAM_OUT"].length > 0) || (parameters[mode == "PARAM_INOUT"].length > 0)){%>
        if (request.isReadWrite()) {
            <%for (parameters[mode == "PARAM_OUT"]){%>
            request.add_out_args_<%name%>(_<%name%>.value);
            <%}%>
            <%for (parameters[mode == "PARAM_INOUT"]){%>
            request.add_inout_args_<%name%>(_<%name%>.value);
            <%}%>
            
            <%if (!type.isVoid){%>
            request.add_result_value(__result);
            <%}%>
        }
        <%}%>
    }
} catch (org.omg.CORBA.SystemException se) {
    request.add_SystemException(se);
    thrownEx = se;
<%for (exceptions){%>
} catch (<%javaFullClassname%> e) {
    request.add_exception_<%name%>(e);
    thrownEx = e;
<%}%>
}

request.postInvoke();
        


<%script type="idlmm.OperationDef" name="genInterceptionCode2"%>
if (request.isReadWrite()) {
    <%genUnmarshallResultCode%>
} else {
    if (thrownEx!=null) request.throw_exception(thrownEx);
}



<%script type="idlmm.OperationDef" name="genUnmarshallResultCode"%>
if (request.the_exception() != null) {
    org.omg.CORBA.Any ex = request.the_exception();
    <%for (exceptions){%>
    if (ex.type().equal(<%javaFullClassname%>Helper.type())) {
        throw <%javaFullClassname%>Helper.extract(ex);
    } else 
    <%}%>
        throw request.the_systemException();
}

<%if (!type.isVoid){%>
__result = request.result_value();
<%}%>
<%for (parameters[mode == "PARAM_INOUT"]){%>
<%name%>.value = request.get_inout_args_<%name%>();
<%}%>
<%for (parameters[mode == "PARAM_OUT"]){%>
<%name%>.value = request.get_out_args_<%name%>();
<%}%>


<%--
   This template generates the request marshalling class of a given operation.
   Expected arguments:
     O: the inherited interface
--%>
<%script type="idlmm.OperationDef" name="genRequestClass"%>
class <%generatedCOPIRequestClassname%> extends <%args(0)%> {

    java.util.HashMap<String, Integer> argumentsIndices = new java.util.HashMap<String, Integer>();
   
    Integer index = -1;

    public <%generatedCOPIRequestClassname%> (String receptacle_name, String component_id,
        org.omg.CORBA.Object facet_object, cdmw.ccm.cif.Context ctx) 
    {
        super(receptacle_name, component_id, facet_object, ctx);    
    }

    public String operation() {
        return "<%name%>"; 
    }

    <%for (parameters[mode == "PARAM_IN"]){%>
    public void add_in_args_<%name%>(<%type.asInParameterDef%> <%name%>) {
        Any any = this.createAny();
        <%type.genAnyInsertion("any", name)%>;
        this.add_in_args(any);
        argumentsIndices.put("<%name%>", ++index);
    }

    public <%type.asReturnParameterDef%> get_in_args_<%name%>() {
        Any any = this.get_arg(argumentsIndices.get("<%name%>").intValue());
        return <%type.genAnyExtraction("any")%>;
    }
    <%}%>
    
    <%for (parameters[mode == "PARAM_INOUT"]){%>
    public void add_inout_args_<%name%>(<%type.asInParameterDef%> <%name%>) {
        Any any = this.createAny();
        <%type.genAnyInsertion("any", name)%>;
        this.add_inout_args(any);
        argumentsIndices.put("<%name%>", ++index);
    }
    
    public <%type.asReturnParameterDef%> get_inout_args_<%name%>() {
        Any any = this.get_arg(argumentsIndices.get("<%name%>").intValue());
        return <%type.genAnyExtraction("any")%>;
    }
    <%}%>

    <%for (parameters[mode == "PARAM_OUT"]){%>
    public void add_out_args_<%name%>(<%type.asInParameterDef%> <%name%>) {
        Any any = this.createAny();
        <%type.genAnyInsertion("any", name)%>;
        this.add_out_args(any);
        argumentsIndices.put("<%name%>", ++index);
    }
    
    public <%type.asReturnParameterDef%> get_out_args_<%name%>() {
        Any any = this.get_arg(argumentsIndices.get("<%name%>").intValue());
        return <%type.genAnyExtraction("any")%>;
    }
    <%}%>
    
    <%if (!type.isVoid){%>
    public void add_result_value(<%type.asInParameterDef%> value) {
        Any any = this.createAny();
        <%type.genAnyInsertion("any", "value")%>;
        this.add_result(any);
    }
               
    public <%type.asReturnParameterDef%> result_value() {
        Any res = this.result();
        return <%type.genAnyExtraction("res")%>;
    }
    <%}%>

    <%for (exceptions){%>
    public void add_exception_<%name%> (<%javaFullClassname%> ex) {
        Any exAny = this.createAny();
        <%javaFullClassname%>Helper.insert(exAny, ex);
        this.add_exception(exAny);
    }
              
    public void add_exception_<%name%>_tc () {
        this.add_exception(<%javaFullClassname%>Helper.type());
    }
    <%}%>

    public void throw_exception(Exception ex) throws org.omg.CORBA.SystemException<%if (exceptions.length > 0){%>,<%}%>
        <%exceptions.javaFullClassname.sep(", ")%>
    {
        if (ex instanceof org.omg.CORBA.SystemException) {
            throw ((org.omg.CORBA.SystemException)ex);
        }
        <%for (exceptions){%>
        if (ex instanceof <%javaFullClassname%>) {
            throw ((<%javaFullClassname%>)ex);
        }
        <%}%>
    }
}  // end of <%generatedCOPIRequestClassname%> class


