<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.Utils
import com.thalesgroup.ccm.codegenerator.corba.java.JavaMappingServices
import com.thalesgroup.ccm.codegenerator.corba.java.Utils
import com.thalesgroup.ccm.codegenerator.corba.java.BasicTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.java.ComplexTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.java.IDLTypeFallback
import com.thalesgroup.ccm.codegenerator.container.Utils
import com.thalesgroup.ccm.codegenerator.container.java.Names
import com.thalesgroup.ccm.codegenerator.container.CommonServices
%>

<%script type="idlmm.EventDef" name="javaFilePath" post="trim()"%>
<%generatedConsumerPackage.replaceAll("\.", "/")%>/<%generatedConsumerClassname%>.java


<%--
  -- Generation template  
  --%>
<%script type="idlmm.EventDef" name="Consumer" file="<%javaFilePath%>"%>
<%copyrightHeader%>

package <%generatedConsumerPackage%>;

import cdmw.orbsupport.ExceptionMinorCodes;
import cdmw.ccm.cif.LifeCycleObjectBase;
import cdmw.ccm.cif.CCMObjectImpl;
import static cdmw.logging.Logger.*;
import static cdmw.logging.FunctionLogger.*;

public class <%generatedConsumerClassname%> 
    extends <%generatedConsumerInterface%>POA {
    
    private org.omg.Components.ExecutorLocator executorLocator;

    private String sinkName;

    private org.omg.PortableServer.Servant component;
    
    private LifeCycleObjectBase lifecycleObjectBase;
    
    private com.thalesgroup.CdmwLogging.Logger logger;
    
    public <%generatedConsumerClassname%>(
        org.omg.Components.ExecutorLocator execLocator, 
        String name,
        cdmw.ccm.cif.Context ctx,
        org.omg.PortableServer.Servant component,
        com.thalesgroup.CdmwLogging.Logger logger) 
    {
        CDMW_LOG_FUNCTION(logger, "name="+name);
        this.lifecycleObjectBase = new LifeCycleObjectBase(ctx);
        this.executorLocator = execLocator;
        this.sinkName = name;
        this.component = component;
        this.logger = logger;
    }

    public void push_<%name%>(<%asInParameterDef%> the<%name%>) {
        
        CDMW_LOG_FUNCTION(logger, "");
        CDMW_DEBUG(logger,                    
            "Consumer " + sinkName + " receives an event",
            new Throwable());
        try {
            org.omg.CORBA.Object obj = this.executorLocator.obtain_executor(this.sinkName);

            if (obj == null) {
                CDMW_DEBUG(logger, 
                    "Executor for consumer " + sinkName + " is null",
                    new Throwable());
                org.omg.CORBA.OBJECT_NOT_EXIST ex =
                    new org.omg.CORBA.OBJECT_NOT_EXIST(
                        ExceptionMinorCodes.OBJECT_NOT_EXIST,
                        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
                CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
                throw ex;
            }
            <%equivalentLocalConsumer%> consumerExec = <%equivalentLocalConsumer%>Helper.narrow(obj);
            
            if(cdmw.ccm.ccmcopi.COPIServiceInit.isInitialized() ) {
        
                cdmw.ccm.ccmcopi.PushContainerServantRequest request = 
                        new cdmw.ccm.ccmcopi.PushContainerServantRequest(sinkName,
                            ((CCMObjectImpl)component).get_component_identity(), 
                            executorLocator, ((CCMObjectImpl)component).get_context());
    
                if(request.isReadWrite()) {
                    // request is a read / write request
                   org.omg.CORBA.Any in_arg = request.createAny();
                   <%javaFullClassname%>Helper.insert(in_arg, the<%name%>);
                   request.add_in_args(in_arg);
                }
                
                request.preInvoke();
    
                // The operation parameters
                <%asLocalVariable%> _event = the<%name%>;
                org.omg.CORBA.Any eventAny = null;
                
                if(request.isReadWrite()) {
                    try {
                        eventAny = request.get_arg(0);
                        if(eventAny != null && 
                                eventAny.type().equals(<%javaFullClassname%>Helper.type())){
                            _event = <%javaFullClassname%>Helper.extract(eventAny); 
                        } else {
                            org.omg.CORBA.SystemException se =
                                new org.omg.CORBA.BAD_OPERATION("A Stub COPI has corrupted the args", 0, org.omg.CORBA.CompletionStatus.COMPLETED_NO);
                            request.add_SystemException(se); 
                        }
                    } catch(Throwable e) {
                        org.omg.CORBA.SystemException se =
                            new org.omg.CORBA.BAD_OPERATION("A Stub COPI has corrupted the args", 0, org.omg.CORBA.CompletionStatus.COMPLETED_NO);
                        request.add_SystemException(se);
                    }
                    
                }
    
                try {
                    if((request.proceed_call.value && request.the_exception() == null)) {
                        consumerExec.push(_event);
                    }
                } catch(org.omg.CORBA.SystemException se) {
                    request.add_SystemException(se);
                }
                request.postInvoke();           
                request.throw_exception();
            } else {
                // COPI Service not initialised
                // push event to the consumer executor
                consumerExec.push(the<%name%>);
            }
           
            this.executorLocator.release_executor(obj);
        } catch(org.omg.CORBA.BAD_PARAM bp2) {
            CDMW_ERROR(logger, "Executor for consumer " + sinkName + 
                " has wrong type", new Throwable());
            org.omg.CORBA.OBJECT_NOT_EXIST ex = new org.omg.CORBA.OBJECT_NOT_EXIST(
                ExceptionMinorCodes.OBJECT_NOT_EXIST, 
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
            throw ex;
         } catch(org.omg.Components.CCMException ccme) {
            CDMW_ERROR(logger, 
                "CCMException received: " + ccme,
                new Throwable());
            org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
                ExceptionMinorCodes.INTERNALCCMCIFError, 
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
            throw ex;
        }
        
    }

    public void push_event(org.omg.Components.EventBase evt)
        throws org.omg.Components.BadEventType 
    {
        CDMW_LOG_FUNCTION(logger, "");
        try {
            <%asLocalVariable%> infoEvt =
               (<%javaFullClassname%>) evt;
            this.push_<%name%>(infoEvt);
        } catch(ClassCastException cce) {
            CDMW_WARN(logger, 
                "EventBase with unexpected type received",
                new Throwable());
            org.omg.Components.BadEventType ex =
                new org.omg.Components.BadEventType();
            CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
            throw ex;
        }

    }

    public void push(org.omg.CORBA.Any data)
        throws org.omg.CosEventComm.Disconnected 
    {
        CDMW_LOG_FUNCTION(logger, "");
        
        /* PCR-0049
        <%asLocalVariable%> event =
            <%javaFullClassname%>Helper.read(data.create_input_stream());
        */

        try {
            // PCR-0049
            cdmw.orbsupport.Codec codec = new cdmw.orbsupport.Codec();
            <%asLocalVariable%> event =
                (<%javaFullClassname%>) codec.decode(data);

            this.push_<%name%>(event);
        } catch (ClassCastException cce) {
            CDMW_WARN(logger, 
                "Event with wrong type received",
                new Throwable());
            cce.printStackTrace();
            org.omg.CORBA.BAD_PARAM ex = new org.omg.CORBA.BAD_PARAM();
            CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
            throw ex;
        } catch (org.omg.CORBA.SystemException se) {
            CDMW_LOG_FUNCTION_EXCEPTION(logger, se);
            throw se;
        }

    }

    public void disconnect_push_consumer() 
    {
        CDMW_LOG_FUNCTION(logger, "");
    }
    
    // methods from LifeCycleObjectBase to delegate operations
    
    public org.omg.CosLifeCycle.LifeCycleObject copy(
        org.omg.CosLifeCycle.FactoryFinder there,
        org.omg.CosLifeCycle.NVP[] the_criteria)
        throws
            org.omg.CosLifeCycle.NoFactory,
            org.omg.CosLifeCycle.NotCopyable,
            org.omg.CosLifeCycle.InvalidCriteria,
            org.omg.CosLifeCycle.CannotMeetCriteria 
    {
        CDMW_LOG_FUNCTION(logger, "");
        return this.lifecycleObjectBase.copy(there, the_criteria);
    }
    
    public void move(
        org.omg.CosLifeCycle.FactoryFinder there,
        org.omg.CosLifeCycle.NVP[] the_criteria)
        throws
            org.omg.CosLifeCycle.NoFactory,
            org.omg.CosLifeCycle.NotMovable,
            org.omg.CosLifeCycle.InvalidCriteria,
            org.omg.CosLifeCycle.CannotMeetCriteria 
    {
        CDMW_LOG_FUNCTION(logger, "");
        this.lifecycleObjectBase.move(there, the_criteria);
    }

    public void remove() throws org.omg.CosLifeCycle.NotRemovable {
        CDMW_LOG_FUNCTION(logger, "");
        this.lifecycleObjectBase.remove();
    }

}
    