<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.Utils
import com.thalesgroup.ccm.codegenerator.corba.java.JavaMappingServices
import com.thalesgroup.ccm.codegenerator.corba.java.Utils
import com.thalesgroup.ccm.codegenerator.corba.java.BasicTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.java.ComplexTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.java.IDLTypeFallback
import com.thalesgroup.ccm.codegenerator.container.CommonServices
import com.thalesgroup.ccm.codegenerator.container.Utils
import com.thalesgroup.ccm.codegenerator.container.java.Names
import com.thalesgroup.ccm.codegenerator.container.java.SessionHome
%>

<%script type="idlmm.HomeDef" name="javaFilePath" post="trim()"%>
<%generatedServantPackage.replaceAll("\.", "/")%>/<%generatedExtensionServantClassname%>.java


<%--
  -- Generation template  
  --%>
<%script type="idlmm.HomeDef" name="ExtensionHome" file="<%javaFilePath%>"%>
<%copyrightHeader%>

package <%generatedServantPackage%>;

import cdmw.orbsupport.ExceptionMinorCodes;

import cdmw.ccm.cif.HomeConfigurationImpl;
import cdmw.ccm.common.CCMLoggers;
import static cdmw.logging.Logger.*;
import static cdmw.logging.FunctionLogger.*;

public class <%generatedExtensionServantClassname%> extends cdmw.ccm.cif.CCMHomeImpl
    implements <%generatedContainerInterface%>Operations {

    public static final String HOME_REP_ID = "<%ID%>";
         
    public static final String COMP_REP_ID = "<%managedComponent.ID%>";

    public static final String[] ids = {
        "<%managedComponent.ID%>",
        <%for (managedComponent.allBaseComponents + managedComponent.allSupportedInterfaces){%>
        "<%ID%>",
        <%}%>
        "IDL:omg.org/Components/Events:1.0",
        "IDL:omg.org/Components/Receptacles:1.0",
        "IDL:omg.org/Components/Navigation:1.0",
        "IDL:omg.org/Components/CCMObject:1.0"
    };
    

    /**
     * private class used to delegate methods from HomeConfigurationImpl
     */
    private class HomeConfigurationImplDelegate extends HomeConfigurationImpl {
    
        public org.omg.Components.IRObject get_component_def() { return null;}
    
        public org.omg.Components.IRObject get_home_def() { return null;}
    
        public void remove_component(org.omg.Components.CCMObject comp) 
            throws org.omg.Components.RemoveFailure {}
 
    }
 
    /**
     * delegate instance
     */
    private HomeConfigurationImplDelegate delegate = new HomeConfigurationImplDelegate();

    /**
     * Home executor
     */
    private <%equivalentLocalInterface%> homeExecutor;
         
    /** 
     * Counter for names of component without COMPONENT_NAME ConfigValue.
     */
    private static int counter = 0;
    
    /**
     * Constructor
     */
    protected <%generatedExtensionServantClassname%>(
        org.omg.Components.HomeExecutorBase homeExec,
        cdmw.lifecycle.ObjectDeactivator deactivator,
        com.thalesgroup.CdmwLifeCycle.ObjectRegistration objectRegistration,
        org.omg.Components.ConfigValue[] config) 
    {
        super(HOME_REP_ID, COMP_REP_ID, deactivator, objectRegistration, config);
            
        CDMW_LOG_FUNCTION(CCMLoggers.GetCcmgeneratedLogger(), "");
        
        try {
            this.homeExecutor = <%equivalentLocalInterface%>Helper.narrow(homeExec);
        } catch (org.omg.CORBA.BAD_PARAM e) {
            CDMW_ERROR(CCMLoggers.GetCcmgeneratedLogger(), 
                "Executor for <%name%> is not a <%equivalentLocalInterface%>",
                new Throwable()); 
            org.omg.CORBA.BAD_PARAM ex = new org.omg.CORBA.BAD_PARAM(
                ExceptionMinorCodes.BAD_PARAMInvalidHomeExecutor, 
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(CCMLoggers.GetCcmgeneratedLogger(), ex);
            throw ex;
        }
        if (this.homeExecutor == null) {
            CDMW_ERROR(CCMLoggers.GetCcmgeneratedLogger(), 
                "Executor for <%name%> is empty",
                new Throwable()); 
            org.omg.CORBA.BAD_PARAM ex = new org.omg.CORBA.BAD_PARAM(
                ExceptionMinorCodes.BAD_PARAMInvalidHomeExecutor, 
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(CCMLoggers.GetCcmgeneratedLogger(), ex);
            throw ex;
        }
    }


    /**
     * Attributes
     */
    <%allAttributes.genOperationImpl%>
    
    /**
     * Explicit interface
     */
    <%allFactoryOperations.genOperationImpl%>

    /**
     * Implicit interface
     */

    public <%managedComponent.asReturnParameterDef%> create()
        throws org.omg.Components.CreateFailure 
    {
        CDMW_LOG_FUNCTION(CCMLoggers.GetCcmgeneratedLogger(), ""); 
        checkIsRemoved(oid);
            
        // Create an empty config
        org.omg.Components.ConfigValue[] config = new org.omg.Components.ConfigValue[0];
            
        org.omg.Components.CCMObject cmp = create_component_with_config_values(config);
        <%managedComponent.asLocalVariable%> result = <%managedComponent.equivalentInterface%>Helper.narrow(cmp);
        
        return result;
     }

     // Keyless home operations

     public org.omg.Components.CCMObject create_component()
         throws org.omg.Components.CreateFailure 
     {
         CDMW_LOG_FUNCTION(CCMLoggers.GetCcmgeneratedLogger(), ""); 
         checkIsRemoved(oid);
            
         // Create an empty config
         org.omg.Components.ConfigValue[] config = new org.omg.Components.ConfigValue[0];
            
         org.omg.Components.CCMObject cmp = create_component_with_config_values(config);
         <%managedComponent.asLocalVariable%> result = <%managedComponent.equivalentInterface%>Helper.narrow(cmp);
            
         return result;
     }


    public org.omg.Components.CCMObject create_component_with_config_values(
           org.omg.Components.ConfigValue[] config)
        throws org.omg.Components.CreateFailure 
    {
        CDMW_LOG_FUNCTION(CCMLoggers.GetCcmgeneratedLogger(), ""); 
        checkIsRemoved(oid);

        org.omg.CORBA.Object obj = create_component_ref(config);    
            
        <%managedComponent.asLocalVariable%> result;
        try {
            result = <%managedComponent.equivalentInterface%>Helper.narrow(obj);
            
        } catch (org.omg.CORBA.BAD_PARAM e) {
            CDMW_ERROR(CCMLoggers.GetCcmgeneratedLogger(), 
                "Created reference is not a <%managedComponent.equivalentInterface%>!",
                new Throwable());
            org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
                ExceptionMinorCodes.INTERNAL, 
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(CCMLoggers.GetCcmgeneratedLogger(), ex);
            throw ex;
        }

        if (this.configurator != null) {
            try {
                // a configurator exist!
                this.configurator.configure(result);
            } catch (org.omg.Components.WrongComponentType wct) {
                CDMW_ERROR(CCMLoggers.GetCcmgeneratedLogger(), 
                    "Cannot configure created component: wrong component type.",
                    new Throwable());
                org.omg.Components.CreateFailure ex = new org.omg.Components.CreateFailure(
                    com.thalesgroup.CdmwDeployment.WRONG_COMPONENT_KIND.value);
                CDMW_LOG_FUNCTION_EXCEPTION(CCMLoggers.GetCcmgeneratedLogger(), ex);
                throw ex;
            }
        }
        return result;
    }

    /**
     * This method acts as a hand shaking between the Servant Provider
     * and the generated Factory implementation. It indicates whether
     * a Servant provided by this Servant Provider may incarnate multiple
     * objects (with ObjectIds provided by this Servant Provider)
     *
     * @return <B>true</B> if a servant may incarnate multiple objects,
     * <B>false</B> otherwise.
     */
    public boolean mayIncarnateMultipleObjects() {
        CDMW_LOG_FUNCTION(CCMLoggers.GetCcmgeneratedLogger(), ""); 
        return false;
    }

    public void remove() throws org.omg.CosLifeCycle.NotRemovable {
        CDMW_LOG_FUNCTION(CCMLoggers.GetCcmgeneratedLogger(), ""); 
        this.homeExecutor = null;
        super.remove();
    }


    //
    // ServantProvider abstract operation implementation
    //

    /**
     * This returns an array containing repository IDs of all objects
     * supported by the current ServantProvider.
     * <B>NOTA:</B> Repository IDs should be statically allocated; thus derived classes
     * should not delete return pointer(s).
     */
    protected String[] getIds() {
        CDMW_LOG_FUNCTION(CCMLoggers.GetCcmgeneratedLogger(), ""); 
        return ids;
    }

    /**
     * This returns the number of repository Ids supported by the current ServantProvider.
     * <B>NOTA:</B> This should correspond to the number of null terminated strings
     * returned by getIds() operation.
     */
    protected int getNumberOfIds() {
        CDMW_LOG_FUNCTION(CCMLoggers.GetCcmgeneratedLogger(), ""); 
        CDMW_LOG_FUNCTION_RETURN(CCMLoggers.GetCcmgeneratedLogger(), ids.length); 
        return ids.length;
    }

    /**
     * This creates new component servant.
     * This shall be implemented by the well typed home servant.
     *
     * @param ctx      The component context
     * @param executor The component executor
     *
     * @return The new component servant.
     * @exception Components::CreateFailure if a problem occured when creating executor.
     */
    protected org.omg.PortableServer.Servant create_component_servant(
            String compOid,
            cdmw.ccm.cif.Context ctx,
            ComponentInfo compInfo)
        throws org.omg.Components.CreateFailure 
    {
        CDMW_LOG_FUNCTION(CCMLoggers.GetCcmgeneratedLogger(), 
            "compOid="+compOid); 
        checkIsRemoved(oid);
         
        // get COMPONENT_NAME from ConfigValues
        String componentName = null;
        try {
            org.omg.Components.ConfigValue[] configValues = 
                ctx.getConfigValues(compOid);
            for(org.omg.Components.ConfigValue c : configValues) {
                if(com.thalesgroup.CdmwDeployment.COMPONENT_NAME.value.equals(c.name)) 
                {
                    // extract COMPONENT_NAME
                    componentName = c.value.extract_string();
                }
            }
                  
        } catch (cdmw.common.NotFoundException e) {
            // No config values for this component.
        }

        // create LoggerFactory with component name
        if (componentName == null) {
            componentName = "<%managedComponent.name%>"
                + "#" + (++counter);
        }
        com.thalesgroup.CdmwLogging.LoggerFactory loggerFactory =
            cdmw.ccm.cif.CCMUtils.CreateLoggerFactory(componentName);
                  
        // Check if an executor has been created at ref creation
        // that is a factory operation has been used to create ref.
        org.omg.Components.EnterpriseComponent compExec = compInfo.compExec;
        boolean isCreatedByFactoryOperation = false;
         
        if (compExec == null) {
            // Create executor
            try {
                CDMW_INFO(CCMLoggers.GetCcmgeneratedLogger(),
                    "Create component executor " + componentName,
                    new Throwable());
                  
                compExec = this.homeExecutor.create();
            } catch (org.omg.Components.CCMException ccme) {
                CDMW_ERROR(CCMLoggers.GetCcmgeneratedLogger(), 
                    "Error occured during component executor creation!",
                    new Throwable());
                org.omg.Components.CreateFailure ex = 
                    new org.omg.Components.CreateFailure(
                    com.thalesgroup.CdmwDeployment.CREATE_FAILURE.value);
                CDMW_LOG_FUNCTION_EXCEPTION(CCMLoggers.GetCcmgeneratedLogger(), ex);
                throw ex;
            }
                  
            if (compExec == null) {
                CDMW_ERROR(CCMLoggers.GetCcmgeneratedLogger(), 
                    "Component executor is nil!",
                    new Throwable());
                org.omg.Components.CreateFailure ex = 
                    new org.omg.Components.CreateFailure(
                        com.thalesgroup.CdmwDeployment.INVALID_COMPONENT_EXECUTOR.value);
                CDMW_LOG_FUNCTION_EXCEPTION(CCMLoggers.GetCcmgeneratedLogger(), ex);
                throw ex;
            }
        } else {
            isCreatedByFactoryOperation = true;
        }

        CDMW_INFO(CCMLoggers.GetCcmgeneratedLogger(),
            "Create component servant " + componentName,
            new Throwable());
               
        try {
            <%managedComponent.generatedExtensionServantFullClassname%> delegate = 
                new <%managedComponent.generatedExtensionServantFullClassname%>(
                    compOid, 
                    ctx, 
                    compInfo.compRef, 
                    compExec, 
                    objectRegistration,
                    loggerFactory,
                    isCreatedByFactoryOperation);
           
            return new <%managedComponent.equivalentInterface%>POATie(delegate);
                  
        } catch(org.omg.Components.CCMException ccme) {
            CDMW_ERROR(CCMLoggers.GetCcmgeneratedLogger(),
                "CCMException occured during component executor creation: "+ccme,
                new Throwable());
            org.omg.Components.CreateFailure ex =
                new org.omg.Components.CreateFailure(
                    com.thalesgroup.CdmwDeployment.CREATE_FAILURE.value);
            CDMW_LOG_FUNCTION_EXCEPTION(CCMLoggers.GetCcmgeneratedLogger(), ex);
            throw ex;
        } catch(org.omg.CORBA.SystemException e) {
            CDMW_ERROR(CCMLoggers.GetCcmgeneratedLogger(),
                "SystemException occured during component executor creation: "+e,
                new Throwable());
            CDMW_LOG_FUNCTION_EXCEPTION(CCMLoggers.GetCcmgeneratedLogger(), e);
            throw e;
        }
         
    }
 
    protected cdmw.ccm.cif.CCMObjectImpl getCCMObjectImpl(
        org.omg.PortableServer.Servant servant) 
    {
        CDMW_LOG_FUNCTION(CCMLoggers.GetCcmgeneratedLogger(), "");
        try {
            <%managedComponent.equivalentInterface%>POATie tie =
                (<%managedComponent.equivalentInterface%>POATie) servant;
             
            return (<%managedComponent.generatedExtensionServantFullClassname%>) tie._delegate();
        } catch(ClassCastException cce) {
            return null;
        }
    }

    public static org.omg.PortableServer.Servant allocate(
        org.omg.Components.HomeExecutorBase homeExecutor,
        cdmw.lifecycle.ObjectDeactivator deactivator,
        com.thalesgroup.CdmwLifeCycle.ObjectRegistration objectRegistration,
        org.omg.Components.ConfigValue[] config)
    {
        CDMW_LOG_FUNCTION(CCMLoggers.GetCcmgeneratedLogger(), "");
        <%generatedExtensionServantClassname%> delegate = 
            new <%generatedExtensionServantClassname%>(homeExecutor, deactivator, objectRegistration, config);
            
        return new <%generatedContainerInterface%>POATie(delegate);
    }
         
    public static org.omg.PortableServer.Servant getDelegate(
        org.omg.PortableServer.Servant servant) 
    {
        CDMW_LOG_FUNCTION(CCMLoggers.GetCcmgeneratedLogger(), "");
        try {
            <%generatedContainerInterface%>POATie tie =
                (<%generatedContainerInterface%>POATie) servant;
            return (<%generatedExtensionServantClassname%>) tie._delegate();
        } catch(ClassCastException cce) {
            return null;
        }
    }

    //
    // methods from HomeConfigurationImpl
    //
     
    protected org.omg.Components.Configurator configurator = null;
         
    public void set_configurator(org.omg.Components.Configurator cfg) {
        CDMW_LOG_FUNCTION(CCMLoggers.GetCcmgeneratedLogger(), "");
        this.delegate.set_configurator(cfg);
        this.configurator = cfg;
    }
         
    public void set_configuration_values(org.omg.Components.ConfigValue[] config) {
        CDMW_LOG_FUNCTION(CCMLoggers.GetCcmgeneratedLogger(), "");
        this.delegate.set_configuration_values(config);
    }
         
    public void complete_component_configuration(boolean b) {
        CDMW_LOG_FUNCTION(CCMLoggers.GetCcmgeneratedLogger(), "b="+b);
        this.delegate.complete_component_configuration(b);
    }
         
    public void disable_home_configuration() {
        CDMW_LOG_FUNCTION(CCMLoggers.GetCcmgeneratedLogger(), "");
        this.delegate.disable_home_configuration();
    }
         
    public org.omg.Components.Configurator getConfigurator() {
        CDMW_LOG_FUNCTION(CCMLoggers.GetCcmgeneratedLogger(), "");
        return this.configurator;
    }
         
    public org.omg.Components.ConfigValue[] getConfigValues() {
        CDMW_LOG_FUNCTION(CCMLoggers.GetCcmgeneratedLogger(), "");
        return this.delegate.getConfigValues();
    }
         
    public boolean isCompleteCompConfEnable() {
        CDMW_LOG_FUNCTION(CCMLoggers.GetCcmgeneratedLogger(), "");
        return this.delegate.isCompleteCompConfEnable();
    }

}



