<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.Utils
import com.thalesgroup.ccm.codegenerator.corba.java.JavaMappingServices
import com.thalesgroup.ccm.codegenerator.corba.java.Utils
import com.thalesgroup.ccm.codegenerator.corba.java.BasicTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.java.ComplexTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.java.IDLTypeFallback
import com.thalesgroup.ccm.codegenerator.container.Utils
import com.thalesgroup.ccm.codegenerator.container.java.Names
import com.thalesgroup.ccm.codegenerator.container.CommonServices
%>

<%script type="idlmm.InterfaceDef" name="javaFilePath" post="trim()"%>
<%generatedFacetServantPackage.replaceAll("\.", "/")%>/<%generatedFacetServantClassname%>.java


<%--
  -- Generation template  
  --%>
<%script type="idlmm.InterfaceDef" name="Facet" file="<%javaFilePath%>"%>
<%copyrightHeader%>

package <%generatedFacetServantPackage%>;

import cdmw.orbsupport.ExceptionMinorCodes;
import cdmw.ccm.cif.LifeCycleObjectBase;
import static cdmw.logging.Logger.*;
import static cdmw.logging.FunctionLogger.*;

public class <%generatedFacetServantClassname%> 
    extends <%generatedContainerInterface%>POA {

    protected org.omg.Components.ExecutorLocator executorLocator;
    
    protected String facetName;

    protected org.omg.PortableServer.Servant component;
    
    protected LifeCycleObjectBase lifecycleObjectBase;

    protected com.thalesgroup.CdmwLogging.Logger logger;
    
    public <%generatedFacetServantClassname%>(
        org.omg.Components.ExecutorLocator execLocator, 
        String name,
        cdmw.ccm.cif.Context ctx,
        org.omg.PortableServer.Servant component,
        com.thalesgroup.CdmwLogging.Logger logger) 
    {
        CDMW_LOG_FUNCTION(logger, "name="+name);
        this.lifecycleObjectBase = new LifeCycleObjectBase(ctx);
        this.executorLocator = execLocator;
        this.facetName = name;
        this.component = component;
        this.logger = logger;
    }

    <%--
       Create operation declarations for attributes.
       NOTA: This should also include inherited attributes.
    --%>
    <%self.push()%>
    <%allAttributes.genAttributeOperations%>
    <%pop()%>

    <%--
       Create operation declarations.
       NOTA: This should also include inherited operations.
    --%>
    <%self.push()%>
    <%allOperations.genOperationImpl%>
    <%pop()%>

    // methods from LifeCycleObjectBase to delegate operations
    
    public org.omg.CosLifeCycle.LifeCycleObject copy(
        org.omg.CosLifeCycle.FactoryFinder there,
        org.omg.CosLifeCycle.NVP[] the_criteria)
        throws
            org.omg.CosLifeCycle.NoFactory,
            org.omg.CosLifeCycle.NotCopyable,
            org.omg.CosLifeCycle.InvalidCriteria,
            org.omg.CosLifeCycle.CannotMeetCriteria 
    {
        CDMW_LOG_FUNCTION(logger, "");
        return this.lifecycleObjectBase.copy(there, the_criteria);
    }
    
    public void move(
        org.omg.CosLifeCycle.FactoryFinder there,
        org.omg.CosLifeCycle.NVP[] the_criteria)
        throws
            org.omg.CosLifeCycle.NoFactory,
            org.omg.CosLifeCycle.NotMovable,
            org.omg.CosLifeCycle.InvalidCriteria,
            org.omg.CosLifeCycle.CannotMeetCriteria 
    {
        CDMW_LOG_FUNCTION(logger, "");
        this.lifecycleObjectBase.move(there, the_criteria);
    }

    public void remove() throws org.omg.CosLifeCycle.NotRemovable {
        CDMW_LOG_FUNCTION(logger, "");
        this.lifecycleObjectBase.remove();
    }

}





<%script type="idlmm.AttributeDef" name="genAttributeOperations"%>
   <%-- REQUIRES parent interface in context
        (containingInterface cannot be used since
         attribute could come from an inherited interface) 
   --%>
public <%type.asReturnParameterDef%> <%name%>() 
    <%if (getExceptions.nSize > 0){%>
    throws <%getExceptions.javaFullClassname.sep(", ")%>
    <%}%>
{
    CDMW_LOG_FUNCTION(logger, "");
    try {
        org.omg.CORBA.Object obj = this.executorLocator.obtain_executor(this.facetName);

        if (obj == null) {
            CDMW_DEBUG(logger, 
                "Executor for facet " + facetName + " is null",
                new Throwable());
            org.omg.CORBA.OBJECT_NOT_EXIST ex =
                new org.omg.CORBA.OBJECT_NOT_EXIST(
                    ExceptionMinorCodes.OBJECT_NOT_EXIST,
                    org.omg.CORBA.CompletionStatus.COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
            throw ex;
        }
   
        <%peek.equivalentLocalInterface%> facetExec;
        try {
            facetExec = <%peek.equivalentLocalInterface%>Helper.narrow(obj);
        } catch (org.omg.CORBA.BAD_PARAM e) {
            CDMW_ERROR(logger, 
                "Executor for facet " + facetName + " has wrong type",
                new Throwable());
            org.omg.CORBA.OBJECT_NOT_EXIST ex =
                new org.omg.CORBA.OBJECT_NOT_EXIST(
                    ExceptionMinorCodes.OBJECT_NOT_EXIST, 
                    org.omg.CORBA.CompletionStatus.COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
            throw ex;
        }
       
        <%type.asLocalVariable%> __result =
            facetExec.<%name%>();

        this.executorLocator.release_executor(facetExec);

        return __result;
            
    } catch(org.omg.Components.CCMException ccme) {
        CDMW_ERROR(logger, 
            "CCMException received: " + ccme,
            new Throwable());
        org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNALCCMCIFError, 
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
        throw ex;
    }
}

<%if (mode != "ATTR_READONLY"){%>
public void <%name%>(<%type.asInParameterDef%> <%name%>) 
    <%if (setExceptions.nSize > 0){%>
    throws <%setExceptions.javaFullClassname.sep(", ")%>
    <%}%>
{
    CDMW_LOG_FUNCTION(logger, "");
    try {
        org.omg.CORBA.Object obj = this.executorLocator.obtain_executor(this.facetName);

        if (obj == null) {
            CDMW_DEBUG(logger, 
                "Executor for facet " + facetName + " is null",
                new Throwable());
            org.omg.CORBA.OBJECT_NOT_EXIST ex =
                new org.omg.CORBA.OBJECT_NOT_EXIST(
                    ExceptionMinorCodes.OBJECT_NOT_EXIST,
                    org.omg.CORBA.CompletionStatus.COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
            throw ex;
        }
   
        <%peek.equivalentLocalInterface%> facetExec;
        try {
            facetExec = <%peek.equivalentLocalInterface%>Helper.narrow(obj);
        } catch (org.omg.CORBA.BAD_PARAM e) {
            CDMW_ERROR(logger, 
                "Executor for facet " + facetName + " has wrong type",
                new Throwable());
            org.omg.CORBA.OBJECT_NOT_EXIST ex =
                new org.omg.CORBA.OBJECT_NOT_EXIST(
                    ExceptionMinorCodes.OBJECT_NOT_EXIST, 
                    org.omg.CORBA.CompletionStatus.COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
            throw ex;
        }
       
        facetExec.<%name%>(<%name%>);

        this.executorLocator.release_executor(facetExec);

    } catch(org.omg.Components.CCMException ccme) {
        CDMW_ERROR(logger, 
            "CCMException received: " + ccme,
            new Throwable());
        org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNALCCMCIFError, 
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
        throw ex;
    }
}
<%}%>





<%script type="idlmm.OperationDef" name="genOperationImpl"%>
   <%-- REQUIRES parent interface in context
        (containingInterface cannot be used since
         attribute could come from an inherited interface) 
   --%>
public <%genOperationSignature%>
{
    CDMW_LOG_FUNCTION(logger, "");
    try {
        org.omg.CORBA.Object obj = this.executorLocator.obtain_executor(this.facetName);

        if (obj == null) {
            CDMW_DEBUG(logger, 
                "Executor for facet " + facetName + " is null",
                new Throwable());
            org.omg.CORBA.OBJECT_NOT_EXIST ex =
                new org.omg.CORBA.OBJECT_NOT_EXIST(
                    ExceptionMinorCodes.OBJECT_NOT_EXIST,
                    org.omg.CORBA.CompletionStatus.COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
            throw ex;
        }
   
        <%peek.equivalentLocalInterface%> facetExec;
        try {
            facetExec = <%peek.equivalentLocalInterface%>Helper.narrow(obj);
        } catch (org.omg.CORBA.BAD_PARAM e) {
            CDMW_ERROR(logger, 
                "Executor for facet " + facetName + " has wrong type",
                new Throwable());
            org.omg.CORBA.OBJECT_NOT_EXIST ex =
                new org.omg.CORBA.OBJECT_NOT_EXIST(
                    ExceptionMinorCodes.OBJECT_NOT_EXIST, 
                    org.omg.CORBA.CompletionStatus.COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
            throw ex;
        }

        <%if (! type.isVoid){%>
        <%type.asLocalVariable%> __result =
        <%}%>   
        facetExec.<%name%>(<%parameters.name.sep(", ")%>);
        
        this.executorLocator.release_executor(facetExec);

        <%if (! type.isVoid){%>
        return __result;
        <%}%>   
    } catch(org.omg.Components.CCMException ccme) {
        CDMW_ERROR(logger, 
            "CCMException received: " + ccme,
            new Throwable());
        org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNALCCMCIFError, 
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
        throw ex;
    }
}




