<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.java.JavaMappingServices
import com.thalesgroup.ccm.codegenerator.corba.Utils
import com.thalesgroup.ccm.codegenerator.corba.java.Utils
import com.thalesgroup.ccm.codegenerator.corba.java.BasicTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.java.ComplexTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.java.IDLTypeFallback
import com.thalesgroup.ccm.codegenerator.container.Utils
import com.thalesgroup.ccm.codegenerator.container.java.Names
%>


<%script type="idlmm.ComponentDef" name="javaFilePath" post="trim()"%>
<%generatedContextPackage.replaceAll("\.", "/")%>/<%generatedSessionContextClassname%>.java


<%--
  -- Generation template  
  --%>
<%script type="idlmm.ComponentDef" name="SessionContext" file="<%javaFilePath%>"%>
<%copyrightHeader%>

package <%generatedContextPackage%>;

import cdmw.orbsupport.ExceptionMinorCodes;
import cdmw.ccm.cif.SessionContextImpl;
import cdmw.ccm.common.CCMLoggers;
import static cdmw.logging.Logger.*;
import static cdmw.logging.FunctionLogger.*;

public class <%generatedSessionContextClassname%> extends SessionContextImpl
    implements <%generatedSessionContextInterface%> {

    /**
     * Component servant implementation
     */
    private <%generatedSessionServantClassname%> component;
    
    /**
     * Logger for logging
     */
    com.thalesgroup.CdmwLogging.Logger logger;

    public <%generatedSessionContextClassname%>(
        org.omg.Components.CCMContext ctx,
        <%generatedSessionServantClassname%> component,
        com.thalesgroup.CdmwLogging.LoggerFactory loggerFactory) 
    {
        super(ctx, component.get_component_identity(), loggerFactory);
        this.logger = loggerFactory.get_logger(
            cdmw.ccm.common.CCMLoggers.CCMGENERATED_LOG_DOMAIN);
        
        CDMW_LOG_FUNCTION(logger, "");
            
        this.component = component;
    }

    <%--
        Uses ports.
    --%>

    <%allUsesPorts.genUsesCode%>
    

    <%--
        Emitters.
    --%>
    
    <%allEmitsPorts.genEventPortCode%>

    <%--
        Publishers.
    --%>
    
    <%allPublishesPorts.genEventPortCode%>

}



<%script type="idlmm.UsesDef" name="genUsesCode"%>
public <%interface_type.asReturnParameterDef%> get_connection_<%name%>() {
    CDMW_LOG_FUNCTION(logger, "");
        <%interface_type.asReturnParameterDef%> recep =
                this.component.get_connection_<%name%>();
    return recep;
}



<%script type="idlmm.EventPortDef" name="genEventPortCode"%>
public void push_<%name%>(<%event.asInParameterDef%> event) {
    CDMW_LOG_FUNCTION(logger, "");

    org.omg.CORBA.Any data;
    
    if (cdmw.ccm.ccmcopi.COPIServiceInit.isInitialized() &&
        cdmw.ccm.ccmcopi.COPIServiceInit.isCOPIRequestsReadWrite()) 
    {
          // need to enable COPIs to access type information,
          // COPIs are not aware of a) which codec to use b) to which object to cast
          data = org.omg.CORBA.ORB.init().create_any();
          <%event.javaFullClassname%>Helper.insert(data, event);
    } else {
          cdmw.orbsupport.Codec codec = new cdmw.orbsupport.Codec();
          data = codec.encode(event);
    }

    // find proxy to push event
    org.omg.CosEventComm.PushConsumer proxyConsumer =
        this.component.get_proxy_consumer("<%name%>");

    if (proxyConsumer == null) {
        CDMW_ERROR(logger,
            "ProxyConsumer for <%name%> port is null",
            new Throwable());
        org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNAL,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
        throw ex;
    }
    
    if (cdmw.ccm.ccmcopi.COPIServiceInit.isInitialized()){
        cdmw.ccm.ccmcopi.PushContainerStubRequest request = new cdmw.ccm.ccmcopi.PushContainerStubRequest("<%name%>",
            component.get_component_identity(), proxyConsumer, component.get_context());

        request.push(data);
    }
    else {
        try {
            proxyConsumer.push(data);
        } catch (org.omg.CosEventComm.Disconnected d) {
            CDMW_ERROR(logger,
                "Cannot send event with <%name%> port since it's not connected",
                new Throwable());
            org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
                ExceptionMinorCodes.INTERNAL,
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
            throw ex;
        }
    }
}


