<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.CommonServices
%>


<%-- 
  -- PrimitiveDef mapping
  --%>
  
    <%--
    This template returns C++ type name.
    In case of aliased type (typedef), the alias name must be
    passed as first argument (args(0)).
    Optional arguments:
      0 : the alias name
    --%>
<%script type="idlmm.PrimitiveDef" name="cppTypeName" post="trim()"%>
    <%-- if specified, alias name is used, except for string and wstring --%>
    <%if ((args(0) != null) && (kind != "pk_string") && (kind != "pk_wstring")){%>
    <%args(0)%>
    <%}else{%>
        <%-- basic types mapping --%>
        <%if (kind == "pk_null"){%>
            <%abort("ERROR: no existing C++ mapping for 'pk_null' PrimitiveDef.")%>
        <%}else if (kind == "pk_void"){%>
            void
        <%}else if (kind == "pk_short"){%>
            ::CORBA::Short
        <%}else if (kind == "pk_long"){%>
            ::CORBA::Long
        <%}else if (kind == "pk_ushort"){%>
            ::CORBA::UShort
        <%}else if (kind == "pk_ulong"){%>
            ::CORBA::ULong
        <%}else if (kind == "pk_float"){%>
            ::CORBA::Float
        <%}else if (kind == "pk_double"){%>
            ::CORBA::Double
        <%}else if (kind == "pk_boolean"){%>
            ::CORBA::Boolean
        <%}else if (kind == "pk_char"){%>
            ::CORBA::Char
        <%}else if (kind == "pk_octet"){%>
            ::CORBA::Octet
        <%}else if (kind == "pk_any"){%>
            ::CORBA::Any
        <%}else if (kind == "pk_type_code"){%>
            ::CORBA::TypeCode
        <%}else if (kind == "pk_principal"){%>
            ::CORBA::Principal
        <%}else if (kind == "pk_string"){%>
            char*
        <%}else if (kind == "pk_objref"){%>
            ::CORBA::Object
        <%}else if (kind == "pk_longlong"){%>
            ::CORBA::LongLong
        <%}else if (kind == "pk_ulonglong"){%>
            ::CORBA::ULongLong
        <%}else if (kind == "pk_longdouble"){%>
            ::CORBA::LongDouble
        <%}else if (kind == "pk_wchar"){%>
            ::CORBA::WChar
        <%}else if (kind == "pk_wstring"){%>
            ::CORBA::WChar*
        <%}else if (kind == "pk_value_base"){%>
            ::CORBA::ValueBase
        <%}else{%>
            <%abort("INTERNAL ERROR: PrimitiveDef with kind '" + kind + "' has no specified mapping")%>
        <%}%>
    <%}%>


<%script type="idlmm.PrimitiveDef" name="inPrefix" post="trim()"%>
    <%if (kind == "pk_null"){%>
        <%abort("ERROR: no existing C++ mapping for 'pk_null' PrimitiveDef.")%>
    <%}else if (kind == "pk_string" ||
                kind == "pk_wstring" ||
                kind == "pk_any" ||
    ){%>
        <%-- const type --%>
        const
    <%}else{%>
        <%-- for simple types, and objref types: no prefix --%>
    <%}%>

<%script type="idlmm.PrimitiveDef" name="inSuffix" post="trim()"%>
    <%if (kind == "pk_null"){%>
        <%abort("ERROR: no existing C++ mapping for 'pk_null' PrimitiveDef.")%>
    <%}else if (kind == "pk_any"){%>
        <%-- const Any & --%>
        &
    <%}else if (kind == "pk_type_code" ||
                kind == "pk_principal" ||
                kind == "pk_objref" ||
    ){%>
        <%-- objref_ptr --%>
        _ptr
    <%}else if (kind == "pk_value_base"){%>
        <%-- valuetype* --%>
        *
    <%}else{%>
        <%-- for simple types and strings: no suffix --%>
    <%}%>

<%script type="idlmm.PrimitiveDef" name="inoutSuffix" post="trim()"%>
    <%if (kind == "pk_null"){%>
        <%abort("ERROR: no existing C++ mapping for 'pk_null' PrimitiveDef.")%>
    <%}else if (kind == "pk_type_code" ||
                kind == "pk_principal" ||
                kind == "pk_objref" ||
    ){%>
        <%-- objref_ptr& --%>
        _ptr&
    <%}else if (kind == "pk_value_base"){%>
        <%-- valuetype*& --%>
        *&
    <%}else{%>
        <%-- for simple types, any and strings: type& --%>
        &
    <%}%>

<%script type="idlmm.PrimitiveDef" name="outSuffix" post="trim()"%>
    <%if (kind == "pk_null"){%>
        <%abort("ERROR: no existing C++ mapping for 'pk_null' PrimitiveDef.")%>
    <%}else if (kind == "pk_any"){%>
        <%-- Any*& --%>
        _out
    <%}else if (kind == "pk_type_code" ||
                kind == "pk_principal" ||
                kind == "pk_objref" ||
                kind == "pk_value_base" ||
    ){%>
        <%-- objref_out --%>
        _out
    <%}else{%>
        <%-- for simple types and strings: type_out --%>
        _out
    <%}%>

<%script type="idlmm.PrimitiveDef" name="returnSuffix" post="trim()"%>
    <%if (kind == "pk_null"){%>
        <%abort("ERROR: no existing C++ mapping for 'pk_null' PrimitiveDef.")%>
    <%}else if (kind == "pk_any"){%>
        <%-- Any* --%>
        *
    <%}else if (kind == "pk_type_code" ||
                kind == "pk_principal" ||
                kind == "pk_objref" ||
    ){%>
        <%-- objref_ptr --%>
        _ptr
    <%}else if (kind == "pk_value_base"){%>
        <%-- valuetype* --%>
        *
    <%}else{%>
        <%-- for simple types: no suffix --%>
    <%}%>

<%script type="idlmm.PrimitiveDef" name="_sub_asLocalVariable" post="trim()"%>
    <%if (args(0) != null){%>
        <%-- If specified, use alias name, --%>
        <%-- except for alias of ValueBase (no _var generated by TAO!) --%>
        <%if (kind == "pk_value_base"){%>
            ::CORBA::ValueBase_var
        <%}else{%>
            <%args(0)%><%varSuffix%>
        <%}%>
    <%}else{%>
        <%-- use cppTypeName, except for string, wstring and ValueBase--%>
        <%if (kind == "pk_string"){%>
            ::CORBA::String_var
        <%}else if (kind == "pk_wstring"){%>
            ::CORBA::WString_var
        <%}else if (kind == "pk_value_base"){%>
            ::CORBA::ValueBase_var
        <%}else{%>
            <%cppTypeName(null)%><%varSuffix%>
        <%}%>
    <%}%>

<%script type="idlmm.PrimitiveDef" name="forInSuffix" post="trim()"%>
    <%if (kind == "pk_any" ||
          kind == "pk_string" ||
          kind == "pk_wstring" ||
          kind == "pk_type_code" ||
          kind == "pk_principal" ||
          kind == "pk_objref" ||
          kind == "pk_value_base"
    ){%>
    .in()
    <%}%>                

<%script type="idlmm.PrimitiveDef" name="forInoutSuffix"%>
    <%if (kind == "pk_any" ||
          kind == "pk_string" ||
          kind == "pk_wstring" ||
          kind == "pk_type_code" ||
          kind == "pk_principal" ||
          kind == "pk_objref" ||
          kind == "pk_value_base"
    ){%>
    .inout()
    <%}%>                

<%script type="idlmm.PrimitiveDef" name="forOutSuffix"%>
    <%if (kind == "pk_any" ||
          kind == "pk_string" ||
          kind == "pk_wstring" ||
          kind == "pk_type_code" ||
          kind == "pk_principal" ||
          kind == "pk_objref" ||
          kind == "pk_value_base"
    ){%>
    .out()
    <%}%>                

<%script type="idlmm.PrimitiveDef" name="forReturnSuffix"%>
    <%if (kind == "pk_any" ||
          kind == "pk_string" ||
          kind == "pk_wstring" ||
          kind == "pk_type_code" ||
          kind == "pk_principal" ||
          kind == "pk_objref" ||
          kind == "pk_value_base"
    ){%>
    ._retn()
    <%}%>                


    
<%script type="idlmm.PrimitiveDef" name="_sub_asVarForAnyExtraction" post="trim()"%>
    <%-- If string or wstring, use specific mapping --%>
    <%if (kind == "pk_string"){%>
        const char *
    <%}else if (kind == "pk_wstring"){%>
        const ::CORBA::WChar *
    <%}else{%>
        <%-- If specified, use alias name, --%>
        <%if (args(0) != null){%>
            <%if (kind == "pk_any"){%>
                const <%args(0)%> *
            <%}else if (kind == "pk_objref"){%>
                <%args(0)%>_ptr
            <%}else if (kind == "pk_value_base"){%>
                <%args(0)%> *
            <%}else{%>
                <%args(0)%>
            <%}%>
        <%}else{%>
            <%if (kind == "pk_any"){%>
                const ::CORBA::Any *
            <%}else if (kind == "pk_objref"){%>
                ::CORBA::Object_ptr
            <%}else if (kind == "pk_value_base"){%>
                ::CORBA::ValueBase *
            <%}else{%>
                <%cppTypeName(null)%>
            <%}%>
        <%}%>
    <%}%>
    
    
<%script type="idlmm.PrimitiveDef" name="varSuffix" post="trim()"%>
    <%-- add _var suffix only for any, strings and objref --%>
    <%if (kind == "pk_any" ||
          kind == "pk_string" ||
          kind == "pk_wstring" ||
          kind == "pk_type_code" ||
          kind == "pk_principal" ||
          kind == "pk_objref" ||
          kind == "pk_value_base"
    ){%>
    _var
    <%}%>                

<%script type="idlmm.PrimitiveDef" name="_sub_getInitValue" post="trim()"%>
    <%if (kind == "pk_null"){%>
        null
    <%}else if (kind == "pk_void"){%>
        <%abort("ERROR: cannot set initial value for 'pk_void' PrimitiveDef.")%>
    <%}else if (kind == "pk_short"){%>
        0
    <%}else if (kind == "pk_long"){%>
        0
    <%}else if (kind == "pk_ushort"){%>
        0
    <%}else if (kind == "pk_ulong"){%>
        0
    <%}else if (kind == "pk_float"){%>
        0
    <%}else if (kind == "pk_double"){%>
        0
    <%}else if (kind == "pk_boolean"){%>
        false
    <%}else if (kind == "pk_char"){%>
        0
    <%}else if (kind == "pk_octet"){%>
        0
    <%}else if (kind == "pk_any"){%>
        0
    <%}else if (kind == "pk_type_code"){%>
        ::CORBA::TypeCode::_nil()
    <%}else if (kind == "pk_principal"){%>
        ::CORBA::Principal::_nil()
    <%}else if (kind == "pk_string"){%>
        (char*) 0
    <%}else if (kind == "pk_objref"){%>
        ::CORBA::Object::_nil()
    <%}else if (kind == "pk_longlong"){%>
        0
    <%}else if (kind == "pk_ulonglong"){%>
        0
    <%}else if (kind == "pk_longdouble"){%>
        ACE_CDR_LONG_DOUBLE_INITIALIZER
    <%}else if (kind == "pk_wchar"){%>
        0
    <%}else if (kind == "pk_wstring"){%>
        (::CORBA::WChar*) 0
    <%}else if (kind == "pk_value_base"){%>
        (::CORBA::ValueBase*) 0
    <%}else{%>
        <%abort("INTERNAL ERROR: PrimitiveDef with kind '" + kind + "' has no specified mapping")%>
    <%}%>

<%script type="idlmm.PrimitiveDef" name="_sub_copyOfVariable" post="trim()"%>
    <%if (kind == "pk_null"){%>
        <%args(1)%>
    <%}else if (kind == "pk_void"){%>
        <%abort("ERROR: cannot copy 'pk_void' PrimitiveDef.")%>
    <%}else if (kind == "pk_short"){%>
        <%args(1)%>
    <%}else if (kind == "pk_long"){%>
        <%args(1)%>
    <%}else if (kind == "pk_ushort"){%>
        <%args(1)%>
    <%}else if (kind == "pk_ulong"){%>
        <%args(1)%>
    <%}else if (kind == "pk_float"){%>
        <%args(1)%>
    <%}else if (kind == "pk_double"){%>
        <%args(1)%>
    <%}else if (kind == "pk_boolean"){%>
        <%args(1)%>
    <%}else if (kind == "pk_char"){%>
        <%args(1)%>
    <%}else if (kind == "pk_octet"){%>
        <%args(1)%>
    <%}else if (kind == "pk_any"){%>
        new ::CORBA::Any(<%args(1)%>)
    <%}else if (kind == "pk_type_code"){%>
        ::CORBA::TypeCode::_duplicate(<%args(1)%>)
    <%}else if (kind == "pk_principal"){%>
        <%args(1)%>
    <%}else if (kind == "pk_string"){%>
        ::CORBA::string_dup(<%args(1)%>)
    <%}else if (kind == "pk_objref"){%>
        ::CORBA::Object::_duplicate(<%args(1)%>)
    <%}else if (kind == "pk_longlong"){%>
        <%args(1)%>
    <%}else if (kind == "pk_ulonglong"){%>
        <%args(1)%>
    <%}else if (kind == "pk_longdouble"){%>
        <%args(1)%>
    <%}else if (kind == "pk_wchar"){%>
        <%args(1)%>
    <%}else if (kind == "pk_wstring"){%>
        ::CORBA::wstring_dup(<%args(1)%>)
    <%}else if (kind == "pk_value_base"){%>
        <%args(1)%>->_copy_value()
    <%}else{%>
        <%abort("INTERNAL ERROR: PrimitiveDef with kind '" + kind + "' has no specified mapping")%>
    <%}%>

    <%--
    This template returns the call to the operation for 
    insertion of a parameter into an Any.
    Required arguments:
      0 : the alias name
      1 : the any variable
      2 : the value to insert in the any
    --%>
<%script type="idlmm.PrimitiveDef" name="_sub_genAnyInsertion" post="trim()"%>
    <%if (kind == "pk_null"){%>
        <%abort("ERROR: cannot insert 'pk_null' PrimitiveDef in an Any (use DynAny).")%>
    <%}else if (kind == "pk_void"){%>
        <%abort("ERROR: cannot insert 'pk_void' PrimitiveDef in an Any (use DynAny).")%>
    <%}else if (kind == "pk_short"){%>
        <%args(1)%> <<= (::CORBA::Short) <%args(2)%>
    <%}else if (kind == "pk_long"){%>
        <%args(1)%> <<= (::CORBA::Long) <%args(2)%>
    <%}else if (kind == "pk_ushort"){%>
        <%args(1)%> <<= (::CORBA::UShort) <%args(2)%>
    <%}else if (kind == "pk_ulong"){%>
        <%args(1)%> <<= (::CORBA::ULong) <%args(2)%>
    <%}else if (kind == "pk_float"){%>
        <%args(1)%> <<= (::CORBA::Float) <%args(2)%>
    <%}else if (kind == "pk_double"){%>
        <%args(1)%> <<= (::CORBA::Double) <%args(2)%>
    <%}else if (kind == "pk_boolean"){%>
        <%args(1)%> <<= ::CORBA::Any::from_boolean(<%args(2)%>)
    <%}else if (kind == "pk_char"){%>
        <%args(1)%> <<= ::CORBA::Any::from_char(<%args(2)%>)
    <%}else if (kind == "pk_octet"){%>
        <%args(1)%> <<= ::CORBA::Any::from_octet(<%args(2)%>)
    <%}else if (kind == "pk_any"){%>
        <%args(1)%> <<= <%args(2)%>
    <%}else if (kind == "pk_type_code"){%>
        <%args(1)%> <<= <%args(2)%>
    <%}else if (kind == "pk_principal"){%>
        <%args(1)%> <<= <%args(2)%>
    <%}else if (kind == "pk_string"){%>
        <%args(1)%> <<= (const char*) <%args(2)%>
    <%}else if (kind == "pk_objref"){%>
        <%args(1)%> <<= <%args(2)%>
    <%}else if (kind == "pk_longlong"){%>
        <%args(1)%> <<= (::CORBA::LongLong) <%args(2)%>
    <%}else if (kind == "pk_ulonglong"){%>
        <%args(1)%> <<= (::CORBA::ULongLong) <%args(2)%>
    <%}else if (kind == "pk_longdouble"){%>
        <%args(1)%> <<= (::CORBA::LongDouble) <%args(2)%>
    <%}else if (kind == "pk_wchar"){%>
        <%args(1)%> <<= ::CORBA::Any::from_wchar(<%args(2)%>)
    <%}else if (kind == "pk_wstring"){%>
        <%args(1)%> <<= (const ::CORBA::WChar*) <%args(2)%>
    <%}else if (kind == "pk_value_base"){%>
        <%args(1)%> <<= <%args(2)%>
    <%}else{%>
        <%abort("INTERNAL ERROR: PrimitiveDef with kind '" + kind + "' has no specified mapping")%>
    <%}%>

    <%--
    This template returns the call to the operation for 
    extraction of a value from an Any.
    Required arguments:
      0 : the alias name
      1 : the any variable
      2 : the variable into which extraction is made
    --%>
<%script type="idlmm.PrimitiveDef" name="_sub_genAnyExtraction" post="trim()"%>
    <%if (kind == "pk_null"){%>
        <%abort("ERROR: cannot extract 'pk_null' PrimitiveDef from an Any (use DynAny).")%>
    <%}else if (kind == "pk_void"){%>
        <%abort("ERROR: cannot extract 'pk_void' PrimitiveDef from an Any (use DynAny).")%>
    <%}else if (kind == "pk_short"){%>
        <%args(1)%> >>= <%args(2)%>
    <%}else if (kind == "pk_long"){%>
        <%args(1)%> >>= <%args(2)%>
    <%}else if (kind == "pk_ushort"){%>
        <%args(1)%> >>= <%args(2)%>
    <%}else if (kind == "pk_ulong"){%>
        <%args(1)%> >>= <%args(2)%>
    <%}else if (kind == "pk_float"){%>
        <%args(1)%> >>= <%args(2)%>
    <%}else if (kind == "pk_double"){%>
        <%args(1)%> >>= <%args(2)%>
    <%}else if (kind == "pk_boolean"){%>
        <%args(1)%> >>= ::CORBA::Any::to_boolean(<%args(2)%>)
    <%}else if (kind == "pk_char"){%>
        <%args(1)%> >>= ::CORBA::Any::to_char(<%args(2)%>)
    <%}else if (kind == "pk_octet"){%>
        <%args(1)%> >>= ::CORBA::Any::to_octet(<%args(2)%>)
    <%}else if (kind == "pk_any"){%>
        <%args(1)%> >>= <%args(2)%>
    <%}else if (kind == "pk_type_code"){%>
        <%args(1)%> >>= <%args(2)%>
    <%}else if (kind == "pk_principal"){%>
        <%args(1)%> >>= <%args(2)%>
    <%}else if (kind == "pk_string"){%>
        <%args(1)%> >>= <%args(2)%>
    <%}else if (kind == "pk_objref"){%>
        <%args(1)%> >>= ::CORBA::Any::to_object(<%args(2)%>)
    <%}else if (kind == "pk_longlong"){%>
        <%args(1)%> >>= <%args(2)%>
    <%}else if (kind == "pk_ulonglong"){%>
        <%args(1)%> >>= <%args(2)%>
    <%}else if (kind == "pk_longdouble"){%>
        <%args(1)%> >>= <%args(2)%>
    <%}else if (kind == "pk_wchar"){%>
        <%args(1)%> >>= ::CORBA::Any::to_wchar(<%args(2)%>)
    <%}else if (kind == "pk_wstring"){%>
        <%args(1)%> >>= <%args(2)%>
    <%}else if (kind == "pk_value_base"){%>
        <%args(1)%> >>= ::CORBA::Any::to_value(<%args(2)%>)
    <%}else{%>
        <%abort("INTERNAL ERROR: PrimitiveDef with kind '" + kind + "' has no specified mapping")%>
    <%}%>




<%-- 
  -- StringDef mapping (for bounded string)
  --%>
<%script type="idlmm.StringDef" name="cppTypeName" post="trim()"%>
    char*

<%script type="idlmm.StringDef" name="inPrefix"%>
    <%-- const char* --%>
    const

<%script type="idlmm.StringDef" name="inSuffix"%>
    <%-- const char* (no in suffix)--%>

<%script type="idlmm.StringDef" name="inoutSuffix"%>
    <%-- char*& --%>
    &

<%script type="idlmm.StringDef" name="outSuffix"%>
    <%-- String_out --%>
    _out

<%script type="idlmm.StringDef" name="returnSuffix"%>
    <%-- char* (no suffix) --%>

<%script type="idlmm.StringDef" name="_sub_asLocalVariable" post="trim()"%>
    <%if (args(0) != null){%>
    <%args(0)%>_var
    <%}else{%>
    ::CORBA::String_var
    <%}%>

<%script type="idlmm.StringDef" name="forInSuffix" post="trim()"%>
    .in()

<%script type="idlmm.StringDef" name="forInoutSuffix" post="trim()"%>
    .inout()

<%script type="idlmm.StringDef" name="forOutSuffix" post="trim()"%>
    .out()

<%script type="idlmm.StringDef" name="forReturnSuffix" post="trim()"%>
    ._retn()

<%script type="idlmm.StringDef" name="_sub_asVarForAnyExtraction" post="trim()"%>
    <%cppTypeName%>
    
<%script type="idlmm.StringDef" name="_sub_getInitValue" post="trim()"%>
    (char*) 0

<%script type="idlmm.StringDef" name="_sub_copyOfVariable" post="trim()"%>
    ::CORBA::string_dup(<%args(1)%>)
    
    <%--
    This template returns the call to the operation for 
    insertion of a parameter into an Any.
    Required arguments:
      0 : the alias name
      1 : the any variable
      2 : the value to insert in the any
    --%>
<%script type="idlmm.StringDef" name="_sub_genAnyInsertion" post="trim()"%>
    <%args(1)%> <<= ::CORBA::Any::from_string(<%args(2)%>, <%bound.getExpressionValue()%>)
    
    <%--
    This template returns the call to the operation for 
    extraction of a value from an Any.
    Required arguments:
      0 : the alias name
      1 : the any variable
      2 : the variable into which extraction is made
    --%>
<%script type="idlmm.StringDef" name="_sub_genAnyExtraction" post="trim()"%>
    <%args(1)%> >>= ::CORBA::Any::to_string(<%args(2)%>, <%bound.getExpressionValue()%>)


<%-- 
  -- WStringDef mapping (for bounded wstring)
  --%>
<%script type="idlmm.WStringDef" name="cppTypeName" post="trim()"%>
    ::CORBA::WChar*

<%script type="idlmm.WStringDef" name="inPrefix"%>
    <%-- const WChar* --%>
    const

<%script type="idlmm.WStringDef" name="inSuffix"%>
    <%-- const WChar* (no in suffix)--%>

<%script type="idlmm.WStringDef" name="inoutSuffix"%>
    <%-- WChar*& --%>
    &

<%script type="idlmm.WStringDef" name="outSuffix"%>
    <%-- WString_out --%>
    _out

<%script type="idlmm.WStringDef" name="returnSuffix"%>
    <%-- WChar* (no suffix) --%>

<%script type="idlmm.WStringDef" name="_sub_asLocalVariable" post="trim()"%>
    <%if (args(0) != null){%>
    <%args(0)%>_var
    <%}else{%>
    ::CORBA::WString_var
    <%}%>

<%script type="idlmm.WStringDef" name="forInSuffix" post="trim()"%>
    .in()

<%script type="idlmm.WStringDef" name="forInoutSuffix" post="trim()"%>
    .inout()

<%script type="idlmm.WStringDef" name="forOutSuffix" post="trim()"%>
    .out()

<%script type="idlmm.WStringDef" name="forReturnSuffix" post="trim()"%>
    ._retn()

<%script type="idlmm.WStringDef" name="_sub_asVarForAnyExtraction" post="trim()"%>
    <%cppTypeName%>
    
<%script type="idlmm.WStringDef" name="_sub_getInitValue" post="trim()"%>
    (::CORBA::WChar*) 0
    
<%script type="idlmm.WStringDef" name="_sub_copyOfVariable" post="trim()"%>
    ::CORBA::wstring_dup(<%args(1)%>)
    
    <%--
    This template returns the call to the operation for 
    insertion of a parameter into an Any.
    Required arguments:
      0 : the alias name
      1 : the any variable
      2 : the value to insert in the any
    --%>
<%script type="idlmm.WStringDef" name="_sub_genAnyInsertion" post="trim()"%>
    <%args(1)%> <<= ::CORBA::Any::from_wstring(<%args(2)%>, <%bound.getExpressionValue()%>)

    <%--
    This template returns the call to the operation for 
    extraction of a value from an Any.
    Required arguments:
      0 : the alias name
      1 : the any variable
      2 : the variable into which extraction is made
    --%>
<%script type="idlmm.WStringDef" name="_sub_genAnyExtraction" post="trim()"%>
    <%args(1)%> >>= ::CORBA::Any::to_wstring(<%args(2)%>, <%bound.getExpressionValue()%>)

    
<%-- 
  -- FixedDef mapping
  --%>
<%script type="idlmm.FixedDef" name="cppTypeName" post="trim()"%>
    <%if (args(0) != null){%>
    <%args(0)%>
    <%}else{%>
    ::CORBA::Fixed
    <%}%>

<%script type="idlmm.FixedDef" name="inPrefix"%>
    <%-- const fixed& --%>
    const

<%script type="idlmm.FixedDef" name="inSuffix"%>
    <%-- const fixed& --%>
    &

<%script type="idlmm.FixedDef" name="inoutSuffix"%>
    <%-- fixed& --%>
    &

<%script type="idlmm.FixedDef" name="outSuffix"%>
    <%-- fixed_out --%>
    _out

<%script type="idlmm.FixedDef" name="returnSuffix"%>
    <%-- fixed (no suffix) --%>

<%script type="idlmm.FixedDef" name="_sub_asLocalVariable" post="trim()"%>
    <%if (args(0) != null){%>
    <%args(0)%>
    <%}else{%>
    ::CORBA::Fixed
    <%}%>

<%script type="idlmm.FixedDef" name="_sub_asVarForAnyExtraction" post="trim()"%>
    <%if (args(0) != null){%>
    <%args(0)%>
    <%}else{%>
    ::CORBA::Fixed
    <%}%>
    
<%script type="idlmm.FixedDef" name="_sub_getInitValue" post="trim()"%>
    "0"

<%script type="idlmm.FixedDef" name="_sub_copyOfVariable" post="trim()"%>
    <%args(1)%>
    
    <%--
    This template returns the call to the operation for 
    insertion of a parameter into an Any.
    Required arguments:
      0 : the alias name
      1 : the any variable
      2 : the value to insert in the any
    --%>
<%script type="idlmm.FixedDef" name="_sub_genAnyInsertion" post="trim()"%>
    <%args(1)%> <<= ::CORBA::Any::from_fixed(<%args(2)%>, <%digits.getExpressionValue()%>, <%scale.getExpressionValue()%>)

    <%--
    This template returns the call to the operation for 
    extraction of a value from an Any.
    Required arguments:
      0 : the alias name
      1 : the any variable
      2 : the variable into which extraction is made
    --%>
<%script type="idlmm.FixedDef" name="_sub_genAnyExtraction" post="trim()"%>
    <%args(1)%> >>= ::CORBA::Any::to_fixed(<%args(2)%>, <%digits.getExpressionValue()%>, <%scale.getExpressionValue()%>)

    