<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.CommonServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.CppMappingServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.BasicTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.cpp.IDLTypeFallback
%>




<%--------------------------- 
  --    AliasDef Mapping   --
  ---------------------------%>
    <%--
    This template returns C++ type name.
    In case of aliased type (typedef), the alias name must be
    passed as first argument (args(0)).
    Optional arguments:
      0 : the alias name
    --%>
<%script type="idlmm.AliasDef" name="cppTypeName" post="trim()"%>
    <%-- Aliased name must be used, except for string and wstring.
         This is checked calling "cppTypeName" with aliased type.
         In case of alias of alias (args(0) non null), 
         parent alias name must be used.
    --%>
    <%if (args(0) != null){%>
    <%type.cppTypeName(args(0))%>
    <%}else{%>
    <%type.cppTypeName(cppFullClassname)%>
    <%}%>
    
<%script type="idlmm.AliasDef" name="inPrefix" post="trim()"%>
    <%type.inPrefix%>

<%script type="idlmm.AliasDef" name="inSuffix" post="trim()"%>
    <%type.inSuffix%>

<%script type="idlmm.AliasDef" name="inoutSuffix" post="trim()"%>
    <%type.inoutSuffix%>

<%script type="idlmm.AliasDef" name="outSuffix" post="trim()"%>
    <%type.outSuffix%>

<%script type="idlmm.AliasDef" name="returnSuffix" post="trim()"%>
    <%type.returnSuffix%>

<%script type="idlmm.AliasDef" name="_sub_asLocalVariable" post="trim()"%>
    <%-- Aliased name must be used, except for string and wstring.
         This is checked calling "_sub_asLocalVariable" with aliased type.
         In case of alias of alias (args(0) non null), 
         parent alias name must be used.
    --%>
    <%if (args(0) != null){%>
    <%type._sub_asLocalVariable(args(0))%>
    <%}else{%>
    <%type._sub_asLocalVariable(cppFullClassname)%>
    <%}%>

<%script type="idlmm.AliasDef" name="forInSuffix" post="trim()"%>
    <%type.forInSuffix%>

<%script type="idlmm.AliasDef" name="forInoutSuffix" post="trim()"%>
    <%type.forInoutSuffix%>

<%script type="idlmm.AliasDef" name="forOutSuffix" post="trim()"%>
    <%type.forOutSuffix%>

<%script type="idlmm.AliasDef" name="forReturnSuffix" post="trim()"%>
    <%type.forReturnSuffix%>

<%script type="idlmm.AliasDef" name="_sub_getInitValue" post="trim()"%>
    <%-- Aliased name must be used, except for string and wstring.
         This is checked calling "_sub_getInitValue" with aliased type.
         In case of alias of alias (args(0) non null), 
         parent alias name must be used.
    --%>
    <%if (args(0) != null){%>
    <%type._sub_getInitValue(args(0))%>
    <%}else{%>
    <%type._sub_getInitValue(cppFullClassname)%>
    <%}%>

<%script type="idlmm.AliasDef" name="_sub_copyOfVariable" post="trim()"%>
    <%-- Aliased name must be used, except for string and wstring.
         This is checked calling "_sub_copyOfVariable" with aliased type.
         In case of alias of alias (args(0) non null), 
         parent alias name must be used.
    --%>
    <%if (args(0) != null){%>
    <%type._sub_copyOfVariable(args(0), args(1))%>
    <%}else{%>
    <%type._sub_copyOfVariable(cppFullClassname, args(1))%>
    <%}%>
    
    <%--
    This template returns the call to the operation for 
    insertion of a parameter into an Any.
    Required arguments:
      0 : the alias name
      1 : the any variable
      2 : the value to insert in the any
    --%>
<%script type="idlmm.AliasDef" name="_sub_genAnyInsertion" post="trim()"%>
    <%-- Pass alias name as first argument.
         In case of alias of alias (args(0) non null), 
         parent alias name must be used.
    --%>
    <%if (args(0) != null){%>
    <%type._sub_genAnyInsertion(args(0), args(1), args(2))%>
    <%}else{%>
    <%type._sub_genAnyInsertion(cppFullClassname, args(1), args(2))%>
    <%}%>
    
    <%--
    This template returns the call to the operation for 
    extraction of a value from an Any.
    Required arguments:
      0 : the alias name
      1 : the any variable
      2 : the variable into which extraction is made
    --%>
<%script type="idlmm.AliasDef" name="_sub_genAnyExtraction" post="trim()"%>
    <%-- Pass alias name as first argument.
         In case of alias of alias (args(0) non null), 
         parent alias name must be used.
    --%>
    <%if (args(0) != null){%>
    <%type._sub_genAnyExtraction(args(0), args(1), args(2))%>
    <%}else{%>
    <%type._sub_genAnyExtraction(cppFullClassname, args(1), args(2))%>
    <%}%>

<%script type="idlmm.AliasDef" name="_sub_asVarForAnyExtraction" post="trim()"%>
    <%-- Aliased name must be used, except for string and wstring.
         This is checked calling "_sub_asLocalVariable" with aliased type.
         In case of alias of alias (args(0) non null), 
         parent alias name must be used.
    --%>
    <%if (args(0) != null){%>
    <%type._sub_asVarForAnyExtraction(args(0))%>
    <%}else{%>
    <%type._sub_asVarForAnyExtraction(cppFullClassname)%>
    <%}%>


<%--------------------------- 
  --  SequenceDef Mapping  --
  ---------------------------%>
    <%--
    This template returns C++ type name.
    In case of aliased type (typedef), the alias name must be
    passed as first argument (args(0)).
    Optional arguments:
      0 : the alias name
    --%>
<%script type="idlmm.SequenceDef" name="cppTypeName" post="trim()"%>
    <%-- a sequence is always aliased (no anonymous type names) --%>
    <%if (args(0) != null){%>
    <%args(0)%>
    <%}else{%>
    <%abort("INTERNAL ERROR: Non aliased sequence used in cppTypeName")%>
    <%}%>
    
<%script type="idlmm.SequenceDef" name="inPrefix" post="trim()"%>
    <%-- const sequence& --%>
    const

<%script type="idlmm.SequenceDef" name="inSuffix" post="trim()"%>
    <%-- const sequence& --%>
    &

<%script type="idlmm.SequenceDef" name="inoutSuffix" post="trim()"%>
    <%-- sequence& --%>
    &

<%script type="idlmm.SequenceDef" name="outSuffix" post="trim()"%>
    <%-- sequence_out --%>
    _out

<%script type="idlmm.SequenceDef" name="returnSuffix" post="trim()"%>
    <%-- sequence* --%>
    *

<%script type="idlmm.SequenceDef" name="_sub_asLocalVariable" post="trim()"%>
    <%cppTypeName(args(0))%>_var

<%script type="idlmm.SequenceDef" name="forInSuffix" post="trim()"%>
    .in()

<%script type="idlmm.SequenceDef" name="forInoutSuffix" post="trim()"%>
    .inout()

<%script type="idlmm.SequenceDef" name="forOutSuffix" post="trim()"%>
    .out()

<%script type="idlmm.SequenceDef" name="forReturnSuffix" post="trim()"%>
    ._retn()

<%script type="idlmm.SequenceDef" name="_sub_asVarForAnyExtraction" post="trim()"%>
    <%cppTypeName(args(0))%> *
    
<%script type="idlmm.SequenceDef" name="_sub_getInitValue" post="trim()"%>
    0

<%script type="idlmm.SequenceDef" name="_sub_copyOfVariable" post="trim()"%>
    new <%cppTypeName(args(0))%>(<%args(1)%>)
    
<%script type="idlmm.SequenceDef" name="_sub_genAnyInsertion" post="trim()"%>
    <%args(1)%> <<= <%args(2)%>

<%script type="idlmm.SequenceDef" name="_sub_genAnyExtraction" post="trim()"%>
    <%args(1)%> >>= <%args(2)%>


<%--------------------------- 
  --    ArrayDef Mapping   --
  ---------------------------%>
    <%--
    This template returns C++ type name.
    In case of aliased type (typedef), the alias name must be
    passed as first argument (args(0)).
    Optional arguments:
      0 : the alias name
    --%>
<%script type="idlmm.ArrayDef" name="cppTypeName" post="trim()"%>
    <%-- an array is always aliased (no anonymous type names) --%>
    <%if (args(0) != null){%>
    <%args(0)%>
    <%}else{%>
    <%abort("INTERNAL ERROR: Non aliased array used in cppTypeName")%>
    <%}%>

<%script type="idlmm.ArrayDef" name="inPrefix" post="trim()"%>
    <%-- const array --%>
    const

<%script type="idlmm.ArrayDef" name="inSuffix" post="trim()"%>
    <%-- const array (no in suffix) --%>

<%script type="idlmm.ArrayDef" name="inoutSuffix" post="trim()"%>
    <%-- array (no inout suffix) --%>

<%script type="idlmm.ArrayDef" name="outSuffix" post="trim()"%>
    <%-- array_out --%>
    _out

<%script type="idlmm.ArrayDef" name="returnSuffix" post="trim()"%>
    <%-- array_slice* --%>
    _slice*

<%script type="idlmm.ArrayDef" name="_sub_asLocalVariable" post="trim()"%>
    <%cppTypeName(args(0))%>_var

<%script type="idlmm.ArrayDef" name="forInSuffix" post="trim()"%>
    .in()

<%script type="idlmm.ArrayDef" name="forInoutSuffix" post="trim()"%>
    .inout()

<%script type="idlmm.ArrayDef" name="forOutSuffix" post="trim()"%>
    .out()

<%script type="idlmm.ArrayDef" name="forReturnSuffix" post="trim()"%>
    ._retn()

<%script type="idlmm.ArrayDef" name="_sub_asVarForAnyExtraction" post="trim()"%>
    <%cppTypeName(args(0))%>_forany
    
<%script type="idlmm.ArrayDef" name="_sub_getInitValue" post="trim()"%>
    0

<%script type="idlmm.ArrayDef" name="_sub_copyOfVariable" post="trim()"%>
    <%args(0)%>_dup(<%args(1)%>)
    
<%script type="idlmm.ArrayDef" name="_sub_genAnyInsertion" post="trim()"%>
    <%-- TAO has no _forany constructor for "const array" parameter. --%>
    <%-- Thus, duplicate the const array, and use _forany            --%>
    <%-- with nocopy param set to 1                                  --%>
    <%args(1)%> <<= <%args(0)%>_forany(<%args(0)%>_dup(<%args(2)%>), 1)

<%script type="idlmm.ArrayDef" name="_sub_genAnyExtraction" post="trim()"%>
    <%args(1)%> >>= <%args(2)%>


<%--------------------------- 
  --    EnumDef Mapping    --
  ---------------------------%>
    <%--
    This template returns C++ type name.
    In case of aliased type (typedef), the alias name must be
    passed as first argument (args(0)).
    Optional arguments:
      0 : the alias name
    --%>
<%script type="idlmm.EnumDef" name="cppTypeName" post="trim()"%>
    <%if (args(0) != null){%>
    <%args(0)%>
    <%}else{%>
    <%cppFullClassname%>
    <%}%>

<%script type="idlmm.EnumDef" name="inPrefix" post="trim()"%>
    <%-- enum (no in prefix) --%>

<%script type="idlmm.EnumDef" name="inSuffix" post="trim()"%>
    <%-- enum (no in suffix) --%>

<%script type="idlmm.EnumDef" name="inoutSuffix" post="trim()"%>
    <%-- enum& --%>
    &

<%script type="idlmm.EnumDef" name="outSuffix" post="trim()"%>
    <%-- enum_out --%>
    _out

<%script type="idlmm.EnumDef" name="returnSuffix" post="trim()"%>
    <%-- enum (no in suffix) --%>

<%script type="idlmm.EnumDef" name="_sub_asLocalVariable" post="trim()"%>
    <%-- no _var for enums --%>
    <%cppTypeName(args(0))%>

<%script type="idlmm.EnumDef" name="forInSuffix" post="trim()"%>
    <%-- enum (no _var, no in suffix) --%>

<%script type="idlmm.EnumDef" name="forInoutSuffix" post="trim()"%>
    <%-- enum (no _var, no inout suffix) --%>

<%script type="idlmm.EnumDef" name="forOutSuffix" post="trim()"%>
    <%-- enum (no _var, no out suffix) --%>

<%script type="idlmm.EnumDef" name="forReturnSuffix" post="trim()"%>
    <%-- enum (no _var, no return suffix) --%>

<%script type="idlmm.EnumDef" name="_sub_asVarForAnyExtraction" post="trim()"%>
    <%cppTypeName(args(0))%>
    
<%script type="idlmm.EnumDef" name="_sub_copyOfVariable" post="trim()"%>
    <%args(1)%>
    
<%script type="idlmm.EnumDef" name="_sub_getInitValue" post="trim()"%>
    <%container.cppFullClassname%>::<%members.nFirst().cppName%>

    <%--
    This template returns the call to the operation for 
    insertion of a parameter into an Any.
    Required arguments:
      0 : the alias name
      1 : the any variable
      2 : the value to insert in the any
    --%>
<%script type="idlmm.EnumDef" name="_sub_genAnyInsertion" post="trim()"%>
    <%args(1)%> <<= <%args(2)%>

    <%--
    This template returns the call to the operation for 
    extraction of a value from an Any.
    Required arguments:
      0 : the alias name
      1 : the any variable
      2 : the variable into which extraction is made
    --%>
<%script type="idlmm.EnumDef" name="_sub_genAnyExtraction" post="trim()"%>
    <%args(1)%> >>= <%args(2)%>


<%--------------------------- 
  --   UnionDef Mapping    --
  ---------------------------%>
    <%--
    This template returns C++ type name.
    In case of aliased type (typedef), the alias name must be
    passed as first argument (args(0)).
    Optional arguments:
      0 : the alias name
    --%>
<%script type="idlmm.UnionDef" name="cppTypeName" post="trim()"%>
    <%if (args(0) != null){%>
    <%args(0)%>
    <%}else{%>
    <%cppFullClassname%>
    <%}%>

<%script type="idlmm.UnionDef" name="inPrefix" post="trim()"%>
    <%-- const union& --%>
    const

<%script type="idlmm.UnionDef" name="inSuffix" post="trim()"%>
    <%-- const union& --%>
    &

<%script type="idlmm.UnionDef" name="inoutSuffix" post="trim()"%>
    <%-- union& --%>
    &

<%script type="idlmm.UnionDef" name="outSuffix" post="trim()"%>
    <%-- union_out --%>
    _out

<%script type="idlmm.UnionDef" name="returnSuffix" post="trim()"%>
    <%-- variable size: union* --%>
    <%-- fixed size:    union --%>
    <%if (isVariableLength){%>
    *
    <%}%>

<%script type="idlmm.UnionDef" name="_sub_asLocalVariable" post="trim()"%>
    <%cppTypeName(args(0))%>_var

<%script type="idlmm.UnionDef" name="forInSuffix" post="trim()"%>
    .in()

<%script type="idlmm.UnionDef" name="forInoutSuffix" post="trim()"%>
    .inout()

<%script type="idlmm.UnionDef" name="forOutSuffix" post="trim()"%>
    .out()

<%script type="idlmm.UnionDef" name="forReturnSuffix" post="trim()"%>
    ._retn()

<%script type="idlmm.UnionDef" name="_sub_asVarForAnyExtraction" post="trim()"%>
    <%cppTypeName(args(0))%> *
    
<%script type="idlmm.UnionDef" name="_sub_getInitValue" post="trim()"%>
    0

<%script type="idlmm.UnionDef" name="_sub_copyOfVariable" post="trim()"%>
    <%if (isVariableLength){%>
        new <%cppTypeName(args(0))%>(<%args(1)%>)
    <%}else{%>
        <%cppTypeName(args(0))%>(<%args(1)%>)
    <%}%>
    
    <%--
    This template returns the call to the operation for 
    insertion of a parameter into an Any.
    Required arguments:
      0 : the alias name
      1 : the any variable
      2 : the value to insert in the any
    --%>
<%script type="idlmm.UnionDef" name="_sub_genAnyInsertion" post="trim()"%>
    <%args(1)%> <<= <%args(2)%>

    <%--
    This template returns the call to the operation for 
    extraction of a value from an Any.
    Required arguments:
      0 : the alias name
      1 : the any variable
      2 : the variable into which extraction is made
    --%>
<%script type="idlmm.UnionDef" name="_sub_genAnyExtraction" post="trim()"%>
    <%args(1)%> >>= <%args(2)%>


<%--------------------------- 
  --   StructDef Mapping   --
  ---------------------------%>
    <%--
    This template returns C++ type name.
    In case of aliased type (typedef), the alias name must be
    passed as first argument (args(0)).
    Optional arguments:
      0 : the alias name
    --%>
<%script type="idlmm.StructDef" name="cppTypeName" post="trim()"%>
    <%if (args(0) != null){%>
    <%args(0)%>
    <%}else{%>
    <%cppFullClassname%>
    <%}%>

<%script type="idlmm.StructDef" name="inPrefix" post="trim()"%>
    <%-- const struct& --%>
    const

<%script type="idlmm.StructDef" name="inSuffix" post="trim()"%>
    <%-- const struct& --%>
    &

<%script type="idlmm.StructDef" name="inoutSuffix" post="trim()"%>
    <%-- struct& --%>
    &

<%script type="idlmm.StructDef" name="outSuffix" post="trim()"%>
    <%-- struct_out --%>
    _out

<%script type="idlmm.StructDef" name="returnSuffix" post="trim()"%>
    <%-- variable size: struct* --%>
    <%-- fixed size:    struct --%>
    <%if (isVariableLength){%>
    *
    <%}%>

<%script type="idlmm.StructDef" name="_sub_asLocalVariable" post="trim()"%>
    <%cppTypeName(args(0))%>_var

<%script type="idlmm.StructDef" name="forInSuffix" post="trim()"%>
    .in()

<%script type="idlmm.StructDef" name="forInoutSuffix" post="trim()"%>
    .inout()

<%script type="idlmm.StructDef" name="forOutSuffix" post="trim()"%>
    .out()

<%script type="idlmm.StructDef" name="forReturnSuffix" post="trim()"%>
    ._retn()

<%script type="idlmm.StructDef" name="_sub_asVarForAnyExtraction" post="trim()"%>
    <%cppTypeName(args(0))%> *
    
<%script type="idlmm.StructDef" name="_sub_getInitValue" post="trim()"%>
    0

<%script type="idlmm.StructDef" name="_sub_copyOfVariable" post="trim()"%>
    <%if (isVariableLength){%>
        new <%cppTypeName(args(0))%>(<%args(1)%>)
    <%}else{%>
        <%cppTypeName(args(0))%>(<%args(1)%>)
    <%}%>
    
    <%--
    This template returns the call to the operation for 
    insertion of a parameter into an Any.
    Required arguments:
      0 : the alias name
      1 : the any variable
      2 : the value to insert in the any
    --%>
<%script type="idlmm.StructDef" name="_sub_genAnyInsertion" post="trim()"%>
    <%args(1)%> <<= <%args(2)%>

    <%--
    This template returns the call to the operation for 
    extraction of a value from an Any.
    Required arguments:
      0 : the alias name
      1 : the any variable
      2 : the variable into which extraction is made
    --%>
<%script type="idlmm.StructDef" name="_sub_genAnyExtraction" post="trim()"%>
    <%args(1)%> >>= <%args(2)%>


<%--------------------------- 
  -- Interface Mapping  --
  ---------------------------%>
    <%--
    This template returns C++ type name.
    In case of aliased type (typedef), the alias name must be
    passed as first argument (args(0)).
    Optional arguments:
      0 : the alias name
    --%>
<%script type="idlmm.Interface" name="cppTypeName" post="trim()"%>
    <%if (args(0) != null){%>
    <%args(0)%>
    <%}else{%>
    <%cppFullClassname%>
    <%}%>

<%script type="idlmm.Interface" name="inPrefix" post="trim()"%>
    <%-- objref_ptr (no in prefix) --%>

<%script type="idlmm.Interface" name="inSuffix" post="trim()"%>
    <%-- objref_ptr --%>
    _ptr

<%script type="idlmm.Interface" name="inoutSuffix" post="trim()"%>
    <%-- objref_ptr& --%>
    _ptr&

<%script type="idlmm.Interface" name="outSuffix" post="trim()"%>
    <%-- objref_out --%>
    _out

<%script type="idlmm.Interface" name="returnSuffix" post="trim()"%>
    <%-- objref_ptr --%>
    _ptr

<%script type="idlmm.Interface" name="_sub_asLocalVariable" post="trim()"%>
    <%cppTypeName(args(0))%>_var

<%script type="idlmm.Interface" name="forInSuffix" post="trim()"%>
    .in()

<%script type="idlmm.Interface" name="forInoutSuffix" post="trim()"%>
    .inout()

<%script type="idlmm.Interface" name="forOutSuffix" post="trim()"%>
    .out()

<%script type="idlmm.Interface" name="forReturnSuffix" post="trim()"%>
    ._retn()

<%script type="idlmm.Interface" name="_sub_asVarForAnyExtraction" post="trim()"%>
    <%cppTypeName(args(0))%>_ptr
    
<%script type="idlmm.Interface" name="_sub_getInitValue" post="trim()"%>
    <%cppTypeName(args(0))%>::_nil()

<%script type="idlmm.Interface" name="_sub_copyOfVariable" post="trim()"%>
    <%cppTypeName(args(0))%>::_duplicate(<%args(1)%>)
    
    <%--
    This template returns the call to the operation for 
    insertion of a parameter into an Any.
    Required arguments:
      0 : the alias name
      1 : the any variable
      2 : the value to insert in the any
    --%>
<%script type="idlmm.Interface" name="_sub_genAnyInsertion" post="trim()"%>
    <%args(1)%> <<= <%args(2)%>

    <%--
    This template returns the call to the operation for 
    extraction of a value from an Any.
    Required arguments:
      0 : the alias name
      1 : the any variable
      2 : the variable into which extraction is made
    --%>
<%script type="idlmm.Interface" name="_sub_genAnyExtraction" post="trim()"%>
    <%args(1)%> >>= <%args(2)%>


<%--------------------------- 
  --     Value Mapping     --
  ---------------------------%>
<%-- applicable to valuetypes (abstract or not) and eventtypes --%>

    <%--
    This template returns C++ type name.
    In case of aliased type (typedef), the alias name must be
    passed as first argument (args(0)).
    Optional arguments:
      0 : the alias name
    --%>
<%script type="idlmm.Value" name="cppTypeName" post="trim()"%>
    <%if (args(0) != null){%>
    <%args(0)%>
    <%}else{%>
    <%cppFullClassname%>
    <%}%>

<%script type="idlmm.Value" name="inPrefix" post="trim()"%>
    <%-- valuetype* (no in prefix) --%>

<%script type="idlmm.Value" name="inSuffix" post="trim()"%>
    <%-- valuetype* --%>
    *

<%script type="idlmm.Value" name="inoutSuffix" post="trim()"%>
    <%-- valuetype*& --%>
    *&

<%script type="idlmm.Value" name="outSuffix" post="trim()"%>
    <%-- valuetype_out --%>
    _out

<%script type="idlmm.Value" name="returnSuffix" post="trim()"%>
    <%-- valuetype* --%>
    *

<%script type="idlmm.Value" name="_sub_asLocalVariable" post="trim()"%>
    <%cppTypeName(args(0))%>_var

<%script type="idlmm.Value" name="forInSuffix" post="trim()"%>
    .in()

<%script type="idlmm.Value" name="forInoutSuffix" post="trim()"%>
    .inout()

<%script type="idlmm.Value" name="forOutSuffix" post="trim()"%>
    .out()

<%script type="idlmm.Value" name="forReturnSuffix" post="trim()"%>
    ._retn()

<%script type="idlmm.Value" name="_sub_asVarForAnyExtraction" post="trim()"%>
    <%cppTypeName(args(0))%>*
    
<%script type="idlmm.Value" name="_sub_getInitValue" post="trim()"%>
    (<%cppTypeName(args(0))%>*) 0

<%script type="idlmm.Value" name="_sub_copyOfVariable" post="trim()"%>
    dynamic_cast< <%cppTypeName(args(0))%>* >(<%args(1)%>->_copy_value())
    
    <%--
    This template returns the call to the operation for 
    insertion of a parameter into an Any.
    Required arguments:
      0 : the alias name
      1 : the any variable
      2 : the value to insert in the any
    --%>
<%script type="idlmm.Value" name="_sub_genAnyInsertion" post="trim()"%>
    <%args(1)%> <<= <%args(2)%>

    <%--
    This template returns the call to the operation for 
    extraction of a value from an Any.
    Required arguments:
      0 : the alias name
      1 : the any variable
      2 : the variable into which extraction is made
    --%>
<%script type="idlmm.Value" name="_sub_genAnyExtraction" post="trim()"%>
    <%args(1)%> >>= <%args(2)%>


<%--------------------------- 
  --  ValueBoxDef Mapping  --
  ---------------------------%>
    <%--
    This template returns C++ type name.
    In case of aliased type (typedef), the alias name must be
    passed as first argument (args(0)).
    Optional arguments:
      0 : the alias name
    --%>
<%script type="idlmm.ValueBoxDef" name="cppTypeName" post="trim()"%>
    <%if (args(0) != null){%>
    <%args(0)%>
    <%}else{%>
    <%cppFullClassname%>
    <%}%>

<%script type="idlmm.ValueBoxDef" name="inPrefix" post="trim()"%>
    <%-- valuetype* (no in prefix) --%>

<%script type="idlmm.ValueBoxDef" name="inSuffix" post="trim()"%>
    <%-- valuetype* --%>
    *

<%script type="idlmm.ValueBoxDef" name="inoutSuffix" post="trim()"%>
    <%-- valuetype*& --%>
    *&

<%script type="idlmm.ValueBoxDef" name="outSuffix" post="trim()"%>
    <%-- valuetype_out --%>
    _out

<%script type="idlmm.ValueBoxDef" name="returnSuffix" post="trim()"%>
    <%-- valuetype* --%>
    *

<%script type="idlmm.ValueBoxDef" name="_sub_asLocalVariable" post="trim()"%>
    <%cppTypeName(args(0))%>_var

<%script type="idlmm.ValueBoxDef" name="forInSuffix" post="trim()"%>
    .in()

<%script type="idlmm.ValueBoxDef" name="forInoutSuffix" post="trim()"%>
    .inout()

<%script type="idlmm.ValueBoxDef" name="forOutSuffix" post="trim()"%>
    .out()

<%script type="idlmm.ValueBoxDef" name="forReturnSuffix" post="trim()"%>
    ._retn()

<%script type="idlmm.ValueBoxDef" name="_sub_asVarForAnyExtraction" post="trim()"%>
    <%cppTypeName(args(0))%>*
    
<%script type="idlmm.ValueBoxDef" name="_sub_getInitValue" post="trim()"%>
    (<%cppTypeName(args(0))%>*) 0

<%script type="idlmm.ValueBoxDef" name="_sub_copyOfVariable" post="trim()"%>
    dynamic_cast< <%cppTypeName(args(0))%>* >(<%args(1)%>->_copy_value())
    
    <%--
    This template returns the call to the operation for 
    insertion of a parameter into an Any.
    Required arguments:
      0 : the alias name
      1 : the any variable
      2 : the value to insert in the any
    --%>
<%script type="idlmm.ValueBoxDef" name="_sub_genAnyInsertion" post="trim()"%>
    <%args(1)%> <<= <%args(2)%>

    <%--
    This template returns the call to the operation for 
    extraction of a value from an Any.
    Required arguments:
      0 : the alias name
      1 : the any variable
    --%>
<%script type="idlmm.ValueBoxDef" name="_sub_genAnyExtraction" post="trim()"%>
    <%args(1)%> >>= <%args(2)%>


<%--------------------------- 
  --   Component Mapping   --
  ---------------------------%>
    <%--
    This template returns C++ type name.
    In case of aliased type (typedef), the alias name must be
    passed as first argument (args(0)).
    Optional arguments:
      0 : the alias name
    --%>
<%script type="idlmm.Component" name="cppTypeName" post="trim()"%>
    <%if (args(0) != null){%>
    <%args(0)%>
    <%}else{%>
    <%cppFullClassname%>
    <%}%>

<%script type="idlmm.Component" name="inPrefix" post="trim()"%>
    <%-- objref_ptr (no in prefix) --%>

<%script type="idlmm.Component" name="inSuffix" post="trim()"%>
    <%-- objref_ptr --%>
    _ptr

<%script type="idlmm.Component" name="inoutSuffix" post="trim()"%>
    <%-- objref_ptr& --%>
    _ptr&

<%script type="idlmm.Component" name="outSuffix" post="trim()"%>
    <%-- objref_out --%>
    _out

<%script type="idlmm.Component" name="returnSuffix" post="trim()"%>
    <%-- objref_ptr --%>
    _ptr

<%script type="idlmm.Component" name="_sub_asLocalVariable" post="trim()"%>
    <%cppTypeName(args(0))%>_var

<%script type="idlmm.Component" name="forInSuffix" post="trim()"%>
    .in()

<%script type="idlmm.Component" name="forInoutSuffix" post="trim()"%>
    .inout()

<%script type="idlmm.Component" name="forOutSuffix" post="trim()"%>
    .out()

<%script type="idlmm.Component" name="forReturnSuffix" post="trim()"%>
    ._retn()

<%script type="idlmm.Component" name="_sub_asVarForAnyExtraction" post="trim()"%>
    <%cppTypeName(args(0))%>_ptr
    
<%script type="idlmm.Component" name="_sub_getInitValue" post="trim()"%>
    <%cppTypeName(args(0))%>::_nil()
    
<%script type="idlmm.Component" name="_sub_copyOfVariable" post="trim()"%>
    <%args(1)%>
    
    <%--
    This template returns the call to the operation for 
    insertion of a parameter into an Any.
    Required arguments:
      0 : the alias name
      1 : the any variable
      2 : the value to insert in the any
    --%>
<%script type="idlmm.Component" name="_sub_genAnyInsertion" post="trim()"%>
    <%args(1)%> <<= <%args(2)%>

    <%--
    This template returns the call to the operation for 
    extraction of a value from an Any.
    Required arguments:
      0 : the alias name
      1 : the any variable
      2 : the variable into which extraction is made
    --%>
<%script type="idlmm.Component" name="_sub_genAnyExtraction" post="trim()"%>
    <%args(1)%> >>= <%args(2)%>


<%--------------------------- 
  --     Home Mapping      --
  ---------------------------%>
    <%--
    This template returns C++ type name.
    In case of aliased type (typedef), the alias name must be
    passed as first argument (args(0)).
    Optional arguments:
      0 : the alias name
    --%>
<%script type="idlmm.Home" name="cppTypeName" post="trim()"%>
    <%if (args(0) != null){%>
    <%args(0)%>
    <%}else{%>
    <%cppFullClassname%>
    <%}%>

<%script type="idlmm.Home" name="inPrefix" post="trim()"%>
    <%-- objref_ptr (no in prefix) --%>

<%script type="idlmm.Home" name="inSuffix" post="trim()"%>
    <%-- objref_ptr --%>
    _ptr

<%script type="idlmm.Home" name="inoutSuffix" post="trim()"%>
    <%-- objref_ptr& --%>
    _ptr&

<%script type="idlmm.Home" name="outSuffix" post="trim()"%>
    <%-- objref_out --%>
    _out

<%script type="idlmm.Home" name="returnSuffix" post="trim()"%>
    <%-- objref_ptr --%>
    _ptr

<%script type="idlmm.Home" name="_sub_asLocalVariable" post="trim()"%>
    <%cppTypeName(args(0))%>_var

<%script type="idlmm.Home" name="forInSuffix" post="trim()"%>
    .in()

<%script type="idlmm.Home" name="forInoutSuffix" post="trim()"%>
    .inout()

<%script type="idlmm.Home" name="forOutSuffix" post="trim()"%>
    .out()

<%script type="idlmm.Home" name="forReturnSuffix" post="trim()"%>
    ._retn()

<%script type="idlmm.Home" name="_sub_asVarForAnyExtraction" post="trim()"%>
    <%cppTypeName(args(0))%>_ptr
    
<%script type="idlmm.Home" name="_sub_getInitValue" post="trim()"%>
    <%cppTypeName(args(0))%>::_nil()

<%script type="idlmm.Home" name="_sub_copyOfVariable" post="trim()"%>
    <%args(1)%>
    
    <%--
    This template returns the call to the operation for 
    insertion of a parameter into an Any.
    Required arguments:
      0 : the alias name
      1 : the any variable
      2 : the value to insert in the any
    --%>
<%script type="idlmm.Home" name="_sub_genAnyInsertion" post="trim()"%>
    <%args(1)%> <<= <%args(2)%>

    <%--
    This template returns the call to the operation for 
    extraction of a value from an Any.
    Required arguments:
      0 : the alias name
      1 : the any variable
      2 : the variable into which extraction is made
    --%>
<%script type="idlmm.Home" name="_sub_genAnyExtraction" post="trim()"%>
    <%args(1)%> >>= <%args(2)%>

    