<%
metamodel http://www.prismtech.com/idlmm
import com.thalesgroup.ccm.codegenerator.corba.CommonServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.BasicTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.cpp.ComplexTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.cpp.IDLTypeFallback
import com.thalesgroup.ccm.codegenerator.corba.cpp.CppMappingServices
%>


<%--
  -- Service scripts
  --%>
  
<%-- generate #ifndef macro for #include protection --%>
<%-- Required argument:                          --%>
<%--    - 0 : the class name                     --%>
<%script type="idlmm.IRObject" name="openIfndefMacro"%>
#ifndef <%IfndefMacroName(args(0))%>
#define <%IfndefMacroName(args(0))%>
  
<%script type="idlmm.IRObject" name="closeIfndefMacro"%>
#endif  // <%IfndefMacroName(args(0))%>
  

<%script type="idlmm.IRObject" name="IfndefMacroName" post="trim()"%>
__INCL_<%args(0).toUpperCase().replaceAll("::", "_")%>_HPP__
  
<%-- Open namespaces for a specified scope --%>
<%-- Required argument:                    --%>
<%--    - 0 : the scope                    --%>
<%script type="idlmm.IRObject" name="openNamespace"%>
<%for (args(0).noColonPrefix.split("::")){%>
namespace <%current%> {
<%}%>
  
<%-- Close namespaces for a specified scope --%>
<%-- Required argument:                    --%>
<%--    - 0 : the scope                    --%>
<%script type="idlmm.IRObject" name="closeNamespace"%>
<%for (args(0).noColonPrefix.split("::").nReverse){%>
}   // end of namespace <%current%>
<%}%>


<%-- Generate #include of stub file defining the IDLType --%>
<%script type="idlmm.IRObject" name="genIncludeStubFile"%>
#include "<%sourceFilename.replaceAll("[.]idl$", ".stub.hpp")%>"    

    
<%-- Generate #include of skeleton file defining the IDLType --%>
<%script type="idlmm.IRObject" name="genIncludeSkelFile"%>
#include "<%sourceFilename.replaceAll("[.]idl$", ".skel.hpp")%>"    


<%-- Scripts for operations generation --%> 
<%script type="idlmm.OperationDef" name="genOperationSignature" post="trim()"%>
<%type.asReturnParameterDef%> <%cppName%>(<%parameters.genParameterDef.sep(", ")%>)
    throw(<%for (exceptions){%><%cppFullClassname%>, <%}%>CORBA::SystemException)

<%script type="idlmm.OperationDef" name="genOperationSignatureWithClassname" post="trim()"%>
<%type.asReturnParameterDef%> <%args(0)%>::<%cppName%>(<%parameters.genParameterDef.sep(", ")%>)
    throw(<%for (exceptions){%><%cppFullClassname%>, <%}%>CORBA::SystemException)

<%script type="idlmm.ParameterDef" name="genParameterType" post="trim()"%>
<%if (mode == "PARAM_IN"){%>
    <%type.asInParameterDef%>
<%}else if (mode == "PARAM_INOUT"){%>
    <%type.asInoutParameterDef%>
<%}else if (mode == "PARAM_OUT"){%>
    <%type.asOutParameterDef%>
<%}%>

<%script type="idlmm.ParameterDef" name="genParameterDef" post="trim()"%>
    <%genParameterType%> <%cppName%>

<%script type="idlmm.InitializerParameterDef" name="genParameterDef" post="trim()"%>
    <%type.asInParameterDef%> <%cppName%>



<%script type="idlmm.IDLType" name="asReturnParameterDef" post="trim()"%>
    <%cppTypeName(null)%><%returnSuffix%>

<%script type="idlmm.IDLType" name="asInParameterDef" post="trim()"%>
    <%inPrefix%> <%cppTypeName(null)%><%inSuffix%>

<%script type="idlmm.IDLType" name="asInoutParameterDef" post="trim()"%>
    <%cppTypeName(null)%><%inoutSuffix%>

<%script type="idlmm.IDLType" name="asOutParameterDef" post="trim()"%>
    <%-- exeptions for string and wstring (even if aliased) --%>
    <%if (isString()){%>
    ::CORBA::String_out
    <%}else if (isWString()){%>
    ::CORBA::WString_out
    <%}else{%>
    <%cppTypeName(null)%><%outSuffix%>
    <%}%>

<%script type="idlmm.IDLType" name="asLocalVariable" post="trim()"%>
    <%-- delegate to sub-script, using null for alias argument --%>
    <%_sub_asLocalVariable(null)%>

<%script type="idlmm.IDLType" name="getInitValue" post="trim()"%>
    <%-- delegate to sub-script, using null for alias argument --%>
    <%_sub_getInitValue(null)%>

    <%--
      -- This template returns the call to the copy operation 
      -- of a parameter (if no such operation, the parameter
      -- is returned as it is)
      -- Required arguments:
      --   0 : the parameter to copy
    --%>
<%script type="idlmm.IDLType" name="copyOfVariable" post="trim()"%>
    <%-- delegate to sub-script, using null for alias argument --%>
    <%_sub_copyOfVariable(null, args(0))%>

    <%--
      -- This template returns the call to the operation for 
      -- insertion of a parameter into an Any.
      -- Required arguments:
      --   0 : the any variable
      --   1 : the value to insert in the any
    --%>
<%script type="idlmm.IDLType" name="genAnyInsertion" post="trim()"%>
    <%-- delegate to sub-script, using null for alias argument --%>
    <%_sub_genAnyInsertion(null, args(0), args(1))%>

    <%--
      -- This template returns the call to the operation for 
      -- extraction of a parameter from an Any.
      -- Required arguments:
      --   0 : the any variable
      --   1 : the variable into which extraction is made
    --%>
<%script type="idlmm.IDLType" name="genAnyExtraction" post="trim()"%>
    <%-- delegate to sub-script, using null for alias argument --%>
    <%_sub_genAnyExtraction(null, args(0), args(1))%>

<%script type="idlmm.IDLType" name="asVarForAnyExtraction" post="trim()"%>
    <%-- delegate to sub-script, using null for alias argument --%>
    <%_sub_asVarForAnyExtraction(null)%>

    <%--
      -- This template returns the call to the copy operation 
      -- of a variable used for extraction from an Any
      -- (if no such operation, the parameter is returned as it is)
      -- Required arguments:
      --   0 : the variable to copy
    --%>
<%script type="idlmm.IDLType" name="copyOfVarForAnyExtraction" post="trim()"%>
    <%-- use same sub-script than "copyOfVariable", but dereferencing
      -- pointer variable, in case it was extracted as pointer.
      --%>
    <%if (isExtractedFromAnyAsPointer){%>
    <%_sub_copyOfVariable(null, "*"+args(0))%>
    <%}else{%>
    <%_sub_copyOfVariable(null, args(0))%>
    <%}%>
    


<%script type="idlmm.ParameterDef" name="genVariableArgPassSuffix" post="trim()"%>
    <%if (mode == "PARAM_IN"){%>
    <%type.forInSuffix%>
    <%}else if (mode == "PARAM_INOUT"){%>
    <%type.forInoutSuffix%>
    <%}else if (mode == "PARAM_OUT"){%>
    <%type.forOutSuffix%>
    <%}%>


    <%--
      -- This template returns "._retn()" suffix if local variable
      -- for IDLType requires it. 
      --%>
<%script type="idlmm.IDLType" name="localVarReturnSuffix" post="trim()"%>
    <%if (asLocalVariable.endsWith("_var")){%>
    ._retn()
    <%}%>
    

    