<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.CommonServices
import com.thalesgroup.ccm.codegenerator.corba.java.JavaMappingServices
import com.thalesgroup.ccm.codegenerator.corba.java.BasicTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.java.IDLTypeFallback
%>



<%--------------------------- 
  --    AliasDef Mapping   --
  ---------------------------%>
<%script type="idlmm.AliasDef" name="asReturnParameterDef" post="trim()"%>
    <%type.asReturnParameterDef(javaFullClassname)%>

<%script type="idlmm.AliasDef" name="asInParameterDef" post="trim()"%>
    <%type.asInParameterDef(javaFullClassname)%>

<%script type="idlmm.AliasDef" name="asInoutParameterDef" post="trim()"%>
    <%type.asInoutParameterDef(javaFullClassname)%>
    
<%script type="idlmm.AliasDef" name="asOutParameterDef" post="trim()"%>
    <%type.asOutParameterDef(javaFullClassname)%>

<%script type="idlmm.AliasDef" name="asLocalVariable" post="trim()"%>
    <%asReturnParameterDef%>

<%script type="idlmm.AliasDef" name="getInitValue" post="trim()"%>
    <%type.getInitValue%>

    <%--
    This template returns the call to the operation for 
    insertion of a parameter into an Any.
    Required arguments:
      0 : the any variable
      1 : the value to insert in the any
    --%>
<%script type="idlmm.AliasDef" name="genAnyInsertion" post="trim()"%>
    <%javaFullClassname%>Helper.insert(<%args(0)%>, <%args(1)%>)

    <%--
    This template returns the call to the operation for 
    extraction of a value from an Any.
    Required arguments:
      0 : the any variable
    --%>
<%script type="idlmm.AliasDef" name="genAnyExtraction" post="trim()"%>
    <%javaFullClassname%>Helper.extract(<%args(0)%>)


<%--------------------------- 
  --  SequenceDef Mapping  --
  ---------------------------%>
<%script type="idlmm.SequenceDef" name="asReturnParameterDef" post="trim()"%>
    <%type.asReturnParameterDef%>[]

<%script type="idlmm.SequenceDef" name="asInParameterDef" post="trim()"%>
    <%type.asReturnParameterDef%>[]

    <%-- For inout and out, a Holder class is generated
      -- with the sequence's mapped Java classname.
      -- But this name comes from the AliasDef pointing to
      -- this SequenceDef.
      -- Thus, we expect AliasDef's mapped Java classname  
      -- to be passed as parameter to this script.   
      --%>
<%script type="idlmm.SequenceDef" name="asInoutParameterDef" post="trim()"%>
    <%if (args(0).length() != 0){%>
        <%args(0)%>Holder
    <%}else{%>
        <%-- cannot guess a name...--%>
        <%abort("INTERNAL ERROR: no argument passed to asInoutParameterDef script for SequenceDef")%>
    <%}%>
    
<%script type="idlmm.SequenceDef" name="asOutParameterDef" post="trim()"%>
    <%asInoutParameterDef(args(0))%>

<%script type="idlmm.SequenceDef" name="asLocalVariable" post="trim()"%>
    <%asReturnParameterDef%>

<%script type="idlmm.SequenceDef" name="getInitValue" post="trim()"%>
    null

<%script type="idlmm.SequenceDef" name="genAnyInsertion" post="trim()"%>
    <%-- We should never be here, since a sequence is always defined
      -- as a typedef (thus modelized with an AliasDef), or
      -- anonymously defined within a complex type (e.g. struct).
      -- Therefore, only AliasDef or complex types will be inserted
      -- in an Any.
      --%>
    <%abort("INTERNAL ERROR: genAnyInsertion called for SequenceDef")%>

<%script type="idlmm.SequenceDef" name="genAnyExtraction" post="trim()"%>
    <%-- We should never be here, since a sequence is always defined
      -- as a typedef (thus modelized with an AliasDef), or
      -- anonymously defined within a complex type (e.g. struct).
      -- Therefore, only AliasDef or complex types will be inserted
      -- in an Any.
      --%>
    <%abort("INTERNAL ERROR: genAnyExtraction called for SequenceDef")%>


<%--------------------------- 
  --    ArrayDef Mapping   --
  ---------------------------%>
<%script type="idlmm.ArrayDef" name="asReturnParameterDef" post="trim()"%>
    <%type.asReturnParameterDef%>[]

<%script type="idlmm.ArrayDef" name="asInParameterDef" post="trim()"%>
    <%type.asReturnParameterDef%>[]

    <%-- For inout and out, a Holder class is generated
      -- with the array's mapped Java classname.
      -- But this name comes from the AliasDef pointing to
      -- this ArrayDef.
      -- Thus, we expect AliasDef's mapped Java classname  
      -- to be passed as parameter to this script.   
      --%>
<%script type="idlmm.ArrayDef" name="asInoutParameterDef" post="trim()"%>
    <%if (args(0).length() != 0){%>
        <%args(0)%>Holder
    <%}else{%>
        <%-- cannot guess a name...--%>
        <%abort("INTERNAL ERROR: no argument passed to asInoutParameterDef script for ArrayDef")%>
    <%}%>
    
<%script type="idlmm.ArrayDef" name="asOutParameterDef" post="trim()"%>
    <%asInoutParameterDef(args(0))%>

<%script type="idlmm.ArrayDef" name="asLocalVariable" post="trim()"%>
    <%asReturnParameterDef%>

<%script type="idlmm.ArrayDef" name="getInitValue" post="trim()"%>
    null

<%script type="idlmm.ArrayDef" name="genAnyInsertion" post="trim()"%>
    <%-- We should never be here, since an array is always defined
      -- as a typedef (thus modelized with an AliasDef), or
      -- anonymously defined within a complex type (e.g. struct).
      -- Therefore, only AliasDef or complex types will be inserted
      -- in an Any.
      --%>
    <%abort("INTERNAL ERROR: genAnyInsertion called for ArrayDef")%>

<%script type="idlmm.ArrayDef" name="genAnyExtraction" post="trim()"%>
    <%-- We should never be here, since a sequence is always defined
      -- as a typedef (thus modelized with an AliasDef), or
      -- anonymously defined within a complex type (e.g. struct).
      -- Therefore, only AliasDef or complex types will be inserted
      -- in an Any.
      --%>
    <%abort("INTERNAL ERROR: genAnyExtraction called for ArrayDef")%>


<%--------------------------- 
  --    EnumDef Mapping    --
  ---------------------------%>
<%script type="idlmm.EnumDef" name="asReturnParameterDef" post="trim()"%>
    <%javaFullClassname%>

<%script type="idlmm.EnumDef" name="asInParameterDef" post="trim()"%>
    <%javaFullClassname%>

<%script type="idlmm.EnumDef" name="asInoutParameterDef" post="trim()"%>
    <%javaFullClassname%>Holder

<%script type="idlmm.EnumDef" name="asOutParameterDef" post="trim()"%>
    <%javaFullClassname%>Holder

<%script type="idlmm.EnumDef" name="asLocalVariable" post="trim()"%>
    <%asReturnParameterDef%>

<%script type="idlmm.EnumDef" name="getInitValue" post="trim()"%>
    null

    <%--
    This template returns the call to the operation for 
    insertion of a parameter into an Any.
    Required arguments:
      0 : the any variable
      1 : the value to insert in the any
    --%>
<%script type="idlmm.EnumDef" name="genAnyInsertion" post="trim()"%>
    <%javaFullClassname%>Helper.insert(<%args(0)%>, <%args(1)%>)

    <%--
    This template returns the call to the operation for 
    extraction of a value from an Any.
    Required arguments:
      0 : the any variable
    --%>
<%script type="idlmm.EnumDef" name="genAnyExtraction" post="trim()"%>
    <%javaFullClassname%>Helper.extract(<%args(0)%>)


<%--------------------------- 
  --   UnionDef Mapping    --
  ---------------------------%>
<%script type="idlmm.UnionDef" name="asReturnParameterDef" post="trim()"%>
    <%javaFullClassname%>

<%script type="idlmm.UnionDef" name="asInParameterDef" post="trim()"%>
    <%javaFullClassname%>

<%script type="idlmm.UnionDef" name="asInoutParameterDef" post="trim()"%>
    <%javaFullClassname%>Holder

<%script type="idlmm.UnionDef" name="asOutParameterDef" post="trim()"%>
    <%javaFullClassname%>Holder

<%script type="idlmm.UnionDef" name="asLocalVariable" post="trim()"%>
    <%asReturnParameterDef%>

<%script type="idlmm.UnionDef" name="getInitValue" post="trim()"%>
    null

    <%--
    This template returns the call to the operation for 
    insertion of a parameter into an Any.
    Required arguments:
      0 : the any variable
      1 : the value to insert in the any
    --%>
<%script type="idlmm.UnionDef" name="genAnyInsertion" post="trim()"%>
    <%javaFullClassname%>Helper.insert(<%args(0)%>, <%args(1)%>)

    <%--
    This template returns the call to the operation for 
    extraction of a value from an Any.
    Required arguments:
      0 : the any variable
    --%>
<%script type="idlmm.UnionDef" name="genAnyExtraction" post="trim()"%>
    <%javaFullClassname%>Helper.extract(<%args(0)%>)


<%--------------------------- 
  --   StructDef Mapping   --
  ---------------------------%>
<%script type="idlmm.StructDef" name="asReturnParameterDef" post="trim()"%>
    <%javaFullClassname%>

<%script type="idlmm.StructDef" name="asInParameterDef" post="trim()"%>
    <%javaFullClassname%>

<%script type="idlmm.StructDef" name="asInoutParameterDef" post="trim()"%>
    <%javaFullClassname%>Holder

<%script type="idlmm.StructDef" name="asOutParameterDef" post="trim()"%>
    <%javaFullClassname%>Holder

<%script type="idlmm.StructDef" name="asLocalVariable" post="trim()"%>
    <%asReturnParameterDef%>

<%script type="idlmm.StructDef" name="getInitValue" post="trim()"%>
    null

    <%--
    This template returns the call to the operation for 
    insertion of a parameter into an Any.
    Required arguments:
      0 : the any variable
      1 : the value to insert in the any
    --%>
<%script type="idlmm.StructDef" name="genAnyInsertion" post="trim()"%>
    <%javaFullClassname%>Helper.insert(<%args(0)%>, <%args(1)%>)

    <%--
    This template returns the call to the operation for 
    extraction of a value from an Any.
    Required arguments:
      0 : the any variable
    --%>
<%script type="idlmm.StructDef" name="genAnyExtraction" post="trim()"%>
    <%javaFullClassname%>Helper.extract(<%args(0)%>)


<%--------------------------- 
  -- Interface Mapping  --
  ---------------------------%>
<%script type="idlmm.Interface" name="asReturnParameterDef" post="trim()"%>
    <%javaFullClassname%>

<%script type="idlmm.Interface" name="asInParameterDef" post="trim()"%>
    <%javaFullClassname%>

<%script type="idlmm.Interface" name="asInoutParameterDef" post="trim()"%>
    <%javaFullClassname%>Holder

<%script type="idlmm.Interface" name="asOutParameterDef" post="trim()"%>
    <%javaFullClassname%>Holder

<%script type="idlmm.Interface" name="asLocalVariable" post="trim()"%>
    <%asReturnParameterDef%>

<%script type="idlmm.Interface" name="getInitValue" post="trim()"%>
    null

    <%--
    This template returns the call to the operation for 
    insertion of a parameter into an Any.
    Required arguments:
      0 : the any variable
      1 : the value to insert in the any
    --%>
<%script type="idlmm.Interface" name="genAnyInsertion" post="trim()"%>
    <%javaFullClassname%>Helper.insert(<%args(0)%>, <%args(1)%>)

    <%--
    This template returns the call to the operation for 
    extraction of a value from an Any.
    Required arguments:
      0 : the any variable
    --%>
<%script type="idlmm.Interface" name="genAnyExtraction" post="trim()"%>
    <%javaFullClassname%>Helper.extract(<%args(0)%>)


<%--------------------------- 
  --     Value Mapping     --
  ---------------------------%>
<%-- applicable to valuetypes (abstract or not) and eventtypes --%>
<%script type="idlmm.Value" name="asReturnParameterDef" post="trim()"%>
    <%javaFullClassname%>

<%script type="idlmm.Value" name="asInParameterDef" post="trim()"%>
    <%javaFullClassname%>

<%script type="idlmm.Value" name="asInoutParameterDef" post="trim()"%>
    <%javaFullClassname%>Holder

<%script type="idlmm.Value" name="asOutParameterDef" post="trim()"%>
    <%javaFullClassname%>Holder

<%script type="idlmm.Value" name="asLocalVariable" post="trim()"%>
    <%asReturnParameterDef%>

<%script type="idlmm.Value" name="getInitValue" post="trim()"%>
    null

    <%--
    This template returns the call to the operation for 
    insertion of a parameter into an Any.
    Required arguments:
      0 : the any variable
      1 : the value to insert in the any
    --%>
<%script type="idlmm.Value" name="genAnyInsertion" post="trim()"%>
    <%javaFullClassname%>Helper.insert(<%args(0)%>, <%args(1)%>)

    <%--
    This template returns the call to the operation for 
    extraction of a value from an Any.
    Required arguments:
      0 : the any variable
    --%>
<%script type="idlmm.Value" name="genAnyExtraction" post="trim()"%>
    <%javaFullClassname%>Helper.extract(<%args(0)%>)


<%--------------------------- 
  --  ValueBoxDef Mapping  --
  ---------------------------%>
<%script type="idlmm.ValueBoxDef" name="asReturnParameterDef" post="trim()"%>
    <%javaFullClassname%>

<%script type="idlmm.ValueBoxDef" name="asInParameterDef" post="trim()"%>
    <%javaFullClassname%>

<%script type="idlmm.ValueBoxDef" name="asInoutParameterDef" post="trim()"%>
    <%javaFullClassname%>Holder

<%script type="idlmm.ValueBoxDef" name="asOutParameterDef" post="trim()"%>
    <%javaFullClassname%>Holder

<%script type="idlmm.ValueBoxDef" name="asLocalVariable" post="trim()"%>
    <%asReturnParameterDef%>

<%script type="idlmm.ValueBoxDef" name="getInitValue" post="trim()"%>
    null

    <%--
    This template returns the call to the operation for 
    insertion of a parameter into an Any.
    Required arguments:
      0 : the any variable
      1 : the value to insert in the any
    --%>
<%script type="idlmm.ValueBoxDef" name="genAnyInsertion" post="trim()"%>
    <%javaFullClassname%>Helper.insert(<%args(0)%>, <%args(1)%>)

    <%--
    This template returns the call to the operation for 
    extraction of a value from an Any.
    Required arguments:
      0 : the any variable
    --%>
<%script type="idlmm.ValueBoxDef" name="genAnyExtraction" post="trim()"%>
    <%javaFullClassname%>Helper.extract(<%args(0)%>)


<%--------------------------- 
  --   Component Mapping   --
  ---------------------------%>
<%script type="idlmm.Component" name="asReturnParameterDef" post="trim()"%>
    <%javaFullClassname%>

<%script type="idlmm.Component" name="asInParameterDef" post="trim()"%>
    <%javaFullClassname%>

<%script type="idlmm.Component" name="asInoutParameterDef" post="trim()"%>
    <%javaFullClassname%>Holder

<%script type="idlmm.Component" name="asOutParameterDef" post="trim()"%>
    <%javaFullClassname%>Holder

<%script type="idlmm.Component" name="asLocalVariable" post="trim()"%>
    <%asReturnParameterDef%>

<%script type="idlmm.Component" name="getInitValue" post="trim()"%>
    null

    <%--
    This template returns the call to the operation for 
    insertion of a parameter into an Any.
    Required arguments:
      0 : the any variable
      1 : the value to insert in the any
    --%>
<%script type="idlmm.Component" name="genAnyInsertion" post="trim()"%>
    <%javaFullClassname%>Helper.insert(<%args(0)%>, <%args(1)%>)

    <%--
    This template returns the call to the operation for 
    extraction of a value from an Any.
    Required arguments:
      0 : the any variable
    --%>
<%script type="idlmm.Component" name="genAnyExtraction" post="trim()"%>
    <%javaFullClassname%>Helper.extract(<%args(0)%>)


<%--------------------------- 
  --     Home Mapping      --
  ---------------------------%>
<%script type="idlmm.Home" name="asReturnParameterDef" post="trim()"%>
    <%javaFullClassname%>

<%script type="idlmm.Home" name="asInParameterDef" post="trim()"%>
    <%javaFullClassname%>

<%script type="idlmm.Home" name="asInoutParameterDef" post="trim()"%>
    <%javaFullClassname%>Holder

<%script type="idlmm.Home" name="asOutParameterDef" post="trim()"%>
    <%javaFullClassname%>Holder

<%script type="idlmm.Home" name="asLocalVariable" post="trim()"%>
    <%asReturnParameterDef%>

<%script type="idlmm.Home" name="getInitValue" post="trim()"%>
    null

    <%--
    This template returns the call to the operation for 
    insertion of a parameter into an Any.
    Required arguments:
      0 : the any variable
      1 : the value to insert in the any
    --%>
<%script type="idlmm.Home" name="genAnyInsertion" post="trim()"%>
    <%javaFullClassname%>Helper.insert(<%args(0)%>, <%args(1)%>)

    <%--
    This template returns the call to the operation for 
    extraction of a value from an Any.
    Required arguments:
      0 : the any variable
    --%>
<%script type="idlmm.Home" name="genAnyExtraction" post="trim()"%>
    <%javaFullClassname%>Helper.extract(<%args(0)%>)

    