<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.cdmw.codegenerator.cdmwinit.ProgramServices
import com.thalesgroup.ccm.codegenerator.corba.CommonServices
%>



<%script type="idlmm.Repository" name="directoryPrefix" post="trim()"%>
<%if (directory.length > 0){%>
<%directory%>/
<%}%>


<%script type="idlmm.Repository" name="InitDTD" file="<%directoryPrefix%><%initDTD%>"%>
<%xmlCopyrightHeader%>

<!ELEMENT process (services+)>

<!ELEMENT services (<%dtdServicesList.sep(", ")%>)>

<%--
     Describe repository-interface.
--%>
<%if (hasRepositoryInterface){%>
<!ELEMENT repository-interface EMPTY>
<!ATTLIST repository-interface
    default-domain-name CDATA #REQUIRED
>
<%}%>

<%--
     Describe performance.
--%>
<%if (hasPerformance){%>
<!ELEMENT performance EMPTY>
<!ATTLIST performance
    result-file-name CDATA #REQUIRED
>
<%}%>

<%--
     Describe trace.
--%>
<%if (hasTrace){%>
<%if (hasBufferingEnabled){%>
<!ELEMENT trace EMPTY>
<!ATTLIST trace
    flush-area-sz CDATA #REQUIRED
    flush-area-nb CDATA #REQUIRED
    flushing-time CDATA #REQUIRED
    collector-name CDATA #REQUIRED
    msg-threshold CDATA #IMPLIED
>
<%}else{%>
<!ELEMENT trace EMPTY>
<!ATTLIST trace
    collector-name CDATA #IMPLIED
    msg-threshold CDATA #IMPLIED
>
<%}%>
<%}%>

<%--
     TODO: Describe time.
--%>
<%if (hasTime){%>
<!ELEMENT time EMPTY>
<%}%>

<%--
     Describe load-balancing.
--%>
<%if (hasLoadBalancing){%>
<!ELEMENT load-balancing EMPTY>
<%}%>

<%--
     Describe recording.
--%>
<%if (hasRecording){%>
<!ELEMENT recording EMPTY>
<!ATTLIST recording
    recorder-timeout CDATA #IMPLIED
>
<%}%>

<%--
     Describe watchdog.
--%>
<%if (hasWatchdog){%>
<!ELEMENT watchdog EMPTY>
<!ATTLIST watchdog
    timeout CDATA #REQUIRED
>
<%}%>

<%--
     Describe fault-tolerance.
--%>

<%--
   Now that elements have been added for each /cdmw/programs/program/services/fault-tolerance/datastores/datastore found,
   insert their descriptions.
--%>

<!ELEMENT multicast EMPTY>
<!ATTLIST multicast
   multicast-port CDATA #REQUIRED 
   multicast-domain CDATA #REQUIRED 
   ip-adresse CDATA #REQUIRED 
>

<!ELEMENT datastore EMPTY>
<!ATTLIST datastore
   typename CDATA #REQUIRED 
   datastore-id CDATA #REQUIRED 
   <%-- Commented attributs to avoid redundancy information. These attributs are already set into datastores element.
   chunk-size CDATA #IMPLIED
   freeze-size CDATA #IMPLIED
   freeze-timeout CDATA #IMPLIED
   --%>  
>

<%if (hasFaultTolerance){%>

    <%if (hasFaultToleranceWithDatastore){%>
<!ELEMENT fault-tolerance (datastores)>

<!ELEMENT datastores (multicast?, datastore*)>
<!ATTLIST datastores
   max-transaction-in-progress CDATA #REQUIRED
   max-transaction-done CDATA #REQUIRED
   cohort-timeout CDATA #REQUIRED
   coordinator-timeout CDATA #REQUIRED
   number-of-scheduler-thread CDATA #REQUIRED
   chunk-size CDATA #REQUIRED
   freeze-size CDATA #REQUIRED
   freeze-timeout CDATA #REQUIRED
>
    <%}else{%>
<!ELEMENT fault-tolerance EMPTY>
    <%}%>

<!ATTLIST fault-tolerance
   request-duration-policy CDATA #REQUIRED 
   client-id CDATA #REQUIRED 
>
<%}%>

<%--
     Describe lifecycle.
--%>
<%if (hasLifeCycle && !hasHomeImpl){%>
<!ELEMENT lifecycle (<%getFrameworksIds.sep(", ")%>)>
<%}%>

<%-- store Repository in context, since we have to use it --%>
<%-- for sub-script calls, instead of 'for' iterator --%>
<%push()%>
<%for (getFrameworksIds){%>
<%if (!isHome(self)){%>
<%peek.genFrameworkElement(self)%>
<%}%>

    <%-- check if framework is multithread
         and set "hasMultithread" context value
    --%>
    <%if (getThreading(self) == "MULTITHREAD"){%>
    <%put("hasMultithread")%>
    <%}%>
    
  
<%}%>
<%pop()%>  <%-- remove Repository from context --%>

  <%--
     Complete element descriptions with additional elements
     regarding threading, named and anonymous instances.
  --%>
<%if (hasLifeCycle && !hasHomeImpl){%>
<%if (get("hasMultithread").length() > 0){%>
<!ELEMENT multithread (serialize?)>
<%}%>
<!ELEMENT serialize EMPTY>
<%}%>





<%--
  -- Generate DTD element for a framework
  -- Required arguments:
  --   - 0: the framework id
  --%>
<%script type="idlmm.IRObject" name="genFrameworkElement"%>
<!ELEMENT <%args(0)%> (<%args(0)%>-instance<%multiplicity(args(0))%>)>
<!ATTLIST <%args(0)%>
    occurrences CDATA #FIXED "<%getOccurrences(args(0))%>"
>

<%--
   Declare a factory instance.
--%>
<%if (isNamedFactory(args(0))){%>
<!ELEMENT <%args(0)%>-instance (<%threading(args(0))%>)>
<!ATTLIST <%args(0)%>-instance
    domain-name CDATA #REQUIRED
    full-factory-name CDATA #REQUIRED
>
<%}else{%>
<!ELEMENT <%args(0)%>-instance (<%threading(args(0))%>)>
<!ATTLIST <%args(0)%>-instance
    full-factory-name CDATA #REQUIRED
>
<%}%>




<%--
  -- Return '+' if occurences > 1
  --%>
<%script type="idlmm.IRObject" name="multiplicity" post="trim()"%>
<%if (getOccurrences(args(0)) > 1){%>+<%}%>


<%--
  -- Return threading element name
  --%>
<%script type="idlmm.IRObject" name="threading" post="trim()"%>
<%getThreading(args(0)).toLowerCase()%>




<%-- Constant header for XML --%>
<%script type="idlmm.IRObject" name="xmlCopyrightHeader"%>
<!--
 * ===================================================================== *
 * This file is part of CARDAMOM (R) which is jointly developed by THALES 
 * and SELEX-SI. 
 * 
 * It is derivative work based on PERCO Copyright (C) THALES 2000-2003. 
 * All rights reserved.
 * 
 * CARDAMOM is free software; you can redistribute it and/or modify it under 
 * the terms of the GNU Library General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your 
 * option) any later version. 
 * 
 * CARDAMOM is distributed in the hope that it will be useful, but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Library General Public 
 * License for more details. 
 * 
 * You should have received a copy of the GNU Library General 
 * Public License along with CARDAMOM; see the file COPYING. If not, write to 
 * ===================================================================== *
-->

<!--
* =========================================================================== *
* This code has been generated by CDMW Code Generator 1.0
* on <%getDate()%>
* DO NOT EDIT !!!
* =========================================================================== *
-->



