<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.cdmw.codegenerator.cdmwinit.ProgramServices
import com.thalesgroup.cdmw.codegenerator.cdmwinit.cpp.initRepositoryInterface
import com.thalesgroup.cdmw.codegenerator.cdmwinit.cpp.initWatchdogService
import com.thalesgroup.cdmw.codegenerator.cdmwinit.cpp.initRequestFollowup
import com.thalesgroup.cdmw.codegenerator.cdmwinit.cpp.initFaultToleranceService
import com.thalesgroup.cdmw.codegenerator.cdmwinit.cpp.initTraceService
import com.thalesgroup.cdmw.codegenerator.cdmwinit.cpp.initRecordingService
import com.thalesgroup.cdmw.codegenerator.cdmwinit.cpp.initPerformanceService
import com.thalesgroup.cdmw.codegenerator.cdmwinit.cpp.initLoadBalancingService
import com.thalesgroup.cdmw.codegenerator.cdmwinit.cpp.initClockService
import com.thalesgroup.cdmw.codegenerator.cdmwinit.cpp.initLifeCycle
import com.thalesgroup.cdmw.codegenerator.cdmwinit.cpp.initCCM
import com.thalesgroup.cdmw.codegenerator.cdmwinit.cpp.DataStoreUtils
import com.thalesgroup.ccm.codegenerator.container.Utils
import com.thalesgroup.ccm.codegenerator.container.cpp.Names
import com.thalesgroup.ccm.codegenerator.corba.CommonServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.Utils
%>



<%script type="idlmm.Repository" name="cppFilePath" post="trim()"%>
<%if (filename.length() > 0){%>
<%directoryPrefix%><%filename%>.cpp
<%}else{%>
<%directoryPrefix%>CdmwInterface.cpp
<%}%>


<%--
  -- If directory attribute is specified for the <program>,
  -- this script returns the directory +"/"
  --%>
<%script type="idlmm.Repository" name="directoryPrefix" post="trim()"%>
<%if (directory.length > 0){%>
<%directory%>/
<%}%>


<%--
  -- Generation template  
  -- This template is not model-based (idlmm.Repository is just specified
  -- to access HomeDef data)
  -- All is based on ProgramServices which provides access to loaded data
  -- from XML file.
  --%>
<%script type="idlmm.Repository" name="CdmwInit" file="<%cppFilePath%>"%>
<%copyrightHeader%>

<%if (hasFaultToleranceServer() && hasLoadBalancingServer()){%>
<%abort("ERROR: Cannot generate CDMWInit with FaultTolerance server and LoadBalancing server at the same time")%>
<%}%>

#include <ConfAndPlug/cdmwinit/CdmwInterface.hpp>
#include <ConfAndPlug/cdmwinit/CdmwInitConfiguration.hpp>
#include <ConfAndPlug/cdmwinit/InitUtils.hpp>
#include <SystemMngt/platforminterface/PlatformInterface.hpp>
#include <Foundation/common/Assert.hpp>
#include <Foundation/ossupport/SystemProperties.hpp>
#include <Foundation/ossupport/OS.hpp>
#include <Foundation/orbsupport/Codec.hpp>
#include <Foundation/orbsupport/StrategyList.hpp>
#include <Foundation/osthreads/Mutex.hpp>
#include <Foundation/osthreads/Condition.hpp>
#include <Foundation/common/Exception.hpp>
#include <Foundation/orbsupport/ExceptionMinorCodes.hpp>
#include <Foundation/orbsupport/OrbSupport.hpp>
#include <Foundation/logging/LogManager.hpp>
#include <Foundation/logging/Logger.hpp>
#include <Foundation/common/Locations.hpp>
#include <Repository/repositoryinterface/RepositoryInterface.hpp>
<%if (hasLifeCycle()){%>
#include <LifeCycle/lifecycleinit/InitUtils.hpp>
<%}%>
<%if (hasRecording()){%>
#include <Foundation/common/Options.hpp>
#include <TraceAndPerf/recordingidl/CdmwRecordingDaemonControl.stub.hpp>
#include <Foundation/idllib/CdmwRecordingContainerManager.stub.hpp>
<%}%>
<%if (hasFaultTolerance()){%>
#include <Foundation/ossupport/OS.hpp>
#include <FaultTolerance/ftlocationmanager/PrimaryBackupGroupRepository_impl.hpp>
#include <FaultTolerance/ftlocationmanager/PrimaryBackupAdmin_impl.hpp>
#include <FaultTolerance/idllib/CdmwFTReplicationManager.stub.hpp>
#include <FaultTolerance/ftcommon/FTConfiguration.hpp>
#include <Foundation/commonsvcs/datastore/StorageHome.hpp>
#include <FaultTolerance/ftstatemanager/TXManager.hpp>
#include <FaultTolerance/ftstatemanager/TXDataStore.hpp>
#include <FaultTolerance/ftstatemanager/DataStoreContext.hpp>
#include <FaultTolerance/ftstatemanager/DataStoreGroup_impl.hpp>
#include <FaultTolerance/ftrequestlogging/FTReplyRecording.hpp>
#include <FaultTolerance/ftinit/FTServiceInit.hpp>
<%}%>
<%if (hasWatchdog()){%>
#include <FaultTolerance/ftwatchdog/WatchdogServiceInit.hpp>
#include <FaultTolerance/ftwatchdog/RequestTimeoutLocalPullMonitorable_impl.hpp>
#include <FaultTolerance/ftcommon/FTSystemProperties.hpp>
<%}%>
<%if (hasFaultToleranceWithDatastore()){%>
#include <FaultTolerance/ftlocationmanager/StatefullPrimaryBackupAdmin_impl.hpp>
#include <FaultTolerance/ftlocationmanager/LocationDataStoreTimeoutHandler_impl.hpp>
<%}%>
<%if (hasLoadBalancing()){%>
#include <LoadBalancing/idllib/CdmwLBGroupManager.stub.hpp>
<%}%>
<%if (hasHomeImpl()){%>
#include <CCMContainer/ccmcif/InitUtils.hpp>
#include <CCMContainer/ccmcontainer/InitUtils.hpp>
#include <CCMContainer/ccmcomponentserver/InitUtils.hpp>
#include <CCMContainer/ccmcontainer/HomeAllocatorRegistry.hpp>
#include <Foundation/common/Locations.hpp>
#include <Foundation/commonsvcs/naming/NamingUtil.hpp>
#include <LifeCycle/lifecycle/DefaultObjectRegistration.hpp>
<%}%>
<%if (hasEventPorts()){%>
#include <Event/idllib/CdmwEvent.stub.hpp>
#include <Event/eventsupport/EventChannelFactory_impl.hpp>
<%}%>

<%for (getFrameworksIds()){%>
<%genFrameworkInclude(self)%>
<%}%>

<%-- generate #include for datastore typetraits, but
     only for <datastore> nodes which are declared in 
     <fault-tolerance><datastores> node.
--%>
<%for (getUsedDatastoreTypenames()){%>
<%genDatastoreInclude(self)%>
<%}%>

#include <memory> // for std::auto_ptr
#include <string>
#include <vector>
#include <sstream>

<%if (hasTrace()){%>
<%if (hasBufferingEnabled()){%>
#include <TraceAndPerf/tracelibrary/Trace.hpp>
#include <TraceAndPerf/tracelibrary/CdmwTrace.hpp>
#include <TraceAndPerf/tracelibrary/InitUtils.hpp>
#define CDMW_TRACES_ENABLED
<%}else{%>
// Use of LogManagerCollectorDelegate instead of the FlushAreaMngr/tracelibrary
// NOTA: Discard of repetitive traces does not work with this configuration.
#include <Foundation/logging/LogManagerCollectorDelegate.hpp>
<%}%>
<%}%>

<%if (hasRequestFollowup()){%>
#include <Foundation/commonsvcs/requestfollowup/NDCServiceInit.hpp>
<%}%>

<%if (hasPerformance()){%>
#include <TraceAndPerf/performancelibrary/InitUtils.hpp>
#define CDMW_PERFORMANCE_ENABLED
<%}%>

<%if (hasTime()){%>
#include <Time/clockservice/CdmwCosClock.hpp>
#include <Time/idllib/CosClockService.stub.hpp>
#define CDMW_TIME_SERVICE_ENABLED
<%}%>

<%if (hasLoadBalancing()){%>
#include <LoadBalancing/lbinit/LBServiceInit.hpp>
#define CDMW_LB_SERVICE_ENABLED
<%}%>

<%if (hasRecording()){%>
// Anonymous namespace
namespace
{
    CORBA::Object_ptr
    set_recorder_policies(CORBA::ORB_ptr orb, 
                          CORBA::Object_ptr obj,
                          unsigned long callTimeout_millisec)
    {
        CORBA::PolicyList policy_list(2);
        CORBA::ULong i = 0L;
          // Create the timeout policy
          if (callTimeout_millisec != 0) {
              CORBA::Any timeout;
              // Timeout success
              //Set the timeout value as a TimeBase::TimeT (100 nanoseconds units)
              TimeBase::TimeT _timeout = ((unsigned long) (callTimeout_millisec * 1.0e4));
              timeout <<= _timeout;
              policy_list.length( i+1 );
              policy_list[i] = orb->create_policy( Messaging::RELATIVE_RT_TIMEOUT_POLICY_TYPE,
                                                   timeout );
              ++i;
        }
        Messaging::SyncScope sync_scope = Messaging::SYNC_WITH_SERVER;
        CORBA::Any sync_scope_any;
          sync_scope_any <<= sync_scope;
          policy_list.length( i+1 );
          policy_list[i] = orb->create_policy (Messaging::SYNC_SCOPE_POLICY_TYPE,
                                                sync_scope_any);
          // Set the policy
          CORBA::Object_var capsule =
              obj->_set_policy_overrides( policy_list, CORBA::SET_OVERRIDE );
                                           
          return capsule._retn();
       }
}; // End anonymous namespace
<%}%>


//--------------------------------------------------------------------------

<%if (hasEventPorts()){%>
//
// Re-implement EventChannelFactory allocator to set 
// use_profile_manager parameter attribute to false 
// in EventChannelFactory constructor call.
//   
<%openNamespace(generatedEventPackage)%>
    template <>
    PortableServer::Servant
    EventChannelFactory_impl_Allocator::allocate(
            CORBA::ORB_ptr orb,
            PortableServer::POA_ptr parent,
            CdmwLifeCycle::ObjectRegistration_ptr name_domain,
            const std::string & name_domain_name,
            const std::string & factory_name,
            Cdmw::OrbSupport::POAThreadingPolicy & threading_policy,
            int & argc, char** argv)
        throw(Cdmw::OutOfMemoryException,
              Cdmw::BadParameterException,
              Cdmw::InternalErrorException,
              CORBA::SystemException)
    {
        try {
            return new Cdmw::Event::EventChannelFactory_impl(orb,
                                                             parent,
                                                             name_domain,
                                                             name_domain_name,
                                                             factory_name,
                                                             threading_policy,
                                                             argc,
                                                             argv,
                                                             false);
        }
        catch (const std::bad_alloc &)
        {
            CDMW_THROW(Cdmw::OutOfMemoryException);
        }
    }    
<%closeNamespace(generatedEventPackage)%>

//--------------------------------------------------------------------------
<%}%>

<%openNamespace(generatedCdmwinitPackage)%>

    void 
    CDMW_preORBInit(int & argc, char** argv) 
        throw (CORBA::SystemException)
    {
        <%if (hasFaultTolerance()){%>

        <%initFTService%>
        <%}%>
        <%if (hasLoadBalancing()){%>

        <%initLBService%>
        <%}%>
        <%if (hasWatchdog()){%>

        <%initWatchdogService%>
        <%}%>
        <%if (hasRequestFollowup()){%>

        <%initRequestFollowup%>
        <%}%>
    }
        

    void 
    CDMW_init(CORBA::ORB_ptr orb, int & argc, char** argv, ProcessControl* ctrl) 
        throw (CORBA::SystemException)
    {
        <%registerCodeGenerationProperties%>

        CDMW_ASSERT(!CORBA::is_nil(orb));
        CdmwProcess_impl * process_impl = 0;

        try {
            // initialise the LogManager
            Cdmw::Logging::LogManager::Init(argc, argv);

            // PCR-0049
            Cdmw::OrbSupport::CodecBase::Init(orb);

            // Initialize XML library
            Cdmw::CdmwInit::InitUtils::init_xml_library();

            // Get the XML init filename. This may raise CORBA::BAD_PARAM, CORBA::NO_MEMORY,
            // or CORBA::INTERNAL    
            std::string xml_file = InitUtils::get_xml_initialisation_file(argc, argv);
        
            // Get the XML documents validation option. This may raise CORBA::NO_MEMORY,
            // or CORBA::INTERNAL
            bool validate_xml = InitUtils::get_xml_validation_option(argc, argv);
        
            CDMW_INFO(InitUtils::Get_Logger(), 
                      "Initialise process with XML file " << xml_file
                      << (validate_xml ? " (it will be validated)"
                                       : " (it will not be validated)"));

            // Parsing xml
            std::auto_ptr<Cdmw::CdmwInit::CdmwInitConfiguration> xml_data(0);
            try {
                std::auto_ptr<Cdmw::CdmwInit::CdmwInitConfiguration> init
                    (Cdmw::CdmwInit::CdmwInitConfiguration::ReadConfiguration(xml_file,
                                                                              validate_xml));
            
                xml_data = init;
            } catch (const Cdmw::OutOfMemoryException & ex) {
                CDMW_WARN(InitUtils::Get_Logger(), "Receive Cdmw::OutOfMemoryException "
                                                   << ex.what());
                CDMW_THROW1( Cdmw::OrbSupport::CORBASystemExceptionWrapperT<CORBA::NO_MEMORY>,
                             CORBA::NO_MEMORY(Cdmw::OrbSupport::NO_MEMORY, 
                                              CORBA::COMPLETED_NO) );
            } catch (const Cdmw::CdmwInit::ConfigurationException & ex) {
                CDMW_WARN(InitUtils::Get_Logger(), "Receive CdmwInit::ConfigurationException "
                                                   << ex.what());
                CDMW_THROW2( Cdmw::OrbSupport::CORBASystemExceptionWrapperT<CORBA::BAD_PARAM>,
                             CORBA::BAD_PARAM(Cdmw::OrbSupport::BAD_PARAMInvalidXMLInitData,
                                              CORBA::COMPLETED_NO),
                             ex.what());
            } catch(const Cdmw::InternalErrorException & ex){
                CDMW_WARN(InitUtils::Get_Logger(), "Receive Cdmw::InternalErrorException "
                                                   << ex.what());
                CDMW_THROW2( Cdmw::OrbSupport::CORBASystemExceptionWrapperT<CORBA::INTERNAL>,
                             CORBA::INTERNAL(Cdmw::OrbSupport::INTERNALXMLLibraryError,
                                             CORBA::COMPLETED_NO),
                             ex.what() );
            }

            // *****************************************************************
            // *****************  CDMW root POA and servant manager ***********
            // *****************************************************************
            //
            // Create the CDMW root POA. It has its own POA Manager
            // May raise a CORBA::SystemException.
            //
            PortableGroup::GOA_var CDMW_rootPOA = InitUtils::create_cdmw_root_GOA(orb);
        
            PortableServer::POAManager_var poaManager = CDMW_rootPOA -> the_POAManager();
            //
            // Initialize the server so that incoming requests are
            // handled from this point on
            //
            // May raise PortableServer::AdapterInactive or CORBA::SystemException
            try {
                CDMW_DEBUG(InitUtils::Get_Logger(), "Activate POA Manager"); 
                poaManager -> activate(); // TODO: maybe move it?
            } catch (const PortableServer::POAManager::AdapterInactive & ) {
                CDMW_THROW1( Cdmw::OrbSupport::CORBASystemExceptionWrapperT<CORBA::INTERNAL>,
                             CORBA::INTERNAL(Cdmw::OrbSupport::INTERNALORBAdapterInactive,
                                             CORBA::COMPLETED_NO) );
            } catch (const CORBA::SystemException & ex ) {
                CDMW_THROW2( Cdmw::OrbSupport::CORBASystemExceptionWrapperT<CORBA::SystemException>,
                             ex, "Could not activate the CDMW POA Manager!" );
            }
         
            <%if (hasFaultTolerance()){%>

            <%setupFTPolicies%>
            <%}%>
            
            <%if (hasWatchdog()){%>

            <%setupWatchdogService%>
            <%}%>
            
            <%if (!hasBufferingEnabled() || hasRecording()){%>

            <%registerDaemonNameServiceAsLocalNameService%>
            <%}%>
            
            // *****************************************************************
            // *****************  setup platforminterface object  **************
            // *****************************************************************

            // Did we receive a ProcessControl callback object?
            CdmwPlatformMngt::ProcessDelegate_var process =
                CdmwPlatformMngt::ProcessDelegate::_nil();
            {
                ProcessControl_var process_ctrl_var;
                if (ctrl != 0)
                    process_ctrl_var = ctrl;
                else
                    process_ctrl_var = new DefaultProcessControl();
                CdmwFT::LocalPullMonitorable_var lpm = CdmwFT::LocalPullMonitorable::_nil();

                <%if (hasWatchdog()){%>
                lpm = new Cdmw::FT::Watchdog::RequestTimeoutLocalPullMonitorable_impl();
                <%}%>
                
                // CdmwProcess_impl() will acquire a reference on ProcessControl object and
                // will automatically release it at object's destruction.
                PortableServer::POA_var rootPOA = InitUtils::get_root_POA(orb);
                process_impl = new CdmwProcess_impl(orb,
                                                    rootPOA.in(),
                                                    CDMW_rootPOA.in(),
                                                    process_ctrl_var._retn(), lpm._retn() );
                PortableServer::ServantBase_var process_impl_servant = process_impl;
                
                process = process_impl->_this();

                <%if (hasSystemManagement()){%>
                // Set the Property before calling init_platform_interface() which calls
                // PlatformInterface::Setup(). The Property is read in Setup().

                Cdmw::OsSupport::SystemProperties::Set_Property(
                    Cdmw::OrbSupport::SYSTEM_MANAGEMENT_FATAL_HANDLER_PROPERTY_NAME, 
                    "true");
                <%}else{%>
                // Set the Property before calling init_platform_interface() which calls PlatformInterface::Setup().
                // The Property is read in Setup().

                Cdmw::OsSupport::SystemProperties::Set_Property(
                    Cdmw::OrbSupport::SYSTEM_MANAGEMENT_FATAL_HANDLER_PROPERTY_NAME, 
                    "false");
                <%}%>

                InitUtils::init_platform_interface(orb, argc, argv, process.in());
            }

            //
            // Get the process name. This may raise CORBA::BAD_INV_ORDER
            std::string process_name = InitUtils::get_cdmw_process_name();
            //
            // Get the application name. This may raise CORBA::BAD_INV_ORDER
            std::string application_name = InitUtils::get_cdmw_application_name();  

            CDMW_INFO(InitUtils::Get_Logger(), "CDMW_init ongoing for " 
                      << application_name << "/" << process_name);
            Cdmw::Logging::LogManager::Instance()->set_process_name(process_name);
            Cdmw::Logging::LogManager::Instance()->set_application_name(application_name);

            // Retreive Repository object reference. This may raise CORBA::BAD_PARAM
            // or CORBA::BAD_INV_ORDER
            CdmwNamingAndRepository::Repository_var repository 
                = InitUtils::get_cdmw_repository();

            <%if (hasFaultTolerance()){%>

            <%setupFTReplicationManager%>
            <%}%>
            
            <%if (hasFaultToleranceServer()){%>

            <%setupFTLocationManager%>
            
                <%if (hasFaultToleranceWithDatastore()){%>

            <%setupStatefullPrimaryBackupAdmin%>
                    <%if (hasFaultToleranceReplyLogging()){%>

            <%initReplyLogging%>
                    <%}%>

            <%registerStatefullLocation%>
            
                <%}else{%>

            <%setupPrimaryBackupAdmin%>
                <%}%>
            
            <%}%>
            
            <%if (hasRepositoryInterface()){%>
            
            <%initRepositoryInterface%>
            <%}%>

            <%if (hasTrace){%>
            <%if (hasBufferingEnabled){%>
            
            <%initTraceService%>
            <%}else{%>
            
            <%initLogManagerCollectorDelegate%>
            <%}%>
            <%}%>

            <%if (hasPerformance){%>
            
            <%initPerformanceService%>
            <%}%>
            
            <%if (hasLoadBalancing){%>
            
            <%initLBGroupManager%>
            <%}%>
            
            <%if (hasTime){%>
            
            <%initClockService%>
            <%}%>

            <%if (hasRecording()){%>
            
            <%initRecordingService%>
            <%}%>

            <%if (hasLifeCycle){%>
            
            <%initLifeCycle%>

            <%if (hasHomeImpl){%>
            
            <%initCCM%>
            <%}%>

            <%}%>

            // Discard requests until run order comes from the platform management
            poaManager->discard_requests(false);

            CDMW_INFO(InitUtils::Get_Logger(), "Acknowledge creation of process "
                      << application_name << "/" << process_name);
            Cdmw::PlatformMngt::PlatformInterface::Acknowledge_creation(process.in());
     
        } catch (const Cdmw::OrbSupport::CORBASystemExceptionWrapper & ex) {
            CDMW_FATAL(InitUtils::Get_Logger(), 
                       "CORBA Exception during CDMW_init: "
                       << ex); 
            ex.raise_SystemException();
        } catch (const CORBA::SystemException & ex) {  
            CDMW_FATAL(InitUtils::Get_Logger(),  
                       "CORBA SystemException during CDMW_init: "
                       << Cdmw::OrbSupport::OrbSupport::exception_to_string(ex));
            throw;
        }

    }

    // CDMW Factory objects will be deactivated at ORB shutdown.
    void
    CDMW_cleanup(CORBA::ORB_ptr orb)
        throw ()
    {
        CDMW_INFO(InitUtils::Get_Logger(), "CDMW_cleanup");
        CDMW_ASSERT(!CORBA::is_nil(orb));

        <%if (hasHomeImpl){%>
        using namespace Cdmw::CCM::Container;

        // We should unbind "processname"/CCM/Components from AdminRootContext
        // here. But as ORB has just been shutdown in on_stop() operation,
        // no outgoing request are allowed (BAD_INV_ORDER or COMM_FAILURE received)
             
        <%genUnregisterHomeAllocators%>

        <%genUnregisterValuetypeFactories%>
        <%}%>

        <%if (hasTrace && hasBufferingEnabled){%>
        
        <%stopTraceService%>
        <%}%>
        
        <%if (hasTime){%>

        <%stopClockService%>
        <%}%>
        
        <%if (hasPerformance){%>

        <%stopPerformanceService%>
        <%}%>

        <%if (hasRepositoryInterface()){%>
        
        <%stopRepositoryInterface%>
        <%}%>
         
        // Release all static object references held by PlatformInterface
        Cdmw::PlatformMngt::PlatformInterface::Cleanup();

        <%if (hasTrace && !hasBufferingEnabled){%>
        
        <%stopLogManagerCollectorDelegate%>
        <%}%>

        try {
            // Cleanup XML library
            Cdmw::CdmwInit::InitUtils::cleanup_xml_library();
        } catch (const Cdmw::OrbSupport::CORBASystemExceptionWrapper& ex) {
            CDMW_WARN(InitUtils::Get_Logger(), 
                      "XML library cleanup: " << ex);
        }     
    }

<%closeNamespace(generatedCdmwinitPackage)%>






<%script type="idlmm.Repository" name="generatedCdmwinitPackage" post="trim()"%>
::Cdmw::CdmwInit


<%-- 
  -- Generate #include for specified framework
  -- Required argument:
  --   - 0 : the framework id
  --%>
<%script type="EObject" name="genFrameworkInclude" post="trim()"%>
<%if (!isHome(args(0)) && !isUserFactory(args(0))){%>
#include "<%genFrameworkFactoryFilename(args(0))%>_allocator.hpp"
<%}else{%>
#include "<%genFrameworkFactoryFilename(args(0)).addFileExtension(".hpp")%>"
<%}%>


<%-- 
  -- Generate filename of factory for specified framework
  -- Required argument:
  --   - 0 : the framework id
  --%>
<%script type="EObject" name="genFrameworkFactoryFilename" post="trim()"%>
<%if (isUserFactory(args(0))){%>
    <%if (getAllocatorFilename(args(0)).length() > 0){%>
        <%getAllocatorFilename(args(0))%>
    <%}else{%>
        <%pathPrefix%><%getAllocatorClassname(args(0)).getLastToken("\.")%>
    <%}%>
<%}else{%>
    <%if (getFactoryFilename(args(0)).length() > 0){%>
        <%getFactoryFilename(args(0))%>
    <%}else{%>
        <%if (getFactoryClassname(args(0)).length() > 0){%>
            <%pathPrefix%><%getFactoryClassname(args(0)).getLastToken("\.")%>
        <%}else{%>
            <%if (isHome(args(0))){%>
                <%pathPrefix%><%homeCategory(args(0)).toLowerCase.toU1Case%><%getFactoryIdlInterface(args(0)).getLastToken("\.")%>_impl
            <%}%>
        <%}%>
    <%}%>
<%}%>



<%--
  -- Returns CSC_NAME System property as path prefix, if defined
  --%>
<%script type="EObject" name="pathPrefix" post="trim()"%>
<%if (getSystemProperty("CSC_NAME").length > 0){%>
<%getSystemProperty("CSC_NAME")%>/
<%}%>


<%script type="idlmm.Repository" name="basePropertyName"%>
Cdmw.ConfAndPlug.CodeGenerationOption.

<%script type="idlmm.Repository" name="registerCodeGenerationProperties"%>
::Cdmw::OsSupport::SystemProperties::Set_Property(
    "<%basePropertyName%>hasRepositoryInterface", "<%hasRepositoryInterface%>");
::Cdmw::OsSupport::SystemProperties::Set_Property(
    "<%basePropertyName%>hasContainerInterception", "<%hasContainerInterception%>");
::Cdmw::OsSupport::SystemProperties::Set_Property(
    "<%basePropertyName%>hasPerformance", "<%hasPerformance%>");
::Cdmw::OsSupport::SystemProperties::Set_Property(
    "<%basePropertyName%>hasTrace", "<%hasTrace%>");
::Cdmw::OsSupport::SystemProperties::Set_Property(
    "<%basePropertyName%>hasRequestFollowup", "<%hasRequestFollowup%>");
::Cdmw::OsSupport::SystemProperties::Set_Property(
    "<%basePropertyName%>hasBufferingEnabled", "<%hasBufferingEnabled%>");
::Cdmw::OsSupport::SystemProperties::Set_Property(
    "<%basePropertyName%>hasSystemManagement", "<%hasSystemManagement%>");
::Cdmw::OsSupport::SystemProperties::Set_Property(
    "<%basePropertyName%>hasTime", "<%hasTime%>");
::Cdmw::OsSupport::SystemProperties::Set_Property(
    "<%basePropertyName%>hasRecording", "<%hasRecording%>");
::Cdmw::OsSupport::SystemProperties::Set_Property(
    "<%basePropertyName%>hasWatchdog", "<%hasWatchdog%>");
::Cdmw::OsSupport::SystemProperties::Set_Property(
    "<%basePropertyName%>hasFaultTolerance", "<%hasFaultTolerance%>");
::Cdmw::OsSupport::SystemProperties::Set_Property(
    "<%basePropertyName%>hasLoadBalancing", "<%hasLoadBalancing%>");
::Cdmw::OsSupport::SystemProperties::Set_Property(
    "<%basePropertyName%>hasLifeCycle", "<%hasLifeCycle%>");
::Cdmw::OsSupport::SystemProperties::Set_Property(
    "<%basePropertyName%>hasHomeImpl", "<%hasHomeImpl%>");
::Cdmw::OsSupport::SystemProperties::Set_Property(
    "<%basePropertyName%>frameworksIdref", "<%getFrameworksIds.sep(", ")%>");
::Cdmw::OsSupport::SystemProperties::Set_Property(
    "<%basePropertyName%>usedDatastoreTypenames", "<%getUsedDatastoreTypenames.sep(", ")%>");



<%script type="idlmm.Repository" name="registerDaemonNameServiceAsLocalNameService"%>
// *****************************************************************
// *********   Retrieve the Daemon's NameService object      *******
// *********   reference and register it as LocalNameService *******
// *********   SystemPort option is now handled by           *******
// *********   OrbSupport::ORB_init(argc,argv)               *******
// *****************************************************************
CosNaming::NamingContext_var local_NameService = CosNaming::NamingContext::_nil();

std::string system_port =
    Cdmw::OsSupport::SystemProperties::Get_Property(Cdmw::OrbSupport::SYSTEM_PORT_PROPERTY_NAME);
if (system_port.empty()) {
    CDMW_FATAL(InitUtils::Get_Logger(), "CdmwSystemPort has not be declared"
               << " in argument. This is required to get the object referennce of"
               << " the LogCollector and/or the recording daemon and recording server.");
    CDMW_THROW1( Cdmw::OrbSupport::CORBASystemExceptionWrapperT<CORBA::BAD_PARAM>,
                 CORBA::BAD_PARAM(Cdmw::OrbSupport::BAD_PARAMMissingPortNumber, 
                                  CORBA::COMPLETED_NO) );
} else {
    try {
        std::ostringstream ostr;
        ostr << "corbaloc::localhost:"<<system_port<<"/NameService";
        CORBA::Object_var obj__ = orb->string_to_object(ostr.str().c_str());
        local_NameService  = CosNaming::NamingContext::_narrow(obj__.in());
        if (CORBA::is_nil(local_NameService.in())) {
            ostr << " is not a NameServer reference!";
            CDMW_FATAL(InitUtils::Get_Logger(), ostr.str());
            CDMW_THROW2( Cdmw::OrbSupport::CORBASystemExceptionWrapperT<CORBA::BAD_PARAM>,
                         CORBA::BAD_PARAM(Cdmw::OrbSupport::BAD_PARAMNilObjectReference, 
                                          CORBA::COMPLETED_NO),
                         ostr.str());
        }
        orb->register_initial_reference("LocalNameService", local_NameService.in());
    } catch (const CORBA::SystemException& ex) {
        CDMW_THROW2( Cdmw::OrbSupport::CORBASystemExceptionWrapperT<CORBA::SystemException>,
                     ex, "Could not retrieve local NameService's object reference!" );
    } catch (const CORBA::ORB::InvalidName& )  {
        CDMW_THROW2( Cdmw::OrbSupport::CORBASystemExceptionWrapperT<CORBA::INTERNAL>,
                     CORBA::INTERNAL(Cdmw::OrbSupport::INTERNAL, CORBA::COMPLETED_NO),
                     "InvalidName => Cannot register LocalNameService.");
    }
}


