<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.CommonServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.CppMappingServices
import com.thalesgroup.ccm.codegenerator.container.Utils
import com.thalesgroup.cdmw.codegenerator.cdmwinit.DatastoreTypesServices
import com.thalesgroup.cdmw.codegenerator.cdmwinit.cpp.DataStoreUtils
%>


<%script type="idlmm.Repository" name="cppFilePath" post="trim()"%>
<%if (getDatastoreFilename(getCurrentDatastoreTypename).length > 0){%>
    <%pathPrefix%><%getDatastoreFilename(getCurrentDatastoreTypename)%>
<%}else{%>
    <%pathPrefix%><%getCurrentDatastoreTypename%>TypeTraits.hpp
<%}%>


<%script type="idlmm.Repository" name="DataStoreTypeTraits" file="<%cppFilePath%>"%>
<%copyrightHeader%>

<%if (getDatastoreIdlFilename(getCurrentDatastoreTypename).length > 0){%>
#include "<%genIdlStubName%>"
<%}%>

<%-- store OID IDLType in context with "oidtype" name --%>
<%getDatastoreOidType(getCurrentDatastoreTypename).put("oidtype")%>
<%if (get("oidtype").isSimpleDataTypeForDataTraits == "false"){%>
#ifndef <%get("oidtype").genDefineMacro%>
#define <%get("oidtype").genDefineMacro%>
#include "<%get("oidtype").genStdLessFilename%>"
<%get("oidtype").genTypeTraitsDefine%>
#endif
<%}%>

<%-- store Data IDLType in context with "datatype" name --%>
<%getDatastoreDataType(getCurrentDatastoreTypename).put("datatype")%>
<%if (get("datatype").isSimpleDataTypeForDataTraits == "false"){%>
#ifndef <%get("datatype").genDefineMacro%>
#define <%get("datatype").genDefineMacro%>
<%get("datatype").genTypeTraitsDefine%>
#endif // <%get("datatype").genDefineMacro%>
<%}%>



<%script type="idlmm.Repository" name="genIdlStubName" post="trim()"%>
<%getDatastoreIdlFilename(getCurrentDatastoreTypename).replaceAll("[.]idl$", ".stub.hpp")%>



<%script type="idlmm.IDLType" name="genDefineMacro" post="trim()"%>
<%abort("INTERNAL ERROR: cannot genDefineMacro for non-Contained type: "+ eClass.name)%>

<%script type="idlmm.Contained" name="genDefineMacro" post="trim()"%>
__DECLARE_<%absoluteName.noColonPrefix.replaceAll("::", "_").toUpperCase%>_TYPE_TRAITS__


<%script type="idlmm.IDLType" name="genStdLessFilename" post="trim()"%>
<%abort("INTERNAL ERROR: cannot genStdLessFilename for non-Contained type: "+ eClass.name)%>

<%script type="idlmm.Contained" name="genStdLessFilename" post="trim()"%>
StdLess<%absoluteName.noColonPrefix.replaceAll("::", "")%>.hpp


<%script type="idlmm.IDLType" name="genTypeTraitsDefine" post="trim()"%>
<%abort("INTERNAL ERROR: cannot genStdLessFilename for non-Contained type: "+ eClass.name)%>

<%script type="idlmm.Contained" name="genTypeTraitsDefine" post="trim()"%>
<%typeTraitsDefineMacro%>(<%absoluteName%>);



<%script type="idlmm.IDLType" name="typeTraitsDefineMacro" post="trim()"%>
<%abort("INTERNAL ERROR: cannot typeTraitsDefineMacro for IDLType type: "+ eClass.name)%>

<%script type="idlmm.Contained" name="typeTraitsDefineMacro" post="trim()"%>
<%abort("INTERNAL ERROR: cannot typeTraitsDefineMacro for Contained type: "+ eClass.name)%>

<%script type="idlmm.AliasDef" name="typeTraitsDefineMacro" post="trim()"%>
<%type.typeTraitsDefineMacro%>

<%script type="idlmm.EnumDef" name="typeTraitsDefineMacro" post="trim()"%>
DEFINE_SIMPLE_DATA_TRAITS

<%script type="idlmm.SequenceDef" name="typeTraitsDefineMacro" post="trim()"%>
DEFINE_VARIABLE_LENGTH_DATA_TRAITS

<%script type="idlmm.UnionDef" name="typeTraitsDefineMacro" post="trim()"%>
<%if (isVariableLength){%>
DEFINE_VARIABLE_LENGTH_DATA_TRAITS
<%}else{%>
DEFINE_FIXED_LENGTH_DATA_TRAITS
<%}%>

<%script type="idlmm.StructDef" name="typeTraitsDefineMacro" post="trim()"%>
<%if (isVariableLength){%>
DEFINE_VARIABLE_LENGTH_DATA_TRAITS
<%}else{%>
DEFINE_FIXED_LENGTH_DATA_TRAITS
<%}%>

<%script type="idlmm.ArrayDef" name="typeTraitsDefineMacro" post="trim()"%>
<%if (isVariableLength){%>
DEFINE_VARIABLE_LENGTH_ARRAY_TRAITS
<%}else{%>
DEFINE_FIXED_LENGTH_ARRAY_TRAITS
<%}%>



