<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.cdmw.codegenerator.cdmwinit.DatastoreTypesServices
import com.thalesgroup.ccm.codegenerator.corba.CommonServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.CppMappingServices

%>


<%-- 
  -- Generate #include for specified datastore
  -- Required argument:
  --   - 0 : the datastore typename
  --%>
<%script type="EObject" name="genDatastoreInclude" post="trim()"%>
#include "<%pathPrefix%><%genDatastoreTypeTraitsFilename(args(0)).addFileExtension(".hpp")%>"

<%-- 
  -- Generate filename of TypeTraits specified datastore
  -- Required argument:
  --   - 0 : the framework id
  --%>
<%script type="EObject" name="genDatastoreTypeTraitsFilename" post="trim()"%>
<%if (getDatastoreFilename(args(0)).length() > 0){%>
<%getDatastoreFilename(args(0))%>
<%}else{%>
<%args(0)%>TypeTraits
<%}%>

<%--
  -- Returns CSC_NAME System property as path prefix, if defined
  --%>
<%script type="EObject" name="pathPrefix" post="trim()"%>
<%if (getSystemProperty("CSC_NAME").length > 0){%>
<%getSystemProperty("CSC_NAME")%>/
<%}%>

<%--
  -- Return true if typename passed as parameter is a simple type
  -- Required argument:
  --   - 0 : the typename
  --%>
<%script type="IDLType" name="isSimpleDataTypeForDataTraits" post="trim"%>
    false


<%script type="PrimitiveDef" name="isSimpleDataTypeForDataTraits" post="trim"%>
<%if (kind == "pk_short" ||
      kind == "pk_long" ||
      kind == "pk_ushort" ||
      kind == "pk_ulong" ||
      kind == "pk_float" ||
      kind == "pk_double" ||
      kind == "pk_boolean" ||
      kind == "pk_char" ||
      kind == "pk_octet" ||
      kind == "pk_string" ||
      kind == "pk_longlong" ||
      kind == "pk_ulonglong" ||
      kind == "pk_longdouble" ||
      kind == "pk_wchar" ||
      kind == "pk_wstring" ||
){%>
    true
<%}else{%>
    false
<%}%>

<%script type="AliasDef" name="isSimpleDataTypeForDataTraits" post="trim"%>
    <%type.isSimpleDataTypeForDataTraits%>

<%--
  -- Return C++ type for typename passed as parameter
  -- Required argument:
  --   - 0 : the typename
  --%>
<%script type="IDLType" name="getCppTypeForDataTraits" post="trim"%>
<%abort("INTERNAL ERROR: Fallback, no getCppTypeForDataTraits specialization for "+eClass)%>

<%script type="PrimitiveDef" name="getCppTypeForDataTraits"  post="trim"%>
<%if (kind == "pk_short"){%>
    CORBA::Short
<%}else if(kind == "pk_long"){%>
    CORBA::Long
<%}else if(kind == "pk_ushort"){%>
    CORBA::UShort
<%}else if(kind == "pk_ulong"){%>
    CORBA::ULong
<%}else if(kind == "pk_float"){%>
    CORBA::Float
<%}else if(kind == "pk_double"){%>
    CORBA::Double
<%}else if(kind == "pk_boolean"){%>
    CORBA::Boolean
<%}else if(kind == "pk_char"){%>
    CORBA::Char
<%}else if(kind == "pk_octet"){%>
    CORBA::Octet
<%}else if(kind == "pk_any"){%>
    CORBA::Any
<%}else if(kind == "pk_string"){%>
    std::string
<%}else if(kind == "pk_objref"){%>
    CORBA::Object
<%}else if(kind == "pk_longlong"){%>
    CORBA::LongLong
<%}else if(kind == "pk_ulonglong"){%>
    CORBA::ULongLong
<%}else if(kind == "pk_longdouble"){%>
    CORBA::LongDouble
<%}else if(kind == "pk_wchar"){%>
    CORBA::WChar
<%}else if(kind == "pk_wstring"){%>
    CORBA::WString
<%}else if(kind == "pk_value_base"){%>
    CORBA::ValueBase
<%}else{%>
    <%abort("ERROR: cannot use type with "+kind+" kind in DataStore")%>
<%}%>

<%script type="Contained" name="getCppTypeForDataTraits"  post="trim"%>
<%absoluteName%>