<%
metamodel http://www.prismtech.com/idlmm
%>


<%script type="idlmm.Repository" name="initLBService"%>
#ifdef CDMW_LB_SERVICE_ENABLED
// *****************************************************************
// *********         Init The CDMW LB Service              *********
// *****************************************************************

try {
    Cdmw::LB::LBServiceInit::Init (argc, argv);
} catch (const CORBA::SystemException & e) {
    try {

        CDMW_ERROR(InitUtils::Get_Logger(),
                   "CORBA Exception during LB init: "
                   << Cdmw::OrbSupport::OrbSupport::exception_to_string(e) );
    } catch(...) {
        CDMW_ASSERT(false);
    }
}
#endif // CDMW_LB_SERVICE_ENABLED


<%script type="idlmm.Repository" name="initLBGroupManager"%>
// *****************************************************************
// ***********    setup LoadBalancing LBGroupManager     ***********
// *****************************************************************

// Try to get the reference of the FT LBGroupManager from Repository
CdmwLB::LBGroupManager_var lb_group_mgr = CdmwLB::LBGroupManager::_nil();
try {
    // Get NamingInterface to object_groups (for reading)
    Cdmw::CommonSvcs::Naming::NamingInterface obj_groups_interface =
        Cdmw::NamingAndRepository::RepositoryInterface::get_domain_naming_interface(
            "lb_group_manager/object_groups");

    // Get LB GroupManager Object Group
    CORBA::Object_var obj_ref = 
        obj_groups_interface.resolve("LBGroupManagerGroup");

    lb_group_mgr = CdmwLB::LBGroupManager::_narrow(obj_ref.in());
}
catch (const CdmwNamingAndRepository::NoNameDomain& ex) {
    CDMW_WARN(InitUtils::Get_Logger(), 
        "FT LBGroupManager not found in Repository " 
        << "(CdmwNamingAndRepository::NoNameDomain). "
        << "Assumes non-FT LBGroupManager has been specified "
        << "with -ORBInitRef...");
}
catch (const CdmwNamingAndRepository::InvalidName& ex) {
    // shouldn't happen since names are valid
    CDMW_FATAL(InitUtils::Get_Logger(), 
       "Error retrieving LBGroupManager from Repository: " 
       << "CdmwNamingAndRepository::InvalidName");
    CDMW_ASSERT(false);
}
catch (const CosNaming::NamingContext::NotFound& ex) {
    CDMW_WARN(InitUtils::Get_Logger(), 
        "FT LBGroupManager not found in Repository "
        << "(CosNaming::NamingContext::NotFound). "
        << "Assumes non-FT LBGroupManager has been specified "
        << "with -ORBInitRef...");
}
catch (const CosNaming::NamingContext::CannotProceed& ex) {
    CDMW_WARN(InitUtils::Get_Logger(), 
        "Exception retrieving FT LBGroupManager from Repository " 
        << "(CosNaming::NamingContext::CannotProceed). "
        << "Assumes non-FT LBGroupManager has been specified "
        << "with -ORBInitRef...");
}
catch (const CosNaming::NamingContext::InvalidName& ex) {
    // shouldn't happen since names are valid
    CDMW_FATAL(InitUtils::Get_Logger(), 
       "Error retrieving LBGroupManager from Repository: " << ex);
    CDMW_ASSERT(false);
}
catch (const CORBA::SystemException& ex) {
    CDMW_WARN(InitUtils::Get_Logger(), 
        "Exception retrieving FT LBGroupManager from Repository: " << ex
        << ". Assumes non-FT LBGroupManager has been specified "
        << "with -ORBInitRef...");
}

if (!CORBA::is_nil(lb_group_mgr.in())) {
    try {
        orb->register_initial_reference("LBGroupManager", lb_group_mgr.in());      
    }
    catch (const CORBA::SystemException& ex)
    {
        CDMW_ERROR(InitUtils::Get_Logger(), 
            "Error regitering LBGroupManager as initial reference: " << ex);
        CDMW_THROW2(Cdmw::OrbSupport::CORBASystemExceptionWrapperT<CORBA::SystemException>,
                    ex,
                    "Cannot register LBGroupManager." );
    }
    catch (const CORBA::ORB::InvalidName& ex)
    {
        CDMW_ERROR(InitUtils::Get_Logger(), 
            "Error regitering LBGroupManager as initial reference: " << ex);
        CDMW_THROW2(Cdmw::OrbSupport::CORBASystemExceptionWrapperT<CORBA::INTERNAL>,
                    CORBA::INTERNAL(Cdmw::OrbSupport::INTERNAL, CORBA::COMPLETED_NO),
                    "InvalidName => Cannot register LBGroupManager.");
    }
}
