<%
metamodel http://www.prismtech.com/idlmm
%>


<%script type="idlmm.Repository" name="initPerformanceService"%>
#ifdef CDMW_PERFORMANCE_ENABLED

// *****************************************************************
// *********         Init The CDMW Performance Library    *********
// ***************************************************************** 
{
    CDMW_DEBUG(InitUtils::Get_Logger(), "Init Performance Library");
    std::string performanceFileName;
    try {
        performanceFileName = xml_data->getServiceAttributeValue("performance", "result-file-name");
    } catch (const Cdmw::BadParameterException& ex ) {
        CDMW_WARN(InitUtils::Get_Logger(), "Cdmw::BadParameterException received: "
                  << ex.what());
        CDMW_THROW2( Cdmw::OrbSupport::CORBASystemExceptionWrapperT<CORBA::BAD_PARAM>,
                     CORBA::BAD_PARAM(Cdmw::OrbSupport::BAD_PARAMInvalidXMLInitData,
                                      CORBA::COMPLETED_NO),
                     ex.what() );
    } catch (const Cdmw::CdmwInit::XMLErrorException & ex ) {
        CDMW_WARN(InitUtils::Get_Logger(), "CdmwInit::XMLErrorException received: "
                  << ex.what());
        CDMW_THROW2( Cdmw::OrbSupport::CORBASystemExceptionWrapperT<CORBA::BAD_PARAM>,
                     CORBA::BAD_PARAM(Cdmw::OrbSupport::BAD_PARAMInvalidXMLInitData,
                                      CORBA::COMPLETED_NO),
                     ex.what() );
    } catch (const OutOfMemoryException & ex ) {
        CDMW_WARN(InitUtils::Get_Logger(), "Cdmw::OutOfMemoryException received: "
                  << ex.what());
        CDMW_THROW2( Cdmw::OrbSupport::CORBASystemExceptionWrapperT<CORBA::NO_MEMORY>,
                     CORBA::NO_MEMORY(Cdmw::OrbSupport::NO_MEMORY,
                                      CORBA::COMPLETED_NO),
                     ex.what() );
    }
    
    CDMW_DEBUG(InitUtils::Get_Logger(), 
               "Performance result file will be " << performanceFileName);
    // May raise CORBA::SystemException
    Performance::InitUtils::init_performance_library(CDMW_rootPOA.in(),
                                                     application_name,
                                                     process_name,
                                                     performanceFileName);
}
#endif // CDMW_PERFORMANCE_ENABLED


<%script type="idlmm.Repository" name="stopPerformanceService"%>
#ifdef CDMW_PERFORMANCE_ENABLED
         
// Free all allocated memory and stop the performance service
try {
    Cdmw::Performance::PerformanceMngr::cleanup();
} catch (const Cdmw::BadParameterException & ) {
    // Do nothing (ignore)
    // TODO: Add trace logs here
}

#endif // CDMW_PERFORMANCE_ENABLED
