<%
metamodel http://www.prismtech.com/idlmm
%>


<%script type="idlmm.Repository" name="initRepositoryInterface"%>
// *****************************************************************
// *****************  INIT of RepositoryInterface ******************
// *****************************************************************
CDMW_DEBUG(InitUtils::Get_Logger(), "Init RepositoryInterface");
std::string default_domaine_name("");
try {
    default_domaine_name  
        = xml_data->getServiceAttributeValue("repository-interface", "default-domain-name");
} catch (const Cdmw::BadParameterException& ex) {
    CDMW_WARN(InitUtils::Get_Logger(), "Receive Cdmw::BadParameterException "
                                       << ex.what());
    CDMW_THROW2( Cdmw::OrbSupport::CORBASystemExceptionWrapperT<CORBA::BAD_PARAM>,
                 CORBA::BAD_PARAM(Cdmw::OrbSupport::BAD_PARAMInvalidXMLInitData,
                                  CORBA::COMPLETED_NO),
                 ex.what() );       
} catch (const Cdmw::CdmwInit::XMLErrorException & ex) {
    CDMW_WARN(InitUtils::Get_Logger(), "Receive CdmwInit::XMLErrorException "
                                       << ex.what());
    CDMW_THROW2( Cdmw::OrbSupport::CORBASystemExceptionWrapperT<CORBA::BAD_PARAM>,
                 CORBA::BAD_PARAM(Cdmw::OrbSupport::BAD_PARAMInvalidXMLInitData,
                                  CORBA::COMPLETED_NO),
                 ex.what() );
} catch (const OutOfMemoryException & ex) {
    CDMW_WARN(InitUtils::Get_Logger(), "Receive Cdmw::OutOfMemoryException "
                                       << ex.what());
    CDMW_THROW2( Cdmw::OrbSupport::CORBASystemExceptionWrapperT<CORBA::NO_MEMORY>,
                 CORBA::NO_MEMORY(Cdmw::OrbSupport::NO_MEMORY,
                                  CORBA::COMPLETED_NO),
                 ex.what() );
} 

try {
    Cdmw::NamingAndRepository::RepositoryInterface::init
        (default_domaine_name, repository.in());
} catch (const CdmwNamingAndRepository::NoNameDomain & ) {
    // Default NameDomain is not a NameDomain! 
    CDMW_WARN(InitUtils::Get_Logger(), 
              "Receive CdmwNamingAndRepository::NoNameDomain for " 
              << default_domaine_name);
    CDMW_THROW2( Cdmw::OrbSupport::CORBASystemExceptionWrapperT<CORBA::BAD_PARAM>,
                 CORBA::BAD_PARAM(Cdmw::OrbSupport::BAD_PARAMNameDomainNotFound,
                                  CORBA::COMPLETED_NO),
                 default_domaine_name + " is not a NameDomain!" );
} catch (const CdmwNamingAndRepository::InvalidName &  ex) {
    // Default NameDomain name is ill-formed! 
    CDMW_WARN(InitUtils::Get_Logger(), 
              "Receive CdmwNamingAndRepository::InvalidName for " 
              << default_domaine_name);
    CDMW_THROW2( Cdmw::OrbSupport::CORBASystemExceptionWrapperT<CORBA::BAD_PARAM>,
                 CORBA::BAD_PARAM(Cdmw::OrbSupport::BAD_PARAMInvalidDefaultDomainName,
                                  CORBA::COMPLETED_NO),
                 default_domaine_name + " is ill-formed :" + ex.reason.in() );
} catch (const CORBA::SystemException & ex) {
    CDMW_WARN(InitUtils::Get_Logger(), 
              "Receive CORBA::SystemException " 
              << Cdmw::OrbSupport::OrbSupport::exception_to_string(ex));
    CDMW_THROW2( Cdmw::OrbSupport::CORBASystemExceptionWrapperT<CORBA::SystemException>,
                 ex,
                 "Cannot initialise RepositoryInterface." );
}


<%script type="idlmm.Repository" name="stopRepositoryInterface"%>
// Release all static object references held by RepositoryInterface
Cdmw::NamingAndRepository::RepositoryInterface::finish();
