<%
metamodel http://www.prismtech.com/idlmm
%>


<%script type="idlmm.Repository" name="initWatchdogService"%>
// *****************************************************************
// *************  setup WatchdogServiceInit  **********
// *****************************************************************
try {
    Cdmw::FT::WatchdogServiceInit::Init (argc, argv);
} catch (const CORBA::SystemException & e) {
    try {
        CDMW_ERROR(InitUtils::Get_Logger(), 
                   "CORBA Exception : " 
                   << Cdmw::OrbSupport::OrbSupport::exception_to_string(e) );
       } catch(...) {
        CDMW_ASSERT(false);
       }
}        


<%script type="idlmm.Repository" name="setupWatchdogService"%>
// *****************************************************************
// *************  INIT WatchdogServiceInit  **********
// *****************************************************************
std::string timeout_s("");
try {
    CORBA::ULong milliseconds = 
        Cdmw::OsSupport::SystemProperties::Get_Property(
            Cdmw::FT::WATCHDOG_TIMEOUT_PROPERTY_NAME, 0);

    if (milliseconds == 0)
    {
        timeout_s  
            = xml_data->getServiceAttributeValue("watchdog", "timeout");
        milliseconds = atoi(timeout_s.c_str());
        Cdmw::FT::WatchdogServiceInit::Set_timeout (milliseconds);
    }

    // export property for debug purpose
    Cdmw::OsSupport::SystemProperties::Set_Property(
        Cdmw::FT::WATCHDOG_TIMEOUT_PROPERTY_NAME, 
        milliseconds);
} catch (const Cdmw::BadParameterException& ex) {
    CDMW_THROW2( Cdmw::OrbSupport::CORBASystemExceptionWrapperT<CORBA::BAD_PARAM>,
                 CORBA::BAD_PARAM(Cdmw::OrbSupport::BAD_PARAMInvalidXMLInitData,
                                  CORBA::COMPLETED_NO),
                 ex.what() );       
} catch (const Cdmw::CdmwInit::XMLErrorException & ex) {
    CDMW_THROW2( Cdmw::OrbSupport::CORBASystemExceptionWrapperT<CORBA::BAD_PARAM>,
                 CORBA::BAD_PARAM(Cdmw::OrbSupport::BAD_PARAMInvalidXMLInitData,
                                  CORBA::COMPLETED_NO),
                 ex.what() );
} catch (const OutOfMemoryException & ex) {
    CDMW_THROW2( Cdmw::OrbSupport::CORBASystemExceptionWrapperT<CORBA::NO_MEMORY>,
                 CORBA::NO_MEMORY(Cdmw::OrbSupport::NO_MEMORY,
                                  CORBA::COMPLETED_NO),
                 ex.what() );
} catch (const CORBA::BAD_PARAM &) {
    CDMW_THROW2( Cdmw::OrbSupport::CORBASystemExceptionWrapperT<CORBA::BAD_PARAM>,
                 CORBA::BAD_PARAM(Cdmw::OrbSupport::BAD_PARAM,
                                  CORBA::COMPLETED_NO),
                 "Bad timeout value for Watchdog.");
}
