<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.cdmw.codegenerator.cdmwinit.ProgramServices
import com.thalesgroup.cdmw.codegenerator.cdmwinit.java.initRepositoryInterface
import com.thalesgroup.cdmw.codegenerator.cdmwinit.java.initWatchdogService
import com.thalesgroup.cdmw.codegenerator.cdmwinit.java.initRequestFollowup
import com.thalesgroup.cdmw.codegenerator.cdmwinit.java.initFaultToleranceService
import com.thalesgroup.cdmw.codegenerator.cdmwinit.java.initTraceService
import com.thalesgroup.cdmw.codegenerator.cdmwinit.java.initRecordingService
import com.thalesgroup.cdmw.codegenerator.cdmwinit.java.initPerformanceService
import com.thalesgroup.cdmw.codegenerator.cdmwinit.java.initLoadBalancingService
import com.thalesgroup.cdmw.codegenerator.cdmwinit.java.initClockService
import com.thalesgroup.cdmw.codegenerator.cdmwinit.java.initLifeCycle
import com.thalesgroup.cdmw.codegenerator.cdmwinit.java.initCCM
import com.thalesgroup.ccm.codegenerator.container.Utils
%>



<%script type="idlmm.Repository" name="javaFilePath" post="trim()"%>
<%if (cdmwInterfacePackage.length() > 0){%>
<%directoryPrefix%><%cdmwInterfacePackage.replaceAll("\.", "/")%>/<%classname%>.java
<%}else{%>
<%directoryPrefix%><%classname%>.java
<%}%>


<%--
  -- If directory attribute is specified for the <program>,
  -- this script returns the directory +"/"
  --%>
<%script type="idlmm.Repository" name="directoryPrefix" post="trim()"%>
<%if (directory.length > 0){%>
<%directory%>/
<%}%>


<%--
  -- Generation template  
  -- This template is not model-based (idlmm.Repository is just specified
  -- to access HomeDef data)
  -- All is based on ProgramServices which provides access to loaded data
  -- from XML file.
  --%>
<%script type="idlmm.Repository" name="CdmwInit" file="<%javaFilePath%>"%>
<%copyrightHeader%>

<%if (cdmwInterfacePackage.length() > 0){%>
package <%cdmwInterfacePackage%>;
<%}%>

import cdmw.common.Assert;
import cdmw.common.BadOrderException;
import cdmw.common.BadParameterException;
import cdmw.common.InternalErrorException;

import cdmw.orbsupport.ExceptionMinorCodes;
import cdmw.orbsupport.CORBASystemExceptionWrapper;

import cdmw.ossupport.OS;

import cdmw.commonsvcs.naming.NamingInterface;
import cdmw.namingandrepository.RepositoryInterface;
import com.thalesgroup.CdmwNamingAndRepository.DEFAULT_ROOT_CONTEXT;
import com.thalesgroup.CdmwNamingAndRepository.RepositoryPackage.NoRootContext;



<%if (hasTrace){%>

    <%if (hasBufferingEnabled){%>
import cdmw.trace.FlushAreaMngr;
import cdmw.trace.TraceDomains;
import cdmw.trace.TraceLevels;
import cdmw.trace.Stream;
    <%}else{%>
// Use of LogManagerCollectorDelegate instead of the FlushAreaMngr/tracelibrary
// NOTA: Discard of repetitive traces does not work with this configuration.
import cdmw.trace.Stream;
import cdmw.trace.FlushAreaMngr;
import cdmw.trace.TraceDomains;
import cdmw.trace.TraceLevels;
import cdmw.logging.LogManagerCollectorDelegate;
import com.thalesgroup.CdmwLogging.LogCollector;
    <%}%>
<%}%>

<%if (hasRequestFollowup){%>
import cdmw.commonsvcs.requestfollowup.NDCServiceInit;
<%}%>

<%if (hasPerformance){%>
import cdmw.performance.PerformanceMngr;
<%}%>

import cdmw.cdmwinit.InitUtils;
import cdmw.cdmwinit.ProcessControl;
import cdmw.cdmwinit.DefaultProcessControl;
import cdmw.cdmwinit.CdmwProcessImpl;
import cdmw.cdmwinit.XMLErrorException;
import cdmw.cdmwinit.CdmwInitConfiguration;
import cdmw.cdmwinit.ConfigurationException;

import cdmw.lifecycle.POAThreadingPolicy;
import cdmw.lifecycle.ThreadPoolPolicy;
import cdmw.lifecycle.ThreadPerRequestPolicy;
import cdmw.lifecycle.SingleThreadPolicy;
import cdmw.lifecycle.AnonymousObjectsFactoryInitUtil;
import cdmw.lifecycle.NamedObjectsFactoryInitUtil;
   
<%if (hasLoadBalancing){%>
import CdmwLB.LBGroupManager;
import cdmw.lb.lbinit.LBServiceInit;
<%}%>

<%if (hasHomeImpl){%>
import cdmw.ccm.container.HomeAllocator;
import cdmw.ccm.container.HomeAllocatorRegistry;
import cdmw.common.Locations;
import cdmw.lifecycle.DefaultObjectRegistration;
<%}%>


public class <%classname%> {

    public static void cdmwInit(
        org.omg.CORBA.ORB orb,
        String[] args,
        ProcessControl ctrl)
        throws org.omg.CORBA.SystemException {

        <%registerCodeGenerationProperties%>

        Assert.check(orb != null);

        try {
            // PCR-0049
            cdmw.orbsupport.Codec.init(orb);

            // Get the XML init filename. This may raise BAD_PARAM or INTERNAL
            String xmlFile = InitUtils.getXmlInitialisationFile(args);

            // Get the XML documents validation option. This may raise INTERNAL
            boolean validateXml = InitUtils.getXmlValidationOption(args);

            // Parsing XML
            CdmwInitConfiguration xmlData = null;
            try {
                CdmwInitConfiguration init =
                    CdmwInitConfiguration.readConfiguration(
                        xmlFile,
                        validateXml);
                xmlData = init;
            } catch (InternalErrorException iee) {
                throw new org.omg.CORBA.BAD_PARAM(
                    ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
                    org.omg.CORBA.CompletionStatus.COMPLETED_NO);
            } catch (ConfigurationException ce) {
                throw new org.omg.CORBA.BAD_PARAM(
                    ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
                    org.omg.CORBA.CompletionStatus.COMPLETED_NO);
            }

            // *****************************************************************
            // *****************  CDMW root POA and servant manager ***********
            // *****************************************************************

            // Create the CDMW root POA. It has its own POA Manager
            // May raise a org.omg.CORBA.SystemException.
            org.omg.PortableServer.POA cdmwRootPOA =
                InitUtils.createCdmwRootPOA(orb);

            org.omg.PortableServer.POAManager poaManager =
                cdmwRootPOA.the_POAManager();

            // Initialize the server so that incoming requests are
            // handled from this point on
            // May raise org.omg.PortableServer.POAManager.AdapterInactive
            // or org.omg.CORBA.SystemException
            try {
                poaManager.activate(); // TODO: maybe move it ?
            } catch (
                org.omg.PortableServer.POAManagerPackage.AdapterInactive ai) {
                throw new org.omg.CORBA.INTERNAL(
                    ExceptionMinorCodes.INTERNALORBAdapterInactive,
                    org.omg.CORBA.CompletionStatus.COMPLETED_NO);
            }

            <%if (hasFaultTolerance){%>
            
            <%setupFTPolicies%>
            <%}%>
            

            <%if (hasWatchdog){%>
            
            <%setupWatchdogService%>
            <%}%>
            
            <%if (!hasBufferingEnabled || hasRecording){%>
            <%registerDaemonNameServiceAsLocalNameService%>
            <%}%>
            

            // *****************************************************************
            // *****************  INIT platforminterface object  **************
            // *****************************************************************

            // Did we receive a ProcessControl callback object?
            ProcessControl processCtrl;
            if (ctrl != null)
                processCtrl = ctrl;
            else
                processCtrl = new DefaultProcessControl();            

            com.thalesgroup.CdmwFT.LocalPullMonitorable lpm = null;
            <%if (hasWatchdog){%>
            lpm = new cdmw.ft.watchdog.RequestTimeoutLocalPullMonitorableImpl();
            <%}%>
            
            // CdmwProcessImpl() will acquire a reference on ProcessControl 
            // object and will automatically release it at object's destruction.
            CdmwProcessImpl processImpl =
                new CdmwProcessImpl(
                    orb,
                    InitUtils.getRootPOA(orb),
                    cdmwRootPOA,
                    processCtrl,
                    lpm);
            com.thalesgroup.CdmwPlatformMngt.ProcessDelegate initProcess =
                processImpl._this(orb);

            <%if (hasSystemManagement){%>
            // Set the Property before calling init_platform_interface which calls PlatformInterface.Setup().
            // The Property is read in Setup().
            System.setProperty(
               cdmw.orbsupport.ORBSupport.SYSTEM_MANAGEMENT_FATAL_HANDLER_PROPERTY_NAME, 
               "true");
            <%}else{%>
            // Set the Property before calling init_platform_interface which calls PlatformInterface.Setup().
            // The Property is read in Setup().
            System.setProperty(
               cdmw.orbsupport.ORBSupport.SYSTEM_MANAGEMENT_FATAL_HANDLER_PROPERTY_NAME, 
               "false");
            <%}%>
            
            InitUtils.initPlatformInterface(orb, args, initProcess);
            //  From now on, a platform supervisor may initiate a call to 
            //  process.init() method. 
            //  process.init() call is blocked with a condition until CDMW
            //  init has completed?

            // Get the process name.
            // This may raise org.omg.CORBA.BAD_INV_ORDER
            String processName = InitUtils.getCdmwProcessName();

            // Get the process name.
            // This may raise org.omg.CORBA.BAD_INV_ORDER
            String applicationName = InitUtils.getCdmwApplicationName();

            cdmw.logging.LogManager.Instance().setProcessName(processName);
            cdmw.logging.LogManager.Instance().setApplicationName(applicationName);

            // Retrieve Repository object reference.
            // This may raise org.omg.CORBA.BAD_PARAM
            com.thalesgroup.CdmwNamingAndRepository.Repository repository =
                InitUtils.getCdmwRepository();

            <%if (hasFaultTolerance){%>
            
            <%setupFTReplicationManager%>
            <%}%>
            
            <%if (hasRepositoryInterface){%>
            
            <%initRepositoryInterface%>
            <%}%>
            
            <%if (hasTrace){%>
            <%if (hasBufferingEnabled){%>
            
            <%initTraceService%>
            <%}else{%>

            <%initLogManagerCollectorDelegate%>
            <%}%>
            <%}%>
            
            <%if (hasPerformance){%>
            
            <%initPerformanceService%>
            <%}%>
            
            <%if (hasLoadBalancing){%>

            <%initLBGroupManager%>
            <%}%>
            
            <%if (hasTime){%>
            
            <%initClockService%>
            <%}%>
            
            <%if (hasRecording()){%>
            
            <%initRecordingService%>
            <%}%>
            
            <%if (hasLifeCycle){%>
            
            <%initLifeCycle%>
            
            <%if (hasHomeImpl){%>
            
            <%initCCM%>
            <%}%>
            
            <%}%>

            // Discard requests until run order comes from the platform management
            try {
                poaManager.discard_requests(false);
            } catch (
                org.omg.PortableServer.POAManagerPackage.AdapterInactive ai) {
                // TODO: Add trace logs here
                throw new org.omg.CORBA.INTERNAL(
                    ExceptionMinorCodes.INTERNALORBAdapterInactive,
                    org.omg.CORBA.CompletionStatus.COMPLETED_NO);
            }
   
            // advise processImpl that cdmwInit is done
            processImpl.setCdmwInitDone();
            
        } catch (CORBASystemExceptionWrapper csew) {
            <%if (hasTrace){%>
            String domain = TraceDomains.CDMW_INIT;
            short level = TraceLevels.FTL;

            if (FlushAreaMngr.isToBeTraced(domain, level)) {
                Stream stream = Stream.getInstance();
                // filename and line number are avalaible in J2SDK 1.4
                stream.setLine((short) 0);
                stream.setFile("unknown");
                stream.setUserDomain(domain);
                stream.setUserLevel(level);
                stream.doFlush();
            } else { // In case there is a problem in the trace library itself!
                System.err.println(
                    domain + " : Fatal Error : " + csew.toString());
            }
            <%}else{%>
            System.err.println(
                "cdmwInit: Fatal Error: " + csew.toString());
            <%}%>
            csew.raiseSystemException();
        }
       
    }  // end of cdmwInit() 


    // CDMW Factory objects are deactivated at ORB shutdown.
    public static void cdmwCleanup(org.omg.CORBA.ORB orb) {
        Assert.check(orb != null);

        <%if (hasHomeImpl){%>
         // We should unbind "processname"/CCM/Components from AdminRootContext
         // here. But as ORB has just been shutdown in on_stop() operation,
         // no outgoing request are allowed (BAD_INV_ORDER or COMM_FAILURE received).
             
        <%genUnregisterHomeAllocators%>
        <%}%>
        
        <%if (hasTrace && hasBufferingEnabled){%>
        
        <%stopTraceService%>
        <%}%>
        
        <%if (hasTime){%>

        <%stopClockService%>
        <%}%>
        
        <%if (hasPerformance){%>

        <%stopPerformanceService%>
        <%}%>
   
        <%if (hasRepositoryInterface){%>
            
        <%stopRepositoryInterface%>
        <%}%>
    }
            
            
    public static void cdmwPreORBInit(String[] args) 
    {
        <%if (hasFaultTolerance){%>
        <%initFTService%>
        <%}%>
        
        <%if (hasLoadBalancing){%>
        <%initLBService%>
        <%}%>
        
        <%if (hasWatchdog){%>

        <%initWatchdogService%>
        <%}%>
        
        <%if (hasRequestFollowup){%>

        <%initRequestFollowup%>
        <%}%>
    }

} // end of <%classname%> class


            
<%script type="idlmm.Repository" name="registerCodeGenerationProperties"%>
final String BASE_PROPERTY_NAME = "Cdmw.ConfAndPlug.CodeGenerationOption.";
System.setProperty(BASE_PROPERTY_NAME+"hasRepositoryInterface", "<%hasRepositoryInterface%>");
System.setProperty(BASE_PROPERTY_NAME+"hasContainerInterception", "<%hasContainerInterception%>");
System.setProperty(BASE_PROPERTY_NAME+"hasPerformance", "<%hasPerformance%>");
System.setProperty(BASE_PROPERTY_NAME+"hasTrace", "<%hasTrace%>");
System.setProperty(BASE_PROPERTY_NAME+"hasRequestFollowup", "<%hasRequestFollowup%>");
System.setProperty(BASE_PROPERTY_NAME+"hasBufferingEnabled", "<%hasBufferingEnabled%>");
System.setProperty(BASE_PROPERTY_NAME+"hasSystemManagement", "<%hasSystemManagement%>");
System.setProperty(BASE_PROPERTY_NAME+"hasTime", "<%hasTime%>");
System.setProperty(BASE_PROPERTY_NAME+"hasRecording", "<%hasRecording%>");
System.setProperty(BASE_PROPERTY_NAME+"hasWatchdog", "<%hasWatchdog%>");
System.setProperty(BASE_PROPERTY_NAME+"hasFaultTolerance", "<%hasFaultTolerance%>");
System.setProperty(BASE_PROPERTY_NAME+"hasLoadBalancing", "<%hasLoadBalancing%>");
System.setProperty(BASE_PROPERTY_NAME+"hasLifeCycle", "<%hasLifeCycle%>");
System.setProperty(BASE_PROPERTY_NAME+"hasHomeImpl", "<%hasHomeImpl%>");
System.setProperty(BASE_PROPERTY_NAME+"frameworksIdref", "<%getFrameworksIds.sep(", ")%>");



<%script type="idlmm.Repository" name="registerDaemonNameServiceAsLocalNameService"%>
// *****************************************************************
// *********   Retrieve the Daemon's NameService object      *******
// *********   reference and register it as LocalNameService *******
// *********   SystemPort option is now handled by           *******
// *********   OrbSupport.ORB_init(argc,argv)                *******
// *****************************************************************
org.omg.CosNaming.NamingContext local_NameService;

String system_port = System.getProperty(cdmw.orbsupport.ORBSupport.SYSTEM_PORT_PROPERTY_NAME);
if (system_port.trim().equals("")) {
    cdmw.logging.Logger.CDMW_FATAL(InitUtils.Get_Logger(), 
        "CDMW_init: CdmwSystemPort has not be declared"
        + " in argument. The port allows to perfom"
        + " register_initial_reference() to access on"
        + " recording daemon and recording server.",
        new Throwable());
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMMissingPortNumber, 
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
} else {
    try {
        String corbaloc = "corbaloc::";
        corbaloc += "localhost";
        corbaloc += ":";        
        corbaloc += system_port;
        corbaloc +="/NameService";
        org.omg.CORBA.Object obj__ = orb.string_to_object(corbaloc);
        Assert.check(obj__ != null);
        
        try {
            local_NameService  = org.omg.CosNaming.NamingContextHelper.narrow(obj__);
        } catch (org.omg.CORBA.SystemException ex) {
            cdmw.logging.Logger.CDMW_FATAL(InitUtils.Get_Logger(), 
               "org.omg.CORBA SystemException during CDMW_init: "
               + cdmw.orbsupport.ORBSupport.exceptionToString(ex),
               new Throwable());
        
            throw ex;
        }
        
        // Register initial reference for the LocalNameService located in the daemon
        ((org.omg.CORBA_2_5.ORB)orb).register_initial_reference("LocalNameService", local_NameService);
        
    } catch (org.omg.CORBA.ORBPackage.InvalidName ex)  {
        cdmw.logging.Logger.CDMW_FATAL(InitUtils.Get_Logger(),
            "CDMW_init: InvalidName => Cannot register LocalNameService."
            + " failed. " + cdmw.orbsupport.ORBSupport.exceptionToString(ex),
            new Throwable());
        throw new CORBASystemExceptionWrapper(
                   new org.omg.CORBA.INTERNAL(
                   ExceptionMinorCodes.INTERNAL,
                   org.omg.CORBA.CompletionStatus.COMPLETED_NO));
    } catch (Exception ex) {
        cdmw.logging.Logger.CDMW_FATAL(InitUtils.Get_Logger(),
            "CDMW_init:  Could not retrieve local NameService's object reference! " + ex.getMessage(),
            new Throwable());
        throw new CORBASystemExceptionWrapper(
            new org.omg.CORBA.INTERNAL(
                ExceptionMinorCodes.INTERNAL,
                org.omg.CORBA.CompletionStatus.COMPLETED_NO));
    }
}






