<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.cdmw.codegenerator.cdmwinit.ProgramServices
import com.thalesgroup.ccm.codegenerator.container.java.Names
import com.thalesgroup.ccm.codegenerator.corba.CommonServices
%>

<%script type="idlmm.Repository" name="initCCM"%>
// Get a Default Event Channel Factory
com.thalesgroup.CdmwEvent.EventChannelFactory eventChannelFactory = null;

<%if (hasEventPorts){%>

<%initEventChannelFactory%>
<%}%>

try {
    // Create an Object registration instance
    // get the admin root context
    cdmw.logging.Logger.CDMW_DEBUG(
        InitUtils.Get_Logger(), 
        "Get the admin root context",
        new Throwable());
    com.thalesgroup.CdmwNamingAndRepository.Repository repository_ref =
        cdmw.namingandrepository.RepositoryInterface.getRepository();
    org.omg.CosNaming.NamingContext adminRootCtx =
        repository_ref.resolve_root_context(
                cdmw.common.Locations.ADMIN_ROOT_CONTEXT_ID);
    cdmw.commonsvcs.naming.NamingInterface ni =
        new cdmw.commonsvcs.naming.NamingInterface(adminRootCtx);

    // bind the new context where component shall be registered
    org.omg.CosNaming.NameComponent[] componentNamePath =
        new org.omg.CosNaming.NameComponent[5];
    componentNamePath[0] = new org.omg.CosNaming.NameComponent(cdmw.ossupport.OS.getHostname(), "");
    componentNamePath[1] = new org.omg.CosNaming.NameComponent(applicationName, "");
    componentNamePath[2] = new org.omg.CosNaming.NameComponent(processName, "");
    componentNamePath[3] = new org.omg.CosNaming.NameComponent("CCM", "");
    componentNamePath[4] = new org.omg.CosNaming.NameComponent("Components", "");

    cdmw.logging.Logger.CDMW_DEBUG(
        InitUtils.Get_Logger(), 
        "Bind component context",
        new Throwable());
    java.lang.String componentPath = ni.toString(componentNamePath);
    cdmw.commonsvcs.naming.NamingInterface niComponent =
        ni.newContext();
    ni.rebindContext(componentPath, niComponent, true);

    cdmw.logging.Logger.CDMW_DEBUG(
        InitUtils.Get_Logger(), 
        "Create object_registration",
        new Throwable());
    org.omg.CosNaming.NamingContext nc = niComponent.getNamingContext();
    com.thalesgroup.CdmwLifeCycle.ObjectRegistration objectRegistration =
        new cdmw.lifecycle.DefaultObjectRegistration(nc, false);

    // Register Managed component naming context in the orb
    // to make it available 
    org.omg.CORBA_2_5.ORB orb25 = (org.omg.CORBA_2_5.ORB) orb;
    orb25.register_initial_reference("ManagedComponentNamingContext", nc);


    // Create the ComponentServer
    com.thalesgroup.CdmwCcmComponentServer.ComponentServer theComponentServer = 
        cdmw.ccm.componentserver.InitUtils.createComponentServer(
            orb,
            cdmwRootPOA,
            eventChannelFactory,
            objectRegistration,
            processName,
            applicationName,
            args);

    // Register it as cdmw.common.locations.ASSEMBLY_AND_DEPLOYMENT_NAME_DOMAIN/
    //     processName@applicationName.ComponentServer
    String id = processName + "@" + applicationName;
    String kind = "ComponentServer";
    org.omg.CosNaming.NameComponent[] name = new org.omg.CosNaming.NameComponent[1];
    name[0] = new org.omg.CosNaming.NameComponent(id, kind);
    String key = NamingInterface.toString(name);

    com.thalesgroup.CdmwNamingAndRepository.NameDomain domain =
        RepositoryInterface.getDomain(Locations.ASSEMBLY_AND_DEPLOYMENT_NAME_DOMAIN);

    try {
        domain.register_new_factory(key, theComponentServer);
    } catch (com.thalesgroup.CdmwNamingAndRepository.NameDomainPackage.AlreadyExists ae) {
        // Re-register it again.
        domain.release_name(key);
        domain.register_new_factory(key, theComponentServer);
    } 
} catch (com.thalesgroup.CdmwNamingAndRepository.NoNameDomain nnd) {
    throw new CORBASystemExceptionWrapper(
        new org.omg.CORBA.BAD_PARAM(
            ExceptionMinorCodes.BAD_PARAMNameDomainNotFound,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO),
        Locations.ASSEMBLY_AND_DEPLOYMENT_NAME_DOMAIN + " is not a NameDomain!");
} catch (NoRootContext nrc) {
    throw new org.omg.CORBA.INTERNAL(
        ExceptionMinorCodes.INTERNALCdmwRepositoryError,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
} catch (org.omg.CosNaming.NamingContextPackage.NotFound nf) {
    throw new CORBASystemExceptionWrapper(
        new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNAL,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO));
} catch (org.omg.CosNaming.NamingContextPackage.AlreadyBound ab) {
    throw new CORBASystemExceptionWrapper(
        new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNAL,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO));
} catch (org.omg.CosNaming.NamingContextPackage.CannotProceed cp) {
    throw new CORBASystemExceptionWrapper(
        new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNAL,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO));
} catch (org.omg.CosNaming.NamingContextPackage.InvalidName cp) {
    throw new CORBASystemExceptionWrapper(
        new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNAL,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO));
} catch (org.omg.CORBA.ORBPackage.InvalidName e) {
    // shouldn't happen if ORB is standard
    throw new org.omg.CORBA.INTERNAL(
        ExceptionMinorCodes.INTERNAL,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
  } catch (com.thalesgroup.CdmwNamingAndRepository.NameDomainPackage.AlreadyExists ae) {
    throw new CORBASystemExceptionWrapper(
        new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNAL,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO));
} catch (com.thalesgroup.CdmwNamingAndRepository.InvalidName in) {
    throw new CORBASystemExceptionWrapper(
        new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNAL,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO));
} catch(cdmw.commonsvcs.naming.InvalidNameException ine) {
    throw new CORBASystemExceptionWrapper(
        new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNAL,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO));
} catch (com.thalesgroup.CdmwNamingAndRepository.NameDomainPackage.NotRegistered nr) {
    throw new CORBASystemExceptionWrapper(
        new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNAL,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO));
} catch (org.omg.CORBA.SystemException se) {
    throw new CORBASystemExceptionWrapper(se);
}




<%script type="idlmm.Repository" name="initEventChannelFactory"%>
try {

    NamingInterface evtNi;

    // First see if a Default Event Channel factory is registered in the Admin Root Context
    try {
        org.omg.CosNaming.NamingContext adminRootContext =  RepositoryInterface.getRepository().resolve_root_context(cdmw.common.Locations.ADMIN_ROOT_CONTEXT_ID);
        evtNi = new NamingInterface(adminRootContext); 
    
        String EVENT_CHANNEL_FACTORY_NAME;
    
        // Get the hostname.
        // Use of toString() before a resolve() to well form the string in the case of a hostname
        // with a dot.
        org.omg.CosNaming.NameComponent[] name = new org.omg.CosNaming.NameComponent[1];
        name[0] = new org.omg.CosNaming.NameComponent();
        name[0].id = cdmw.ossupport.OS.getHostname();
        name[0].kind = "";
        String to_return = "";
    
        try{
            EVENT_CHANNEL_FACTORY_NAME = cdmw.commonsvcs.naming.NameParser.toString(name); 
        } catch (cdmw.commonsvcs.naming.InvalidNameException e) {
        throw new CORBASystemExceptionWrapper(
                        new org.omg.CORBA.INTERNAL(
                ExceptionMinorCodes.INTERNAL,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO));
        }
    
        EVENT_CHANNEL_FACTORY_NAME += "/" + cdmw.common.Locations.LOCAL_EVENT_SERVICE_NAME_DOMAIN;
        EVENT_CHANNEL_FACTORY_NAME += "/FACTORIES/DefaultEventChannelFactory";
    
        eventChannelFactory = com.thalesgroup.CdmwEvent.EventChannelFactoryHelper.narrow(
               evtNi.resolve(EVENT_CHANNEL_FACTORY_NAME));
    
    } catch (org.omg.CosNaming.NamingContextPackage.NotFound nf) { 
        // Retrieve reference to the Default Event Channel factory 
        
        String evtFactoriesNd = 
        Locations.CDMW_EVENT_SERVICE_NAME_DOMAIN + "/FACTORIES";
        
        evtNi = RepositoryInterface.getDomainNamingInterface(evtFactoriesNd);
        
        String EVENT_CHANNEL_FACTORY_NAME = "DefaultEventChannelFactory";
        
        eventChannelFactory = com.thalesgroup.CdmwEvent.EventChannelFactoryHelper.narrow(
                                        evtNi.resolve(EVENT_CHANNEL_FACTORY_NAME));
    } catch (com.thalesgroup.CdmwNamingAndRepository.RepositoryPackage.NoRootContext nrc) {
        throw new CORBASystemExceptionWrapper(
                new org.omg.CORBA.INTERNAL(
                    ExceptionMinorCodes.INTERNAL,
                    org.omg.CORBA.CompletionStatus.COMPLETED_NO));
    }

} catch (com.thalesgroup.CdmwNamingAndRepository.NoNameDomain nnd) {
    throw new CORBASystemExceptionWrapper(
        new org.omg.CORBA.BAD_PARAM(
            ExceptionMinorCodes.BAD_PARAMNameDomainNotFound,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO),
        Locations.CDMW_EVENT_SERVICE_NAME_DOMAIN + "/FACTORIES is not a NameDomain!");
} catch (com.thalesgroup.CdmwNamingAndRepository.InvalidName in) {
    throw new CORBASystemExceptionWrapper(
        new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNAL,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO));
} catch (org.omg.CosNaming.NamingContextPackage.NotFound nf) {
    throw new CORBASystemExceptionWrapper(
        new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNAL,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO));
} catch (org.omg.CosNaming.NamingContextPackage.CannotProceed cp) {
    throw new CORBASystemExceptionWrapper(
        new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNAL,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO));
} catch (org.omg.CosNaming.NamingContextPackage.InvalidName in) {
    throw new CORBASystemExceptionWrapper(
        new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNAL,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO));
} catch (org.omg.CORBA.SystemException se) {
    throw new CORBASystemExceptionWrapper(se);
}



<%script type="idlmm.IRObject" name="genRegisterValuetypeFactories"%>
// Register Valuetype factories
cdmw.ccm.cif.InitUtils.registerValuetypeFactories(orb);
cdmw.ccm.container.InitUtils.registerValuetypeFactories(orb);




<%script type="idlmm.IRObject" name="genRegisterHomeAllocator"%>
// Register <%get("factoryClassname")%> HomeAllocator
HomeAllocatorRegistry.register("<%get("factoryClassname")%>",
                               new HomeAllocator("<%get("factoryClassname")%>"));
<%--
    <%if (hasLoadBalancing){%>
    // Register <%lbFactoryClassname(getCategory(self))%> HomeAllocator
    HomeAllocatorRegistry.register("<%lbFactoryClassname(getCategory(self))%>",
                                   new HomeAllocator("<%lbFactoryClassname(getCategory(self))%>"));
    <%}%>
--%>




<%script type="idlmm.IRObject" name="genUnregisterHomeAllocators" post="trim()"%>
// Unregister HomeAllocators
<%for (getFrameworksIds){%>
<%if (isHome(self)){%>
<%getHome(self).factoryClassname(getCategory(self)).put("factoryClassname")%>
HomeAllocatorRegistry.unregister("<%get("factoryClassname")%>");
<%}%>
<%}%>



<%script type="idlmm.HomeDef" name="factoryClassname" post="trim()"%>
<%if (args(0) == "SESSION"){%>
    <%generatedServantPackage%>.<%generatedSessionServantClassname%>
<%}else if(args(0) == "EXTENSION"){%>
    <%generatedServantPackage%>.<%generatedExtensionServantClassname%>
<%}else{%>
    <%abort("ERROR: Unknown home category("+args(0)+")")%>
<%}%>





