<%
metamodel http://www.prismtech.com/idlmm
%>


<%script type="idlmm.Repository" name="initFTService"%>
// generate call to FTServiceInit.Init
try {
    // only client FT is supported at this time
    cdmw.ftinit.FTServiceInit.Init(args, true);
} catch (org.omg.CORBA.SystemException e) {
    System.err.println("CDMW_preORBInit: Fatal Error:");
    System.err.println("CORBA Exception : " + e);
    e.printStackTrace();
}


<%script type="idlmm.Repository" name="setupFTPolicies"%>
// *****************************************************************
// *************  setup FaultTolerance Policies   ******************
// *****************************************************************

long durationTime;
String clientId;
   
try {
    String resFTDuration = 
        xmlData.getServiceAttributeValue("fault-tolerance", 
                                         "request-duration-policy"); 
    durationTime = Long.parseLong(resFTDuration);
    
} catch (BadParameterException bpe) {
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
} catch (XMLErrorException xmle) {
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
} catch (NumberFormatException e) {
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
}

try  {
     clientId = xmlData.getServiceAttributeValue("fault-tolerance", 
                                                 "client-id");
     cdmw.ft.FTConfiguration.SetClientId(orb, clientId);
} catch (BadParameterException bpe) {
     // do nothing : parameter is optional
} catch (XMLErrorException xmle) {
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
}

org.omg.CORBA.Object obj;
try {
    obj = orb.resolve_initial_references("ORBPolicyManager");
} catch (org.omg.CORBA.ORBPackage.InvalidName e) {
    // shouldn't happen if ORB is standard
    throw new org.omg.CORBA.INTERNAL(
        ExceptionMinorCodes.INTERNAL,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
}

org.omg.CORBA.PolicyManager policyManager =
    org.omg.CORBA.PolicyManagerHelper.narrow(obj);

// Create and apply an ORB-wide Routed policy
cdmw.logging.Logger.CDMW_DEBUG(
    InitUtils.Get_Logger(), 
    "Request duration policy set to " + durationTime,
    new Throwable());
org.omg.CORBA.Any any = orb.create_any();

any.insert_ulonglong(durationTime);
org.omg.CORBA.Policy[] policies =
    new org.omg.CORBA.Policy[1];
try {
    policies[0] =
       orb.create_policy(org.omg.FT.REQUEST_DURATION_POLICY.value, any);
    
    policyManager.set_policy_overrides(policies, 
       org.omg.CORBA.SetOverrideType.ADD_OVERRIDE);
    policies[0].destroy();
    
} catch (org.omg.CORBA.PolicyError e) {
    // shouldn't happen if ORB implements FT
    throw new org.omg.CORBA.INTERNAL(
        ExceptionMinorCodes.INTERNAL,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
} catch (org.omg.CORBA.InvalidPolicies e) {
    // shouldn't happen if ORB implements FT
    throw new org.omg.CORBA.INTERNAL(
        ExceptionMinorCodes.INTERNAL,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
}            



<%script type="idlmm.Repository" name="setupFTReplicationManager"%>
// *****************************************************************
// ***********  setup FaultTolerance ReplicationManager  ***********
// *****************************************************************

// Get the reference of the Replication Manager and register it in the ORB
org.omg.CORBA.Object objref =
    InitUtils.getService("ReplicationManager");  

com.thalesgroup.CdmwFT.ReplicationManager replicationManager = 
    com.thalesgroup.CdmwFT.ReplicationManagerHelper.narrow(objref);

try  
{
    org.omg.CORBA_2_5.ORB orb25 = (org.omg.CORBA_2_5.ORB) orb;
    orb25.register_initial_reference(
        "ReplicationManager", 
        replicationManager);      
}
catch (org.omg.CORBA.ORBPackage.InvalidName ex)
{
    throw new org.omg.CORBA.INTERNAL(
        ExceptionMinorCodes.INTERNAL,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
}



