<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.cdmw.codegenerator.cdmwinit.ProgramServices
import com.thalesgroup.cdmw.codegenerator.cdmwinit.java.initCCM
import com.thalesgroup.ccm.codegenerator.corba.CommonServices
%>

<%script type="idlmm.Repository" name="initLifeCycle"%>
// *****************************************************************
// *********  Create CDMW Factories POA (persistent POA)  *********
// *****************************************************************
// Raises org.omg.CORBA.SystemException
org.omg.PortableServer.POA factoriesPOA =
    InitUtils.createCdmwLifeCyclePOA(cdmwRootPOA);

// Create CDMW factories

org.omg.CosNaming.NamingContext ncRootContext = null;
try {
    ncRootContext = 
        repository.resolve_root_context(DEFAULT_ROOT_CONTEXT.value);
} catch (NoRootContext nrc) {
    processImpl.setCdmwInitExceptionRaised();
    throw new org.omg.CORBA.INTERNAL(
        ExceptionMinorCodes.INTERNALCdmwRepositoryError,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
} catch (org.omg.CORBA.SystemException se) {
    processImpl.setCdmwInitExceptionRaised();
    throw se;
}

// May raise a org.omg.CORBA.SystemException
NamingInterface rootContext = new NamingInterface(ncRootContext);

<%if (hasHomeImpl){%>
<%genRegisterValuetypeFactories%>
<%}%>

String fullNameDomainName = "";
String fullFactoryName = "";
POAThreadingPolicy threadingPolicy = null;
int i = 0;

<%for (getFrameworksIds){%>

    <%printFrameworkData%>
    
    // *********************************
    // Init lifecycle-framework <%self%> (<%getCategory(self)%>)
    // *********************************
    
    <%-- compute and store factoryClassname in context as "factoryClassname"--%>
    <%if (isHome(self)){%>
    <%getHome(self).factoryClassname(getCategory(self)).put("factoryClassname")%>
    <%}else{%>
    <%getFactoryClassname(self).put("factoryClassname")%>
    <%}%>
    
    <%--
       Register the home allocator.
    --%>
    <%if (isHome(self)){%>
    
    <%genRegisterHomeAllocator%>
    <%}%>
    
    <%--
       Strategy selection.
    --%>
    <%if (getCategory(self) == "ENTITY"){%>
        <%--
           ENTITY
        --%>
        <%if (isHome(self)){%>
        <%--
           TODO: Add component server code here!
        --%>
        <%}else{%>
        
        <%genEntityAllocatorInit%>
        <%}%>
    
    <%}else if (getCategory(self) == "UNMANAGED_ENTITY"){%>
        <%--
           UNMANAGED_ENTITY.
        --%>
        <%genUnmanagedEntityAllocatorInit%>
    
    <%}else if (getCategory(self) == "SESSION"){%>
        <%--
           SESSION
        --%>
        <%if (isHome(self)){%>
        <%--
           TODO: Add component server code here!
        --%>
        <%}else{%>
        
        <%genSessionAllocatorInit%>
        <%}%>
    
    <%}else if (getCategory(self) == "SERVICE"){%>
        <%--
           SERVICE
        --%>
        <%if (isHome(self)){%>
        <%--
           TODO: Add component server code here!
        --%>
        <%}else{%>
        
        <%genServiceAllocatorInit%>
        <%}%>
    
    <%}else if (getCategory(self) == "PROCESS"){%>
        <%--
           TODO: Add component server code here!
        --%>
    
    <%}else if (getCategory(self) == "USER_DEFINED"){%>
        
        <%genUserDefinedFactoryAllocatorInit%>
    
    <%}else{%>
    <%abort("ERROR UNKOWN CATEGORY: <%getCategory(self)%> (shouldn't happen)")%>
    <%}%>
    
<%}%>




<%--
  -- Generate code for Entity lifecycle-framework
  -- This script is supposed to be called with the lifecycle-framework id as self.
  -- And context should contain a entry for "factoryClassname"
  --  
--%>
<%script type="idlmm.IRObject" name="genEntityAllocatorInit"%>
// *****************************************************************
// ****** <%get("factoryClassname")%>  ******
// ***************************************************************** 
fullNameDomainName = "";
fullFactoryName = "";
threadingPolicy = null;
i = 0;

<%if (getOccurrences(self) > 0){%>
try {
    fullNameDomainName =
        xmlData.getFrameworkAttributeValue(
            "<%self%>",
            i,
            "domain-name");
    fullFactoryName =
        xmlData.getFrameworkAttributeValue(
            "<%self%>",
            i,
            "full-factory-name");
    // TODO: If fullNameDomainName and fullFactoryName are empty
    // use default name domain
    
    <%if (getThreading(self) == "SERIALIZE"){%>
    threadingPolicy = new SingleThreadPolicy();       
    <%}else if (getThreading(self) == "MULTITHREAD"){%>
    String[] values =
        xmlData.getFrameworkMultithreadAttribute(
            "<%self%>",
            i);
    String xmlThreadingPolicy = values[0];
    String xmlThreadingAttribute = values[1];
    String xmlThreadingAttributeValue = values[2];
      
    if (!xmlThreadingPolicy.equals("serialize")) {
        threadingPolicy = new SingleThreadPolicy();
    } else { // threadingPolicy must be initialized
        threadingPolicy = new ThreadPoolPolicy(5);
    }
    <%}else{%>
    <%abort("ERROR UNKOWN THREADING POLICY: <%getThreading(self)%> (shouldn't happen)")%>
    <%}%>
       
       
} catch (NumberFormatException nfe) {
    processImpl.setCdmwInitExceptionRaised();
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
} catch (XMLErrorException xee) {
    processImpl.setCdmwInitExceptionRaised();
    // TODO: Add trace logs here
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
} catch (BadParameterException bpe) {
    processImpl.setCdmwInitExceptionRaised();
    // TODO: Add trace logs here
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
}
   
try {
    // Get the factory Allocator
    // TODO: Use a user-provided name rather than a naming convention!
    <%get("factoryClassname")%>Allocator allocator = 
        <%get("factoryClassname")%>Allocator.theAllocator;

    NamedObjectsFactoryInitUtil
        .setupNamedObjectFactory(
            allocator,
            orb,
            factoriesPOA,
            repository,
            rootContext,
            fullNameDomainName,
            fullFactoryName,
            "", // TODO:
            threadingPolicy,
            args);

} catch (BadParameterException bpe) {
    processImpl.setCdmwInitExceptionRaised();
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMLifeCycleFrameworkInit,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
} catch (InternalErrorException iie) {
    processImpl.setCdmwInitExceptionRaised();
    throw new org.omg.CORBA.INTERNAL(
        ExceptionMinorCodes.INTERNALLifeCycleFrameworkError,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
}
<%}%>



<%--
  -- Generate code for UnmanagedEntity lifecycle-framework
  -- This script is supposed to be called with the lifecycle-framework id as self.
  -- And context should contain a entry for "factoryClassname"
  --  
--%>
<%script type="idlmm.IRObject" name="genUnmanagedEntityAllocatorInit"%>
// *****************************************************************
// ****** <%get("factoryClassname")%>  ******
// *****************************************************************
fullNameDomainName = "";
fullFactoryName = "";
threadingPolicy = null;
i = 0;

<%if (getOccurrences(self) > 0){%>
try {
    fullNameDomainName =
        xmlData.getFrameworkAttributeValue(
            "<%self%>",
            i,
            "domain-name");
    fullFactoryName =
        xmlData.getFrameworkAttributeValue(
            "<%self%>",
            i,
            "full-factory-name");
    // TODO: If fullNameDomainName and fullFactoryName are empty
    // use default name domain

    <%if (getThreading(self) == "SERIALIZE"){%>
    threadingPolicy = new SingleThreadPolicy();
    <%}else if (getThreading(self) == "MULTITHREAD"){%>
    String[] values =
        xmlData.getFrameworkMultithreadAttribute(
            "<%self%>",
            i);
    String xmlThreadingPolicy = values[0];
    String xmlThreadingAttribute = values[1];
    String xmlThreadingAttributeValue = values[2];
    
    if (!xmlThreadingPolicy.equals("serialize")) {
        threadingPolicy = new SingleThreadPolicy();
    } else { // threadingPolicy must be initialized
        threadingPolicy = new ThreadPoolPolicy(5);
    }
    <%}else{%>
    <%abort("ERROR UNKOWN THREADING POLICY: <%getThreading(self)%> (shouldn't happen)")%>
    <%}%>

} catch (NumberFormatException nfe) {
    processImpl.setCdmwInitExceptionRaised();
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
} catch (XMLErrorException xee) {
    processImpl.setCdmwInitExceptionRaised();
    // TODO: Add trace logs here
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
} catch (BadParameterException bpe) {
    processImpl.setCdmwInitExceptionRaised();
    // TODO: Add trace logs here
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
}

try {
    // Get the factory Allocator
    // TODO: Use a user-provided name rather than a naming convention!
    <%get("factoryClassname")%>Allocator allocator = 
        <%get("factoryClassname")%>Allocator.theAllocator;
      
    NamedObjectsFactoryInitUtil
        .setupNamedObjectFactory(
            allocator,
            orb,
            factoriesPOA,
            repository,
            rootContext,
            fullNameDomainName,
            fullFactoryName,
            "", // TODO:
            threadingPolicy,
            args);

} catch (BadParameterException bpe) {
    processImpl.setCdmwInitExceptionRaised();
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMLifeCycleFrameworkInit,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
} catch (InternalErrorException iie) {
    processImpl.setCdmwInitExceptionRaised();
    throw new org.omg.CORBA.INTERNAL(
        ExceptionMinorCodes.INTERNALLifeCycleFrameworkError,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
}
<%}%>



<%--
  -- Generate code for Session lifecycle-framework
  -- This script is supposed to be called with the lifecycle-framework id as self.
  -- And context should contain a entry for "factoryClassname"
  --  
--%>
<%script type="idlmm.IRObject" name="genSessionAllocatorInit"%>
// *****************************************************************
// ****** <%get("factoryClassname")%>  ******
// *****************************************************************
fullFactoryName = "";
threadingPolicy = null;
i = 0;

<%if (getOccurrences(self) > 0){%>
try {
    fullFactoryName =
        xmlData.getFrameworkAttributeValue(
            "<%self%>",
            i,
            "full-factory-name");
                          
    <%if (getThreading(self) == "SERIALIZE"){%>
    threadingPolicy = new SingleThreadPolicy();
    <%}else if (getThreading(self) == "MULTITHREAD"){%>
    String[] values =
        xmlData.getFrameworkMultithreadAttribute(
            "<%self%>",
            i);
    String xmlThreadingPolicy = values[0];
    String xmlThreadingAttribute = values[1];
    String xmlThreadingAttributeValue = values[2];
     
    if (!xmlThreadingPolicy.equals("serialize")) {
        threadingPolicy = new SingleThreadPolicy();
    } else { // threadingPolicy must be initialized
        threadingPolicy = new ThreadPoolPolicy(5);
    }
    <%}else{%>
    <%abort("ERROR UNKOWN THREADING POLICY: <%getThreading(self)%> (shouldn't happen)")%>
    <%}%>

} catch (NumberFormatException nfe) {
    processImpl.setCdmwInitExceptionRaised();
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
} catch (XMLErrorException xee) {
    processImpl.setCdmwInitExceptionRaised();
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
} catch (BadParameterException bpe) {
    processImpl.setCdmwInitExceptionRaised();
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
}

try {
    // Get the factory Allocator
    // TODO: Use a user-provided name rather than a naming convention!
    <%get("factoryClassname")%>Allocator allocator = 
        <%get("factoryClassname")%>Allocator.theAllocator;

    AnonymousObjectsFactoryInitUtil
        .setupAnonymousObjectFactory(
            allocator,
            orb,
            factoriesPOA,
            repository,
            rootContext,
            fullFactoryName,
            "", // TODO:
            threadingPolicy, 
            args);
} catch (BadParameterException bpe) {
    processImpl.setCdmwInitExceptionRaised();
    // TODO: Add trace logs here
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMLifeCycleFrameworkInit,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
} catch (InternalErrorException iie) {
    processImpl.setCdmwInitExceptionRaised();
    // TODO: Add trace logs here
    throw new org.omg.CORBA.INTERNAL(
        ExceptionMinorCodes.INTERNALLifeCycleFrameworkError,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
}
<%}%>



<%--
  -- Generate code for Service lifecycle-framework
  -- This script is supposed to be called with the lifecycle-framework id as self.
  -- And context should contain a entry for "factoryClassname"
  --  
--%>
<%script type="idlmm.IRObject" name="genServiceAllocatorInit"%>
// *****************************************************************
// ****** <%get("factoryClassname")%>  ******
// *****************************************************************
fullFactoryName = "";
threadingPolicy = null;
i = 0;

<%if (getOccurrences(self) > 0){%>
try {
    fullFactoryName =
        xmlData.getFrameworkAttributeValue(
            "<%self%>",
            i,
            "full-factory-name");
                          
    <%if (getThreading(self) == "SERIALIZE"){%>
    threadingPolicy = new SingleThreadPolicy();
    <%}else if (getThreading(self) == "MULTITHREAD"){%>
    String[] values =
        xmlData.getFrameworkMultithreadAttribute(
            "<%self%>",
            i);
    String xmlThreadingPolicy = values[0];
    String xmlThreadingAttribute = values[1];
    String xmlThreadingAttributeValue = values[2];
      
    if (!xmlThreadingPolicy.equals("serialize")) {
        threadingPolicy = new SingleThreadPolicy();
    } else { // threadingPolicy must be initialized
        threadingPolicy = new ThreadPoolPolicy(5);
    }
    <%}else{%>
    <%abort("ERROR UNKOWN THREADING POLICY: <%getThreading(self)%> (shouldn't happen)")%>
    <%}%>

} catch (NumberFormatException nfe) {
    processImpl.setCdmwInitExceptionRaised();
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
} catch (XMLErrorException xee) {
    processImpl.setCdmwInitExceptionRaised();
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
} catch (BadParameterException bpe) {
    processImpl.setCdmwInitExceptionRaised();
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
}

try {
    // Get the factory Allocator
    // TODO: Use a user-provided name rather than a naming convention!
    <%get("factoryClassname")%>Allocator allocator = 
        <%get("factoryClassname")%>Allocator.theAllocator;

    AnonymousObjectsFactoryInitUtil
        .setupAnonymousObjectFactory(
            allocator,
            orb,
            factoriesPOA,
            repository,
            rootContext,
            fullFactoryName,
            "", // TODO:
            threadingPolicy, 
            args);
} catch (BadParameterException bpe) {
    processImpl.setCdmwInitExceptionRaised();
    // TODO: Add trace logs here
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMLifeCycleFrameworkInit,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
} catch (InternalErrorException iie) {
    processImpl.setCdmwInitExceptionRaised();
    // TODO: Add trace logs here
    throw new org.omg.CORBA.INTERNAL(
        ExceptionMinorCodes.INTERNALLifeCycleFrameworkError,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
}
<%}%>



<%--
  -- Generate code for User Defined Factory lifecycle-framework
  -- This script is supposed to be called with the lifecycle-framework id as self.
  -- And context should contain a entry for "factoryClassname"
  --  
--%>
<%script type="idlmm.IRObject" name="genUserDefinedFactoryAllocatorInit"%>
// *****************************************************************
// ******                User defined factory                 ******
// *****************************************************************
fullFactoryName = "";;
<%if (isNamedFactory(self)){%>
fullNameDomainName= "";
<%}%>
threadingPolicy = null;
i = 0;

<%if (getOccurrences(self) > 0){%>
try {
    <%if (isNamedFactory(self)){%>
    fullNameDomainName =
        xmlData.getFrameworkAttributeValue(
            "<%self%>",
            i,
            "domain-name");
    fullFactoryName =
        xmlData.getFrameworkAttributeValue(
            "<%self%>",
            i,
            "full-factory-name");
    // TODO: If fullNameDomainName and fullFactoryName are empty
    // use default name domain
    <%}else{%>
    fullFactoryName =
        xmlData.getFrameworkAttributeValue(
            "<%self%>",
            i,
            "full-factory-name");
    <%}%>

    <%if (getThreading(self) == "SERIALIZE"){%>
    threadingPolicy = new SingleThreadPolicy();
    <%}else if (getThreading(self) == "MULTITHREAD"){%>
    String[] values =
        xmlData.getFrameworkMultithreadAttribute(
            "<%self%>",
            i);
    String xmlThreadingPolicy = values[0];
    String xmlThreadingAttribute = values[1];
    String xmlThreadingAttributeValue = values[2];
      
    if (!xmlThreadingPolicy.equals("serialize")) {
        threadingPolicy = new SingleThreadPolicy();
    } else { // threadingPolicy must be initialized
        threadingPolicy = new ThreadPoolPolicy(5);
    }
    <%}else{%>
    <%abort("ERROR UNKOWN THREADING POLICY: <%getThreading(self)%> (shouldn't happen)")%>
    <%}%>

} catch (NumberFormatException nfe) {
    processImpl.setCdmwInitExceptionRaised();
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
} catch (XMLErrorException xee) {
    processImpl.setCdmwInitExceptionRaised();
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
} catch (BadParameterException bpe) {
    processImpl.setCdmwInitExceptionRaised();
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
}

try {
    // Get the factory Allocator
    // TODO: Use a user-provided name rather than a naming convention!
    <%getAllocatorClassname(self)%> allocator = 
        <%getAllocatorClassname(self)%>.theAllocator;
      
    <%namedPrefix%>ObjectsFactoryInitUtil
        .setup<%namedPrefix%>ObjectFactory(
            allocator,
            orb,
            factoriesPOA,
            repository,
            rootContext,
            <%if (isNamedFactory(self)){%>
            fullNameDomainName,
            <%}%>
            fullFactoryName,
            "", // TODO:
            threadingPolicy, 
            args);
} catch (BadParameterException bpe) {
    processImpl.setCdmwInitExceptionRaised();
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMLifeCycleFrameworkInit,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
} catch (InternalErrorException iie) {
    processImpl.setCdmwInitExceptionRaised();
    throw new org.omg.CORBA.INTERNAL(
        ExceptionMinorCodes.INTERNALLifeCycleFrameworkError,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
}
<%}%>




<%script type="idlmm.IRObject" name="namedPrefix" post="trim()"%>
<%if (isNamedFactory(self)){%>
Named
<%}else{%>
Anonymous
<%}%>



<%script type="idlmm.IRObject" name="printFrameworkData"%>
// ***********************************************************
// Framework: <%self%>
//    occurences     <%getOccurrences(self)%>
//    idl-interface  <%getFactoryIdlInterface(self)%>
//    isHome         <%isHome(self)%>
//    isNamed        <%isNamedFactory(self)%>
//    homeDef        <%getHome(self)%>
//    factoryClassname   <%getFactoryClassname(self)%>
//    allocatorClassname <%getAllocatorClassname(self)%>
//    category       <%getCategory(self)%>
//    threading      <%getThreading(self)%>
// ***********************************************************
