<%
metamodel http://www.prismtech.com/idlmm
%>

<%script type="idlmm.Repository" name="initLBService"%>
// generate call for LBServiceInit.Init
try {
    cdmw.lb.lbinit.LBServiceInit.init(args);
} catch (org.omg.CORBA.SystemException e) {
    System.err.println("CDMW_preORBInit: Fatal Error:");
    System.err.println("CORBA Exception : " + e);
    e.printStackTrace();
}



<%script type="idlmm.Repository" name="initLBGroupManager"%>
// *****************************************************************
// ***********    setup LoadBalancing LBGroupManager     ***********
// *****************************************************************

// Try to get the reference of the FT LBGroupManager from Repository
CdmwLB.LBGroupManager lbGroupMgr = null;
try {
    // Get NamingInterface to object_groups (for reading)
    cdmw.commonsvcs.naming.NamingInterface objGroupsInterface = 
        cdmw.namingandrepository.RepositoryInterface
            .getDomainNamingInterface("lb_group_manager/object_groups");

    // Get LB GroupManager Object Group
    org.omg.CORBA.Object objRef = 
        objGroupsInterface.resolve("LBGroupManagerGroup");

    lbGroupMgr = CdmwLB.LBGroupManagerHelper.narrow(objRef);
}
catch (com.thalesgroup.CdmwNamingAndRepository.NoNameDomain ex) {
    System.err.println( 
        "FT LBGroupManager not found in Repository " 
        + "(CdmwNamingAndRepository.NoNameDomain). "
        + "Assumes non-FT LBGroupManager has been specified "
        + "with -ORBInitRef...");
}
catch (com.thalesgroup.CdmwNamingAndRepository.InvalidName ex) {
    // shouldn't happen since names are valid
    System.err.println( 
       "Error retrieving LBGroupManager from Repository: " 
       + "CdmwNamingAndRepository.InvalidName");
    Assert.check(false);
}
catch (org.omg.CosNaming.NamingContextPackage.NotFound ex) {
    System.err.println( 
        "FT LBGroupManager not found in Repository "
        + "(CosNaming.NamingContext.NotFound). "
        + "Assumes non-FT LBGroupManager has been specified "
        + "with -ORBInitRef...");
}
catch (org.omg.CosNaming.NamingContextPackage.CannotProceed ex) {
    System.err.println( 
        "Exception retrieving FT LBGroupManager from Repository " 
        + "(CosNaming.NamingContext.CannotProceed). "
        + "Assumes non-FT LBGroupManager has been specified "
        + "with -ORBInitRef...");
}
catch (org.omg.CosNaming.NamingContextPackage.InvalidName ex) {
    // shouldn't happen since names are valid
    System.err.println( 
       "Error retrieving LBGroupManager from Repository: " + ex);
    Assert.check(false);
}
catch (org.omg.CORBA.SystemException ex) {
    System.err.println( 
        "Exception retrieving FT LBGroupManager from Repository: " + ex
        + ". Assumes non-FT LBGroupManager has been specified "
        + "with -ORBInitRef...");
}

if (lbGroupMgr != null) {
    try {
        ((org.omg.CORBA_2_5.ORB) orb).register_initial_reference("LBGroupManager", lbGroupMgr);      
    }
    catch (org.omg.CORBA.SystemException ex)
    {
        System.err.println( 
           "Error regitering LBGroupManager as initial reference: " + ex);
        throw ex;
    }
    catch (org.omg.CORBA.ORBPackage.InvalidName ex)
    {
        System.err.println( 
            "Error regitering LBGroupManager as initial reference: " + ex);
        throw new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNAL,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
    }
}



