<%
metamodel http://www.prismtech.com/idlmm
%>


<%script type="idlmm.Repository" name="initPerformanceService"%>
// *****************************************************************
// *********       Init The CDMW Performance Library      *********
// *****************************************************************
String performanceFileName = null;
try {
    performanceFileName =
        xmlData.getServiceAttributeValue(
            "performance",
            "result-file-name");
} catch (BadParameterException bpe) {
    processImpl.setCdmwInitExceptionRaised();
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
} catch (XMLErrorException xee) {
    processImpl.setCdmwInitExceptionRaised();
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
}

// May raise org.omg.CORBA.SystemException
if (performanceFileName != null) {
    cdmw.performance.InitUtils.initPerformanceLibrary(
        cdmwRootPOA,
        performanceFileName);
}


<%script type="idlmm.Repository" name="stopPerformanceService"%>
// Free all allocated memory and stop the performance service
try {
    PerformanceMngr.cleanup();
} catch (BadParameterException bpe) {
    // Do nothing (ignore)
    // TODO: Add trace logs here
}

