<%
metamodel http://www.prismtech.com/idlmm
%>


<%script type="idlmm.Repository" name="initRecordingService"%>
// *****************************************************************
// **********  register initial references for Recording ***********
// *****************************************************************
//

Assert.check(local_NameService != null); 
NamingInterface localNi = new NamingInterface(local_NameService);

Long callTimeout_millisec = 0L;
try {
    String resRecordingTimeout = 
        xmlData.getServiceAttributeValue("recording", "recorder-timeout"); 
        callTimeout_millisec = Long.parseLong(resRecordingTimeout);
} catch (BadParameterException ex) {
    processImpl.setCdmwInitExceptionRaised();
    throw new CORBASystemExceptionWrapper(
        new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO));
} catch (XMLErrorException xmle) {
    processImpl.setCdmwInitExceptionRaised();
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
}


// Register initial reference for the recording daemon
cdmw.logging.Logger.CDMW_DEBUG(InitUtils.Get_Logger(),
                               "CDMW_init: register initial reference of the recording daemon",
                               new Throwable());
org.omg.CORBA.Object daemonObj; 
try {
    daemonObj = localNi.resolve(com.thalesgroup.CdmwRecording.REC_CONTAINER_MNGR_ID.value);
} catch (org.omg.CosNaming.NamingContextPackage.NotFound nf) {
    cdmw.logging.Logger.CDMW_FATAL(InitUtils.Get_Logger(),
        "CDMW_init: org.omg.CosNaming.NamingContextPackage.NotFound exception. Recording daemon control not found. " + cdmw.orbsupport.ORBSupport.exceptionToString(nf),
         new Throwable());
    throw new CORBASystemExceptionWrapper(
                new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAM,
    org.omg.CORBA.CompletionStatus.COMPLETED_NO));
} catch (Exception e) {
    cdmw.logging.Logger.CDMW_FATAL(InitUtils.Get_Logger(),
        "CDMW_init: Exception during the resolving of REC_CONTAINER_MNGR_ID in the naming. " + e.getMessage(),
         new Throwable());
    throw new CORBASystemExceptionWrapper(
                new org.omg.CORBA.INTERNAL(
        ExceptionMinorCodes.INTERNAL,
    org.omg.CORBA.CompletionStatus.COMPLETED_NO));
}

if (daemonObj == null)
{ 
    cdmw.logging.Logger.CDMW_FATAL(InitUtils.Get_Logger(),
        "CDMW_init: null Object Reference for '" 
        + com.thalesgroup.CdmwRecording.REC_CONTAINER_MNGR_ID.value,
        new Throwable());
    throw new CORBASystemExceptionWrapper(
        new org.omg.CORBA.BAD_PARAM(
            ExceptionMinorCodes.BAD_PARAM,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO));
}

try {
    ((org.omg.CORBA_2_5.ORB)orb).register_initial_reference(
        com.thalesgroup.CdmwRecording.REC_CONTAINER_MNGR_ID.value, 
        daemonObj);
}
catch (org.omg.CORBA.ORBPackage.InvalidName in) {
    cdmw.logging.Logger.CDMW_FATAL(InitUtils.Get_Logger(),
        "CDMW_init: register_initial_reference of "
        + com.thalesgroup.CdmwRecording.REC_CONTAINER_MNGR_ID.value
        + " failed. " + cdmw.orbsupport.ORBSupport.exceptionToString(in),
        new Throwable());
    throw new CORBASystemExceptionWrapper(
        new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNAL,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO));
}

try {
    daemonObj =  localNi.resolve(com.thalesgroup.CdmwRecording.REC_DAEMON_CTRL_ID.value);
} catch (org.omg.CosNaming.NamingContextPackage.NotFound nf) {
    cdmw.logging.Logger.CDMW_FATAL(InitUtils.Get_Logger(),
        "CDMW_init: org.omg.CosNaming.NamingContextPackage.NotFound exception. Recording daemon control not found. " + cdmw.orbsupport.ORBSupport.exceptionToString(nf),
         new Throwable());
    throw new CORBASystemExceptionWrapper(
        new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNAL,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO));
} catch (Exception e) {
    cdmw.logging.Logger.CDMW_FATAL(InitUtils.Get_Logger(),
        "CDMW_init:  Exception raised. Recording daemon control not found. " + e.getMessage(),
         new Throwable());
    throw new CORBASystemExceptionWrapper(
        new org.omg.CORBA.INTERNAL(
           ExceptionMinorCodes.INTERNAL,
           org.omg.CORBA.CompletionStatus.COMPLETED_NO));
}

if (daemonObj == null)
{ 
    cdmw.logging.Logger.CDMW_FATAL(InitUtils.Get_Logger(),
        "CDMW_init: null Object Reference for '" 
        + com.thalesgroup.CdmwRecording.REC_DAEMON_CTRL_ID.value,
        new Throwable());
    throw new CORBASystemExceptionWrapper(
        new org.omg.CORBA.BAD_PARAM(
            ExceptionMinorCodes.BAD_PARAM,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO));
}

com.thalesgroup.CdmwRecording.DaemonControl daemon = 
    com.thalesgroup.CdmwRecording.DaemonControlHelper.narrow(daemonObj);

String recordingServerUrl = daemon.recorder_url();
cdmw.logging.Logger.CDMW_DEBUG(InitUtils.Get_Logger(), 
    "CDWM_init: recording server URL  = "
    + recordingServerUrl,
    new Throwable());

if ( recordingServerUrl.trim().equals("") ) {
    cdmw.logging.Logger.CDMW_WARN(InitUtils.Get_Logger(), 
    "CDWM_init: No Recording server url defined! Thus register_initial_reference() is not perfomed for the Recording server.",
    new Throwable());
} else {
    // Register initial reference for the recording server
    //
    cdmw.logging.Logger.CDMW_DEBUG(InitUtils.Get_Logger(), 
        "CDMW_init: register initial reference of the recording server",
         new Throwable());

    try {
        org.omg.CORBA.Object recordingServerObj = orb.string_to_object(recordingServerUrl);
        Assert.check(recordingServerObj != null);
        ((org.omg.CORBA_2_5.ORB)orb).register_initial_reference("RecordingServer", recordingServerObj);
    }  
    catch (org.omg.CORBA.ORBPackage.InvalidName in) {
        cdmw.logging.Logger.CDMW_FATAL(InitUtils.Get_Logger(),
            "CDMW_init:org.omg.CORBA.ORBPackage.InvalidName exception raised. register_initial_reference of RecordingServer not performed. " + cdmw.orbsupport.ORBSupport.exceptionToString(in),
            new Throwable());
        throw new CORBASystemExceptionWrapper(
            new org.omg.CORBA.INTERNAL(
                ExceptionMinorCodes.INTERNAL,
                org.omg.CORBA.CompletionStatus.COMPLETED_NO));
    }
}



