<%
metamodel http://www.prismtech.com/idlmm
%>

<%script type="idlmm.Repository" name="initTraceService"%>
// *****************************************************************
// *********         Init The CDMW Trace Library          *********
// *****************************************************************

String res;
int flushingTime = 0;
int msgThreshold = 0;
int nbFlushArea = 0;
int sizeFlushArea = 0;
String collectorName;
java.util.Vector collectorNameList = new java.util.Vector();

try {
    try {
        flushingTime = Integer.parseInt(
            xmlData.getServiceAttributeValue(
                "trace",
                "flushing-time"));
        nbFlushArea = Integer.parseInt(
            xmlData.getServiceAttributeValue(
                "trace",
                "flush-area-nb"));
        sizeFlushArea = Integer.parseInt(
            xmlData.getServiceAttributeValue(
                "trace",
                "flush-area-sz"));
        collectorName =
            xmlData.getServiceAttributeValue(
                "trace",
                "collector-name");
        collectorNameList.add(collectorName);
    }
    catch (BadParameterException bpe) {
        processImpl.setCdmwInitExceptionRaised();
        throw new org.omg.CORBA.BAD_PARAM(
            ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
    }

    try {
        msgThreshold = Integer.parseInt(
            xmlData.getServiceAttributeValue(
                "trace",
                "msg-threshold"));
    } catch (BadParameterException bpe) {
        // do nothing : parameter is optional
    }

    try {
        collectorName =
            xmlData.getServiceAttributeValue(
                "trace",
                "collector-name");
        collectorNameList.add(collectorName);
    } catch (BadParameterException bpe) {
        // do nothing : parameter is optional
    }

} catch (XMLErrorException xee) {
    processImpl.setCdmwInitExceptionRaised();
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
} catch (NumberFormatException nfe) {
    processImpl.setCdmwInitExceptionRaised();
    throw new org.omg.CORBA.BAD_PARAM(
        ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
}

// May raise org.omg.CORBA.SystemException
cdmw.trace.InitUtils.initTraceLibrary(
    cdmwRootPOA,
    applicationName,
    processName,
    flushingTime,
    msgThreshold,
    nbFlushArea,
    sizeFlushArea,
    collectorNameList);

// active the trace flushing to trace collector
FlushAreaMngr.getInstance().activateFlushing();


<%script type="idlmm.Repository" name="stopTraceService"%>
// Free all allocated memory and stop the trace service
FlushAreaMngr.cleanup();



<%script type="idlmm.Repository" name="initLogManagerCollectorDelegate"%>
// *****************************************************************
// *********   Init The CDMW LogManagerCollectorDelegate   *********
// *****************************************************************
{

    cdmw.logging.Logger.CDMW_DEBUG(InitUtils.Get_Logger(), 
                                   "Init LogManagerCollectorDelegate",
                                   new Throwable());
    int msg_threshold = 0; // NOTA: Not used in this version
    String collectorName = "";
    try {
        try {
            collectorName = xmlData.getServiceAttributeValue("trace", "collector-name");
        } catch (BadParameterException ex) {
            cdmw.logging.Logger.CDMW_DEBUG(InitUtils.Get_Logger(),
                "Cdmw::BadParameterException received: ",
                new Throwable());
        }
    
        try  {
            //FlushAreaMngr DEFAULT_MSG_THRESHOLD;
            String resThreshold = xmlData.getServiceAttributeValue("trace", "msg-threshold"); 
            msg_threshold = Integer.valueOf(resThreshold).intValue();
        } catch (BadParameterException e) {
            // do nothing : parameter is optional
        }
    } catch (XMLErrorException ex) {
        processImpl.setCdmwInitExceptionRaised();
        cdmw.logging.Logger.CDMW_WARN(InitUtils.Get_Logger(), 
            "XMLErrorException received: "
            + ex.getMessage(),
            new Throwable());
        throw new CORBASystemExceptionWrapper(new org.omg.CORBA.BAD_PARAM(
            ExceptionMinorCodes.BAD_PARAMInvalidXMLInitData,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO));
    }
    // We have a collector name now. Let's retreive it from PlatformDaemon (NameServer).
    // Use collectorName if provided by user, otherwise use default one.
    if (collectorName.trim().equals("")) {
        collectorName = cdmw.common.Locations.DEFAULT_LOG_COLLECTOR_ID;
    }
    com.thalesgroup.CdmwLogging.LogCollector logCollector__;
    if (local_NameService == null)
    {
        cdmw.logging.Logger.CDMW_WARN(InitUtils.Get_Logger(), "No Local NameService available. "
            + "Trace logs will not be sent to Trace Collector.",
            new Throwable());
    } else {
        NamingInterface localNI = new NamingInterface(local_NameService);
        org.omg.CORBA.Object obj__;
        try {
            obj__ = localNI.resolve(collectorName);
            logCollector__ = com.thalesgroup.CdmwLogging.LogCollectorHelper.narrow(obj__);
            if (logCollector__ == null) {
                cdmw.logging.Logger.CDMW_WARN(InitUtils.Get_Logger(), 
                    "'" + collectorName + "' does not denote a valid "
                    + "Log Collector object. "
                    + "Trace logs will not be sent to Trace Collector.",
                    new Throwable());
            }
            else {
                cdmw.logging.LogManagerCollectorDelegate delegate__ =
                    new cdmw.logging.LogManagerCollectorDelegate(logCollector__);
                cdmw.logging.LogManagerDelegate d__ = 
                    cdmw.logging.LogManager.Instance().registerAlternateDelegate(delegate__);
            }
        } catch (org.omg.CosNaming.NamingContextPackage.NotFound nf) {
            cdmw.logging.Logger.CDMW_WARN(InitUtils.Get_Logger(), 
                "Could not retrieve reference of the Log Collector "
                + "'" + collectorName + "' not found in the naming. "
                + "Trace logs will not be sent to Trace Collector.",
                new Throwable());
        } catch (org.omg.CosNaming.NamingContextPackage.CannotProceed cp) {
            cdmw.logging.Logger.CDMW_WARN(InitUtils.Get_Logger(), 
                "Could not retrieve reference of the Log Collector (cannot proceeed) "
                + "Trace logs will not be sent to Trace Collector.",
                new Throwable());
        } catch (org.omg.CosNaming.NamingContextPackage.InvalidName in) {
            cdmw.logging.Logger.CDMW_WARN(InitUtils.Get_Logger(), 
                "Could not retrieve reference of the Log Collector (invalid name) "
                + "Trace logs will not be sent to Trace Collector.",
                new Throwable());
        }
    }
}



