<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.cdmw.codegenerator.lifecycle.LifeCycleServices
import com.thalesgroup.cdmw.codegenerator.lifecycle.ModelServices
import com.thalesgroup.cdmw.codegenerator.lifecycle.Utils
import com.thalesgroup.cdmw.codegenerator.lifecycle.cpp.Utils
import com.thalesgroup.ccm.codegenerator.corba.CommonServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.Utils
import com.thalesgroup.ccm.codegenerator.corba.cpp.CppMappingServices
import com.thalesgroup.ccm.codegenerator.container.Utils
%>


<%--
  -- Generation template  
  -- This template is not model-based (idlmm.Repository is just specified
  -- to access InterfaceDef data)
  -- All is based on LifeCycleServices which provides access to loaded data
  -- from XML file.
  --%>
<%script type="idlmm.Repository" name="EntityFactoryAllocator_hpp" file="<%factoryAllocatorHppFilePath%>"%>
<%copyrightHeader%>

<%openIfndefMacro("RESOURCES_"+factoryAllocatorClassname)%>

#include <LifeCycle/lifecycle/FactoryAllocator.hpp>
#include <Foundation/common/Locations.hpp>
#include <Foundation/commonsvcs/naming/NamingUtil.hpp>
#include <Repository/repositoryinterface/RepositoryInterface.hpp>

#include "<%factoryHppFilePath%>"

namespace
{
    // PropertSet Name
    const char* ENTITY_PROPERTY_SET_NAME = "PropertySet.object";
};


namespace Cdmw {
namespace LifeCycle {

    template <>
    PortableServer::Servant
    NamedObjectsFactoryAllocator< <%factoryImplFullClassname%> >::allocate
        (CORBA::ORB_ptr                           orb,
         PortableServer::POA_ptr                  parent,
         CdmwLifeCycle::ObjectRegistration_ptr    name_domain,
         const std::string &                      name_domain_name,
         const std::string &                      factory_name,
         Cdmw::OrbSupport::POAThreadingPolicy &   threading_policy,
         int & argc, char** argv)
        throw(Cdmw::OutOfMemoryException,
              Cdmw::BadParameterException,
              Cdmw::InternalErrorException,
              CORBA::SystemException)
    {
        // Get the property set "CDMW/SERVICES/PropertySet.object"
        // (CDMW Developpers should not rely on this functionalilty as this is only
        // needed for persisting EntityCleanupNotifier objects. This may change in
        // future CDMW versions)
        CosPropertyService::PropertySet_var property_set
            = CosPropertyService::PropertySet::_nil();
        try {
            using Cdmw::NamingAndRepository::RepositoryInterface;
            Cdmw::CommonSvcs::Naming::NamingInterface sni
                = RepositoryInterface::get_domain_naming_interface
            (Cdmw::Common::Locations::CDMW_SERVICES_NAME_DOMAIN);

            typedef Cdmw::CommonSvcs::Naming::NamingUtil<CosPropertyService::PropertySet>
                NamingUtil;
            property_set = NamingUtil::resolve_name(sni,ENTITY_PROPERTY_SET_NAME);

        } catch (const CdmwNamingAndRepository::NoNameDomain & ) {
            throw CORBA::INTERNAL(Cdmw::OrbSupport::INTERNALCdmwRepositoryError,
                                  CORBA::COMPLETED_YES);
        } catch (const CdmwNamingAndRepository::InvalidName & ) {
            throw CORBA::INTERNAL(Cdmw::OrbSupport::INTERNALCdmwRepositoryError,
                                  CORBA::COMPLETED_YES);
        } catch (const CosNaming::NamingContext::NotFound & ) {
            // TODO: Echo warning
        } catch (const CORBA::SystemException & ) {
            throw;
        } catch (...) {
            throw CORBA::INTERNAL(Cdmw::OrbSupport::INTERNAL,
                                  CORBA::COMPLETED_YES);
        }

        try {
            return new <%factoryImplFullClassname%>
                (orb,
                 parent,
                 name_domain,
                 name_domain_name,
                 factory_name,
                 threading_policy,
                 property_set.in(),
                 argc,
                 argv);
        } catch (const std::bad_alloc &) {
            CDMW_THROW(Cdmw::OutOfMemoryException);
        } catch (const Cdmw::OutOfMemoryException &) {
            throw;
        } catch (const Cdmw::BadParameterException &) {
            throw;
        } catch (const Cdmw::InternalErrorException &) {
            throw;
        } catch (const CORBA::SystemException & e) {
            throw;
        }
    }

}; // End namespace LifeCycle
}; // End namespace Cdmw


<%openNamespace(factoryImplClassnameScope.withCppScope)%>

    // TODO: Use a user-provided name rather than a naming convention!
    typedef Cdmw::LifeCycle::NamedObjectsFactoryAllocator< <%factoryImplClassname%> >
        <%factoryImplClassname%>_Allocator;

<%closeNamespace(factoryImplClassnameScope.withCppScope)%>

<%closeIfndefMacro("RESOURCES_"+factoryAllocatorClassname)%>
