<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.cdmw.codegenerator.lifecycle.LifeCycleServices
import com.thalesgroup.cdmw.codegenerator.lifecycle.ModelServices
import com.thalesgroup.ccm.codegenerator.corba.CommonServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.Utils
import com.thalesgroup.ccm.codegenerator.corba.cpp.CppMappingServices
import com.thalesgroup.ccm.codegenerator.container.Utils
%>


<%script type="idlmm.Repository" name="servantProviderHppFilePath" post="trim()"%>
<%if (servantProviderFilename.length() > 0){%>
<%directoryPrefix%><%servantProviderFilename%>
<%}else{%>
<%directoryPrefix%><%servantProviderClassname%>.hpp
<%}%>



<%--
  -- If directory attribute is specified for the <program>,
  -- this script returns the directory +"/"
  --%>
<%script type="idlmm.Repository" name="directoryPrefix" post="trim()"%>
<%if (servantProviderDirectory.length > 0){%>
<%servantProviderDirectory%>/
<%}%>



<%--
  -- Generation template  
  -- This template is not model-based (idlmm.Repository is just specified
  -- to access InterfaceDef data)
  -- All is based on LifeCycleServices which provides access to loaded data
  -- from XML file.
  --%>
<%script type="idlmm.Repository" name="ServantProvider_hpp" file="<%servantProviderHppFilePath%>"%>
<%copyrightHeader%>

<%openIfndefMacro("SERVANT_PROVIDER_"+servantProviderClassname)%>

#include <Foundation/orbsupport/CORBA.hpp>
<%idlInterface.genIncludeIdlStub%>
#include <LifeCycle/lifecycle/ServantProviderBase.hpp>

<%openNamespace(servantProviderClassnameScope.withCppScope)%>

    class <%servantProviderClassname%> : public Cdmw::LifeCycle::ServantProviderBase
    {
        public:
            virtual 
            ~<%servantProviderClassname%>()
            throw();

            <%--
                Create the operations declarations.
            --%>
            <%for (idlInterface.findAllFactoryOperations){%>
            <%generateOperation%>
        
            <%}%>
        
        protected:
            virtual const char ** get_ids() const throw();
            virtual CORBA::Long   get_number_of_ids() const throw();      
        
            <%servantProviderClassname%>()
            throw();
      
      private:
         // Hide copy constructor/assignment operator
         <%servantProviderClassname%>(const <%servantProviderClassname%>& rhs)
            throw();
        
         <%servantProviderClassname%>&
         operator=(const <%servantProviderClassname%>& rhs)
            throw();
   }; // End class

<%closeNamespace(servantProviderClassnameScope.withCppScope)%>

<%closeIfndefMacro("SERVANT_PROVIDER_"+servantProviderClassname)%>






<%script type="idlmm.OperationDef" name="generateOperation"%>
virtual PortableServer::ObjectId *<%cppName%>(<%parameters[mode == "PARAM_IN"].genParameterDef.sep(", ")%>)
    throw (
        <%for (exceptions){%>
        <%cppFullClassname%>,
        <%}%>
    ) = 0;     


<%script type="idlmm.InterfaceDef" name="genIncludeIdlStub"%>
<%-- for all operations, find return types which are ShareIDLType
     (this is to filter out PrimitiveDef for which no include are
     required), get IDL source filenames, remove duplicates (nMinimize)
     and include stub file corresponding to IDL file defining each type.
--%>
<%for (operations.type.filter("SharedIDLType").sourceFilename.nMinimize){%>
#include "<%current.replaceAll("[.]idl$", ".stub.hpp")%>"
<%}%>

   