<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.cdmw.codegenerator.lifecycle.LifeCycleServices
import com.thalesgroup.cdmw.codegenerator.lifecycle.ModelServices
import com.thalesgroup.cdmw.codegenerator.lifecycle.Utils
import com.thalesgroup.cdmw.codegenerator.lifecycle.cpp.Utils
import com.thalesgroup.ccm.codegenerator.corba.CommonServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.Utils
import com.thalesgroup.ccm.codegenerator.corba.cpp.CppMappingServices
import com.thalesgroup.ccm.codegenerator.container.Utils
%>


<%--
  -- Generation template  
  -- This template is not model-based (idlmm.Repository is just specified
  -- to access InterfaceDef data)
  -- All is based on LifeCycleServices which provides access to loaded data
  -- from XML file.
  --%>
<%script type="idlmm.Repository" name="UnmanagedEntityFactory_hpp" file="<%factoryHppFilePath%>"%>
<%copyrightHeader%>

<%openIfndefMacro("RESOURCES_"+factoryImplClassname)%>

#include <Foundation/orbsupport/CORBA.hpp>
#include <Foundation/common/Exception.hpp>

<%idlInterface.genIncludeSkelFile%>

#include <LifeCycle/idllib/CdmwLifeCycle.stub.hpp>
#include <LifeCycle/lifecycle/RetainObjectDeactivator.hpp>
#include <Foundation/orbsupport/POAThreadingPolicy.hpp>
#include <LifeCycle/lifecycle/FactoryAllocator.hpp>
#include <Foundation/orbsupport/RefCountServantBase.hpp>

#include <string>

<%openNamespace(servantProviderClassnameScope.withCppScope)%>

    // Forward declarations
    class <%servantProviderClassname%>;

<%closeNamespace(servantProviderClassnameScope.withCppScope)%>


<%openNamespace(factoryImplClassnameScope.withCppScope)%>

    class <%factoryImplClassname%> :
        public virtual POA_<%idlInterface.cppFullClassname.noColonPrefix%>,
        public virtual Cdmw::OrbSupport::RefCountServantBase
    {

        public:
            <%factoryImplClassname%>
                (CORBA::ORB_ptr                           orb,
                 PortableServer::POA_ptr                  parent,
                 CdmwLifeCycle::ObjectRegistration_ptr    name_domain,
                 const std::string &                      name_domain_name,
                 const std::string &                      factory_name,
                 Cdmw::OrbSupport::POAThreadingPolicy &   threading_policy,
                 int & argc, char** argv)
                throw(Cdmw::OutOfMemoryException,
                      Cdmw::BadParameterException,
                      Cdmw::InternalErrorException,
                      CORBA::SystemException);

            virtual
            ~<%factoryImplClassname%> ()
                throw();

            virtual PortableServer::POA_ptr _default_POA() {
                return PortableServer::POA::_duplicate(m_poa.in());
            }

            <%--
                Create the operation declarations.
            --%>
            <%for (idlInterface.findAllFactoryOperations){%>
            <%generateOperation%>
    
            <%}%>

            //
            // IDL:thalesgroup.com/CdmwLifeCycle/FactoryBase/supports:1.0
            //
            virtual CORBA::Boolean supports(const char* repository_id)
                throw(CORBA::SystemException);

            //
            // IDL:thalesgroup.com/CdmwLifeCycle/FactoryBase/get_supported_objects:1.0
            //
            virtual CdmwLifeCycle::RepositoryIdSeq* get_supported_objects()
                throw(CORBA::SystemException);

        protected:
            <%factoryImplClassname%> ()
                throw(CORBA::SystemException);

        private:
            // Register (name,object) within the repository. The name has already been
            // registered, so this should succeed. In case of a TRANSIENT system exception
            // There will be a retry max_retries times. if max_retries == 0, then this will do
            // retry forever.
            void
            register_object
                (CORBA::Object_ptr                                           the_object,
                 const char*                                                 object_name,
                 signed long                                                 max_retries)
                throw(CdmwLifeCycle::AlreadyExistant,
                      CdmwLifeCycle::InvalidName,
                      CORBA::SystemException);

            // Hide copy constructor/assignment operator
            <%factoryImplClassname%> (const <%factoryImplClassname%> & rhs)
                throw();

            <%factoryImplClassname%> &
            operator=(const <%factoryImplClassname%> & rhs)
                throw();

            /**
             * [Attribute description]
             */
            CORBA::ORB_var                            m_orb;
            PortableServer::POA_var                   m_poa;
            PortableServer::POA_var                   m_objects_poa;
            CdmwLifeCycle::ObjectRegistration_var     m_domain;
            std::string                               m_domain_name;
            std::string                               m_factory_name;
            Cdmw::LifeCycle::RetainObjectDeactivator  m_object_deactivator;
    
            <%servantProviderFullClassname%>* m_servant_provider;

   }; // End class <%factoryImplClassname%>

<%closeNamespace(factoryImplClassnameScope.withCppScope)%>

<%closeIfndefMacro("RESOURCES_"+factoryImplClassname)%>



<%script type="idlmm.OperationDef" name="generateOperation"%>
<%checkCdmwLifeCycleKeyParameterForNamedFactory%>
<%type.asReturnParameterDef%> <%name%>(<%parameters[mode == "PARAM_IN"].genParameterDef.sep(", ")%>)
throw ( 
       <%for (exceptions){%>
       <%cppFullClassname%>,
       <%}%>
       CORBA::SystemException
      );



