/*
 * Copyright (c) 2005-2008 Obeo.
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */

package fr.obeo.acceleo.gen.phantom;

import java.util.Map;

import org.acceleo.tools.strings.Int2;

/**
 * An element that can be synchronized.
 * 
 * @author www.obeo.fr
 * 
 */
public interface SyncElement {

	/**
	 * Correspondences between the input and the output.
	 * 
	 * @return correspondences between the input and the output
	 */
	Map<String, Int2[]> inOutMapping();

	/**
	 * Correspondences between the template element and the output.
	 * 
	 * @return correspondences between the template element and the output
	 */
	Map<String, Int2[]> templateOutMapping();

	/**
	 * Correspondences between the output and the input.
	 * 
	 * @return correspondences between the output and the input
	 */
	Map<Int2, String> outInMapping();

	/**
	 * Correspondences between the output and the template element.
	 * 
	 * @return correspondences between the output and the template element
	 */
	Map<Int2, String> outTemplateMapping();

	/**
	 * The content of this element.
	 * 
	 * @return the content of this element
	 */
	Object getContent();

}
