/*
 * Copyright (c) 2005-2008 Obeo.
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */
package fr.obeo.acceleo.gen.template.eval;

import org.eclipse.emf.common.util.Monitor;

/**
 * This is the interface to implement to manage launcher.
 * 
 * @author <a href="mailto:yvan.lussaud@obeo.fr">Yvan Lussaud</a>
 * 
 */
public interface ILauncherManager {

	/**
	 * The mode in which to launch : RUN_MODE.
	 */
	int RUN_MODE = 1;

	/**
	 * The mode in which to launch : DEBUG_MODE.
	 */
	int DEBUG_MODE = 2;

	/**
	 * The mode in which to launch : PREVIEW_MODE.
	 */
	int PREVIEW_MODE = 3;

	/**
	 * The mode in which to launch : PHANTOM_MODE.
	 */
	int PHANTOM_MODE = 4;

	/**
	 * The mode in which to launch.
	 * 
	 * @return the mode in which to launch
	 */
	int getMode();

	/**
	 * Is the synchronization activated or not?
	 * 
	 * @return true if the text/model synchronization is activated
	 */
	boolean isSynchronize();

	/**
	 * Activate the synchronization or not.
	 * 
	 * @param synchronize
	 *            indicates if the text/model synchronization is activated
	 */
	void setSynchronize(boolean synchronize);

	/**
	 * @return the monitor
	 */
	public Monitor getMonitor();

	/**
	 * @param monitor
	 *            is the monitor to set
	 */
	public void setMonitor(Monitor monitor);
}