/*
 * Copyright (c) 2008 Obeo.
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */

package org.acceleo.engine.eval.imports.services;

import fr.obeo.acceleo.gen.template.eval.ENode;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

import org.acceleo.tools.resources.Resources;
import org.eclipse.core.runtime.Platform;
import org.eclipse.emf.common.EMFPlugin;

/**
 * Eclipse resource services.
 * 
 * @author www.obeo.fr
 * 
 */
public final class ResourceServices implements IThreadSafeService {

	/**
	 * Returns the content of the given file.
	 * 
	 * @param node
	 *            is the current node
	 * @param path
	 *            is the path of the file
	 * @return the content of the file, or an empty buffer if the file doesn't
	 *         exist
	 */
	public String getFileContent(ENode node, String path) {
		// TODO merge with Resources.getFileContent()
		String ret = ""; //$NON-NLS-1$
		File file = new File(path);
		// if Eclipse running, Eclipse relative path is tried
		if (!file.exists() && EMFPlugin.IS_ECLIPSE_RUNNING) {
			file = new File(Platform.getLocation() + path);
		} else {
			return Resources.getFileContent(path);
		}
		if (file.exists()) {
			FileInputStream inputStream;
			try {
				inputStream = new FileInputStream(file);
				final byte[] buffer = new byte[inputStream.available()];
				inputStream.read(buffer);
				ret = new String(buffer);
			} catch (final FileNotFoundException e) {
				//
			} catch (final IOException e) {
				//
			}
		}
		return ret;
	}
}
