/*
 * Copyright (c) 2008 Obeo.
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */
package org.acceleo.engine.template.core.impl.spec;

import org.acceleo.template.core.FilePath;
import org.acceleo.template.core.Script;
import org.acceleo.template.core.Service;
import org.acceleo.template.core.Template;
import org.acceleo.template.core.impl.CoreFactoryImpl;

/**
 * Specific implementation of the factory.
 * 
 * @author Yvan LUSSAUD <a
 *         href="mailto:yvan.lussaud@obeo.fr">yvan.lussaud@obeo.fr</a>
 * 
 */
public class TCoreFactory extends CoreFactoryImpl {

	/**
	 * Constructor.
	 */
	public TCoreFactory() {
		super();
	}

	/**
	 * {@inheritDoc}
	 */
	public Template createTemplate() {
		return new TTemplate();
	}

	/**
	 * {@inheritDoc}
	 */
	public Script createScript() {
		return new TScript();
	}

	/**
	 * {@inheritDoc}
	 */
	public FilePath createFilePath() {
		return new TFilePath();
	}

	/**
	 * {@inheritDoc}
	 */
	public Service createService() {
		return new TService();
	}
} // TCoreFactory
