/*
 * Copyright (c) 2008 Obeo.
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */
package org.acceleo.engine.template.expressions.impl.spec;

import fr.obeo.acceleo.gen.template.eval.ENode;

import org.acceleo.engine.context.EvalContext;
import org.acceleo.engine.template.impl.spec.IEvaluable;
import org.acceleo.template.expressions.impl.BooleanLiteralImpl;
import org.acceleo.tools.template.TemplateConstants;

/**
 * A representation of the model object '<em><b>Boolean Literal</b></em>'.
 * 
 * @author <a href="mailto:yvan.lussaud@obeo.fr">Yvan Lussaud</a>
 * 
 */
public class TBooleanLiteral extends BooleanLiteralImpl implements IEvaluable {

	/**
	 * {@inheritDoc}
	 */
	public ENode gen(ENode root, EvalContext evalContext) {
		return new ENode(value, root);
	}

	/**
	 * {@inheritDoc}
	 */
	public String toString() {
		if (value) {
			return TemplateConstants.LITERAL_TRUE;
		} else {
			return TemplateConstants.LITERAL_FALSE;
		}
	}
}
