/*
 * Copyright (c) 2008 Obeo.
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */
package org.acceleo.engine.template.expressions.impl.spec;

import fr.obeo.acceleo.gen.template.eval.ENode;
import fr.obeo.acceleo.gen.template.eval.ENodeException;

import java.util.Iterator;

import org.acceleo.engine.context.EvalContext;
import org.acceleo.engine.template.impl.spec.IEvaluable;
import org.acceleo.template.expressions.Call;
import org.acceleo.template.expressions.impl.CallSetImpl;
import org.acceleo.tools.factory.FactoryException;
import org.acceleo.tools.template.TemplateConstants;

/**
 * A representation of the model object '<em><b>Call Set</b></em>'.
 * 
 * @author <a href="mailto:yvan.lussaud@obeo.fr">Yvan Lussaud</a>
 * 
 */
public class TCallSet extends CallSetImpl implements IEvaluable {

	/**
	 * {@inheritDoc}
	 */
	public ENode gen(ENode root, EvalContext evalContext) throws ENodeException, FactoryException {
		ENode current = root;
		for (Call call : getCalls()) {
			current = ((IEvaluable) call).gen(current, evalContext);
		}
		return current;
	}

	/**
	 * {@inheritDoc}
	 */
	public String toString() {
		StringBuffer buffer = new StringBuffer(""); //$NON-NLS-1$
		Iterator<Call> calls = this.calls.iterator();
		while (calls.hasNext()) {
			Call call = calls.next();
			buffer.append(call.toString());
			if (calls.hasNext()) {
				buffer.append(TemplateConstants.CALL_SEP);
			}
		}
		return buffer.toString();
	}
}
