/*
 * Copyright (c) 2008 Obeo.
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */
package org.acceleo.engine.template.expressions.impl.spec;

import org.acceleo.template.expressions.BooleanLiteral;
import org.acceleo.template.expressions.Call;
import org.acceleo.template.expressions.CallSet;
import org.acceleo.template.expressions.DoubleLiteral;
import org.acceleo.template.expressions.IntegerLiteral;
import org.acceleo.template.expressions.Not;
import org.acceleo.template.expressions.NullLiteral;
import org.acceleo.template.expressions.Operator;
import org.acceleo.template.expressions.Parenthesis;
import org.acceleo.template.expressions.StringLiteral;
import org.acceleo.template.expressions.impl.ExpressionsFactoryImpl;

/**
 * Specific implementation of the factory.
 * 
 * @author Yvan LUSSAUD <a
 *         href="mailto:yvan.lussaud@obeo.fr">yvan.lussaud@obeo.fr</a>
 * 
 */
public class TExpressionsFactory extends ExpressionsFactoryImpl {

	/**
	 * Constructor.
	 */
	public TExpressionsFactory() {
		super();
	}

	/**
	 * {@inheritDoc}
	 */
	public CallSet createCallSet() {
		return new TCallSet();
	}

	/**
	 * {@inheritDoc}
	 */
	public Call createCall() {
		return new TCall();
	}

	/**
	 * {@inheritDoc}
	 */
	public Not createNot() {
		return new TNot();
	}

	/**
	 * {@inheritDoc}
	 */
	public Operator createOperator() {
		return new TOperator();
	}

	/**
	 * {@inheritDoc}
	 */
	public Parenthesis createParenthesis() {
		return new TParenthesis();
	}

	/**
	 * {@inheritDoc}
	 */
	public StringLiteral createStringLiteral() {
		return new TStringLiteral();
	}

	/**
	 * {@inheritDoc}
	 */
	public IntegerLiteral createIntegerLiteral() {
		return new TIntegerLiteral();
	}

	/**
	 * {@inheritDoc}
	 */
	public DoubleLiteral createDoubleLiteral() {
		return new TDoubleLiteral();
	}

	/**
	 * {@inheritDoc}
	 */
	public BooleanLiteral createBooleanLiteral() {
		return new TBooleanLiteral();
	}

	/**
	 * {@inheritDoc}
	 */
	public NullLiteral createNullLiteral() {
		return new TNullLiteral();
	}
} // TExpressionsFactory
