/*
 * Copyright (c) 2008 Obeo.
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */
package org.acceleo.engine.template.expressions.impl.spec;

import fr.obeo.acceleo.gen.template.eval.ENode;

import org.acceleo.engine.context.EvalContext;
import org.acceleo.engine.template.impl.spec.IEvaluable;
import org.acceleo.template.expressions.impl.NullLiteralImpl;
import org.acceleo.tools.template.TemplateConstants;

/**
 * A representation of the model object '<em><b>Null Literal</b></em>'.
 * 
 * @author Yvan LUSSAUD <a href="mailto:yvan.lussaud@obeo.fr">Yvan Lussaud</a>
 * 
 */
public class TNullLiteral extends NullLiteralImpl implements IEvaluable {

	/**
	 * {@inheritDoc}
	 */
	public ENode gen(ENode root, EvalContext evalContext) {
		return new ENode(ENode.EMPTY, root);
	}

	/**
	 * {@inheritDoc}
	 */
	public String toString() {
		return TemplateConstants.LITERAL_NULL;
	}
}
