/*
 * Copyright (c) 2008 Obeo.
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */
package org.acceleo.engine.template.impl.spec;

import fr.obeo.acceleo.gen.template.eval.ENode;
import fr.obeo.acceleo.gen.template.eval.ENodeException;

import org.acceleo.engine.context.EvalContext;
import org.acceleo.template.core.ASTNode;
import org.acceleo.tools.factory.FactoryException;

/**
 * Implement this interface to create an object that can generate text in
 * Acceleo.
 * 
 * @author <a href="mailto:yvan.lussaud@obeo.fr">Yvan Lussaud</a>
 * 
 */
public interface IEvaluable extends ASTNode {

	/**
	 * Create a new ENode with the interpreted value.
	 * 
	 * @param root
	 *            Current ENode
	 * @param evalContext
	 *            Current evaluation context
	 * @return a new ENode with the interpreted value
	 * @throws ENodeException
	 *             depends on the implementation.
	 * @throws FactoryException
	 *             depends on the implementation.
	 */
	ENode gen(ENode root, EvalContext evalContext) throws ENodeException, FactoryException;

}
