/*
 * Copyright (c) 2008 Obeo.
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */
package org.acceleo.engine.template.statements.impl.spec;

import fr.obeo.acceleo.gen.template.eval.ENode;
import fr.obeo.acceleo.gen.template.eval.ENodeCastException;

import org.acceleo.engine.context.EvalContext;
import org.acceleo.engine.template.impl.spec.IEvaluable;
import org.acceleo.template.statements.impl.CommentImpl;
import org.acceleo.tools.template.TemplateConstants;
import org.eclipse.emf.ecore.EObject;

/**
 * A representation of the model object '<em><b>Comment</b></em>'.
 * 
 * @author <a href="mailto:yvan.lussaud@obeo.fr">Yvan Lussaud</a>
 * 
 */
public class TComment extends CommentImpl implements IEvaluable {

	/**
	 * {@inheritDoc}
	 */
	public ENode gen(ENode root, EvalContext evalContext) {
		EObject eObj;
		try {
			eObj = root.getEObject();
		} catch (ENodeCastException e) {
			eObj = ENode.EMPTY;
		}

		return new ENode(ENode.EMPTY, eObj, this, evalContext.getLaunchManager().isSynchronize());
	}

	/**
	 * {@inheritDoc}
	 */
	public String toString() {
		return TemplateConstants.COMMENT_BEGIN + value + TemplateConstants.COMMENT_END;
	}
}
