/*
 * Copyright (c) 2008 Obeo.
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */
package org.acceleo.engine.template.statements.impl.spec;

import fr.obeo.acceleo.gen.template.eval.ENode;
import fr.obeo.acceleo.gen.template.eval.ENodeCastException;
import fr.obeo.acceleo.gen.template.eval.ENodeException;

import org.acceleo.engine.context.EvalContext;
import org.acceleo.engine.template.core.impl.spec.TTemplate;
import org.acceleo.engine.template.impl.spec.IEvaluable;
import org.acceleo.template.statements.impl.FeatureImpl;
import org.acceleo.tools.factory.FactoryException;
import org.acceleo.tools.template.TemplateConstants;
import org.eclipse.emf.ecore.EObject;

/**
 * A representation of the model object '<em><b>Feature</b></em>'.
 * 
 * @author <a href="mailto:yvan.lussaud@obeo.fr">Yvan Lussaud</a>
 * 
 */
public class TFeature extends FeatureImpl implements IEvaluable {

	/**
	 * {@inheritDoc}
	 */
	public ENode gen(ENode root, EvalContext evalContext) throws ENodeException, FactoryException {
		EObject eObj;
		try {
			eObj = root.getEObject();
		} catch (final ENodeCastException e) {
			eObj = ENode.EMPTY;
		}
		final ENode current = new ENode(eObj, this, evalContext.getLaunchManager().isSynchronize());
		evalContext.contextPush(TTemplate.CURRENT_NODE, current);
		try {
			final ENode node = ((IEvaluable) expression).gen(current, evalContext);
			return node;
		} finally {
			evalContext.contextPop(TTemplate.CURRENT_NODE);
		}
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public String toString() {
		return TemplateConstants.FEATURE_BEGIN + expression.toString() + TemplateConstants.FEATURE_END;
	}
}
