/*
 * Copyright (c) 2008 Obeo.
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */
package org.acceleo.engine.template.statements.impl.spec;

import org.acceleo.template.statements.Comment;
import org.acceleo.template.statements.Feature;
import org.acceleo.template.statements.For;
import org.acceleo.template.statements.If;
import org.acceleo.template.statements.Text;
import org.acceleo.template.statements.impl.StatementsFactoryImpl;

/**
 * Specific implementation of the factory.
 * 
 * @author Yvan LUSSAUD <a
 *         href="mailto:yvan.lussaud@obeo.fr">yvan.lussaud@obeo.fr</a>
 * 
 */
public class TStatementsFactory extends StatementsFactoryImpl {

	/**
	 * Constructor.
	 */
	public TStatementsFactory() {
		super();
	}

	/**
	 * {@inheritDoc}
	 */
	public Comment createComment() {
		return new TComment();
	}

	/**
	 * {@inheritDoc}
	 */
	public If createIf() {
		return new TIf();
	}

	/**
	 * {@inheritDoc}
	 */
	public For createFor() {
		return new TFor();
	}

	/**
	 * {@inheritDoc}
	 */
	public Feature createFeature() {
		return new TFeature();
	}

	/**
	 * {@inheritDoc}
	 */
	public Text createText() {
		return new TText();
	}
} // TStatementsFactory
