/*
 * Copyright (c) 2008 Obeo.
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */
package org.acceleo.engine.template.statements.impl.spec;

import fr.obeo.acceleo.gen.template.eval.ENode;
import fr.obeo.acceleo.gen.template.eval.ENodeCastException;
import fr.obeo.acceleo.gen.template.eval.TextModelMapping;

import org.acceleo.engine.context.EvalContext;
import org.acceleo.engine.template.impl.spec.IEvaluable;
import org.acceleo.template.statements.impl.TextImpl;
import org.eclipse.emf.ecore.EObject;

/**
 * A representation of the model object '<em><b>Text</b></em>'.
 * 
 * @author <a href="mailto:yvan.lussaud@obeo.fr">Yvan Lussaud</a>
 * 
 */
public class TText extends TextImpl implements IEvaluable {

	/**
	 * {@inheritDoc}
	 */
	public ENode gen(ENode root, EvalContext evalContext) {
		EObject eObj;
		try {
			eObj = root.getEObject();
		} catch (final ENodeCastException e) {
			eObj = ENode.EMPTY;
		}
		final ENode node = new ENode(ENode.EMPTY, eObj, this, evalContext.getLaunchManager().isSynchronize());
		node.append(value, TextModelMapping.HIGHLIGHTED_STATIC_TEXT);
		return node;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public String toString() {
		return value;
	}
}
