/*
 * Copyright (c) 2005-2008 Obeo.
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */

package org.acceleo.gen.extension.chain;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

/**
 * The default post generation action.
 * 
 * @author www.obeo.fr
 * 
 */
public class DefaultPostGeneration implements IPostGeneration {

	/**
	 * Priority of the post generation action.
	 */
	private int priority;

	public int getPriority() {
		return priority;
	}

	/**
	 * Post file generation.
	 * 
	 * @param path
	 *            File path
	 * @param content
	 *            Content
	 * @exception IOException
	 *                If an I/O error occurs
	 */
	public void postFileGeneration(String path, StringBuffer content) throws IOException {
		File outDir = new File(path.substring(0, path.lastIndexOf(File.separatorChar)));
		File outFile = new File(path);
		outDir.mkdirs();

		FileWriter f = new FileWriter(outFile);
		BufferedWriter out = new BufferedWriter(f);
		out.write(content.toString());
		out.close();
	}

	public void setPriority(int priority) {
		this.priority = priority;
	}

}
