/*
 * Copyright (c) 2005-2008 Obeo.
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */

package org.acceleo.gen.extension.chain;

import java.io.IOException;

/**
 * A post generation action.
 * 
 * @author www.obeo.fr
 */
public interface IPostGeneration {

	/**
	 * This method is called at the end of each file generation, when we have to
	 * create a new file.
	 * 
	 * @param path
	 *            is the path of the file to create
	 * @param content
	 *            is the content of the file to create
	 * @throws IOException
	 *             If an I/O error occurs
	 */
	// TODO progress monitor
	void postFileGeneration(String path, StringBuffer content) throws IOException;

	/**
	 * Returns the priority of the post generation action.
	 * 
	 * @return the priority of the post generation action
	 */
	int getPriority();

	/**
	 * Set the priority of the post generation action.
	 * 
	 * @param priority
	 *            the priority
	 */
	void setPriority(int priority);

	/**
	 * This method is called at the end of a CGenerate action.
	 * 
	 * @param monitor
	 *            is the monitor
	 */
	// public void postProcessing(IProgressMonitor monitor);
}
