/*
 * Copyright (c) 2005-2008 Obeo.
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */

package org.acceleo.gen.extension.vm;

import org.acceleo.template.Resource;
import org.acceleo.template.ResourceSet;
import org.acceleo.template.core.Template;

import java.util.ArrayList;
import java.util.List;

/**
 * A script loader that converts the script's content before loading. The
 * default implementation returns the initial content.
 * 
 * @author www.obeo.fr
 * 
 */
public class DefaultTemplateLoader implements ITemplateLoader {

	/**
	 * {@inheritDoc}
	 */
	public String load(String content) {
		return content;
	}

	/**
	 * {@inheritDoc}
	 */
	public Template[] goToSpecifics(Template template) {
		List<Template> specifics = new ArrayList<Template>();
		List<Resource> resources = ((ResourceSet) template.eContainer()).getResources();

		for (int i = 0; i < resources.indexOf(this); ++i) {
			if (resources.get(i) instanceof Template) {
				specifics.add((Template) resources.get(i));
			}
		}
		return specifics.toArray(new Template[specifics.size()]);
	}

}
