/*
 * Copyright (c) 2005-2008 Obeo.
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */

package org.acceleo.gen.extension.vm;

import org.acceleo.template.core.Template;

/**
 * A script loader that converts the script's content before loading.
 * 
 * @author www.obeo.fr
 * 
 */
public interface ITemplateLoader {

	/**
	 * The method to convert the script's content.
	 * 
	 * @param content
	 *            is the content to convert
	 * @return the converted string
	 */
	String load(String content);

	/**
	 * Gets the templates of the specific strategy.
	 * 
	 * @param script
	 *            is the current template
	 * @return templates of the specific strategy
	 */
	Template[] goToSpecifics(Template script);

}
