/*
 * Copyright (c) 2005-2008 Obeo.
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */
package org.acceleo.parser.template;

import org.acceleo.template.core.ASTNode;
import org.acceleo.template.core.Template;

import org.acceleo.tools.strings.Int2;

/**
 * Extends this class to create an object that parse ASTNode objects.
 * 
 * @author <a href="mailto:yvan.lussaud@obeo.fr">Yvan Lussaud</a>
 */
public abstract class AbstractParser {
	/**
	 * No public access to the constructor.
	 */
	protected AbstractParser() {

	}

	/**
	 * Parse the given buffer to create a new instance of ASTNode.
	 * 
	 * @param offset
	 *            offset to add to the ASTNode position
	 * @param buffer
	 *            the buffer to parse
	 * @param range
	 *            range of the buffer that should be parsed
	 * @param template
	 *            the owning template if any
	 * @return the parsed instance of ASTNode
	 * @throws TemplateSyntaxException
	 *             if the element can't be parsed
	 */
	public static ASTNode fromString(int offset, String buffer, Int2 range, Template template) throws TemplateSyntaxException {
		return null;
	}
}
