/*
 * Copyright (c) 2005-2008 Obeo.
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */
package org.acceleo.parser.template.statements;

import org.acceleo.template.core.Template;
import org.acceleo.template.statements.Comment;
import org.acceleo.template.statements.StatementsFactory;

import org.acceleo.parser.template.TemplateSyntaxException;
import org.acceleo.tools.strings.Int2;

/**
 * Acceleo Text parser.
 * 
 * @author <a href="mailto:yvan.lussaud@obeo.fr">Yvan Lussaud</a>
 */
public class CommentParser extends StatementParser {

	/**
	 * {@inheritDoc}
	 */
	public static Comment fromString(int offset, String buffer, Int2 range, Template template) throws TemplateSyntaxException {
		Comment comment = StatementsFactory.eINSTANCE.createComment();
		comment.setValue(buffer.substring(range.b(), range.e()));
		comment.setBegin(offset + range.b());
		comment.setEnd(offset + range.e());
		return comment;
	}
}
