/*
 * Copyright (c) 2005-2008 Obeo.
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */

package org.acceleo.tools.log;

import org.acceleo.tools.AcceleoToolsMessages;

/**
 * Template evaluation failures.
 * 
 * @author www.obeo.fr
 * 
 */
// TODO revoir la gestion des logs
public class EvalFailure implements IFailure {

	/**
	 * Failure message.
	 */
	protected String message;

	/**
	 * Position in the generated text.
	 */
	protected int position;

	/**
	 * Constructor.
	 * 
	 * @param message
	 *            is the failure message
	 */
	public EvalFailure(String message) {
		this.message = message;
	}

	/**
	 * {@inheritDoc}
	 */
	public String getMessage() {
		return AcceleoToolsMessages.getString("EvalFailure.FailureMessage", new Object[] { message, }); //$NON-NLS-1$
	}

	/**
	 * Getter on position attribute.
	 * 
	 * @return the position
	 */
	public int position() {
		return position;
	}

	/**
	 * {@inheritDoc}
	 */
	public String toString() {
		return AcceleoToolsMessages.getString("EvalFailure.FailurePosition", new Object[] { Integer.toString(position()), }) + " : " + getMessage(); //$NON-NLS-1$ //$NON-NLS-2$
	}

}
