/**
 * <copyright> </copyright>
 * 
 * $Id: IdlmmPackageImpl.java,v 1.118 2009/09/04 09:24:29 je Exp $
 */
package com.prismtech.idt.idlmm.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.impl.EPackageImpl;

import com.prismtech.idt.idlmm.AddOperator;
import com.prismtech.idt.idlmm.AliasContainer;
import com.prismtech.idt.idlmm.AliasDef;
import com.prismtech.idt.idlmm.ArrayDef;
import com.prismtech.idt.idlmm.AttributeContainer;
import com.prismtech.idt.idlmm.AttributeDef;
import com.prismtech.idt.idlmm.AttributeMode;
import com.prismtech.idt.idlmm.BinaryOperator;
import com.prismtech.idt.idlmm.BitwiseAndOperator;
import com.prismtech.idt.idlmm.BitwiseComplementOperator;
import com.prismtech.idt.idlmm.BitwiseLeftShiftOperator;
import com.prismtech.idt.idlmm.BitwiseOrOperator;
import com.prismtech.idt.idlmm.BitwiseRightShiftOperator;
import com.prismtech.idt.idlmm.BitwiseXorOperator;
import com.prismtech.idt.idlmm.BooleanLiteral;
import com.prismtech.idt.idlmm.CharacterLiteral;
import com.prismtech.idt.idlmm.Component;
import com.prismtech.idt.idlmm.ComponentContained;
import com.prismtech.idt.idlmm.ComponentDecl;
import com.prismtech.idt.idlmm.ComponentDef;
import com.prismtech.idt.idlmm.ComponentPortDef;
import com.prismtech.idt.idlmm.ConstantContainer;
import com.prismtech.idt.idlmm.ConstantDef;
import com.prismtech.idt.idlmm.ConsumesDef;
import com.prismtech.idt.idlmm.Contained;
import com.prismtech.idt.idlmm.Container;
import com.prismtech.idt.idlmm.DivideOperator;
import com.prismtech.idt.idlmm.EmitsDef;
import com.prismtech.idt.idlmm.EnumContained;
import com.prismtech.idt.idlmm.EnumContainer;
import com.prismtech.idt.idlmm.EnumDef;
import com.prismtech.idt.idlmm.EnumMember;
import com.prismtech.idt.idlmm.Event;
import com.prismtech.idt.idlmm.EventDecl;
import com.prismtech.idt.idlmm.EventDef;
import com.prismtech.idt.idlmm.EventPortDef;
import com.prismtech.idt.idlmm.ExceptionContained;
import com.prismtech.idt.idlmm.ExceptionContainer;
import com.prismtech.idt.idlmm.ExceptionDef;
import com.prismtech.idt.idlmm.ExceptionMember;
import com.prismtech.idt.idlmm.Expression;
import com.prismtech.idt.idlmm.ExpressionContext;
import com.prismtech.idt.idlmm.FactoryOperation;
import com.prismtech.idt.idlmm.FinderOperation;
import com.prismtech.idt.idlmm.FixedDef;
import com.prismtech.idt.idlmm.FixedPointLiteral;
import com.prismtech.idt.idlmm.FloatingPointLiteral;
import com.prismtech.idt.idlmm.Home;
import com.prismtech.idt.idlmm.HomeContained;
import com.prismtech.idt.idlmm.HomeDef;
import com.prismtech.idt.idlmm.IDLType;
import com.prismtech.idt.idlmm.IRObject;
import com.prismtech.idt.idlmm.IdlmmFactory;
import com.prismtech.idt.idlmm.IdlmmPackage;
import com.prismtech.idt.idlmm.Initializer;
import com.prismtech.idt.idlmm.InitializerParameterDef;
import com.prismtech.idt.idlmm.IntegerLiteral;
import com.prismtech.idt.idlmm.Interface;
import com.prismtech.idt.idlmm.InterfaceContained;
import com.prismtech.idt.idlmm.InterfaceDecl;
import com.prismtech.idt.idlmm.InterfaceDef;
import com.prismtech.idt.idlmm.InterfaceModifier;
import com.prismtech.idt.idlmm.InterfacePortDef;
import com.prismtech.idt.idlmm.Literal;
import com.prismtech.idt.idlmm.Member;
import com.prismtech.idt.idlmm.ModuleContained;
import com.prismtech.idt.idlmm.ModuleDef;
import com.prismtech.idt.idlmm.ModuloOperator;
import com.prismtech.idt.idlmm.MultiplyOperator;
import com.prismtech.idt.idlmm.Named;
import com.prismtech.idt.idlmm.NativeContainer;
import com.prismtech.idt.idlmm.NativeDef;
import com.prismtech.idt.idlmm.NegativeOperator;
import com.prismtech.idt.idlmm.OperationContainer;
import com.prismtech.idt.idlmm.OperationDef;
import com.prismtech.idt.idlmm.OperationMode;
import com.prismtech.idt.idlmm.Operator;
import com.prismtech.idt.idlmm.OwnedExpression;
import com.prismtech.idt.idlmm.OwnedIDLType;
import com.prismtech.idt.idlmm.ParameterDef;
import com.prismtech.idt.idlmm.ParameterMode;
import com.prismtech.idt.idlmm.PositiveOperator;
import com.prismtech.idt.idlmm.PostPragma;
import com.prismtech.idt.idlmm.Pragma;
import com.prismtech.idt.idlmm.PrePragma;
import com.prismtech.idt.idlmm.PrimitiveDef;
import com.prismtech.idt.idlmm.PrimitiveKind;
import com.prismtech.idt.idlmm.ProvidesDef;
import com.prismtech.idt.idlmm.PublishesDef;
import com.prismtech.idt.idlmm.Repository;
import com.prismtech.idt.idlmm.RepositoryContained;
import com.prismtech.idt.idlmm.ScopePragma;
import com.prismtech.idt.idlmm.SequenceDef;
import com.prismtech.idt.idlmm.SharedExpression;
import com.prismtech.idt.idlmm.SharedIDLType;
import com.prismtech.idt.idlmm.StringDef;
import com.prismtech.idt.idlmm.StringLiteral;
import com.prismtech.idt.idlmm.StructContained;
import com.prismtech.idt.idlmm.StructContainer;
import com.prismtech.idt.idlmm.StructDef;
import com.prismtech.idt.idlmm.StructMember;
import com.prismtech.idt.idlmm.SubtractOperator;
import com.prismtech.idt.idlmm.Typed;
import com.prismtech.idt.idlmm.TypedefDef;
import com.prismtech.idt.idlmm.UnaryOperator;
import com.prismtech.idt.idlmm.UnionContained;
import com.prismtech.idt.idlmm.UnionContainer;
import com.prismtech.idt.idlmm.UnionDef;
import com.prismtech.idt.idlmm.UnionMember;
import com.prismtech.idt.idlmm.UsesDef;
import com.prismtech.idt.idlmm.UsesMode;
import com.prismtech.idt.idlmm.Value;
import com.prismtech.idt.idlmm.ValueBoxDef;
import com.prismtech.idt.idlmm.ValueContained;
import com.prismtech.idt.idlmm.ValueDecl;
import com.prismtech.idt.idlmm.ValueDef;
import com.prismtech.idt.idlmm.ValueMemberDef;
import com.prismtech.idt.idlmm.Visibility;
import com.prismtech.idt.idlmm.WCharacterLiteral;
import com.prismtech.idt.idlmm.WStringDef;
import com.prismtech.idt.idlmm.WStringLiteral;


/**
 * <!-- begin-user-doc --> An implementation of the model <b>Package</b>. <!--
 * end-user-doc -->
 * @generated
 */
public class IdlmmPackageImpl extends EPackageImpl implements IdlmmPackage
{
   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass moduleDefEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass containerEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass irObjectEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass containedEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass repositoryEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass stringDefEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass idlTypeEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass typedefDefEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass aliasDefEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass primitiveDefEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass pragmaEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass wStringDefEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass sequenceDefEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass arrayDefEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass fixedDefEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass structDefEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass structMemberEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass interfaceDefEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass ownedIDLTypeEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass sharedIDLTypeEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass typedEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass unionDefEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass enumDefEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass constantDefEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass enumMemberEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass unionMemberEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass exceptionDefEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass attributeDefEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass parameterDefEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass operationDefEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass valueMemberDefEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass valueDefEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass initializerEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass valueBoxDefEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass nativeDefEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass namedEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass memberEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass exceptionMemberEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass repositoryContainedEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass moduleContainedEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass exceptionContainedEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass interfaceContainedEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass structContainedEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass unionContainedEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass valueContainedEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass sharedExpressionEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass ownedExpressionEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass expressionEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass operatorEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass literalEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass bitwiseComplementOperatorEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass bitwiseRightShiftOperatorEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass bitwiseLeftShiftOperatorEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass bitwiseAndOperatorEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass addOperatorEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass bitwiseXorOperatorEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass positiveOperatorEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass negativeOperatorEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass bitwiseOrOperatorEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass subtractOperatorEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass multiplyOperatorEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass binaryOperatorEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass moduloOperatorEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass unaryOperatorEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass divideOperatorEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass enumContainedEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass interfaceDeclEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass interfaceEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass prePragmaEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass postPragmaEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass scopePragmaEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass booleanLiteralEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass characterLiteralEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass fixedPointLiteralEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass floatingPointLiteralEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass integerLiteralEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass stringLiteralEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass wCharacterLiteralEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass wStringLiteralEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass expressionContextEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass valueEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass valueDeclEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EClass initializerParameterDefEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass componentEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass componentDefEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass componentDeclEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass componentContainedEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass componentPortDefEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass homeEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass homeDefEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass homeContainedEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass factoryOperationEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass finderOperationEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass interfacePortDefEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass eventPortDefEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass providesDefEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass usesDefEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass consumesDefEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass publishesDefEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass emitsDefEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass eventEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass eventDeclEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass eventDefEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass attributeContainerEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass operationContainerEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass constantContainerEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass aliasContainerEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass nativeContainerEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass unionContainerEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass structContainerEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass enumContainerEClass = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EClass exceptionContainerEClass = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EEnum primitiveKindEEnum = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EEnum attributeModeEEnum = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EEnum operationModeEEnum = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EEnum parameterModeEEnum = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EEnum visibilityEEnum = null;

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private EEnum interfaceModifierEEnum = null;

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   private EEnum usesModeEEnum = null;

   /**
    * Creates an instance of the model <b>Package</b>, registered with
    * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the
    * package package URI value.
    * <p>
    * Note: the correct way to create the package is via the static factory
    * method {@link #init init()}, which also performs initialization of the
    * package, or returns the registered package, if one already exists. <!--
    * begin-user-doc --> <!-- end-user-doc -->
    * 
    * @see org.eclipse.emf.ecore.EPackage.Registry
    * @see com.prismtech.idt.idlmm.IdlmmPackage#eNS_URI
    * @see #init()
    * @generated
    */
   private IdlmmPackageImpl ()
   {
      super (eNS_URI, IdlmmFactory.eINSTANCE);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private static boolean isInited = false;

   /**
    * Creates, registers, and initializes the <b>Package</b> for this
    * model, and for any others upon which it depends.  Simple
    * dependencies are satisfied by calling this method on all
    * dependent packages before doing anything else.  This method drives
    * initialization for interdependent packages directly, in parallel
    * with this package, itself.
    * <p>Of this package and its interdependencies, all packages which
    * have not yet been registered by their URI values are first created
    * and registered.  The packages are then initialized in two steps:
    * meta-model objects for all of the packages are created before any
    * are initialized, since one package's meta-model objects may refer to
    * those of another.
    * <p>Invocation of this method will not affect any packages that have
    * already been initialized.
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @see #eNS_URI
    * @see #createPackageContents()
    * @see #initializePackageContents()
    * @generated
    */
   public static IdlmmPackage init ()
   {
      if (isInited)
         return (IdlmmPackage) EPackage.Registry.INSTANCE.getEPackage (IdlmmPackage.eNS_URI);

      // Obtain or create and register package
      IdlmmPackageImpl theIdlmmPackage = (IdlmmPackageImpl) (EPackage.Registry.INSTANCE.getEPackage (eNS_URI) instanceof IdlmmPackageImpl ? EPackage.Registry.INSTANCE
            .getEPackage (eNS_URI)
            : new IdlmmPackageImpl ());

      isInited = true;

      // Create package meta-data objects
      theIdlmmPackage.createPackageContents ();

      // Initialize created meta-data
      theIdlmmPackage.initializePackageContents ();

      // Mark meta-data to indicate it can't be changed
      theIdlmmPackage.freeze ();

      return theIdlmmPackage;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getModuleDef ()
   {
      return moduleDefEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getModuleDef_ModuleContents ()
   {
      return (EReference) moduleDefEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getModuleDef_Interfaces ()
   {
      return (EReference) moduleDefEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getModuleDef_Modules ()
   {
      return (EReference) moduleDefEClass.getEStructuralFeatures ().get (2);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getModuleDef_ValueTypes ()
   {
      return (EReference) moduleDefEClass.getEStructuralFeatures ().get (3);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getContainer ()
   {
      return containerEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getContainer_Contents ()
   {
      return (EReference) containerEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getIRObject ()
   {
      return irObjectEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getIRObject_Pragmas ()
   {
      return (EReference) irObjectEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EAttribute getIRObject_Source ()
   {
      return (EAttribute) irObjectEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getIRObject_Repository ()
   {
      return (EReference) irObjectEClass.getEStructuralFeatures ().get (2);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getContained ()
   {
      return containedEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EAttribute getContained_AbsoluteName ()
   {
      return (EAttribute) containedEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getContained_Container ()
   {
      return (EReference) containedEClass.getEStructuralFeatures ().get (4);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EAttribute getContained_Prefix ()
   {
      return (EAttribute) containedEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EAttribute getContained_ID ()
   {
      return (EAttribute) containedEClass.getEStructuralFeatures ().get (2);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EAttribute getContained_Version ()
   {
      return (EAttribute) containedEClass.getEStructuralFeatures ().get (3);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getRepository ()
   {
      return repositoryEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getRepository_RepositoryContents ()
   {
      return (EReference) repositoryEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getRepository_Includes ()
   {
      return (EReference) repositoryEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getRepository_Enums ()
   {
      return (EReference) repositoryEClass.getEStructuralFeatures ().get (2);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getRepository_Aliases ()
   {
      return (EReference) repositoryEClass.getEStructuralFeatures ().get (3);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getRepository_Constants ()
   {
      return (EReference) repositoryEClass.getEStructuralFeatures ().get (4);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getRepository_Exceptions ()
   {
      return (EReference) repositoryEClass.getEStructuralFeatures ().get (5);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getRepository_Interfaces ()
   {
      return (EReference) repositoryEClass.getEStructuralFeatures ().get (6);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getRepository_Modules ()
   {
      return (EReference) repositoryEClass.getEStructuralFeatures ().get (7);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getRepository_Natives ()
   {
      return (EReference) repositoryEClass.getEStructuralFeatures ().get (8);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getRepository_Structs ()
   {
      return (EReference) repositoryEClass.getEStructuralFeatures ().get (9);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getRepository_Unions ()
   {
      return (EReference) repositoryEClass.getEStructuralFeatures ().get (10);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getRepository_ValueTypes ()
   {
      return (EReference) repositoryEClass.getEStructuralFeatures ().get (11);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getStringDef ()
   {
      return stringDefEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getStringDef_Bound ()
   {
      return (EReference) stringDefEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getStringDef_OwnedBound ()
   {
      return (EReference) stringDefEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getIDLType ()
   {
      return idlTypeEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getTypedefDef ()
   {
      return typedefDefEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getAliasDef ()
   {
      return aliasDefEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getPrimitiveDef ()
   {
      return primitiveDefEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EAttribute getPrimitiveDef_Kind ()
   {
      return (EAttribute) primitiveDefEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getPragma ()
   {
      return pragmaEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EAttribute getPragma_Text ()
   {
      return (EAttribute) pragmaEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getPragma_Owner ()
   {
      return (EReference) pragmaEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getPragma_Prerequisites ()
   {
      return (EReference) pragmaEClass.getEStructuralFeatures ().get (2);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getWStringDef ()
   {
      return wStringDefEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getWStringDef_OwnedBound ()
   {
      return (EReference) wStringDefEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getWStringDef_Bound ()
   {
      return (EReference) wStringDefEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getSequenceDef ()
   {
      return sequenceDefEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getSequenceDef_Bound ()
   {
      return (EReference) sequenceDefEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getSequenceDef_OwnedBound ()
   {
      return (EReference) sequenceDefEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getArrayDef ()
   {
      return arrayDefEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getArrayDef_OwnedLength ()
   {
      return (EReference) arrayDefEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getArrayDef_Length ()
   {
      return (EReference) arrayDefEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getFixedDef ()
   {
      return fixedDefEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getFixedDef_Scale ()
   {
      return (EReference) fixedDefEClass.getEStructuralFeatures ().get (2);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getFixedDef_OwnedScale ()
   {
      return (EReference) fixedDefEClass.getEStructuralFeatures ().get (3);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getFixedDef_Digits ()
   {
      return (EReference) fixedDefEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getFixedDef_OwnedDigits ()
   {
      return (EReference) fixedDefEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getStructDef ()
   {
      return structDefEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getStructDef_StructContents ()
   {
      return (EReference) structDefEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getStructDef_Members ()
   {
      return (EReference) structDefEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getStructMember ()
   {
      return structMemberEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getInterfaceDef ()
   {
      return interfaceDefEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getInterfaceDef_InterfaceContents ()
   {
      return (EReference) interfaceDefEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getInterfaceDef_BaseInterfaces ()
   {
      return (EReference) interfaceDefEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getInterfaceDef_AllBaseInterfaces ()
   {
      return (EReference) interfaceDefEClass.getEStructuralFeatures ().get (2);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getInterfaceDef_AllContents ()
   {
      return (EReference) interfaceDefEClass.getEStructuralFeatures ().get (3);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getOwnedIDLType ()
   {
      return ownedIDLTypeEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getSharedIDLType ()
   {
      return sharedIDLTypeEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getTyped ()
   {
      return typedEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getTyped_OwnedType ()
   {
      return (EReference) typedEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getTyped_Type ()
   {
      return (EReference) typedEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getTyped_SharedType ()
   {
      return (EReference) typedEClass.getEStructuralFeatures ().get (2);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getUnionDef ()
   {
      return unionDefEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getUnionDef_UnionContents ()
   {
      return (EReference) unionDefEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getUnionDef_Members ()
   {
      return (EReference) unionDefEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getEnumDef ()
   {
      return enumDefEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getEnumDef_EnumContents ()
   {
      return (EReference) enumDefEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getEnumDef_Members ()
   {
      return (EReference) enumDefEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getConstantDef ()
   {
      return constantDefEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getConstantDef_Value ()
   {
      return (EReference) constantDefEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getConstantDef_OwnedValue ()
   {
      return (EReference) constantDefEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getEnumMember ()
   {
      return enumMemberEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getUnionMember ()
   {
      return unionMemberEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getUnionMember_Labels ()
   {
      return (EReference) unionMemberEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getUnionMember_OwnedLabels ()
   {
      return (EReference) unionMemberEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getExceptionDef ()
   {
      return exceptionDefEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getExceptionDef_ExceptionContents ()
   {
      return (EReference) exceptionDefEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getExceptionDef_Members ()
   {
      return (EReference) exceptionDefEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getAttributeDef ()
   {
      return attributeDefEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EAttribute getAttributeDef_Mode ()
   {
      return (EAttribute) attributeDefEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getAttributeDef_GetExceptions ()
   {
      return (EReference) attributeDefEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getAttributeDef_SetExceptions ()
   {
      return (EReference) attributeDefEClass.getEStructuralFeatures ().get (2);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getParameterDef ()
   {
      return parameterDefEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getParameterDef_Operation ()
   {
      return (EReference) parameterDefEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EAttribute getParameterDef_Mode ()
   {
      return (EAttribute) parameterDefEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getOperationDef ()
   {
      return operationDefEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EAttribute getOperationDef_Contexts ()
   {
      return (EAttribute) operationDefEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EAttribute getOperationDef_Mode ()
   {
      return (EAttribute) operationDefEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getOperationDef_Parameters ()
   {
      return (EReference) operationDefEClass.getEStructuralFeatures ().get (2);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getOperationDef_Exceptions ()
   {
      return (EReference) operationDefEClass.getEStructuralFeatures ().get (3);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getValueMemberDef ()
   {
      return valueMemberDefEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EAttribute getValueMemberDef_Access ()
   {
      return (EAttribute) valueMemberDefEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getValueDef ()
   {
      return valueDefEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EAttribute getValueDef_Custom ()
   {
      return (EAttribute) valueDefEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EAttribute getValueDef_Truncatable ()
   {
      return (EAttribute) valueDefEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getValueDef_Members ()
   {
      return (EReference) valueDefEClass.getEStructuralFeatures ().get (5);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getValueDef_Initializers ()
   {
      return (EReference) valueDefEClass.getEStructuralFeatures ().get (6);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getValueDef_AllContents ()
   {
      return (EReference) valueDefEClass.getEStructuralFeatures ().get (7);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getValueDef_AllBaseValues ()
   {
      return (EReference) valueDefEClass.getEStructuralFeatures ().get (8);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getValueDef_AllSupportedInterfaces ()
   {
      return (EReference) valueDefEClass.getEStructuralFeatures ().get (9);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getValueDef_BaseValues ()
   {
      return (EReference) valueDefEClass.getEStructuralFeatures ().get (2);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getValueDef_ValueContents ()
   {
      return (EReference) valueDefEClass.getEStructuralFeatures ().get (3);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getValueDef_SupportedInterfaces ()
   {
      return (EReference) valueDefEClass.getEStructuralFeatures ().get (4);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getInitializer ()
   {
      return initializerEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getInitializer_Exceptions ()
   {
      return (EReference) initializerEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getInitializer_Parameters ()
   {
      return (EReference) initializerEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getValueBoxDef ()
   {
      return valueBoxDefEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getNativeDef ()
   {
      return nativeDefEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getNamed ()
   {
      return namedEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EAttribute getNamed_Name ()
   {
      return (EAttribute) namedEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EAttribute getNamed_Key ()
   {
      return (EAttribute) namedEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getMember ()
   {
      return memberEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getExceptionMember ()
   {
      return exceptionMemberEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getRepositoryContained ()
   {
      return repositoryContainedEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getRepositoryContained_ContainingRepository ()
   {
      return (EReference) repositoryContainedEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getModuleContained ()
   {
      return moduleContainedEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getModuleContained_ContainingModule ()
   {
      return (EReference) moduleContainedEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getExceptionContained ()
   {
      return exceptionContainedEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getExceptionContained_ContainingException ()
   {
      return (EReference) exceptionContainedEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getInterfaceContained ()
   {
      return interfaceContainedEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getInterfaceContained_ContainingInterface ()
   {
      return (EReference) interfaceContainedEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getStructContained ()
   {
      return structContainedEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getStructContained_ContainingStruct ()
   {
      return (EReference) structContainedEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getUnionContained ()
   {
      return unionContainedEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getUnionContained_ContainingUnion ()
   {
      return (EReference) unionContainedEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getValueContained ()
   {
      return valueContainedEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getValueContained_ContainingValue ()
   {
      return (EReference) valueContainedEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getSharedExpression ()
   {
      return sharedExpressionEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getOwnedExpression ()
   {
      return ownedExpressionEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getExpression ()
   {
      return expressionEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getOperator ()
   {
      return operatorEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getLiteral ()
   {
      return literalEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getBitwiseComplementOperator ()
   {
      return bitwiseComplementOperatorEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getBitwiseRightShiftOperator ()
   {
      return bitwiseRightShiftOperatorEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getBitwiseLeftShiftOperator ()
   {
      return bitwiseLeftShiftOperatorEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getBitwiseAndOperator ()
   {
      return bitwiseAndOperatorEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getAddOperator ()
   {
      return addOperatorEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getBitwiseXorOperator ()
   {
      return bitwiseXorOperatorEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getPositiveOperator ()
   {
      return positiveOperatorEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getNegativeOperator ()
   {
      return negativeOperatorEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getBitwiseOrOperator ()
   {
      return bitwiseOrOperatorEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getSubtractOperator ()
   {
      return subtractOperatorEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getMultiplyOperator ()
   {
      return multiplyOperatorEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getBinaryOperator ()
   {
      return binaryOperatorEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getBinaryOperator_Lhs ()
   {
      return (EReference) binaryOperatorEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getBinaryOperator_OwnedRhs ()
   {
      return (EReference) binaryOperatorEClass.getEStructuralFeatures ().get (2);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getBinaryOperator_OwnedLhs ()
   {
      return (EReference) binaryOperatorEClass.getEStructuralFeatures ().get (3);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getBinaryOperator_Rhs ()
   {
      return (EReference) binaryOperatorEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getModuloOperator ()
   {
      return moduloOperatorEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getUnaryOperator ()
   {
      return unaryOperatorEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getUnaryOperator_Operand ()
   {
      return (EReference) unaryOperatorEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getUnaryOperator_OwnedOperand ()
   {
      return (EReference) unaryOperatorEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getDivideOperator ()
   {
      return divideOperatorEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getEnumContained ()
   {
      return enumContainedEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getEnumContained_ContainingEnum ()
   {
      return (EReference) enumContainedEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getInterfaceDecl ()
   {
      return interfaceDeclEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getInterface ()
   {
      return interfaceEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EAttribute getInterface_Modifier ()
   {
      return (EAttribute) interfaceEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getPrePragma ()
   {
      return prePragmaEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getPostPragma ()
   {
      return postPragmaEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getScopePragma ()
   {
      return scopePragmaEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getBooleanLiteral ()
   {
      return booleanLiteralEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EAttribute getBooleanLiteral_ExpressionValue ()
   {
      return (EAttribute) booleanLiteralEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getCharacterLiteral ()
   {
      return characterLiteralEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EAttribute getCharacterLiteral_ExpressionValue ()
   {
      return (EAttribute) characterLiteralEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getFixedPointLiteral ()
   {
      return fixedPointLiteralEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EAttribute getFixedPointLiteral_ExpressionValue ()
   {
      return (EAttribute) fixedPointLiteralEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getFloatingPointLiteral ()
   {
      return floatingPointLiteralEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EAttribute getFloatingPointLiteral_ExpressionValue ()
   {
      return (EAttribute) floatingPointLiteralEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getIntegerLiteral ()
   {
      return integerLiteralEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EAttribute getIntegerLiteral_ExpressionValue ()
   {
      return (EAttribute) integerLiteralEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getStringLiteral ()
   {
      return stringLiteralEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EAttribute getStringLiteral_ExpressionValue ()
   {
      return (EAttribute) stringLiteralEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getWCharacterLiteral ()
   {
      return wCharacterLiteralEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EAttribute getWCharacterLiteral_ExpressionValue ()
   {
      return (EAttribute) wCharacterLiteralEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getWStringLiteral ()
   {
      return wStringLiteralEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EAttribute getWStringLiteral_ExpressionValue ()
   {
      return (EAttribute) wStringLiteralEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getExpressionContext ()
   {
      return expressionContextEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getValue ()
   {
      return valueEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EAttribute getValue_Abstract ()
   {
      return (EAttribute) valueEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getValueDecl ()
   {
      return valueDeclEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EClass getInitializerParameterDef ()
   {
      return initializerParameterDefEClass;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EReference getInitializerParameterDef_Initializer ()
   {
      return (EReference) initializerParameterDefEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getInitializerParameterDef_FactoryOperation ()
   {
      return (EReference) initializerParameterDefEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getInitializerParameterDef_FinderOperation ()
   {
      return (EReference) initializerParameterDefEClass.getEStructuralFeatures ().get (2);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EClass getComponent ()
   {
      return componentEClass;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EClass getComponentDef ()
   {
      return componentDefEClass;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getComponentDef_ComponentContents ()
   {
      return (EReference) componentDefEClass.getEStructuralFeatures ().get (4);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getComponentDef_AllContents ()
   {
      return (EReference) componentDefEClass.getEStructuralFeatures ().get (5);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getComponentDef_Ports ()
   {
      return (EReference) componentDefEClass.getEStructuralFeatures ().get (6);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getComponentDef_AllPorts ()
   {
      return (EReference) componentDefEClass.getEStructuralFeatures ().get (7);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getComponentDef_AllUsesPorts ()
   {
      return (EReference) componentDefEClass.getEStructuralFeatures ().get (8);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getComponentDef_UsesPorts ()
   {
      return (EReference) componentDefEClass.getEStructuralFeatures ().get (9);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getComponentDef_AllProvidesPorts ()
   {
      return (EReference) componentDefEClass.getEStructuralFeatures ().get (10);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getComponentDef_ProvidesPorts ()
   {
      return (EReference) componentDefEClass.getEStructuralFeatures ().get (11);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getComponentDef_ConsumesPorts ()
   {
      return (EReference) componentDefEClass.getEStructuralFeatures ().get (12);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getComponentDef_AllConsumesPorts ()
   {
      return (EReference) componentDefEClass.getEStructuralFeatures ().get (13);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getComponentDef_PublishesPorts ()
   {
      return (EReference) componentDefEClass.getEStructuralFeatures ().get (14);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getComponentDef_AllPublishesPorts ()
   {
      return (EReference) componentDefEClass.getEStructuralFeatures ().get (15);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getComponentDef_EmitsPorts ()
   {
      return (EReference) componentDefEClass.getEStructuralFeatures ().get (16);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getComponentDef_AllEmitsPorts ()
   {
      return (EReference) componentDefEClass.getEStructuralFeatures ().get (17);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getComponentDef_BaseComponent ()
   {
      return (EReference) componentDefEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getComponentDef_SupportedInterfaces ()
   {
      return (EReference) componentDefEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getComponentDef_AllBaseComponents ()
   {
      return (EReference) componentDefEClass.getEStructuralFeatures ().get (2);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getComponentDef_AllSupportedInterfaces ()
   {
      return (EReference) componentDefEClass.getEStructuralFeatures ().get (3);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EClass getComponentDecl ()
   {
      return componentDeclEClass;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EClass getComponentContained ()
   {
      return componentContainedEClass;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getComponentContained_ContainingComponent ()
   {
      return (EReference) componentContainedEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EClass getComponentPortDef ()
   {
      return componentPortDefEClass;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EClass getHome ()
   {
      return homeEClass;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EClass getHomeDef ()
   {
      return homeDefEClass;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getHomeDef_ManagedComponent ()
   {
      return (EReference) homeDefEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getHomeDef_BaseHome ()
   {
      return (EReference) homeDefEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getHomeDef_AllBaseHomes ()
   {
      return (EReference) homeDefEClass.getEStructuralFeatures ().get (2);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getHomeDef_SupportedInterfaces ()
   {
      return (EReference) homeDefEClass.getEStructuralFeatures ().get (3);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getHomeDef_AllSupportedInterfaces ()
   {
      return (EReference) homeDefEClass.getEStructuralFeatures ().get (4);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getHomeDef_Primarykey ()
   {
      return (EReference) homeDefEClass.getEStructuralFeatures ().get (5);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getHomeDef_HomeContents ()
   {
      return (EReference) homeDefEClass.getEStructuralFeatures ().get (6);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getHomeDef_FactoryOperations ()
   {
      return (EReference) homeDefEClass.getEStructuralFeatures ().get (7);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getHomeDef_AllFactoryOperations ()
   {
      return (EReference) homeDefEClass.getEStructuralFeatures ().get (8);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getHomeDef_FinderOperations ()
   {
      return (EReference) homeDefEClass.getEStructuralFeatures ().get (9);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getHomeDef_AllFinderOperations ()
   {
      return (EReference) homeDefEClass.getEStructuralFeatures ().get (10);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EClass getHomeContained ()
   {
      return homeContainedEClass;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getHomeContained_ContainingHome ()
   {
      return (EReference) homeContainedEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EClass getFactoryOperation ()
   {
      return factoryOperationEClass;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getFactoryOperation_Parameters ()
   {
      return (EReference) factoryOperationEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getFactoryOperation_Exceptions ()
   {
      return (EReference) factoryOperationEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EClass getFinderOperation ()
   {
      return finderOperationEClass;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getFinderOperation_Exceptions ()
   {
      return (EReference) finderOperationEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getFinderOperation_Parameters ()
   {
      return (EReference) finderOperationEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EClass getInterfacePortDef ()
   {
      return interfacePortDefEClass;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getInterfacePortDef_Interface_type ()
   {
      return (EReference) interfacePortDefEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EClass getEventPortDef ()
   {
      return eventPortDefEClass;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getEventPortDef_Event ()
   {
      return (EReference) eventPortDefEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EClass getProvidesDef ()
   {
      return providesDefEClass;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EClass getUsesDef ()
   {
      return usesDefEClass;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EAttribute getUsesDef_Mode ()
   {
      return (EAttribute) usesDefEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EClass getConsumesDef ()
   {
      return consumesDefEClass;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EClass getPublishesDef ()
   {
      return publishesDefEClass;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EClass getEmitsDef ()
   {
      return emitsDefEClass;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EClass getEvent ()
   {
      return eventEClass;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EClass getEventDecl ()
   {
      return eventDeclEClass;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EClass getEventDef ()
   {
      return eventDefEClass;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getEventDef_EventContents ()
   {
      return (EReference) eventDefEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EClass getAttributeContainer ()
   {
      return attributeContainerEClass;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getAttributeContainer_Attributes ()
   {
      return (EReference) attributeContainerEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getAttributeContainer_AllAttributes ()
   {
      return (EReference) attributeContainerEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EClass getOperationContainer ()
   {
      return operationContainerEClass;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getOperationContainer_Operations ()
   {
      return (EReference) operationContainerEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getOperationContainer_AllOperations ()
   {
      return (EReference) operationContainerEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EClass getConstantContainer ()
   {
      return constantContainerEClass;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getConstantContainer_Constants ()
   {
      return (EReference) constantContainerEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getConstantContainer_AllConstants ()
   {
      return (EReference) constantContainerEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EClass getAliasContainer ()
   {
      return aliasContainerEClass;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getAliasContainer_Aliases ()
   {
      return (EReference) aliasContainerEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getAliasContainer_AllAliases ()
   {
      return (EReference) aliasContainerEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EClass getNativeContainer ()
   {
      return nativeContainerEClass;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getNativeContainer_Natives ()
   {
      return (EReference) nativeContainerEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getNativeContainer_AllNatives ()
   {
      return (EReference) nativeContainerEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EClass getUnionContainer ()
   {
      return unionContainerEClass;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getUnionContainer_Unions ()
   {
      return (EReference) unionContainerEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getUnionContainer_AllUnions ()
   {
      return (EReference) unionContainerEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EClass getStructContainer ()
   {
      return structContainerEClass;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getStructContainer_Structs ()
   {
      return (EReference) structContainerEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getStructContainer_AllStructs ()
   {
      return (EReference) structContainerEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EClass getEnumContainer ()
   {
      return enumContainerEClass;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getEnumContainer_Enums ()
   {
      return (EReference) enumContainerEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getEnumContainer_AllEnums ()
   {
      return (EReference) enumContainerEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EClass getExceptionContainer ()
   {
      return exceptionContainerEClass;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getExceptionContainer_Exceptions ()
   {
      return (EReference) exceptionContainerEClass.getEStructuralFeatures ().get (0);
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EReference getExceptionContainer_AllExceptions ()
   {
      return (EReference) exceptionContainerEClass.getEStructuralFeatures ().get (1);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EEnum getPrimitiveKind ()
   {
      return primitiveKindEEnum;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EEnum getAttributeMode ()
   {
      return attributeModeEEnum;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EEnum getOperationMode ()
   {
      return operationModeEEnum;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EEnum getParameterMode ()
   {
      return parameterModeEEnum;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EEnum getVisibility ()
   {
      return visibilityEEnum;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public EEnum getInterfaceModifier ()
   {
      return interfaceModifierEEnum;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public EEnum getUsesMode ()
   {
      return usesModeEEnum;
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   public IdlmmFactory getIdlmmFactory ()
   {
      return (IdlmmFactory) getEFactoryInstance ();
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private boolean isCreated = false;

   /**
    * Creates the meta-model objects for the package.  This method is
    * guarded to have no affect on any invocation but its first.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public void createPackageContents ()
   {
      if (isCreated)
         return;
      isCreated = true;

      // Create classes and their features
      moduleDefEClass = createEClass (MODULE_DEF);
      createEReference (moduleDefEClass, MODULE_DEF__MODULE_CONTENTS);
      createEReference (moduleDefEClass, MODULE_DEF__INTERFACES);
      createEReference (moduleDefEClass, MODULE_DEF__MODULES);
      createEReference (moduleDefEClass, MODULE_DEF__VALUE_TYPES);

      containerEClass = createEClass (CONTAINER);
      createEReference (containerEClass, CONTAINER__CONTENTS);

      irObjectEClass = createEClass (IR_OBJECT);
      createEAttribute (irObjectEClass, IR_OBJECT__SOURCE);
      createEReference (irObjectEClass, IR_OBJECT__PRAGMAS);
      createEReference (irObjectEClass, IR_OBJECT__REPOSITORY);

      containedEClass = createEClass (CONTAINED);
      createEAttribute (containedEClass, CONTAINED__ABSOLUTE_NAME);
      createEAttribute (containedEClass, CONTAINED__PREFIX);
      createEAttribute (containedEClass, CONTAINED__ID);
      createEAttribute (containedEClass, CONTAINED__VERSION);
      createEReference (containedEClass, CONTAINED__CONTAINER);

      repositoryEClass = createEClass (REPOSITORY);
      createEReference (repositoryEClass, REPOSITORY__REPOSITORY_CONTENTS);
      createEReference (repositoryEClass, REPOSITORY__INCLUDES);
      createEReference (repositoryEClass, REPOSITORY__ENUMS);
      createEReference (repositoryEClass, REPOSITORY__ALIASES);
      createEReference (repositoryEClass, REPOSITORY__CONSTANTS);
      createEReference (repositoryEClass, REPOSITORY__EXCEPTIONS);
      createEReference (repositoryEClass, REPOSITORY__INTERFACES);
      createEReference (repositoryEClass, REPOSITORY__MODULES);
      createEReference (repositoryEClass, REPOSITORY__NATIVES);
      createEReference (repositoryEClass, REPOSITORY__STRUCTS);
      createEReference (repositoryEClass, REPOSITORY__UNIONS);
      createEReference (repositoryEClass, REPOSITORY__VALUE_TYPES);

      stringDefEClass = createEClass (STRING_DEF);
      createEReference (stringDefEClass, STRING_DEF__BOUND);
      createEReference (stringDefEClass, STRING_DEF__OWNED_BOUND);

      idlTypeEClass = createEClass (IDL_TYPE);

      typedefDefEClass = createEClass (TYPEDEF_DEF);

      aliasDefEClass = createEClass (ALIAS_DEF);

      primitiveDefEClass = createEClass (PRIMITIVE_DEF);
      createEAttribute (primitiveDefEClass, PRIMITIVE_DEF__KIND);

      pragmaEClass = createEClass (PRAGMA);
      createEAttribute (pragmaEClass, PRAGMA__TEXT);
      createEReference (pragmaEClass, PRAGMA__OWNER);
      createEReference (pragmaEClass, PRAGMA__PREREQUISITES);

      wStringDefEClass = createEClass (WSTRING_DEF);
      createEReference (wStringDefEClass, WSTRING_DEF__OWNED_BOUND);
      createEReference (wStringDefEClass, WSTRING_DEF__BOUND);

      sequenceDefEClass = createEClass (SEQUENCE_DEF);
      createEReference (sequenceDefEClass, SEQUENCE_DEF__BOUND);
      createEReference (sequenceDefEClass, SEQUENCE_DEF__OWNED_BOUND);

      arrayDefEClass = createEClass (ARRAY_DEF);
      createEReference (arrayDefEClass, ARRAY_DEF__OWNED_LENGTH);
      createEReference (arrayDefEClass, ARRAY_DEF__LENGTH);

      fixedDefEClass = createEClass (FIXED_DEF);
      createEReference (fixedDefEClass, FIXED_DEF__DIGITS);
      createEReference (fixedDefEClass, FIXED_DEF__OWNED_DIGITS);
      createEReference (fixedDefEClass, FIXED_DEF__SCALE);
      createEReference (fixedDefEClass, FIXED_DEF__OWNED_SCALE);

      structDefEClass = createEClass (STRUCT_DEF);
      createEReference (structDefEClass, STRUCT_DEF__STRUCT_CONTENTS);
      createEReference (structDefEClass, STRUCT_DEF__MEMBERS);

      structMemberEClass = createEClass (STRUCT_MEMBER);

      interfaceDefEClass = createEClass (INTERFACE_DEF);
      createEReference (interfaceDefEClass, INTERFACE_DEF__INTERFACE_CONTENTS);
      createEReference (interfaceDefEClass, INTERFACE_DEF__BASE_INTERFACES);
      createEReference (interfaceDefEClass, INTERFACE_DEF__ALL_BASE_INTERFACES);
      createEReference (interfaceDefEClass, INTERFACE_DEF__ALL_CONTENTS);

      ownedIDLTypeEClass = createEClass (OWNED_IDL_TYPE);

      sharedIDLTypeEClass = createEClass (SHARED_IDL_TYPE);

      typedEClass = createEClass (TYPED);
      createEReference (typedEClass, TYPED__OWNED_TYPE);
      createEReference (typedEClass, TYPED__TYPE);
      createEReference (typedEClass, TYPED__SHARED_TYPE);

      unionDefEClass = createEClass (UNION_DEF);
      createEReference (unionDefEClass, UNION_DEF__UNION_CONTENTS);
      createEReference (unionDefEClass, UNION_DEF__MEMBERS);

      enumDefEClass = createEClass (ENUM_DEF);
      createEReference (enumDefEClass, ENUM_DEF__ENUM_CONTENTS);
      createEReference (enumDefEClass, ENUM_DEF__MEMBERS);

      constantDefEClass = createEClass (CONSTANT_DEF);
      createEReference (constantDefEClass, CONSTANT_DEF__VALUE);
      createEReference (constantDefEClass, CONSTANT_DEF__OWNED_VALUE);

      enumMemberEClass = createEClass (ENUM_MEMBER);

      unionMemberEClass = createEClass (UNION_MEMBER);
      createEReference (unionMemberEClass, UNION_MEMBER__OWNED_LABELS);
      createEReference (unionMemberEClass, UNION_MEMBER__LABELS);

      exceptionDefEClass = createEClass (EXCEPTION_DEF);
      createEReference (exceptionDefEClass, EXCEPTION_DEF__EXCEPTION_CONTENTS);
      createEReference (exceptionDefEClass, EXCEPTION_DEF__MEMBERS);

      attributeDefEClass = createEClass (ATTRIBUTE_DEF);
      createEAttribute (attributeDefEClass, ATTRIBUTE_DEF__MODE);
      createEReference (attributeDefEClass, ATTRIBUTE_DEF__GET_EXCEPTIONS);
      createEReference (attributeDefEClass, ATTRIBUTE_DEF__SET_EXCEPTIONS);

      parameterDefEClass = createEClass (PARAMETER_DEF);
      createEAttribute (parameterDefEClass, PARAMETER_DEF__MODE);
      createEReference (parameterDefEClass, PARAMETER_DEF__OPERATION);

      operationDefEClass = createEClass (OPERATION_DEF);
      createEAttribute (operationDefEClass, OPERATION_DEF__CONTEXTS);
      createEAttribute (operationDefEClass, OPERATION_DEF__MODE);
      createEReference (operationDefEClass, OPERATION_DEF__PARAMETERS);
      createEReference (operationDefEClass, OPERATION_DEF__EXCEPTIONS);

      valueMemberDefEClass = createEClass (VALUE_MEMBER_DEF);
      createEAttribute (valueMemberDefEClass, VALUE_MEMBER_DEF__ACCESS);

      valueDefEClass = createEClass (VALUE_DEF);
      createEAttribute (valueDefEClass, VALUE_DEF__CUSTOM);
      createEAttribute (valueDefEClass, VALUE_DEF__TRUNCATABLE);
      createEReference (valueDefEClass, VALUE_DEF__BASE_VALUES);
      createEReference (valueDefEClass, VALUE_DEF__VALUE_CONTENTS);
      createEReference (valueDefEClass, VALUE_DEF__SUPPORTED_INTERFACES);
      createEReference (valueDefEClass, VALUE_DEF__MEMBERS);
      createEReference (valueDefEClass, VALUE_DEF__INITIALIZERS);
      createEReference (valueDefEClass, VALUE_DEF__ALL_CONTENTS);
      createEReference (valueDefEClass, VALUE_DEF__ALL_BASE_VALUES);
      createEReference (valueDefEClass, VALUE_DEF__ALL_SUPPORTED_INTERFACES);

      initializerEClass = createEClass (INITIALIZER);
      createEReference (initializerEClass, INITIALIZER__EXCEPTIONS);
      createEReference (initializerEClass, INITIALIZER__PARAMETERS);

      valueBoxDefEClass = createEClass (VALUE_BOX_DEF);

      nativeDefEClass = createEClass (NATIVE_DEF);

      namedEClass = createEClass (NAMED);
      createEAttribute (namedEClass, NAMED__NAME);
      createEAttribute (namedEClass, NAMED__KEY);

      memberEClass = createEClass (MEMBER);

      exceptionMemberEClass = createEClass (EXCEPTION_MEMBER);

      repositoryContainedEClass = createEClass (REPOSITORY_CONTAINED);
      createEReference (repositoryContainedEClass, REPOSITORY_CONTAINED__CONTAINING_REPOSITORY);

      moduleContainedEClass = createEClass (MODULE_CONTAINED);
      createEReference (moduleContainedEClass, MODULE_CONTAINED__CONTAINING_MODULE);

      exceptionContainedEClass = createEClass (EXCEPTION_CONTAINED);
      createEReference (exceptionContainedEClass, EXCEPTION_CONTAINED__CONTAINING_EXCEPTION);

      interfaceContainedEClass = createEClass (INTERFACE_CONTAINED);
      createEReference (interfaceContainedEClass, INTERFACE_CONTAINED__CONTAINING_INTERFACE);

      structContainedEClass = createEClass (STRUCT_CONTAINED);
      createEReference (structContainedEClass, STRUCT_CONTAINED__CONTAINING_STRUCT);

      unionContainedEClass = createEClass (UNION_CONTAINED);
      createEReference (unionContainedEClass, UNION_CONTAINED__CONTAINING_UNION);

      valueContainedEClass = createEClass (VALUE_CONTAINED);
      createEReference (valueContainedEClass, VALUE_CONTAINED__CONTAINING_VALUE);

      sharedExpressionEClass = createEClass (SHARED_EXPRESSION);

      ownedExpressionEClass = createEClass (OWNED_EXPRESSION);

      expressionEClass = createEClass (EXPRESSION);

      operatorEClass = createEClass (OPERATOR);

      literalEClass = createEClass (LITERAL);

      bitwiseComplementOperatorEClass = createEClass (BITWISE_COMPLEMENT_OPERATOR);

      bitwiseRightShiftOperatorEClass = createEClass (BITWISE_RIGHT_SHIFT_OPERATOR);

      bitwiseLeftShiftOperatorEClass = createEClass (BITWISE_LEFT_SHIFT_OPERATOR);

      bitwiseAndOperatorEClass = createEClass (BITWISE_AND_OPERATOR);

      addOperatorEClass = createEClass (ADD_OPERATOR);

      bitwiseXorOperatorEClass = createEClass (BITWISE_XOR_OPERATOR);

      positiveOperatorEClass = createEClass (POSITIVE_OPERATOR);

      negativeOperatorEClass = createEClass (NEGATIVE_OPERATOR);

      bitwiseOrOperatorEClass = createEClass (BITWISE_OR_OPERATOR);

      subtractOperatorEClass = createEClass (SUBTRACT_OPERATOR);

      multiplyOperatorEClass = createEClass (MULTIPLY_OPERATOR);

      binaryOperatorEClass = createEClass (BINARY_OPERATOR);
      createEReference (binaryOperatorEClass, BINARY_OPERATOR__RHS);
      createEReference (binaryOperatorEClass, BINARY_OPERATOR__LHS);
      createEReference (binaryOperatorEClass, BINARY_OPERATOR__OWNED_RHS);
      createEReference (binaryOperatorEClass, BINARY_OPERATOR__OWNED_LHS);

      moduloOperatorEClass = createEClass (MODULO_OPERATOR);

      unaryOperatorEClass = createEClass (UNARY_OPERATOR);
      createEReference (unaryOperatorEClass, UNARY_OPERATOR__OPERAND);
      createEReference (unaryOperatorEClass, UNARY_OPERATOR__OWNED_OPERAND);

      divideOperatorEClass = createEClass (DIVIDE_OPERATOR);

      enumContainedEClass = createEClass (ENUM_CONTAINED);
      createEReference (enumContainedEClass, ENUM_CONTAINED__CONTAINING_ENUM);

      interfaceDeclEClass = createEClass (INTERFACE_DECL);

      interfaceEClass = createEClass (INTERFACE);
      createEAttribute (interfaceEClass, INTERFACE__MODIFIER);

      prePragmaEClass = createEClass (PRE_PRAGMA);

      postPragmaEClass = createEClass (POST_PRAGMA);

      scopePragmaEClass = createEClass (SCOPE_PRAGMA);

      booleanLiteralEClass = createEClass (BOOLEAN_LITERAL);
      createEAttribute (booleanLiteralEClass, BOOLEAN_LITERAL__EXPRESSION_VALUE);

      characterLiteralEClass = createEClass (CHARACTER_LITERAL);
      createEAttribute (characterLiteralEClass, CHARACTER_LITERAL__EXPRESSION_VALUE);

      fixedPointLiteralEClass = createEClass (FIXED_POINT_LITERAL);
      createEAttribute (fixedPointLiteralEClass, FIXED_POINT_LITERAL__EXPRESSION_VALUE);

      floatingPointLiteralEClass = createEClass (FLOATING_POINT_LITERAL);
      createEAttribute (floatingPointLiteralEClass, FLOATING_POINT_LITERAL__EXPRESSION_VALUE);

      integerLiteralEClass = createEClass (INTEGER_LITERAL);
      createEAttribute (integerLiteralEClass, INTEGER_LITERAL__EXPRESSION_VALUE);

      stringLiteralEClass = createEClass (STRING_LITERAL);
      createEAttribute (stringLiteralEClass, STRING_LITERAL__EXPRESSION_VALUE);

      wCharacterLiteralEClass = createEClass (WCHARACTER_LITERAL);
      createEAttribute (wCharacterLiteralEClass, WCHARACTER_LITERAL__EXPRESSION_VALUE);

      wStringLiteralEClass = createEClass (WSTRING_LITERAL);
      createEAttribute (wStringLiteralEClass, WSTRING_LITERAL__EXPRESSION_VALUE);

      expressionContextEClass = createEClass (EXPRESSION_CONTEXT);

      valueEClass = createEClass (VALUE);
      createEAttribute (valueEClass, VALUE__ABSTRACT);

      valueDeclEClass = createEClass (VALUE_DECL);

      initializerParameterDefEClass = createEClass (INITIALIZER_PARAMETER_DEF);
      createEReference (initializerParameterDefEClass, INITIALIZER_PARAMETER_DEF__INITIALIZER);
      createEReference (initializerParameterDefEClass, INITIALIZER_PARAMETER_DEF__FACTORY_OPERATION);
      createEReference (initializerParameterDefEClass, INITIALIZER_PARAMETER_DEF__FINDER_OPERATION);

      componentEClass = createEClass (COMPONENT);

      componentDefEClass = createEClass (COMPONENT_DEF);
      createEReference (componentDefEClass, COMPONENT_DEF__BASE_COMPONENT);
      createEReference (componentDefEClass, COMPONENT_DEF__SUPPORTED_INTERFACES);
      createEReference (componentDefEClass, COMPONENT_DEF__ALL_BASE_COMPONENTS);
      createEReference (componentDefEClass, COMPONENT_DEF__ALL_SUPPORTED_INTERFACES);
      createEReference (componentDefEClass, COMPONENT_DEF__COMPONENT_CONTENTS);
      createEReference (componentDefEClass, COMPONENT_DEF__ALL_CONTENTS);
      createEReference (componentDefEClass, COMPONENT_DEF__PORTS);
      createEReference (componentDefEClass, COMPONENT_DEF__ALL_PORTS);
      createEReference (componentDefEClass, COMPONENT_DEF__ALL_USES_PORTS);
      createEReference (componentDefEClass, COMPONENT_DEF__USES_PORTS);
      createEReference (componentDefEClass, COMPONENT_DEF__ALL_PROVIDES_PORTS);
      createEReference (componentDefEClass, COMPONENT_DEF__PROVIDES_PORTS);
      createEReference (componentDefEClass, COMPONENT_DEF__CONSUMES_PORTS);
      createEReference (componentDefEClass, COMPONENT_DEF__ALL_CONSUMES_PORTS);
      createEReference (componentDefEClass, COMPONENT_DEF__PUBLISHES_PORTS);
      createEReference (componentDefEClass, COMPONENT_DEF__ALL_PUBLISHES_PORTS);
      createEReference (componentDefEClass, COMPONENT_DEF__EMITS_PORTS);
      createEReference (componentDefEClass, COMPONENT_DEF__ALL_EMITS_PORTS);

      componentDeclEClass = createEClass (COMPONENT_DECL);

      componentContainedEClass = createEClass (COMPONENT_CONTAINED);
      createEReference (componentContainedEClass, COMPONENT_CONTAINED__CONTAINING_COMPONENT);

      componentPortDefEClass = createEClass (COMPONENT_PORT_DEF);

      homeEClass = createEClass (HOME);

      homeDefEClass = createEClass (HOME_DEF);
      createEReference (homeDefEClass, HOME_DEF__MANAGED_COMPONENT);
      createEReference (homeDefEClass, HOME_DEF__BASE_HOME);
      createEReference (homeDefEClass, HOME_DEF__ALL_BASE_HOMES);
      createEReference (homeDefEClass, HOME_DEF__SUPPORTED_INTERFACES);
      createEReference (homeDefEClass, HOME_DEF__ALL_SUPPORTED_INTERFACES);
      createEReference (homeDefEClass, HOME_DEF__PRIMARYKEY);
      createEReference (homeDefEClass, HOME_DEF__HOME_CONTENTS);
      createEReference (homeDefEClass, HOME_DEF__FACTORY_OPERATIONS);
      createEReference (homeDefEClass, HOME_DEF__ALL_FACTORY_OPERATIONS);
      createEReference (homeDefEClass, HOME_DEF__FINDER_OPERATIONS);
      createEReference (homeDefEClass, HOME_DEF__ALL_FINDER_OPERATIONS);

      homeContainedEClass = createEClass (HOME_CONTAINED);
      createEReference (homeContainedEClass, HOME_CONTAINED__CONTAINING_HOME);

      factoryOperationEClass = createEClass (FACTORY_OPERATION);
      createEReference (factoryOperationEClass, FACTORY_OPERATION__PARAMETERS);
      createEReference (factoryOperationEClass, FACTORY_OPERATION__EXCEPTIONS);

      finderOperationEClass = createEClass (FINDER_OPERATION);
      createEReference (finderOperationEClass, FINDER_OPERATION__EXCEPTIONS);
      createEReference (finderOperationEClass, FINDER_OPERATION__PARAMETERS);

      interfacePortDefEClass = createEClass (INTERFACE_PORT_DEF);
      createEReference (interfacePortDefEClass, INTERFACE_PORT_DEF__INTERFACE_TYPE);

      eventPortDefEClass = createEClass (EVENT_PORT_DEF);
      createEReference (eventPortDefEClass, EVENT_PORT_DEF__EVENT);

      providesDefEClass = createEClass (PROVIDES_DEF);

      usesDefEClass = createEClass (USES_DEF);
      createEAttribute (usesDefEClass, USES_DEF__MODE);

      consumesDefEClass = createEClass (CONSUMES_DEF);

      publishesDefEClass = createEClass (PUBLISHES_DEF);

      emitsDefEClass = createEClass (EMITS_DEF);

      eventEClass = createEClass (EVENT);

      eventDeclEClass = createEClass (EVENT_DECL);

      eventDefEClass = createEClass (EVENT_DEF);
      createEReference (eventDefEClass, EVENT_DEF__EVENT_CONTENTS);

      attributeContainerEClass = createEClass (ATTRIBUTE_CONTAINER);
      createEReference (attributeContainerEClass, ATTRIBUTE_CONTAINER__ATTRIBUTES);
      createEReference (attributeContainerEClass, ATTRIBUTE_CONTAINER__ALL_ATTRIBUTES);

      operationContainerEClass = createEClass (OPERATION_CONTAINER);
      createEReference (operationContainerEClass, OPERATION_CONTAINER__OPERATIONS);
      createEReference (operationContainerEClass, OPERATION_CONTAINER__ALL_OPERATIONS);

      constantContainerEClass = createEClass (CONSTANT_CONTAINER);
      createEReference (constantContainerEClass, CONSTANT_CONTAINER__CONSTANTS);
      createEReference (constantContainerEClass, CONSTANT_CONTAINER__ALL_CONSTANTS);

      aliasContainerEClass = createEClass (ALIAS_CONTAINER);
      createEReference (aliasContainerEClass, ALIAS_CONTAINER__ALIASES);
      createEReference (aliasContainerEClass, ALIAS_CONTAINER__ALL_ALIASES);

      nativeContainerEClass = createEClass (NATIVE_CONTAINER);
      createEReference (nativeContainerEClass, NATIVE_CONTAINER__NATIVES);
      createEReference (nativeContainerEClass, NATIVE_CONTAINER__ALL_NATIVES);

      unionContainerEClass = createEClass (UNION_CONTAINER);
      createEReference (unionContainerEClass, UNION_CONTAINER__UNIONS);
      createEReference (unionContainerEClass, UNION_CONTAINER__ALL_UNIONS);

      structContainerEClass = createEClass (STRUCT_CONTAINER);
      createEReference (structContainerEClass, STRUCT_CONTAINER__STRUCTS);
      createEReference (structContainerEClass, STRUCT_CONTAINER__ALL_STRUCTS);

      enumContainerEClass = createEClass (ENUM_CONTAINER);
      createEReference (enumContainerEClass, ENUM_CONTAINER__ENUMS);
      createEReference (enumContainerEClass, ENUM_CONTAINER__ALL_ENUMS);

      exceptionContainerEClass = createEClass (EXCEPTION_CONTAINER);
      createEReference (exceptionContainerEClass, EXCEPTION_CONTAINER__EXCEPTIONS);
      createEReference (exceptionContainerEClass, EXCEPTION_CONTAINER__ALL_EXCEPTIONS);

      // Create enums
      primitiveKindEEnum = createEEnum (PRIMITIVE_KIND);
      attributeModeEEnum = createEEnum (ATTRIBUTE_MODE);
      operationModeEEnum = createEEnum (OPERATION_MODE);
      parameterModeEEnum = createEEnum (PARAMETER_MODE);
      visibilityEEnum = createEEnum (VISIBILITY);
      interfaceModifierEEnum = createEEnum (INTERFACE_MODIFIER);
      usesModeEEnum = createEEnum (USES_MODE);
   }

   /**
    * <!-- begin-user-doc --> <!-- end-user-doc -->
    * @generated
    */
   private boolean isInitialized = false;

   /**
    * Complete the initialization of the package and its meta-model. This method
    * is guarded to have no affect on any invocation but its first. <!--
    * begin-user-doc --> <!-- end-user-doc -->
    * 
    * @generated
    */
   public void initializePackageContents ()
   {
      if (isInitialized)
         return;
      isInitialized = true;

      // Initialize package
      setName (eNAME);
      setNsPrefix (eNS_PREFIX);
      setNsURI (eNS_URI);

      // Create type parameters

      // Set bounds for type parameters

      // Add supertypes to classes
      moduleDefEClass.getESuperTypes ().add (this.getRepositoryContained ());
      moduleDefEClass.getESuperTypes ().add (this.getModuleContained ());
      moduleDefEClass.getESuperTypes ().add (this.getContainer ());
      moduleDefEClass.getESuperTypes ().add (this.getExceptionContainer ());
      moduleDefEClass.getESuperTypes ().add (this.getStructContainer ());
      moduleDefEClass.getESuperTypes ().add (this.getEnumContainer ());
      moduleDefEClass.getESuperTypes ().add (this.getUnionContainer ());
      moduleDefEClass.getESuperTypes ().add (this.getNativeContainer ());
      moduleDefEClass.getESuperTypes ().add (this.getAliasContainer ());
      moduleDefEClass.getESuperTypes ().add (this.getConstantContainer ());
      containerEClass.getESuperTypes ().add (this.getIRObject ());
      containedEClass.getESuperTypes ().add (this.getIRObject ());
      containedEClass.getESuperTypes ().add (this.getNamed ());
      repositoryEClass.getESuperTypes ().add (this.getContainer ());
      stringDefEClass.getESuperTypes ().add (this.getOwnedIDLType ());
      stringDefEClass.getESuperTypes ().add (this.getExpressionContext ());
      idlTypeEClass.getESuperTypes ().add (this.getIRObject ());
      typedefDefEClass.getESuperTypes ().add (this.getSharedIDLType ());
      typedefDefEClass.getESuperTypes ().add (this.getContained ());
      aliasDefEClass.getESuperTypes ().add (this.getTypedefDef ());
      aliasDefEClass.getESuperTypes ().add (this.getTyped ());
      aliasDefEClass.getESuperTypes ().add (this.getRepositoryContained ());
      aliasDefEClass.getESuperTypes ().add (this.getModuleContained ());
      aliasDefEClass.getESuperTypes ().add (this.getInterfaceContained ());
      aliasDefEClass.getESuperTypes ().add (this.getHomeContained ());
      primitiveDefEClass.getESuperTypes ().add (this.getOwnedIDLType ());
      pragmaEClass.getESuperTypes ().add (this.getIRObject ());
      wStringDefEClass.getESuperTypes ().add (this.getOwnedIDLType ());
      wStringDefEClass.getESuperTypes ().add (this.getExpressionContext ());
      sequenceDefEClass.getESuperTypes ().add (this.getOwnedIDLType ());
      sequenceDefEClass.getESuperTypes ().add (this.getTyped ());
      sequenceDefEClass.getESuperTypes ().add (this.getExpressionContext ());
      arrayDefEClass.getESuperTypes ().add (this.getOwnedIDLType ());
      arrayDefEClass.getESuperTypes ().add (this.getTyped ());
      arrayDefEClass.getESuperTypes ().add (this.getExpressionContext ());
      fixedDefEClass.getESuperTypes ().add (this.getOwnedIDLType ());
      fixedDefEClass.getESuperTypes ().add (this.getExpressionContext ());
      structDefEClass.getESuperTypes ().add (this.getTypedefDef ());
      structDefEClass.getESuperTypes ().add (this.getContainer ());
      structDefEClass.getESuperTypes ().add (this.getRepositoryContained ());
      structDefEClass.getESuperTypes ().add (this.getExceptionContained ());
      structDefEClass.getESuperTypes ().add (this.getUnionContained ());
      structDefEClass.getESuperTypes ().add (this.getModuleContained ());
      structDefEClass.getESuperTypes ().add (this.getStructContained ());
      structDefEClass.getESuperTypes ().add (this.getInterfaceContained ());
      structDefEClass.getESuperTypes ().add (this.getStructContainer ());
      structDefEClass.getESuperTypes ().add (this.getEnumContainer ());
      structDefEClass.getESuperTypes ().add (this.getUnionContainer ());
      structDefEClass.getESuperTypes ().add (this.getHomeContained ());
      structMemberEClass.getESuperTypes ().add (this.getMember ());
      structMemberEClass.getESuperTypes ().add (this.getStructContained ());
      structMemberEClass.getESuperTypes ().add (this.getSharedExpression ());
      interfaceDefEClass.getESuperTypes ().add (this.getContainer ());
      interfaceDefEClass.getESuperTypes ().add (this.getInterface ());
      interfaceDefEClass.getESuperTypes ().add (this.getAttributeContainer ());
      interfaceDefEClass.getESuperTypes ().add (this.getOperationContainer ());
      interfaceDefEClass.getESuperTypes ().add (this.getExceptionContainer ());
      interfaceDefEClass.getESuperTypes ().add (this.getStructContainer ());
      interfaceDefEClass.getESuperTypes ().add (this.getEnumContainer ());
      interfaceDefEClass.getESuperTypes ().add (this.getUnionContainer ());
      interfaceDefEClass.getESuperTypes ().add (this.getNativeContainer ());
      interfaceDefEClass.getESuperTypes ().add (this.getAliasContainer ());
      interfaceDefEClass.getESuperTypes ().add (this.getConstantContainer ());
      ownedIDLTypeEClass.getESuperTypes ().add (this.getIDLType ());
      sharedIDLTypeEClass.getESuperTypes ().add (this.getIDLType ());
      typedEClass.getESuperTypes ().add (this.getIRObject ());
      unionDefEClass.getESuperTypes ().add (this.getTypedefDef ());
      unionDefEClass.getESuperTypes ().add (this.getContainer ());
      unionDefEClass.getESuperTypes ().add (this.getUnionContained ());
      unionDefEClass.getESuperTypes ().add (this.getRepositoryContained ());
      unionDefEClass.getESuperTypes ().add (this.getExceptionContained ());
      unionDefEClass.getESuperTypes ().add (this.getModuleContained ());
      unionDefEClass.getESuperTypes ().add (this.getStructContained ());
      unionDefEClass.getESuperTypes ().add (this.getTyped ());
      unionDefEClass.getESuperTypes ().add (this.getInterfaceContained ());
      unionDefEClass.getESuperTypes ().add (this.getUnionContainer ());
      unionDefEClass.getESuperTypes ().add (this.getStructContainer ());
      unionDefEClass.getESuperTypes ().add (this.getEnumContainer ());
      unionDefEClass.getESuperTypes ().add (this.getHomeContained ());
      enumDefEClass.getESuperTypes ().add (this.getTypedefDef ());
      enumDefEClass.getESuperTypes ().add (this.getRepositoryContained ());
      enumDefEClass.getESuperTypes ().add (this.getModuleContained ());
      enumDefEClass.getESuperTypes ().add (this.getExceptionContained ());
      enumDefEClass.getESuperTypes ().add (this.getStructContained ());
      enumDefEClass.getESuperTypes ().add (this.getUnionContained ());
      enumDefEClass.getESuperTypes ().add (this.getInterfaceContained ());
      enumDefEClass.getESuperTypes ().add (this.getContainer ());
      enumDefEClass.getESuperTypes ().add (this.getHomeContained ());
      constantDefEClass.getESuperTypes ().add (this.getTyped ());
      constantDefEClass.getESuperTypes ().add (this.getRepositoryContained ());
      constantDefEClass.getESuperTypes ().add (this.getModuleContained ());
      constantDefEClass.getESuperTypes ().add (this.getInterfaceContained ());
      constantDefEClass.getESuperTypes ().add (this.getSharedExpression ());
      constantDefEClass.getESuperTypes ().add (this.getExpressionContext ());
      constantDefEClass.getESuperTypes ().add (this.getHomeContained ());
      enumMemberEClass.getESuperTypes ().add (this.getNamed ());
      enumMemberEClass.getESuperTypes ().add (this.getSharedExpression ());
      enumMemberEClass.getESuperTypes ().add (this.getEnumContained ());
      unionMemberEClass.getESuperTypes ().add (this.getMember ());
      unionMemberEClass.getESuperTypes ().add (this.getUnionContained ());
      unionMemberEClass.getESuperTypes ().add (this.getExpressionContext ());
      exceptionDefEClass.getESuperTypes ().add (this.getContainer ());
      exceptionDefEClass.getESuperTypes ().add (this.getModuleContained ());
      exceptionDefEClass.getESuperTypes ().add (this.getInterfaceContained ());
      exceptionDefEClass.getESuperTypes ().add (this.getRepositoryContained ());
      exceptionDefEClass.getESuperTypes ().add (this.getStructContainer ());
      exceptionDefEClass.getESuperTypes ().add (this.getEnumContainer ());
      exceptionDefEClass.getESuperTypes ().add (this.getUnionContainer ());
      exceptionDefEClass.getESuperTypes ().add (this.getHomeContained ());
      attributeDefEClass.getESuperTypes ().add (this.getTyped ());
      attributeDefEClass.getESuperTypes ().add (this.getInterfaceContained ());
      attributeDefEClass.getESuperTypes ().add (this.getValueContained ());
      attributeDefEClass.getESuperTypes ().add (this.getComponentContained ());
      attributeDefEClass.getESuperTypes ().add (this.getHomeContained ());
      parameterDefEClass.getESuperTypes ().add (this.getTyped ());
      parameterDefEClass.getESuperTypes ().add (this.getNamed ());
      operationDefEClass.getESuperTypes ().add (this.getTyped ());
      operationDefEClass.getESuperTypes ().add (this.getValueContained ());
      operationDefEClass.getESuperTypes ().add (this.getInterfaceContained ());
      operationDefEClass.getESuperTypes ().add (this.getHomeContained ());
      valueMemberDefEClass.getESuperTypes ().add (this.getMember ());
      valueMemberDefEClass.getESuperTypes ().add (this.getValueContained ());
      valueDefEClass.getESuperTypes ().add (this.getContainer ());
      valueDefEClass.getESuperTypes ().add (this.getValue ());
      valueDefEClass.getESuperTypes ().add (this.getOperationContainer ());
      valueDefEClass.getESuperTypes ().add (this.getAttributeContainer ());
      initializerEClass.getESuperTypes ().add (this.getValueContained ());
      valueBoxDefEClass.getESuperTypes ().add (this.getTypedefDef ());
      valueBoxDefEClass.getESuperTypes ().add (this.getTyped ());
      valueBoxDefEClass.getESuperTypes ().add (this.getRepositoryContained ());
      valueBoxDefEClass.getESuperTypes ().add (this.getModuleContained ());
      nativeDefEClass.getESuperTypes ().add (this.getTypedefDef ());
      nativeDefEClass.getESuperTypes ().add (this.getRepositoryContained ());
      nativeDefEClass.getESuperTypes ().add (this.getModuleContained ());
      nativeDefEClass.getESuperTypes ().add (this.getInterfaceContained ());
      nativeDefEClass.getESuperTypes ().add (this.getHomeContained ());
      memberEClass.getESuperTypes ().add (this.getTyped ());
      memberEClass.getESuperTypes ().add (this.getContained ());
      exceptionMemberEClass.getESuperTypes ().add (this.getMember ());
      exceptionMemberEClass.getESuperTypes ().add (this.getExceptionContained ());
      repositoryContainedEClass.getESuperTypes ().add (this.getContained ());
      moduleContainedEClass.getESuperTypes ().add (this.getContained ());
      exceptionContainedEClass.getESuperTypes ().add (this.getContained ());
      interfaceContainedEClass.getESuperTypes ().add (this.getContained ());
      structContainedEClass.getESuperTypes ().add (this.getContained ());
      unionContainedEClass.getESuperTypes ().add (this.getContained ());
      valueContainedEClass.getESuperTypes ().add (this.getContained ());
      sharedExpressionEClass.getESuperTypes ().add (this.getExpression ());
      ownedExpressionEClass.getESuperTypes ().add (this.getExpression ());
      expressionEClass.getESuperTypes ().add (this.getIRObject ());
      operatorEClass.getESuperTypes ().add (this.getOwnedExpression ());
      literalEClass.getESuperTypes ().add (this.getOwnedExpression ());
      bitwiseComplementOperatorEClass.getESuperTypes ().add (this.getUnaryOperator ());
      bitwiseRightShiftOperatorEClass.getESuperTypes ().add (this.getBinaryOperator ());
      bitwiseLeftShiftOperatorEClass.getESuperTypes ().add (this.getBinaryOperator ());
      bitwiseAndOperatorEClass.getESuperTypes ().add (this.getBinaryOperator ());
      addOperatorEClass.getESuperTypes ().add (this.getBinaryOperator ());
      bitwiseXorOperatorEClass.getESuperTypes ().add (this.getBinaryOperator ());
      positiveOperatorEClass.getESuperTypes ().add (this.getUnaryOperator ());
      negativeOperatorEClass.getESuperTypes ().add (this.getUnaryOperator ());
      bitwiseOrOperatorEClass.getESuperTypes ().add (this.getBinaryOperator ());
      subtractOperatorEClass.getESuperTypes ().add (this.getBinaryOperator ());
      multiplyOperatorEClass.getESuperTypes ().add (this.getBinaryOperator ());
      binaryOperatorEClass.getESuperTypes ().add (this.getOperator ());
      moduloOperatorEClass.getESuperTypes ().add (this.getBinaryOperator ());
      unaryOperatorEClass.getESuperTypes ().add (this.getOperator ());
      divideOperatorEClass.getESuperTypes ().add (this.getBinaryOperator ());
      enumContainedEClass.getESuperTypes ().add (this.getContained ());
      interfaceDeclEClass.getESuperTypes ().add (this.getInterface ());
      interfaceEClass.getESuperTypes ().add (this.getSharedIDLType ());
      interfaceEClass.getESuperTypes ().add (this.getModuleContained ());
      interfaceEClass.getESuperTypes ().add (this.getRepositoryContained ());
      prePragmaEClass.getESuperTypes ().add (this.getPragma ());
      postPragmaEClass.getESuperTypes ().add (this.getPragma ());
      scopePragmaEClass.getESuperTypes ().add (this.getPragma ());
      booleanLiteralEClass.getESuperTypes ().add (this.getLiteral ());
      characterLiteralEClass.getESuperTypes ().add (this.getLiteral ());
      fixedPointLiteralEClass.getESuperTypes ().add (this.getLiteral ());
      floatingPointLiteralEClass.getESuperTypes ().add (this.getLiteral ());
      integerLiteralEClass.getESuperTypes ().add (this.getLiteral ());
      stringLiteralEClass.getESuperTypes ().add (this.getLiteral ());
      wCharacterLiteralEClass.getESuperTypes ().add (this.getLiteral ());
      wStringLiteralEClass.getESuperTypes ().add (this.getLiteral ());
      valueEClass.getESuperTypes ().add (this.getModuleContained ());
      valueEClass.getESuperTypes ().add (this.getRepositoryContained ());
      valueEClass.getESuperTypes ().add (this.getSharedIDLType ());
      valueDeclEClass.getESuperTypes ().add (this.getValue ());
      initializerParameterDefEClass.getESuperTypes ().add (this.getTyped ());
      initializerParameterDefEClass.getESuperTypes ().add (this.getNamed ());
      componentEClass.getESuperTypes ().add (this.getModuleContained ());
      componentEClass.getESuperTypes ().add (this.getRepositoryContained ());
      componentEClass.getESuperTypes ().add (this.getSharedIDLType ());
      componentDefEClass.getESuperTypes ().add (this.getComponent ());
      componentDefEClass.getESuperTypes ().add (this.getContainer ());
      componentDefEClass.getESuperTypes ().add (this.getAttributeContainer ());
      componentDeclEClass.getESuperTypes ().add (this.getComponent ());
      componentContainedEClass.getESuperTypes ().add (this.getContained ());
      componentPortDefEClass.getESuperTypes ().add (this.getComponentContained ());
      homeEClass.getESuperTypes ().add (this.getModuleContained ());
      homeEClass.getESuperTypes ().add (this.getRepositoryContained ());
      homeEClass.getESuperTypes ().add (this.getSharedIDLType ());
      homeDefEClass.getESuperTypes ().add (this.getHome ());
      homeDefEClass.getESuperTypes ().add (this.getContainer ());
      homeDefEClass.getESuperTypes ().add (this.getAttributeContainer ());
      homeDefEClass.getESuperTypes ().add (this.getOperationContainer ());
      homeDefEClass.getESuperTypes ().add (this.getConstantContainer ());
      homeDefEClass.getESuperTypes ().add (this.getExceptionContainer ());
      homeDefEClass.getESuperTypes ().add (this.getAliasContainer ());
      homeDefEClass.getESuperTypes ().add (this.getStructContainer ());
      homeDefEClass.getESuperTypes ().add (this.getUnionContainer ());
      homeDefEClass.getESuperTypes ().add (this.getEnumContainer ());
      homeDefEClass.getESuperTypes ().add (this.getNativeContainer ());
      homeContainedEClass.getESuperTypes ().add (this.getContained ());
      factoryOperationEClass.getESuperTypes ().add (this.getHomeContained ());
      finderOperationEClass.getESuperTypes ().add (this.getHomeContained ());
      interfacePortDefEClass.getESuperTypes ().add (this.getComponentPortDef ());
      eventPortDefEClass.getESuperTypes ().add (this.getComponentPortDef ());
      providesDefEClass.getESuperTypes ().add (this.getInterfacePortDef ());
      usesDefEClass.getESuperTypes ().add (this.getInterfacePortDef ());
      consumesDefEClass.getESuperTypes ().add (this.getEventPortDef ());
      publishesDefEClass.getESuperTypes ().add (this.getEventPortDef ());
      emitsDefEClass.getESuperTypes ().add (this.getEventPortDef ());
      eventEClass.getESuperTypes ().add (this.getValue ());
      eventDeclEClass.getESuperTypes ().add (this.getEvent ());
      eventDeclEClass.getESuperTypes ().add (this.getValueDecl ());
      eventDefEClass.getESuperTypes ().add (this.getEvent ());
      eventDefEClass.getESuperTypes ().add (this.getValueDef ());
      attributeContainerEClass.getESuperTypes ().add (this.getContainer ());
      operationContainerEClass.getESuperTypes ().add (this.getContainer ());
      constantContainerEClass.getESuperTypes ().add (this.getContainer ());
      aliasContainerEClass.getESuperTypes ().add (this.getContainer ());
      nativeContainerEClass.getESuperTypes ().add (this.getContainer ());
      unionContainerEClass.getESuperTypes ().add (this.getContainer ());
      structContainerEClass.getESuperTypes ().add (this.getContainer ());
      enumContainerEClass.getESuperTypes ().add (this.getContainer ());
      exceptionContainerEClass.getESuperTypes ().add (this.getContainer ());

      // Initialize classes and features; add operations and parameters
      initEClass (moduleDefEClass, ModuleDef.class, "ModuleDef", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference (getModuleDef_ModuleContents (), this.getModuleContained (), this.getModuleContained_ContainingModule (),
            "moduleContents", null, 0, -1, ModuleDef.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
            !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference (getModuleDef_Interfaces (), this.getInterfaceDef (), null, "interfaces", null, 0, -1, ModuleDef.class,
            IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED,
            IS_ORDERED);
      initEReference (getModuleDef_Modules (), this.getModuleDef (), null, "modules", null, 0, -1, ModuleDef.class, IS_TRANSIENT,
            IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
      initEReference (getModuleDef_ValueTypes (), this.getValueDef (), null, "valueTypes", null, 0, -1, ModuleDef.class,
            IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED,
            IS_ORDERED);

      EOperation op = addEOperation (moduleDefEClass, this.getModuleDef (), "getAllModules", 1, -1, IS_UNIQUE, IS_ORDERED);
      addEParameter (op, ecorePackage.getEBoolean (), "inclusive", 1, 1, IS_UNIQUE, IS_ORDERED);

      addEOperation (moduleDefEClass, this.getValueBoxDef (), "getValueBoxes", 0, -1, IS_UNIQUE, IS_ORDERED);

      initEClass (containerEClass, Container.class, "Container", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference (getContainer_Contents (), this.getContained (), this.getContained_Container (), "contents", null, 0, -1,
            Container.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, IS_DERIVED, IS_ORDERED);

      op = addEOperation (containerEClass, this.getContained (), "lookup", 1, 1, IS_UNIQUE, IS_ORDERED);
      addEParameter (op, ecorePackage.getEString (), "name", 1, 1, IS_UNIQUE, IS_ORDERED);

      addEOperation (containerEClass, this.getIRObject (), "getPrerequisites", 0, -1, IS_UNIQUE, IS_ORDERED);

      op = addEOperation (containerEClass, this.getContained (), "lookup", 1, 1, IS_UNIQUE, IS_ORDERED);
      addEParameter (op, ecorePackage.getEString (), "name", 1, 1, IS_UNIQUE, IS_ORDERED);
      addEParameter (op, ecorePackage.getEBoolean (), "inherited", 1, 1, IS_UNIQUE, IS_ORDERED);
      addEParameter (op, ecorePackage.getEBoolean (), "global", 1, 1, IS_UNIQUE, IS_ORDERED);

      initEClass (irObjectEClass, IRObject.class, "IRObject", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEAttribute (getIRObject_Source (), ecorePackage.getEString (), "source", null, 0, 1, IRObject.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference (getIRObject_Pragmas (), this.getPragma (), this.getPragma_Owner (), "pragmas", null, 0, -1, IRObject.class,
            !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
            IS_ORDERED);
      initEReference (getIRObject_Repository (), this.getRepository (), null, "repository", null, 1, 1, IRObject.class,
            IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED,
            !IS_ORDERED);

      addEOperation (irObjectEClass, this.getIRObject (), "getPrerequisites", 0, -1, IS_UNIQUE, IS_ORDERED);

      initEClass (containedEClass, Contained.class, "Contained", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEAttribute (getContained_AbsoluteName (), ecorePackage.getEString (), "absoluteName", null, 1, 1, Contained.class,
            IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, !IS_ORDERED);
      initEAttribute (getContained_Prefix (), ecorePackage.getEString (), "prefix", null, 0, 1, Contained.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEAttribute (getContained_ID (), ecorePackage.getEString (), "ID", null, 0, 1, Contained.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, !IS_ORDERED);
      initEAttribute (getContained_Version (), ecorePackage.getEString (), "version", null, 0, 1, Contained.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference (getContained_Container (), this.getContainer (), this.getContainer_Contents (), "container", null, 0, 1,
            Contained.class, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, IS_DERIVED, !IS_ORDERED);

      initEClass (repositoryEClass, Repository.class, "Repository", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference (getRepository_RepositoryContents (), this.getRepositoryContained (), this
            .getRepositoryContained_ContainingRepository (), "repositoryContents", null, 0, -1, Repository.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference (getRepository_Includes (), this.getRepository (), null, "includes", null, 0, -1, Repository.class,
            !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
            IS_ORDERED);
      initEReference (getRepository_Enums (), this.getEnumDef (), null, "enums", null, 0, -1, Repository.class, IS_TRANSIENT,
            IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, !IS_ORDERED);
      initEReference (getRepository_Aliases (), this.getAliasDef (), null, "aliases", null, 0, -1, Repository.class, IS_TRANSIENT,
            IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, !IS_ORDERED);
      initEReference (getRepository_Constants (), this.getConstantDef (), null, "constants", null, 0, -1, Repository.class,
            IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED,
            IS_ORDERED);
      initEReference (getRepository_Exceptions (), this.getExceptionDef (), null, "exceptions", null, 0, -1, Repository.class,
            IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED,
            !IS_ORDERED);
      initEReference (getRepository_Interfaces (), this.getInterfaceDef (), null, "interfaces", null, 0, -1, Repository.class,
            IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED,
            IS_ORDERED);
      initEReference (getRepository_Modules (), this.getModuleDef (), null, "modules", null, 0, -1, Repository.class, IS_TRANSIENT,
            IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
      initEReference (getRepository_Natives (), this.getNativeDef (), null, "natives", null, 0, -1, Repository.class, IS_TRANSIENT,
            IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, !IS_ORDERED);
      initEReference (getRepository_Structs (), this.getStructDef (), null, "structs", null, 0, -1, Repository.class, IS_TRANSIENT,
            IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
      initEReference (getRepository_Unions (), this.getUnionDef (), null, "unions", null, 0, -1, Repository.class, IS_TRANSIENT,
            IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
      initEReference (getRepository_ValueTypes (), this.getValueDef (), null, "valueTypes", null, 0, -1, Repository.class,
            IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED,
            IS_ORDERED);

      op = addEOperation (repositoryEClass, this.getPrimitiveDef (), "createPrimitive", 1, 1, IS_UNIQUE, IS_ORDERED);
      addEParameter (op, this.getPrimitiveKind (), "kind", 1, 1, IS_UNIQUE, IS_ORDERED);

      op = addEOperation (repositoryEClass, this.getStringDef (), "createString", 1, 1, IS_UNIQUE, IS_ORDERED);
      addEParameter (op, ecorePackage.getEInt (), "bound", 1, 1, IS_UNIQUE, IS_ORDERED);

      op = addEOperation (repositoryEClass, this.getWStringDef (), "createWString", 1, 1, IS_UNIQUE, IS_ORDERED);
      addEParameter (op, ecorePackage.getEInt (), "bound", 1, 1, IS_UNIQUE, IS_ORDERED);

      op = addEOperation (repositoryEClass, this.getSequenceDef (), "createSequence", 1, 1, IS_UNIQUE, IS_ORDERED);
      addEParameter (op, ecorePackage.getEInt (), "bound", 1, 1, IS_UNIQUE, IS_ORDERED);
      addEParameter (op, this.getIDLType (), "elementType", 1, 1, IS_UNIQUE, IS_ORDERED);

      op = addEOperation (repositoryEClass, this.getArrayDef (), "createArray", 1, 1, IS_UNIQUE, IS_ORDERED);
      addEParameter (op, ecorePackage.getEInt (), "length", 1, 1, IS_UNIQUE, IS_ORDERED);
      addEParameter (op, this.getIDLType (), "elementType", 1, 1, IS_UNIQUE, IS_ORDERED);

      op = addEOperation (repositoryEClass, this.getFixedDef (), "createFixed", 1, 1, IS_UNIQUE, IS_ORDERED);
      addEParameter (op, ecorePackage.getEInt (), "digits", 1, 1, IS_UNIQUE, IS_ORDERED);
      addEParameter (op, ecorePackage.getEInt (), "scale", 1, 1, IS_UNIQUE, IS_ORDERED);

      addEOperation (repositoryEClass, this.getValueBoxDef (), "getValueBoxes", 0, -1, IS_UNIQUE, IS_ORDERED);

      op = addEOperation (repositoryEClass, this.getRepository (), "getAllIncludes", 0, -1, IS_UNIQUE, IS_ORDERED);
      addEParameter (op, ecorePackage.getEBoolean (), "inclusive", 1, 1, IS_UNIQUE, IS_ORDERED);

      initEClass (stringDefEClass, StringDef.class, "StringDef", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference (getStringDef_Bound (), this.getExpression (), null, "bound", null, 1, 1, StringDef.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference (getStringDef_OwnedBound (), this.getOwnedExpression (), null, "ownedBound", null, 0, 1, StringDef.class,
            !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
            !IS_ORDERED);

      addEOperation (stringDefEClass, this.getIRObject (), "getPrerequisites", 0, -1, IS_UNIQUE, IS_ORDERED);

      addEOperation (stringDefEClass, this.getIDLType (), "getExpressionType", 1, 1, IS_UNIQUE, IS_ORDERED);

      initEClass (idlTypeEClass, IDLType.class, "IDLType", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

      initEClass (typedefDefEClass, TypedefDef.class, "TypedefDef", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

      initEClass (aliasDefEClass, AliasDef.class, "AliasDef", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

      initEClass (primitiveDefEClass, PrimitiveDef.class, "PrimitiveDef", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEAttribute (getPrimitiveDef_Kind (), this.getPrimitiveKind (), "kind", null, 1, 1, PrimitiveDef.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      initEClass (pragmaEClass, Pragma.class, "Pragma", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEAttribute (getPragma_Text (), ecorePackage.getEString (), "text", null, 1, 1, Pragma.class, !IS_TRANSIENT, !IS_VOLATILE,
            IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference (getPragma_Owner (), this.getIRObject (), this.getIRObject_Pragmas (), "owner", null, 1, 1, Pragma.class,
            !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
            IS_ORDERED);
      initEReference (getPragma_Prerequisites (), this.getIRObject (), null, "prerequisites", null, 0, -1, Pragma.class,
            !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
            IS_ORDERED);

      initEClass (wStringDefEClass, WStringDef.class, "WStringDef", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference (getWStringDef_OwnedBound (), this.getOwnedExpression (), null, "ownedBound", null, 0, 1, WStringDef.class,
            !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
            !IS_ORDERED);
      initEReference (getWStringDef_Bound (), this.getExpression (), null, "bound", null, 1, 1, WStringDef.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

      addEOperation (wStringDefEClass, this.getIRObject (), "getPrerequisites", 0, -1, IS_UNIQUE, IS_ORDERED);

      addEOperation (wStringDefEClass, this.getIDLType (), "getExpressionType", 1, 1, IS_UNIQUE, IS_ORDERED);

      initEClass (sequenceDefEClass, SequenceDef.class, "SequenceDef", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference (getSequenceDef_Bound (), this.getExpression (), null, "bound", null, 1, 1, SequenceDef.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference (getSequenceDef_OwnedBound (), this.getOwnedExpression (), null, "ownedBound", null, 0, 1, SequenceDef.class,
            !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
            !IS_ORDERED);

      addEOperation (sequenceDefEClass, this.getIRObject (), "getPrerequisites", 0, -1, IS_UNIQUE, IS_ORDERED);

      addEOperation (sequenceDefEClass, this.getIDLType (), "getExpressionType", 1, 1, IS_UNIQUE, IS_ORDERED);

      initEClass (arrayDefEClass, ArrayDef.class, "ArrayDef", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference (getArrayDef_OwnedLength (), this.getOwnedExpression (), null, "ownedLength", null, 0, 1, ArrayDef.class,
            !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
            !IS_ORDERED);
      initEReference (getArrayDef_Length (), this.getExpression (), null, "length", null, 1, 1, ArrayDef.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

      addEOperation (arrayDefEClass, this.getIRObject (), "getPrerequisites", 0, -1, IS_UNIQUE, IS_ORDERED);

      addEOperation (arrayDefEClass, this.getIDLType (), "getExpressionType", 1, 1, IS_UNIQUE, IS_ORDERED);

      initEClass (fixedDefEClass, FixedDef.class, "FixedDef", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference (getFixedDef_Digits (), this.getExpression (), null, "digits", null, 1, 1, FixedDef.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference (getFixedDef_OwnedDigits (), this.getOwnedExpression (), null, "ownedDigits", null, 0, 1, FixedDef.class,
            !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
            !IS_ORDERED);
      initEReference (getFixedDef_Scale (), this.getExpression (), null, "scale", null, 1, 1, FixedDef.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference (getFixedDef_OwnedScale (), this.getOwnedExpression (), null, "ownedScale", null, 0, 1, FixedDef.class,
            !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
            !IS_ORDERED);

      addEOperation (fixedDefEClass, this.getIDLType (), "getExpressionType", 1, 1, IS_UNIQUE, IS_ORDERED);

      initEClass (structDefEClass, StructDef.class, "StructDef", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference (getStructDef_StructContents (), this.getStructContained (), this.getStructContained_ContainingStruct (),
            "structContents", null, 0, -1, StructDef.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
            !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference (getStructDef_Members (), this.getStructMember (), null, "members", null, 0, -1, StructDef.class,
            IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED,
            IS_ORDERED);

      op = addEOperation (structDefEClass, this.getStructMember (), "getMember", 0, 1, IS_UNIQUE, IS_ORDERED);
      addEParameter (op, ecorePackage.getEString (), "name", 1, 1, IS_UNIQUE, IS_ORDERED);

      initEClass (structMemberEClass, StructMember.class, "StructMember", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

      initEClass (interfaceDefEClass, InterfaceDef.class, "InterfaceDef", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference (getInterfaceDef_InterfaceContents (), this.getInterfaceContained (), this
            .getInterfaceContained_ContainingInterface (), "interfaceContents", null, 0, -1, InterfaceDef.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference (getInterfaceDef_BaseInterfaces (), this.getInterfaceDef (), null, "baseInterfaces", null, 0, -1,
            InterfaceDef.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference (getInterfaceDef_AllBaseInterfaces (), this.getInterfaceDef (), null, "allBaseInterfaces", null, 0, -1,
            InterfaceDef.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, IS_DERIVED, IS_ORDERED);
      initEReference (getInterfaceDef_AllContents (), this.getContained (), null, "allContents", null, 0, -1, InterfaceDef.class,
            IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED,
            IS_ORDERED);

      addEOperation (interfaceDefEClass, this.getIRObject (), "getPrerequisites", 0, -1, IS_UNIQUE, IS_ORDERED);

      initEClass (ownedIDLTypeEClass, OwnedIDLType.class, "OwnedIDLType", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

      initEClass (sharedIDLTypeEClass, SharedIDLType.class, "SharedIDLType", IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);

      initEClass (typedEClass, Typed.class, "Typed", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference (getTyped_OwnedType (), this.getOwnedIDLType (), null, "ownedType", null, 0, 1, Typed.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference (getTyped_Type (), this.getIDLType (), null, "type", null, 1, 1, Typed.class, IS_TRANSIENT, IS_VOLATILE,
            IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, !IS_ORDERED);
      initEReference (getTyped_SharedType (), this.getSharedIDLType (), null, "sharedType", null, 0, 1, Typed.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

      op = addEOperation (typedEClass, this.getIDLType (), "setType", 1, 1, IS_UNIQUE, IS_ORDERED);
      addEParameter (op, this.getPrimitiveKind (), "kind", 1, 1, IS_UNIQUE, IS_ORDERED);

      op = addEOperation (typedEClass, this.getIDLType (), "setType", 1, 1, IS_UNIQUE, IS_ORDERED);
      addEParameter (op, ecorePackage.getEString (), "name", 1, 1, IS_UNIQUE, IS_ORDERED);

      addEOperation (typedEClass, this.getIRObject (), "getPrerequisites", 0, -1, IS_UNIQUE, IS_ORDERED);

      initEClass (unionDefEClass, UnionDef.class, "UnionDef", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference (getUnionDef_UnionContents (), this.getUnionContained (), this.getUnionContained_ContainingUnion (),
            "unionContents", null, 0, -1, UnionDef.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
            !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference (getUnionDef_Members (), this.getUnionMember (), null, "members", null, 0, -1, UnionDef.class, IS_TRANSIENT,
            IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);

      addEOperation (unionDefEClass, this.getIRObject (), "getPrerequisites", 0, -1, IS_UNIQUE, IS_ORDERED);

      initEClass (enumDefEClass, EnumDef.class, "EnumDef", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference (getEnumDef_EnumContents (), this.getEnumContained (), this.getEnumContained_ContainingEnum (),
            "enumContents", null, 1, -1, EnumDef.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
            !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference (getEnumDef_Members (), this.getEnumMember (), null, "members", null, 0, -1, EnumDef.class, IS_TRANSIENT,
            IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);

      initEClass (constantDefEClass, ConstantDef.class, "ConstantDef", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference (getConstantDef_Value (), this.getExpression (), null, "value", null, 1, 1, ConstantDef.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference (getConstantDef_OwnedValue (), this.getOwnedExpression (), null, "ownedValue", null, 0, 1, ConstantDef.class,
            !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
            !IS_ORDERED);

      addEOperation (constantDefEClass, ecorePackage.getEJavaObject (), "getExpressionValue", 1, 1, IS_UNIQUE, IS_ORDERED);

      addEOperation (constantDefEClass, this.getIRObject (), "getPrerequisites", 0, -1, IS_UNIQUE, IS_ORDERED);

      addEOperation (constantDefEClass, this.getIDLType (), "getExpressionType", 1, 1, IS_UNIQUE, IS_ORDERED);

      initEClass (enumMemberEClass, EnumMember.class, "EnumMember", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

      addEOperation (enumMemberEClass, ecorePackage.getEJavaObject (), "getExpressionValue", 1, 1, IS_UNIQUE, IS_ORDERED);

      initEClass (unionMemberEClass, UnionMember.class, "UnionMember", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference (getUnionMember_OwnedLabels (), this.getOwnedExpression (), null, "ownedLabels", null, 0, -1,
            UnionMember.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference (getUnionMember_Labels (), this.getExpression (), null, "labels", null, 0, -1, UnionMember.class,
            !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
            !IS_ORDERED);

      addEOperation (unionMemberEClass, ecorePackage.getEBoolean (), "isDefault", 1, 1, IS_UNIQUE, IS_ORDERED);

      addEOperation (unionMemberEClass, this.getIDLType (), "getExpressionType", 1, 1, IS_UNIQUE, IS_ORDERED);

      initEClass (exceptionDefEClass, ExceptionDef.class, "ExceptionDef", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference (getExceptionDef_ExceptionContents (), this.getExceptionContained (), this
            .getExceptionContained_ContainingException (), "exceptionContents", null, 0, -1, ExceptionDef.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference (getExceptionDef_Members (), this.getExceptionMember (), null, "members", null, 0, -1, ExceptionDef.class,
            IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED,
            IS_ORDERED);

      op = addEOperation (exceptionDefEClass, this.getExceptionMember (), "getMember", 0, 1, IS_UNIQUE, IS_ORDERED);
      addEParameter (op, ecorePackage.getEString (), "name", 1, 1, IS_UNIQUE, IS_ORDERED);

      initEClass (attributeDefEClass, AttributeDef.class, "AttributeDef", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEAttribute (getAttributeDef_Mode (), this.getAttributeMode (), "mode", null, 1, 1, AttributeDef.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference (getAttributeDef_GetExceptions (), this.getExceptionDef (), null, "getExceptions", null, 0, -1,
            AttributeDef.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference (getAttributeDef_SetExceptions (), this.getExceptionDef (), null, "setExceptions", null, 0, -1,
            AttributeDef.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      addEOperation (attributeDefEClass, this.getIRObject (), "getPrerequisites", 0, -1, IS_UNIQUE, IS_ORDERED);

      initEClass (parameterDefEClass, ParameterDef.class, "ParameterDef", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEAttribute (getParameterDef_Mode (), this.getParameterMode (), "mode", null, 1, 1, ParameterDef.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference (getParameterDef_Operation (), this.getOperationDef (), this.getOperationDef_Parameters (), "operation", null,
            1, 1, ParameterDef.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      initEClass (operationDefEClass, OperationDef.class, "OperationDef", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEAttribute (getOperationDef_Contexts (), ecorePackage.getEString (), "contexts", null, 0, -1, OperationDef.class,
            !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEAttribute (getOperationDef_Mode (), this.getOperationMode (), "mode", null, 1, 1, OperationDef.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference (getOperationDef_Parameters (), this.getParameterDef (), this.getParameterDef_Operation (), "parameters",
            null, 0, -1, OperationDef.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference (getOperationDef_Exceptions (), this.getExceptionDef (), null, "exceptions", null, 0, -1, OperationDef.class,
            !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
            IS_ORDERED);

      addEOperation (operationDefEClass, this.getIRObject (), "getPrerequisites", 0, -1, IS_UNIQUE, IS_ORDERED);

      initEClass (valueMemberDefEClass, ValueMemberDef.class, "ValueMemberDef", !IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
      initEAttribute (getValueMemberDef_Access (), this.getVisibility (), "access", null, 1, 1, ValueMemberDef.class,
            !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

      initEClass (valueDefEClass, ValueDef.class, "ValueDef", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEAttribute (getValueDef_Custom (), ecorePackage.getEBoolean (), "custom", null, 1, 1, ValueDef.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEAttribute (getValueDef_Truncatable (), ecorePackage.getEBoolean (), "truncatable", null, 1, 1, ValueDef.class,
            !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference (getValueDef_BaseValues (), this.getValueDef (), null, "baseValues", null, 0, -1, ValueDef.class,
            !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
            IS_ORDERED);
      initEReference (getValueDef_ValueContents (), this.getValueContained (), this.getValueContained_ContainingValue (),
            "valueContents", null, 0, -1, ValueDef.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
            !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference (getValueDef_SupportedInterfaces (), this.getInterface (), null, "supportedInterfaces", null, 0, -1,
            ValueDef.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference (getValueDef_Members (), this.getValueMemberDef (), null, "members", null, 0, -1, ValueDef.class,
            IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED,
            IS_ORDERED);
      initEReference (getValueDef_Initializers (), this.getInitializer (), null, "initializers", null, 0, -1, ValueDef.class,
            IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED,
            IS_ORDERED);
      initEReference (getValueDef_AllContents (), this.getContained (), null, "allContents", null, 0, -1, ValueDef.class,
            IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED,
            IS_ORDERED);
      initEReference (getValueDef_AllBaseValues (), this.getValueDef (), null, "allBaseValues", null, 0, -1, ValueDef.class,
            IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED,
            !IS_ORDERED);
      initEReference (getValueDef_AllSupportedInterfaces (), this.getInterface (), null, "allSupportedInterfaces", null, 0, -1,
            ValueDef.class, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE,
            IS_DERIVED, IS_ORDERED);

      addEOperation (valueDefEClass, this.getIRObject (), "getPrerequisites", 0, -1, IS_UNIQUE, IS_ORDERED);

      initEClass (initializerEClass, Initializer.class, "Initializer", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference (getInitializer_Exceptions (), this.getExceptionDef (), null, "exceptions", null, 0, -1, Initializer.class,
            !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
            IS_ORDERED);
      initEReference (getInitializer_Parameters (), this.getInitializerParameterDef (), this
            .getInitializerParameterDef_Initializer (), "parameters", null, 0, -1, Initializer.class, !IS_TRANSIENT, !IS_VOLATILE,
            IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      addEOperation (initializerEClass, this.getIRObject (), "getPrerequisites", 0, -1, IS_UNIQUE, IS_ORDERED);

      initEClass (valueBoxDefEClass, ValueBoxDef.class, "ValueBoxDef", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

      initEClass (nativeDefEClass, NativeDef.class, "NativeDef", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

      initEClass (namedEClass, Named.class, "Named", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEAttribute (getNamed_Name (), ecorePackage.getEString (), "name", null, 1, 1, Named.class, !IS_TRANSIENT, !IS_VOLATILE,
            IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEAttribute (getNamed_Key (), ecorePackage.getEString (), "key", null, 1, 1, Named.class, IS_TRANSIENT, IS_VOLATILE,
            !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, !IS_ORDERED);

      initEClass (memberEClass, Member.class, "Member", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

      initEClass (exceptionMemberEClass, ExceptionMember.class, "ExceptionMember", !IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);

      initEClass (repositoryContainedEClass, RepositoryContained.class, "RepositoryContained", IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
      initEReference (getRepositoryContained_ContainingRepository (), this.getRepository (), this
            .getRepository_RepositoryContents (), "containingRepository", null, 0, 1, RepositoryContained.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

      initEClass (moduleContainedEClass, ModuleContained.class, "ModuleContained", IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
      initEReference (getModuleContained_ContainingModule (), this.getModuleDef (), this.getModuleDef_ModuleContents (),
            "containingModule", null, 0, 1, ModuleContained.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
            !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

      initEClass (exceptionContainedEClass, ExceptionContained.class, "ExceptionContained", IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
      initEReference (getExceptionContained_ContainingException (), this.getExceptionDef (), this
            .getExceptionDef_ExceptionContents (), "containingException", null, 0, 1, ExceptionContained.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

      initEClass (interfaceContainedEClass, InterfaceContained.class, "InterfaceContained", IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
      initEReference (getInterfaceContained_ContainingInterface (), this.getInterfaceDef (), this
            .getInterfaceDef_InterfaceContents (), "containingInterface", null, 0, 1, InterfaceContained.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

      initEClass (structContainedEClass, StructContained.class, "StructContained", IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
      initEReference (getStructContained_ContainingStruct (), this.getStructDef (), this.getStructDef_StructContents (),
            "containingStruct", null, 0, 1, StructContained.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
            !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

      initEClass (unionContainedEClass, UnionContained.class, "UnionContained", IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
      initEReference (getUnionContained_ContainingUnion (), this.getUnionDef (), this.getUnionDef_UnionContents (),
            "containingUnion", null, 0, 1, UnionContained.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
            !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

      initEClass (valueContainedEClass, ValueContained.class, "ValueContained", IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
      initEReference (getValueContained_ContainingValue (), this.getValueDef (), this.getValueDef_ValueContents (),
            "containingValue", null, 0, 1, ValueContained.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
            !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

      initEClass (sharedExpressionEClass, SharedExpression.class, "SharedExpression", IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);

      initEClass (ownedExpressionEClass, OwnedExpression.class, "OwnedExpression", IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);

      initEClass (expressionEClass, Expression.class, "Expression", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

      addEOperation (expressionEClass, ecorePackage.getEJavaObject (), "getExpressionValue", 1, 1, IS_UNIQUE, IS_ORDERED);

      initEClass (operatorEClass, Operator.class, "Operator", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

      initEClass (literalEClass, Literal.class, "Literal", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

      initEClass (bitwiseComplementOperatorEClass, BitwiseComplementOperator.class, "BitwiseComplementOperator", !IS_ABSTRACT,
            !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

      addEOperation (bitwiseComplementOperatorEClass, ecorePackage.getEJavaObject (), "getExpressionValue", 1, 1, IS_UNIQUE,
            IS_ORDERED);

      initEClass (bitwiseRightShiftOperatorEClass, BitwiseRightShiftOperator.class, "BitwiseRightShiftOperator", !IS_ABSTRACT,
            !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

      addEOperation (bitwiseRightShiftOperatorEClass, ecorePackage.getEJavaObject (), "getExpressionValue", 1, 1, IS_UNIQUE,
            IS_ORDERED);

      initEClass (bitwiseLeftShiftOperatorEClass, BitwiseLeftShiftOperator.class, "BitwiseLeftShiftOperator", !IS_ABSTRACT,
            !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

      addEOperation (bitwiseLeftShiftOperatorEClass, ecorePackage.getEJavaObject (), "getExpressionValue", 1, 1, IS_UNIQUE,
            IS_ORDERED);

      initEClass (bitwiseAndOperatorEClass, BitwiseAndOperator.class, "BitwiseAndOperator", !IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);

      addEOperation (bitwiseAndOperatorEClass, ecorePackage.getEJavaObject (), "getExpressionValue", 1, 1, IS_UNIQUE, IS_ORDERED);

      initEClass (addOperatorEClass, AddOperator.class, "AddOperator", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

      addEOperation (addOperatorEClass, ecorePackage.getEJavaObject (), "getExpressionValue", 1, 1, IS_UNIQUE, IS_ORDERED);

      initEClass (bitwiseXorOperatorEClass, BitwiseXorOperator.class, "BitwiseXorOperator", !IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);

      addEOperation (bitwiseXorOperatorEClass, ecorePackage.getEJavaObject (), "getExpressionValue", 1, 1, IS_UNIQUE, IS_ORDERED);

      initEClass (positiveOperatorEClass, PositiveOperator.class, "PositiveOperator", !IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);

      addEOperation (positiveOperatorEClass, ecorePackage.getEJavaObject (), "getExpressionValue", 1, 1, IS_UNIQUE, IS_ORDERED);

      initEClass (negativeOperatorEClass, NegativeOperator.class, "NegativeOperator", !IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);

      addEOperation (negativeOperatorEClass, ecorePackage.getEJavaObject (), "getExpressionValue", 1, 1, IS_UNIQUE, IS_ORDERED);

      initEClass (bitwiseOrOperatorEClass, BitwiseOrOperator.class, "BitwiseOrOperator", !IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);

      addEOperation (bitwiseOrOperatorEClass, ecorePackage.getEJavaObject (), "getExpressionValue", 1, 1, IS_UNIQUE, IS_ORDERED);

      initEClass (subtractOperatorEClass, SubtractOperator.class, "SubtractOperator", !IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);

      addEOperation (subtractOperatorEClass, ecorePackage.getEJavaObject (), "getExpressionValue", 1, 1, IS_UNIQUE, IS_ORDERED);

      initEClass (multiplyOperatorEClass, MultiplyOperator.class, "MultiplyOperator", !IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);

      addEOperation (multiplyOperatorEClass, ecorePackage.getEJavaObject (), "getExpressionValue", 1, 1, IS_UNIQUE, IS_ORDERED);

      initEClass (binaryOperatorEClass, BinaryOperator.class, "BinaryOperator", IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
      initEReference (getBinaryOperator_Rhs (), this.getExpression (), null, "rhs", null, 1, 1, BinaryOperator.class,
            !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
            !IS_ORDERED);
      initEReference (getBinaryOperator_Lhs (), this.getExpression (), null, "lhs", null, 1, 1, BinaryOperator.class,
            !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
            !IS_ORDERED);
      initEReference (getBinaryOperator_OwnedRhs (), this.getOwnedExpression (), null, "ownedRhs", null, 0, 1,
            BinaryOperator.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference (getBinaryOperator_OwnedLhs (), this.getOwnedExpression (), null, "ownedLhs", null, 0, 1,
            BinaryOperator.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

      addEOperation (binaryOperatorEClass, this.getIRObject (), "getPrerequisites", 0, -1, IS_UNIQUE, IS_ORDERED);

      initEClass (moduloOperatorEClass, ModuloOperator.class, "ModuloOperator", !IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);

      addEOperation (moduloOperatorEClass, ecorePackage.getEJavaObject (), "getExpressionValue", 1, 1, IS_UNIQUE, IS_ORDERED);

      initEClass (unaryOperatorEClass, UnaryOperator.class, "UnaryOperator", IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
      initEReference (getUnaryOperator_Operand (), this.getExpression (), null, "operand", null, 1, 1, UnaryOperator.class,
            !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
            !IS_ORDERED);
      initEReference (getUnaryOperator_OwnedOperand (), this.getOwnedExpression (), null, "ownedOperand", null, 0, 1,
            UnaryOperator.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

      addEOperation (unaryOperatorEClass, this.getIRObject (), "getPrerequisites", 0, -1, IS_UNIQUE, IS_ORDERED);

      initEClass (divideOperatorEClass, DivideOperator.class, "DivideOperator", !IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);

      addEOperation (divideOperatorEClass, ecorePackage.getEJavaObject (), "getExpressionValue", 1, 1, IS_UNIQUE, IS_ORDERED);

      initEClass (enumContainedEClass, EnumContained.class, "EnumContained", IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
      initEReference (getEnumContained_ContainingEnum (), this.getEnumDef (), this.getEnumDef_EnumContents (), "containingEnum",
            null, 0, 1, EnumContained.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

      initEClass (interfaceDeclEClass, InterfaceDecl.class, "InterfaceDecl", !IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);

      initEClass (interfaceEClass, Interface.class, "Interface", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEAttribute (getInterface_Modifier (), this.getInterfaceModifier (), "modifier", null, 1, 1, Interface.class,
            !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

      addEOperation (interfaceEClass, this.getIRObject (), "getPrerequisites", 0, -1, IS_UNIQUE, IS_ORDERED);

      initEClass (prePragmaEClass, PrePragma.class, "PrePragma", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

      initEClass (postPragmaEClass, PostPragma.class, "PostPragma", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

      initEClass (scopePragmaEClass, ScopePragma.class, "ScopePragma", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

      initEClass (booleanLiteralEClass, BooleanLiteral.class, "BooleanLiteral", !IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
      initEAttribute (getBooleanLiteral_ExpressionValue (), ecorePackage.getEBooleanObject (), "expressionValue", null, 1, 1,
            BooleanLiteral.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED,
            IS_ORDERED);

      initEClass (characterLiteralEClass, CharacterLiteral.class, "CharacterLiteral", !IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
      initEAttribute (getCharacterLiteral_ExpressionValue (), ecorePackage.getECharacterObject (), "expressionValue", null, 1, 1,
            CharacterLiteral.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED,
            IS_ORDERED);

      initEClass (fixedPointLiteralEClass, FixedPointLiteral.class, "FixedPointLiteral", !IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
      initEAttribute (getFixedPointLiteral_ExpressionValue (), ecorePackage.getEBigDecimal (), "expressionValue", null, 1, 1,
            FixedPointLiteral.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED,
            IS_ORDERED);

      initEClass (floatingPointLiteralEClass, FloatingPointLiteral.class, "FloatingPointLiteral", !IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
      initEAttribute (getFloatingPointLiteral_ExpressionValue (), ecorePackage.getEBigDecimal (), "expressionValue", null, 1, 1,
            FloatingPointLiteral.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED,
            IS_ORDERED);

      initEClass (integerLiteralEClass, IntegerLiteral.class, "IntegerLiteral", !IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
      initEAttribute (getIntegerLiteral_ExpressionValue (), ecorePackage.getEBigInteger (), "expressionValue", null, 1, 1,
            IntegerLiteral.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED,
            IS_ORDERED);

      initEClass (stringLiteralEClass, StringLiteral.class, "StringLiteral", !IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
      initEAttribute (getStringLiteral_ExpressionValue (), ecorePackage.getEString (), "expressionValue", null, 1, 1,
            StringLiteral.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED,
            IS_ORDERED);

      initEClass (wCharacterLiteralEClass, WCharacterLiteral.class, "WCharacterLiteral", !IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
      initEAttribute (getWCharacterLiteral_ExpressionValue (), ecorePackage.getECharacterObject (), "expressionValue", null, 1, 1,
            WCharacterLiteral.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED,
            IS_ORDERED);

      initEClass (wStringLiteralEClass, WStringLiteral.class, "WStringLiteral", !IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
      initEAttribute (getWStringLiteral_ExpressionValue (), ecorePackage.getEString (), "expressionValue", null, 1, 1,
            WStringLiteral.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED,
            IS_ORDERED);

      initEClass (expressionContextEClass, ExpressionContext.class, "ExpressionContext", IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);

      addEOperation (expressionContextEClass, this.getIDLType (), "getExpressionType", 1, 1, IS_UNIQUE, IS_ORDERED);

      initEClass (valueEClass, Value.class, "Value", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEAttribute (getValue_Abstract (), ecorePackage.getEBoolean (), "abstract", null, 1, 1, Value.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

      initEClass (valueDeclEClass, ValueDecl.class, "ValueDecl", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

      initEClass (initializerParameterDefEClass, InitializerParameterDef.class, "InitializerParameterDef", !IS_ABSTRACT,
            !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference (getInitializerParameterDef_Initializer (), this.getInitializer (), this.getInitializer_Parameters (),
            "initializer", null, 0, 1, InitializerParameterDef.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE,
            !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference (getInitializerParameterDef_FactoryOperation (), this.getFactoryOperation (), this
            .getFactoryOperation_Parameters (), "factoryOperation", null, 0, 1, InitializerParameterDef.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference (getInitializerParameterDef_FinderOperation (), this.getFinderOperation (), this
            .getFinderOperation_Parameters (), "finderOperation", null, 0, 1, InitializerParameterDef.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

      initEClass (componentEClass, Component.class, "Component", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

      initEClass (componentDefEClass, ComponentDef.class, "ComponentDef", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference (getComponentDef_BaseComponent (), this.getComponentDef (), null, "baseComponent", null, 0, 1,
            ComponentDef.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference (getComponentDef_SupportedInterfaces (), this.getInterfaceDef (), null, "supportedInterfaces", null, 0, -1,
            ComponentDef.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference (getComponentDef_AllBaseComponents (), this.getComponentDef (), null, "allBaseComponents", null, 0, -1,
            ComponentDef.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, IS_DERIVED, IS_ORDERED);
      initEReference (getComponentDef_AllSupportedInterfaces (), this.getInterfaceDef (), null, "allSupportedInterfaces", null, 0,
            -1, ComponentDef.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, IS_DERIVED, IS_ORDERED);
      initEReference (getComponentDef_ComponentContents (), this.getComponentContained (), this
            .getComponentContained_ContainingComponent (), "componentContents", null, 0, -1, ComponentDef.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference (getComponentDef_AllContents (), this.getContained (), null, "allContents", null, 0, -1, ComponentDef.class,
            IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED,
            IS_ORDERED);
      initEReference (getComponentDef_Ports (), this.getComponentPortDef (), null, "ports", null, 0, -1, ComponentDef.class,
            IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED,
            IS_ORDERED);
      initEReference (getComponentDef_AllPorts (), this.getComponentPortDef (), null, "allPorts", null, 0, -1, ComponentDef.class,
            IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED,
            IS_ORDERED);
      initEReference (getComponentDef_AllUsesPorts (), this.getUsesDef (), null, "allUsesPorts", null, 0, -1, ComponentDef.class,
            IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED,
            IS_ORDERED);
      initEReference (getComponentDef_UsesPorts (), this.getUsesDef (), null, "usesPorts", null, 0, -1, ComponentDef.class,
            IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED,
            IS_ORDERED);
      initEReference (getComponentDef_AllProvidesPorts (), this.getProvidesDef (), null, "allProvidesPorts", null, 0, -1,
            ComponentDef.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, IS_DERIVED, IS_ORDERED);
      initEReference (getComponentDef_ProvidesPorts (), this.getProvidesDef (), null, "providesPorts", null, 0, -1,
            ComponentDef.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, IS_DERIVED, IS_ORDERED);
      initEReference (getComponentDef_ConsumesPorts (), this.getConsumesDef (), null, "consumesPorts", null, 0, -1,
            ComponentDef.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, IS_DERIVED, IS_ORDERED);
      initEReference (getComponentDef_AllConsumesPorts (), this.getConsumesDef (), null, "allConsumesPorts", null, 0, -1,
            ComponentDef.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, IS_DERIVED, IS_ORDERED);
      initEReference (getComponentDef_PublishesPorts (), this.getPublishesDef (), null, "publishesPorts", null, 0, -1,
            ComponentDef.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, IS_DERIVED, IS_ORDERED);
      initEReference (getComponentDef_AllPublishesPorts (), this.getPublishesDef (), null, "allPublishesPorts", null, 0, -1,
            ComponentDef.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, IS_DERIVED, IS_ORDERED);
      initEReference (getComponentDef_EmitsPorts (), this.getEmitsDef (), null, "emitsPorts", null, 0, -1, ComponentDef.class,
            IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
            IS_ORDERED);
      initEReference (getComponentDef_AllEmitsPorts (), this.getEmitsDef (), null, "allEmitsPorts", null, 0, -1,
            ComponentDef.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, IS_DERIVED, IS_ORDERED);

      addEOperation (componentDefEClass, this.getIRObject (), "getPrerequisites", 0, -1, IS_UNIQUE, IS_ORDERED);

      initEClass (componentDeclEClass, ComponentDecl.class, "ComponentDecl", !IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);

      initEClass (componentContainedEClass, ComponentContained.class, "ComponentContained", IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
      initEReference (getComponentContained_ContainingComponent (), this.getComponentDef (), this
            .getComponentDef_ComponentContents (), "containingComponent", null, 0, 1, ComponentContained.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

      initEClass (componentPortDefEClass, ComponentPortDef.class, "ComponentPortDef", IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);

      initEClass (homeEClass, Home.class, "Home", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

      initEClass (homeDefEClass, HomeDef.class, "HomeDef", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference (getHomeDef_ManagedComponent (), this.getComponentDef (), null, "managedComponent", null, 1, 1, HomeDef.class,
            !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED,
            !IS_ORDERED);
      initEReference (getHomeDef_BaseHome (), this.getHomeDef (), null, "baseHome", null, 0, 1, HomeDef.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference (getHomeDef_AllBaseHomes (), this.getHomeDef (), null, "allBaseHomes", null, 0, -1, HomeDef.class,
            IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED,
            !IS_ORDERED);
      initEReference (getHomeDef_SupportedInterfaces (), this.getInterfaceDef (), null, "supportedInterfaces", null, 0, -1,
            HomeDef.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference (getHomeDef_AllSupportedInterfaces (), this.getInterfaceDef (), null, "allSupportedInterfaces", null, 0, -1,
            HomeDef.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE,
            IS_DERIVED, IS_ORDERED);
      initEReference (getHomeDef_Primarykey (), this.getValueDef (), null, "primarykey", null, 0, 1, HomeDef.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference (getHomeDef_HomeContents (), this.getHomeContained (), this.getHomeContained_ContainingHome (),
            "homeContents", null, 0, -1, HomeDef.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE,
            !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);
      initEReference (getHomeDef_FactoryOperations (), this.getFactoryOperation (), null, "factoryOperations", null, 0, -1,
            HomeDef.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE,
            IS_DERIVED, IS_ORDERED);
      initEReference (getHomeDef_AllFactoryOperations (), this.getFactoryOperation (), null, "allFactoryOperations", null, 0, -1,
            HomeDef.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE,
            IS_DERIVED, IS_ORDERED);
      initEReference (getHomeDef_FinderOperations (), this.getFinderOperation (), null, "finderOperations", null, 0, -1,
            HomeDef.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE,
            IS_DERIVED, IS_ORDERED);
      initEReference (getHomeDef_AllFinderOperations (), this.getFinderOperation (), null, "allFinderOperations", null, 0, -1,
            HomeDef.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE,
            IS_DERIVED, IS_ORDERED);

      addEOperation (homeDefEClass, this.getIRObject (), "getPrerequisites", 0, -1, IS_UNIQUE, !IS_ORDERED);

      initEClass (homeContainedEClass, HomeContained.class, "HomeContained", IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
      initEReference (getHomeContained_ContainingHome (), this.getHomeDef (), this.getHomeDef_HomeContents (), "containingHome",
            null, 0, 1, HomeContained.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

      initEClass (factoryOperationEClass, FactoryOperation.class, "FactoryOperation", !IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
      initEReference (getFactoryOperation_Parameters (), this.getInitializerParameterDef (), this
            .getInitializerParameterDef_FactoryOperation (), "parameters", null, 0, -1, FactoryOperation.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference (getFactoryOperation_Exceptions (), this.getExceptionDef (), null, "exceptions", null, 0, -1,
            FactoryOperation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      initEClass (finderOperationEClass, FinderOperation.class, "FinderOperation", !IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
      initEReference (getFinderOperation_Exceptions (), this.getExceptionDef (), null, "exceptions", null, 0, -1,
            FinderOperation.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
      initEReference (getFinderOperation_Parameters (), this.getInitializerParameterDef (), this
            .getInitializerParameterDef_FinderOperation (), "parameters", null, 0, -1, FinderOperation.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

      initEClass (interfacePortDefEClass, InterfacePortDef.class, "InterfacePortDef", IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
      initEReference (getInterfacePortDef_Interface_type (), this.getInterface (), null, "interface_type", null, 1, 1,
            InterfacePortDef.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

      initEClass (eventPortDefEClass, EventPortDef.class, "EventPortDef", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference (getEventPortDef_Event (), this.getEventDef (), null, "event", null, 1, 1, EventPortDef.class, !IS_TRANSIENT,
            !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

      initEClass (providesDefEClass, ProvidesDef.class, "ProvidesDef", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

      initEClass (usesDefEClass, UsesDef.class, "UsesDef", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEAttribute (getUsesDef_Mode (), this.getUsesMode (), "mode", null, 1, 1, UsesDef.class, !IS_TRANSIENT, !IS_VOLATILE,
            IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, !IS_ORDERED);

      initEClass (consumesDefEClass, ConsumesDef.class, "ConsumesDef", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

      initEClass (publishesDefEClass, PublishesDef.class, "PublishesDef", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

      initEClass (emitsDefEClass, EmitsDef.class, "EmitsDef", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

      initEClass (eventEClass, Event.class, "Event", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

      initEClass (eventDeclEClass, EventDecl.class, "EventDecl", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

      initEClass (eventDefEClass, EventDef.class, "EventDef", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
      initEReference (getEventDef_EventContents (), this.getValueContained (), null, "eventContents", null, 0, -1, EventDef.class,
            IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED,
            IS_ORDERED);

      addEOperation (eventDefEClass, this.getIRObject (), "getPrerequisites", 0, -1, IS_UNIQUE, !IS_ORDERED);

      initEClass (attributeContainerEClass, AttributeContainer.class, "AttributeContainer", IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
      initEReference (getAttributeContainer_Attributes (), this.getAttributeDef (), null, "attributes", null, 0, -1,
            AttributeContainer.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, IS_DERIVED, IS_ORDERED);
      initEReference (getAttributeContainer_AllAttributes (), this.getAttributeDef (), null, "allAttributes", null, 0, -1,
            AttributeContainer.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, IS_DERIVED, IS_ORDERED);

      initEClass (operationContainerEClass, OperationContainer.class, "OperationContainer", IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
      initEReference (getOperationContainer_Operations (), this.getOperationDef (), null, "operations", null, 0, -1,
            OperationContainer.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, IS_DERIVED, IS_ORDERED);
      initEReference (getOperationContainer_AllOperations (), this.getOperationDef (), null, "allOperations", null, 0, -1,
            OperationContainer.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, IS_DERIVED, IS_ORDERED);

      initEClass (constantContainerEClass, ConstantContainer.class, "ConstantContainer", IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
      initEReference (getConstantContainer_Constants (), this.getConstantDef (), null, "constants", null, 0, -1,
            ConstantContainer.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, IS_DERIVED, IS_ORDERED);
      initEReference (getConstantContainer_AllConstants (), this.getConstantDef (), null, "allConstants", null, 0, -1,
            ConstantContainer.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, IS_DERIVED, IS_ORDERED);

      initEClass (aliasContainerEClass, AliasContainer.class, "AliasContainer", IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
      initEReference (getAliasContainer_Aliases (), this.getAliasDef (), null, "aliases", null, 0, -1, AliasContainer.class,
            IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED,
            IS_ORDERED);
      initEReference (getAliasContainer_AllAliases (), this.getAliasDef (), null, "allAliases", null, 0, -1, AliasContainer.class,
            IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED,
            !IS_ORDERED);

      initEClass (nativeContainerEClass, NativeContainer.class, "NativeContainer", IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
      initEReference (getNativeContainer_Natives (), this.getNativeDef (), null, "natives", null, 0, -1, NativeContainer.class,
            IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED,
            !IS_ORDERED);
      initEReference (getNativeContainer_AllNatives (), this.getNativeDef (), null, "allNatives", null, 0, -1,
            NativeContainer.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, IS_DERIVED, !IS_ORDERED);

      initEClass (unionContainerEClass, UnionContainer.class, "UnionContainer", IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
      initEReference (getUnionContainer_Unions (), this.getUnionDef (), null, "unions", null, 0, -1, UnionContainer.class,
            IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED,
            IS_ORDERED);
      initEReference (getUnionContainer_AllUnions (), this.getUnionDef (), null, "allUnions", null, 0, -1, UnionContainer.class,
            IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED,
            IS_ORDERED);

      initEClass (structContainerEClass, StructContainer.class, "StructContainer", IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
      initEReference (getStructContainer_Structs (), this.getStructDef (), null, "structs", null, 0, -1, StructContainer.class,
            IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED,
            IS_ORDERED);
      initEReference (getStructContainer_AllStructs (), this.getStructDef (), null, "allStructs", null, 0, -1,
            StructContainer.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, IS_DERIVED, IS_ORDERED);

      initEClass (enumContainerEClass, EnumContainer.class, "EnumContainer", IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
      initEReference (getEnumContainer_Enums (), this.getEnumDef (), null, "enums", null, 0, -1, EnumContainer.class, IS_TRANSIENT,
            IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, !IS_ORDERED);
      initEReference (getEnumContainer_AllEnums (), this.getEnumDef (), null, "allEnums", null, 0, -1, EnumContainer.class,
            IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED,
            !IS_ORDERED);

      initEClass (exceptionContainerEClass, ExceptionContainer.class, "ExceptionContainer", IS_ABSTRACT, !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
      initEReference (getExceptionContainer_Exceptions (), this.getExceptionDef (), null, "exceptions", null, 0, -1,
            ExceptionContainer.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, IS_DERIVED, !IS_ORDERED);
      initEReference (getExceptionContainer_AllExceptions (), this.getExceptionDef (), null, "allExceptions", null, 0, -1,
            ExceptionContainer.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE,
            IS_UNIQUE, IS_DERIVED, !IS_ORDERED);

      // Initialize enums and add enum literals
      initEEnum (primitiveKindEEnum, PrimitiveKind.class, "PrimitiveKind");
      addEEnumLiteral (primitiveKindEEnum, PrimitiveKind.PK_NULL);
      addEEnumLiteral (primitiveKindEEnum, PrimitiveKind.PK_VOID);
      addEEnumLiteral (primitiveKindEEnum, PrimitiveKind.PK_SHORT);
      addEEnumLiteral (primitiveKindEEnum, PrimitiveKind.PK_LONG);
      addEEnumLiteral (primitiveKindEEnum, PrimitiveKind.PK_USHORT);
      addEEnumLiteral (primitiveKindEEnum, PrimitiveKind.PK_ULONG);
      addEEnumLiteral (primitiveKindEEnum, PrimitiveKind.PK_FLOAT);
      addEEnumLiteral (primitiveKindEEnum, PrimitiveKind.PK_DOUBLE);
      addEEnumLiteral (primitiveKindEEnum, PrimitiveKind.PK_BOOLEAN);
      addEEnumLiteral (primitiveKindEEnum, PrimitiveKind.PK_CHAR);
      addEEnumLiteral (primitiveKindEEnum, PrimitiveKind.PK_OCTET);
      addEEnumLiteral (primitiveKindEEnum, PrimitiveKind.PK_ANY);
      addEEnumLiteral (primitiveKindEEnum, PrimitiveKind.PK_TYPE_CODE);
      addEEnumLiteral (primitiveKindEEnum, PrimitiveKind.PK_PRINCIPAL);
      addEEnumLiteral (primitiveKindEEnum, PrimitiveKind.PK_STRING);
      addEEnumLiteral (primitiveKindEEnum, PrimitiveKind.PK_OBJREF);
      addEEnumLiteral (primitiveKindEEnum, PrimitiveKind.PK_LONGLONG);
      addEEnumLiteral (primitiveKindEEnum, PrimitiveKind.PK_ULONGLONG);
      addEEnumLiteral (primitiveKindEEnum, PrimitiveKind.PK_LONGDOUBLE);
      addEEnumLiteral (primitiveKindEEnum, PrimitiveKind.PK_WCHAR);
      addEEnumLiteral (primitiveKindEEnum, PrimitiveKind.PK_WSTRING);
      addEEnumLiteral (primitiveKindEEnum, PrimitiveKind.PK_VALUE_BASE);

      initEEnum (attributeModeEEnum, AttributeMode.class, "AttributeMode");
      addEEnumLiteral (attributeModeEEnum, AttributeMode.ATTR_NORMAL);
      addEEnumLiteral (attributeModeEEnum, AttributeMode.ATTR_READONLY);

      initEEnum (operationModeEEnum, OperationMode.class, "OperationMode");
      addEEnumLiteral (operationModeEEnum, OperationMode.OP_NORMAL);
      addEEnumLiteral (operationModeEEnum, OperationMode.OP_ONEWAY);

      initEEnum (parameterModeEEnum, ParameterMode.class, "ParameterMode");
      addEEnumLiteral (parameterModeEEnum, ParameterMode.PARAM_IN);
      addEEnumLiteral (parameterModeEEnum, ParameterMode.PARAM_OUT);
      addEEnumLiteral (parameterModeEEnum, ParameterMode.PARAM_INOUT);

      initEEnum (visibilityEEnum, Visibility.class, "Visibility");
      addEEnumLiteral (visibilityEEnum, Visibility.PRIVATE_MEMBER);
      addEEnumLiteral (visibilityEEnum, Visibility.PUBLIC_MEMBER);

      initEEnum (interfaceModifierEEnum, InterfaceModifier.class, "InterfaceModifier");
      addEEnumLiteral (interfaceModifierEEnum, InterfaceModifier.IF_REGULAR);
      addEEnumLiteral (interfaceModifierEEnum, InterfaceModifier.IF_LOCAL);
      addEEnumLiteral (interfaceModifierEEnum, InterfaceModifier.IF_ABSTRACT);

      initEEnum (usesModeEEnum, UsesMode.class, "UsesMode");
      addEEnumLiteral (usesModeEEnum, UsesMode.USES_NORMAL);
      addEEnumLiteral (usesModeEEnum, UsesMode.USES_MULTIPLE);

      // Create resource
      createResource (eNS_URI);

      // Create annotations
      // subsets
      createSubsetsAnnotations ();
      // union
      createUnionAnnotations ();
   }

   /**
    * Initializes the annotations for <b>subsets</b>.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected void createSubsetsAnnotations ()
   {
      String source = "subsets";
      addAnnotation (getModuleDef_ModuleContents (), source, new String[] {});
      addAnnotation (getRepository_RepositoryContents (), source, new String[] {});
      addAnnotation (getStructDef_StructContents (), source, new String[] {});
      addAnnotation (getInterfaceDef_InterfaceContents (), source, new String[] {});
      addAnnotation (getUnionDef_UnionContents (), source, new String[] {});
      addAnnotation (getEnumDef_EnumContents (), source, new String[] {});
      addAnnotation (getExceptionDef_ExceptionContents (), source, new String[] {});
      addAnnotation (getValueDef_ValueContents (), source, new String[] {});
      addAnnotation (getRepositoryContained_ContainingRepository (), source, new String[] {});
      addAnnotation (getModuleContained_ContainingModule (), source, new String[] {});
      addAnnotation (getExceptionContained_ContainingException (), source, new String[] {});
      addAnnotation (getInterfaceContained_ContainingInterface (), source, new String[] {});
      addAnnotation (getStructContained_ContainingStruct (), source, new String[] {});
      addAnnotation (getUnionContained_ContainingUnion (), source, new String[] {});
      addAnnotation (getValueContained_ContainingValue (), source, new String[] {});
      addAnnotation (getEnumContained_ContainingEnum (), source, new String[] {});
      addAnnotation (getComponentDef_ComponentContents (), source, new String[] {});
      addAnnotation (getComponentContained_ContainingComponent (), source, new String[] {});
      addAnnotation (getHomeDef_HomeContents (), source, new String[] {});
      addAnnotation (getHomeContained_ContainingHome (), source, new String[] {});
   }

   /**
    * Initializes the annotations for <b>union</b>.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   protected void createUnionAnnotations ()
   {
      String source = "union";
      addAnnotation (getContainer_Contents (), source, new String[] {});
      addAnnotation (getContained_Container (), source, new String[] {});
   }

} // IdlmmPackageImpl
