// $ANTLR 2.7.7 (2006-11-01): "IdlTreeParser.g" -> "IdlTreeParser.java"$

/*
 * COPYRIGHT NOTICE 
 *
 * The information contained herein and which follows is proprietary
 * information and is the property of PrismTech Corporation.  This
 * information is not to be divulged, released, copied, reproduced, or
 * conveyed to unauthorized personnel, companies, or other institutions
 * without the direct and expressed approval in writing of PrismTech
 * Corporation.
 *
 * DISCLAIMER
 * 
 * Neither PrismTech Limited nor PrismTech Corporation ("PrismTech")
 * are under any obligation to support the use of this code which is
 * provided without warranty of any kind. PrismTech shall (except as
 * otherwise prohibited by law) have no liability whatsoever in relation
 * to its use.
 */

package com.prismtech.idt.imports.idl.internal.importer;

import java.util.*;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.MultiStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.emf.ecore.*;

import com.prismtech.idt.idlmm.*;
import com.prismtech.idt.imports.idl.importer.*;

import com.prismtech.idt.imports.idl.parser.IdlParserAST;

import antlr.TreeParser;
import antlr.Token;
import antlr.collections.AST;
import antlr.RecognitionException;
import antlr.ANTLRException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.collections.impl.BitSet;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;


public class IdlTreeParser extends antlr.TreeParser       implements IdlTreeParserTokenTypes
 {

   // ---------members
   private IdlmmBuilder m_builder;

   /**
    * This is a list of {@link IStatus} objects that contain the details of any
    * problems encountered during the {@link #parse(IdlParserAST) parse}
    */
   private final StatusHolder m_statusHolder = new StatusHolder();

   // ---------Java methods

   public IdlTreeParser(IIdlSourceComposer sourceAttrComposer, List<IIdlPragmaHandler> pragmaHandlers)
   {
      m_builder = new IdlmmBuilder(m_statusHolder, sourceAttrComposer, pragmaHandlers);
      tokenNames = _tokenNames;      
      this.getASTFactory().setASTNodeClass (IdlParserAST.class);
   } 
    
   /**
    * Returns the first object that was encountered when tree parsing was
    * started. For example, if {@link #specification(IdlParserAST)} is called as the
    * initial rule, then this will return a {@link Repository}.
    */
   public <T extends EObject> T getRootObject (Class<T> type)
   {
      return m_builder.getRootObject (type);
   }

   /**
    * Calls the {@link #specification(IdlParserAST)} rule to parse the specified {@link IdlParserAST}.
    * Any problems encountered will be returned in the {@link IStatus}
    * 
    * @return The details of any warnings or errors found during the
    *         parse/populate
    */
   public IStatus parse (IdlParserAST ast)
   {
      m_statusHolder.reset ();      
      try
      {
         specification (ast);
      }
      catch (RecognitionException e)
      {
         reportError(e);
      }
      return getStatus ();
   }

   /**
    * Removes the '_' escape character from ESCAPED_IDENT tokens.
    *
    * @return The modified token
    */
   private IdlParserAST removeEscape (IdlParserAST ast)
   {
      String text = ast.getText ();
      ast.setText (text.substring (1));
      return ast;
   }

   /**
    * 
    */
   public IStatus getStatus ()
   {
      List<IStatus> status = m_statusHolder.getStatus(); 
      switch (status.size ())
      {
         case 0:
         {
            return new Status (IStatus.OK, IdlImporterPlugin.PLUGIN_ID, 0, "", null);
         }
         case 1:
         {
            return status.get (0);
         }
         default:
         {
            MultiStatus st = new MultiStatus (IdlImporterPlugin.PLUGIN_ID, 0, "", null);
            for (IStatus s : status)
            {
               st.add (s);
            }
            return st;
         }
      }
   }

   @Override
   public void reportError (RecognitionException exception)
   {
      m_statusHolder.addStatusItem (new IdlImporterStatus(exception));
   }

   @Override
   public void reportError (String message)
   {
      m_statusHolder.addStatusItem (new IdlImporterStatus (this, IStatus.ERROR, message, null));
   }
public IdlTreeParser() {
 tokenNames = _tokenNames;
}

 public final void specification(AST _t) throws RecognitionException {
  
  IdlParserAST specification_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST specification_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  try {      // for error handling
   AST __t2 = _t;
   i1 = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   ASTPair __currentAST2 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,SPECIFICATION);
   _t = _t.getFirstChild();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startRepository (i1);
    
   }
   definition_list(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endRepository ();
    
   }
   currentAST = __currentAST2;
   _t = __t2;
   _t = _t.getNextSibling();
   specification_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = specification_AST;
  _retTree = _t;
 }
 
 public final void definition_list(AST _t) throws RecognitionException {
  
  IdlParserAST definition_list_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST definition_list_AST = null;
  
  try {      // for error handling
   {
   _loop6:
   do {
    if (_t==null) _t=ASTNULL;
    if ((_tokenSet_0.member(_t.getType()))) {
     if ( inputState.guessing==0 ) {
      
      this.m_builder.startDefinition();
      
     }
     definition(_t);
     _t = _retTree;
     astFactory.addASTChild(currentAST, returnAST);
     if ( inputState.guessing==0 ) {
      
      this.m_builder.endDefinition();
      
     }
    }
    else {
     break _loop6;
    }
    
   } while (true);
   }
   definition_list_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = definition_list_AST;
  _retTree = _t;
 }
 
 public final void definition(AST _t) throws RecognitionException {
  
  IdlParserAST definition_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST definition_AST = null;
  
  try {      // for error handling
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_interface:
   {
    interface_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    definition_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_module:
   {
    module(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    definition_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_typedef:
   case LITERAL_native:
   case LITERAL_struct:
   case LITERAL_union:
   case LITERAL_enum:
   {
    type_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    definition_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_const:
   {
    const_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    definition_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case PRAGMA:
   {
    pragma_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    definition_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_exception:
   {
    exception_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    definition_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_component:
   {
    component_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    definition_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_home:
   {
    home_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    definition_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_typeid:
   {
    type_id_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    definition_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_typeprefix:
   {
    type_prefix_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    definition_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
    if (_t==null) _t=ASTNULL;
    if ((_t.getType()==LITERAL_valuetype)) {
     value(_t);
     _t = _retTree;
     astFactory.addASTChild(currentAST, returnAST);
     definition_AST = (IdlParserAST)currentAST.root;
    }
    else if ((_t.getType()==LITERAL_valuetype||_t.getType()==LITERAL_eventtype)) {
     event(_t);
     _t = _retTree;
     astFactory.addASTChild(currentAST, returnAST);
     definition_AST = (IdlParserAST)currentAST.root;
    }
   else {
    throw new NoViableAltException(_t);
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = definition_AST;
  _retTree = _t;
 }
 
 public final void interface_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST interface_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST interface_dcl_AST = null;
  
  try {      // for error handling
   boolean synPredMatched162 = false;
   if (_t==null) _t=ASTNULL;
   if (((_t.getType()==LITERAL_interface))) {
    AST __t162 = _t;
    synPredMatched162 = true;
    inputState.guessing++;
    try {
     {
     interface_def(_t);
     _t = _retTree;
     }
    }
    catch (RecognitionException pe) {
     synPredMatched162 = false;
    }
    _t = __t162;
inputState.guessing--;
   }
   if ( synPredMatched162 ) {
    interface_def(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    interface_dcl_AST = (IdlParserAST)currentAST.root;
   }
   else if ((_t.getType()==LITERAL_interface)) {
    interface_forward_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    interface_dcl_AST = (IdlParserAST)currentAST.root;
   }
   else {
    throw new NoViableAltException(_t);
   }
   
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = interface_dcl_AST;
  _retTree = _t;
 }
 
 public final void module(AST _t) throws RecognitionException {
  
  IdlParserAST module_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST module_AST = null;
  IdlParserAST module_literal = null;
  IdlParserAST module_literal_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  IdlParserAST i2 = null;
  IdlParserAST i2_AST = null;
  
  try {      // for error handling
   AST __t8 = _t;
   module_literal = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST module_literal_AST_in = null;
   module_literal_AST = (IdlParserAST)astFactory.create(module_literal);
   astFactory.addASTChild(currentAST, module_literal_AST);
   ASTPair __currentAST8 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_module);
   _t = _t.getFirstChild();
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case IDENT:
   {
    i1 = (IdlParserAST)_t;
    IdlParserAST i1_AST_in = null;
    i1_AST = (IdlParserAST)astFactory.create(i1);
    astFactory.addASTChild(currentAST, i1_AST);
    match(_t,IDENT);
    _t = _t.getNextSibling();
    break;
   }
   case ESCAPED_IDENT:
   {
    i2 = (IdlParserAST)_t;
    IdlParserAST i2_AST_in = null;
    i2_AST = (IdlParserAST)astFactory.create(i2);
    astFactory.addASTChild(currentAST, i2_AST);
    match(_t,ESCAPED_IDENT);
    _t = _t.getNextSibling();
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   if ( inputState.guessing==0 ) {
    
    IdlParserAST ast = (i1 != null) ? i1 : this.removeEscape (i2);
    this.m_builder.startModule (ast, module_literal);
    
   }
   definition_list(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endModule();
    
   }
   currentAST = __currentAST8;
   _t = __t8;
   _t = _t.getNextSibling();
   module_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = module_AST;
  _retTree = _t;
 }
 
 public final void type_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST type_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST type_dcl_AST = null;
  
  try {      // for error handling
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_typedef:
   {
    typedef_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    type_dcl_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_enum:
   {
    enum_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    type_dcl_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_native:
   {
    native_decl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    type_dcl_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
    boolean synPredMatched12 = false;
    if (_t==null) _t=ASTNULL;
    if (((_t.getType()==LITERAL_struct))) {
     AST __t12 = _t;
     synPredMatched12 = true;
     inputState.guessing++;
     try {
      {
      struct_type(_t);
      _t = _retTree;
      }
     }
     catch (RecognitionException pe) {
      synPredMatched12 = false;
     }
     _t = __t12;
inputState.guessing--;
    }
    if ( synPredMatched12 ) {
     struct_type(_t);
     _t = _retTree;
     astFactory.addASTChild(currentAST, returnAST);
     type_dcl_AST = (IdlParserAST)currentAST.root;
    }
    else {
     boolean synPredMatched14 = false;
     if (_t==null) _t=ASTNULL;
     if (((_t.getType()==LITERAL_union))) {
      AST __t14 = _t;
      synPredMatched14 = true;
      inputState.guessing++;
      try {
       {
       union_type(_t);
       _t = _retTree;
       }
      }
      catch (RecognitionException pe) {
       synPredMatched14 = false;
      }
      _t = __t14;
inputState.guessing--;
     }
     if ( synPredMatched14 ) {
      union_type(_t);
      _t = _retTree;
      astFactory.addASTChild(currentAST, returnAST);
      type_dcl_AST = (IdlParserAST)currentAST.root;
     }
     else if ((_t.getType()==LITERAL_struct||_t.getType()==LITERAL_union)) {
      constr_forward_decl(_t);
      _t = _retTree;
      astFactory.addASTChild(currentAST, returnAST);
      type_dcl_AST = (IdlParserAST)currentAST.root;
     }
    else {
     throw new NoViableAltException(_t);
    }
    }}
   }
   catch (RecognitionException ex) {
    if (inputState.guessing==0) {
     reportError(ex);
     if (_t!=null) {_t = _t.getNextSibling();}
    } else {
      throw ex;
    }
   }
   returnAST = type_dcl_AST;
   _retTree = _t;
  }
  
 public final void const_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST const_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST const_dcl_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  IdlParserAST i2 = null;
  IdlParserAST i2_AST = null;
  IdlParserAST i3 = null;
  IdlParserAST i3_AST = null;
  
  try {      // for error handling
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startConstType();
    
   }
   AST __t21 = _t;
   i1 = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   ASTPair __currentAST21 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_const);
   _t = _t.getFirstChild();
   const_type(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case IDENT:
   {
    i2 = (IdlParserAST)_t;
    IdlParserAST i2_AST_in = null;
    i2_AST = (IdlParserAST)astFactory.create(i2);
    astFactory.addASTChild(currentAST, i2_AST);
    match(_t,IDENT);
    _t = _t.getNextSibling();
    break;
   }
   case ESCAPED_IDENT:
   {
    i3 = (IdlParserAST)_t;
    IdlParserAST i3_AST_in = null;
    i3_AST = (IdlParserAST)astFactory.create(i3);
    astFactory.addASTChild(currentAST, i3_AST);
    match(_t,ESCAPED_IDENT);
    _t = _t.getNextSibling();
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   if ( inputState.guessing==0 ) {
    
    IdlParserAST ast = (i2 != null) ? i2 : this.removeEscape (i3);
    this.m_builder.constMetaPoint(ast, i1);
    
   }
   const_or_scoped_decl(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   currentAST = __currentAST21;
   _t = __t21;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endConstType();
    
   }
   const_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = const_dcl_AST;
  _retTree = _t;
 }
 
 public final void pragma_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST pragma_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST pragma_dcl_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  try {      // for error handling
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startPragmaType();
    
   }
   i1 = (IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   match(_t,PRAGMA);
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    
    this.m_builder.endPragmaType(i1);
    
   }
   pragma_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = pragma_dcl_AST;
  _retTree = _t;
 }
 
 public final void exception_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST exception_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST exception_dcl_AST = null;
  IdlParserAST exception_literal = null;
  IdlParserAST exception_literal_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  IdlParserAST i2 = null;
  IdlParserAST i2_AST = null;
  
  try {      // for error handling
   AST __t232 = _t;
   exception_literal = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST exception_literal_AST_in = null;
   exception_literal_AST = (IdlParserAST)astFactory.create(exception_literal);
   astFactory.addASTChild(currentAST, exception_literal_AST);
   ASTPair __currentAST232 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_exception);
   _t = _t.getFirstChild();
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case IDENT:
   {
    i1 = (IdlParserAST)_t;
    IdlParserAST i1_AST_in = null;
    i1_AST = (IdlParserAST)astFactory.create(i1);
    astFactory.addASTChild(currentAST, i1_AST);
    match(_t,IDENT);
    _t = _t.getNextSibling();
    break;
   }
   case ESCAPED_IDENT:
   {
    i2 = (IdlParserAST)_t;
    IdlParserAST i2_AST_in = null;
    i2_AST = (IdlParserAST)astFactory.create(i2);
    astFactory.addASTChild(currentAST, i2_AST);
    match(_t,ESCAPED_IDENT);
    _t = _t.getNextSibling();
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   if ( inputState.guessing==0 ) {
    
    IdlParserAST ast = (i1 != null) ? i1 : this.removeEscape (i2);
    this.m_builder.startExceptionDecl(ast, exception_literal);
    
   }
   exception_member_list(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endExceptionDecl();
    
   }
   currentAST = __currentAST232;
   _t = __t232;
   _t = _t.getNextSibling();
   exception_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = exception_dcl_AST;
  _retTree = _t;
 }
 
 public final void value(AST _t) throws RecognitionException {
  
  IdlParserAST value_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST value_AST = null;
  
  try {      // for error handling
   boolean synPredMatched115 = false;
   if (_t==null) _t=ASTNULL;
   if (((_t.getType()==LITERAL_valuetype))) {
    AST __t115 = _t;
    synPredMatched115 = true;
    inputState.guessing++;
    try {
     {
     value_dcl(_t);
     _t = _retTree;
     }
    }
    catch (RecognitionException pe) {
     synPredMatched115 = false;
    }
    _t = __t115;
inputState.guessing--;
   }
   if ( synPredMatched115 ) {
    value_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    value_AST = (IdlParserAST)currentAST.root;
   }
   else {
    boolean synPredMatched117 = false;
    if (_t==null) _t=ASTNULL;
    if (((_t.getType()==LITERAL_valuetype))) {
     AST __t117 = _t;
     synPredMatched117 = true;
     inputState.guessing++;
     try {
      {
      value_abs_dcl(_t);
      _t = _retTree;
      }
     }
     catch (RecognitionException pe) {
      synPredMatched117 = false;
     }
     _t = __t117;
inputState.guessing--;
    }
    if ( synPredMatched117 ) {
     value_abs_dcl(_t);
     _t = _retTree;
     astFactory.addASTChild(currentAST, returnAST);
     value_AST = (IdlParserAST)currentAST.root;
    }
    else {
     boolean synPredMatched119 = false;
     if (_t==null) _t=ASTNULL;
     if (((_t.getType()==LITERAL_valuetype))) {
      AST __t119 = _t;
      synPredMatched119 = true;
      inputState.guessing++;
      try {
       {
       value_box_dcl(_t);
       _t = _retTree;
       }
      }
      catch (RecognitionException pe) {
       synPredMatched119 = false;
      }
      _t = __t119;
inputState.guessing--;
     }
     if ( synPredMatched119 ) {
      value_box_dcl(_t);
      _t = _retTree;
      astFactory.addASTChild(currentAST, returnAST);
      value_AST = (IdlParserAST)currentAST.root;
     }
     else if ((_t.getType()==LITERAL_valuetype)) {
      value_forward_dcl(_t);
      _t = _retTree;
      astFactory.addASTChild(currentAST, returnAST);
      value_AST = (IdlParserAST)currentAST.root;
     }
     else {
      throw new NoViableAltException(_t);
     }
     }}
    }
    catch (RecognitionException ex) {
     if (inputState.guessing==0) {
      reportError(ex);
      if (_t!=null) {_t = _t.getNextSibling();}
     } else {
       throw ex;
     }
    }
    returnAST = value_AST;
    _retTree = _t;
   }
   
 public final void event(AST _t) throws RecognitionException {
  
  IdlParserAST event_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST event_AST = null;
  
  try {      // for error handling
   boolean synPredMatched336 = false;
   if (_t==null) _t=ASTNULL;
   if (((_t.getType()==LITERAL_eventtype))) {
    AST __t336 = _t;
    synPredMatched336 = true;
    inputState.guessing++;
    try {
     {
     event_dcl(_t);
     _t = _retTree;
     }
    }
    catch (RecognitionException pe) {
     synPredMatched336 = false;
    }
    _t = __t336;
inputState.guessing--;
   }
   if ( synPredMatched336 ) {
    event_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    event_AST = (IdlParserAST)currentAST.root;
   }
   else {
    boolean synPredMatched338 = false;
    if (_t==null) _t=ASTNULL;
    if (((_t.getType()==LITERAL_eventtype))) {
     AST __t338 = _t;
     synPredMatched338 = true;
     inputState.guessing++;
     try {
      {
      event_abs_dcl(_t);
      _t = _retTree;
      }
     }
     catch (RecognitionException pe) {
      synPredMatched338 = false;
     }
     _t = __t338;
inputState.guessing--;
    }
    if ( synPredMatched338 ) {
     event_abs_dcl(_t);
     _t = _retTree;
     astFactory.addASTChild(currentAST, returnAST);
     event_AST = (IdlParserAST)currentAST.root;
    }
    else if ((_t.getType()==LITERAL_valuetype)) {
     event_forward_dcl(_t);
     _t = _retTree;
     astFactory.addASTChild(currentAST, returnAST);
     event_AST = (IdlParserAST)currentAST.root;
    }
    else {
     throw new NoViableAltException(_t);
    }
    }
   }
   catch (RecognitionException ex) {
    if (inputState.guessing==0) {
     reportError(ex);
     if (_t!=null) {_t = _t.getNextSibling();}
    } else {
      throw ex;
    }
   }
   returnAST = event_AST;
   _retTree = _t;
  }
  
 public final void component_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST component_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST component_dcl_AST = null;
  
  try {      // for error handling
   boolean synPredMatched355 = false;
   if (_t==null) _t=ASTNULL;
   if (((_t.getType()==LITERAL_component))) {
    AST __t355 = _t;
    synPredMatched355 = true;
    inputState.guessing++;
    try {
     {
     component_def(_t);
     _t = _retTree;
     }
    }
    catch (RecognitionException pe) {
     synPredMatched355 = false;
    }
    _t = __t355;
inputState.guessing--;
   }
   if ( synPredMatched355 ) {
    component_def(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    component_dcl_AST = (IdlParserAST)currentAST.root;
   }
   else if ((_t.getType()==LITERAL_component)) {
    component_forward_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    component_dcl_AST = (IdlParserAST)currentAST.root;
   }
   else {
    throw new NoViableAltException(_t);
   }
   
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = component_dcl_AST;
  _retTree = _t;
 }
 
 public final void home_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST home_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST home_dcl_AST = null;
  IdlParserAST home_literal = null;
  IdlParserAST home_literal_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  try {      // for error handling
   AST __t389 = _t;
   home_literal = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST home_literal_AST_in = null;
   home_literal_AST = (IdlParserAST)astFactory.create(home_literal);
   astFactory.addASTChild(currentAST, home_literal_AST);
   ASTPair __currentAST389 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_home);
   _t = _t.getFirstChild();
   i1 = (IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   match(_t,IDENT);
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startHomeType(i1, home_literal);
    
   }
   home_header(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   IdlParserAST tmp1_AST = null;
   IdlParserAST tmp1_AST_in = null;
   tmp1_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp1_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp1_AST);
   match(_t,LCURLY);
   _t = _t.getNextSibling();
   home_body(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   IdlParserAST tmp2_AST = null;
   IdlParserAST tmp2_AST_in = null;
   tmp2_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp2_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp2_AST);
   match(_t,RCURLY);
   _t = _t.getNextSibling();
   currentAST = __currentAST389;
   _t = __t389;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endHomeType();
    
   }
   home_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = home_dcl_AST;
  _retTree = _t;
 }
 
 public final void type_id_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST type_id_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST type_id_dcl_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  try {      // for error handling
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startTypeIdDcl();
    
   }
   AST __t182 = _t;
   i1 = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   ASTPair __currentAST182 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_typeid);
   _t = _t.getFirstChild();
   scoped_name(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   string_literal(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   currentAST = __currentAST182;
   _t = __t182;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endTypeIdDcl(i1);
    
   }
   type_id_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = type_id_dcl_AST;
  _retTree = _t;
 }
 
 public final void type_prefix_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST type_prefix_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST type_prefix_dcl_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  try {      // for error handling
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startTypePrefixDcl();
    
   }
   AST __t184 = _t;
   i1 = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   ASTPair __currentAST184 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_typeprefix);
   _t = _t.getFirstChild();
   scoped_name(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   string_literal(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   currentAST = __currentAST184;
   _t = __t184;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endTypePrefixDcl(i1);
    
   }
   type_prefix_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = type_prefix_dcl_AST;
  _retTree = _t;
 }
 
 public final void struct_type(AST _t) throws RecognitionException {
  
  IdlParserAST struct_type_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST struct_type_AST = null;
  IdlParserAST struct_literal = null;
  IdlParserAST struct_literal_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  IdlParserAST i2 = null;
  IdlParserAST i2_AST = null;
  
  try {      // for error handling
   AST __t83 = _t;
   struct_literal = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST struct_literal_AST_in = null;
   struct_literal_AST = (IdlParserAST)astFactory.create(struct_literal);
   astFactory.addASTChild(currentAST, struct_literal_AST);
   ASTPair __currentAST83 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_struct);
   _t = _t.getFirstChild();
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case IDENT:
   {
    i1 = (IdlParserAST)_t;
    IdlParserAST i1_AST_in = null;
    i1_AST = (IdlParserAST)astFactory.create(i1);
    astFactory.addASTChild(currentAST, i1_AST);
    match(_t,IDENT);
    _t = _t.getNextSibling();
    break;
   }
   case ESCAPED_IDENT:
   {
    i2 = (IdlParserAST)_t;
    IdlParserAST i2_AST_in = null;
    i2_AST = (IdlParserAST)astFactory.create(i2);
    astFactory.addASTChild(currentAST, i2_AST);
    match(_t,ESCAPED_IDENT);
    _t = _t.getNextSibling();
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   if ( inputState.guessing==0 ) {
    
    IdlParserAST ast = (i1 != null) ? i1 : this.removeEscape (i2);
    this.m_builder.startStruct(ast, struct_literal);
    
   }
   member_list(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endStruct();
    
   }
   currentAST = __currentAST83;
   _t = __t83;
   _t = _t.getNextSibling();
   struct_type_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = struct_type_AST;
  _retTree = _t;
 }
 
 public final void union_type(AST _t) throws RecognitionException {
  
  IdlParserAST union_type_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST union_type_AST = null;
  IdlParserAST literal_union = null;
  IdlParserAST literal_union_AST = null;
  IdlParserAST i2 = null;
  IdlParserAST i2_AST = null;
  IdlParserAST i3 = null;
  IdlParserAST i3_AST = null;
  
  try {      // for error handling
   AST __t90 = _t;
   literal_union = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST literal_union_AST_in = null;
   literal_union_AST = (IdlParserAST)astFactory.create(literal_union);
   astFactory.addASTChild(currentAST, literal_union_AST);
   ASTPair __currentAST90 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_union);
   _t = _t.getFirstChild();
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case IDENT:
   {
    i2 = (IdlParserAST)_t;
    IdlParserAST i2_AST_in = null;
    i2_AST = (IdlParserAST)astFactory.create(i2);
    astFactory.addASTChild(currentAST, i2_AST);
    match(_t,IDENT);
    _t = _t.getNextSibling();
    break;
   }
   case ESCAPED_IDENT:
   {
    i3 = (IdlParserAST)_t;
    IdlParserAST i3_AST_in = null;
    i3_AST = (IdlParserAST)astFactory.create(i3);
    astFactory.addASTChild(currentAST, i3_AST);
    match(_t,ESCAPED_IDENT);
    _t = _t.getNextSibling();
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   if ( inputState.guessing==0 ) {
    
    IdlParserAST ast = (i2 != null) ? i2 : this.removeEscape (i3);
    this.m_builder.startUnionType(ast, literal_union);
    
   }
   switch_type_spec(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   switch_body(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   currentAST = __currentAST90;
   _t = __t90;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endUnionType();
    
   }
   union_type_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = union_type_AST;
  _retTree = _t;
 }
 
 public final void typedef_type(AST _t) throws RecognitionException {
  
  IdlParserAST typedef_type_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST typedef_type_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  try {      // for error handling
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startTypedefType();
    
   }
   AST __t81 = _t;
   i1 = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   ASTPair __currentAST81 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_typedef);
   _t = _t.getFirstChild();
   type_spec(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   if ( inputState.guessing==0 ) {
    
    this.m_builder.typedefMetaPoint(i1);
    
   }
   declarators(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   currentAST = __currentAST81;
   _t = __t81;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endTypedefType();
    
   }
   typedef_type_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = typedef_type_AST;
  _retTree = _t;
 }
 
 public final void enum_type(AST _t) throws RecognitionException {
  
  IdlParserAST enum_type_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST enum_type_AST = null;
  IdlParserAST literal_enum = null;
  IdlParserAST literal_enum_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  IdlParserAST i2 = null;
  IdlParserAST i2_AST = null;
  
  try {      // for error handling
   AST __t93 = _t;
   literal_enum = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST literal_enum_AST_in = null;
   literal_enum_AST = (IdlParserAST)astFactory.create(literal_enum);
   astFactory.addASTChild(currentAST, literal_enum_AST);
   ASTPair __currentAST93 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_enum);
   _t = _t.getFirstChild();
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case IDENT:
   {
    i1 = (IdlParserAST)_t;
    IdlParserAST i1_AST_in = null;
    i1_AST = (IdlParserAST)astFactory.create(i1);
    astFactory.addASTChild(currentAST, i1_AST);
    match(_t,IDENT);
    _t = _t.getNextSibling();
    break;
   }
   case ESCAPED_IDENT:
   {
    i2 = (IdlParserAST)_t;
    IdlParserAST i2_AST_in = null;
    i2_AST = (IdlParserAST)astFactory.create(i2);
    astFactory.addASTChild(currentAST, i2_AST);
    match(_t,ESCAPED_IDENT);
    _t = _t.getNextSibling();
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   if ( inputState.guessing==0 ) {
    
    IdlParserAST ast = (i1 != null) ? i1 : this.removeEscape (i2);
    this.m_builder.startEnumType(ast, literal_enum);
    
   }
   enumerator_list(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   currentAST = __currentAST93;
   _t = __t93;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endEnumType();
    
   }
   enum_type_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = enum_type_AST;
  _retTree = _t;
 }
 
 public final void native_decl(AST _t) throws RecognitionException {
  
  IdlParserAST native_decl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST native_decl_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  IdlParserAST i2_AST = null;
  IdlParserAST i2 = null;
  
  try {      // for error handling
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startNativeDecl();
    
   }
   AST __t186 = _t;
   i1 = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   ASTPair __currentAST186 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_native);
   _t = _t.getFirstChild();
   i2 = _t==ASTNULL ? null : (IdlParserAST)_t;
   simple_declarator(_t);
   _t = _retTree;
   i2_AST = (IdlParserAST)returnAST;
   astFactory.addASTChild(currentAST, returnAST);
   currentAST = __currentAST186;
   _t = __t186;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endNativeDecl(i1, i2);
    
   }
   native_decl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = native_decl_AST;
  _retTree = _t;
 }
 
 public final void constr_forward_decl(AST _t) throws RecognitionException {
  
  IdlParserAST constr_forward_decl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST constr_forward_decl_AST = null;
  
  try {      // for error handling
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_struct:
   {
    struct_forward_decl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    constr_forward_decl_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_union:
   {
    union_forward_decl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    constr_forward_decl_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = constr_forward_decl_AST;
  _retTree = _t;
 }
 
 public final void type_spec(AST _t) throws RecognitionException {
  
  IdlParserAST type_spec_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST type_spec_AST = null;
  
  this.m_builder.startTypeSpec();
  
  
  try {      // for error handling
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case IDENT:
   case ESCAPED_IDENT:
   case LITERAL_float:
   case LITERAL_double:
   case LITERAL_long:
   case LITERAL_short:
   case LITERAL_unsigned:
   case LITERAL_char:
   case LITERAL_wchar:
   case LITERAL_boolean:
   case LITERAL_octet:
   case LITERAL_any:
   case LITERAL_Object:
   case LITERAL_sequence:
   case LITERAL_string:
   case LITERAL_wstring:
   case LITERAL_ValueBase:
   {
    simple_type_spec(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_struct:
   case LITERAL_union:
   case LITERAL_enum:
   {
    constr_type_spec(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    if ( inputState.guessing==0 ) {
     
     this.m_builder.endTypeSpec();
     
    }
    type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = type_spec_AST;
  _retTree = _t;
 }
 
 public final void simple_type_spec(AST _t) throws RecognitionException {
  
  IdlParserAST simple_type_spec_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST simple_type_spec_AST = null;
  
  this.m_builder.startSimpleTypeSpec();
  
  
  try {      // for error handling
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_float:
   case LITERAL_double:
   case LITERAL_long:
   case LITERAL_short:
   case LITERAL_unsigned:
   case LITERAL_char:
   case LITERAL_wchar:
   case LITERAL_boolean:
   case LITERAL_octet:
   case LITERAL_any:
   case LITERAL_Object:
   case LITERAL_ValueBase:
   {
    base_type_spec(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    simple_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_sequence:
   case LITERAL_string:
   case LITERAL_wstring:
   {
    template_type_spec(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    simple_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case IDENT:
   case ESCAPED_IDENT:
   {
    scoped_name(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    if ( inputState.guessing==0 ) {
     
     this.m_builder.endSimpleTypeSpec();
     
    }
    simple_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = simple_type_spec_AST;
  _retTree = _t;
 }
 
 public final void constr_type_spec(AST _t) throws RecognitionException {
  
  IdlParserAST constr_type_spec_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST constr_type_spec_AST = null;
  
  this.m_builder.startConstrTypeSpec();
  
  
  try {      // for error handling
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_struct:
   {
    struct_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    constr_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_union:
   {
    union_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    constr_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_enum:
   {
    enum_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    if ( inputState.guessing==0 ) {
     
     this.m_builder.startConstrTypeSpec();
     
    }
    constr_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = constr_type_spec_AST;
  _retTree = _t;
 }
 
 public final void base_type_spec(AST _t) throws RecognitionException {
  
  IdlParserAST base_type_spec_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST base_type_spec_AST = null;
  
  try {      // for error handling
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_long:
   case LITERAL_unsigned:
   {
    long_integer_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    base_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_short:
   {
    integer_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    base_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_float:
   case LITERAL_double:
   {
    floating_pt_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    base_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_char:
   {
    char_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    base_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_wchar:
   {
    wide_char_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    base_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_boolean:
   {
    boolean_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    base_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_octet:
   {
    octet_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    base_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_any:
   {
    any_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    base_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_Object:
   {
    object_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    base_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_ValueBase:
   {
    value_base_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    base_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = base_type_spec_AST;
  _retTree = _t;
 }
 
 public final void template_type_spec(AST _t) throws RecognitionException {
  
  IdlParserAST template_type_spec_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST template_type_spec_AST = null;
  
  try {      // for error handling
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_string:
   {
    string_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    template_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_wstring:
   {
    wide_string_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    template_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_sequence:
   {
    sequence_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    template_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = template_type_spec_AST;
  _retTree = _t;
 }
 
 public final void scoped_name(AST _t) throws RecognitionException {
  
  IdlParserAST scoped_name_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST scoped_name_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  IdlParserAST i2 = null;
  IdlParserAST i2_AST = null;
  IdlParserAST i4 = null;
  IdlParserAST i4_AST = null;
  IdlParserAST i5 = null;
  IdlParserAST i5_AST = null;
  IdlParserAST i6 = null;
  IdlParserAST i6_AST = null;
  IdlParserAST i7 = null;
  IdlParserAST i7_AST = null;
  IdlParserAST i9 = null;
  IdlParserAST i9_AST = null;
  IdlParserAST i10 = null;
  IdlParserAST i10_AST = null;
  
  this.m_builder.startScopedName();
  StringBuilder sb = new StringBuilder();
  boolean isMultiName = false;
  List<IdlParserAST> astList = new ArrayList<IdlParserAST>();
  
  
  try {      // for error handling
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case IDENT:
   {
    AST __t29 = _t;
    i1 = _t==ASTNULL ? null :(IdlParserAST)_t;
    IdlParserAST i1_AST_in = null;
    i1_AST = (IdlParserAST)astFactory.create(i1);
    astFactory.addASTChild(currentAST, i1_AST);
    ASTPair __currentAST29 = currentAST.copy();
    currentAST.root = currentAST.child;
    currentAST.child = null;
    match(_t,IDENT);
    _t = _t.getFirstChild();
    {
    if (_t==null) _t=ASTNULL;
    switch ( _t.getType()) {
    case SCOPEOP:
    {
     i2 = (IdlParserAST)_t;
     IdlParserAST i2_AST_in = null;
     i2_AST = (IdlParserAST)astFactory.create(i2);
     astFactory.addASTChild(currentAST, i2_AST);
     match(_t,SCOPEOP);
     _t = _t.getNextSibling();
     break;
    }
    case 3:
    case IDENT:
    case ESCAPED_IDENT:
    {
     break;
    }
    default:
    {
     throw new NoViableAltException(_t);
    }
    }
    }
    if ( inputState.guessing==0 ) {
     
     astList.add(i1); 
     if (i2 != null)
     {
     sb.append("::");
     astList.add(i2);
     }
     sb.append(i1.getText());
     
     
    }
    {
    _loop33:
    do {
     if (_t==null) _t=ASTNULL;
     if ((_t.getType()==IDENT||_t.getType()==ESCAPED_IDENT)) {
      {
      if (_t==null) _t=ASTNULL;
      switch ( _t.getType()) {
      case IDENT:
      {
       i4 = (IdlParserAST)_t;
       IdlParserAST i4_AST_in = null;
       i4_AST = (IdlParserAST)astFactory.create(i4);
       astFactory.addASTChild(currentAST, i4_AST);
       match(_t,IDENT);
       _t = _t.getNextSibling();
       break;
      }
      case ESCAPED_IDENT:
      {
       i5 = (IdlParserAST)_t;
       IdlParserAST i5_AST_in = null;
       i5_AST = (IdlParserAST)astFactory.create(i5);
       astFactory.addASTChild(currentAST, i5_AST);
       match(_t,ESCAPED_IDENT);
       _t = _t.getNextSibling();
       break;
      }
      default:
      {
       throw new NoViableAltException(_t);
      }
      }
      }
      if ( inputState.guessing==0 ) {
       
       IdlParserAST ast = (i4 != null) ? i4 : this.removeEscape (i5);
       sb.append("::");
       sb.append(ast.getText());
       astList.add(ast);
       
      }
     }
     else {
      break _loop33;
     }
     
    } while (true);
    }
    currentAST = __currentAST29;
    _t = __t29;
    _t = _t.getNextSibling();
    break;
   }
   case ESCAPED_IDENT:
   {
    AST __t34 = _t;
    i6 = _t==ASTNULL ? null :(IdlParserAST)_t;
    IdlParserAST i6_AST_in = null;
    i6_AST = (IdlParserAST)astFactory.create(i6);
    astFactory.addASTChild(currentAST, i6_AST);
    ASTPair __currentAST34 = currentAST.copy();
    currentAST.root = currentAST.child;
    currentAST.child = null;
    match(_t,ESCAPED_IDENT);
    _t = _t.getFirstChild();
    {
    if (_t==null) _t=ASTNULL;
    switch ( _t.getType()) {
    case SCOPEOP:
    {
     i7 = (IdlParserAST)_t;
     IdlParserAST i7_AST_in = null;
     i7_AST = (IdlParserAST)astFactory.create(i7);
     astFactory.addASTChild(currentAST, i7_AST);
     match(_t,SCOPEOP);
     _t = _t.getNextSibling();
     break;
    }
    case 3:
    case IDENT:
    case ESCAPED_IDENT:
    {
     break;
    }
    default:
    {
     throw new NoViableAltException(_t);
    }
    }
    }
    if ( inputState.guessing==0 ) {
     
     IdlParserAST ast = this.removeEscape (i6);
     astList.add(ast); 
     if (i7 != null)
     {
     sb.append("::");
     astList.add(i7);
     }
     sb.append(ast.getText());
     
     
    }
    {
    _loop38:
    do {
     if (_t==null) _t=ASTNULL;
     if ((_t.getType()==IDENT||_t.getType()==ESCAPED_IDENT)) {
      {
      if (_t==null) _t=ASTNULL;
      switch ( _t.getType()) {
      case IDENT:
      {
       i9 = (IdlParserAST)_t;
       IdlParserAST i9_AST_in = null;
       i9_AST = (IdlParserAST)astFactory.create(i9);
       astFactory.addASTChild(currentAST, i9_AST);
       match(_t,IDENT);
       _t = _t.getNextSibling();
       break;
      }
      case ESCAPED_IDENT:
      {
       i10 = (IdlParserAST)_t;
       IdlParserAST i10_AST_in = null;
       i10_AST = (IdlParserAST)astFactory.create(i10);
       astFactory.addASTChild(currentAST, i10_AST);
       match(_t,ESCAPED_IDENT);
       _t = _t.getNextSibling();
       break;
      }
      default:
      {
       throw new NoViableAltException(_t);
      }
      }
      }
      if ( inputState.guessing==0 ) {
       
       IdlParserAST ast = (i9 != null) ? i9 : this.removeEscape (i10);
       sb.append("::");
       sb.append(ast.getText());
       astList.add(ast);
       
      }
     }
     else {
      break _loop38;
     }
     
    } while (true);
    }
    currentAST = __currentAST34;
    _t = __t34;
    _t = _t.getNextSibling();
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endScopedName(sb, astList.toArray(new IdlParserAST[astList.size()]));
    
   }
   scoped_name_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = scoped_name_AST;
  _retTree = _t;
 }
 
 public final void long_integer_type(AST _t) throws RecognitionException {
  
  IdlParserAST long_integer_type_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST long_integer_type_AST = null;
  
  try {      // for error handling
   boolean synPredMatched42 = false;
   if (_t==null) _t=ASTNULL;
   if (((_t.getType()==LITERAL_long))) {
    AST __t42 = _t;
    synPredMatched42 = true;
    inputState.guessing++;
    try {
     {
     AST __t41 = _t;
     ASTPair __currentAST41 = currentAST.copy();
     currentAST.root = currentAST.child;
     currentAST.child = null;
     match(_t,LITERAL_long);
     _t = _t.getFirstChild();
     match(_t,LITERAL_double);
     _t = _t.getNextSibling();
     currentAST = __currentAST41;
     _t = __t41;
     _t = _t.getNextSibling();
     }
    }
    catch (RecognitionException pe) {
     synPredMatched42 = false;
    }
    _t = __t42;
inputState.guessing--;
   }
   if ( synPredMatched42 ) {
    long_double_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    long_integer_type_AST = (IdlParserAST)currentAST.root;
   }
   else {
    boolean synPredMatched44 = false;
    if (_t==null) _t=ASTNULL;
    if (((_t.getType()==LITERAL_long))) {
     AST __t44 = _t;
     synPredMatched44 = true;
     inputState.guessing++;
     try {
      {
      match(_t,LITERAL_long);
      _t = _t.getNextSibling();
      match(_t,LITERAL_long);
      _t = _t.getNextSibling();
      }
     }
     catch (RecognitionException pe) {
      synPredMatched44 = false;
     }
     _t = __t44;
inputState.guessing--;
    }
    if ( synPredMatched44 ) {
     signed_longlong_int(_t);
     _t = _retTree;
     astFactory.addASTChild(currentAST, returnAST);
     long_integer_type_AST = (IdlParserAST)currentAST.root;
    }
    else {
     boolean synPredMatched46 = false;
     if (_t==null) _t=ASTNULL;
     if (((_t.getType()==LITERAL_long))) {
      AST __t46 = _t;
      synPredMatched46 = true;
      inputState.guessing++;
      try {
       {
       match(_t,LITERAL_long);
       _t = _t.getNextSibling();
       }
      }
      catch (RecognitionException pe) {
       synPredMatched46 = false;
      }
      _t = __t46;
inputState.guessing--;
     }
     if ( synPredMatched46 ) {
      signed_long_int(_t);
      _t = _retTree;
      astFactory.addASTChild(currentAST, returnAST);
      long_integer_type_AST = (IdlParserAST)currentAST.root;
     }
     else {
      boolean synPredMatched48 = false;
      if (_t==null) _t=ASTNULL;
      if (((_t.getType()==LITERAL_unsigned))) {
       AST __t48 = _t;
       synPredMatched48 = true;
       inputState.guessing++;
       try {
        {
        match(_t,LITERAL_unsigned);
        _t = _t.getNextSibling();
        match(_t,LITERAL_long);
        _t = _t.getNextSibling();
        match(_t,LITERAL_long);
        _t = _t.getNextSibling();
        }
       }
       catch (RecognitionException pe) {
        synPredMatched48 = false;
       }
       _t = __t48;
inputState.guessing--;
      }
      if ( synPredMatched48 ) {
       unsigned_longlong_int(_t);
       _t = _retTree;
       astFactory.addASTChild(currentAST, returnAST);
       long_integer_type_AST = (IdlParserAST)currentAST.root;
      }
      else {
       boolean synPredMatched50 = false;
       if (_t==null) _t=ASTNULL;
       if (((_t.getType()==LITERAL_unsigned))) {
        AST __t50 = _t;
        synPredMatched50 = true;
        inputState.guessing++;
        try {
         {
         match(_t,LITERAL_unsigned);
         _t = _t.getNextSibling();
         match(_t,LITERAL_long);
         _t = _t.getNextSibling();
         }
        }
        catch (RecognitionException pe) {
         synPredMatched50 = false;
        }
        _t = __t50;
inputState.guessing--;
       }
       if ( synPredMatched50 ) {
        unsigned_long_int(_t);
        _t = _retTree;
        astFactory.addASTChild(currentAST, returnAST);
        long_integer_type_AST = (IdlParserAST)currentAST.root;
       }
       else {
        boolean synPredMatched52 = false;
        if (_t==null) _t=ASTNULL;
        if (((_t.getType()==LITERAL_unsigned))) {
         AST __t52 = _t;
         synPredMatched52 = true;
         inputState.guessing++;
         try {
          {
          match(_t,LITERAL_unsigned);
          _t = _t.getNextSibling();
          match(_t,LITERAL_short);
          _t = _t.getNextSibling();
          }
         }
         catch (RecognitionException pe) {
          synPredMatched52 = false;
         }
         _t = __t52;
inputState.guessing--;
        }
        if ( synPredMatched52 ) {
         unsigned_short_int(_t);
         _t = _retTree;
         astFactory.addASTChild(currentAST, returnAST);
         long_integer_type_AST = (IdlParserAST)currentAST.root;
        }
        else {
         throw new NoViableAltException(_t);
        }
        }}}}}
       }
       catch (RecognitionException ex) {
        if (inputState.guessing==0) {
         reportError(ex);
         if (_t!=null) {_t = _t.getNextSibling();}
        } else {
          throw ex;
        }
       }
       returnAST = long_integer_type_AST;
       _retTree = _t;
      }
      
 public final void integer_type(AST _t) throws RecognitionException {
  
  IdlParserAST integer_type_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST integer_type_AST = null;
  
  try {      // for error handling
   signed_int(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   integer_type_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = integer_type_AST;
  _retTree = _t;
 }
 
 public final void floating_pt_type(AST _t) throws RecognitionException {
  
  IdlParserAST floating_pt_type_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST floating_pt_type_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  IdlParserAST i2 = null;
  IdlParserAST i2_AST = null;
  
  try {      // for error handling
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_float:
   {
    i1 = (IdlParserAST)_t;
    IdlParserAST i1_AST_in = null;
    i1_AST = (IdlParserAST)astFactory.create(i1);
    astFactory.addASTChild(currentAST, i1_AST);
    match(_t,LITERAL_float);
    _t = _t.getNextSibling();
    if ( inputState.guessing==0 ) {
     
     this.m_builder.startFloatType(i1);
     
    }
    if ( inputState.guessing==0 ) {
     
     this.m_builder.endFloatType();
     
    }
    floating_pt_type_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_double:
   {
    i2 = (IdlParserAST)_t;
    IdlParserAST i2_AST_in = null;
    i2_AST = (IdlParserAST)astFactory.create(i2);
    astFactory.addASTChild(currentAST, i2_AST);
    match(_t,LITERAL_double);
    _t = _t.getNextSibling();
    if ( inputState.guessing==0 ) {
     
     this.m_builder.startDoubleType(i2);
     
    }
    if ( inputState.guessing==0 ) {
     
     this.m_builder.endDoubleType();
     
    }
    floating_pt_type_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = floating_pt_type_AST;
  _retTree = _t;
 }
 
 public final void char_type(AST _t) throws RecognitionException {
  
  IdlParserAST char_type_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST char_type_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  try {      // for error handling
   i1 = (IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   match(_t,LITERAL_char);
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startCharType(i1);
    
   }
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endCharType();
    
   }
   char_type_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = char_type_AST;
  _retTree = _t;
 }
 
 public final void wide_char_type(AST _t) throws RecognitionException {
  
  IdlParserAST wide_char_type_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST wide_char_type_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  try {      // for error handling
   i1 = (IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   match(_t,LITERAL_wchar);
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startWCharType(i1);
    
   }
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endWCharType();
    
   }
   wide_char_type_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = wide_char_type_AST;
  _retTree = _t;
 }
 
 public final void boolean_type(AST _t) throws RecognitionException {
  
  IdlParserAST boolean_type_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST boolean_type_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  try {      // for error handling
   i1 = (IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   match(_t,LITERAL_boolean);
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startBooleanType(i1);
    
   }
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endBooleanType();
    
   }
   boolean_type_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = boolean_type_AST;
  _retTree = _t;
 }
 
 public final void octet_type(AST _t) throws RecognitionException {
  
  IdlParserAST octet_type_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST octet_type_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  try {      // for error handling
   i1 = (IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   match(_t,LITERAL_octet);
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startOctetType(i1);
    
   }
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endOctetType();
    
   }
   octet_type_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = octet_type_AST;
  _retTree = _t;
 }
 
 public final void any_type(AST _t) throws RecognitionException {
  
  IdlParserAST any_type_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST any_type_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  try {      // for error handling
   i1 = (IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   match(_t,LITERAL_any);
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startAnyType(i1);
    
   }
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endAnyType();
    
   }
   any_type_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = any_type_AST;
  _retTree = _t;
 }
 
 public final void object_type(AST _t) throws RecognitionException {
  
  IdlParserAST object_type_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST object_type_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  try {      // for error handling
   i1 = (IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   match(_t,LITERAL_Object);
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startObjectType(i1); 
    
   }
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endObjectType();
    
   }
   object_type_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = object_type_AST;
  _retTree = _t;
 }
 
 public final void value_base_type(AST _t) throws RecognitionException {
  
  IdlParserAST value_base_type_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST value_base_type_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  try {      // for error handling
   i1 = (IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   match(_t,LITERAL_ValueBase);
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startValueBaseType(i1); 
    
   }
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endValueBaseType(); 
    
   }
   value_base_type_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = value_base_type_AST;
  _retTree = _t;
 }
 
 public final void string_type(AST _t) throws RecognitionException {
  
  IdlParserAST string_type_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST string_type_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  try {      // for error handling
   AST __t72 = _t;
   i1 = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   ASTPair __currentAST72 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_string);
   _t = _t.getFirstChild();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startStringType(i1);
    
   }
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case IDENT:
   case ESCAPED_IDENT:
   case OR:
   case XOR:
   case AND:
   case LSHIFT:
   case RSHIFT:
   case PLUS:
   case MINUS:
   case STAR:
   case DIV:
   case MOD:
   case TILDE:
   case LITERAL_TRUE:
   case LITERAL_FALSE:
   case INT:
   case OCTAL:
   case HEX:
   case STRING_LITERAL:
   case WIDE_STRING_LITERAL:
   case CHAR_LITERAL:
   case WIDE_CHAR_LITERAL:
   case FIXED:
   case FLOAT:
   {
    const_or_scoped_decl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case 3:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   currentAST = __currentAST72;
   _t = __t72;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endStringType(); 
    
   }
   string_type_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = string_type_AST;
  _retTree = _t;
 }
 
 public final void wide_string_type(AST _t) throws RecognitionException {
  
  IdlParserAST wide_string_type_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST wide_string_type_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  try {      // for error handling
   AST __t75 = _t;
   i1 = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   ASTPair __currentAST75 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_wstring);
   _t = _t.getFirstChild();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startWStringType(i1);
    
   }
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case IDENT:
   case ESCAPED_IDENT:
   case OR:
   case XOR:
   case AND:
   case LSHIFT:
   case RSHIFT:
   case PLUS:
   case MINUS:
   case STAR:
   case DIV:
   case MOD:
   case TILDE:
   case LITERAL_TRUE:
   case LITERAL_FALSE:
   case INT:
   case OCTAL:
   case HEX:
   case STRING_LITERAL:
   case WIDE_STRING_LITERAL:
   case CHAR_LITERAL:
   case WIDE_CHAR_LITERAL:
   case FIXED:
   case FLOAT:
   {
    const_or_scoped_decl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case 3:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   currentAST = __currentAST75;
   _t = __t75;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endWStringType(); 
    
   }
   wide_string_type_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = wide_string_type_AST;
  _retTree = _t;
 }
 
 public final void sequence_type(AST _t) throws RecognitionException {
  
  IdlParserAST sequence_type_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST sequence_type_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  this.m_builder.startSequenceType();
  
  
  try {      // for error handling
   AST __t78 = _t;
   i1 = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   ASTPair __currentAST78 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_sequence);
   _t = _t.getFirstChild();
   simple_type_spec(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   if ( inputState.guessing==0 ) {
    
    
   }
   if ( inputState.guessing==0 ) {
    
    this.m_builder.sequenceMetaPoint(i1);
    
   }
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case IDENT:
   case ESCAPED_IDENT:
   case OR:
   case XOR:
   case AND:
   case LSHIFT:
   case RSHIFT:
   case PLUS:
   case MINUS:
   case STAR:
   case DIV:
   case MOD:
   case TILDE:
   case LITERAL_TRUE:
   case LITERAL_FALSE:
   case INT:
   case OCTAL:
   case HEX:
   case STRING_LITERAL:
   case WIDE_STRING_LITERAL:
   case CHAR_LITERAL:
   case WIDE_CHAR_LITERAL:
   case FIXED:
   case FLOAT:
   {
    const_or_scoped_decl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case 3:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endSequenceType();
    
   }
   currentAST = __currentAST78;
   _t = __t78;
   _t = _t.getNextSibling();
   sequence_type_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = sequence_type_AST;
  _retTree = _t;
 }
 
 public final void const_type(AST _t) throws RecognitionException {
  
  IdlParserAST const_type_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST const_type_AST = null;
  
  try {      // for error handling
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_long:
   case LITERAL_unsigned:
   {
    long_integer_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    const_type_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_short:
   {
    integer_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    const_type_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_char:
   {
    char_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    const_type_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_wchar:
   {
    wide_char_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    const_type_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_boolean:
   {
    boolean_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    const_type_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_float:
   case LITERAL_double:
   {
    floating_pt_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    const_type_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_string:
   {
    string_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    const_type_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_wstring:
   {
    wide_string_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    const_type_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case IDENT:
   case ESCAPED_IDENT:
   {
    scoped_name(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    const_type_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_octet:
   {
    octet_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    const_type_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = const_type_AST;
  _retTree = _t;
 }
 
 public final void const_or_scoped_decl(AST _t) throws RecognitionException {
  
  IdlParserAST const_or_scoped_decl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST const_or_scoped_decl_AST = null;
  IdlParserAST i1_AST = null;
  IdlParserAST i1 = null;
  
  try {      // for error handling
   {
   if (_t==null) _t=ASTNULL;
   if ((_tokenSet_1.member(_t.getType()))) {
    const_exp(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
   }
   else if ((_t.getType()==IDENT||_t.getType()==ESCAPED_IDENT)) {
    scoped_name(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
   }
   else {
    throw new NoViableAltException(_t);
   }
   
   }
   const_or_scoped_decl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = const_or_scoped_decl_AST;
  _retTree = _t;
 }
 
 public final void scoped_name_list(AST _t) throws RecognitionException {
  
  IdlParserAST scoped_name_list_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST scoped_name_list_AST = null;
  
  try {      // for error handling
   scoped_name(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   {
   _loop26:
   do {
    if (_t==null) _t=ASTNULL;
    if ((_t.getType()==IDENT||_t.getType()==ESCAPED_IDENT)) {
     scoped_name(_t);
     _t = _retTree;
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop26;
    }
    
   } while (true);
   }
   scoped_name_list_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = scoped_name_list_AST;
  _retTree = _t;
 }
 
 public final void long_double_type(AST _t) throws RecognitionException {
  
  IdlParserAST long_double_type_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST long_double_type_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  IdlParserAST i2 = null;
  IdlParserAST i2_AST = null;
  
  try {      // for error handling
   AST __t70 = _t;
   i1 = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   ASTPair __currentAST70 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_long);
   _t = _t.getFirstChild();
   i2 = (IdlParserAST)_t;
   IdlParserAST i2_AST_in = null;
   i2_AST = (IdlParserAST)astFactory.create(i2);
   astFactory.addASTChild(currentAST, i2_AST);
   match(_t,LITERAL_double);
   _t = _t.getNextSibling();
   currentAST = __currentAST70;
   _t = __t70;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startLongDoubleType(i1, i2); 
    
   }
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endLongDoubleType(); 
    
   }
   long_double_type_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = long_double_type_AST;
  _retTree = _t;
 }
 
 public final void signed_longlong_int(AST _t) throws RecognitionException {
  
  IdlParserAST signed_longlong_int_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST signed_longlong_int_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  IdlParserAST i2 = null;
  IdlParserAST i2_AST = null;
  
  try {      // for error handling
   i1 = (IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   match(_t,LITERAL_long);
   _t = _t.getNextSibling();
   i2 = (IdlParserAST)_t;
   IdlParserAST i2_AST_in = null;
   i2_AST = (IdlParserAST)astFactory.create(i2);
   astFactory.addASTChild(currentAST, i2_AST);
   match(_t,LITERAL_long);
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startLongLongType(i1, i2); 
    
   }
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endLongLongType();
    
   }
   signed_longlong_int_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = signed_longlong_int_AST;
  _retTree = _t;
 }
 
 public final void signed_long_int(AST _t) throws RecognitionException {
  
  IdlParserAST signed_long_int_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST signed_long_int_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  try {      // for error handling
   i1 = (IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   match(_t,LITERAL_long);
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startLongType(i1);
    
   }
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endLongType();
    
   }
   signed_long_int_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = signed_long_int_AST;
  _retTree = _t;
 }
 
 public final void unsigned_longlong_int(AST _t) throws RecognitionException {
  
  IdlParserAST unsigned_longlong_int_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST unsigned_longlong_int_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  IdlParserAST i2 = null;
  IdlParserAST i2_AST = null;
  IdlParserAST i3 = null;
  IdlParserAST i3_AST = null;
  
  try {      // for error handling
   i1 = (IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   match(_t,LITERAL_unsigned);
   _t = _t.getNextSibling();
   i2 = (IdlParserAST)_t;
   IdlParserAST i2_AST_in = null;
   i2_AST = (IdlParserAST)astFactory.create(i2);
   astFactory.addASTChild(currentAST, i2_AST);
   match(_t,LITERAL_long);
   _t = _t.getNextSibling();
   i3 = (IdlParserAST)_t;
   IdlParserAST i3_AST_in = null;
   i3_AST = (IdlParserAST)astFactory.create(i3);
   astFactory.addASTChild(currentAST, i3_AST);
   match(_t,LITERAL_long);
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startULongLongType(i1, i2, i3);
    
   }
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endULongLongType();
    
   }
   unsigned_longlong_int_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = unsigned_longlong_int_AST;
  _retTree = _t;
 }
 
 public final void unsigned_long_int(AST _t) throws RecognitionException {
  
  IdlParserAST unsigned_long_int_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST unsigned_long_int_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  IdlParserAST i2 = null;
  IdlParserAST i2_AST = null;
  
  try {      // for error handling
   i1 = (IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   match(_t,LITERAL_unsigned);
   _t = _t.getNextSibling();
   i2 = (IdlParserAST)_t;
   IdlParserAST i2_AST_in = null;
   i2_AST = (IdlParserAST)astFactory.create(i2);
   astFactory.addASTChild(currentAST, i2_AST);
   match(_t,LITERAL_long);
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startULongType(i1, i2);
    
   }
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endULongType();
    
   }
   unsigned_long_int_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = unsigned_long_int_AST;
  _retTree = _t;
 }
 
 public final void unsigned_short_int(AST _t) throws RecognitionException {
  
  IdlParserAST unsigned_short_int_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST unsigned_short_int_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  IdlParserAST i2 = null;
  IdlParserAST i2_AST = null;
  
  try {      // for error handling
   i1 = (IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   match(_t,LITERAL_unsigned);
   _t = _t.getNextSibling();
   i2 = (IdlParserAST)_t;
   IdlParserAST i2_AST_in = null;
   i2_AST = (IdlParserAST)astFactory.create(i2);
   astFactory.addASTChild(currentAST, i2_AST);
   match(_t,LITERAL_short);
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startUShortType(i1, i2);
    
   }
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endUShortType();
    
   }
   unsigned_short_int_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = unsigned_short_int_AST;
  _retTree = _t;
 }
 
 public final void signed_int(AST _t) throws RecognitionException {
  
  IdlParserAST signed_int_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST signed_int_AST = null;
  
  try {      // for error handling
   signed_short_int(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   signed_int_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = signed_int_AST;
  _retTree = _t;
 }
 
 public final void signed_short_int(AST _t) throws RecognitionException {
  
  IdlParserAST signed_short_int_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST signed_short_int_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  try {      // for error handling
   i1 = (IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   match(_t,LITERAL_short);
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startShortType(i1);
    
   }
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endShortType();
    
   }
   signed_short_int_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = signed_short_int_AST;
  _retTree = _t;
 }
 
 public final void declarators(AST _t) throws RecognitionException {
  
  IdlParserAST declarators_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST declarators_AST = null;
  
  try {      // for error handling
   declarator(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   {
   _loop241:
   do {
    if (_t==null) _t=ASTNULL;
    if ((_t.getType()==IDENT||_t.getType()==ESCAPED_IDENT)) {
     declarator(_t);
     _t = _retTree;
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop241;
    }
    
   } while (true);
   }
   declarators_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = declarators_AST;
  _retTree = _t;
 }
 
 public final void member_list(AST _t) throws RecognitionException {
  
  IdlParserAST member_list_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST member_list_AST = null;
  
  try {      // for error handling
   {
   int _cnt87=0;
   _loop87:
   do {
    if (_t==null) _t=ASTNULL;
    if ((_tokenSet_2.member(_t.getType()))) {
     member(_t);
     _t = _retTree;
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     if ( _cnt87>=1 ) { break _loop87; } else {throw new NoViableAltException(_t);}
    }
    
    _cnt87++;
   } while (true);
   }
   member_list_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = member_list_AST;
  _retTree = _t;
 }
 
 public final void member(AST _t) throws RecognitionException {
  
  IdlParserAST member_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST member_AST = null;
  IdlParserAST semi = null;
  IdlParserAST semi_AST = null;
  
  try {      // for error handling
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startMember();
    
   }
   type_spec(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   declarators(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   semi = (IdlParserAST)_t;
   IdlParserAST semi_AST_in = null;
   semi_AST = (IdlParserAST)astFactory.create(semi);
   astFactory.addASTChild(currentAST, semi_AST);
   match(_t,SEMI);
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endMember(semi); 
    
   }
   member_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = member_AST;
  _retTree = _t;
 }
 
 public final void switch_type_spec(AST _t) throws RecognitionException {
  
  IdlParserAST switch_type_spec_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST switch_type_spec_AST = null;
  IdlParserAST t1_AST = null;
  IdlParserAST t1 = null;
  
  this.m_builder.startSwitchTypeSpec();
  
  
  try {      // for error handling
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_long:
   case LITERAL_unsigned:
   {
    long_integer_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LITERAL_short:
   {
    integer_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LITERAL_char:
   {
    char_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LITERAL_boolean:
   {
    boolean_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LITERAL_enum:
   {
    enum_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case IDENT:
   case ESCAPED_IDENT:
   {
    scoped_name(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endSwitchTypeSpec(t1);
    
   }
   switch_type_spec_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = switch_type_spec_AST;
  _retTree = _t;
 }
 
 public final void switch_body(AST _t) throws RecognitionException {
  
  IdlParserAST switch_body_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST switch_body_AST = null;
  
  this.m_builder.startSwitchBody();
  
  
  try {      // for error handling
   case_stmt_list(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endSwitchBody();
    
   }
   switch_body_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = switch_body_AST;
  _retTree = _t;
 }
 
 public final void enumerator_list(AST _t) throws RecognitionException {
  
  IdlParserAST enumerator_list_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST enumerator_list_AST = null;
  
  try {      // for error handling
   enumerator(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   {
   _loop97:
   do {
    if (_t==null) _t=ASTNULL;
    if ((_t.getType()==IDENT||_t.getType()==ESCAPED_IDENT)) {
     enumerator(_t);
     _t = _retTree;
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop97;
    }
    
   } while (true);
   }
   enumerator_list_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = enumerator_list_AST;
  _retTree = _t;
 }
 
 public final void enumerator(AST _t) throws RecognitionException {
  
  IdlParserAST enumerator_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST enumerator_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  IdlParserAST i2 = null;
  IdlParserAST i2_AST = null;
  
  try {      // for error handling
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startEnumerator();
    
   }
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case IDENT:
   {
    i1 = (IdlParserAST)_t;
    IdlParserAST i1_AST_in = null;
    i1_AST = (IdlParserAST)astFactory.create(i1);
    astFactory.addASTChild(currentAST, i1_AST);
    match(_t,IDENT);
    _t = _t.getNextSibling();
    break;
   }
   case ESCAPED_IDENT:
   {
    i2 = (IdlParserAST)_t;
    IdlParserAST i2_AST_in = null;
    i2_AST = (IdlParserAST)astFactory.create(i2);
    astFactory.addASTChild(currentAST, i2_AST);
    match(_t,ESCAPED_IDENT);
    _t = _t.getNextSibling();
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   if ( inputState.guessing==0 ) {
    
    IdlParserAST ast = (i1 != null) ? i1 : this.removeEscape (i2);
    this.m_builder.endEnumerator(ast);
    
   }
   enumerator_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = enumerator_AST;
  _retTree = _t;
 }
 
 public final void case_stmt_list(AST _t) throws RecognitionException {
  
  IdlParserAST case_stmt_list_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST case_stmt_list_AST = null;
  
  try {      // for error handling
   {
   int _cnt105=0;
   _loop105:
   do {
    if (_t==null) _t=ASTNULL;
    if ((_t.getType()==LITERAL_case||_t.getType()==LITERAL_default)) {
     if ( inputState.guessing==0 ) {
      
      this.m_builder.startUnionMember();
      
     }
     case_stmt(_t);
     _t = _retTree;
     astFactory.addASTChild(currentAST, returnAST);
     if ( inputState.guessing==0 ) {
      
      this.m_builder.endUnionMember();
      
     }
    }
    else {
     if ( _cnt105>=1 ) { break _loop105; } else {throw new NoViableAltException(_t);}
    }
    
    _cnt105++;
   } while (true);
   }
   case_stmt_list_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = case_stmt_list_AST;
  _retTree = _t;
 }
 
 public final void case_stmt(AST _t) throws RecognitionException {
  
  IdlParserAST case_stmt_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST case_stmt_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  IdlParserAST i2 = null;
  IdlParserAST i2_AST = null;
  
  try {      // for error handling
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_case:
   {
    AST __t108 = _t;
    i1 = _t==ASTNULL ? null :(IdlParserAST)_t;
    IdlParserAST i1_AST_in = null;
    i1_AST = (IdlParserAST)astFactory.create(i1);
    astFactory.addASTChild(currentAST, i1_AST);
    ASTPair __currentAST108 = currentAST.copy();
    currentAST.root = currentAST.child;
    currentAST.child = null;
    match(_t,LITERAL_case);
    _t = _t.getFirstChild();
    {
    if (_t==null) _t=ASTNULL;
    switch ( _t.getType()) {
    case LITERAL_case:
    case LITERAL_default:
    {
     case_stmt(_t);
     _t = _retTree;
     astFactory.addASTChild(currentAST, returnAST);
     break;
    }
    case IDENT:
    case ESCAPED_IDENT:
    case OR:
    case XOR:
    case AND:
    case LSHIFT:
    case RSHIFT:
    case PLUS:
    case MINUS:
    case STAR:
    case DIV:
    case MOD:
    case TILDE:
    case LITERAL_TRUE:
    case LITERAL_FALSE:
    case INT:
    case OCTAL:
    case HEX:
    case STRING_LITERAL:
    case WIDE_STRING_LITERAL:
    case CHAR_LITERAL:
    case WIDE_CHAR_LITERAL:
    case FIXED:
    case FLOAT:
    {
     break;
    }
    default:
    {
     throw new NoViableAltException(_t);
    }
    }
    }
    const_or_scoped_decl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    if ( inputState.guessing==0 ) {
     
     this.m_builder.startCaseStmt(i1);
     
    }
    {
    if (_t==null) _t=ASTNULL;
    switch ( _t.getType()) {
    case IDENT:
    case ESCAPED_IDENT:
    case LITERAL_float:
    case LITERAL_double:
    case LITERAL_long:
    case LITERAL_short:
    case LITERAL_unsigned:
    case LITERAL_char:
    case LITERAL_wchar:
    case LITERAL_boolean:
    case LITERAL_octet:
    case LITERAL_any:
    case LITERAL_Object:
    case LITERAL_struct:
    case LITERAL_union:
    case LITERAL_enum:
    case LITERAL_sequence:
    case LITERAL_string:
    case LITERAL_wstring:
    case LITERAL_ValueBase:
    {
     element_spec(_t);
     _t = _retTree;
     astFactory.addASTChild(currentAST, returnAST);
     break;
    }
    case 3:
    {
     break;
    }
    default:
    {
     throw new NoViableAltException(_t);
    }
    }
    }
    currentAST = __currentAST108;
    _t = __t108;
    _t = _t.getNextSibling();
    break;
   }
   case LITERAL_default:
   {
    AST __t111 = _t;
    i2 = _t==ASTNULL ? null :(IdlParserAST)_t;
    IdlParserAST i2_AST_in = null;
    i2_AST = (IdlParserAST)astFactory.create(i2);
    astFactory.addASTChild(currentAST, i2_AST);
    ASTPair __currentAST111 = currentAST.copy();
    currentAST.root = currentAST.child;
    currentAST.child = null;
    match(_t,LITERAL_default);
    _t = _t.getFirstChild();
    if ( inputState.guessing==0 ) {
     
     this.m_builder.startCaseStmt(i2);
     
    }
    element_spec(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    currentAST = __currentAST111;
    _t = __t111;
    _t = _t.getNextSibling();
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endCaseStmt();
    
   }
   case_stmt_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = case_stmt_AST;
  _retTree = _t;
 }
 
 public final void element_spec(AST _t) throws RecognitionException {
  
  IdlParserAST element_spec_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST element_spec_AST = null;
  
  this.m_builder.startElementSpec();
  
  
  try {      // for error handling
   type_spec(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   declarator(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endElementSpec();
    
   }
   element_spec_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = element_spec_AST;
  _retTree = _t;
 }
 
 public final void declarator(AST _t) throws RecognitionException {
  
  IdlParserAST declarator_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST declarator_AST = null;
  
  try {      // for error handling
   boolean synPredMatched245 = false;
   if (_t==null) _t=ASTNULL;
   if (((_t.getType()==IDENT||_t.getType()==ESCAPED_IDENT))) {
    AST __t245 = _t;
    synPredMatched245 = true;
    inputState.guessing++;
    try {
     {
     AST __t244 = _t;
     ASTPair __currentAST244 = currentAST.copy();
     currentAST.root = currentAST.child;
     currentAST.child = null;
     match(_t,IDENT);
     _t = _t.getFirstChild();
     fixed_array_size(_t);
     _t = _retTree;
     currentAST = __currentAST244;
     _t = __t244;
     _t = _t.getNextSibling();
     }
    }
    catch (RecognitionException pe) {
     synPredMatched245 = false;
    }
    _t = __t245;
inputState.guessing--;
   }
   if ( synPredMatched245 ) {
    complex_declarator(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    declarator_AST = (IdlParserAST)currentAST.root;
   }
   else {
    boolean synPredMatched248 = false;
    if (_t==null) _t=ASTNULL;
    if (((_t.getType()==IDENT||_t.getType()==ESCAPED_IDENT))) {
     AST __t248 = _t;
     synPredMatched248 = true;
     inputState.guessing++;
     try {
      {
      AST __t247 = _t;
      ASTPair __currentAST247 = currentAST.copy();
      currentAST.root = currentAST.child;
      currentAST.child = null;
      match(_t,ESCAPED_IDENT);
      _t = _t.getFirstChild();
      fixed_array_size(_t);
      _t = _retTree;
      currentAST = __currentAST247;
      _t = __t247;
      _t = _t.getNextSibling();
      }
     }
     catch (RecognitionException pe) {
      synPredMatched248 = false;
     }
     _t = __t248;
inputState.guessing--;
    }
    if ( synPredMatched248 ) {
     complex_declarator(_t);
     _t = _retTree;
     astFactory.addASTChild(currentAST, returnAST);
     declarator_AST = (IdlParserAST)currentAST.root;
    }
    else if ((_t.getType()==IDENT||_t.getType()==ESCAPED_IDENT)) {
     simple_declarator(_t);
     _t = _retTree;
     astFactory.addASTChild(currentAST, returnAST);
     declarator_AST = (IdlParserAST)currentAST.root;
    }
    else {
     throw new NoViableAltException(_t);
    }
    }
   }
   catch (RecognitionException ex) {
    if (inputState.guessing==0) {
     reportError(ex);
     if (_t!=null) {_t = _t.getNextSibling();}
    } else {
      throw ex;
    }
   }
   returnAST = declarator_AST;
   _retTree = _t;
  }
  
 public final void value_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST value_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST value_dcl_AST = null;
  IdlParserAST value_literal = null;
  IdlParserAST value_literal_AST = null;
  IdlParserAST cst = null;
  IdlParserAST cst_AST = null;
  IdlParserAST id1 = null;
  IdlParserAST id1_AST = null;
  IdlParserAST id2 = null;
  IdlParserAST id2_AST = null;
  
  try {      // for error handling
   AST __t121 = _t;
   value_literal = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST value_literal_AST_in = null;
   value_literal_AST = (IdlParserAST)astFactory.create(value_literal);
   astFactory.addASTChild(currentAST, value_literal_AST);
   ASTPair __currentAST121 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_valuetype);
   _t = _t.getFirstChild();
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_custom:
   {
    cst = (IdlParserAST)_t;
    IdlParserAST cst_AST_in = null;
    cst_AST = (IdlParserAST)astFactory.create(cst);
    astFactory.addASTChild(currentAST, cst_AST);
    match(_t,LITERAL_custom);
    _t = _t.getNextSibling();
    break;
   }
   case IDENT:
   case ESCAPED_IDENT:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case IDENT:
   {
    id1 = (IdlParserAST)_t;
    IdlParserAST id1_AST_in = null;
    id1_AST = (IdlParserAST)astFactory.create(id1);
    astFactory.addASTChild(currentAST, id1_AST);
    match(_t,IDENT);
    _t = _t.getNextSibling();
    break;
   }
   case ESCAPED_IDENT:
   {
    id2 = (IdlParserAST)_t;
    IdlParserAST id2_AST_in = null;
    id2_AST = (IdlParserAST)astFactory.create(id2);
    astFactory.addASTChild(currentAST, id2_AST);
    match(_t,ESCAPED_IDENT);
    _t = _t.getNextSibling();
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   if ( inputState.guessing==0 ) {
    
    IdlParserAST id = (id1 != null) ? id1 : this.removeEscape (id2);
    this.m_builder.startValueDcl(cst, id, value_literal);
    
   }
   {
   if (_t==null) _t=ASTNULL;
   if ((_t.getType()==LCURLY||_t.getType()==COLON||_t.getType()==LITERAL_supports)) {
    value_inheritance_spec(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
   }
   else if ((_t.getType()==LCURLY)) {
   }
   else {
    throw new NoViableAltException(_t);
   }
   
   }
   IdlParserAST tmp3_AST = null;
   IdlParserAST tmp3_AST_in = null;
   tmp3_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp3_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp3_AST);
   match(_t,LCURLY);
   _t = _t.getNextSibling();
   {
   _loop126:
   do {
    if (_t==null) _t=ASTNULL;
    if ((_tokenSet_3.member(_t.getType()))) {
     value_element(_t);
     _t = _retTree;
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop126;
    }
    
   } while (true);
   }
   IdlParserAST tmp4_AST = null;
   IdlParserAST tmp4_AST_in = null;
   tmp4_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp4_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp4_AST);
   match(_t,RCURLY);
   _t = _t.getNextSibling();
   currentAST = __currentAST121;
   _t = __t121;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endValueDcl();
    
   }
   value_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = value_dcl_AST;
  _retTree = _t;
 }
 
 public final void value_abs_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST value_abs_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST value_abs_dcl_AST = null;
  IdlParserAST value_literal = null;
  IdlParserAST value_literal_AST = null;
  IdlParserAST id1 = null;
  IdlParserAST id1_AST = null;
  IdlParserAST id2 = null;
  IdlParserAST id2_AST = null;
  
  try {      // for error handling
   AST __t128 = _t;
   value_literal = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST value_literal_AST_in = null;
   value_literal_AST = (IdlParserAST)astFactory.create(value_literal);
   astFactory.addASTChild(currentAST, value_literal_AST);
   ASTPair __currentAST128 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_valuetype);
   _t = _t.getFirstChild();
   IdlParserAST tmp5_AST = null;
   IdlParserAST tmp5_AST_in = null;
   tmp5_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp5_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp5_AST);
   match(_t,LITERAL_abstract);
   _t = _t.getNextSibling();
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case IDENT:
   {
    id1 = (IdlParserAST)_t;
    IdlParserAST id1_AST_in = null;
    id1_AST = (IdlParserAST)astFactory.create(id1);
    astFactory.addASTChild(currentAST, id1_AST);
    match(_t,IDENT);
    _t = _t.getNextSibling();
    break;
   }
   case ESCAPED_IDENT:
   {
    id2 = (IdlParserAST)_t;
    IdlParserAST id2_AST_in = null;
    id2_AST = (IdlParserAST)astFactory.create(id2);
    astFactory.addASTChild(currentAST, id2_AST);
    match(_t,ESCAPED_IDENT);
    _t = _t.getNextSibling();
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   if ( inputState.guessing==0 ) {
    
    IdlParserAST id = (id1 != null) ? id1 : this.removeEscape (id2);
    this.m_builder.startValueAbsDcl(id, value_literal);
    
   }
   {
   if (_t==null) _t=ASTNULL;
   if ((_t.getType()==LCURLY||_t.getType()==COLON||_t.getType()==LITERAL_supports)) {
    value_inheritance_spec(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
   }
   else if ((_t.getType()==LCURLY)) {
   }
   else {
    throw new NoViableAltException(_t);
   }
   
   }
   IdlParserAST tmp6_AST = null;
   IdlParserAST tmp6_AST_in = null;
   tmp6_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp6_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp6_AST);
   match(_t,LCURLY);
   _t = _t.getNextSibling();
   {
   _loop132:
   do {
    if (_t==null) _t=ASTNULL;
    if ((_tokenSet_4.member(_t.getType()))) {
     export_dcl(_t);
     _t = _retTree;
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop132;
    }
    
   } while (true);
   }
   IdlParserAST tmp7_AST = null;
   IdlParserAST tmp7_AST_in = null;
   tmp7_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp7_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp7_AST);
   match(_t,RCURLY);
   _t = _t.getNextSibling();
   currentAST = __currentAST128;
   _t = __t128;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endValueAbsDcl();
    
   }
   value_abs_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = value_abs_dcl_AST;
  _retTree = _t;
 }
 
 public final void value_box_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST value_box_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST value_box_dcl_AST = null;
  IdlParserAST value_literal = null;
  IdlParserAST value_literal_AST = null;
  IdlParserAST id1 = null;
  IdlParserAST id1_AST = null;
  IdlParserAST id2 = null;
  IdlParserAST id2_AST = null;
  
  try {      // for error handling
   AST __t134 = _t;
   value_literal = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST value_literal_AST_in = null;
   value_literal_AST = (IdlParserAST)astFactory.create(value_literal);
   astFactory.addASTChild(currentAST, value_literal_AST);
   ASTPair __currentAST134 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_valuetype);
   _t = _t.getFirstChild();
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case IDENT:
   {
    id1 = (IdlParserAST)_t;
    IdlParserAST id1_AST_in = null;
    id1_AST = (IdlParserAST)astFactory.create(id1);
    astFactory.addASTChild(currentAST, id1_AST);
    match(_t,IDENT);
    _t = _t.getNextSibling();
    break;
   }
   case ESCAPED_IDENT:
   {
    id2 = (IdlParserAST)_t;
    IdlParserAST id2_AST_in = null;
    id2_AST = (IdlParserAST)astFactory.create(id2);
    astFactory.addASTChild(currentAST, id2_AST);
    match(_t,ESCAPED_IDENT);
    _t = _t.getNextSibling();
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   type_spec(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   currentAST = __currentAST134;
   _t = __t134;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    IdlParserAST id = (id1 != null) ? id1 : this.removeEscape (id2);
    this.m_builder.endValueBoxDcl(id, value_literal);
    
   }
   value_box_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = value_box_dcl_AST;
  _retTree = _t;
 }
 
 public final void value_forward_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST value_forward_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST value_forward_dcl_AST = null;
  IdlParserAST value_literal = null;
  IdlParserAST value_literal_AST = null;
  IdlParserAST abs = null;
  IdlParserAST abs_AST = null;
  IdlParserAST id1 = null;
  IdlParserAST id1_AST = null;
  IdlParserAST id2 = null;
  IdlParserAST id2_AST = null;
  
  try {      // for error handling
   AST __t137 = _t;
   value_literal = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST value_literal_AST_in = null;
   value_literal_AST = (IdlParserAST)astFactory.create(value_literal);
   astFactory.addASTChild(currentAST, value_literal_AST);
   ASTPair __currentAST137 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_valuetype);
   _t = _t.getFirstChild();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startValueForwardDcl();
    
   }
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_abstract:
   {
    abs = (IdlParserAST)_t;
    IdlParserAST abs_AST_in = null;
    abs_AST = (IdlParserAST)astFactory.create(abs);
    astFactory.addASTChild(currentAST, abs_AST);
    match(_t,LITERAL_abstract);
    _t = _t.getNextSibling();
    break;
   }
   case IDENT:
   case ESCAPED_IDENT:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case IDENT:
   {
    id1 = (IdlParserAST)_t;
    IdlParserAST id1_AST_in = null;
    id1_AST = (IdlParserAST)astFactory.create(id1);
    astFactory.addASTChild(currentAST, id1_AST);
    match(_t,IDENT);
    _t = _t.getNextSibling();
    break;
   }
   case ESCAPED_IDENT:
   {
    id2 = (IdlParserAST)_t;
    IdlParserAST id2_AST_in = null;
    id2_AST = (IdlParserAST)astFactory.create(id2);
    astFactory.addASTChild(currentAST, id2_AST);
    match(_t,ESCAPED_IDENT);
    _t = _t.getNextSibling();
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   if ( inputState.guessing==0 ) {
    
    IdlParserAST id = (id1 != null) ? id1 : this.removeEscape (id2);
    this.m_builder.endValueForwardDcl(abs, id, value_literal);
    
   }
   currentAST = __currentAST137;
   _t = __t137;
   _t = _t.getNextSibling();
   value_forward_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = value_forward_dcl_AST;
  _retTree = _t;
 }
 
 public final void value_inheritance_spec(AST _t) throws RecognitionException {
  
  IdlParserAST value_inheritance_spec_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST value_inheritance_spec_AST = null;
  
  try {      // for error handling
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case COLON:
   {
    value_bases(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LCURLY:
   case LITERAL_supports:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_supports:
   {
    value_supported_interfaces(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LCURLY:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   value_inheritance_spec_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = value_inheritance_spec_AST;
  _retTree = _t;
 }
 
 public final void value_element(AST _t) throws RecognitionException {
  
  IdlParserAST value_element_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST value_element_AST = null;
  
  try {      // for error handling
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case IDENT:
   case ESCAPED_IDENT:
   case LITERAL_const:
   case LITERAL_typedef:
   case LITERAL_native:
   case LITERAL_struct:
   case LITERAL_union:
   case LITERAL_enum:
   case LITERAL_exception:
   case LITERAL_typeid:
   case LITERAL_typeprefix:
   case LITERAL_attribute:
   case PRAGMA:
   {
    export_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    value_element_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_public:
   case LITERAL_private:
   {
    state_member(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    value_element_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_factory:
   {
    init_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    value_element_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = value_element_AST;
  _retTree = _t;
 }
 
 public final void export_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST export_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST export_dcl_AST = null;
  
  this.m_builder.startExportDcl();
  
  
  try {      // for error handling
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_typedef:
   case LITERAL_native:
   case LITERAL_struct:
   case LITERAL_union:
   case LITERAL_enum:
   {
    type_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LITERAL_const:
   {
    const_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LITERAL_exception:
   {
    exception_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LITERAL_attribute:
   {
    attr_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case IDENT:
   case ESCAPED_IDENT:
   {
    op_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LITERAL_typeid:
   {
    type_id_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LITERAL_typeprefix:
   {
    type_prefix_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case PRAGMA:
   {
    pragma_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endExportDcl();
    
   }
   export_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = export_dcl_AST;
  _retTree = _t;
 }
 
 public final void value_bases(AST _t) throws RecognitionException {
  
  IdlParserAST value_bases_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST value_bases_AST = null;
  IdlParserAST trn = null;
  IdlParserAST trn_AST = null;
  
  try {      // for error handling
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startValueBases();  
    
   }
   AST __t144 = _t;
   IdlParserAST tmp8_AST = null;
   IdlParserAST tmp8_AST_in = null;
   tmp8_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp8_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp8_AST);
   ASTPair __currentAST144 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,COLON);
   _t = _t.getFirstChild();
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_truncatable:
   {
    trn = (IdlParserAST)_t;
    IdlParserAST trn_AST_in = null;
    trn_AST = (IdlParserAST)astFactory.create(trn);
    astFactory.addASTChild(currentAST, trn_AST);
    match(_t,LITERAL_truncatable);
    _t = _t.getNextSibling();
    break;
   }
   case IDENT:
   case ESCAPED_IDENT:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   scoped_name_list(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   currentAST = __currentAST144;
   _t = __t144;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endValueBases(trn);  
    
   }
   value_bases_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = value_bases_AST;
  _retTree = _t;
 }
 
 public final void value_supported_interfaces(AST _t) throws RecognitionException {
  
  IdlParserAST value_supported_interfaces_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST value_supported_interfaces_AST = null;
  
  try {      // for error handling
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startValueSupports();  
    
   }
   AST __t147 = _t;
   IdlParserAST tmp9_AST = null;
   IdlParserAST tmp9_AST_in = null;
   tmp9_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp9_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp9_AST);
   ASTPair __currentAST147 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_supports);
   _t = _t.getFirstChild();
   scoped_name_list(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   currentAST = __currentAST147;
   _t = __t147;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endValueSupports();  
    
   }
   value_supported_interfaces_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = value_supported_interfaces_AST;
  _retTree = _t;
 }
 
 public final void state_member(AST _t) throws RecognitionException {
  
  IdlParserAST state_member_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST state_member_AST = null;
  IdlParserAST acc_AST = null;
  IdlParserAST acc = null;
  IdlParserAST semi = null;
  IdlParserAST semi_AST = null;
  
  try {      // for error handling
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startMember();
    
   }
   acc = _t==ASTNULL ? null : (IdlParserAST)_t;
   access(_t);
   _t = _retTree;
   acc_AST = (IdlParserAST)returnAST;
   astFactory.addASTChild(currentAST, returnAST);
   type_spec(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   declarators(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   semi = (IdlParserAST)_t;
   IdlParserAST semi_AST_in = null;
   semi_AST = (IdlParserAST)astFactory.create(semi);
   astFactory.addASTChild(currentAST, semi_AST);
   match(_t,SEMI);
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endMember(acc);
    
   }
   state_member_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = state_member_AST;
  _retTree = _t;
 }
 
 public final void init_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST init_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST init_dcl_AST = null;
  IdlParserAST id1 = null;
  IdlParserAST id1_AST = null;
  IdlParserAST id2 = null;
  IdlParserAST id2_AST = null;
  
  try {      // for error handling
   AST __t152 = _t;
   IdlParserAST tmp10_AST = null;
   IdlParserAST tmp10_AST_in = null;
   tmp10_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp10_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp10_AST);
   ASTPair __currentAST152 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_factory);
   _t = _t.getFirstChild();
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case IDENT:
   {
    id1 = (IdlParserAST)_t;
    IdlParserAST id1_AST_in = null;
    id1_AST = (IdlParserAST)astFactory.create(id1);
    astFactory.addASTChild(currentAST, id1_AST);
    match(_t,IDENT);
    _t = _t.getNextSibling();
    break;
   }
   case ESCAPED_IDENT:
   {
    id2 = (IdlParserAST)_t;
    IdlParserAST id2_AST_in = null;
    id2_AST = (IdlParserAST)astFactory.create(id2);
    astFactory.addASTChild(currentAST, id2_AST);
    match(_t,ESCAPED_IDENT);
    _t = _t.getNextSibling();
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   if ( inputState.guessing==0 ) {
    
    IdlParserAST id = (id1 != null) ? id1 : this.removeEscape (id2);
    this.m_builder.startInitDcl(id);
    
   }
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_in:
   {
    init_param_decls(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case 3:
   case LITERAL_raises:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_raises:
   {
    raises_expr(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case 3:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   currentAST = __currentAST152;
   _t = __t152;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endInitDcl();
    
   }
   init_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = init_dcl_AST;
  _retTree = _t;
 }
 
 public final void access(AST _t) throws RecognitionException {
  
  IdlParserAST access_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST access_AST = null;
  
  try {      // for error handling
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_private:
   {
    IdlParserAST tmp11_AST = null;
    IdlParserAST tmp11_AST_in = null;
    tmp11_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
    tmp11_AST_in = (IdlParserAST)_t;
    astFactory.addASTChild(currentAST, tmp11_AST);
    match(_t,LITERAL_private);
    _t = _t.getNextSibling();
    access_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_public:
   {
    IdlParserAST tmp12_AST = null;
    IdlParserAST tmp12_AST_in = null;
    tmp12_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
    tmp12_AST_in = (IdlParserAST)_t;
    astFactory.addASTChild(currentAST, tmp12_AST);
    match(_t,LITERAL_public);
    _t = _t.getNextSibling();
    access_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = access_AST;
  _retTree = _t;
 }
 
 public final void init_param_decls(AST _t) throws RecognitionException {
  
  IdlParserAST init_param_decls_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST init_param_decls_AST = null;
  
  try {      // for error handling
   init_param_decl(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   {
   _loop158:
   do {
    if (_t==null) _t=ASTNULL;
    if ((_t.getType()==LITERAL_in)) {
     init_param_decl(_t);
     _t = _retTree;
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop158;
    }
    
   } while (true);
   }
   init_param_decls_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = init_param_decls_AST;
  _retTree = _t;
 }
 
 public final void raises_expr(AST _t) throws RecognitionException {
  
  IdlParserAST raises_expr_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST raises_expr_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  try {      // for error handling
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startRaisesExpr();
    
   }
   AST __t275 = _t;
   i1 = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   ASTPair __currentAST275 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_raises);
   _t = _t.getFirstChild();
   scoped_name_list(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   currentAST = __currentAST275;
   _t = __t275;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endRaisesExpr(i1);
    
   }
   raises_expr_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = raises_expr_AST;
  _retTree = _t;
 }
 
 public final void init_param_decl(AST _t) throws RecognitionException {
  
  IdlParserAST init_param_decl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST init_param_decl_AST = null;
  IdlParserAST dec_AST = null;
  IdlParserAST dec = null;
  
  try {      // for error handling
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startInitParamDcl();
    
   }
   IdlParserAST tmp13_AST = null;
   IdlParserAST tmp13_AST_in = null;
   tmp13_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp13_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp13_AST);
   match(_t,LITERAL_in);
   _t = _t.getNextSibling();
   param_type_spec(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   dec = _t==ASTNULL ? null : (IdlParserAST)_t;
   simple_declarator(_t);
   _t = _retTree;
   dec_AST = (IdlParserAST)returnAST;
   astFactory.addASTChild(currentAST, returnAST);
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endInitParamDcl(dec);
    
   }
   init_param_decl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = init_param_decl_AST;
  _retTree = _t;
 }
 
 public final void param_type_spec(AST _t) throws RecognitionException {
  
  IdlParserAST param_type_spec_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST param_type_spec_AST = null;
  
  try {      // for error handling
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_float:
   case LITERAL_double:
   case LITERAL_long:
   case LITERAL_short:
   case LITERAL_unsigned:
   case LITERAL_char:
   case LITERAL_wchar:
   case LITERAL_boolean:
   case LITERAL_octet:
   case LITERAL_any:
   case LITERAL_Object:
   case LITERAL_ValueBase:
   {
    if ( inputState.guessing==0 ) {
     
     this.m_builder.startParamTypeSpec();
     
    }
    base_type_spec(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    param_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_string:
   {
    string_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    param_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_wstring:
   {
    wide_string_type(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    param_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case IDENT:
   case ESCAPED_IDENT:
   {
    scoped_name(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    if ( inputState.guessing==0 ) {
     
     this.m_builder.endParamTypeSpec();
     
    }
    param_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = param_type_spec_AST;
  _retTree = _t;
 }
 
 public final void simple_declarator(AST _t) throws RecognitionException {
  
  IdlParserAST simple_declarator_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST simple_declarator_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  IdlParserAST i2 = null;
  IdlParserAST i2_AST = null;
  
  try {      // for error handling
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case IDENT:
   {
    i1 = (IdlParserAST)_t;
    IdlParserAST i1_AST_in = null;
    i1_AST = (IdlParserAST)astFactory.create(i1);
    astFactory.addASTChild(currentAST, i1_AST);
    match(_t,IDENT);
    _t = _t.getNextSibling();
    break;
   }
   case ESCAPED_IDENT:
   {
    i2 = (IdlParserAST)_t;
    IdlParserAST i2_AST_in = null;
    i2_AST = (IdlParserAST)astFactory.create(i2);
    astFactory.addASTChild(currentAST, i2_AST);
    match(_t,ESCAPED_IDENT);
    _t = _t.getNextSibling();
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   if ( inputState.guessing==0 ) {
    
    IdlParserAST ast = (i1 != null) ? i1 : this.removeEscape (i2);
    this.m_builder.startSimpleDeclarator(ast);
    
    this.m_builder.endSimpleDeclarator();  
    
   }
   simple_declarator_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = simple_declarator_AST;
  _retTree = _t;
 }
 
 public final void interface_def(AST _t) throws RecognitionException {
  
  IdlParserAST interface_def_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST interface_def_AST = null;
  IdlParserAST interface_literal = null;
  IdlParserAST interface_literal_AST = null;
  IdlParserAST i1_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i2 = null;
  IdlParserAST i2_AST = null;
  IdlParserAST i3 = null;
  IdlParserAST i3_AST = null;
  
  try {      // for error handling
   AST __t168 = _t;
   interface_literal = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST interface_literal_AST_in = null;
   interface_literal_AST = (IdlParserAST)astFactory.create(interface_literal);
   astFactory.addASTChild(currentAST, interface_literal_AST);
   ASTPair __currentAST168 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_interface);
   _t = _t.getFirstChild();
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_abstract:
   case LITERAL_local:
   {
    i1 = _t==ASTNULL ? null : (IdlParserAST)_t;
    interf_modifier_decl(_t);
    _t = _retTree;
    i1_AST = (IdlParserAST)returnAST;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case IDENT:
   case ESCAPED_IDENT:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case IDENT:
   {
    i2 = (IdlParserAST)_t;
    IdlParserAST i2_AST_in = null;
    i2_AST = (IdlParserAST)astFactory.create(i2);
    astFactory.addASTChild(currentAST, i2_AST);
    match(_t,IDENT);
    _t = _t.getNextSibling();
    break;
   }
   case ESCAPED_IDENT:
   {
    i3 = (IdlParserAST)_t;
    IdlParserAST i3_AST_in = null;
    i3_AST = (IdlParserAST)astFactory.create(i3);
    astFactory.addASTChild(currentAST, i3_AST);
    match(_t,ESCAPED_IDENT);
    _t = _t.getNextSibling();
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   if ( inputState.guessing==0 ) {
    
    IdlParserAST ast = (i2 != null) ? i2 : this.removeEscape (i3);
    this.m_builder.startInterfaceType(i1, ast, interface_literal);
    
   }
   interface_header(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   IdlParserAST tmp14_AST = null;
   IdlParserAST tmp14_AST_in = null;
   tmp14_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp14_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp14_AST);
   match(_t,LCURLY);
   _t = _t.getNextSibling();
   interface_body(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   IdlParserAST tmp15_AST = null;
   IdlParserAST tmp15_AST_in = null;
   tmp15_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp15_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp15_AST);
   match(_t,RCURLY);
   _t = _t.getNextSibling();
   currentAST = __currentAST168;
   _t = __t168;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endInterfaceType();
    
   }
   interface_def_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = interface_def_AST;
  _retTree = _t;
 }
 
 public final void interface_forward_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST interface_forward_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST interface_forward_dcl_AST = null;
  IdlParserAST interface_literal = null;
  IdlParserAST interface_literal_AST = null;
  IdlParserAST i1_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i2 = null;
  IdlParserAST i2_AST = null;
  IdlParserAST i3 = null;
  IdlParserAST i3_AST = null;
  
  try {      // for error handling
   AST __t164 = _t;
   interface_literal = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST interface_literal_AST_in = null;
   interface_literal_AST = (IdlParserAST)astFactory.create(interface_literal);
   astFactory.addASTChild(currentAST, interface_literal_AST);
   ASTPair __currentAST164 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_interface);
   _t = _t.getFirstChild();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startInterfaceForwardDecl();
    
   }
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_abstract:
   case LITERAL_local:
   {
    i1 = _t==ASTNULL ? null : (IdlParserAST)_t;
    interf_modifier_decl(_t);
    _t = _retTree;
    i1_AST = (IdlParserAST)returnAST;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case IDENT:
   case ESCAPED_IDENT:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case IDENT:
   {
    i2 = (IdlParserAST)_t;
    IdlParserAST i2_AST_in = null;
    i2_AST = (IdlParserAST)astFactory.create(i2);
    astFactory.addASTChild(currentAST, i2_AST);
    match(_t,IDENT);
    _t = _t.getNextSibling();
    break;
   }
   case ESCAPED_IDENT:
   {
    i3 = (IdlParserAST)_t;
    IdlParserAST i3_AST_in = null;
    i3_AST = (IdlParserAST)astFactory.create(i3);
    astFactory.addASTChild(currentAST, i3_AST);
    match(_t,ESCAPED_IDENT);
    _t = _t.getNextSibling();
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   if ( inputState.guessing==0 ) {
    
    IdlParserAST ast = (i2 != null) ? i2 : this.removeEscape (i3);
    this.m_builder.endInterfaceForwardDecl(i1, ast, interface_literal);
    
   }
   currentAST = __currentAST164;
   _t = __t164;
   _t = _t.getNextSibling();
   interface_forward_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = interface_forward_dcl_AST;
  _retTree = _t;
 }
 
 public final void interf_modifier_decl(AST _t) throws RecognitionException {
  
  IdlParserAST interf_modifier_decl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST interf_modifier_decl_AST = null;
  
  try {      // for error handling
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_abstract:
   {
    IdlParserAST tmp16_AST = null;
    IdlParserAST tmp16_AST_in = null;
    tmp16_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
    tmp16_AST_in = (IdlParserAST)_t;
    astFactory.addASTChild(currentAST, tmp16_AST);
    match(_t,LITERAL_abstract);
    _t = _t.getNextSibling();
    interf_modifier_decl_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_local:
   {
    IdlParserAST tmp17_AST = null;
    IdlParserAST tmp17_AST_in = null;
    tmp17_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
    tmp17_AST_in = (IdlParserAST)_t;
    astFactory.addASTChild(currentAST, tmp17_AST);
    match(_t,LITERAL_local);
    _t = _t.getNextSibling();
    interf_modifier_decl_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = interf_modifier_decl_AST;
  _retTree = _t;
 }
 
 public final void interface_header(AST _t) throws RecognitionException {
  
  IdlParserAST interface_header_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST interface_header_AST = null;
  
  try {      // for error handling
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startInterfaceHeader();  
    
   }
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case COLON:
   {
    interf_inheritance_spec(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LCURLY:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endInterfaceHeader();
    
   }
   interface_header_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = interface_header_AST;
  _retTree = _t;
 }
 
 public final void interface_body(AST _t) throws RecognitionException {
  
  IdlParserAST interface_body_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST interface_body_AST = null;
  
  try {      // for error handling
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startInterfaceBody();
    
   }
   {
   _loop178:
   do {
    if (_t==null) _t=ASTNULL;
    if ((_tokenSet_4.member(_t.getType()))) {
     export_dcl(_t);
     _t = _retTree;
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop178;
    }
    
   } while (true);
   }
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endInterfaceBody();
    
   }
   interface_body_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = interface_body_AST;
  _retTree = _t;
 }
 
 public final void interf_inheritance_spec(AST _t) throws RecognitionException {
  
  IdlParserAST interf_inheritance_spec_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST interf_inheritance_spec_AST = null;
  
  try {      // for error handling
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startInterfaceInherSpec();  
    
   }
   AST __t175 = _t;
   IdlParserAST tmp18_AST = null;
   IdlParserAST tmp18_AST_in = null;
   tmp18_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp18_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp18_AST);
   ASTPair __currentAST175 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,COLON);
   _t = _t.getFirstChild();
   scoped_name_list(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   currentAST = __currentAST175;
   _t = __t175;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endInterfaceInherSpec();  
    
   }
   interf_inheritance_spec_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = interf_inheritance_spec_AST;
  _retTree = _t;
 }
 
 public final void attr_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST attr_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST attr_dcl_AST = null;
  
  try {      // for error handling
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startAttrDecl();
    
   }
   attr_spec(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endAttrDecl();
    
   }
   attr_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = attr_dcl_AST;
  _retTree = _t;
 }
 
 public final void op_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST op_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST op_dcl_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  IdlParserAST i2_AST = null;
  IdlParserAST i2 = null;
  IdlParserAST i3 = null;
  IdlParserAST i3_AST = null;
  IdlParserAST i4_AST = null;
  IdlParserAST i4 = null;
  
  this.m_builder.startOperationDecl();
  
  
  try {      // for error handling
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case IDENT:
   {
    AST __t196 = _t;
    i1 = _t==ASTNULL ? null :(IdlParserAST)_t;
    IdlParserAST i1_AST_in = null;
    i1_AST = (IdlParserAST)astFactory.create(i1);
    astFactory.addASTChild(currentAST, i1_AST);
    ASTPair __currentAST196 = currentAST.copy();
    currentAST.root = currentAST.child;
    currentAST.child = null;
    match(_t,IDENT);
    _t = _t.getFirstChild();
    {
    if (_t==null) _t=ASTNULL;
    switch ( _t.getType()) {
    case LITERAL_oneway:
    {
     i2 = _t==ASTNULL ? null : (IdlParserAST)_t;
     op_attribute(_t);
     _t = _retTree;
     i2_AST = (IdlParserAST)returnAST;
     astFactory.addASTChild(currentAST, returnAST);
     break;
    }
    case IDENT:
    case ESCAPED_IDENT:
    case LITERAL_float:
    case LITERAL_double:
    case LITERAL_long:
    case LITERAL_short:
    case LITERAL_unsigned:
    case LITERAL_char:
    case LITERAL_wchar:
    case LITERAL_boolean:
    case LITERAL_octet:
    case LITERAL_any:
    case LITERAL_Object:
    case LITERAL_string:
    case LITERAL_wstring:
    case LITERAL_void:
    case LITERAL_ValueBase:
    {
     break;
    }
    default:
    {
     throw new NoViableAltException(_t);
    }
    }
    }
    if ( inputState.guessing==0 ) {
     
     this.m_builder.endOperationDeclAttribute(i1, i2);
     
    }
    op_type_spec(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    parameter_dcls(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    {
    if (_t==null) _t=ASTNULL;
    switch ( _t.getType()) {
    case LITERAL_raises:
    {
     raises_expr(_t);
     _t = _retTree;
     astFactory.addASTChild(currentAST, returnAST);
     break;
    }
    case 3:
    case LITERAL_context:
    {
     break;
    }
    default:
    {
     throw new NoViableAltException(_t);
    }
    }
    }
    {
    if (_t==null) _t=ASTNULL;
    switch ( _t.getType()) {
    case LITERAL_context:
    {
     context_expr(_t);
     _t = _retTree;
     astFactory.addASTChild(currentAST, returnAST);
     break;
    }
    case 3:
    {
     break;
    }
    default:
    {
     throw new NoViableAltException(_t);
    }
    }
    }
    currentAST = __currentAST196;
    _t = __t196;
    _t = _t.getNextSibling();
    break;
   }
   case ESCAPED_IDENT:
   {
    AST __t200 = _t;
    i3 = _t==ASTNULL ? null :(IdlParserAST)_t;
    IdlParserAST i3_AST_in = null;
    i3_AST = (IdlParserAST)astFactory.create(i3);
    astFactory.addASTChild(currentAST, i3_AST);
    ASTPair __currentAST200 = currentAST.copy();
    currentAST.root = currentAST.child;
    currentAST.child = null;
    match(_t,ESCAPED_IDENT);
    _t = _t.getFirstChild();
    {
    if (_t==null) _t=ASTNULL;
    switch ( _t.getType()) {
    case LITERAL_oneway:
    {
     i4 = _t==ASTNULL ? null : (IdlParserAST)_t;
     op_attribute(_t);
     _t = _retTree;
     i4_AST = (IdlParserAST)returnAST;
     astFactory.addASTChild(currentAST, returnAST);
     break;
    }
    case IDENT:
    case ESCAPED_IDENT:
    case LITERAL_float:
    case LITERAL_double:
    case LITERAL_long:
    case LITERAL_short:
    case LITERAL_unsigned:
    case LITERAL_char:
    case LITERAL_wchar:
    case LITERAL_boolean:
    case LITERAL_octet:
    case LITERAL_any:
    case LITERAL_Object:
    case LITERAL_string:
    case LITERAL_wstring:
    case LITERAL_void:
    case LITERAL_ValueBase:
    {
     break;
    }
    default:
    {
     throw new NoViableAltException(_t);
    }
    }
    }
    if ( inputState.guessing==0 ) {
     
     this.m_builder.endOperationDeclAttribute(this.removeEscape (i3), i4);
     
    }
    op_type_spec(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    parameter_dcls(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    {
    if (_t==null) _t=ASTNULL;
    switch ( _t.getType()) {
    case LITERAL_raises:
    {
     raises_expr(_t);
     _t = _retTree;
     astFactory.addASTChild(currentAST, returnAST);
     break;
    }
    case 3:
    case LITERAL_context:
    {
     break;
    }
    default:
    {
     throw new NoViableAltException(_t);
    }
    }
    }
    {
    if (_t==null) _t=ASTNULL;
    switch ( _t.getType()) {
    case LITERAL_context:
    {
     context_expr(_t);
     _t = _retTree;
     astFactory.addASTChild(currentAST, returnAST);
     break;
    }
    case 3:
    {
     break;
    }
    default:
    {
     throw new NoViableAltException(_t);
    }
    }
    }
    currentAST = __currentAST200;
    _t = __t200;
    _t = _t.getNextSibling();
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endOperationDecl();
    
   }
   op_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = op_dcl_AST;
  _retTree = _t;
 }
 
 public final void string_literal(AST _t) throws RecognitionException {
  
  IdlParserAST string_literal_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST string_literal_AST = null;
  IdlParserAST i1_AST = null;
  IdlParserAST i1 = null;
  
  this.m_builder.startStringLiteral();
  
  
  try {      // for error handling
   {
   int _cnt321=0;
   _loop321:
   do {
    if (_t==null) _t=ASTNULL;
    if ((_t.getType()==STRING_LITERAL)) {
     i1 = _t==ASTNULL ? null : (IdlParserAST)_t;
     string_literal_inner(_t);
     _t = _retTree;
     i1_AST = (IdlParserAST)returnAST;
     astFactory.addASTChild(currentAST, returnAST);
     if ( inputState.guessing==0 ) {
      
      this.m_builder.endStringLiteral(i1);
      
     }
    }
    else {
     if ( _cnt321>=1 ) { break _loop321; } else {throw new NoViableAltException(_t);}
    }
    
    _cnt321++;
   } while (true);
   }
   string_literal_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = string_literal_AST;
  _retTree = _t;
 }
 
 public final void struct_forward_decl(AST _t) throws RecognitionException {
  
  IdlParserAST struct_forward_decl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST struct_forward_decl_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  IdlParserAST i2 = null;
  IdlParserAST i2_AST = null;
  
  try {      // for error handling
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startStructForwardDecl();
    
   }
   AST __t189 = _t;
   IdlParserAST tmp19_AST = null;
   IdlParserAST tmp19_AST_in = null;
   tmp19_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp19_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp19_AST);
   ASTPair __currentAST189 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_struct);
   _t = _t.getFirstChild();
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case IDENT:
   {
    i1 = (IdlParserAST)_t;
    IdlParserAST i1_AST_in = null;
    i1_AST = (IdlParserAST)astFactory.create(i1);
    astFactory.addASTChild(currentAST, i1_AST);
    match(_t,IDENT);
    _t = _t.getNextSibling();
    break;
   }
   case ESCAPED_IDENT:
   {
    i2 = (IdlParserAST)_t;
    IdlParserAST i2_AST_in = null;
    i2_AST = (IdlParserAST)astFactory.create(i2);
    astFactory.addASTChild(currentAST, i2_AST);
    match(_t,ESCAPED_IDENT);
    _t = _t.getNextSibling();
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   currentAST = __currentAST189;
   _t = __t189;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    IdlParserAST ast = (i1 != null) ? i1 : this.removeEscape (i2);
    this.m_builder.endStructForwardDecl(ast);
    
   }
   struct_forward_decl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = struct_forward_decl_AST;
  _retTree = _t;
 }
 
 public final void union_forward_decl(AST _t) throws RecognitionException {
  
  IdlParserAST union_forward_decl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST union_forward_decl_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  IdlParserAST i2 = null;
  IdlParserAST i2_AST = null;
  
  try {      // for error handling
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startUnionForwardDecl();
    
   }
   AST __t192 = _t;
   IdlParserAST tmp20_AST = null;
   IdlParserAST tmp20_AST_in = null;
   tmp20_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp20_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp20_AST);
   ASTPair __currentAST192 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_union);
   _t = _t.getFirstChild();
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case IDENT:
   {
    i1 = (IdlParserAST)_t;
    IdlParserAST i1_AST_in = null;
    i1_AST = (IdlParserAST)astFactory.create(i1);
    astFactory.addASTChild(currentAST, i1_AST);
    match(_t,IDENT);
    _t = _t.getNextSibling();
    break;
   }
   case ESCAPED_IDENT:
   {
    i2 = (IdlParserAST)_t;
    IdlParserAST i2_AST_in = null;
    i2_AST = (IdlParserAST)astFactory.create(i2);
    astFactory.addASTChild(currentAST, i2_AST);
    match(_t,ESCAPED_IDENT);
    _t = _t.getNextSibling();
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   currentAST = __currentAST192;
   _t = __t192;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    IdlParserAST ast = (i1 != null) ? i1 : this.removeEscape (i2);
    this.m_builder.endUnionForwardDecl(ast);
    
   }
   union_forward_decl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = union_forward_decl_AST;
  _retTree = _t;
 }
 
 public final void op_attribute(AST _t) throws RecognitionException {
  
  IdlParserAST op_attribute_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST op_attribute_AST = null;
  
  this.m_builder.startOpAttribute();
  
  
  try {      // for error handling
   IdlParserAST tmp21_AST = null;
   IdlParserAST tmp21_AST_in = null;
   tmp21_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp21_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp21_AST);
   match(_t,LITERAL_oneway);
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endOpAttribute();
    
   }
   op_attribute_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = op_attribute_AST;
  _retTree = _t;
 }
 
 public final void op_type_spec(AST _t) throws RecognitionException {
  
  IdlParserAST op_type_spec_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST op_type_spec_AST = null;
  
  this.m_builder.startOpTypeSpec();
  
  
  try {      // for error handling
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case IDENT:
   case ESCAPED_IDENT:
   case LITERAL_float:
   case LITERAL_double:
   case LITERAL_long:
   case LITERAL_short:
   case LITERAL_unsigned:
   case LITERAL_char:
   case LITERAL_wchar:
   case LITERAL_boolean:
   case LITERAL_octet:
   case LITERAL_any:
   case LITERAL_Object:
   case LITERAL_string:
   case LITERAL_wstring:
   case LITERAL_ValueBase:
   {
    param_type_spec(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LITERAL_void:
   {
    void_literal(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endOpTypeSpec();
    
   }
   op_type_spec_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = op_type_spec_AST;
  _retTree = _t;
 }
 
 public final void parameter_dcls(AST _t) throws RecognitionException {
  
  IdlParserAST parameter_dcls_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST parameter_dcls_AST = null;
  
  try {      // for error handling
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_in:
   case LITERAL_out:
   case LITERAL_inout:
   {
    param_dcl_list(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case 3:
   case LITERAL_raises:
   case LITERAL_context:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   parameter_dcls_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = parameter_dcls_AST;
  _retTree = _t;
 }
 
 public final void context_expr(AST _t) throws RecognitionException {
  
  IdlParserAST context_expr_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST context_expr_AST = null;
  
  try {      // for error handling
   AST __t218 = _t;
   IdlParserAST tmp22_AST = null;
   IdlParserAST tmp22_AST_in = null;
   tmp22_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp22_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp22_AST);
   ASTPair __currentAST218 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_context);
   _t = _t.getFirstChild();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startContextExpr();
    
   }
   {
   int _cnt220=0;
   _loop220:
   do {
    if (_t==null) _t=ASTNULL;
    if ((_t.getType()==STRING_LITERAL)) {
     string_literal(_t);
     _t = _retTree;
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     if ( _cnt220>=1 ) { break _loop220; } else {throw new NoViableAltException(_t);}
    }
    
    _cnt220++;
   } while (true);
   }
   currentAST = __currentAST218;
   _t = __t218;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endContextExpr();
    
   }
   context_expr_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = context_expr_AST;
  _retTree = _t;
 }
 
 public final void void_literal(AST _t) throws RecognitionException {
  
  IdlParserAST void_literal_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST void_literal_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  try {      // for error handling
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startVoidLiteral();
    
   }
   i1 = (IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   match(_t,LITERAL_void);
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endVoidLiteral(i1);
    
   }
   void_literal_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = void_literal_AST;
  _retTree = _t;
 }
 
 public final void attr_spec(AST _t) throws RecognitionException {
  
  IdlParserAST attr_spec_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST attr_spec_AST = null;
  
  try {      // for error handling
   boolean synPredMatched212 = false;
   if (_t==null) _t=ASTNULL;
   if (((_t.getType()==LITERAL_attribute))) {
    AST __t212 = _t;
    synPredMatched212 = true;
    inputState.guessing++;
    try {
     {
     AST __t211 = _t;
     ASTPair __currentAST211 = currentAST.copy();
     currentAST.root = currentAST.child;
     currentAST.child = null;
     match(_t,LITERAL_attribute);
     _t = _t.getFirstChild();
     match(_t,LITERAL_readonly);
     _t = _t.getNextSibling();
     currentAST = __currentAST211;
     _t = __t211;
     _t = _t.getNextSibling();
     }
    }
    catch (RecognitionException pe) {
     synPredMatched212 = false;
    }
    _t = __t212;
inputState.guessing--;
   }
   if ( synPredMatched212 ) {
    if ( inputState.guessing==0 ) {
     
     this.m_builder.startAttrSpec();
     
    }
    readonly_attr_spec(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    attr_spec_AST = (IdlParserAST)currentAST.root;
   }
   else if ((_t.getType()==LITERAL_attribute)) {
    normal_attr_spec(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    if ( inputState.guessing==0 ) {
     
     this.m_builder.endAttrSpec();
     
    }
    attr_spec_AST = (IdlParserAST)currentAST.root;
   }
   else {
    throw new NoViableAltException(_t);
   }
   
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = attr_spec_AST;
  _retTree = _t;
 }
 
 public final void readonly_attr_spec(AST _t) throws RecognitionException {
  
  IdlParserAST readonly_attr_spec_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST readonly_attr_spec_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  IdlParserAST i2 = null;
  IdlParserAST i2_AST = null;
  
  try {      // for error handling
   AST __t214 = _t;
   i1 = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   ASTPair __currentAST214 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_attribute);
   _t = _t.getFirstChild();
   i2 = (IdlParserAST)_t;
   IdlParserAST i2_AST_in = null;
   i2_AST = (IdlParserAST)astFactory.create(i2);
   astFactory.addASTChild(currentAST, i2_AST);
   match(_t,LITERAL_readonly);
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startReadonlyAttrSpec(i1, i2);
    
   }
   param_type_spec(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endAttrParamSpec();
    
   }
   readonly_attr_declarator(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   currentAST = __currentAST214;
   _t = __t214;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endReadonlyAttrSpec();
    
   }
   readonly_attr_spec_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = readonly_attr_spec_AST;
  _retTree = _t;
 }
 
 public final void normal_attr_spec(AST _t) throws RecognitionException {
  
  IdlParserAST normal_attr_spec_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST normal_attr_spec_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  try {      // for error handling
   AST __t216 = _t;
   i1 = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   ASTPair __currentAST216 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_attribute);
   _t = _t.getFirstChild();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startNormalAttrSpec(i1);
    
   }
   param_type_spec(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endAttrParamSpec();
    
   }
   attr_declarator(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   currentAST = __currentAST216;
   _t = __t216;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endNormalAttrSpec();
    
   }
   normal_attr_spec_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = normal_attr_spec_AST;
  _retTree = _t;
 }
 
 public final void readonly_attr_declarator(AST _t) throws RecognitionException {
  
  IdlParserAST readonly_attr_declarator_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST readonly_attr_declarator_AST = null;
  
  try {      // for error handling
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startReadonlyAttrDeclarator();
    
   }
   simple_declarator(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_raises:
   {
    raises_expr(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case 3:
   case IDENT:
   case ESCAPED_IDENT:
   {
    {
    _loop263:
    do {
     if (_t==null) _t=ASTNULL;
     if ((_t.getType()==IDENT||_t.getType()==ESCAPED_IDENT)) {
      simple_declarator(_t);
      _t = _retTree;
      astFactory.addASTChild(currentAST, returnAST);
     }
     else {
      break _loop263;
     }
     
    } while (true);
    }
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endReadonlyAttrDeclarator();
    
   }
   readonly_attr_declarator_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = readonly_attr_declarator_AST;
  _retTree = _t;
 }
 
 public final void attr_declarator(AST _t) throws RecognitionException {
  
  IdlParserAST attr_declarator_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST attr_declarator_AST = null;
  
  try {      // for error handling
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startAttrDeclarator();
    
   }
   simple_declarator(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   {
   boolean synPredMatched268 = false;
   if (_t==null) _t=ASTNULL;
   if (((_t.getType()==3||_t.getType()==LITERAL_getraises||_t.getType()==LITERAL_setraises))) {
    AST __t268 = _t;
    synPredMatched268 = true;
    inputState.guessing++;
    try {
     {
     AST __t267 = _t;
     ASTPair __currentAST267 = currentAST.copy();
     currentAST.root = currentAST.child;
     currentAST.child = null;
     match(_t,LITERAL_getraises);
     _t = _t.getFirstChild();
     scoped_name_list(_t);
     _t = _retTree;
     currentAST = __currentAST267;
     _t = __t267;
     _t = _t.getNextSibling();
     }
    }
    catch (RecognitionException pe) {
     synPredMatched268 = false;
    }
    _t = __t268;
inputState.guessing--;
   }
   if ( synPredMatched268 ) {
    attr_raises_expr(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
   }
   else {
    boolean synPredMatched271 = false;
    if (_t==null) _t=ASTNULL;
    if (((_t.getType()==3||_t.getType()==LITERAL_getraises||_t.getType()==LITERAL_setraises))) {
     AST __t271 = _t;
     synPredMatched271 = true;
     inputState.guessing++;
     try {
      {
      AST __t270 = _t;
      ASTPair __currentAST270 = currentAST.copy();
      currentAST.root = currentAST.child;
      currentAST.child = null;
      match(_t,LITERAL_setraises);
      _t = _t.getFirstChild();
      scoped_name_list(_t);
      _t = _retTree;
      currentAST = __currentAST270;
      _t = __t270;
      _t = _t.getNextSibling();
      }
     }
     catch (RecognitionException pe) {
      synPredMatched271 = false;
     }
     _t = __t271;
inputState.guessing--;
    }
    if ( synPredMatched271 ) {
     attr_raises_expr(_t);
     _t = _retTree;
     astFactory.addASTChild(currentAST, returnAST);
    }
    else if ((_t.getType()==3||_t.getType()==IDENT||_t.getType()==ESCAPED_IDENT)) {
     {
     _loop273:
     do {
      if (_t==null) _t=ASTNULL;
      if ((_t.getType()==IDENT||_t.getType()==ESCAPED_IDENT)) {
       simple_declarator(_t);
       _t = _retTree;
       astFactory.addASTChild(currentAST, returnAST);
      }
      else {
       break _loop273;
      }
      
     } while (true);
     }
    }
    else {
     throw new NoViableAltException(_t);
    }
    }
    }
    if ( inputState.guessing==0 ) {
     
     this.m_builder.endAttrDeclarator();
     
    }
    attr_declarator_AST = (IdlParserAST)currentAST.root;
   }
   catch (RecognitionException ex) {
    if (inputState.guessing==0) {
     reportError(ex);
     if (_t!=null) {_t = _t.getNextSibling();}
    } else {
      throw ex;
    }
   }
   returnAST = attr_declarator_AST;
   _retTree = _t;
  }
  
 public final void param_dcl_list(AST _t) throws RecognitionException {
  
  IdlParserAST param_dcl_list_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST param_dcl_list_AST = null;
  
  try {      // for error handling
   {
   int _cnt225=0;
   _loop225:
   do {
    if (_t==null) _t=ASTNULL;
    if ((_t.getType()==LITERAL_in||_t.getType()==LITERAL_out||_t.getType()==LITERAL_inout)) {
     param_dcl(_t);
     _t = _retTree;
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     if ( _cnt225>=1 ) { break _loop225; } else {throw new NoViableAltException(_t);}
    }
    
    _cnt225++;
   } while (true);
   }
   param_dcl_list_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = param_dcl_list_AST;
  _retTree = _t;
 }
 
 public final void param_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST param_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST param_dcl_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  IdlParserAST i4_AST = null;
  IdlParserAST i4 = null;
  IdlParserAST i2 = null;
  IdlParserAST i2_AST = null;
  IdlParserAST i5_AST = null;
  IdlParserAST i5 = null;
  IdlParserAST i3 = null;
  IdlParserAST i3_AST = null;
  IdlParserAST i6_AST = null;
  IdlParserAST i6 = null;
  
  this.m_builder.startParamDcl();
  IdlParserAST i7 = null, i8 = null;
  
  
  try {      // for error handling
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_in:
   {
    AST __t228 = _t;
    i1 = _t==ASTNULL ? null :(IdlParserAST)_t;
    IdlParserAST i1_AST_in = null;
    i1_AST = (IdlParserAST)astFactory.create(i1);
    astFactory.addASTChild(currentAST, i1_AST);
    ASTPair __currentAST228 = currentAST.copy();
    currentAST.root = currentAST.child;
    currentAST.child = null;
    match(_t,LITERAL_in);
    _t = _t.getFirstChild();
    param_type_spec(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    i4 = _t==ASTNULL ? null : (IdlParserAST)_t;
    simple_declarator(_t);
    _t = _retTree;
    i4_AST = (IdlParserAST)returnAST;
    astFactory.addASTChild(currentAST, returnAST);
    currentAST = __currentAST228;
    _t = __t228;
    _t = _t.getNextSibling();
    break;
   }
   case LITERAL_out:
   {
    AST __t229 = _t;
    i2 = _t==ASTNULL ? null :(IdlParserAST)_t;
    IdlParserAST i2_AST_in = null;
    i2_AST = (IdlParserAST)astFactory.create(i2);
    astFactory.addASTChild(currentAST, i2_AST);
    ASTPair __currentAST229 = currentAST.copy();
    currentAST.root = currentAST.child;
    currentAST.child = null;
    match(_t,LITERAL_out);
    _t = _t.getFirstChild();
    param_type_spec(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    i5 = _t==ASTNULL ? null : (IdlParserAST)_t;
    simple_declarator(_t);
    _t = _retTree;
    i5_AST = (IdlParserAST)returnAST;
    astFactory.addASTChild(currentAST, returnAST);
    currentAST = __currentAST229;
    _t = __t229;
    _t = _t.getNextSibling();
    break;
   }
   case LITERAL_inout:
   {
    AST __t230 = _t;
    i3 = _t==ASTNULL ? null :(IdlParserAST)_t;
    IdlParserAST i3_AST_in = null;
    i3_AST = (IdlParserAST)astFactory.create(i3);
    astFactory.addASTChild(currentAST, i3_AST);
    ASTPair __currentAST230 = currentAST.copy();
    currentAST.root = currentAST.child;
    currentAST.child = null;
    match(_t,LITERAL_inout);
    _t = _t.getFirstChild();
    param_type_spec(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    i6 = _t==ASTNULL ? null : (IdlParserAST)_t;
    simple_declarator(_t);
    _t = _retTree;
    i6_AST = (IdlParserAST)returnAST;
    astFactory.addASTChild(currentAST, returnAST);
    currentAST = __currentAST230;
    _t = __t230;
    _t = _t.getNextSibling();
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   if ( inputState.guessing==0 ) {
    
    if (i1 != null)
    {
    i7 = i1;
    i8 = i4;
    }
    else if (i2 != null)
    {
    i7 = i2;
    i8 = i5;
    }
    else if (i3 != null)
    {
    i7 = i3;
    i8 = i6;
    }
    
   }
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endParamDcl(i7, i8);
    
   }
   param_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = param_dcl_AST;
  _retTree = _t;
 }
 
 public final void exception_member_list(AST _t) throws RecognitionException {
  
  IdlParserAST exception_member_list_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST exception_member_list_AST = null;
  
  try {      // for error handling
   {
   _loop236:
   do {
    if (_t==null) _t=ASTNULL;
    if ((_tokenSet_2.member(_t.getType()))) {
     member(_t);
     _t = _retTree;
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop236;
    }
    
   } while (true);
   }
   exception_member_list_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = exception_member_list_AST;
  _retTree = _t;
 }
 
 public final void fixed_array_size(AST _t) throws RecognitionException {
  
  IdlParserAST fixed_array_size_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST fixed_array_size_AST = null;
  
  try {      // for error handling
   const_or_scoped_decl(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   fixed_array_size_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = fixed_array_size_AST;
  _retTree = _t;
 }
 
 public final void complex_declarator(AST _t) throws RecognitionException {
  
  IdlParserAST complex_declarator_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST complex_declarator_AST = null;
  
  try {      // for error handling
   array_declarator(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   complex_declarator_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = complex_declarator_AST;
  _retTree = _t;
 }
 
 public final void array_declarator(AST _t) throws RecognitionException {
  
  IdlParserAST array_declarator_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST array_declarator_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  IdlParserAST i2 = null;
  IdlParserAST i2_AST = null;
  
  try {      // for error handling
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case IDENT:
   {
    AST __t254 = _t;
    i1 = _t==ASTNULL ? null :(IdlParserAST)_t;
    IdlParserAST i1_AST_in = null;
    i1_AST = (IdlParserAST)astFactory.create(i1);
    astFactory.addASTChild(currentAST, i1_AST);
    ASTPair __currentAST254 = currentAST.copy();
    currentAST.root = currentAST.child;
    currentAST.child = null;
    match(_t,IDENT);
    _t = _t.getFirstChild();
    if ( inputState.guessing==0 ) {
     
     this.m_builder.startArrayDeclarator(i1);
     
    }
    {
    int _cnt256=0;
    _loop256:
    do {
     if (_t==null) _t=ASTNULL;
     if ((_tokenSet_1.member(_t.getType()))) {
      const_or_scoped_decl(_t);
      _t = _retTree;
      astFactory.addASTChild(currentAST, returnAST);
     }
     else {
      if ( _cnt256>=1 ) { break _loop256; } else {throw new NoViableAltException(_t);}
     }
     
     _cnt256++;
    } while (true);
    }
    currentAST = __currentAST254;
    _t = __t254;
    _t = _t.getNextSibling();
    break;
   }
   case ESCAPED_IDENT:
   {
    AST __t257 = _t;
    i2 = _t==ASTNULL ? null :(IdlParserAST)_t;
    IdlParserAST i2_AST_in = null;
    i2_AST = (IdlParserAST)astFactory.create(i2);
    astFactory.addASTChild(currentAST, i2_AST);
    ASTPair __currentAST257 = currentAST.copy();
    currentAST.root = currentAST.child;
    currentAST.child = null;
    match(_t,ESCAPED_IDENT);
    _t = _t.getFirstChild();
    if ( inputState.guessing==0 ) {
     
     this.m_builder.startArrayDeclarator(this.removeEscape (i2));
     
    }
    {
    int _cnt259=0;
    _loop259:
    do {
     if (_t==null) _t=ASTNULL;
     if ((_tokenSet_1.member(_t.getType()))) {
      const_or_scoped_decl(_t);
      _t = _retTree;
      astFactory.addASTChild(currentAST, returnAST);
     }
     else {
      if ( _cnt259>=1 ) { break _loop259; } else {throw new NoViableAltException(_t);}
     }
     
     _cnt259++;
    } while (true);
    }
    currentAST = __currentAST257;
    _t = __t257;
    _t = _t.getNextSibling();
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endArrayDeclarator();
    
   }
   array_declarator_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = array_declarator_AST;
  _retTree = _t;
 }
 
 public final void attr_raises_expr(AST _t) throws RecognitionException {
  
  IdlParserAST attr_raises_expr_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST attr_raises_expr_AST = null;
  
  try {      // for error handling
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_getraises:
   {
    get_excep_expr(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case 3:
   case LITERAL_setraises:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_setraises:
   {
    set_excep_expr(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case 3:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   attr_raises_expr_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = attr_raises_expr_AST;
  _retTree = _t;
 }
 
 public final void get_excep_expr(AST _t) throws RecognitionException {
  
  IdlParserAST get_excep_expr_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST get_excep_expr_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  this.m_builder.startGetRaisedException();
  
  
  try {      // for error handling
   AST __t280 = _t;
   i1 = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   ASTPair __currentAST280 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_getraises);
   _t = _t.getFirstChild();
   scoped_name_list(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   currentAST = __currentAST280;
   _t = __t280;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endGetRaisedException(i1);
    
   }
   get_excep_expr_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = get_excep_expr_AST;
  _retTree = _t;
 }
 
 public final void set_excep_expr(AST _t) throws RecognitionException {
  
  IdlParserAST set_excep_expr_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST set_excep_expr_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  this.m_builder.startSetRaisedException();
  
  
  try {      // for error handling
   AST __t282 = _t;
   i1 = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   ASTPair __currentAST282 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_setraises);
   _t = _t.getFirstChild();
   scoped_name_list(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   currentAST = __currentAST282;
   _t = __t282;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endSetRaisedException(i1);
    
   }
   set_excep_expr_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = set_excep_expr_AST;
  _retTree = _t;
 }
 
 public final void positive_int_const(AST _t) throws RecognitionException {
  
  IdlParserAST positive_int_const_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST positive_int_const_AST = null;
  
  try {      // for error handling
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startPositiveIntConst();
    
   }
   const_exp(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endPositiveIntConst();
    
   }
   positive_int_const_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = positive_int_const_AST;
  _retTree = _t;
 }
 
 public final void const_exp(AST _t) throws RecognitionException {
  
  IdlParserAST const_exp_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST const_exp_AST = null;
  
  try {      // for error handling
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case OR:
   {
    or_expr(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    const_exp_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case XOR:
   {
    xor_expr(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    const_exp_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case AND:
   {
    and_expr(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    const_exp_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case RSHIFT:
   {
    rshift_expr(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    const_exp_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LSHIFT:
   {
    lshift_expr(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    const_exp_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case PLUS:
   {
    plus_expr(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    const_exp_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case MINUS:
   {
    minus_expr(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    const_exp_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case TILDE:
   {
    tilde_expr(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    const_exp_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case STAR:
   {
    star_expr(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    const_exp_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case DIV:
   {
    div_expr(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    const_exp_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case MOD:
   {
    mod_expr(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    const_exp_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_TRUE:
   case LITERAL_FALSE:
   case INT:
   case OCTAL:
   case HEX:
   case STRING_LITERAL:
   case WIDE_STRING_LITERAL:
   case CHAR_LITERAL:
   case WIDE_CHAR_LITERAL:
   case FIXED:
   case FLOAT:
   {
    literal(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    const_exp_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case IDENT:
   case ESCAPED_IDENT:
   {
    scoped_name(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    const_exp_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = const_exp_AST;
  _retTree = _t;
 }
 
 public final void opt_pos_int(AST _t) throws RecognitionException {
  
  IdlParserAST opt_pos_int_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST opt_pos_int_AST = null;
  
  try {      // for error handling
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case IDENT:
   case ESCAPED_IDENT:
   case OR:
   case XOR:
   case AND:
   case LSHIFT:
   case RSHIFT:
   case PLUS:
   case MINUS:
   case STAR:
   case DIV:
   case MOD:
   case TILDE:
   case LITERAL_TRUE:
   case LITERAL_FALSE:
   case INT:
   case OCTAL:
   case HEX:
   case STRING_LITERAL:
   case WIDE_STRING_LITERAL:
   case CHAR_LITERAL:
   case WIDE_CHAR_LITERAL:
   case FIXED:
   case FLOAT:
   {
    positive_int_const(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case 3:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   opt_pos_int_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = opt_pos_int_AST;
  _retTree = _t;
 }
 
 public final void or_expr(AST _t) throws RecognitionException {
  
  IdlParserAST or_expr_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST or_expr_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  try {      // for error handling
   AST __t291 = _t;
   i1 = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   ASTPair __currentAST291 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,OR);
   _t = _t.getFirstChild();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startOrExpr(i1);
    
   }
   const_exp(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   const_exp(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   currentAST = __currentAST291;
   _t = __t291;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endOrExpr();
    
   }
   or_expr_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = or_expr_AST;
  _retTree = _t;
 }
 
 public final void xor_expr(AST _t) throws RecognitionException {
  
  IdlParserAST xor_expr_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST xor_expr_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  try {      // for error handling
   AST __t293 = _t;
   i1 = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   ASTPair __currentAST293 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,XOR);
   _t = _t.getFirstChild();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startXorExpr(i1);
    
   }
   const_exp(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   const_exp(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   currentAST = __currentAST293;
   _t = __t293;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endXorExpr();
    
   }
   xor_expr_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = xor_expr_AST;
  _retTree = _t;
 }
 
 public final void and_expr(AST _t) throws RecognitionException {
  
  IdlParserAST and_expr_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST and_expr_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  try {      // for error handling
   AST __t295 = _t;
   i1 = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   ASTPair __currentAST295 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,AND);
   _t = _t.getFirstChild();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startAndExpr(i1);
    
   }
   const_exp(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   const_exp(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   currentAST = __currentAST295;
   _t = __t295;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endAndExpr();
    
   }
   and_expr_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = and_expr_AST;
  _retTree = _t;
 }
 
 public final void rshift_expr(AST _t) throws RecognitionException {
  
  IdlParserAST rshift_expr_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST rshift_expr_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  try {      // for error handling
   AST __t297 = _t;
   i1 = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   ASTPair __currentAST297 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,RSHIFT);
   _t = _t.getFirstChild();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startRShiftExpr(i1);
    
   }
   const_exp(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   const_exp(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   currentAST = __currentAST297;
   _t = __t297;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endRShiftExpr();
    
   }
   rshift_expr_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = rshift_expr_AST;
  _retTree = _t;
 }
 
 public final void lshift_expr(AST _t) throws RecognitionException {
  
  IdlParserAST lshift_expr_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST lshift_expr_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  try {      // for error handling
   AST __t299 = _t;
   i1 = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   ASTPair __currentAST299 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LSHIFT);
   _t = _t.getFirstChild();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startLShiftExpr(i1);
    
   }
   const_exp(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   const_exp(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   currentAST = __currentAST299;
   _t = __t299;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endLShiftExpr();
    
   }
   lshift_expr_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = lshift_expr_AST;
  _retTree = _t;
 }
 
 public final void plus_expr(AST _t) throws RecognitionException {
  
  IdlParserAST plus_expr_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST plus_expr_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  try {      // for error handling
   AST __t301 = _t;
   i1 = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   ASTPair __currentAST301 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,PLUS);
   _t = _t.getFirstChild();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startPlusExpr(i1);
    
   }
   const_exp(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case IDENT:
   case ESCAPED_IDENT:
   case OR:
   case XOR:
   case AND:
   case LSHIFT:
   case RSHIFT:
   case PLUS:
   case MINUS:
   case STAR:
   case DIV:
   case MOD:
   case TILDE:
   case LITERAL_TRUE:
   case LITERAL_FALSE:
   case INT:
   case OCTAL:
   case HEX:
   case STRING_LITERAL:
   case WIDE_STRING_LITERAL:
   case CHAR_LITERAL:
   case WIDE_CHAR_LITERAL:
   case FIXED:
   case FLOAT:
   {
    const_exp(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case 3:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   currentAST = __currentAST301;
   _t = __t301;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endPlusExpr();
    
   }
   plus_expr_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = plus_expr_AST;
  _retTree = _t;
 }
 
 public final void minus_expr(AST _t) throws RecognitionException {
  
  IdlParserAST minus_expr_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST minus_expr_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  try {      // for error handling
   AST __t304 = _t;
   i1 = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   ASTPair __currentAST304 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,MINUS);
   _t = _t.getFirstChild();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startMinusExpr(i1);
    
   }
   const_exp(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case IDENT:
   case ESCAPED_IDENT:
   case OR:
   case XOR:
   case AND:
   case LSHIFT:
   case RSHIFT:
   case PLUS:
   case MINUS:
   case STAR:
   case DIV:
   case MOD:
   case TILDE:
   case LITERAL_TRUE:
   case LITERAL_FALSE:
   case INT:
   case OCTAL:
   case HEX:
   case STRING_LITERAL:
   case WIDE_STRING_LITERAL:
   case CHAR_LITERAL:
   case WIDE_CHAR_LITERAL:
   case FIXED:
   case FLOAT:
   {
    const_exp(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case 3:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   currentAST = __currentAST304;
   _t = __t304;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endMinusExpr();
    
   }
   minus_expr_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = minus_expr_AST;
  _retTree = _t;
 }
 
 public final void tilde_expr(AST _t) throws RecognitionException {
  
  IdlParserAST tilde_expr_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST tilde_expr_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  try {      // for error handling
   AST __t307 = _t;
   i1 = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   ASTPair __currentAST307 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,TILDE);
   _t = _t.getFirstChild();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startTildeExpr(i1);
    
   }
   const_exp(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   currentAST = __currentAST307;
   _t = __t307;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endTildeExpr();
    
   }
   tilde_expr_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = tilde_expr_AST;
  _retTree = _t;
 }
 
 public final void star_expr(AST _t) throws RecognitionException {
  
  IdlParserAST star_expr_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST star_expr_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  try {      // for error handling
   AST __t309 = _t;
   i1 = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   ASTPair __currentAST309 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,STAR);
   _t = _t.getFirstChild();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startStarExpr(i1);
    
   }
   const_exp(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   const_exp(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   currentAST = __currentAST309;
   _t = __t309;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endStarExpr();
    
   }
   star_expr_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = star_expr_AST;
  _retTree = _t;
 }
 
 public final void div_expr(AST _t) throws RecognitionException {
  
  IdlParserAST div_expr_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST div_expr_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  try {      // for error handling
   AST __t311 = _t;
   i1 = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   ASTPair __currentAST311 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,DIV);
   _t = _t.getFirstChild();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startDivExpr(i1);
    
   }
   const_exp(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   const_exp(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   currentAST = __currentAST311;
   _t = __t311;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endDivExpr();
    
   }
   div_expr_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = div_expr_AST;
  _retTree = _t;
 }
 
 public final void mod_expr(AST _t) throws RecognitionException {
  
  IdlParserAST mod_expr_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST mod_expr_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  try {      // for error handling
   AST __t313 = _t;
   i1 = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   ASTPair __currentAST313 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,MOD);
   _t = _t.getFirstChild();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startModExpr(i1);
    
   }
   const_exp(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   const_exp(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   currentAST = __currentAST313;
   _t = __t313;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endModExpr();
    
   }
   mod_expr_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = mod_expr_AST;
  _retTree = _t;
 }
 
 public final void literal(AST _t) throws RecognitionException {
  
  IdlParserAST literal_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST literal_AST = null;
  
  try {      // for error handling
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case INT:
   case OCTAL:
   case HEX:
   {
    integer_literal(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    literal_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case STRING_LITERAL:
   {
    string_literal(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    literal_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case WIDE_STRING_LITERAL:
   {
    wide_string_literal(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    literal_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case CHAR_LITERAL:
   {
    character_literal(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    literal_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case WIDE_CHAR_LITERAL:
   {
    wide_character_literal(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    literal_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case FIXED:
   {
    fixed_pt_literal(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    literal_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case FLOAT:
   {
    floating_pt_literal(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    literal_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_TRUE:
   case LITERAL_FALSE:
   {
    boolean_literal(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    literal_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = literal_AST;
  _retTree = _t;
 }
 
 public final void integer_literal(AST _t) throws RecognitionException {
  
  IdlParserAST integer_literal_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST integer_literal_AST = null;
  IdlParserAST i1_AST = null;
  IdlParserAST i1 = null;
  
  this.m_builder.startIntegerLiteral();
  
  
  try {      // for error handling
   i1 = _t==ASTNULL ? null : (IdlParserAST)_t;
   integer_literal_inner(_t);
   _t = _retTree;
   i1_AST = (IdlParserAST)returnAST;
   astFactory.addASTChild(currentAST, returnAST);
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endIntegerLiteral(i1);
    
   }
   integer_literal_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = integer_literal_AST;
  _retTree = _t;
 }
 
 public final void wide_string_literal(AST _t) throws RecognitionException {
  
  IdlParserAST wide_string_literal_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST wide_string_literal_AST = null;
  IdlParserAST i1_AST = null;
  IdlParserAST i1 = null;
  
  this.m_builder.startWStringLiteral();
  
  
  try {      // for error handling
   i1 = _t==ASTNULL ? null : (IdlParserAST)_t;
   wide_string_literal_inner(_t);
   _t = _retTree;
   i1_AST = (IdlParserAST)returnAST;
   astFactory.addASTChild(currentAST, returnAST);
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endWStringLiteral(i1);
    
   }
   wide_string_literal_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = wide_string_literal_AST;
  _retTree = _t;
 }
 
 public final void character_literal(AST _t) throws RecognitionException {
  
  IdlParserAST character_literal_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST character_literal_AST = null;
  IdlParserAST i1_AST = null;
  IdlParserAST i1 = null;
  
  this.m_builder.startCharLiteral();
  
  
  try {      // for error handling
   i1 = _t==ASTNULL ? null : (IdlParserAST)_t;
   character_literal_inner(_t);
   _t = _retTree;
   i1_AST = (IdlParserAST)returnAST;
   astFactory.addASTChild(currentAST, returnAST);
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endCharLiteral(i1);
    
   }
   character_literal_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = character_literal_AST;
  _retTree = _t;
 }
 
 public final void wide_character_literal(AST _t) throws RecognitionException {
  
  IdlParserAST wide_character_literal_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST wide_character_literal_AST = null;
  IdlParserAST i1_AST = null;
  IdlParserAST i1 = null;
  
  this.m_builder.startWCharLiteral();
  
  
  try {      // for error handling
   i1 = _t==ASTNULL ? null : (IdlParserAST)_t;
   wide_character_literal_inner(_t);
   _t = _retTree;
   i1_AST = (IdlParserAST)returnAST;
   astFactory.addASTChild(currentAST, returnAST);
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endWCharLiteral(i1);
    
   }
   wide_character_literal_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = wide_character_literal_AST;
  _retTree = _t;
 }
 
 public final void fixed_pt_literal(AST _t) throws RecognitionException {
  
  IdlParserAST fixed_pt_literal_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST fixed_pt_literal_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp23_AST = null;
   IdlParserAST tmp23_AST_in = null;
   tmp23_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp23_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp23_AST);
   match(_t,FIXED);
   _t = _t.getNextSibling();
   fixed_pt_literal_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = fixed_pt_literal_AST;
  _retTree = _t;
 }
 
 public final void floating_pt_literal(AST _t) throws RecognitionException {
  
  IdlParserAST floating_pt_literal_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST floating_pt_literal_AST = null;
  IdlParserAST i1_AST = null;
  IdlParserAST i1 = null;
  
  this.m_builder.startFloatLiteral();
  
  
  try {      // for error handling
   i1 = _t==ASTNULL ? null : (IdlParserAST)_t;
   floating_pt_literal_inner(_t);
   _t = _retTree;
   i1_AST = (IdlParserAST)returnAST;
   astFactory.addASTChild(currentAST, returnAST);
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endFloatLiteral(i1);
    
   }
   floating_pt_literal_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = floating_pt_literal_AST;
  _retTree = _t;
 }
 
 public final void boolean_literal(AST _t) throws RecognitionException {
  
  IdlParserAST boolean_literal_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST boolean_literal_AST = null;
  IdlParserAST i1_AST = null;
  IdlParserAST i1 = null;
  
  this.m_builder.startBooleanLiteral();
  
  
  try {      // for error handling
   i1 = _t==ASTNULL ? null : (IdlParserAST)_t;
   boolean_literal_inner(_t);
   _t = _retTree;
   i1_AST = (IdlParserAST)returnAST;
   astFactory.addASTChild(currentAST, returnAST);
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endBooleanLiteral(i1);
    
   }
   boolean_literal_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = boolean_literal_AST;
  _retTree = _t;
 }
 
 public final void boolean_literal_inner(AST _t) throws RecognitionException {
  
  IdlParserAST boolean_literal_inner_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST boolean_literal_inner_AST = null;
  
  try {      // for error handling
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_TRUE:
   {
    IdlParserAST tmp24_AST = null;
    IdlParserAST tmp24_AST_in = null;
    tmp24_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
    tmp24_AST_in = (IdlParserAST)_t;
    astFactory.addASTChild(currentAST, tmp24_AST);
    match(_t,LITERAL_TRUE);
    _t = _t.getNextSibling();
    boolean_literal_inner_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_FALSE:
   {
    IdlParserAST tmp25_AST = null;
    IdlParserAST tmp25_AST_in = null;
    tmp25_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
    tmp25_AST_in = (IdlParserAST)_t;
    astFactory.addASTChild(currentAST, tmp25_AST);
    match(_t,LITERAL_FALSE);
    _t = _t.getNextSibling();
    boolean_literal_inner_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = boolean_literal_inner_AST;
  _retTree = _t;
 }
 
 public final void integer_literal_inner(AST _t) throws RecognitionException {
  
  IdlParserAST integer_literal_inner_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST integer_literal_inner_AST = null;
  
  try {      // for error handling
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case INT:
   {
    IdlParserAST tmp26_AST = null;
    IdlParserAST tmp26_AST_in = null;
    tmp26_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
    tmp26_AST_in = (IdlParserAST)_t;
    astFactory.addASTChild(currentAST, tmp26_AST);
    match(_t,INT);
    _t = _t.getNextSibling();
    integer_literal_inner_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case OCTAL:
   {
    IdlParserAST tmp27_AST = null;
    IdlParserAST tmp27_AST_in = null;
    tmp27_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
    tmp27_AST_in = (IdlParserAST)_t;
    astFactory.addASTChild(currentAST, tmp27_AST);
    match(_t,OCTAL);
    _t = _t.getNextSibling();
    integer_literal_inner_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case HEX:
   {
    IdlParserAST tmp28_AST = null;
    IdlParserAST tmp28_AST_in = null;
    tmp28_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
    tmp28_AST_in = (IdlParserAST)_t;
    astFactory.addASTChild(currentAST, tmp28_AST);
    match(_t,HEX);
    _t = _t.getNextSibling();
    integer_literal_inner_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = integer_literal_inner_AST;
  _retTree = _t;
 }
 
 public final void string_literal_inner(AST _t) throws RecognitionException {
  
  IdlParserAST string_literal_inner_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST string_literal_inner_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp29_AST = null;
   IdlParserAST tmp29_AST_in = null;
   tmp29_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp29_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp29_AST);
   match(_t,STRING_LITERAL);
   _t = _t.getNextSibling();
   string_literal_inner_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = string_literal_inner_AST;
  _retTree = _t;
 }
 
 public final void wide_string_literal_inner(AST _t) throws RecognitionException {
  
  IdlParserAST wide_string_literal_inner_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST wide_string_literal_inner_AST = null;
  
  try {      // for error handling
   {
   int _cnt326=0;
   _loop326:
   do {
    if (_t==null) _t=ASTNULL;
    if ((_t.getType()==WIDE_STRING_LITERAL)) {
     IdlParserAST tmp30_AST = null;
     IdlParserAST tmp30_AST_in = null;
     tmp30_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
     tmp30_AST_in = (IdlParserAST)_t;
     astFactory.addASTChild(currentAST, tmp30_AST);
     match(_t,WIDE_STRING_LITERAL);
     _t = _t.getNextSibling();
    }
    else {
     if ( _cnt326>=1 ) { break _loop326; } else {throw new NoViableAltException(_t);}
    }
    
    _cnt326++;
   } while (true);
   }
   wide_string_literal_inner_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = wide_string_literal_inner_AST;
  _retTree = _t;
 }
 
 public final void character_literal_inner(AST _t) throws RecognitionException {
  
  IdlParserAST character_literal_inner_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST character_literal_inner_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp31_AST = null;
   IdlParserAST tmp31_AST_in = null;
   tmp31_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp31_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp31_AST);
   match(_t,CHAR_LITERAL);
   _t = _t.getNextSibling();
   character_literal_inner_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = character_literal_inner_AST;
  _retTree = _t;
 }
 
 public final void wide_character_literal_inner(AST _t) throws RecognitionException {
  
  IdlParserAST wide_character_literal_inner_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST wide_character_literal_inner_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp32_AST = null;
   IdlParserAST tmp32_AST_in = null;
   tmp32_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp32_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp32_AST);
   match(_t,WIDE_CHAR_LITERAL);
   _t = _t.getNextSibling();
   wide_character_literal_inner_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = wide_character_literal_inner_AST;
  _retTree = _t;
 }
 
 public final void floating_pt_literal_inner(AST _t) throws RecognitionException {
  
  IdlParserAST floating_pt_literal_inner_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST floating_pt_literal_inner_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp33_AST = null;
   IdlParserAST tmp33_AST_in = null;
   tmp33_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp33_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp33_AST);
   match(_t,FLOAT);
   _t = _t.getNextSibling();
   floating_pt_literal_inner_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = floating_pt_literal_inner_AST;
  _retTree = _t;
 }
 
 public final void event_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST event_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST event_dcl_AST = null;
  IdlParserAST event_literal = null;
  IdlParserAST event_literal_AST = null;
  IdlParserAST cst = null;
  IdlParserAST cst_AST = null;
  IdlParserAST id = null;
  IdlParserAST id_AST = null;
  
  try {      // for error handling
   AST __t340 = _t;
   event_literal = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST event_literal_AST_in = null;
   event_literal_AST = (IdlParserAST)astFactory.create(event_literal);
   astFactory.addASTChild(currentAST, event_literal_AST);
   ASTPair __currentAST340 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_eventtype);
   _t = _t.getFirstChild();
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_custom:
   {
    cst = (IdlParserAST)_t;
    IdlParserAST cst_AST_in = null;
    cst_AST = (IdlParserAST)astFactory.create(cst);
    astFactory.addASTChild(currentAST, cst_AST);
    match(_t,LITERAL_custom);
    _t = _t.getNextSibling();
    break;
   }
   case IDENT:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   id = (IdlParserAST)_t;
   IdlParserAST id_AST_in = null;
   id_AST = (IdlParserAST)astFactory.create(id);
   astFactory.addASTChild(currentAST, id_AST);
   match(_t,IDENT);
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startEventDcl(cst, id, event_literal);
    
   }
   {
   if (_t==null) _t=ASTNULL;
   if ((_t.getType()==LCURLY||_t.getType()==COLON||_t.getType()==LITERAL_supports)) {
    value_inheritance_spec(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
   }
   else if ((_t.getType()==LCURLY)) {
   }
   else {
    throw new NoViableAltException(_t);
   }
   
   }
   IdlParserAST tmp34_AST = null;
   IdlParserAST tmp34_AST_in = null;
   tmp34_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp34_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp34_AST);
   match(_t,LCURLY);
   _t = _t.getNextSibling();
   {
   _loop344:
   do {
    if (_t==null) _t=ASTNULL;
    if ((_tokenSet_3.member(_t.getType()))) {
     value_element(_t);
     _t = _retTree;
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop344;
    }
    
   } while (true);
   }
   IdlParserAST tmp35_AST = null;
   IdlParserAST tmp35_AST_in = null;
   tmp35_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp35_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp35_AST);
   match(_t,RCURLY);
   _t = _t.getNextSibling();
   currentAST = __currentAST340;
   _t = __t340;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endEventDcl();
    
   }
   event_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = event_dcl_AST;
  _retTree = _t;
 }
 
 public final void event_abs_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST event_abs_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST event_abs_dcl_AST = null;
  IdlParserAST event_literal = null;
  IdlParserAST event_literal_AST = null;
  IdlParserAST id = null;
  IdlParserAST id_AST = null;
  
  try {      // for error handling
   AST __t346 = _t;
   event_literal = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST event_literal_AST_in = null;
   event_literal_AST = (IdlParserAST)astFactory.create(event_literal);
   astFactory.addASTChild(currentAST, event_literal_AST);
   ASTPair __currentAST346 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_eventtype);
   _t = _t.getFirstChild();
   IdlParserAST tmp36_AST = null;
   IdlParserAST tmp36_AST_in = null;
   tmp36_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp36_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp36_AST);
   match(_t,LITERAL_abstract);
   _t = _t.getNextSibling();
   id = (IdlParserAST)_t;
   IdlParserAST id_AST_in = null;
   id_AST = (IdlParserAST)astFactory.create(id);
   astFactory.addASTChild(currentAST, id_AST);
   match(_t,IDENT);
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startEventAbsDcl(id, event_literal);
    
   }
   {
   if (_t==null) _t=ASTNULL;
   if ((_t.getType()==LCURLY||_t.getType()==COLON||_t.getType()==LITERAL_supports)) {
    value_inheritance_spec(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
   }
   else if ((_t.getType()==LCURLY)) {
   }
   else {
    throw new NoViableAltException(_t);
   }
   
   }
   IdlParserAST tmp37_AST = null;
   IdlParserAST tmp37_AST_in = null;
   tmp37_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp37_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp37_AST);
   match(_t,LCURLY);
   _t = _t.getNextSibling();
   {
   _loop349:
   do {
    if (_t==null) _t=ASTNULL;
    if ((_tokenSet_4.member(_t.getType()))) {
     export_dcl(_t);
     _t = _retTree;
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop349;
    }
    
   } while (true);
   }
   IdlParserAST tmp38_AST = null;
   IdlParserAST tmp38_AST_in = null;
   tmp38_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp38_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp38_AST);
   match(_t,RCURLY);
   _t = _t.getNextSibling();
   currentAST = __currentAST346;
   _t = __t346;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endEventAbsDcl();
    
   }
   event_abs_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = event_abs_dcl_AST;
  _retTree = _t;
 }
 
 public final void event_forward_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST event_forward_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST event_forward_dcl_AST = null;
  IdlParserAST value_literal = null;
  IdlParserAST value_literal_AST = null;
  IdlParserAST abs = null;
  IdlParserAST abs_AST = null;
  IdlParserAST id = null;
  IdlParserAST id_AST = null;
  
  try {      // for error handling
   AST __t351 = _t;
   value_literal = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST value_literal_AST_in = null;
   value_literal_AST = (IdlParserAST)astFactory.create(value_literal);
   astFactory.addASTChild(currentAST, value_literal_AST);
   ASTPair __currentAST351 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_valuetype);
   _t = _t.getFirstChild();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startEventForwardDcl();
    
   }
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_abstract:
   {
    abs = (IdlParserAST)_t;
    IdlParserAST abs_AST_in = null;
    abs_AST = (IdlParserAST)astFactory.create(abs);
    astFactory.addASTChild(currentAST, abs_AST);
    match(_t,LITERAL_abstract);
    _t = _t.getNextSibling();
    break;
   }
   case IDENT:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   id = (IdlParserAST)_t;
   IdlParserAST id_AST_in = null;
   id_AST = (IdlParserAST)astFactory.create(id);
   astFactory.addASTChild(currentAST, id_AST);
   match(_t,IDENT);
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endEventForwardDcl(abs, id, value_literal);
    
   }
   currentAST = __currentAST351;
   _t = __t351;
   _t = _t.getNextSibling();
   event_forward_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = event_forward_dcl_AST;
  _retTree = _t;
 }
 
 public final void component_def(AST _t) throws RecognitionException {
  
  IdlParserAST component_def_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST component_def_AST = null;
  IdlParserAST component_literal = null;
  IdlParserAST component_literal_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  try {      // for error handling
   AST __t359 = _t;
   component_literal = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST component_literal_AST_in = null;
   component_literal_AST = (IdlParserAST)astFactory.create(component_literal);
   astFactory.addASTChild(currentAST, component_literal_AST);
   ASTPair __currentAST359 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_component);
   _t = _t.getFirstChild();
   i1 = (IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   match(_t,IDENT);
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startComponentType(i1, component_literal);
    
   }
   component_header(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   IdlParserAST tmp39_AST = null;
   IdlParserAST tmp39_AST_in = null;
   tmp39_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp39_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp39_AST);
   match(_t,LCURLY);
   _t = _t.getNextSibling();
   component_body(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   IdlParserAST tmp40_AST = null;
   IdlParserAST tmp40_AST_in = null;
   tmp40_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp40_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp40_AST);
   match(_t,RCURLY);
   _t = _t.getNextSibling();
   currentAST = __currentAST359;
   _t = __t359;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endComponentType();
    
   }
   component_def_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = component_def_AST;
  _retTree = _t;
 }
 
 public final void component_forward_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST component_forward_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST component_forward_dcl_AST = null;
  IdlParserAST component_literal = null;
  IdlParserAST component_literal_AST = null;
  IdlParserAST i1 = null;
  IdlParserAST i1_AST = null;
  
  try {      // for error handling
   AST __t357 = _t;
   component_literal = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST component_literal_AST_in = null;
   component_literal_AST = (IdlParserAST)astFactory.create(component_literal);
   astFactory.addASTChild(currentAST, component_literal_AST);
   ASTPair __currentAST357 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_component);
   _t = _t.getFirstChild();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startComponentForwardDecl();
    
   }
   i1 = (IdlParserAST)_t;
   IdlParserAST i1_AST_in = null;
   i1_AST = (IdlParserAST)astFactory.create(i1);
   astFactory.addASTChild(currentAST, i1_AST);
   match(_t,IDENT);
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endComponentForwardDecl(i1, component_literal);
    
   }
   currentAST = __currentAST357;
   _t = __t357;
   _t = _t.getNextSibling();
   component_forward_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = component_forward_dcl_AST;
  _retTree = _t;
 }
 
 public final void component_header(AST _t) throws RecognitionException {
  
  IdlParserAST component_header_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST component_header_AST = null;
  
  try {      // for error handling
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startComponentHeader();  
    
   }
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case COLON:
   {
    component_inheritance_spec(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LCURLY:
   case LITERAL_supports:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_supports:
   {
    component_supported_spec(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LCURLY:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endComponentHeader();
    
   }
   component_header_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = component_header_AST;
  _retTree = _t;
 }
 
 public final void component_body(AST _t) throws RecognitionException {
  
  IdlParserAST component_body_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST component_body_AST = null;
  
  try {      // for error handling
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startComponentBody();
    
   }
   {
   _loop369:
   do {
    if (_t==null) _t=ASTNULL;
    if ((_tokenSet_5.member(_t.getType()))) {
     component_export_dcl(_t);
     _t = _retTree;
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop369;
    }
    
   } while (true);
   }
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endComponentBody();
    
   }
   component_body_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = component_body_AST;
  _retTree = _t;
 }
 
 public final void component_inheritance_spec(AST _t) throws RecognitionException {
  
  IdlParserAST component_inheritance_spec_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST component_inheritance_spec_AST = null;
  
  try {      // for error handling
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startComponentInherSpec();  
    
   }
   AST __t364 = _t;
   IdlParserAST tmp41_AST = null;
   IdlParserAST tmp41_AST_in = null;
   tmp41_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp41_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp41_AST);
   ASTPair __currentAST364 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,COLON);
   _t = _t.getFirstChild();
   scoped_name(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   currentAST = __currentAST364;
   _t = __t364;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endComponentInherSpec();  
    
   }
   component_inheritance_spec_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = component_inheritance_spec_AST;
  _retTree = _t;
 }
 
 public final void component_supported_spec(AST _t) throws RecognitionException {
  
  IdlParserAST component_supported_spec_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST component_supported_spec_AST = null;
  
  try {      // for error handling
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startComponentSupportSpec();  
    
   }
   AST __t366 = _t;
   IdlParserAST tmp42_AST = null;
   IdlParserAST tmp42_AST_in = null;
   tmp42_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp42_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp42_AST);
   ASTPair __currentAST366 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_supports);
   _t = _t.getFirstChild();
   scoped_name_list(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   currentAST = __currentAST366;
   _t = __t366;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endComponentSupportSpec();  
    
   }
   component_supported_spec_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = component_supported_spec_AST;
  _retTree = _t;
 }
 
 public final void component_export_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST component_export_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST component_export_dcl_AST = null;
  
  this.m_builder.startComponentExportDcl();
  
  
  try {      // for error handling
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_provides:
   {
    provides_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LITERAL_uses:
   {
    uses_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LITERAL_emits:
   {
    emits_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LITERAL_publishes:
   {
    publishes_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LITERAL_consumes:
   {
    consumes_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LITERAL_attribute:
   {
    attr_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endComponentExportDcl();
    
   }
   component_export_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = component_export_dcl_AST;
  _retTree = _t;
 }
 
 public final void provides_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST provides_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST provides_dcl_AST = null;
  IdlParserAST provides_literal = null;
  IdlParserAST provides_literal_AST = null;
  IdlParserAST param_AST = null;
  IdlParserAST param = null;
  
  try {      // for error handling
   AST __t373 = _t;
   provides_literal = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST provides_literal_AST_in = null;
   provides_literal_AST = (IdlParserAST)astFactory.create(provides_literal);
   astFactory.addASTChild(currentAST, provides_literal_AST);
   ASTPair __currentAST373 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_provides);
   _t = _t.getFirstChild();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startProvidesDcl(provides_literal);
    
   }
   param = _t==ASTNULL ? null : (IdlParserAST)_t;
   param_type_spec(_t);
   _t = _retTree;
   param_AST = (IdlParserAST)returnAST;
   astFactory.addASTChild(currentAST, returnAST);
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endProvidesParamSpec(param);
    
   }
   simple_declarator(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endProvidesDcl();
    
   }
   currentAST = __currentAST373;
   _t = __t373;
   _t = _t.getNextSibling();
   provides_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = provides_dcl_AST;
  _retTree = _t;
 }
 
 public final void uses_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST uses_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST uses_dcl_AST = null;
  
  try {      // for error handling
   boolean synPredMatched377 = false;
   if (_t==null) _t=ASTNULL;
   if (((_t.getType()==LITERAL_uses))) {
    AST __t377 = _t;
    synPredMatched377 = true;
    inputState.guessing++;
    try {
     {
     AST __t376 = _t;
     ASTPair __currentAST376 = currentAST.copy();
     currentAST.root = currentAST.child;
     currentAST.child = null;
     match(_t,LITERAL_uses);
     _t = _t.getFirstChild();
     match(_t,LITERAL_multiple);
     _t = _t.getNextSibling();
     currentAST = __currentAST376;
     _t = __t376;
     _t = _t.getNextSibling();
     }
    }
    catch (RecognitionException pe) {
     synPredMatched377 = false;
    }
    _t = __t377;
inputState.guessing--;
   }
   if ( synPredMatched377 ) {
    multiple_uses_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    uses_dcl_AST = (IdlParserAST)currentAST.root;
   }
   else if ((_t.getType()==LITERAL_uses)) {
    single_uses_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    uses_dcl_AST = (IdlParserAST)currentAST.root;
   }
   else {
    throw new NoViableAltException(_t);
   }
   
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = uses_dcl_AST;
  _retTree = _t;
 }
 
 public final void emits_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST emits_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST emits_dcl_AST = null;
  IdlParserAST emits_literal = null;
  IdlParserAST emits_literal_AST = null;
  IdlParserAST param_AST = null;
  IdlParserAST param = null;
  
  try {      // for error handling
   AST __t383 = _t;
   emits_literal = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST emits_literal_AST_in = null;
   emits_literal_AST = (IdlParserAST)astFactory.create(emits_literal);
   astFactory.addASTChild(currentAST, emits_literal_AST);
   ASTPair __currentAST383 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_emits);
   _t = _t.getFirstChild();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startEmitsDcl(emits_literal);
    
   }
   param = _t==ASTNULL ? null : (IdlParserAST)_t;
   param_type_spec(_t);
   _t = _retTree;
   param_AST = (IdlParserAST)returnAST;
   astFactory.addASTChild(currentAST, returnAST);
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endEmitsParamSpec(param);
    
   }
   simple_declarator(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endEmitsDcl();
    
   }
   currentAST = __currentAST383;
   _t = __t383;
   _t = _t.getNextSibling();
   emits_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = emits_dcl_AST;
  _retTree = _t;
 }
 
 public final void publishes_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST publishes_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST publishes_dcl_AST = null;
  IdlParserAST publishes_literal = null;
  IdlParserAST publishes_literal_AST = null;
  IdlParserAST param_AST = null;
  IdlParserAST param = null;
  
  try {      // for error handling
   AST __t385 = _t;
   publishes_literal = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST publishes_literal_AST_in = null;
   publishes_literal_AST = (IdlParserAST)astFactory.create(publishes_literal);
   astFactory.addASTChild(currentAST, publishes_literal_AST);
   ASTPair __currentAST385 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_publishes);
   _t = _t.getFirstChild();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startPublishesDcl(publishes_literal);
    
   }
   param = _t==ASTNULL ? null : (IdlParserAST)_t;
   param_type_spec(_t);
   _t = _retTree;
   param_AST = (IdlParserAST)returnAST;
   astFactory.addASTChild(currentAST, returnAST);
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endPublishesParamSpec(param);
    
   }
   simple_declarator(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endPublishesDcl();
    
   }
   currentAST = __currentAST385;
   _t = __t385;
   _t = _t.getNextSibling();
   publishes_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = publishes_dcl_AST;
  _retTree = _t;
 }
 
 public final void consumes_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST consumes_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST consumes_dcl_AST = null;
  IdlParserAST consumes_literal = null;
  IdlParserAST consumes_literal_AST = null;
  IdlParserAST param_AST = null;
  IdlParserAST param = null;
  
  try {      // for error handling
   AST __t387 = _t;
   consumes_literal = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST consumes_literal_AST_in = null;
   consumes_literal_AST = (IdlParserAST)astFactory.create(consumes_literal);
   astFactory.addASTChild(currentAST, consumes_literal_AST);
   ASTPair __currentAST387 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_consumes);
   _t = _t.getFirstChild();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startConsumesDcl(consumes_literal);
    
   }
   param = _t==ASTNULL ? null : (IdlParserAST)_t;
   param_type_spec(_t);
   _t = _retTree;
   param_AST = (IdlParserAST)returnAST;
   astFactory.addASTChild(currentAST, returnAST);
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endConsumesParamSpec(param);
    
   }
   simple_declarator(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endConsumesDcl();
    
   }
   currentAST = __currentAST387;
   _t = __t387;
   _t = _t.getNextSibling();
   consumes_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = consumes_dcl_AST;
  _retTree = _t;
 }
 
 public final void multiple_uses_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST multiple_uses_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST multiple_uses_dcl_AST = null;
  IdlParserAST uses_literal = null;
  IdlParserAST uses_literal_AST = null;
  IdlParserAST param_AST = null;
  IdlParserAST param = null;
  
  try {      // for error handling
   AST __t379 = _t;
   uses_literal = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST uses_literal_AST_in = null;
   uses_literal_AST = (IdlParserAST)astFactory.create(uses_literal);
   astFactory.addASTChild(currentAST, uses_literal_AST);
   ASTPair __currentAST379 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_uses);
   _t = _t.getFirstChild();
   IdlParserAST tmp43_AST = null;
   IdlParserAST tmp43_AST_in = null;
   tmp43_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp43_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp43_AST);
   match(_t,LITERAL_multiple);
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startUsesDcl(uses_literal, true);
    
   }
   param = _t==ASTNULL ? null : (IdlParserAST)_t;
   param_type_spec(_t);
   _t = _retTree;
   param_AST = (IdlParserAST)returnAST;
   astFactory.addASTChild(currentAST, returnAST);
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endUsesParamSpec(param);
    
   }
   simple_declarator(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endUsesDcl();
    
   }
   currentAST = __currentAST379;
   _t = __t379;
   _t = _t.getNextSibling();
   multiple_uses_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = multiple_uses_dcl_AST;
  _retTree = _t;
 }
 
 public final void single_uses_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST single_uses_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST single_uses_dcl_AST = null;
  IdlParserAST uses_literal = null;
  IdlParserAST uses_literal_AST = null;
  IdlParserAST param_AST = null;
  IdlParserAST param = null;
  
  try {      // for error handling
   AST __t381 = _t;
   uses_literal = _t==ASTNULL ? null :(IdlParserAST)_t;
   IdlParserAST uses_literal_AST_in = null;
   uses_literal_AST = (IdlParserAST)astFactory.create(uses_literal);
   astFactory.addASTChild(currentAST, uses_literal_AST);
   ASTPair __currentAST381 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_uses);
   _t = _t.getFirstChild();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startUsesDcl(uses_literal, false);
    
   }
   param = _t==ASTNULL ? null : (IdlParserAST)_t;
   param_type_spec(_t);
   _t = _retTree;
   param_AST = (IdlParserAST)returnAST;
   astFactory.addASTChild(currentAST, returnAST);
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endUsesParamSpec(param);
    
   }
   simple_declarator(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endUsesDcl();
    
   }
   currentAST = __currentAST381;
   _t = __t381;
   _t = _t.getNextSibling();
   single_uses_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = single_uses_dcl_AST;
  _retTree = _t;
 }
 
 public final void home_header(AST _t) throws RecognitionException {
  
  IdlParserAST home_header_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST home_header_AST = null;
  
  try {      // for error handling
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startHomeHeader();  
    
   }
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case COLON:
   {
    home_inheritance_spec(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LITERAL_supports:
   case LITERAL_manages:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_supports:
   {
    home_supported_spec(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LITERAL_manages:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   {
   home_manages_spec(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   }
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_primarykey:
   {
    home_primary_key_spec(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LCURLY:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endHomeHeader();
    
   }
   home_header_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = home_header_AST;
  _retTree = _t;
 }
 
 public final void home_body(AST _t) throws RecognitionException {
  
  IdlParserAST home_body_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST home_body_AST = null;
  
  try {      // for error handling
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startHomeBody();
    
   }
   {
   _loop405:
   do {
    if (_t==null) _t=ASTNULL;
    if ((_tokenSet_6.member(_t.getType()))) {
     home_export_dcl(_t);
     _t = _retTree;
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop405;
    }
    
   } while (true);
   }
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endHomeBody();
    
   }
   home_body_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = home_body_AST;
  _retTree = _t;
 }
 
 public final void home_inheritance_spec(AST _t) throws RecognitionException {
  
  IdlParserAST home_inheritance_spec_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST home_inheritance_spec_AST = null;
  
  try {      // for error handling
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startHomeInherSpec();  
    
   }
   AST __t396 = _t;
   IdlParserAST tmp44_AST = null;
   IdlParserAST tmp44_AST_in = null;
   tmp44_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp44_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp44_AST);
   ASTPair __currentAST396 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,COLON);
   _t = _t.getFirstChild();
   scoped_name(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   currentAST = __currentAST396;
   _t = __t396;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endHomeInherSpec();  
    
   }
   home_inheritance_spec_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = home_inheritance_spec_AST;
  _retTree = _t;
 }
 
 public final void home_supported_spec(AST _t) throws RecognitionException {
  
  IdlParserAST home_supported_spec_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST home_supported_spec_AST = null;
  
  try {      // for error handling
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startHomeSupportSpec();  
    
   }
   AST __t398 = _t;
   IdlParserAST tmp45_AST = null;
   IdlParserAST tmp45_AST_in = null;
   tmp45_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp45_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp45_AST);
   ASTPair __currentAST398 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_supports);
   _t = _t.getFirstChild();
   scoped_name_list(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   currentAST = __currentAST398;
   _t = __t398;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endHomeSupportSpec();  
    
   }
   home_supported_spec_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = home_supported_spec_AST;
  _retTree = _t;
 }
 
 public final void home_manages_spec(AST _t) throws RecognitionException {
  
  IdlParserAST home_manages_spec_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST home_manages_spec_AST = null;
  
  try {      // for error handling
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startHomeManagesSpec();  
    
   }
   AST __t400 = _t;
   IdlParserAST tmp46_AST = null;
   IdlParserAST tmp46_AST_in = null;
   tmp46_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp46_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp46_AST);
   ASTPair __currentAST400 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_manages);
   _t = _t.getFirstChild();
   scoped_name(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   currentAST = __currentAST400;
   _t = __t400;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endHomeManagesSpec();  
    
   }
   home_manages_spec_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = home_manages_spec_AST;
  _retTree = _t;
 }
 
 public final void home_primary_key_spec(AST _t) throws RecognitionException {
  
  IdlParserAST home_primary_key_spec_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST home_primary_key_spec_AST = null;
  
  try {      // for error handling
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startHomePrimaryKeySpec();  
    
   }
   AST __t402 = _t;
   IdlParserAST tmp47_AST = null;
   IdlParserAST tmp47_AST_in = null;
   tmp47_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp47_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp47_AST);
   ASTPair __currentAST402 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_primarykey);
   _t = _t.getFirstChild();
   scoped_name(_t);
   _t = _retTree;
   astFactory.addASTChild(currentAST, returnAST);
   currentAST = __currentAST402;
   _t = __t402;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endHomePrimaryKeySpec();  
    
   }
   home_primary_key_spec_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = home_primary_key_spec_AST;
  _retTree = _t;
 }
 
 public final void home_export_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST home_export_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST home_export_dcl_AST = null;
  
  this.m_builder.startHomeExportDcl();
  
  
  try {      // for error handling
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_typedef:
   case LITERAL_native:
   case LITERAL_struct:
   case LITERAL_union:
   case LITERAL_enum:
   {
    type_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LITERAL_const:
   {
    const_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LITERAL_exception:
   {
    exception_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LITERAL_attribute:
   {
    attr_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case IDENT:
   case ESCAPED_IDENT:
   {
    op_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LITERAL_typeid:
   {
    type_id_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LITERAL_typeprefix:
   {
    type_prefix_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case PRAGMA:
   {
    pragma_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LITERAL_factory:
   {
    factory_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LITERAL_finder:
   {
    finder_dcl(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endHomeExportDcl();
    
   }
   home_export_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = home_export_dcl_AST;
  _retTree = _t;
 }
 
 public final void factory_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST factory_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST factory_dcl_AST = null;
  IdlParserAST id = null;
  IdlParserAST id_AST = null;
  
  try {      // for error handling
   AST __t409 = _t;
   IdlParserAST tmp48_AST = null;
   IdlParserAST tmp48_AST_in = null;
   tmp48_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp48_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp48_AST);
   ASTPair __currentAST409 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_factory);
   _t = _t.getFirstChild();
   id = (IdlParserAST)_t;
   IdlParserAST id_AST_in = null;
   id_AST = (IdlParserAST)astFactory.create(id);
   astFactory.addASTChild(currentAST, id_AST);
   match(_t,IDENT);
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startFactoryDcl(id);
    
   }
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_in:
   {
    init_param_decls(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case 3:
   case LITERAL_raises:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_raises:
   {
    raises_expr(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case 3:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   currentAST = __currentAST409;
   _t = __t409;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endFactoryDcl();
    
   }
   factory_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = factory_dcl_AST;
  _retTree = _t;
 }
 
 public final void finder_dcl(AST _t) throws RecognitionException {
  
  IdlParserAST finder_dcl_AST_in = (_t == ASTNULL) ? null : (IdlParserAST)_t;
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST finder_dcl_AST = null;
  IdlParserAST id = null;
  IdlParserAST id_AST = null;
  
  try {      // for error handling
   AST __t413 = _t;
   IdlParserAST tmp49_AST = null;
   IdlParserAST tmp49_AST_in = null;
   tmp49_AST = (IdlParserAST)astFactory.create((IdlParserAST)_t);
   tmp49_AST_in = (IdlParserAST)_t;
   astFactory.addASTChild(currentAST, tmp49_AST);
   ASTPair __currentAST413 = currentAST.copy();
   currentAST.root = currentAST.child;
   currentAST.child = null;
   match(_t,LITERAL_finder);
   _t = _t.getFirstChild();
   id = (IdlParserAST)_t;
   IdlParserAST id_AST_in = null;
   id_AST = (IdlParserAST)astFactory.create(id);
   astFactory.addASTChild(currentAST, id_AST);
   match(_t,IDENT);
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.startFinderDcl(id);
    
   }
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_in:
   {
    init_param_decls(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case 3:
   case LITERAL_raises:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   {
   if (_t==null) _t=ASTNULL;
   switch ( _t.getType()) {
   case LITERAL_raises:
   {
    raises_expr(_t);
    _t = _retTree;
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case 3:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(_t);
   }
   }
   }
   currentAST = __currentAST413;
   _t = __t413;
   _t = _t.getNextSibling();
   if ( inputState.guessing==0 ) {
    
    this.m_builder.endFinderDcl();
    
   }
   finder_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    if (_t!=null) {_t = _t.getNextSibling();}
   } else {
     throw ex;
   }
  }
  returnAST = finder_dcl_AST;
  _retTree = _t;
 }
 
 
 public static final String[] _tokenNames = {
  "<0>",
  "EOF",
  "<2>",
  "NULL_TREE_LOOKAHEAD",
  "SPECIFICATION",
  ";",
  "\"abstract\"",
  "\"local\"",
  "\"interface\"",
  "\"custom\"",
  "\"valuetype\"",
  "\"eventtype\"",
  "\"module\"",
  "{",
  "}",
  ":",
  ",",
  "::",
  "an identifer",
  "an escaped identifer",
  "\"truncatable\"",
  "\"supports\"",
  "\"public\"",
  "\"private\"",
  "\"factory\"",
  "(",
  ")",
  "\"in\"",
  "\"const\"",
  "=",
  "|",
  "^",
  "&",
  "<<",
  ">>",
  "+",
  "-",
  "*",
  "/",
  "%",
  "~",
  "\"TRUE\"",
  "\"FALSE\"",
  "\"typedef\"",
  "\"native\"",
  "\"float\"",
  "\"double\"",
  "\"long\"",
  "\"short\"",
  "\"unsigned\"",
  "\"char\"",
  "\"wchar\"",
  "\"boolean\"",
  "\"octet\"",
  "\"any\"",
  "\"Object\"",
  "\"struct\"",
  "\"union\"",
  "\"switch\"",
  "\"case\"",
  "\"default\"",
  "\"enum\"",
  "\"sequence\"",
  "<",
  ">",
  "\"string\"",
  "\"wstring\"",
  "[",
  "]",
  "\"exception\"",
  "\"oneway\"",
  "\"void\"",
  "\"out\"",
  "\"inout\"",
  "\"raises\"",
  "\"context\"",
  "\"fixed\"",
  "\"ValueBase\"",
  "\"import\"",
  "\"typeid\"",
  "\"typeprefix\"",
  "\"readonly\"",
  "\"attribute\"",
  "\"getraises\"",
  "\"setraises\"",
  "\"component\"",
  "\"provides\"",
  "\"uses\"",
  "\"multiple\"",
  "\"emits\"",
  "\"publishes\"",
  "\"consumes\"",
  "\"home\"",
  "\"manages\"",
  "\"primarykey\"",
  "\"finder\"",
  "an integer value",
  "an octal value",
  "a hexadecimal value value",
  "a string literal",
  "a wide string literal",
  "a character literal",
  "a wide character literal",
  "FIXED",
  "a floating point value",
  "PRAGMA",
  "LINEMARKER",
  "?",
  ".",
  "!",
  "white space",
  "NL",
  "#",
  "a comment",
  "an escape sequence",
  "an escaped character value",
  "a digit",
  "a non-zero digit",
  "an octal digit",
  "a hexadecimal digit"
 };
 
 private static final long[] mk_tokenSet_0() {
  long[] data = { 2522042179874987264L, 2199293886496L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
 private static final long[] mk_tokenSet_1() {
  long[] data = { 8795020066816L, 2194728288256L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
 private static final long[] mk_tokenSet_2() {
  long[] data = { 7205724219421491200L, 8198L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
 private static final long[] mk_tokenSet_3() {
  long[] data = { 2522042179905126400L, 2199023616032L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_3 = new BitSet(mk_tokenSet_3());
 private static final long[] mk_tokenSet_4() {
  long[] data = { 2522042179875766272L, 2199023616032L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_4 = new BitSet(mk_tokenSet_4());
 private static final long[] mk_tokenSet_5() {
  long[] data = { 0L, 247726080L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_5 = new BitSet(mk_tokenSet_5());
 private static final long[] mk_tokenSet_6() {
  long[] data = { 2522042179892543488L, 2201171099680L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_6 = new BitSet(mk_tokenSet_6());
 }
 
