// $ANTLR 2.7.7 (2006-11-01): "IdlParser.g" -> "IdlParser.java"$

  package com.prismtech.idt.imports.idl.internal.parser;
  
  import java.io.*;
  import java.net.URI;
  import java.util.List;
  import java.util.ArrayList;
  import java.util.Vector;
  import java.util.Hashtable;

import com.prismtech.idt.imports.idl.parser.*;
 
import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;
import antlr.collections.AST;
import java.util.Hashtable;
import antlr.ASTFactory;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;

/**
 *  This is a complete parser for the IDL language as defined
 *  by the CORBA 3.0.2 specification.  It will allow those who
 *  need an IDL parser to get up-and-running very quickly.
 *  Though IDL's syntax is very similar to C++, it is also
 *  much simpler, due in large part to the fact that it is
 *  a declarative-only language.
 *
 *  Some things that are not included are: Symbol table construction
 *  (it is not necessary for parsing, btw) and preprocessing (for
 *  IDL compiler #pragma directives). You can use just about any
 *  C or C++ preprocessor, but there is an interesting semantic
 *  issue if you are going to generate code: In C, #include is
 *  a literal include, in IDL, #include is more like Java's import:
 *  It adds definitions to the scope of the parse, but included
 *  definitions are not generated.
 *
 *  Jim Coker, jcoker@magelang.com
 *  Gary Duzan, gduzan@bbn.com
 */
public class IdlParser extends antlr.LLkParser       implements IdlTokenTypes
 {

   /**
    * 
    */
   private List<IIdlParserStatus> m_status = new ArrayList<IIdlParserStatus> ();

   /**
    * Calls the {@link #specification()} rule and returns the resulting
    * {@link AST}. If any lexer or parser errors are encountered, they will be
    * gathered together in an {@link IdlParserException} which gets thrown at
    * the end of the parse.
    * 
    * @return The details of any warnings or errors found by the {@link IdlLexer} or {@link IdlParser}
    */
   public IIdlParserStatus parse ()
   {
      this.getASTFactory().setASTNodeClass (IdlParserAST.class);
       
      try
      {
         specification ();
      }
      catch (RecognitionException e)
      {
         reportError (e);
      }
      catch (TokenStreamException e)
      {
         reportError (e);
      }

      return getStatus ();
   }
   
   /**
    * 
    */
   public IIdlParserStatus getStatus ()
   {
      switch (m_status.size ())
      {
         case 0 :
         {
            return new IdlParserStatus (IIdlParserStatus.OK);
         }
         case 1 :
         {
            return m_status.get (0);
         }
         default :
         {
            IdlParserStatus status = new IdlParserStatus ();
            
            for (IIdlParserStatus s : m_status)
            {
               status.add (s);
            }
            
            return status;
         }
      }
   }
   
   IdlLexer getIdlLexer ()
   {
      return (IdlLexer) inputState.getInput ().getInput ();
   }
   
   @Override
   public void reportError (RecognitionException exception)
   {
      m_status.add (new IdlRecognitionStatus (this, exception));
   }

   public void reportError (TokenStreamException exception)
   {
      m_status.add (new IdlTokenStreamStatus (this, exception));
   }

   @Override
   public void reportError (String message)
   {
      m_status.add (new IdlParserStatus (this, IIdlParserStatus.ERROR, message, null, getIdlLexer ().getFilename ()));
   }
   
   public IdlParser (InputStream in, URI initialIdlUri)
   {
      this (new IdlLexer (in));
      this.setFilename (initialIdlUri.getPath ());

      this.getASTFactory().setASTNodeClass (IdlParserAST.class);
   }

protected IdlParser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

public IdlParser(TokenBuffer tokenBuf) {
  this(tokenBuf,4);
}

protected IdlParser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

public IdlParser(TokenStream lexer) {
  this(lexer,4);
}

public IdlParser(ParserSharedInputState state) {
  super(state,4);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

 public final void specification() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST specification_AST = null;
  
  try {      // for error handling
   if ((_tokenSet_0.member(LA(1))) && (_tokenSet_1.member(LA(2))) && (_tokenSet_2.member(LA(3))) && (_tokenSet_3.member(LA(4)))) {
    {
    {
    _loop4:
    do {
     if ((LA(1)==LITERAL_import)) {
      import_dcl();
      astFactory.addASTChild(currentAST, returnAST);
     }
     else {
      break _loop4;
     }
     
    } while (true);
    }
    {
    _loop6:
    do {
     if ((_tokenSet_4.member(LA(1)))) {
      definition();
      astFactory.addASTChild(currentAST, returnAST);
     }
     else {
      break _loop6;
     }
     
    } while (true);
    }
    if ( inputState.guessing==0 ) {
     specification_AST = (IdlParserAST)currentAST.root;
     
     specification_AST = (IdlParserAST)astFactory.make( (new ASTArray(2)).add((IdlParserAST)astFactory.create(SPECIFICATION,"SPECIFICATION")).add(specification_AST));
     specification_AST.setFilename (getIdlLexer ().getPrimaryFilename ());
     
     currentAST.root = specification_AST;
     currentAST.child = specification_AST!=null &&specification_AST.getFirstChild()!=null ?
      specification_AST.getFirstChild() : specification_AST;
     currentAST.advanceChildToEnd();
    }
    }
    specification_AST = (IdlParserAST)currentAST.root;
   }
   else if ((LA(1)==EOF) && (LA(2)==EOF) && (LA(3)==EOF) && (LA(4)==EOF)) {
    if ( inputState.guessing==0 ) {
    }
    specification_AST = (IdlParserAST)currentAST.root;
   }
   else {
    throw new NoViableAltException(LT(1), getFilename());
   }
   
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_5);
   } else {
     throw ex;
   }
  }
  returnAST = specification_AST;
 }
 
 public final void import_dcl() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST import_dcl_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp1_AST = null;
   tmp1_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp1_AST);
   match(LITERAL_import);
   imported_scope();
   astFactory.addASTChild(currentAST, returnAST);
   match(SEMI);
   import_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_0);
   } else {
     throw ex;
   }
  }
  returnAST = import_dcl_AST;
 }
 
 public final void definition() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST definition_AST = null;
  
  try {      // for error handling
   {
   switch ( LA(1)) {
   case LITERAL_typedef:
   case LITERAL_native:
   case LITERAL_struct:
   case LITERAL_union:
   case LITERAL_enum:
   {
    type_dcl();
    astFactory.addASTChild(currentAST, returnAST);
    match(SEMI);
    break;
   }
   case LITERAL_const:
   {
    const_dcl();
    astFactory.addASTChild(currentAST, returnAST);
    match(SEMI);
    break;
   }
   case LITERAL_exception:
   {
    except_dcl();
    astFactory.addASTChild(currentAST, returnAST);
    match(SEMI);
    break;
   }
   case LITERAL_module:
   {
    module();
    astFactory.addASTChild(currentAST, returnAST);
    match(SEMI);
    break;
   }
   case LITERAL_typeid:
   {
    type_id_dcl();
    astFactory.addASTChild(currentAST, returnAST);
    match(SEMI);
    break;
   }
   case LITERAL_typeprefix:
   {
    type_prefix_dcl();
    astFactory.addASTChild(currentAST, returnAST);
    match(SEMI);
    break;
   }
   case LITERAL_component:
   {
    component();
    astFactory.addASTChild(currentAST, returnAST);
    match(SEMI);
    break;
   }
   case LITERAL_home:
   {
    home();
    astFactory.addASTChild(currentAST, returnAST);
    match(SEMI);
    break;
   }
   case PRAGMA:
   {
    pragma_dcl();
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   default:
    boolean synPredMatched11 = false;
    if ((((LA(1) >= LITERAL_abstract && LA(1) <= LITERAL_interface)) && (LA(2)==LITERAL_interface||LA(2)==IDENT||LA(2)==ESCAPED_IDENT) && (_tokenSet_6.member(LA(3))) && (_tokenSet_7.member(LA(4))))) {
     int _m11 = mark();
     synPredMatched11 = true;
     inputState.guessing++;
     try {
      {
      {
      switch ( LA(1)) {
      case LITERAL_abstract:
      {
       match(LITERAL_abstract);
       break;
      }
      case LITERAL_local:
      {
       match(LITERAL_local);
       break;
      }
      case LITERAL_interface:
      {
       break;
      }
      default:
      {
       throw new NoViableAltException(LT(1), getFilename());
      }
      }
      }
      match(LITERAL_interface);
      }
     }
     catch (RecognitionException pe) {
      synPredMatched11 = false;
     }
     rewind(_m11);
inputState.guessing--;
    }
    if ( synPredMatched11 ) {
     interf();
     astFactory.addASTChild(currentAST, returnAST);
     match(SEMI);
    }
    else {
     boolean synPredMatched14 = false;
     if (((LA(1)==LITERAL_abstract||LA(1)==LITERAL_custom||LA(1)==LITERAL_valuetype) && (LA(2)==LITERAL_valuetype||LA(2)==IDENT||LA(2)==ESCAPED_IDENT) && (_tokenSet_8.member(LA(3))) && (_tokenSet_9.member(LA(4))))) {
      int _m14 = mark();
      synPredMatched14 = true;
      inputState.guessing++;
      try {
       {
       {
       switch ( LA(1)) {
       case LITERAL_abstract:
       {
        match(LITERAL_abstract);
        break;
       }
       case LITERAL_custom:
       {
        match(LITERAL_custom);
        break;
       }
       case LITERAL_valuetype:
       {
        break;
       }
       default:
       {
        throw new NoViableAltException(LT(1), getFilename());
       }
       }
       }
       match(LITERAL_valuetype);
       }
      }
      catch (RecognitionException pe) {
       synPredMatched14 = false;
      }
      rewind(_m14);
inputState.guessing--;
     }
     if ( synPredMatched14 ) {
      value();
      astFactory.addASTChild(currentAST, returnAST);
      match(SEMI);
     }
     else {
      boolean synPredMatched17 = false;
      if (((LA(1)==LITERAL_abstract||LA(1)==LITERAL_custom||LA(1)==LITERAL_eventtype) && (LA(2)==LITERAL_eventtype||LA(2)==IDENT||LA(2)==ESCAPED_IDENT) && (_tokenSet_10.member(LA(3))) && (_tokenSet_11.member(LA(4))))) {
       int _m17 = mark();
       synPredMatched17 = true;
       inputState.guessing++;
       try {
        {
        {
        switch ( LA(1)) {
        case LITERAL_abstract:
        {
         match(LITERAL_abstract);
         break;
        }
        case LITERAL_custom:
        {
         match(LITERAL_custom);
         break;
        }
        case LITERAL_eventtype:
        {
         break;
        }
        default:
        {
         throw new NoViableAltException(LT(1), getFilename());
        }
        }
        }
        match(LITERAL_eventtype);
        }
       }
       catch (RecognitionException pe) {
        synPredMatched17 = false;
       }
       rewind(_m17);
inputState.guessing--;
      }
      if ( synPredMatched17 ) {
       event();
       astFactory.addASTChild(currentAST, returnAST);
       match(SEMI);
      }
     else {
      throw new NoViableAltException(LT(1), getFilename());
     }
     }}}
     }
     definition_AST = (IdlParserAST)currentAST.root;
    }
    catch (RecognitionException ex) {
     if (inputState.guessing==0) {
      reportError(ex);
      recover(ex,_tokenSet_12);
     } else {
       throw ex;
     }
    }
    returnAST = definition_AST;
   }
   
 public final void type_dcl() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST type_dcl_AST = null;
  
  try {      // for error handling
   switch ( LA(1)) {
   case LITERAL_typedef:
   {
    IdlParserAST tmp14_AST = null;
    tmp14_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.makeASTRoot(currentAST, tmp14_AST);
    match(LITERAL_typedef);
    type_declarator();
    astFactory.addASTChild(currentAST, returnAST);
    type_dcl_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_enum:
   {
    enum_type();
    astFactory.addASTChild(currentAST, returnAST);
    type_dcl_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_native:
   {
    IdlParserAST tmp15_AST = null;
    tmp15_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.makeASTRoot(currentAST, tmp15_AST);
    match(LITERAL_native);
    simple_declarator();
    astFactory.addASTChild(currentAST, returnAST);
    type_dcl_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
    boolean synPredMatched106 = false;
    if (((LA(1)==LITERAL_struct) && (LA(2)==IDENT||LA(2)==ESCAPED_IDENT) && (LA(3)==LCURLY))) {
     int _m106 = mark();
     synPredMatched106 = true;
     inputState.guessing++;
     try {
      {
      struct_type();
      }
     }
     catch (RecognitionException pe) {
      synPredMatched106 = false;
     }
     rewind(_m106);
inputState.guessing--;
    }
    if ( synPredMatched106 ) {
     struct_type();
     astFactory.addASTChild(currentAST, returnAST);
     type_dcl_AST = (IdlParserAST)currentAST.root;
    }
    else {
     boolean synPredMatched108 = false;
     if (((LA(1)==LITERAL_union) && (LA(2)==IDENT||LA(2)==ESCAPED_IDENT) && (LA(3)==LITERAL_switch))) {
      int _m108 = mark();
      synPredMatched108 = true;
      inputState.guessing++;
      try {
       {
       union_type();
       }
      }
      catch (RecognitionException pe) {
       synPredMatched108 = false;
      }
      rewind(_m108);
inputState.guessing--;
     }
     if ( synPredMatched108 ) {
      union_type();
      astFactory.addASTChild(currentAST, returnAST);
      type_dcl_AST = (IdlParserAST)currentAST.root;
     }
     else if ((LA(1)==LITERAL_struct||LA(1)==LITERAL_union) && (LA(2)==IDENT||LA(2)==ESCAPED_IDENT) && (LA(3)==SEMI)) {
      constr_forward_decl();
      astFactory.addASTChild(currentAST, returnAST);
      type_dcl_AST = (IdlParserAST)currentAST.root;
     }
    else {
     throw new NoViableAltException(LT(1), getFilename());
    }
    }}
   }
   catch (RecognitionException ex) {
    if (inputState.guessing==0) {
     reportError(ex);
     recover(ex,_tokenSet_13);
    } else {
      throw ex;
    }
   }
   returnAST = type_dcl_AST;
  }
  
 public final void const_dcl() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST const_dcl_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp16_AST = null;
   tmp16_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp16_AST);
   match(LITERAL_const);
   const_type();
   astFactory.addASTChild(currentAST, returnAST);
   identifier();
   astFactory.addASTChild(currentAST, returnAST);
   match(ASSIGN);
   const_exp();
   astFactory.addASTChild(currentAST, returnAST);
   const_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = const_dcl_AST;
 }
 
 public final void except_dcl() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST except_dcl_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp18_AST = null;
   tmp18_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp18_AST);
   match(LITERAL_exception);
   identifier();
   astFactory.addASTChild(currentAST, returnAST);
   match(LCURLY);
   opt_member_list();
   astFactory.addASTChild(currentAST, returnAST);
   match(RCURLY);
   except_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = except_dcl_AST;
 }
 
 public final void interf() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST interf_AST = null;
  
  try {      // for error handling
   {
   switch ( LA(1)) {
   case LITERAL_abstract:
   {
    IdlParserAST tmp21_AST = null;
    tmp21_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.addASTChild(currentAST, tmp21_AST);
    match(LITERAL_abstract);
    break;
   }
   case LITERAL_local:
   {
    IdlParserAST tmp22_AST = null;
    tmp22_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.addASTChild(currentAST, tmp22_AST);
    match(LITERAL_local);
    break;
   }
   case LITERAL_interface:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   IdlParserAST tmp23_AST = null;
   tmp23_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp23_AST);
   match(LITERAL_interface);
   identifier();
   astFactory.addASTChild(currentAST, returnAST);
   {
   switch ( LA(1)) {
   case LCURLY:
   case COLON:
   {
    interface_dcl();
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case SEMI:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   interf_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = interf_AST;
 }
 
 public final void module() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST module_AST = null;
  IdlParserAST d_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp24_AST = null;
   tmp24_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp24_AST);
   match(LITERAL_module);
   identifier();
   astFactory.addASTChild(currentAST, returnAST);
   match(LCURLY);
   definition_list();
   d_AST = (IdlParserAST)returnAST;
   astFactory.addASTChild(currentAST, returnAST);
   match(RCURLY);
   module_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = module_AST;
 }
 
 public final void value() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST value_AST = null;
  
  try {      // for error handling
   {
   if ((LA(1)==LITERAL_custom||LA(1)==LITERAL_valuetype) && (LA(2)==LITERAL_valuetype||LA(2)==IDENT||LA(2)==ESCAPED_IDENT) && (_tokenSet_14.member(LA(3))) && (_tokenSet_15.member(LA(4)))) {
    value_dcl();
    astFactory.addASTChild(currentAST, returnAST);
   }
   else if ((LA(1)==LITERAL_abstract) && (LA(2)==LITERAL_valuetype) && (LA(3)==IDENT||LA(3)==ESCAPED_IDENT) && (LA(4)==LCURLY||LA(4)==COLON||LA(4)==LITERAL_supports)) {
    value_abs_dcl();
    astFactory.addASTChild(currentAST, returnAST);
   }
   else if ((LA(1)==LITERAL_valuetype) && (LA(2)==IDENT||LA(2)==ESCAPED_IDENT) && (_tokenSet_16.member(LA(3))) && (_tokenSet_17.member(LA(4)))) {
    value_box_dcl();
    astFactory.addASTChild(currentAST, returnAST);
   }
   else if ((LA(1)==LITERAL_abstract||LA(1)==LITERAL_valuetype) && (LA(2)==LITERAL_valuetype||LA(2)==IDENT||LA(2)==ESCAPED_IDENT) && (LA(3)==SEMI||LA(3)==IDENT||LA(3)==ESCAPED_IDENT) && (_tokenSet_18.member(LA(4)))) {
    value_forward_dcl();
    astFactory.addASTChild(currentAST, returnAST);
   }
   else {
    throw new NoViableAltException(LT(1), getFilename());
   }
   
   }
   value_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = value_AST;
 }
 
 public final void type_id_dcl() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST type_id_dcl_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp27_AST = null;
   tmp27_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp27_AST);
   match(LITERAL_typeid);
   scoped_name();
   astFactory.addASTChild(currentAST, returnAST);
   string_literal();
   astFactory.addASTChild(currentAST, returnAST);
   type_id_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = type_id_dcl_AST;
 }
 
 public final void type_prefix_dcl() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST type_prefix_dcl_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp28_AST = null;
   tmp28_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp28_AST);
   match(LITERAL_typeprefix);
   scoped_name();
   astFactory.addASTChild(currentAST, returnAST);
   string_literal();
   astFactory.addASTChild(currentAST, returnAST);
   type_prefix_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = type_prefix_dcl_AST;
 }
 
 public final void event() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST event_AST = null;
  
  try {      // for error handling
   {
   if ((LA(1)==LITERAL_custom||LA(1)==LITERAL_eventtype) && (LA(2)==LITERAL_eventtype||LA(2)==IDENT||LA(2)==ESCAPED_IDENT) && (_tokenSet_14.member(LA(3))) && (_tokenSet_15.member(LA(4)))) {
    event_dcl();
    astFactory.addASTChild(currentAST, returnAST);
   }
   else if ((LA(1)==LITERAL_abstract) && (LA(2)==LITERAL_eventtype) && (LA(3)==IDENT||LA(3)==ESCAPED_IDENT) && (LA(4)==LCURLY||LA(4)==COLON||LA(4)==LITERAL_supports)) {
    event_abs_dcl();
    astFactory.addASTChild(currentAST, returnAST);
   }
   else if ((LA(1)==LITERAL_abstract||LA(1)==LITERAL_eventtype) && (LA(2)==LITERAL_eventtype||LA(2)==IDENT||LA(2)==ESCAPED_IDENT) && (LA(3)==SEMI||LA(3)==IDENT||LA(3)==ESCAPED_IDENT) && (_tokenSet_18.member(LA(4)))) {
    event_forward_dcl();
    astFactory.addASTChild(currentAST, returnAST);
   }
   else {
    throw new NoViableAltException(LT(1), getFilename());
   }
   
   }
   event_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = event_AST;
 }
 
 public final void component() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST component_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp29_AST = null;
   tmp29_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp29_AST);
   match(LITERAL_component);
   identifier();
   astFactory.addASTChild(currentAST, returnAST);
   {
   switch ( LA(1)) {
   case LCURLY:
   case COLON:
   case LITERAL_supports:
   {
    component_dcl();
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case SEMI:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   component_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = component_AST;
 }
 
 public final void home() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST home_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp30_AST = null;
   tmp30_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp30_AST);
   match(LITERAL_home);
   identifier();
   astFactory.addASTChild(currentAST, returnAST);
   home_dcl();
   astFactory.addASTChild(currentAST, returnAST);
   home_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = home_AST;
 }
 
 public final void pragma_dcl() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST pragma_dcl_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp31_AST = null;
   tmp31_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp31_AST);
   match(PRAGMA);
   pragma_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_19);
   } else {
     throw ex;
   }
  }
  returnAST = pragma_dcl_AST;
 }
 
 public final void identifier() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST identifier_AST = null;
  
  try {      // for error handling
   {
   switch ( LA(1)) {
   case IDENT:
   {
    IdlParserAST tmp32_AST = null;
    tmp32_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.addASTChild(currentAST, tmp32_AST);
    match(IDENT);
    break;
   }
   case ESCAPED_IDENT:
   {
    IdlParserAST tmp33_AST = null;
    tmp33_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.addASTChild(currentAST, tmp33_AST);
    match(ESCAPED_IDENT);
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   identifier_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_20);
   } else {
     throw ex;
   }
  }
  returnAST = identifier_AST;
 }
 
 public final void definition_list() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST definition_list_AST = null;
  
  try {      // for error handling
   {
   int _cnt21=0;
   _loop21:
   do {
    if ((_tokenSet_4.member(LA(1)))) {
     definition();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     if ( _cnt21>=1 ) { break _loop21; } else {throw new NoViableAltException(LT(1), getFilename());}
    }
    
    _cnt21++;
   } while (true);
   }
   definition_list_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_21);
   } else {
     throw ex;
   }
  }
  returnAST = definition_list_AST;
 }
 
 public final void interface_dcl() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST interface_dcl_AST = null;
  
  try {      // for error handling
   interface_header();
   astFactory.addASTChild(currentAST, returnAST);
   IdlParserAST tmp34_AST = null;
   tmp34_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp34_AST);
   match(LCURLY);
   interface_body();
   astFactory.addASTChild(currentAST, returnAST);
   IdlParserAST tmp35_AST = null;
   tmp35_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp35_AST);
   match(RCURLY);
   interface_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = interface_dcl_AST;
 }
 
 public final void interface_header() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST interface_header_AST = null;
  
  try {      // for error handling
   {
   switch ( LA(1)) {
   case COLON:
   {
    interface_inheritance_spec();
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LCURLY:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   interface_header_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_22);
   } else {
     throw ex;
   }
  }
  returnAST = interface_header_AST;
 }
 
 public final void interface_body() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST interface_body_AST = null;
  
  try {      // for error handling
   {
   _loop30:
   do {
    if ((_tokenSet_23.member(LA(1)))) {
     export();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop30;
    }
    
   } while (true);
   }
   interface_body_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_21);
   } else {
     throw ex;
   }
  }
  returnAST = interface_body_AST;
 }
 
 public final void interface_inheritance_spec() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST interface_inheritance_spec_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp36_AST = null;
   tmp36_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp36_AST);
   match(COLON);
   scoped_name_list();
   astFactory.addASTChild(currentAST, returnAST);
   interface_inheritance_spec_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_22);
   } else {
     throw ex;
   }
  }
  returnAST = interface_inheritance_spec_AST;
 }
 
 public final void export() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST export_AST = null;
  
  try {      // for error handling
   {
   switch ( LA(1)) {
   case LITERAL_typedef:
   case LITERAL_native:
   case LITERAL_struct:
   case LITERAL_union:
   case LITERAL_enum:
   {
    type_dcl();
    astFactory.addASTChild(currentAST, returnAST);
    match(SEMI);
    break;
   }
   case LITERAL_const:
   {
    const_dcl();
    astFactory.addASTChild(currentAST, returnAST);
    match(SEMI);
    break;
   }
   case LITERAL_exception:
   {
    except_dcl();
    astFactory.addASTChild(currentAST, returnAST);
    match(SEMI);
    break;
   }
   case LITERAL_readonly:
   case LITERAL_attribute:
   {
    attr_dcl();
    astFactory.addASTChild(currentAST, returnAST);
    match(SEMI);
    break;
   }
   case SCOPEOP:
   case IDENT:
   case ESCAPED_IDENT:
   case LITERAL_float:
   case LITERAL_double:
   case LITERAL_long:
   case LITERAL_short:
   case LITERAL_unsigned:
   case LITERAL_char:
   case LITERAL_wchar:
   case LITERAL_boolean:
   case LITERAL_octet:
   case LITERAL_any:
   case LITERAL_Object:
   case LITERAL_string:
   case LITERAL_wstring:
   case LITERAL_oneway:
   case LITERAL_void:
   case LITERAL_ValueBase:
   {
    op_dcl();
    astFactory.addASTChild(currentAST, returnAST);
    match(SEMI);
    break;
   }
   case LITERAL_typeid:
   {
    type_id_dcl();
    astFactory.addASTChild(currentAST, returnAST);
    match(SEMI);
    break;
   }
   case LITERAL_typeprefix:
   {
    type_prefix_dcl();
    astFactory.addASTChild(currentAST, returnAST);
    match(SEMI);
    break;
   }
   case PRAGMA:
   {
    pragma_dcl();
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   export_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_24);
   } else {
     throw ex;
   }
  }
  returnAST = export_AST;
 }
 
 public final void attr_dcl() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST attr_dcl_AST = null;
  
  try {      // for error handling
   switch ( LA(1)) {
   case LITERAL_readonly:
   {
    readonly_attr_spec();
    astFactory.addASTChild(currentAST, returnAST);
    attr_dcl_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_attribute:
   {
    attr_spec();
    astFactory.addASTChild(currentAST, returnAST);
    attr_dcl_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = attr_dcl_AST;
 }
 
 public final void op_dcl() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST op_dcl_AST = null;
  
  try {      // for error handling
   {
   switch ( LA(1)) {
   case LITERAL_oneway:
   {
    op_attribute();
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case SCOPEOP:
   case IDENT:
   case ESCAPED_IDENT:
   case LITERAL_float:
   case LITERAL_double:
   case LITERAL_long:
   case LITERAL_short:
   case LITERAL_unsigned:
   case LITERAL_char:
   case LITERAL_wchar:
   case LITERAL_boolean:
   case LITERAL_octet:
   case LITERAL_any:
   case LITERAL_Object:
   case LITERAL_string:
   case LITERAL_wstring:
   case LITERAL_void:
   case LITERAL_ValueBase:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   op_type_spec();
   astFactory.addASTChild(currentAST, returnAST);
   {
   switch ( LA(1)) {
   case IDENT:
   {
    IdlParserAST tmp44_AST = null;
    tmp44_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.makeASTRoot(currentAST, tmp44_AST);
    match(IDENT);
    break;
   }
   case ESCAPED_IDENT:
   {
    IdlParserAST tmp45_AST = null;
    tmp45_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.makeASTRoot(currentAST, tmp45_AST);
    match(ESCAPED_IDENT);
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   parameter_dcls();
   astFactory.addASTChild(currentAST, returnAST);
   {
   switch ( LA(1)) {
   case LITERAL_raises:
   {
    raises_expr();
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case SEMI:
   case LITERAL_context:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   {
   switch ( LA(1)) {
   case LITERAL_context:
   {
    context_expr();
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case SEMI:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   op_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = op_dcl_AST;
 }
 
 public final void scoped_name_list() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST scoped_name_list_AST = null;
  
  try {      // for error handling
   scoped_name();
   astFactory.addASTChild(currentAST, returnAST);
   {
   _loop36:
   do {
    if ((LA(1)==COMMA)) {
     match(COMMA);
     scoped_name();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop36;
    }
    
   } while (true);
   }
   scoped_name_list_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_25);
   } else {
     throw ex;
   }
  }
  returnAST = scoped_name_list_AST;
 }
 
 public final void scoped_name() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST scoped_name_AST = null;
  
  try {      // for error handling
   {
   switch ( LA(1)) {
   case SCOPEOP:
   {
    IdlParserAST tmp47_AST = null;
    tmp47_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.makeASTRoot(currentAST, tmp47_AST);
    match(SCOPEOP);
    break;
   }
   case IDENT:
   case ESCAPED_IDENT:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   {
   switch ( LA(1)) {
   case IDENT:
   {
    IdlParserAST tmp48_AST = null;
    tmp48_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.makeASTRoot(currentAST, tmp48_AST);
    match(IDENT);
    break;
   }
   case ESCAPED_IDENT:
   {
    IdlParserAST tmp49_AST = null;
    tmp49_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.makeASTRoot(currentAST, tmp49_AST);
    match(ESCAPED_IDENT);
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   {
   _loop41:
   do {
    if ((LA(1)==SCOPEOP)) {
     match(SCOPEOP);
     identifier();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop41;
    }
    
   } while (true);
   }
   scoped_name_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_26);
   } else {
     throw ex;
   }
  }
  returnAST = scoped_name_AST;
 }
 
 public final void value_dcl() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST value_dcl_AST = null;
  
  try {      // for error handling
   {
   switch ( LA(1)) {
   case LITERAL_custom:
   {
    IdlParserAST tmp51_AST = null;
    tmp51_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.addASTChild(currentAST, tmp51_AST);
    match(LITERAL_custom);
    break;
   }
   case LITERAL_valuetype:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   IdlParserAST tmp52_AST = null;
   tmp52_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp52_AST);
   match(LITERAL_valuetype);
   identifier();
   astFactory.addASTChild(currentAST, returnAST);
   value_inheritance_spec();
   astFactory.addASTChild(currentAST, returnAST);
   IdlParserAST tmp53_AST = null;
   tmp53_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp53_AST);
   match(LCURLY);
   {
   _loop47:
   do {
    if ((_tokenSet_27.member(LA(1)))) {
     value_element();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop47;
    }
    
   } while (true);
   }
   IdlParserAST tmp54_AST = null;
   tmp54_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp54_AST);
   match(RCURLY);
   value_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = value_dcl_AST;
 }
 
 public final void value_abs_dcl() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST value_abs_dcl_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp55_AST = null;
   tmp55_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp55_AST);
   match(LITERAL_abstract);
   IdlParserAST tmp56_AST = null;
   tmp56_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp56_AST);
   match(LITERAL_valuetype);
   identifier();
   astFactory.addASTChild(currentAST, returnAST);
   value_inheritance_spec();
   astFactory.addASTChild(currentAST, returnAST);
   IdlParserAST tmp57_AST = null;
   tmp57_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp57_AST);
   match(LCURLY);
   {
   _loop59:
   do {
    if ((_tokenSet_23.member(LA(1)))) {
     export();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop59;
    }
    
   } while (true);
   }
   IdlParserAST tmp58_AST = null;
   tmp58_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp58_AST);
   match(RCURLY);
   value_abs_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = value_abs_dcl_AST;
 }
 
 public final void value_box_dcl() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST value_box_dcl_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp59_AST = null;
   tmp59_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp59_AST);
   match(LITERAL_valuetype);
   identifier();
   astFactory.addASTChild(currentAST, returnAST);
   type_spec();
   astFactory.addASTChild(currentAST, returnAST);
   value_box_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = value_box_dcl_AST;
 }
 
 public final void value_forward_dcl() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST value_forward_dcl_AST = null;
  
  try {      // for error handling
   {
   switch ( LA(1)) {
   case LITERAL_abstract:
   {
    IdlParserAST tmp60_AST = null;
    tmp60_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.addASTChild(currentAST, tmp60_AST);
    match(LITERAL_abstract);
    break;
   }
   case LITERAL_valuetype:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   IdlParserAST tmp61_AST = null;
   tmp61_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp61_AST);
   match(LITERAL_valuetype);
   identifier();
   astFactory.addASTChild(currentAST, returnAST);
   value_forward_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = value_forward_dcl_AST;
 }
 
 public final void value_inheritance_spec() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST value_inheritance_spec_AST = null;
  
  try {      // for error handling
   {
   switch ( LA(1)) {
   case COLON:
   {
    value_bases();
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LCURLY:
   case LITERAL_supports:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   {
   switch ( LA(1)) {
   case LITERAL_supports:
   {
    value_supported_interfaces();
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LCURLY:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   value_inheritance_spec_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_22);
   } else {
     throw ex;
   }
  }
  returnAST = value_inheritance_spec_AST;
 }
 
 public final void value_element() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST value_element_AST = null;
  
  try {      // for error handling
   {
   switch ( LA(1)) {
   case SCOPEOP:
   case IDENT:
   case ESCAPED_IDENT:
   case LITERAL_const:
   case LITERAL_typedef:
   case LITERAL_native:
   case LITERAL_float:
   case LITERAL_double:
   case LITERAL_long:
   case LITERAL_short:
   case LITERAL_unsigned:
   case LITERAL_char:
   case LITERAL_wchar:
   case LITERAL_boolean:
   case LITERAL_octet:
   case LITERAL_any:
   case LITERAL_Object:
   case LITERAL_struct:
   case LITERAL_union:
   case LITERAL_enum:
   case LITERAL_string:
   case LITERAL_wstring:
   case LITERAL_exception:
   case LITERAL_oneway:
   case LITERAL_void:
   case LITERAL_ValueBase:
   case LITERAL_typeid:
   case LITERAL_typeprefix:
   case LITERAL_readonly:
   case LITERAL_attribute:
   case PRAGMA:
   {
    export();
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LITERAL_public:
   case LITERAL_private:
   {
    state_member();
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LITERAL_factory:
   {
    init_dcl();
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   value_element_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_28);
   } else {
     throw ex;
   }
  }
  returnAST = value_element_AST;
 }
 
 public final void state_member() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST state_member_AST = null;
  
  try {      // for error handling
   {
   switch ( LA(1)) {
   case LITERAL_public:
   {
    IdlParserAST tmp62_AST = null;
    tmp62_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.addASTChild(currentAST, tmp62_AST);
    match(LITERAL_public);
    break;
   }
   case LITERAL_private:
   {
    IdlParserAST tmp63_AST = null;
    tmp63_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.addASTChild(currentAST, tmp63_AST);
    match(LITERAL_private);
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   type_spec();
   astFactory.addASTChild(currentAST, returnAST);
   declarators();
   astFactory.addASTChild(currentAST, returnAST);
   IdlParserAST tmp64_AST = null;
   tmp64_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp64_AST);
   match(SEMI);
   state_member_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_28);
   } else {
     throw ex;
   }
  }
  returnAST = state_member_AST;
 }
 
 public final void init_dcl() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST init_dcl_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp65_AST = null;
   tmp65_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp65_AST);
   match(LITERAL_factory);
   identifier();
   astFactory.addASTChild(currentAST, returnAST);
   match(LPAREN);
   {
   switch ( LA(1)) {
   case LITERAL_in:
   {
    init_param_decls();
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case RPAREN:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   match(RPAREN);
   {
   switch ( LA(1)) {
   case LITERAL_raises:
   {
    raises_expr();
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case SEMI:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   match(SEMI);
   init_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_28);
   } else {
     throw ex;
   }
  }
  returnAST = init_dcl_AST;
 }
 
 public final void value_bases() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST value_bases_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp69_AST = null;
   tmp69_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp69_AST);
   match(COLON);
   {
   switch ( LA(1)) {
   case LITERAL_truncatable:
   {
    IdlParserAST tmp70_AST = null;
    tmp70_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.addASTChild(currentAST, tmp70_AST);
    match(LITERAL_truncatable);
    break;
   }
   case SCOPEOP:
   case IDENT:
   case ESCAPED_IDENT:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   scoped_name_list();
   astFactory.addASTChild(currentAST, returnAST);
   value_bases_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_29);
   } else {
     throw ex;
   }
  }
  returnAST = value_bases_AST;
 }
 
 public final void value_supported_interfaces() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST value_supported_interfaces_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp71_AST = null;
   tmp71_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp71_AST);
   match(LITERAL_supports);
   scoped_name_list();
   astFactory.addASTChild(currentAST, returnAST);
   value_supported_interfaces_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_22);
   } else {
     throw ex;
   }
  }
  returnAST = value_supported_interfaces_AST;
 }
 
 public final void type_spec() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST type_spec_AST = null;
  
  try {      // for error handling
   switch ( LA(1)) {
   case SCOPEOP:
   case IDENT:
   case ESCAPED_IDENT:
   case LITERAL_float:
   case LITERAL_double:
   case LITERAL_long:
   case LITERAL_short:
   case LITERAL_unsigned:
   case LITERAL_char:
   case LITERAL_wchar:
   case LITERAL_boolean:
   case LITERAL_octet:
   case LITERAL_any:
   case LITERAL_Object:
   case LITERAL_sequence:
   case LITERAL_string:
   case LITERAL_wstring:
   case LITERAL_fixed:
   case LITERAL_ValueBase:
   {
    simple_type_spec();
    astFactory.addASTChild(currentAST, returnAST);
    type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_struct:
   case LITERAL_union:
   case LITERAL_enum:
   {
    constr_type_spec();
    astFactory.addASTChild(currentAST, returnAST);
    type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_30);
   } else {
     throw ex;
   }
  }
  returnAST = type_spec_AST;
 }
 
 public final void declarators() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST declarators_AST = null;
  
  try {      // for error handling
   declarator();
   astFactory.addASTChild(currentAST, returnAST);
   {
   _loop119:
   do {
    if ((LA(1)==COMMA)) {
     match(COMMA);
     declarator();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop119;
    }
    
   } while (true);
   }
   declarators_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = declarators_AST;
 }
 
 public final void init_param_decls() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST init_param_decls_AST = null;
  
  try {      // for error handling
   init_param_decl();
   astFactory.addASTChild(currentAST, returnAST);
   {
   _loop69:
   do {
    if ((LA(1)==COMMA)) {
     match(COMMA);
     init_param_decl();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop69;
    }
    
   } while (true);
   }
   init_param_decls_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_31);
   } else {
     throw ex;
   }
  }
  returnAST = init_param_decls_AST;
 }
 
 public final void raises_expr() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST raises_expr_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp74_AST = null;
   tmp74_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp74_AST);
   match(LITERAL_raises);
   match(LPAREN);
   scoped_name_list();
   astFactory.addASTChild(currentAST, returnAST);
   match(RPAREN);
   raises_expr_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_32);
   } else {
     throw ex;
   }
  }
  returnAST = raises_expr_AST;
 }
 
 public final void init_param_decl() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST init_param_decl_AST = null;
  
  try {      // for error handling
   init_param_attribute();
   astFactory.addASTChild(currentAST, returnAST);
   param_type_spec();
   astFactory.addASTChild(currentAST, returnAST);
   simple_declarator();
   astFactory.addASTChild(currentAST, returnAST);
   init_param_decl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_33);
   } else {
     throw ex;
   }
  }
  returnAST = init_param_decl_AST;
 }
 
 public final void init_param_attribute() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST init_param_attribute_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp77_AST = null;
   tmp77_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp77_AST);
   match(LITERAL_in);
   init_param_attribute_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_34);
   } else {
     throw ex;
   }
  }
  returnAST = init_param_attribute_AST;
 }
 
 public final void param_type_spec() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST param_type_spec_AST = null;
  
  try {      // for error handling
   switch ( LA(1)) {
   case LITERAL_float:
   case LITERAL_double:
   case LITERAL_long:
   case LITERAL_short:
   case LITERAL_unsigned:
   case LITERAL_char:
   case LITERAL_wchar:
   case LITERAL_boolean:
   case LITERAL_octet:
   case LITERAL_any:
   case LITERAL_Object:
   case LITERAL_ValueBase:
   {
    base_type_spec();
    astFactory.addASTChild(currentAST, returnAST);
    param_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_string:
   {
    string_type();
    astFactory.addASTChild(currentAST, returnAST);
    param_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_wstring:
   {
    wide_string_type();
    astFactory.addASTChild(currentAST, returnAST);
    param_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case SCOPEOP:
   case IDENT:
   case ESCAPED_IDENT:
   {
    scoped_name();
    astFactory.addASTChild(currentAST, returnAST);
    param_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_35);
   } else {
     throw ex;
   }
  }
  returnAST = param_type_spec_AST;
 }
 
 public final void simple_declarator() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST simple_declarator_AST = null;
  
  try {      // for error handling
   identifier();
   astFactory.addASTChild(currentAST, returnAST);
   simple_declarator_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_36);
   } else {
     throw ex;
   }
  }
  returnAST = simple_declarator_AST;
 }
 
 public final void const_type() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST const_type_AST = null;
  
  try {      // for error handling
   switch ( LA(1)) {
   case LITERAL_char:
   {
    char_type();
    astFactory.addASTChild(currentAST, returnAST);
    const_type_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_wchar:
   {
    wide_char_type();
    astFactory.addASTChild(currentAST, returnAST);
    const_type_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_boolean:
   {
    boolean_type();
    astFactory.addASTChild(currentAST, returnAST);
    const_type_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_string:
   {
    string_type();
    astFactory.addASTChild(currentAST, returnAST);
    const_type_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_wstring:
   {
    wide_string_type();
    astFactory.addASTChild(currentAST, returnAST);
    const_type_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_fixed:
   {
    fixed_pt_const_type();
    astFactory.addASTChild(currentAST, returnAST);
    const_type_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case SCOPEOP:
   case IDENT:
   case ESCAPED_IDENT:
   {
    scoped_name();
    astFactory.addASTChild(currentAST, returnAST);
    const_type_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_octet:
   {
    octet_type();
    astFactory.addASTChild(currentAST, returnAST);
    const_type_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
    boolean synPredMatched75 = false;
    if ((((LA(1) >= LITERAL_long && LA(1) <= LITERAL_unsigned)) && (_tokenSet_37.member(LA(2))) && (_tokenSet_38.member(LA(3))) && (_tokenSet_39.member(LA(4))))) {
     int _m75 = mark();
     synPredMatched75 = true;
     inputState.guessing++;
     try {
      {
      integer_type();
      }
     }
     catch (RecognitionException pe) {
      synPredMatched75 = false;
     }
     rewind(_m75);
inputState.guessing--;
    }
    if ( synPredMatched75 ) {
     integer_type();
     astFactory.addASTChild(currentAST, returnAST);
     const_type_AST = (IdlParserAST)currentAST.root;
    }
    else if (((LA(1) >= LITERAL_float && LA(1) <= LITERAL_long)) && (LA(2)==IDENT||LA(2)==ESCAPED_IDENT||LA(2)==LITERAL_double) && (LA(3)==IDENT||LA(3)==ESCAPED_IDENT||LA(3)==ASSIGN) && (_tokenSet_39.member(LA(4)))) {
     floating_pt_type();
     astFactory.addASTChild(currentAST, returnAST);
     const_type_AST = (IdlParserAST)currentAST.root;
    }
   else {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_35);
   } else {
     throw ex;
   }
  }
  returnAST = const_type_AST;
 }
 
 public final void const_exp() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST const_exp_AST = null;
  
  try {      // for error handling
   or_expr();
   astFactory.addASTChild(currentAST, returnAST);
   const_exp_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_40);
   } else {
     throw ex;
   }
  }
  returnAST = const_exp_AST;
 }
 
 public final void integer_type() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST integer_type_AST = null;
  
  try {      // for error handling
   switch ( LA(1)) {
   case LITERAL_long:
   case LITERAL_short:
   {
    signed_int();
    astFactory.addASTChild(currentAST, returnAST);
    integer_type_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_unsigned:
   {
    unsigned_int();
    astFactory.addASTChild(currentAST, returnAST);
    integer_type_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_41);
   } else {
     throw ex;
   }
  }
  returnAST = integer_type_AST;
 }
 
 public final void char_type() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST char_type_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp78_AST = null;
   tmp78_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp78_AST);
   match(LITERAL_char);
   char_type_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_41);
   } else {
     throw ex;
   }
  }
  returnAST = char_type_AST;
 }
 
 public final void wide_char_type() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST wide_char_type_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp79_AST = null;
   tmp79_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp79_AST);
   match(LITERAL_wchar);
   wide_char_type_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_42);
   } else {
     throw ex;
   }
  }
  returnAST = wide_char_type_AST;
 }
 
 public final void boolean_type() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST boolean_type_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp80_AST = null;
   tmp80_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp80_AST);
   match(LITERAL_boolean);
   boolean_type_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_41);
   } else {
     throw ex;
   }
  }
  returnAST = boolean_type_AST;
 }
 
 public final void floating_pt_type() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST floating_pt_type_AST = null;
  
  try {      // for error handling
   switch ( LA(1)) {
   case LITERAL_float:
   {
    IdlParserAST tmp81_AST = null;
    tmp81_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.addASTChild(currentAST, tmp81_AST);
    match(LITERAL_float);
    floating_pt_type_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_double:
   {
    IdlParserAST tmp82_AST = null;
    tmp82_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.addASTChild(currentAST, tmp82_AST);
    match(LITERAL_double);
    floating_pt_type_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_long:
   {
    IdlParserAST tmp83_AST = null;
    tmp83_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.makeASTRoot(currentAST, tmp83_AST);
    match(LITERAL_long);
    IdlParserAST tmp84_AST = null;
    tmp84_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.addASTChild(currentAST, tmp84_AST);
    match(LITERAL_double);
    floating_pt_type_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_42);
   } else {
     throw ex;
   }
  }
  returnAST = floating_pt_type_AST;
 }
 
 public final void string_type() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST string_type_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp85_AST = null;
   tmp85_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp85_AST);
   match(LITERAL_string);
   {
   switch ( LA(1)) {
   case LT:
   {
    match(LT);
    positive_int_const();
    astFactory.addASTChild(currentAST, returnAST);
    match(GT);
    break;
   }
   case SEMI:
   case COMMA:
   case IDENT:
   case ESCAPED_IDENT:
   case GT:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   string_type_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_42);
   } else {
     throw ex;
   }
  }
  returnAST = string_type_AST;
 }
 
 public final void wide_string_type() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST wide_string_type_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp88_AST = null;
   tmp88_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp88_AST);
   match(LITERAL_wstring);
   {
   switch ( LA(1)) {
   case LT:
   {
    match(LT);
    positive_int_const();
    astFactory.addASTChild(currentAST, returnAST);
    match(GT);
    break;
   }
   case SEMI:
   case COMMA:
   case IDENT:
   case ESCAPED_IDENT:
   case GT:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   wide_string_type_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_42);
   } else {
     throw ex;
   }
  }
  returnAST = wide_string_type_AST;
 }
 
 public final void fixed_pt_const_type() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST fixed_pt_const_type_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp91_AST = null;
   tmp91_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp91_AST);
   match(LITERAL_fixed);
   fixed_pt_const_type_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_35);
   } else {
     throw ex;
   }
  }
  returnAST = fixed_pt_const_type_AST;
 }
 
 public final void octet_type() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST octet_type_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp92_AST = null;
   tmp92_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp92_AST);
   match(LITERAL_octet);
   octet_type_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_42);
   } else {
     throw ex;
   }
  }
  returnAST = octet_type_AST;
 }
 
 public final void or_expr() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST or_expr_AST = null;
  
  try {      // for error handling
   xor_expr();
   astFactory.addASTChild(currentAST, returnAST);
   {
   _loop79:
   do {
    if ((LA(1)==OR)) {
     IdlParserAST tmp93_AST = null;
     tmp93_AST = (IdlParserAST)astFactory.create(LT(1));
     astFactory.makeASTRoot(currentAST, tmp93_AST);
     match(OR);
     xor_expr();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop79;
    }
    
   } while (true);
   }
   or_expr_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_40);
   } else {
     throw ex;
   }
  }
  returnAST = or_expr_AST;
 }
 
 public final void xor_expr() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST xor_expr_AST = null;
  
  try {      // for error handling
   and_expr();
   astFactory.addASTChild(currentAST, returnAST);
   {
   _loop82:
   do {
    if ((LA(1)==XOR)) {
     IdlParserAST tmp94_AST = null;
     tmp94_AST = (IdlParserAST)astFactory.create(LT(1));
     astFactory.makeASTRoot(currentAST, tmp94_AST);
     match(XOR);
     and_expr();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop82;
    }
    
   } while (true);
   }
   xor_expr_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_43);
   } else {
     throw ex;
   }
  }
  returnAST = xor_expr_AST;
 }
 
 public final void and_expr() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST and_expr_AST = null;
  
  try {      // for error handling
   shift_expr();
   astFactory.addASTChild(currentAST, returnAST);
   {
   _loop85:
   do {
    if ((LA(1)==AND)) {
     IdlParserAST tmp95_AST = null;
     tmp95_AST = (IdlParserAST)astFactory.create(LT(1));
     astFactory.makeASTRoot(currentAST, tmp95_AST);
     match(AND);
     shift_expr();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop85;
    }
    
   } while (true);
   }
   and_expr_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_44);
   } else {
     throw ex;
   }
  }
  returnAST = and_expr_AST;
 }
 
 public final void shift_expr() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST shift_expr_AST = null;
  
  try {      // for error handling
   add_expr();
   astFactory.addASTChild(currentAST, returnAST);
   {
   _loop89:
   do {
    if ((LA(1)==LSHIFT||LA(1)==RSHIFT)) {
     {
     switch ( LA(1)) {
     case LSHIFT:
     {
      IdlParserAST tmp96_AST = null;
      tmp96_AST = (IdlParserAST)astFactory.create(LT(1));
      astFactory.makeASTRoot(currentAST, tmp96_AST);
      match(LSHIFT);
      break;
     }
     case RSHIFT:
     {
      IdlParserAST tmp97_AST = null;
      tmp97_AST = (IdlParserAST)astFactory.create(LT(1));
      astFactory.makeASTRoot(currentAST, tmp97_AST);
      match(RSHIFT);
      break;
     }
     default:
     {
      throw new NoViableAltException(LT(1), getFilename());
     }
     }
     }
     add_expr();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop89;
    }
    
   } while (true);
   }
   shift_expr_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_45);
   } else {
     throw ex;
   }
  }
  returnAST = shift_expr_AST;
 }
 
 public final void add_expr() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST add_expr_AST = null;
  
  try {      // for error handling
   mult_expr();
   astFactory.addASTChild(currentAST, returnAST);
   {
   _loop93:
   do {
    if ((LA(1)==PLUS||LA(1)==MINUS)) {
     {
     switch ( LA(1)) {
     case PLUS:
     {
      IdlParserAST tmp98_AST = null;
      tmp98_AST = (IdlParserAST)astFactory.create(LT(1));
      astFactory.makeASTRoot(currentAST, tmp98_AST);
      match(PLUS);
      break;
     }
     case MINUS:
     {
      IdlParserAST tmp99_AST = null;
      tmp99_AST = (IdlParserAST)astFactory.create(LT(1));
      astFactory.makeASTRoot(currentAST, tmp99_AST);
      match(MINUS);
      break;
     }
     default:
     {
      throw new NoViableAltException(LT(1), getFilename());
     }
     }
     }
     mult_expr();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop93;
    }
    
   } while (true);
   }
   add_expr_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_46);
   } else {
     throw ex;
   }
  }
  returnAST = add_expr_AST;
 }
 
 public final void mult_expr() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST mult_expr_AST = null;
  
  try {      // for error handling
   unary_expr();
   astFactory.addASTChild(currentAST, returnAST);
   {
   _loop97:
   do {
    if (((LA(1) >= STAR && LA(1) <= MOD))) {
     {
     switch ( LA(1)) {
     case STAR:
     {
      IdlParserAST tmp100_AST = null;
      tmp100_AST = (IdlParserAST)astFactory.create(LT(1));
      astFactory.makeASTRoot(currentAST, tmp100_AST);
      match(STAR);
      break;
     }
     case DIV:
     {
      IdlParserAST tmp101_AST = null;
      tmp101_AST = (IdlParserAST)astFactory.create(LT(1));
      astFactory.makeASTRoot(currentAST, tmp101_AST);
      match(DIV);
      break;
     }
     case MOD:
     {
      IdlParserAST tmp102_AST = null;
      tmp102_AST = (IdlParserAST)astFactory.create(LT(1));
      astFactory.makeASTRoot(currentAST, tmp102_AST);
      match(MOD);
      break;
     }
     default:
     {
      throw new NoViableAltException(LT(1), getFilename());
     }
     }
     }
     unary_expr();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop97;
    }
    
   } while (true);
   }
   mult_expr_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_47);
   } else {
     throw ex;
   }
  }
  returnAST = mult_expr_AST;
 }
 
 public final void unary_expr() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST unary_expr_AST = null;
  
  try {      // for error handling
   switch ( LA(1)) {
   case PLUS:
   case MINUS:
   case TILDE:
   {
    {
    switch ( LA(1)) {
    case MINUS:
    {
     IdlParserAST tmp103_AST = null;
     tmp103_AST = (IdlParserAST)astFactory.create(LT(1));
     astFactory.makeASTRoot(currentAST, tmp103_AST);
     match(MINUS);
     break;
    }
    case PLUS:
    {
     IdlParserAST tmp104_AST = null;
     tmp104_AST = (IdlParserAST)astFactory.create(LT(1));
     astFactory.makeASTRoot(currentAST, tmp104_AST);
     match(PLUS);
     break;
    }
    case TILDE:
    {
     IdlParserAST tmp105_AST = null;
     tmp105_AST = (IdlParserAST)astFactory.create(LT(1));
     astFactory.makeASTRoot(currentAST, tmp105_AST);
     match(TILDE);
     break;
    }
    default:
    {
     throw new NoViableAltException(LT(1), getFilename());
    }
    }
    }
    primary_expr();
    astFactory.addASTChild(currentAST, returnAST);
    unary_expr_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case SCOPEOP:
   case IDENT:
   case ESCAPED_IDENT:
   case LPAREN:
   case LITERAL_TRUE:
   case LITERAL_FALSE:
   case INT:
   case OCTAL:
   case HEX:
   case STRING_LITERAL:
   case WIDE_STRING_LITERAL:
   case CHAR_LITERAL:
   case WIDE_CHAR_LITERAL:
   case FIXED:
   case FLOAT:
   {
    primary_expr();
    astFactory.addASTChild(currentAST, returnAST);
    unary_expr_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_48);
   } else {
     throw ex;
   }
  }
  returnAST = unary_expr_AST;
 }
 
 public final void primary_expr() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST primary_expr_AST = null;
  
  try {      // for error handling
   switch ( LA(1)) {
   case SCOPEOP:
   case IDENT:
   case ESCAPED_IDENT:
   {
    scoped_name();
    astFactory.addASTChild(currentAST, returnAST);
    primary_expr_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_TRUE:
   case LITERAL_FALSE:
   case INT:
   case OCTAL:
   case HEX:
   case STRING_LITERAL:
   case WIDE_STRING_LITERAL:
   case CHAR_LITERAL:
   case WIDE_CHAR_LITERAL:
   case FIXED:
   case FLOAT:
   {
    literal();
    astFactory.addASTChild(currentAST, returnAST);
    primary_expr_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LPAREN:
   {
    match(LPAREN);
    const_exp();
    astFactory.addASTChild(currentAST, returnAST);
    match(RPAREN);
    primary_expr_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_48);
   } else {
     throw ex;
   }
  }
  returnAST = primary_expr_AST;
 }
 
 public final void literal() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST literal_AST = null;
  
  try {      // for error handling
   switch ( LA(1)) {
   case INT:
   case OCTAL:
   case HEX:
   {
    integer_literal();
    astFactory.addASTChild(currentAST, returnAST);
    literal_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case STRING_LITERAL:
   {
    string_literal();
    astFactory.addASTChild(currentAST, returnAST);
    literal_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case WIDE_STRING_LITERAL:
   {
    wide_string_literal();
    astFactory.addASTChild(currentAST, returnAST);
    literal_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case CHAR_LITERAL:
   {
    character_literal();
    astFactory.addASTChild(currentAST, returnAST);
    literal_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case WIDE_CHAR_LITERAL:
   {
    wide_character_literal();
    astFactory.addASTChild(currentAST, returnAST);
    literal_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case FIXED:
   {
    fixed_pt_literal();
    astFactory.addASTChild(currentAST, returnAST);
    literal_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case FLOAT:
   {
    floating_pt_literal();
    astFactory.addASTChild(currentAST, returnAST);
    literal_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_TRUE:
   case LITERAL_FALSE:
   {
    boolean_literal();
    astFactory.addASTChild(currentAST, returnAST);
    literal_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_48);
   } else {
     throw ex;
   }
  }
  returnAST = literal_AST;
 }
 
 public final void integer_literal() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST integer_literal_AST = null;
  
  try {      // for error handling
   switch ( LA(1)) {
   case INT:
   {
    IdlParserAST tmp108_AST = null;
    tmp108_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.addASTChild(currentAST, tmp108_AST);
    match(INT);
    integer_literal_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case OCTAL:
   {
    IdlParserAST tmp109_AST = null;
    tmp109_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.addASTChild(currentAST, tmp109_AST);
    match(OCTAL);
    integer_literal_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case HEX:
   {
    IdlParserAST tmp110_AST = null;
    tmp110_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.addASTChild(currentAST, tmp110_AST);
    match(HEX);
    integer_literal_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_48);
   } else {
     throw ex;
   }
  }
  returnAST = integer_literal_AST;
 }
 
 public final void string_literal() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST string_literal_AST = null;
  
  try {      // for error handling
   {
   int _cnt281=0;
   _loop281:
   do {
    if ((LA(1)==STRING_LITERAL)) {
     IdlParserAST tmp111_AST = null;
     tmp111_AST = (IdlParserAST)astFactory.create(LT(1));
     astFactory.addASTChild(currentAST, tmp111_AST);
     match(STRING_LITERAL);
    }
    else {
     if ( _cnt281>=1 ) { break _loop281; } else {throw new NoViableAltException(LT(1), getFilename());}
    }
    
    _cnt281++;
   } while (true);
   }
   string_literal_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_48);
   } else {
     throw ex;
   }
  }
  returnAST = string_literal_AST;
 }
 
 public final void wide_string_literal() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST wide_string_literal_AST = null;
  
  try {      // for error handling
   {
   int _cnt284=0;
   _loop284:
   do {
    if ((LA(1)==WIDE_STRING_LITERAL)) {
     IdlParserAST tmp112_AST = null;
     tmp112_AST = (IdlParserAST)astFactory.create(LT(1));
     astFactory.addASTChild(currentAST, tmp112_AST);
     match(WIDE_STRING_LITERAL);
    }
    else {
     if ( _cnt284>=1 ) { break _loop284; } else {throw new NoViableAltException(LT(1), getFilename());}
    }
    
    _cnt284++;
   } while (true);
   }
   wide_string_literal_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_48);
   } else {
     throw ex;
   }
  }
  returnAST = wide_string_literal_AST;
 }
 
 public final void character_literal() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST character_literal_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp113_AST = null;
   tmp113_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp113_AST);
   match(CHAR_LITERAL);
   character_literal_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_48);
   } else {
     throw ex;
   }
  }
  returnAST = character_literal_AST;
 }
 
 public final void wide_character_literal() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST wide_character_literal_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp114_AST = null;
   tmp114_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp114_AST);
   match(WIDE_CHAR_LITERAL);
   wide_character_literal_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_48);
   } else {
     throw ex;
   }
  }
  returnAST = wide_character_literal_AST;
 }
 
 public final void fixed_pt_literal() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST fixed_pt_literal_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp115_AST = null;
   tmp115_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp115_AST);
   match(FIXED);
   fixed_pt_literal_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_48);
   } else {
     throw ex;
   }
  }
  returnAST = fixed_pt_literal_AST;
 }
 
 public final void floating_pt_literal() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST floating_pt_literal_AST = null;
  Token  f = null;
  IdlParserAST f_AST = null;
  
  try {      // for error handling
   f = LT(1);
   f_AST = (IdlParserAST)astFactory.create(f);
   astFactory.addASTChild(currentAST, f_AST);
   match(FLOAT);
   floating_pt_literal_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_48);
   } else {
     throw ex;
   }
  }
  returnAST = floating_pt_literal_AST;
 }
 
 public final void boolean_literal() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST boolean_literal_AST = null;
  
  try {      // for error handling
   switch ( LA(1)) {
   case LITERAL_TRUE:
   {
    IdlParserAST tmp116_AST = null;
    tmp116_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.addASTChild(currentAST, tmp116_AST);
    match(LITERAL_TRUE);
    boolean_literal_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_FALSE:
   {
    IdlParserAST tmp117_AST = null;
    tmp117_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.addASTChild(currentAST, tmp117_AST);
    match(LITERAL_FALSE);
    boolean_literal_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_48);
   } else {
     throw ex;
   }
  }
  returnAST = boolean_literal_AST;
 }
 
 public final void positive_int_const() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST positive_int_const_AST = null;
  
  try {      // for error handling
   const_exp();
   astFactory.addASTChild(currentAST, returnAST);
   positive_int_const_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_49);
   } else {
     throw ex;
   }
  }
  returnAST = positive_int_const_AST;
 }
 
 public final void type_declarator() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST type_declarator_AST = null;
  
  try {      // for error handling
   type_spec();
   astFactory.addASTChild(currentAST, returnAST);
   declarators();
   astFactory.addASTChild(currentAST, returnAST);
   type_declarator_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = type_declarator_AST;
 }
 
 public final void struct_type() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST struct_type_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp118_AST = null;
   tmp118_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp118_AST);
   match(LITERAL_struct);
   identifier();
   astFactory.addASTChild(currentAST, returnAST);
   match(LCURLY);
   member_list();
   astFactory.addASTChild(currentAST, returnAST);
   match(RCURLY);
   struct_type_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_30);
   } else {
     throw ex;
   }
  }
  returnAST = struct_type_AST;
 }
 
 public final void union_type() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST union_type_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp121_AST = null;
   tmp121_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp121_AST);
   match(LITERAL_union);
   identifier();
   astFactory.addASTChild(currentAST, returnAST);
   match(LITERAL_switch);
   match(LPAREN);
   switch_type_spec();
   astFactory.addASTChild(currentAST, returnAST);
   match(RPAREN);
   match(LCURLY);
   switch_body();
   astFactory.addASTChild(currentAST, returnAST);
   match(RCURLY);
   union_type_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_30);
   } else {
     throw ex;
   }
  }
  returnAST = union_type_AST;
 }
 
 public final void enum_type() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST enum_type_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp127_AST = null;
   tmp127_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp127_AST);
   match(LITERAL_enum);
   identifier();
   astFactory.addASTChild(currentAST, returnAST);
   match(LCURLY);
   enumerator_list();
   astFactory.addASTChild(currentAST, returnAST);
   match(RCURLY);
   enum_type_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_50);
   } else {
     throw ex;
   }
  }
  returnAST = enum_type_AST;
 }
 
 public final void constr_forward_decl() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST constr_forward_decl_AST = null;
  
  try {      // for error handling
   switch ( LA(1)) {
   case LITERAL_struct:
   {
    IdlParserAST tmp130_AST = null;
    tmp130_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.makeASTRoot(currentAST, tmp130_AST);
    match(LITERAL_struct);
    identifier();
    astFactory.addASTChild(currentAST, returnAST);
    constr_forward_decl_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_union:
   {
    IdlParserAST tmp131_AST = null;
    tmp131_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.makeASTRoot(currentAST, tmp131_AST);
    match(LITERAL_union);
    identifier();
    astFactory.addASTChild(currentAST, returnAST);
    constr_forward_decl_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = constr_forward_decl_AST;
 }
 
 public final void simple_type_spec() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST simple_type_spec_AST = null;
  
  try {      // for error handling
   switch ( LA(1)) {
   case LITERAL_float:
   case LITERAL_double:
   case LITERAL_long:
   case LITERAL_short:
   case LITERAL_unsigned:
   case LITERAL_char:
   case LITERAL_wchar:
   case LITERAL_boolean:
   case LITERAL_octet:
   case LITERAL_any:
   case LITERAL_Object:
   case LITERAL_ValueBase:
   {
    base_type_spec();
    astFactory.addASTChild(currentAST, returnAST);
    simple_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_sequence:
   case LITERAL_string:
   case LITERAL_wstring:
   case LITERAL_fixed:
   {
    template_type_spec();
    astFactory.addASTChild(currentAST, returnAST);
    simple_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case SCOPEOP:
   case IDENT:
   case ESCAPED_IDENT:
   {
    scoped_name();
    astFactory.addASTChild(currentAST, returnAST);
    simple_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_42);
   } else {
     throw ex;
   }
  }
  returnAST = simple_type_spec_AST;
 }
 
 public final void constr_type_spec() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST constr_type_spec_AST = null;
  
  try {      // for error handling
   switch ( LA(1)) {
   case LITERAL_struct:
   {
    struct_type();
    astFactory.addASTChild(currentAST, returnAST);
    constr_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_union:
   {
    union_type();
    astFactory.addASTChild(currentAST, returnAST);
    constr_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_enum:
   {
    enum_type();
    astFactory.addASTChild(currentAST, returnAST);
    constr_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_30);
   } else {
     throw ex;
   }
  }
  returnAST = constr_type_spec_AST;
 }
 
 public final void base_type_spec() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST base_type_spec_AST = null;
  
  try {      // for error handling
   switch ( LA(1)) {
   case LITERAL_char:
   {
    char_type();
    astFactory.addASTChild(currentAST, returnAST);
    base_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_wchar:
   {
    wide_char_type();
    astFactory.addASTChild(currentAST, returnAST);
    base_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_boolean:
   {
    boolean_type();
    astFactory.addASTChild(currentAST, returnAST);
    base_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_octet:
   {
    octet_type();
    astFactory.addASTChild(currentAST, returnAST);
    base_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_any:
   {
    any_type();
    astFactory.addASTChild(currentAST, returnAST);
    base_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_Object:
   {
    object_type();
    astFactory.addASTChild(currentAST, returnAST);
    base_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_ValueBase:
   {
    value_base_type();
    astFactory.addASTChild(currentAST, returnAST);
    base_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
    boolean synPredMatched114 = false;
    if ((((LA(1) >= LITERAL_float && LA(1) <= LITERAL_long)) && (_tokenSet_51.member(LA(2))) && (_tokenSet_52.member(LA(3))) && (_tokenSet_53.member(LA(4))))) {
     int _m114 = mark();
     synPredMatched114 = true;
     inputState.guessing++;
     try {
      {
      floating_pt_type();
      }
     }
     catch (RecognitionException pe) {
      synPredMatched114 = false;
     }
     rewind(_m114);
inputState.guessing--;
    }
    if ( synPredMatched114 ) {
     floating_pt_type();
     astFactory.addASTChild(currentAST, returnAST);
     base_type_spec_AST = (IdlParserAST)currentAST.root;
    }
    else if (((LA(1) >= LITERAL_long && LA(1) <= LITERAL_unsigned)) && (_tokenSet_54.member(LA(2))) && (_tokenSet_55.member(LA(3))) && (_tokenSet_53.member(LA(4)))) {
     integer_type();
     astFactory.addASTChild(currentAST, returnAST);
     base_type_spec_AST = (IdlParserAST)currentAST.root;
    }
   else {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_42);
   } else {
     throw ex;
   }
  }
  returnAST = base_type_spec_AST;
 }
 
 public final void template_type_spec() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST template_type_spec_AST = null;
  
  try {      // for error handling
   switch ( LA(1)) {
   case LITERAL_sequence:
   {
    sequence_type();
    astFactory.addASTChild(currentAST, returnAST);
    template_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_string:
   {
    string_type();
    astFactory.addASTChild(currentAST, returnAST);
    template_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_wstring:
   {
    wide_string_type();
    astFactory.addASTChild(currentAST, returnAST);
    template_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_fixed:
   {
    fixed_pt_type();
    astFactory.addASTChild(currentAST, returnAST);
    template_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_42);
   } else {
     throw ex;
   }
  }
  returnAST = template_type_spec_AST;
 }
 
 public final void any_type() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST any_type_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp132_AST = null;
   tmp132_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp132_AST);
   match(LITERAL_any);
   any_type_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_42);
   } else {
     throw ex;
   }
  }
  returnAST = any_type_AST;
 }
 
 public final void object_type() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST object_type_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp133_AST = null;
   tmp133_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp133_AST);
   match(LITERAL_Object);
   object_type_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_42);
   } else {
     throw ex;
   }
  }
  returnAST = object_type_AST;
 }
 
 public final void value_base_type() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST value_base_type_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp134_AST = null;
   tmp134_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp134_AST);
   match(LITERAL_ValueBase);
   value_base_type_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_42);
   } else {
     throw ex;
   }
  }
  returnAST = value_base_type_AST;
 }
 
 public final void sequence_type() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST sequence_type_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp135_AST = null;
   tmp135_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp135_AST);
   match(LITERAL_sequence);
   match(LT);
   simple_type_spec();
   astFactory.addASTChild(currentAST, returnAST);
   opt_pos_int();
   astFactory.addASTChild(currentAST, returnAST);
   match(GT);
   sequence_type_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_42);
   } else {
     throw ex;
   }
  }
  returnAST = sequence_type_AST;
 }
 
 public final void fixed_pt_type() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST fixed_pt_type_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp138_AST = null;
   tmp138_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp138_AST);
   match(LITERAL_fixed);
   match(LT);
   positive_int_const();
   astFactory.addASTChild(currentAST, returnAST);
   match(COMMA);
   positive_int_const();
   astFactory.addASTChild(currentAST, returnAST);
   match(GT);
   fixed_pt_type_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_42);
   } else {
     throw ex;
   }
  }
  returnAST = fixed_pt_type_AST;
 }
 
 public final void declarator() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST declarator_AST = null;
  
  try {      // for error handling
   if ((LA(1)==IDENT||LA(1)==ESCAPED_IDENT) && (LA(2)==SEMI||LA(2)==COMMA)) {
    simple_declarator();
    astFactory.addASTChild(currentAST, returnAST);
    declarator_AST = (IdlParserAST)currentAST.root;
   }
   else if ((LA(1)==IDENT||LA(1)==ESCAPED_IDENT) && (LA(2)==LBRACK)) {
    complex_declarator();
    astFactory.addASTChild(currentAST, returnAST);
    declarator_AST = (IdlParserAST)currentAST.root;
   }
   else {
    throw new NoViableAltException(LT(1), getFilename());
   }
   
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_56);
   } else {
     throw ex;
   }
  }
  returnAST = declarator_AST;
 }
 
 public final void complex_declarator() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST complex_declarator_AST = null;
  
  try {      // for error handling
   array_declarator();
   astFactory.addASTChild(currentAST, returnAST);
   complex_declarator_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_56);
   } else {
     throw ex;
   }
  }
  returnAST = complex_declarator_AST;
 }
 
 public final void array_declarator() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST array_declarator_AST = null;
  
  try {      // for error handling
   {
   switch ( LA(1)) {
   case IDENT:
   {
    IdlParserAST tmp142_AST = null;
    tmp142_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.makeASTRoot(currentAST, tmp142_AST);
    match(IDENT);
    break;
   }
   case ESCAPED_IDENT:
   {
    IdlParserAST tmp143_AST = null;
    tmp143_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.makeASTRoot(currentAST, tmp143_AST);
    match(ESCAPED_IDENT);
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   {
   int _cnt169=0;
   _loop169:
   do {
    if ((LA(1)==LBRACK)) {
     fixed_array_size();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     if ( _cnt169>=1 ) { break _loop169; } else {throw new NoViableAltException(LT(1), getFilename());}
    }
    
    _cnt169++;
   } while (true);
   }
   array_declarator_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_56);
   } else {
     throw ex;
   }
  }
  returnAST = array_declarator_AST;
 }
 
 public final void signed_int() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST signed_int_AST = null;
  
  try {      // for error handling
   if ((LA(1)==LITERAL_short)) {
    signed_short_int();
    astFactory.addASTChild(currentAST, returnAST);
    signed_int_AST = (IdlParserAST)currentAST.root;
   }
   else if ((LA(1)==LITERAL_long) && (_tokenSet_41.member(LA(2)))) {
    signed_long_int();
    astFactory.addASTChild(currentAST, returnAST);
    signed_int_AST = (IdlParserAST)currentAST.root;
   }
   else if ((LA(1)==LITERAL_long) && (LA(2)==LITERAL_long)) {
    signed_longlong_int();
    astFactory.addASTChild(currentAST, returnAST);
    signed_int_AST = (IdlParserAST)currentAST.root;
   }
   else {
    throw new NoViableAltException(LT(1), getFilename());
   }
   
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_41);
   } else {
     throw ex;
   }
  }
  returnAST = signed_int_AST;
 }
 
 public final void unsigned_int() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST unsigned_int_AST = null;
  
  try {      // for error handling
   if ((LA(1)==LITERAL_unsigned) && (LA(2)==LITERAL_short)) {
    unsigned_short_int();
    astFactory.addASTChild(currentAST, returnAST);
    unsigned_int_AST = (IdlParserAST)currentAST.root;
   }
   else if ((LA(1)==LITERAL_unsigned) && (LA(2)==LITERAL_long) && (_tokenSet_41.member(LA(3)))) {
    unsigned_long_int();
    astFactory.addASTChild(currentAST, returnAST);
    unsigned_int_AST = (IdlParserAST)currentAST.root;
   }
   else if ((LA(1)==LITERAL_unsigned) && (LA(2)==LITERAL_long) && (LA(3)==LITERAL_long)) {
    unsigned_longlong_int();
    astFactory.addASTChild(currentAST, returnAST);
    unsigned_int_AST = (IdlParserAST)currentAST.root;
   }
   else {
    throw new NoViableAltException(LT(1), getFilename());
   }
   
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_41);
   } else {
     throw ex;
   }
  }
  returnAST = unsigned_int_AST;
 }
 
 public final void signed_short_int() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST signed_short_int_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp144_AST = null;
   tmp144_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp144_AST);
   match(LITERAL_short);
   signed_short_int_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_41);
   } else {
     throw ex;
   }
  }
  returnAST = signed_short_int_AST;
 }
 
 public final void signed_long_int() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST signed_long_int_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp145_AST = null;
   tmp145_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp145_AST);
   match(LITERAL_long);
   signed_long_int_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_41);
   } else {
     throw ex;
   }
  }
  returnAST = signed_long_int_AST;
 }
 
 public final void signed_longlong_int() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST signed_longlong_int_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp146_AST = null;
   tmp146_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp146_AST);
   match(LITERAL_long);
   IdlParserAST tmp147_AST = null;
   tmp147_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp147_AST);
   match(LITERAL_long);
   signed_longlong_int_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_41);
   } else {
     throw ex;
   }
  }
  returnAST = signed_longlong_int_AST;
 }
 
 public final void unsigned_short_int() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST unsigned_short_int_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp148_AST = null;
   tmp148_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp148_AST);
   match(LITERAL_unsigned);
   IdlParserAST tmp149_AST = null;
   tmp149_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp149_AST);
   match(LITERAL_short);
   unsigned_short_int_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_41);
   } else {
     throw ex;
   }
  }
  returnAST = unsigned_short_int_AST;
 }
 
 public final void unsigned_long_int() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST unsigned_long_int_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp150_AST = null;
   tmp150_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp150_AST);
   match(LITERAL_unsigned);
   IdlParserAST tmp151_AST = null;
   tmp151_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp151_AST);
   match(LITERAL_long);
   unsigned_long_int_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_41);
   } else {
     throw ex;
   }
  }
  returnAST = unsigned_long_int_AST;
 }
 
 public final void unsigned_longlong_int() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST unsigned_longlong_int_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp152_AST = null;
   tmp152_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp152_AST);
   match(LITERAL_unsigned);
   IdlParserAST tmp153_AST = null;
   tmp153_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp153_AST);
   match(LITERAL_long);
   IdlParserAST tmp154_AST = null;
   tmp154_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp154_AST);
   match(LITERAL_long);
   unsigned_longlong_int_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_41);
   } else {
     throw ex;
   }
  }
  returnAST = unsigned_longlong_int_AST;
 }
 
 public final void member_list() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST member_list_AST = null;
  
  try {      // for error handling
   {
   int _cnt142=0;
   _loop142:
   do {
    if ((_tokenSet_16.member(LA(1)))) {
     member();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     if ( _cnt142>=1 ) { break _loop142; } else {throw new NoViableAltException(LT(1), getFilename());}
    }
    
    _cnt142++;
   } while (true);
   }
   member_list_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_21);
   } else {
     throw ex;
   }
  }
  returnAST = member_list_AST;
 }
 
 public final void member() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST member_AST = null;
  
  try {      // for error handling
   type_spec();
   astFactory.addASTChild(currentAST, returnAST);
   declarators();
   astFactory.addASTChild(currentAST, returnAST);
   IdlParserAST tmp155_AST = null;
   tmp155_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp155_AST);
   match(SEMI);
   member_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_57);
   } else {
     throw ex;
   }
  }
  returnAST = member_AST;
 }
 
 public final void switch_type_spec() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST switch_type_spec_AST = null;
  
  try {      // for error handling
   switch ( LA(1)) {
   case LITERAL_long:
   case LITERAL_short:
   case LITERAL_unsigned:
   {
    integer_type();
    astFactory.addASTChild(currentAST, returnAST);
    switch_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_char:
   {
    char_type();
    astFactory.addASTChild(currentAST, returnAST);
    switch_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_boolean:
   {
    boolean_type();
    astFactory.addASTChild(currentAST, returnAST);
    switch_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_enum:
   {
    enum_type();
    astFactory.addASTChild(currentAST, returnAST);
    switch_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case SCOPEOP:
   case IDENT:
   case ESCAPED_IDENT:
   {
    scoped_name();
    astFactory.addASTChild(currentAST, returnAST);
    switch_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_31);
   } else {
     throw ex;
   }
  }
  returnAST = switch_type_spec_AST;
 }
 
 public final void switch_body() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST switch_body_AST = null;
  
  try {      // for error handling
   case_stmt_list();
   astFactory.addASTChild(currentAST, returnAST);
   switch_body_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_21);
   } else {
     throw ex;
   }
  }
  returnAST = switch_body_AST;
 }
 
 public final void case_stmt_list() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST case_stmt_list_AST = null;
  
  try {      // for error handling
   {
   int _cnt149=0;
   _loop149:
   do {
    if ((LA(1)==LITERAL_case||LA(1)==LITERAL_default)) {
     case_stmt();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     if ( _cnt149>=1 ) { break _loop149; } else {throw new NoViableAltException(LT(1), getFilename());}
    }
    
    _cnt149++;
   } while (true);
   }
   case_stmt_list_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_21);
   } else {
     throw ex;
   }
  }
  returnAST = case_stmt_list_AST;
 }
 
 public final void case_stmt() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST case_stmt_AST = null;
  
  try {      // for error handling
   {
   int _cnt152=0;
   _loop152:
   do {
    switch ( LA(1)) {
    case LITERAL_case:
    {
     IdlParserAST tmp156_AST = null;
     tmp156_AST = (IdlParserAST)astFactory.create(LT(1));
     astFactory.makeASTRoot(currentAST, tmp156_AST);
     match(LITERAL_case);
     const_exp();
     astFactory.addASTChild(currentAST, returnAST);
     match(COLON);
     break;
    }
    case LITERAL_default:
    {
     IdlParserAST tmp158_AST = null;
     tmp158_AST = (IdlParserAST)astFactory.create(LT(1));
     astFactory.makeASTRoot(currentAST, tmp158_AST);
     match(LITERAL_default);
     match(COLON);
     break;
    }
    default:
    {
     if ( _cnt152>=1 ) { break _loop152; } else {throw new NoViableAltException(LT(1), getFilename());}
    }
    }
    _cnt152++;
   } while (true);
   }
   element_spec();
   astFactory.addASTChild(currentAST, returnAST);
   match(SEMI);
   case_stmt_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_58);
   } else {
     throw ex;
   }
  }
  returnAST = case_stmt_AST;
 }
 
 public final void element_spec() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST element_spec_AST = null;
  
  try {      // for error handling
   type_spec();
   astFactory.addASTChild(currentAST, returnAST);
   declarator();
   astFactory.addASTChild(currentAST, returnAST);
   element_spec_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = element_spec_AST;
 }
 
 public final void enumerator_list() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST enumerator_list_AST = null;
  
  try {      // for error handling
   enumerator();
   astFactory.addASTChild(currentAST, returnAST);
   {
   _loop157:
   do {
    if ((LA(1)==COMMA)) {
     match(COMMA);
     enumerator();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop157;
    }
    
   } while (true);
   }
   enumerator_list_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_21);
   } else {
     throw ex;
   }
  }
  returnAST = enumerator_list_AST;
 }
 
 public final void enumerator() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST enumerator_AST = null;
  
  try {      // for error handling
   identifier();
   astFactory.addASTChild(currentAST, returnAST);
   enumerator_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_59);
   } else {
     throw ex;
   }
  }
  returnAST = enumerator_AST;
 }
 
 public final void opt_pos_int() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST opt_pos_int_AST = null;
  
  try {      // for error handling
   {
   switch ( LA(1)) {
   case COMMA:
   {
    match(COMMA);
    positive_int_const();
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case GT:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   opt_pos_int_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_60);
   } else {
     throw ex;
   }
  }
  returnAST = opt_pos_int_AST;
 }
 
 public final void fixed_array_size() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST fixed_array_size_AST = null;
  
  try {      // for error handling
   match(LBRACK);
   positive_int_const();
   astFactory.addASTChild(currentAST, returnAST);
   match(RBRACK);
   fixed_array_size_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_61);
   } else {
     throw ex;
   }
  }
  returnAST = fixed_array_size_AST;
 }
 
 public final void readonly_attr_spec() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST readonly_attr_spec_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp165_AST = null;
   tmp165_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp165_AST);
   match(LITERAL_readonly);
   IdlParserAST tmp166_AST = null;
   tmp166_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp166_AST);
   match(LITERAL_attribute);
   param_type_spec();
   astFactory.addASTChild(currentAST, returnAST);
   readonly_attr_declarator();
   astFactory.addASTChild(currentAST, returnAST);
   readonly_attr_spec_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = readonly_attr_spec_AST;
 }
 
 public final void attr_spec() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST attr_spec_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp167_AST = null;
   tmp167_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp167_AST);
   match(LITERAL_attribute);
   param_type_spec();
   astFactory.addASTChild(currentAST, returnAST);
   attr_declarator();
   astFactory.addASTChild(currentAST, returnAST);
   attr_spec_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = attr_spec_AST;
 }
 
 public final void opt_member_list() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST opt_member_list_AST = null;
  
  try {      // for error handling
   {
   _loop175:
   do {
    if ((_tokenSet_16.member(LA(1)))) {
     member();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop175;
    }
    
   } while (true);
   }
   opt_member_list_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_21);
   } else {
     throw ex;
   }
  }
  returnAST = opt_member_list_AST;
 }
 
 public final void op_attribute() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST op_attribute_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp168_AST = null;
   tmp168_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp168_AST);
   match(LITERAL_oneway);
   op_attribute_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_62);
   } else {
     throw ex;
   }
  }
  returnAST = op_attribute_AST;
 }
 
 public final void op_type_spec() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST op_type_spec_AST = null;
  
  try {      // for error handling
   switch ( LA(1)) {
   case SCOPEOP:
   case IDENT:
   case ESCAPED_IDENT:
   case LITERAL_float:
   case LITERAL_double:
   case LITERAL_long:
   case LITERAL_short:
   case LITERAL_unsigned:
   case LITERAL_char:
   case LITERAL_wchar:
   case LITERAL_boolean:
   case LITERAL_octet:
   case LITERAL_any:
   case LITERAL_Object:
   case LITERAL_string:
   case LITERAL_wstring:
   case LITERAL_ValueBase:
   {
    param_type_spec();
    astFactory.addASTChild(currentAST, returnAST);
    op_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case LITERAL_void:
   {
    IdlParserAST tmp169_AST = null;
    tmp169_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.addASTChild(currentAST, tmp169_AST);
    match(LITERAL_void);
    op_type_spec_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_35);
   } else {
     throw ex;
   }
  }
  returnAST = op_type_spec_AST;
 }
 
 public final void parameter_dcls() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST parameter_dcls_AST = null;
  
  try {      // for error handling
   match(LPAREN);
   {
   switch ( LA(1)) {
   case LITERAL_in:
   case LITERAL_out:
   case LITERAL_inout:
   {
    param_dcl_list();
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case RPAREN:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   match(RPAREN);
   parameter_dcls_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_63);
   } else {
     throw ex;
   }
  }
  returnAST = parameter_dcls_AST;
 }
 
 public final void context_expr() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST context_expr_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp172_AST = null;
   tmp172_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp172_AST);
   match(LITERAL_context);
   match(LPAREN);
   string_literal_list();
   astFactory.addASTChild(currentAST, returnAST);
   match(RPAREN);
   context_expr_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = context_expr_AST;
 }
 
 public final void param_dcl_list() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST param_dcl_list_AST = null;
  
  try {      // for error handling
   param_dcl();
   astFactory.addASTChild(currentAST, returnAST);
   {
   _loop187:
   do {
    if ((LA(1)==COMMA)) {
     match(COMMA);
     param_dcl();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop187;
    }
    
   } while (true);
   }
   param_dcl_list_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_31);
   } else {
     throw ex;
   }
  }
  returnAST = param_dcl_list_AST;
 }
 
 public final void param_dcl() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST param_dcl_AST = null;
  
  try {      // for error handling
   {
   switch ( LA(1)) {
   case LITERAL_in:
   {
    IdlParserAST tmp176_AST = null;
    tmp176_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.makeASTRoot(currentAST, tmp176_AST);
    match(LITERAL_in);
    break;
   }
   case LITERAL_out:
   {
    IdlParserAST tmp177_AST = null;
    tmp177_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.makeASTRoot(currentAST, tmp177_AST);
    match(LITERAL_out);
    break;
   }
   case LITERAL_inout:
   {
    IdlParserAST tmp178_AST = null;
    tmp178_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.makeASTRoot(currentAST, tmp178_AST);
    match(LITERAL_inout);
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   param_type_spec();
   astFactory.addASTChild(currentAST, returnAST);
   simple_declarator();
   astFactory.addASTChild(currentAST, returnAST);
   param_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_33);
   } else {
     throw ex;
   }
  }
  returnAST = param_dcl_AST;
 }
 
 public final void string_literal_list() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST string_literal_list_AST = null;
  
  try {      // for error handling
   string_literal();
   astFactory.addASTChild(currentAST, returnAST);
   {
   _loop194:
   do {
    if ((LA(1)==COMMA)) {
     match(COMMA);
     string_literal();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop194;
    }
    
   } while (true);
   }
   string_literal_list_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_31);
   } else {
     throw ex;
   }
  }
  returnAST = string_literal_list_AST;
 }
 
 public final void imported_scope() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST imported_scope_AST = null;
  
  try {      // for error handling
   switch ( LA(1)) {
   case SCOPEOP:
   case IDENT:
   case ESCAPED_IDENT:
   {
    scoped_name();
    astFactory.addASTChild(currentAST, returnAST);
    imported_scope_AST = (IdlParserAST)currentAST.root;
    break;
   }
   case STRING_LITERAL:
   {
    string_literal();
    astFactory.addASTChild(currentAST, returnAST);
    imported_scope_AST = (IdlParserAST)currentAST.root;
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = imported_scope_AST;
 }
 
 public final void readonly_attr_declarator() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST readonly_attr_declarator_AST = null;
  
  try {      // for error handling
   simple_declarator();
   astFactory.addASTChild(currentAST, returnAST);
   {
   switch ( LA(1)) {
   case LITERAL_raises:
   {
    raises_expr();
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case SEMI:
   case COMMA:
   {
    {
    _loop208:
    do {
     if ((LA(1)==COMMA)) {
      match(COMMA);
      simple_declarator();
      astFactory.addASTChild(currentAST, returnAST);
     }
     else {
      break _loop208;
     }
     
    } while (true);
    }
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   readonly_attr_declarator_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = readonly_attr_declarator_AST;
 }
 
 public final void attr_declarator() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST attr_declarator_AST = null;
  
  try {      // for error handling
   simple_declarator();
   astFactory.addASTChild(currentAST, returnAST);
   {
   boolean synPredMatched213 = false;
   if (((LA(1)==SEMI||LA(1)==LITERAL_getraises||LA(1)==LITERAL_setraises) && (_tokenSet_64.member(LA(2))) && (_tokenSet_65.member(LA(3))) && (_tokenSet_66.member(LA(4))))) {
    int _m213 = mark();
    synPredMatched213 = true;
    inputState.guessing++;
    try {
     {
     switch ( LA(1)) {
     case LITERAL_getraises:
     {
      match(LITERAL_getraises);
      break;
     }
     case LITERAL_setraises:
     {
      match(LITERAL_setraises);
      break;
     }
     default:
     {
      throw new NoViableAltException(LT(1), getFilename());
     }
     }
     }
    }
    catch (RecognitionException pe) {
     synPredMatched213 = false;
    }
    rewind(_m213);
inputState.guessing--;
   }
   if ( synPredMatched213 ) {
    attr_raises_expr();
    astFactory.addASTChild(currentAST, returnAST);
   }
   else if ((LA(1)==SEMI||LA(1)==COMMA) && (_tokenSet_67.member(LA(2))) && (_tokenSet_68.member(LA(3))) && (_tokenSet_69.member(LA(4)))) {
    {
    _loop215:
    do {
     if ((LA(1)==COMMA)) {
      match(COMMA);
      simple_declarator();
      astFactory.addASTChild(currentAST, returnAST);
     }
     else {
      break _loop215;
     }
     
    } while (true);
    }
   }
   else {
    throw new NoViableAltException(LT(1), getFilename());
   }
   
   }
   attr_declarator_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = attr_declarator_AST;
 }
 
 public final void attr_raises_expr() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST attr_raises_expr_AST = null;
  
  try {      // for error handling
   {
   switch ( LA(1)) {
   case LITERAL_getraises:
   {
    get_excep_expr();
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case SEMI:
   case LITERAL_setraises:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   {
   switch ( LA(1)) {
   case LITERAL_setraises:
   {
    set_excep_expr();
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case SEMI:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   attr_raises_expr_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = attr_raises_expr_AST;
 }
 
 public final void get_excep_expr() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST get_excep_expr_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp182_AST = null;
   tmp182_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp182_AST);
   match(LITERAL_getraises);
   exception_list();
   astFactory.addASTChild(currentAST, returnAST);
   get_excep_expr_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_70);
   } else {
     throw ex;
   }
  }
  returnAST = get_excep_expr_AST;
 }
 
 public final void set_excep_expr() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST set_excep_expr_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp183_AST = null;
   tmp183_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp183_AST);
   match(LITERAL_setraises);
   exception_list();
   astFactory.addASTChild(currentAST, returnAST);
   set_excep_expr_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = set_excep_expr_AST;
 }
 
 public final void exception_list() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST exception_list_AST = null;
  
  try {      // for error handling
   match(LPAREN);
   scoped_name();
   astFactory.addASTChild(currentAST, returnAST);
   {
   _loop223:
   do {
    if ((LA(1)==COMMA)) {
     match(COMMA);
     scoped_name();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop223;
    }
    
   } while (true);
   }
   match(RPAREN);
   exception_list_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_70);
   } else {
     throw ex;
   }
  }
  returnAST = exception_list_AST;
 }
 
 public final void component_dcl() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST component_dcl_AST = null;
  
  try {      // for error handling
   {
   switch ( LA(1)) {
   case COLON:
   {
    component_inheritance_spec();
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LCURLY:
   case LITERAL_supports:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   {
   switch ( LA(1)) {
   case LITERAL_supports:
   {
    supported_interface_spec();
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LCURLY:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   IdlParserAST tmp187_AST = null;
   tmp187_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp187_AST);
   match(LCURLY);
   component_body();
   astFactory.addASTChild(currentAST, returnAST);
   IdlParserAST tmp188_AST = null;
   tmp188_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp188_AST);
   match(RCURLY);
   component_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = component_dcl_AST;
 }
 
 public final void component_inheritance_spec() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST component_inheritance_spec_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp189_AST = null;
   tmp189_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp189_AST);
   match(COLON);
   scoped_name();
   astFactory.addASTChild(currentAST, returnAST);
   component_inheritance_spec_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_29);
   } else {
     throw ex;
   }
  }
  returnAST = component_inheritance_spec_AST;
 }
 
 public final void supported_interface_spec() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST supported_interface_spec_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp190_AST = null;
   tmp190_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp190_AST);
   match(LITERAL_supports);
   scoped_name();
   astFactory.addASTChild(currentAST, returnAST);
   {
   _loop231:
   do {
    if ((LA(1)==COMMA)) {
     match(COMMA);
     scoped_name();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop231;
    }
    
   } while (true);
   }
   supported_interface_spec_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_71);
   } else {
     throw ex;
   }
  }
  returnAST = supported_interface_spec_AST;
 }
 
 public final void component_body() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST component_body_AST = null;
  
  try {      // for error handling
   {
   _loop235:
   do {
    if ((_tokenSet_72.member(LA(1)))) {
     component_export();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop235;
    }
    
   } while (true);
   }
   component_body_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_21);
   } else {
     throw ex;
   }
  }
  returnAST = component_body_AST;
 }
 
 public final void component_export() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST component_export_AST = null;
  
  try {      // for error handling
   {
   switch ( LA(1)) {
   case LITERAL_provides:
   {
    provides_dcl();
    astFactory.addASTChild(currentAST, returnAST);
    match(SEMI);
    break;
   }
   case LITERAL_uses:
   {
    uses_dcl();
    astFactory.addASTChild(currentAST, returnAST);
    match(SEMI);
    break;
   }
   case LITERAL_emits:
   {
    emits_dcl();
    astFactory.addASTChild(currentAST, returnAST);
    match(SEMI);
    break;
   }
   case LITERAL_publishes:
   {
    publishes_dcl();
    astFactory.addASTChild(currentAST, returnAST);
    match(SEMI);
    break;
   }
   case LITERAL_consumes:
   {
    consumes_dcl();
    astFactory.addASTChild(currentAST, returnAST);
    match(SEMI);
    break;
   }
   case LITERAL_readonly:
   case LITERAL_attribute:
   {
    attr_dcl();
    astFactory.addASTChild(currentAST, returnAST);
    match(SEMI);
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   component_export_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_73);
   } else {
     throw ex;
   }
  }
  returnAST = component_export_AST;
 }
 
 public final void provides_dcl() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST provides_dcl_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp198_AST = null;
   tmp198_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp198_AST);
   match(LITERAL_provides);
   interface_type();
   astFactory.addASTChild(currentAST, returnAST);
   identifier();
   astFactory.addASTChild(currentAST, returnAST);
   provides_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = provides_dcl_AST;
 }
 
 public final void uses_dcl() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST uses_dcl_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp199_AST = null;
   tmp199_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp199_AST);
   match(LITERAL_uses);
   {
   switch ( LA(1)) {
   case LITERAL_multiple:
   {
    IdlParserAST tmp200_AST = null;
    tmp200_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.addASTChild(currentAST, tmp200_AST);
    match(LITERAL_multiple);
    break;
   }
   case SCOPEOP:
   case IDENT:
   case ESCAPED_IDENT:
   case LITERAL_Object:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   interface_type();
   astFactory.addASTChild(currentAST, returnAST);
   identifier();
   astFactory.addASTChild(currentAST, returnAST);
   uses_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = uses_dcl_AST;
 }
 
 public final void emits_dcl() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST emits_dcl_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp201_AST = null;
   tmp201_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp201_AST);
   match(LITERAL_emits);
   scoped_name();
   astFactory.addASTChild(currentAST, returnAST);
   identifier();
   astFactory.addASTChild(currentAST, returnAST);
   emits_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = emits_dcl_AST;
 }
 
 public final void publishes_dcl() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST publishes_dcl_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp202_AST = null;
   tmp202_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp202_AST);
   match(LITERAL_publishes);
   scoped_name();
   astFactory.addASTChild(currentAST, returnAST);
   identifier();
   astFactory.addASTChild(currentAST, returnAST);
   publishes_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = publishes_dcl_AST;
 }
 
 public final void consumes_dcl() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST consumes_dcl_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp203_AST = null;
   tmp203_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp203_AST);
   match(LITERAL_consumes);
   scoped_name();
   astFactory.addASTChild(currentAST, returnAST);
   identifier();
   astFactory.addASTChild(currentAST, returnAST);
   consumes_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = consumes_dcl_AST;
 }
 
 public final void interface_type() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST interface_type_AST = null;
  
  try {      // for error handling
   {
   switch ( LA(1)) {
   case SCOPEOP:
   case IDENT:
   case ESCAPED_IDENT:
   {
    scoped_name();
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LITERAL_Object:
   {
    IdlParserAST tmp204_AST = null;
    tmp204_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.addASTChild(currentAST, tmp204_AST);
    match(LITERAL_Object);
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   interface_type_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_35);
   } else {
     throw ex;
   }
  }
  returnAST = interface_type_AST;
 }
 
 public final void home_dcl() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST home_dcl_AST = null;
  
  try {      // for error handling
   home_header();
   astFactory.addASTChild(currentAST, returnAST);
   IdlParserAST tmp205_AST = null;
   tmp205_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp205_AST);
   match(LCURLY);
   home_body();
   astFactory.addASTChild(currentAST, returnAST);
   IdlParserAST tmp206_AST = null;
   tmp206_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp206_AST);
   match(RCURLY);
   home_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = home_dcl_AST;
 }
 
 public final void home_header() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST home_header_AST = null;
  
  try {      // for error handling
   {
   switch ( LA(1)) {
   case COLON:
   {
    home_inheritance_spec();
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LITERAL_supports:
   case LITERAL_manages:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   {
   switch ( LA(1)) {
   case LITERAL_supports:
   {
    supported_interface_spec();
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LITERAL_manages:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   {
   home_manages_spec();
   astFactory.addASTChild(currentAST, returnAST);
   }
   {
   switch ( LA(1)) {
   case LITERAL_primarykey:
   {
    primary_key_spec();
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LCURLY:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   home_header_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_22);
   } else {
     throw ex;
   }
  }
  returnAST = home_header_AST;
 }
 
 public final void home_body() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST home_body_AST = null;
  
  try {      // for error handling
   {
   _loop258:
   do {
    if ((_tokenSet_74.member(LA(1)))) {
     home_export();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop258;
    }
    
   } while (true);
   }
   home_body_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_21);
   } else {
     throw ex;
   }
  }
  returnAST = home_body_AST;
 }
 
 public final void home_inheritance_spec() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST home_inheritance_spec_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp207_AST = null;
   tmp207_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp207_AST);
   match(COLON);
   scoped_name();
   astFactory.addASTChild(currentAST, returnAST);
   home_inheritance_spec_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_75);
   } else {
     throw ex;
   }
  }
  returnAST = home_inheritance_spec_AST;
 }
 
 public final void home_manages_spec() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST home_manages_spec_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp208_AST = null;
   tmp208_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp208_AST);
   match(LITERAL_manages);
   scoped_name();
   astFactory.addASTChild(currentAST, returnAST);
   home_manages_spec_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_76);
   } else {
     throw ex;
   }
  }
  returnAST = home_manages_spec_AST;
 }
 
 public final void primary_key_spec() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST primary_key_spec_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp209_AST = null;
   tmp209_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp209_AST);
   match(LITERAL_primarykey);
   scoped_name();
   astFactory.addASTChild(currentAST, returnAST);
   primary_key_spec_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_22);
   } else {
     throw ex;
   }
  }
  returnAST = primary_key_spec_AST;
 }
 
 public final void home_export() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST home_export_AST = null;
  
  try {      // for error handling
   {
   switch ( LA(1)) {
   case SCOPEOP:
   case IDENT:
   case ESCAPED_IDENT:
   case LITERAL_const:
   case LITERAL_typedef:
   case LITERAL_native:
   case LITERAL_float:
   case LITERAL_double:
   case LITERAL_long:
   case LITERAL_short:
   case LITERAL_unsigned:
   case LITERAL_char:
   case LITERAL_wchar:
   case LITERAL_boolean:
   case LITERAL_octet:
   case LITERAL_any:
   case LITERAL_Object:
   case LITERAL_struct:
   case LITERAL_union:
   case LITERAL_enum:
   case LITERAL_string:
   case LITERAL_wstring:
   case LITERAL_exception:
   case LITERAL_oneway:
   case LITERAL_void:
   case LITERAL_ValueBase:
   case LITERAL_typeid:
   case LITERAL_typeprefix:
   case LITERAL_readonly:
   case LITERAL_attribute:
   case PRAGMA:
   {
    export();
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LITERAL_factory:
   {
    factory_dcl();
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case LITERAL_finder:
   {
    finder_dcl();
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   home_export_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_77);
   } else {
     throw ex;
   }
  }
  returnAST = home_export_AST;
 }
 
 public final void factory_dcl() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST factory_dcl_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp210_AST = null;
   tmp210_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp210_AST);
   match(LITERAL_factory);
   identifier();
   astFactory.addASTChild(currentAST, returnAST);
   match(LPAREN);
   {
   switch ( LA(1)) {
   case LITERAL_in:
   {
    init_param_decls();
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case RPAREN:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   match(RPAREN);
   {
   switch ( LA(1)) {
   case LITERAL_raises:
   {
    raises_expr();
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case SEMI:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   match(SEMI);
   factory_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_77);
   } else {
     throw ex;
   }
  }
  returnAST = factory_dcl_AST;
 }
 
 public final void finder_dcl() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST finder_dcl_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp214_AST = null;
   tmp214_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp214_AST);
   match(LITERAL_finder);
   identifier();
   astFactory.addASTChild(currentAST, returnAST);
   match(LPAREN);
   {
   switch ( LA(1)) {
   case LITERAL_in:
   {
    init_param_decls();
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case RPAREN:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   match(RPAREN);
   {
   switch ( LA(1)) {
   case LITERAL_raises:
   {
    raises_expr();
    astFactory.addASTChild(currentAST, returnAST);
    break;
   }
   case SEMI:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   match(SEMI);
   finder_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_77);
   } else {
     throw ex;
   }
  }
  returnAST = finder_dcl_AST;
 }
 
 public final void event_dcl() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST event_dcl_AST = null;
  
  try {      // for error handling
   {
   switch ( LA(1)) {
   case LITERAL_custom:
   {
    IdlParserAST tmp218_AST = null;
    tmp218_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.addASTChild(currentAST, tmp218_AST);
    match(LITERAL_custom);
    break;
   }
   case LITERAL_eventtype:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   IdlParserAST tmp219_AST = null;
   tmp219_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp219_AST);
   match(LITERAL_eventtype);
   identifier();
   astFactory.addASTChild(currentAST, returnAST);
   value_inheritance_spec();
   astFactory.addASTChild(currentAST, returnAST);
   IdlParserAST tmp220_AST = null;
   tmp220_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp220_AST);
   match(LCURLY);
   {
   _loop272:
   do {
    if ((_tokenSet_27.member(LA(1)))) {
     value_element();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop272;
    }
    
   } while (true);
   }
   IdlParserAST tmp221_AST = null;
   tmp221_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp221_AST);
   match(RCURLY);
   event_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = event_dcl_AST;
 }
 
 public final void event_abs_dcl() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST event_abs_dcl_AST = null;
  
  try {      // for error handling
   IdlParserAST tmp222_AST = null;
   tmp222_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp222_AST);
   match(LITERAL_abstract);
   IdlParserAST tmp223_AST = null;
   tmp223_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp223_AST);
   match(LITERAL_eventtype);
   identifier();
   astFactory.addASTChild(currentAST, returnAST);
   value_inheritance_spec();
   astFactory.addASTChild(currentAST, returnAST);
   IdlParserAST tmp224_AST = null;
   tmp224_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp224_AST);
   match(LCURLY);
   {
   _loop275:
   do {
    if ((_tokenSet_23.member(LA(1)))) {
     export();
     astFactory.addASTChild(currentAST, returnAST);
    }
    else {
     break _loop275;
    }
    
   } while (true);
   }
   IdlParserAST tmp225_AST = null;
   tmp225_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.addASTChild(currentAST, tmp225_AST);
   match(RCURLY);
   event_abs_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = event_abs_dcl_AST;
 }
 
 public final void event_forward_dcl() throws RecognitionException, TokenStreamException {
  
  returnAST = null;
  ASTPair currentAST = new ASTPair();
  IdlParserAST event_forward_dcl_AST = null;
  
  try {      // for error handling
   {
   switch ( LA(1)) {
   case LITERAL_abstract:
   {
    IdlParserAST tmp226_AST = null;
    tmp226_AST = (IdlParserAST)astFactory.create(LT(1));
    astFactory.addASTChild(currentAST, tmp226_AST);
    match(LITERAL_abstract);
    break;
   }
   case LITERAL_eventtype:
   {
    break;
   }
   default:
   {
    throw new NoViableAltException(LT(1), getFilename());
   }
   }
   }
   IdlParserAST tmp227_AST = null;
   tmp227_AST = (IdlParserAST)astFactory.create(LT(1));
   astFactory.makeASTRoot(currentAST, tmp227_AST);
   match(LITERAL_eventtype);
   identifier();
   astFactory.addASTChild(currentAST, returnAST);
   event_forward_dcl_AST = (IdlParserAST)currentAST.root;
  }
  catch (RecognitionException ex) {
   if (inputState.guessing==0) {
    reportError(ex);
    recover(ex,_tokenSet_13);
   } else {
     throw ex;
   }
  }
  returnAST = event_forward_dcl_AST;
 }
 
 
 public static final String[] _tokenNames = {
  "<0>",
  "EOF",
  "<2>",
  "NULL_TREE_LOOKAHEAD",
  "SPECIFICATION",
  ";",
  "\"abstract\"",
  "\"local\"",
  "\"interface\"",
  "\"custom\"",
  "\"valuetype\"",
  "\"eventtype\"",
  "\"module\"",
  "{",
  "}",
  ":",
  ",",
  "::",
  "an identifer",
  "an escaped identifer",
  "\"truncatable\"",
  "\"supports\"",
  "\"public\"",
  "\"private\"",
  "\"factory\"",
  "(",
  ")",
  "\"in\"",
  "\"const\"",
  "=",
  "|",
  "^",
  "&",
  "<<",
  ">>",
  "+",
  "-",
  "*",
  "/",
  "%",
  "~",
  "\"TRUE\"",
  "\"FALSE\"",
  "\"typedef\"",
  "\"native\"",
  "\"float\"",
  "\"double\"",
  "\"long\"",
  "\"short\"",
  "\"unsigned\"",
  "\"char\"",
  "\"wchar\"",
  "\"boolean\"",
  "\"octet\"",
  "\"any\"",
  "\"Object\"",
  "\"struct\"",
  "\"union\"",
  "\"switch\"",
  "\"case\"",
  "\"default\"",
  "\"enum\"",
  "\"sequence\"",
  "<",
  ">",
  "\"string\"",
  "\"wstring\"",
  "[",
  "]",
  "\"exception\"",
  "\"oneway\"",
  "\"void\"",
  "\"out\"",
  "\"inout\"",
  "\"raises\"",
  "\"context\"",
  "\"fixed\"",
  "\"ValueBase\"",
  "\"import\"",
  "\"typeid\"",
  "\"typeprefix\"",
  "\"readonly\"",
  "\"attribute\"",
  "\"getraises\"",
  "\"setraises\"",
  "\"component\"",
  "\"provides\"",
  "\"uses\"",
  "\"multiple\"",
  "\"emits\"",
  "\"publishes\"",
  "\"consumes\"",
  "\"home\"",
  "\"manages\"",
  "\"primarykey\"",
  "\"finder\"",
  "an integer value",
  "an octal value",
  "a hexadecimal value value",
  "a string literal",
  "a wide string literal",
  "a character literal",
  "a wide character literal",
  "FIXED",
  "a floating point value",
  "PRAGMA",
  "LINEMARKER",
  "?",
  ".",
  "!",
  "white space",
  "NL",
  "#",
  "a comment",
  "an escape sequence",
  "an escaped character value",
  "a digit",
  "a non-zero digit",
  "an octal digit",
  "a hexadecimal digit"
 };
 
 protected void buildTokenTypeASTClassMap() {
  tokenTypeToASTClassMap=null;
 };
 
 private static final long[] mk_tokenSet_0() {
  long[] data = { 2522042179874987970L, 2199293902880L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
 private static final long[] mk_tokenSet_1() {
  long[] data = { 7205750607969132482L, 2233653637158L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
 private static final long[] mk_tokenSet_2() {
  long[] data = { -1729391052731793438L, 2234190508070L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
 private static final long[] mk_tokenSet_3() {
  long[] data = { -1729383252470267934L, 4394806931694L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_3 = new BitSet(mk_tokenSet_3());
 private static final long[] mk_tokenSet_4() {
  long[] data = { 2522042179874987968L, 2199293886496L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_4 = new BitSet(mk_tokenSet_4());
 private static final long[] mk_tokenSet_5() {
  long[] data = { 2L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_5 = new BitSet(mk_tokenSet_5());
 private static final long[] mk_tokenSet_6() {
  long[] data = { 827424L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_6 = new BitSet(mk_tokenSet_6());
 private static final long[] mk_tokenSet_7() {
  long[] data = { 2594064589541801954L, 2199294288102L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_7 = new BitSet(mk_tokenSet_7());
 private static final long[] mk_tokenSet_8() {
  long[] data = { 7205724219423760416L, 12294L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_8 = new BitSet(mk_tokenSet_8());
 private static final long[] mk_tokenSet_9() {
  long[] data = { -6629307447280467998L, 2199294288102L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_9 = new BitSet(mk_tokenSet_9());
 private static final long[] mk_tokenSet_10() {
  long[] data = { 2924576L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_10 = new BitSet(mk_tokenSet_10());
 private static final long[] mk_tokenSet_11() {
  long[] data = { 2594064589574307810L, 2199294288102L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_11 = new BitSet(mk_tokenSet_11());
 private static final long[] mk_tokenSet_12() {
  long[] data = { 2522042179875004354L, 2199293886496L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_12 = new BitSet(mk_tokenSet_12());
 private static final long[] mk_tokenSet_13() {
  long[] data = { 32L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_13 = new BitSet(mk_tokenSet_13());
 private static final long[] mk_tokenSet_14() {
  long[] data = { 2924544L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_14 = new BitSet(mk_tokenSet_14());
 private static final long[] mk_tokenSet_15() {
  long[] data = { 2594064589574299648L, 2199023755494L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_15 = new BitSet(mk_tokenSet_15());
 private static final long[] mk_tokenSet_16() {
  long[] data = { 7205724219421622272L, 12294L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_16 = new BitSet(mk_tokenSet_16());
 private static final long[] mk_tokenSet_17() {
  long[] data = { -9222879455644614624L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_17 = new BitSet(mk_tokenSet_17());
 private static final long[] mk_tokenSet_18() {
  long[] data = { 2522042179875004386L, 2199293886496L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_18 = new BitSet(mk_tokenSet_18());
 private static final long[] mk_tokenSet_19() {
  long[] data = { 2594064589571121090L, 2201441771750L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_19 = new BitSet(mk_tokenSet_19());
 private static final long[] mk_tokenSet_20() {
  long[] data = { 7493955694650974240L, 35971937303L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_20 = new BitSet(mk_tokenSet_20());
 private static final long[] mk_tokenSet_21() {
  long[] data = { 16384L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_21 = new BitSet(mk_tokenSet_21());
 private static final long[] mk_tokenSet_22() {
  long[] data = { 8192L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_22 = new BitSet(mk_tokenSet_22());
 private static final long[] mk_tokenSet_23() {
  long[] data = { 2594064589541736448L, 2199023755494L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_23 = new BitSet(mk_tokenSet_23());
 private static final long[] mk_tokenSet_24() {
  long[] data = { 2594064589571112960L, 2201171239142L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_24 = new BitSet(mk_tokenSet_24());
 private static final long[] mk_tokenSet_25() {
  long[] data = { 69214208L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_25 = new BitSet(mk_tokenSet_25());
 private static final long[] mk_tokenSet_26() {
  long[] data = { 1098507984928L, 35970351121L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_26 = new BitSet(mk_tokenSet_26());
 private static final long[] mk_tokenSet_27() {
  long[] data = { 2594064589571096576L, 2199023755494L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_27 = new BitSet(mk_tokenSet_27());
 private static final long[] mk_tokenSet_28() {
  long[] data = { 2594064589571112960L, 2199023755494L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_28 = new BitSet(mk_tokenSet_28());
 private static final long[] mk_tokenSet_29() {
  long[] data = { 2105344L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_29 = new BitSet(mk_tokenSet_29());
 private static final long[] mk_tokenSet_30() {
  long[] data = { 786464L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_30 = new BitSet(mk_tokenSet_30());
 private static final long[] mk_tokenSet_31() {
  long[] data = { 67108864L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_31 = new BitSet(mk_tokenSet_31());
 private static final long[] mk_tokenSet_32() {
  long[] data = { 32L, 2048L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_32 = new BitSet(mk_tokenSet_32());
 private static final long[] mk_tokenSet_33() {
  long[] data = { 67174400L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_33 = new BitSet(mk_tokenSet_33());
 private static final long[] mk_tokenSet_34() {
  long[] data = { 72022409666756608L, 8198L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_34 = new BitSet(mk_tokenSet_34());
 private static final long[] mk_tokenSet_35() {
  long[] data = { 786432L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_35 = new BitSet(mk_tokenSet_35());
 private static final long[] mk_tokenSet_36() {
  long[] data = { 67174432L, 1573888L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_36 = new BitSet(mk_tokenSet_36());
 private static final long[] mk_tokenSet_37() {
  long[] data = { 422212465852416L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_37 = new BitSet(mk_tokenSet_37());
 private static final long[] mk_tokenSet_38() {
  long[] data = { 140738026012672L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_38 = new BitSet(mk_tokenSet_38());
 private static final long[] mk_tokenSet_39() {
  long[] data = { 7800231952384L, 2194728288256L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_39 = new BitSet(mk_tokenSet_39());
 private static final long[] mk_tokenSet_40() {
  long[] data = { 67207200L, 17L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_40 = new BitSet(mk_tokenSet_40());
 private static final long[] mk_tokenSet_41() {
  long[] data = { 67960864L, 1L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_41 = new BitSet(mk_tokenSet_41());
 private static final long[] mk_tokenSet_42() {
  long[] data = { 852000L, 1L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_42 = new BitSet(mk_tokenSet_42());
 private static final long[] mk_tokenSet_43() {
  long[] data = { 1140949024L, 17L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_43 = new BitSet(mk_tokenSet_43());
 private static final long[] mk_tokenSet_44() {
  long[] data = { 3288432672L, 17L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_44 = new BitSet(mk_tokenSet_44());
 private static final long[] mk_tokenSet_45() {
  long[] data = { 7583399968L, 17L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_45 = new BitSet(mk_tokenSet_45());
 private static final long[] mk_tokenSet_46() {
  long[] data = { 33353203744L, 17L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_46 = new BitSet(mk_tokenSet_46());
 private static final long[] mk_tokenSet_47() {
  long[] data = { 136432418848L, 17L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_47 = new BitSet(mk_tokenSet_47());
 private static final long[] mk_tokenSet_48() {
  long[] data = { 1098505093152L, 17L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_48 = new BitSet(mk_tokenSet_48());
 private static final long[] mk_tokenSet_49() {
  long[] data = { 65536L, 17L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_49 = new BitSet(mk_tokenSet_49());
 private static final long[] mk_tokenSet_50() {
  long[] data = { 67895328L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_50 = new BitSet(mk_tokenSet_50());
 private static final long[] mk_tokenSet_51() {
  long[] data = { 70368745029664L, 1L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_51 = new BitSet(mk_tokenSet_51());
 private static final long[] mk_tokenSet_52() {
  long[] data = { 2522049979637260258L, 4394023748649L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_52 = new BitSet(mk_tokenSet_52());
 private static final long[] mk_tokenSet_53() {
  long[] data = { 8935141660163006434L, 4396419104751L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_53 = new BitSet(mk_tokenSet_53());
 private static final long[] mk_tokenSet_54() {
  long[] data = { 422212465917984L, 1L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_54 = new BitSet(mk_tokenSet_54());
 private static final long[] mk_tokenSet_55() {
  long[] data = { 2522190717125615586L, 4394023748649L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_55 = new BitSet(mk_tokenSet_55());
 private static final long[] mk_tokenSet_56() {
  long[] data = { 65568L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_56 = new BitSet(mk_tokenSet_56());
 private static final long[] mk_tokenSet_57() {
  long[] data = { 7205724219421638656L, 12294L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_57 = new BitSet(mk_tokenSet_57());
 private static final long[] mk_tokenSet_58() {
  long[] data = { 1729382256910286848L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_58 = new BitSet(mk_tokenSet_58());
 private static final long[] mk_tokenSet_59() {
  long[] data = { 81920L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_59 = new BitSet(mk_tokenSet_59());
 private static final long[] mk_tokenSet_60() {
  long[] data = { 0L, 1L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_60 = new BitSet(mk_tokenSet_60());
 private static final long[] mk_tokenSet_61() {
  long[] data = { 65568L, 8L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_61 = new BitSet(mk_tokenSet_61());
 private static final long[] mk_tokenSet_62() {
  long[] data = { 72022409666756608L, 8326L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_62 = new BitSet(mk_tokenSet_62());
 private static final long[] mk_tokenSet_63() {
  long[] data = { 32L, 3072L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_63 = new BitSet(mk_tokenSet_63());
 private static final long[] mk_tokenSet_64() {
  long[] data = { 2594064589604667392L, 2201418703078L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_64 = new BitSet(mk_tokenSet_64());
 private static final long[] mk_tokenSet_65() {
  long[] data = { -2017621428856274912L, 2201188020454L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_65 = new BitSet(mk_tokenSet_65());
 private static final long[] mk_tokenSet_66() {
  long[] data = { -1729383252943208478L, 4396170064102L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_66 = new BitSet(mk_tokenSet_66());
 private static final long[] mk_tokenSet_67() {
  long[] data = { 2594064589571112960L, 2201418703078L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_67 = new BitSet(mk_tokenSet_67());
 private static final long[] mk_tokenSet_68() {
  long[] data = { -2017621428856209376L, 2201188020454L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_68 = new BitSet(mk_tokenSet_68());
 private static final long[] mk_tokenSet_69() {
  long[] data = { -1729383253010382878L, 4396417528038L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_69 = new BitSet(mk_tokenSet_69());
 private static final long[] mk_tokenSet_70() {
  long[] data = { 32L, 1048576L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_70 = new BitSet(mk_tokenSet_70());
 private static final long[] mk_tokenSet_71() {
  long[] data = { 8192L, 536870912L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_71 = new BitSet(mk_tokenSet_71());
 private static final long[] mk_tokenSet_72() {
  long[] data = { 0L, 247857152L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_72 = new BitSet(mk_tokenSet_72());
 private static final long[] mk_tokenSet_73() {
  long[] data = { 16384L, 247857152L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_73 = new BitSet(mk_tokenSet_73());
 private static final long[] mk_tokenSet_74() {
  long[] data = { 2594064589558513664L, 2201171239142L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_74 = new BitSet(mk_tokenSet_74());
 private static final long[] mk_tokenSet_75() {
  long[] data = { 2097152L, 536870912L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_75 = new BitSet(mk_tokenSet_75());
 private static final long[] mk_tokenSet_76() {
  long[] data = { 8192L, 1073741824L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_76 = new BitSet(mk_tokenSet_76());
 private static final long[] mk_tokenSet_77() {
  long[] data = { 2594064589558530048L, 2201171239142L, 0L, 0L};
  return data;
 }
 public static final BitSet _tokenSet_77 = new BitSet(mk_tokenSet_77());
 
 }
