<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.cpp.CppMappingServices
import com.thalesgroup.ccm.codegenerator.corba.cpp.Utils
import com.thalesgroup.ccm.codegenerator.container.Utils
import com.thalesgroup.ccm.codegenerator.container.cpp.Utils
import com.thalesgroup.ccm.codegenerator.container.cpp.Names
%>

<%script type="idlmm.InterfaceDef" name="filePath" post="trim()"%>
<%generatedCOPIReceptacleClassname%>.hpp

<%--
  -- Generation template  
  --%>
<%script type="idlmm.InterfaceDef" name="COPIReceptacle_hpp" file="<%filePath%>"%>
<%copyrightHeader%>

<%openIfndefMacro(generatedCOPIReceptacleFullClassname)%>

<%genIncludeCdmwCifSkelFile%>

#include <Foundation/orbsupport/RefCountServantBase.hpp>
#include <Foundation/logging/CdmwLogging.stub.hpp>
#include <CCMContainer/ccmcif/LifeCycleObjectBase.hpp>

<%openNamespace(generatedCOPIReceptaclePackage)%>

class <%generatedCOPIReceptacleClassname%> : 
        virtual public ::CORBA::LocalObject,
        virtual public <%equivalentLocalInterface%>
        //virtual public OrbSupport::RefCountServantBase
{
    public:

        <%generatedCOPIReceptacleClassname%>(
            const ::std::string &       receptacle_name,
            const ::std::string &       component_id,
            ::CORBA::Object_ptr         facet_object,
            ::Cdmw::CCM::CIF::Context * context,
            CdmwLogging::Logger_ptr     logger);
    
        ~<%generatedCOPIReceptacleClassname%>() throw();
                        

        <%--
           Create operation declarations for attributes.
           NOTA: This should also include inherited attributes.
        --%>
        <%allAttributes.genAttributeOperations%>
        
        <%--
           Create operation declarations.
           NOTA: This should also include inherited operations.
        --%>
        <%allOperations.genInterceptedOperationImpl%>

    private:
        <%generatedCOPIReceptacleClassname%>(const <%generatedCOPIReceptacleClassname%>&);
        void operator=(const <%generatedCOPIReceptacleClassname%>&);
    
        const std::string m_receptacle_name;    
        const std::string m_component_identity;
        ::CORBA::Object_var m_facet_object;
        ::Cdmw::CCM::CIF::Context * m_context;   
        ::CdmwLogging::Logger_ptr m_logger;
};

<%closeNamespace(generatedCOPIReceptaclePackage)%>

<%closeIfndefMacro(generatedCOPIReceptacleFullClassname)%>



<%script type="idlmm.AttributeDef" name="genAttributeOperations"%>
virtual <%type.asReturnParameterDef%> <%cppName%>()
    throw(<%for (getExceptions){%><%cppFullClassname%>,<%}%>CORBA::SystemException);
<%if (mode != "ATTR_READONLY"){%>
virtual void <%cppName%>(<%type.asInParameterDef%>)
    throw(<%for (setExceptions){%><%cppFullClassname%>,<%}%>CORBA::SystemException);
<%}%>


<%script type="idlmm.OperationDef" name="genInterceptedOperationImpl"%>
virtual <%genOperationSignature%>;
