<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.Utils
import com.thalesgroup.ccm.codegenerator.corba.java.JavaMappingServices
import com.thalesgroup.ccm.codegenerator.corba.java.Utils
import com.thalesgroup.ccm.codegenerator.corba.java.BasicTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.java.ComplexTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.java.IDLTypeFallback
import com.thalesgroup.ccm.codegenerator.container.CommonServices
import com.thalesgroup.ccm.codegenerator.container.Utils
import com.thalesgroup.ccm.codegenerator.container.java.Names
import com.thalesgroup.ccm.codegenerator.container.java.COPIUtils
%>

<%script type="idlmm.InterfaceDef" name="javaFilePath" post="trim()"%>
<%generatedCOPIReceptaclePackage.replaceAll("\.", "/")%>/<%generatedCOPIReceptacleClassname%>.java


<%--
  -- Generation template  
  --%>
<%script type="idlmm.InterfaceDef" name="COPIReceptacle" file="<%javaFilePath%>"%>
<%copyrightHeader%>

package <%generatedCOPIReceptaclePackage%>;

import static cdmw.logging.Logger.*;
import static cdmw.logging.FunctionLogger.*;
import cdmw.orbsupport.ExceptionMinorCodes;

import org.omg.CORBA.Any;

public class <%generatedCOPIReceptacleClassname%> extends org.omg.CORBA.LocalObject
    implements <%equivalentLocalInterface%> {


    private String receptacle_name;
    
    private String component_identity;
    
    private org.omg.CORBA.Object facet_object;
    
    private cdmw.logging.Logger logger;
    
    private cdmw.ccm.cif.Context context;
    
        
    public <%generatedCOPIReceptacleClassname%>(String receptacle_name, String component_id,
            org.omg.CORBA.Object facet_object, cdmw.ccm.cif.Context ctx) {
        this.receptacle_name = receptacle_name;
        this.component_identity = component_id;
        this.facet_object = facet_object;
        this.logger = cdmw.ccm.common.CCMLoggers.GetCcmgeneratedLogger();
        this.context = ctx;
    }
    
    <%--
       Create operation declarations for attributes.
       NOTA: This should also include inherited attributes.
    --%>
    <%self.push()%>
    <%allAttributes.genAttributeOperations%>
    <%pop()%>
    
    <%--
       Create operation declarations.
       NOTA: This should also include inherited operations.
    --%>
    <%self.push()%>
    <%allOperations.genInterceptedOperationImpl%>
    <%pop()%>

}


<%script type="idlmm.AttributeDef" name="genAttributeOperations"%>
   <%-- REQUIRES parent interface in context
        (containingInterface cannot be used since
         attribute could come from an inherited interface) 
   --%>
public <%type.asReturnParameterDef%> <%name%>() {
    CDMW_LOG_FUNCTION(logger, "");

    <%peek.equivalentLocalInterface%> facetExec;
    try {
        facetExec = <%peek.equivalentLocalInterface%>Helper.narrow(this.facet_object);
    } catch (org.omg.CORBA.BAD_PARAM e) {
        CDMW_ERROR(logger,
            "The facet object has a wrong type",
            new Throwable());
        org.omg.CORBA.OBJECT_NOT_EXIST ex =
            new org.omg.CORBA.OBJECT_NOT_EXIST(
                ExceptionMinorCodes.OBJECT_NOT_EXIST,
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
        throw ex;
    }

    <%type.asLocalVariable%> __result =
        facetExec.<%name%>();

    return __result;
}

<%if (mode != "ATTR_READONLY"){%>
public void <%name%>(<%type.asInParameterDef%> <%name%>) {
    CDMW_LOG_FUNCTION(logger, "");

    <%peek.equivalentLocalInterface%> facetExec;
    try {
        facetExec = <%peek.equivalentLocalInterface%>Helper.narrow(this.facet_object);
    } catch (org.omg.CORBA.BAD_PARAM e) {
        CDMW_ERROR(logger,
            "The facet object has a wrong type",
            new Throwable());
        org.omg.CORBA.OBJECT_NOT_EXIST ex =
            new org.omg.CORBA.OBJECT_NOT_EXIST(
                ExceptionMinorCodes.OBJECT_NOT_EXIST,
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
        throw ex;
    }

    facetExec.<%name%>(<%name%>);
}
<%}%>



<%script type="idlmm.OperationDef" name="genInterceptedOperationImpl"%>
   <%-- REQUIRES parent interface in context
        (containingInterface cannot be used since
         attribute could come from an inherited interface) 
   --%>
public <%genOperationSignature%>
{
    CDMW_LOG_FUNCTION(logger, "");
    String feature_name = this.receptacle_name;
    org.omg.CORBA.Object target = this.facet_object;
    <%peek.asLocalVariable%> facetObject;
    java.lang.Exception thrownEx = null;
              
    <%genReceptacleInterceptionCode("facetObject")%>
}

     <%-- 
            <xsl:if test="not($returnType = 'void')">
               <xsl:value-of select="concat('request.add_return_value','(__result);',$lf)"/>
            </xsl:if>
            
         <xsl:for-each select="UML:BehavioralFeature.parameter/UML:Parameter[@kind = 'inout']">
               <xsl:value-of select="concat('request.add_inout_args_', @name,'(',@name,');', $lf)"/>
       </xsl:for-each>
       
        <xsl:for-each select="UML:BehavioralFeature.parameter/UML:Parameter[@kind = 'out']">
               <xsl:value-of select="concat('request.add_out_args_', @name,'(',@name,');', $lf)"/>
       </xsl:for-each>
         --%>
         
<%genRequestClass("cdmw.ccm.ccmcopi.ContainerStubRequest")%>


<%-- 
  -- Generate interception code.
  -- Required arguments:
  --   0 : name of the variable to delegate operation call
  --%>
<%script type="idlmm.OperationDef" name="genReceptacleInterceptionCode"%>
   <%-- REQUIRES parent interface in context
        (containingInterface cannot be used since
         attribute could come from an inherited interface) 
   --%>

<%if (! type.isVoid){%>
<%type.asLocalVariable%> __result = <%type.getInitValue%>;
<%}%>

<%generatedCOPIRequestClassname%> request = new <%generatedCOPIRequestClassname%>(feature_name, component_identity, target, context);

if (request.isReadWrite()){
    <%for (parameters[mode == "PARAM_IN"]){%>
    request.add_in_args_<%name%>(<%name%>);
    <%}%>
    <%for (parameters[mode == "PARAM_INOUT"]){%>
    request.add_inout_args_<%name%>(<%name%>.value);
    <%}%>
    <%for (parameters[mode == "PARAM_OUT"]){%>
    request.add_out_args_<%name%>(<%name%>.value);
    <%}%>

    <%for (exceptions){%>
    request.add_exception_<%name%>_tc();
    <%}%>
    
    <%if (!type.isVoid){%>
    request.add_result_value(__result);
    <%}%>

    request.preInvoke();
    request.invoke();
    request.postInvoke();

    <%genUnmarshallResultCode%>

} else {
    request.preInvoke();
    try {
        <%args(0)%> = <%peek.javaFullClassname%>Helper.narrow(target);
    } catch (org.omg.CORBA.BAD_PARAM e) {
        CDMW_ERROR(logger, 
            "The facet object has wrong type",
            new Throwable());
        org.omg.CORBA.OBJECT_NOT_EXIST ex =
            new org.omg.CORBA.OBJECT_NOT_EXIST(
                ExceptionMinorCodes.OBJECT_NOT_EXIST, 
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
        throw ex;
    }
    
    try {
        <%if (! type.isVoid){%>
        __result =
        <%}%>
        <%args(0)%>.<%name%>(<%parameters.name.sep(", ")%>);
    } catch(org.omg.CORBA.SystemException se){
        request.add_SystemException(se);
        thrownEx = se;
    <%for (exceptions){%>
    } catch (<%javaFullClassname%> e) {
        request.add_exception_<%name%>(e);
        thrownEx = e;
    <%}%>
    }

    request.postInvoke();
    if(thrownEx!=null) request.throw_exception(thrownEx);
         
} //end of else

<%if (! type.isVoid){%>
return __result;
<%}%>


