<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.java.JavaMappingServices
import com.thalesgroup.ccm.codegenerator.corba.Utils
import com.thalesgroup.ccm.codegenerator.corba.java.Utils
import com.thalesgroup.ccm.codegenerator.corba.java.BasicTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.java.ComplexTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.java.IDLTypeFallback
import com.thalesgroup.ccm.codegenerator.container.Utils
import com.thalesgroup.ccm.codegenerator.container.java.Names
import com.thalesgroup.ccm.codegenerator.container.java.SessionComponent
%>


<%script type="idlmm.ComponentDef" name="javaFilePath" post="trim()"%>
<%generatedServantPackage.replaceAll("\.", "/")%>/<%generatedExtensionServantClassname%>.java


<%--
  -- Generation template  
  --%>
<%script type="idlmm.ComponentDef" name="ExtensionComponent" file="<%javaFilePath%>"%>
<%copyrightHeader%>

package <%generatedServantPackage%>;

import cdmw.common.AlreadyDoneException;
import cdmw.common.InternalErrorException;
import cdmw.orbsupport.ExceptionMinorCodes;
import cdmw.ccm.cif.CCMObjectImpl;
import static cdmw.logging.Logger.*;
import static cdmw.logging.FunctionLogger.*;

/**
 * Extension component
 */

public class <%generatedExtensionServantClassname%> extends <%generatedSessionServantClassname%>
{

    public static final String COMP_REP_ID = "<%ID%>";
    
    public static final String COMP_NAME   = "<%name%>";
    

    /**
     * If a home, when creating a component, returns an EnterpriseComponent, we map it 
     * in an ExecutorLocator for code optimisation purpose. Thus the code is the same
     * for monolithic executor and segmented executor.
     */
    private class <%name%>ExecutorLocator 
        extends org.omg.CORBA.LocalObject
        implements org.omg.Components.ExecutorLocator, org.omg.Components.ExtensionComponent {

        /**
         * indicates that the component executor inherits from the ExtensionComponent local interface.
         */
        private boolean isExtensionComponent = false;

        /**
         * points on Component monolithic executor.
         */
        private <%equivalentLocalInterface%> compExecutor;
        
        /**
         * Logger to be used
         */
        private com.thalesgroup.CdmwLogging.Logger logger;
        
        public <%name%>ExecutorLocator(
            <%equivalentLocalInterface%> executor,
            com.thalesgroup.CdmwLogging.Logger logger) 
        {
            CDMW_LOG_FUNCTION(logger, "");
            this.logger = logger;
            this.compExecutor = executor;
            try  {
                org.omg.Components.ExtensionComponent extensionComp
                    = org.omg.Components.ExtensionComponentHelper.narrow(this.compExecutor);
            
                if (extensionComp != null) {
                    isExtensionComponent = true;
                }
            } catch (Exception e) {}
        }

        /**
         * the cif will invoke its obtain_executor operation prior to each invocation to
         * retrieve the implementation for a port. The port name, given in the name
         * parameter, is the same as used in the components interface description 
         * in IDL, or the components name for the main executor. The obtain_executor
         * operation returns a local object reference of the expected type. The 
         * CCMException exception may be raised in case of a system error that 
         * prohibits locating the requested executor.
         */
        //
        // IDL:omg.org/Components/ExecutorLocator/obtain_executor:1.0
        //
        public org.omg.CORBA.Object obtain_executor(String name)
            throws org.omg.Components.CCMException 
        {
            CDMW_LOG_FUNCTION(logger, "name="+name);
            String execName = name;
            org.omg.CORBA.Object result = null;

            if (execName.equals("<%name%>")) {
                result = this.compExecutor;
            }
            <%for (allProvidesPorts){%>
            else if (execName.equals("<%name%>")) {        
                result = this.compExecutor.get_<%name%>();
            }
            <%}%>
            <%for (allConsumesPorts){%>
            else if (execName.equals("<%name%>")) {        
                result = this.<%consumerExecutorName%>();
            }
            <%}%>
            else {
               org.omg.CORBA.BAD_PARAM ex = new org.omg.CORBA.BAD_PARAM(
                   ExceptionMinorCodes.BAD_PARAMInvalidExecutorName, 
                   org.omg.CORBA.CompletionStatus.COMPLETED_NO);
               CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
               throw ex;
            }

            return result;
        }

        /** 
         * The release_executor operation is called by the cif once the current
         * invocation on an executor that was obtained through the obtain_executor 
         * operation has finished. The locator can thus release any resources that
         * were acquired as part of the obtain_executor operation.
         */
        //
        // IDL:omg.org/Components/ExecutorLocator/release_executor:1.0
        //
        public void release_executor(org.omg.CORBA.Object exc) 
           throws org.omg.Components.CCMException 
        {
           CDMW_LOG_FUNCTION(logger, "");
        }

        /** 
         * The configuration_complete operation is called to propagate the
         * configuration_complete operation on the CCMObject interface to the
         * component implementation.
         */
        //
        // IDL:omg.org/Components/ExecutorLocator/configuration_complete:1.0
        //
        public void configuration_complete() 
            throws org.omg.Components.InvalidConfiguration {
            CDMW_LOG_FUNCTION(logger, "");
            // No equivalent operation for monolithic executor
        }
        
        //
        // IDL:omg.org/Components/ExtensionComponent/set_extension_context:1.0
        //
        public void set_extension_context(org.omg.Components.ExtensionContext ctx)
            throws org.omg.Components.CCMException {
            CDMW_LOG_FUNCTION(logger, "");
            // check if component implements the ExtensionComponent local interface
            if (isExtensionComponent) {
                CDMW_INFO(logger, "Call set_extension_context()", new Throwable());
                org.omg.Components.ExtensionComponent extensionComp =
                    org.omg.Components.ExtensionComponentHelper.narrow(this.compExecutor);
                extensionComp.set_extension_context(ctx);
            }
        }

        /**
         * The ccm_remove operation is called by the container when the servant is
         * about to be destroyed. It informs the component that it is about to be
         * destroyed.The component may raise the CCMException with the SYSTEM_ERROR
         * minor code to indicate a failure caused by a system level error.
         */
        //
        // IDL:omg.org/Components/ExtensionComponent/ccm_remove:1.0
        //
        public void ccm_remove() throws org.omg.Components.CCMException {
            CDMW_LOG_FUNCTION(logger, "");
            // check if component implements the ExtensionComponent local interface
            if (isExtensionComponent) {
                CDMW_INFO(logger, "Call ccm_remove()", new Throwable());
                org.omg.Components.ExtensionComponent extensionComp =
                    org.omg.Components.ExtensionComponentHelper.narrow(this.compExecutor);
               extensionComp.ccm_remove();
            }
        }
    
    } // end of class <%name%>ExecutorLocator
             
    /**
     * Attributes
     */
   
    /**
     * If a home, in creating a component, returns an ExecutorLocator, the cif
     * will invoke its obtain_executor operation prior to each invocation to
     * retrieve the implementation for a port. If the home returns an
     * EnterpriseComponent, we encapsulate it in an executor locator in order to
     * use same code.
     *
     */
   
    /**
     * <%name%> executor locator used to get component exec and facet exec
     */
    private org.omg.Components.ExecutorLocator executorLocator;
    
    /**
     * executor locator must an extension component 
     */
    private org.omg.Components.ExtensionComponent extensionLocator;
    
    // set to true when component is activated
    boolean isActivated;
    
    /**
     * <%name%> context executor
     */
    private <%generatedExtensionContextInterface%> contextExecutor;
   
    /**
     * Logger for logging
     */
    private com.thalesgroup.CdmwLogging.Logger logger;
     
    /**
     * Indicates if current component has been created via a factory operation
     */
    private boolean isCreatedByFactoryOperation;
        
    
    /**
     * Constructor
     */
    public <%generatedExtensionServantClassname%>(
        String compOid,
        cdmw.ccm.cif.Context ctx,
        org.omg.CORBA.Object compRef,
        org.omg.Components.EnterpriseComponent executor,
        com.thalesgroup.CdmwLifeCycle.ObjectRegistration objectRegistration,
        com.thalesgroup.CdmwLogging.LoggerFactory loggerFactory,
        boolean isCreatedByFactoryOperation)
        throws org.omg.Components.CCMException 
    {
        super(compOid, ctx, compRef, executor, objectRegistration,
              loggerFactory, isCreatedByFactoryOperation);
        
        this.logger = loggerFactory.get_logger(
            cdmw.ccm.common.CCMLoggers.CCMGENERATED_LOG_DOMAIN);
        
        CDMW_LOG_FUNCTION(logger, "");
        
        //this.isActivated = false;
        this.isCreatedByFactoryOperation = isCreatedByFactoryOperation;

        // Check if the home returns an executor locator
        try {
            this.executorLocator = org.omg.Components.ExecutorLocatorHelper.narrow(executor);
            this.extensionLocator = org.omg.Components.ExtensionComponentHelper.narrow(this.executorLocator);

            if (this.extensionLocator == null) {
                System.err.println("Executor Locator should be a extension component!");
                throw new org.omg.CORBA.BAD_PARAM(
                    ExceptionMinorCodes.BAD_PARAMInvalidComponentExecutor,
                    org.omg.CORBA.CompletionStatus.COMPLETED_NO);
            }
        } catch(org.omg.CORBA.BAD_PARAM bp) {
            // executor is not an executor locator
            // map monolithic executor to executor locator
            <%equivalentLocalInterface%> compExec = <%equivalentLocalInterface%>Helper.narrow(executor);
        
            if (compExec == null) {
                CDMW_ERROR(logger, "Invalid Component Executor", new Throwable());
                org.omg.CORBA.BAD_PARAM ex = new org.omg.CORBA.BAD_PARAM(
                    ExceptionMinorCodes.BAD_PARAMInvalidComponentExecutor,
                    org.omg.CORBA.CompletionStatus.COMPLETED_NO);
                CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
            }
            this.executorLocator = 
                new <%name%>ExecutorLocator(compExec, this.logger);
            this.extensionLocator = 
                org.omg.Components.ExtensionComponentHelper.narrow(this.executorLocator);
         
            if (this.extensionLocator == null) {
                CDMW_ERROR(logger, "Executor Locator should be a extension component!", new Throwable());
                org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
                    ExceptionMinorCodes.INTERNALInvalidExecutor,
                    org.omg.CORBA.CompletionStatus.COMPLETED_NO);
                CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
            }            
        }

        this.contextExecutor = new <%generatedExtensionContextClassname%>(ctx.get_ccm_context(), this, loggerFactory);
        this.extensionLocator.set_extension_context(this.contextExecutor);
    
        CDMW_LOG_FUNCTION_RETURN(logger, "");
    } 
    
    
    /**
     * Inherited CCMObject interface implemented by CCMObjectImpl
     */

    public void configuration_complete()
        throws org.omg.Components.InvalidConfiguration {
      
        CDMW_LOG_FUNCTION(logger, "");
      
        if (!is_configured()) {
            super.configuration_complete();
            this.executorLocator.configuration_complete();
        }
    }
    
    /**
     * In case of a extension component, this operation will call 
     * it's executor's ccm_remove operation.
     *
     *@exception org.omg.Components.CCMException Any CCMException thrown by the
     * executor's ccm_remove operation.
     *@exception org.omg.CORBA.SystemException Any SystemException thrown by the
     * executor's ccm_remove operation.
     */ 
    public void ccm_remove() 
        throws org.omg.Components.CCMException, 
               org.omg.CORBA.SystemException
    {
        // this is a extension component, call ccm_remove
        this.extensionLocator.ccm_remove();
    }
    
}


