<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.ccm.codegenerator.corba.java.JavaMappingServices
import com.thalesgroup.ccm.codegenerator.corba.Utils
import com.thalesgroup.ccm.codegenerator.corba.java.Utils
import com.thalesgroup.ccm.codegenerator.corba.java.BasicTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.java.ComplexTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.java.IDLTypeFallback
import com.thalesgroup.ccm.codegenerator.container.Utils
import com.thalesgroup.ccm.codegenerator.container.java.Names
import com.thalesgroup.ccm.codegenerator.container.java.COPIUtils
%>


<%script type="idlmm.ComponentDef" name="javaFilePath" post="trim()"%>
<%generatedServantPackage.replaceAll("\.", "/")%>/<%generatedSessionServantClassname%>.java


<%--
  -- Generation template  
  --%>
<%script type="idlmm.ComponentDef" name="SessionComponent" file="<%javaFilePath%>"%>
<%copyrightHeader%>

package <%generatedServantPackage%>;

import cdmw.common.AlreadyDoneException;
import cdmw.common.InternalErrorException;
import cdmw.orbsupport.ExceptionMinorCodes;
import cdmw.ccm.cif.CCMObjectImpl;
import static cdmw.logging.Logger.*;
import static cdmw.logging.FunctionLogger.*;
import org.omg.CORBA.Any;
import org.omg.CORBA.CompletionStatus;

/**
 * Session component
 */

public class <%generatedSessionServantClassname%> extends CCMObjectImpl
    implements <%equivalentInterface%>Operations
{

    public static final String COMP_REP_ID = "<%ID%>";
    
    public static final String COMP_NAME   = "<%name%>";
    
    <%--
       Ports constants
    --%>
    <%allProvidesPorts.genPortConstantsDef%>
    <%allUsesPorts.genPortConstantsDef%>
    <%allPublishesPorts.genPortConstantsDef%>
    <%allEmitsPorts.genPortConstantsDef%>
    <%allConsumesPorts.genPortConstantsDef%>
    
    /**
     * If a home, when creating a component, returns an EnterpriseComponent, we map it 
     * in an ExecutorLocator for code optimisation purpose. Thus the code is the same
     * for monolithic executor and segmented executor.
     */
    private class <%name%>ExecutorLocator 
        extends org.omg.CORBA.LocalObject
        implements com.thalesgroup.CdmwCcmCif.SessionExecutorLocator {

        /**
         * indicates that the component executor inherits from the SessionComponent local interface.
         */
        private boolean isSessionComponent = false;

        /**
         * points on Component monolithic executor.
         */
        private <%equivalentLocalInterface%> compExecutor;
        
        /**
         * Logger to be used
         */
        private com.thalesgroup.CdmwLogging.Logger logger;
        
        <%--
          -- Generate consumer executors
          --%>
          
        <%allConsumesPorts.genConsumerExecutor%>
        
        
        public <%name%>ExecutorLocator(
            <%equivalentLocalInterface%> executor,
            com.thalesgroup.CdmwLogging.Logger logger) 
        {
            CDMW_LOG_FUNCTION(logger, "");
            this.logger = logger;
            this.compExecutor = executor;
            try  {
                org.omg.Components.SessionComponent sessionComp
                    = org.omg.Components.SessionComponentHelper.narrow(this.compExecutor);
            
                if (sessionComp != null) {
                    isSessionComponent = true;
                }
            } catch (Exception e) {}
        }

        /**
         * the cif will invoke its obtain_executor operation prior to each invocation to
         * retrieve the implementation for a port. The port name, given in the name
         * parameter, is the same as used in the components interface description 
         * in IDL, or the components name for the main executor. The obtain_executor
         * operation returns a local object reference of the expected type. The 
         * CCMException exception may be raised in case of a system error that 
         * prohibits locating the requested executor.
         */
        //
        // IDL:omg.org/Components/ExecutorLocator/obtain_executor:1.0
        //
        public org.omg.CORBA.Object obtain_executor(String name)
            throws org.omg.Components.CCMException 
        {
            CDMW_LOG_FUNCTION(logger, "name="+name);
            String execName = name;
            org.omg.CORBA.Object result = null;

            if (execName.equals("<%name%>")) {
                result = this.compExecutor;
            }
            <%for (allProvidesPorts){%>
            else if (execName.equals(<%portNameConstName%>)) {        
                result = this.compExecutor.get_<%name%>();
            }
            <%}%>
            <%for (allConsumesPorts){%>
            else if (execName.equals(<%portNameConstName%>)) {        
                result = this.<%consumerExecutorName%>;
            }
            <%}%>
            else {
               org.omg.CORBA.BAD_PARAM ex = new org.omg.CORBA.BAD_PARAM(
                   ExceptionMinorCodes.BAD_PARAMInvalidExecutorName, 
                   org.omg.CORBA.CompletionStatus.COMPLETED_NO);
               CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
               throw ex;
            }

            return result;
        }

        /** 
         * The release_executor operation is called by the cif once the current
         * invocation on an executor that was obtained through the obtain_executor 
         * operation has finished. The locator can thus release any resources that
         * were acquired as part of the obtain_executor operation.
         */
        //
        // IDL:omg.org/Components/ExecutorLocator/release_executor:1.0
        //
        public void release_executor(org.omg.CORBA.Object exc) 
           throws org.omg.Components.CCMException 
        {
           CDMW_LOG_FUNCTION(logger, "");
        }

        /** 
         * The configuration_complete operation is called to propagate the
         * configuration_complete operation on the CCMObject interface to the
         * component implementation.
         */
        //
        // IDL:omg.org/Components/ExecutorLocator/configuration_complete:1.0
        //
        public void configuration_complete() 
            throws org.omg.Components.InvalidConfiguration {
            CDMW_LOG_FUNCTION(logger, "");
            // No equivalent operation for monolithic executor
        }
        
        //
        // IDL:omg.org/Components/SessionComponent/set_session_context:1.0
        //
        public void set_session_context(org.omg.Components.SessionContext ctx)
            throws org.omg.Components.CCMException {
            CDMW_LOG_FUNCTION(logger, "");
            // check if component implements the SessionComponent local interface
            if (isSessionComponent) {
                CDMW_INFO(logger, "Call set_session_context()", new Throwable());
                org.omg.Components.SessionComponent sessionComp 
                    = org.omg.Components.SessionComponentHelper.narrow(this.compExecutor);
                sessionComp.set_session_context(ctx);
            }
        }

        /** 
         * The ccm_activate operation is called by the container to notify a 
         * session component that it has been made active. The component instance
         * should perform any initialization required prior to operation invocation.
         * The component may raise the CCMException with the SYSTEM_ERROR minor code
         * to indicate a failure caused by a system level error.
         */
        //
        // IDL:omg.org/Components/SessionComponent/ccm_activate:1.0
        //
        public void ccm_activate() throws org.omg.Components.CCMException {
            CDMW_LOG_FUNCTION(logger, "");
            // check if component implements the SessionComponent local interface
            if (isSessionComponent) {
                CDMW_INFO(logger, "Call ccm_activate()", new Throwable());
                org.omg.Components.SessionComponent sessionComp 
                    = org.omg.Components.SessionComponentHelper.narrow(this.compExecutor);
                sessionComp.ccm_activate();
            }
        }

        /** 
         * The ccm_passivate operation is called by the container to notify a session
         * component that it has been made inactive. The component instance should
         * release any resources it acquired at activation time.The component may 
         * raise the CCMException with the SYSTEM_ERROR minor code to indicate a 
         * failure caused by a system level error.
         */
        //
        // IDL:omg.org/Components/SessionComponent/ccm_passivate:1.0
        //
        public void ccm_passivate() throws org.omg.Components.CCMException {
            CDMW_LOG_FUNCTION(logger, "");
            // check if component implements the SessionComponent local interface
            if (isSessionComponent) {
                CDMW_INFO(logger, "Call ccm_passivate()", new Throwable());
                org.omg.Components.SessionComponent sessionComp 
                    = org.omg.Components.SessionComponentHelper.narrow(this.compExecutor);
                sessionComp.ccm_passivate();
            }
        }

        /**
         * The ccm_remove operation is called by the container when the servant is
         * about to be destroyed. It informs the component that it is about to be
         * destroyed.The component may raise the CCMException with the SYSTEM_ERROR
         * minor code to indicate a failure caused by a system level error.
         */
        //
        // IDL:omg.org/Components/SessionComponent/ccm_remove:1.0
        //
        public void ccm_remove() throws org.omg.Components.CCMException {
            CDMW_LOG_FUNCTION(logger, "");
            // check if component implements the SessionComponent local interface
            if (isSessionComponent) {
                CDMW_INFO(logger, "Call ccm_remove()", new Throwable());
                org.omg.Components.SessionComponent sessionComp 
                    = org.omg.Components.SessionComponentHelper.narrow(this.compExecutor);
                sessionComp.ccm_remove();
            }
        }
    
    } // end of class <%name%>ExecutorLocator
             
    /**
     * Attributes
     */
   
    /**
     * If a home, in creating a component, returns an ExecutorLocator, the cif
     * will invoke its obtain_executor operation prior to each invocation to
     * retrieve the implementation for a port. If the home returns an
     * EnterpriseComponent, we encapsulate it in an executor locator in order to
     * use same code.
     *
     */
   
    /**
     * <%name%> executor locator used to get component exec and facet exec
     */
    private org.omg.Components.ExecutorLocator executorLocator;
    
    /**
     * executor locator must a session component to be advise 
     * of its activation, passivation and removal
     */
    private org.omg.Components.SessionComponent sessionLocator;

    // set to true when component is activated
    boolean isActivated;
    
    /**
     * <%name%> context executor
     */
    private <%generatedSessionContextInterface%> contextExecutor;
   
    /**
     * Logger for logging
     */
    private com.thalesgroup.CdmwLogging.Logger logger;
     
    /**
     * Indicates if current component has been created via a factory operation
     */
    private boolean isCreatedByFactoryOperation;
    
    <%if (allSupportedInterfaces.nSize > 0){%>
    /**
     * the COPI-enabled implementation of all supported interfaces
     */
    private InterceptedSupportedInterfacesImpl interceptedSupportedInterfacesImpl;
    <%}%>
    
    <%for (allAttributes[mode != "ATTR_READONLY"]){%>
    private boolean is<%name%>Configured = false;
    <%}%>
    
    
    /**
     * Constructor
     */
    public <%generatedSessionServantClassname%>(
        String compOid,
        cdmw.ccm.cif.Context ctx,
        org.omg.CORBA.Object compRef,
        org.omg.Components.EnterpriseComponent executor,
        com.thalesgroup.CdmwLifeCycle.ObjectRegistration objectRegistration,
        com.thalesgroup.CdmwLogging.LoggerFactory loggerFactory,
        boolean isCreatedByFactoryOperation)
        throws org.omg.Components.CCMException 
    {
        super(compOid, ctx, COMP_REP_ID, compRef, objectRegistration, loggerFactory);
        
        this.logger = loggerFactory.get_logger(
            cdmw.ccm.common.CCMLoggers.CCMGENERATED_LOG_DOMAIN);
        
        CDMW_LOG_FUNCTION(logger, "");
        
        this.isActivated = false;
        this.isCreatedByFactoryOperation = isCreatedByFactoryOperation;
        <%if (allSupportedInterfaces.nSize > 0){%>
        this.interceptedSupportedInterfacesImpl = new InterceptedSupportedInterfacesImpl(this.context, this, logger); 
        <%}%>
        // Check if the home returns an executor locator
        try {
            this.executorLocator = org.omg.Components.ExecutorLocatorHelper.narrow(executor);
            this.sessionLocator = org.omg.Components.SessionComponentHelper.narrow(this.executorLocator);

            if (this.sessionLocator == null) {
                System.err.println("Executor Locator should be a session component!");
                throw new org.omg.CORBA.BAD_PARAM(
                  ExceptionMinorCodes.BAD_PARAMInvalidComponentExecutor,
                  org.omg.CORBA.CompletionStatus.COMPLETED_NO);
            }
        } catch(org.omg.CORBA.BAD_PARAM bp) {
            // executor is not an executor locator
            // map monolithic executor to executor locator
            <%equivalentLocalInterface%> compExec = <%equivalentLocalInterface%>Helper.narrow(executor);
        
            if (compExec == null) {
                CDMW_ERROR(logger, "Invalid Component Executor", new Throwable());
                org.omg.CORBA.BAD_PARAM ex = new org.omg.CORBA.BAD_PARAM(
                    ExceptionMinorCodes.BAD_PARAMInvalidComponentExecutor,
                    org.omg.CORBA.CompletionStatus.COMPLETED_NO);
                CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
            }
            this.executorLocator = 
                new <%name%>ExecutorLocator(compExec, this.logger);
            this.sessionLocator = 
                org.omg.Components.SessionComponentHelper.narrow(this.executorLocator);
         
            if (this.sessionLocator == null) {
                CDMW_ERROR(logger, "Executor Locator should be a session component!", new Throwable());
                org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
                    ExceptionMinorCodes.INTERNALInvalidExecutor,
                    org.omg.CORBA.CompletionStatus.COMPLETED_NO);
                CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
            }            
        }

        this.contextExecutor = new <%generatedSessionContextClassname%>(ctx.get_ccm_context(), this, loggerFactory);
        this.sessionLocator.set_session_context(this.contextExecutor);
    
        <%-- facets declarations --%>
        
        <%allProvidesPorts.genProvidesDeclaration%>
        
        <%-- receptacles declarations --%>
        <%if (allUsesPorts.nSize > 0){%>
        try {
            <%for (allUsesPorts){%>
            declare_receptacle(<%portNameConstName%>, <%portRepIdConstName%>);
            <%}%>
        } catch (AlreadyDoneException ade) {
            CDMW_ERROR(logger, "Receptacle already declared!", new Throwable());
            // Don't propagate while its probably a code generation error!
        <%-- //TODO: remove this catch statement if not needed
        } catch (InternalErrorException iee) {
            System.err.println("Internal exception raised when declaring receptacle!");
            throw new org.omg.CORBA.INTERNAL(
                ExceptionMinorCodes.INTERNAL, 
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        --%>
        } catch (org.omg.CORBA.SystemException se) {
            CDMW_ERROR(logger, 
                "System exception raised when declaring receptacle!" + se.toString(),
                new Throwable());
            org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
               ExceptionMinorCodes.INTERNAL, 
               org.omg.CORBA.CompletionStatus.COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
            throw ex;
        }
        <%}%>
        
        <%-- publishers & emitters declarations --%>
        <%if (allPublishesPorts.nSize > 0 || allEmitsPorts.nSize > 0){%>
        try {
            <%for (allPublishesPorts){%>
            declare_publisher(<%portNameConstName%>, <%portRepIdConstName%>);
            <%}%>
            <%for (allEmitsPorts){%>
            declare_emitter(<%portNameConstName%>, <%portRepIdConstName%>);
            <%}%>
        } catch (AlreadyDoneException ade) {
            CDMW_ERROR(logger, "Event source already declared!", new Throwable());
            // Don't propagate while its probably a code generation error!
        } catch (org.omg.CORBA.SystemException se) {
            CDMW_ERROR(logger, 
                "System exception raised when declaring event source: " + se,
                new Throwable());
            org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
                ExceptionMinorCodes.INTERNAL, 
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
            throw ex;
        }
        <%}%>
        
        <%-- consumers declarations --%>
        <%if (allConsumesPorts.nSize > 0){%>
        try {
            <%for (allConsumesPorts){%>
            declare_consumer(compOid, <%portNameConstName%>, <%portRepIdConstName%>);
            <%}%>
        } catch (AlreadyDoneException ade) {
            CDMW_ERROR(logger, "Consumer already declared!", new Throwable());
            // Don't propagate while its probably a code generation error!
        } catch (InternalErrorException iee) {
            CDMW_ERROR(logger, "Internal exception raised when declaring consumer!", new Throwable());
            throw new org.omg.CORBA.INTERNAL(
                ExceptionMinorCodes.INTERNAL, 
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        } catch (org.omg.CORBA.SystemException se) {
            CDMW_ERROR(logger, "System exception raised when declaring consumer: " + se, new Throwable());
            org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
                ExceptionMinorCodes.INTERNAL, 
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
            throw ex;
        }
        <%}%>
        
        CDMW_LOG_FUNCTION_RETURN(logger, "");
    } 
    
    /**
     * Component attributes
     */
    <%self.push()%>
    <%allAttributes.genAttributeOperations.sep("\n\n")%>
    <%pop()%>
    

    /**
     * Supported interfaces
     */
    <%self.push%>
    <%allSupportedInterfaces.operations.genOperationImpl.sep("\n\n")%>
    <%pop()%>

    /**
     * Equivalent IDL methods
     */

    // Facets
    <%allProvidesPorts.genEquivalentOperations.sep("\n\n")%>

    // Receptacles
    <%allUsesPorts.genEquivalentOperations.sep("\n\n")%>

    // Consumers
    <%allConsumesPorts.genEquivalentOperations.sep("\n\n")%>

    // Publishers
    <%allPublishesPorts.genEquivalentOperations.sep("\n\n")%>

    // Emitters
    <%allEmitsPorts.genEquivalentOperations.sep("\n\n")%>
    
    
    /**
     * Inherited CCMObject interface implemented by CCMObjectImpl
     */

    public void configuration_complete()
        throws org.omg.Components.InvalidConfiguration {
      
        CDMW_LOG_FUNCTION(logger, "");
      
        if (!is_configured()) {
            if (!this.isCreatedByFactoryOperation) {
                CDMW_DEBUG(logger, "Check if configuration is complete", new Throwable());
    
                <%allAttributes[mode != "ATTR_READONLY"].genAttributeInitCheck%>
            }
            super.configuration_complete();
        
            try {
                this.executorLocator.configuration_complete();
             
                // change state
                this.state = this.state.configuration_complete(this);
             
                // no error occurs component is activated
                this.isActivated = true;
            } catch(org.omg.Components.CCMException ccme) {
                CDMW_DEBUG(logger, 
                    "CCMException raised, reason: " + ccme.toString(),
                    new Throwable());
                org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
                    ExceptionMinorCodes.INTERNAL,
                    org.omg.CORBA.CompletionStatus.COMPLETED_NO);
                CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
               throw ex;
           }
        }
    }
    
    /**
     * Inherited Events interface implemented by CCMObjectImpl
     */

    /**
     * This returns the servant for the facet specified by facetName.
     * This operation is implemented by the well typed component servant.
     *
     * @param facetName The facet name
     *
     * @return the facet servant.
     */
    <%if ((allProvidesPorts.nSize > 0) || (allConsumesPorts.nSize > 0)){%>
    public org.omg.PortableServer.Servant get_facet_servant(String facetName) {
        CDMW_LOG_FUNCTION(logger, "facetName="+facetName);
         
        String facet = facetName;
        org.omg.PortableServer.Servant facetServant = null;
        
        <%for (allProvidesPorts){%>
        if (facet.equals(<%portNameConstName%>)) {
            if(cdmw.ccm.ccmcopi.COPIServiceInit.isInitialized()){
                facetServant = new <%interface_type.generatedCOPIFacetServantFullClassname%>(
                    this.executorLocator, 
                    <%portNameConstName%>,
                    this.context,
                    this,
                    this.logger,
                    this.get_component_identity()); 
            } else {
                facetServant = new <%interface_type.generatedFacetServantFullClassname%>(
                    this.executorLocator, 
                    <%portNameConstName%>,
                    this.context,
                    this,
                    this.logger);
            }
        } 
        else 
        <%}%>
        <%for (allConsumesPorts){%>
           if (facet.equals(<%portNameConstName%>)) {
            facetServant = new <%event.generatedConsumerFullClassname%>(
                this.executorLocator, 
                <%portNameConstName%>,
                this.context,
                this,
                this.logger);
        }
        else
        <%}%>
        {
            // No facet/consumer with this name define for that component
            CDMW_ERROR(logger, 
                "No '" + facetName + 
                "' facet or consumer defined for this component",
                new Throwable());
            org.omg.CORBA.OBJECT_NOT_EXIST ex = new org.omg.CORBA.OBJECT_NOT_EXIST(
                ExceptionMinorCodes.OBJECT_NOT_EXIST,
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
            throw ex;
        }
          
        return facetServant;
    }        
    
    <%}else{%>
    public org.omg.PortableServer.Servant get_facet_servant(String facetName) {
        CDMW_LOG_FUNCTION(logger, "facetName="+facetName);
        // No facet with this name define for that component
        CDMW_ERROR(logger, 
            "No '" + facetName + 
            "' facet or consumer defined for this component",
            new Throwable());
        org.omg.CORBA.OBJECT_NOT_EXIST ex = new org.omg.CORBA.OBJECT_NOT_EXIST(
            ExceptionMinorCodes.OBJECT_NOT_EXIST,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO); 
        CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
        throw ex;
    }
    <%}%>
    
    /**
     * In case of a session component, this operation will call 
     * it's executor's ccm_activate operation.
     *
     *@exception org.omg.Components.CCMException Any CCMException thrown by the
     * executor's ccm_activate operation.
     *@exception org.omg.CORBA.SystemException Any SystemException thrown by the
     * executor's ccm_activate operation.
     */ 
    public void ccm_activate() 
        throws org.omg.Components.CCMException, 
               org.omg.CORBA.SystemException
    {
        // this is a session component, call ccm_activate
        this.sessionLocator.ccm_activate();
    }
    
    /**
     * In case of a session component, this operation will call 
     * it's executor's ccm_passivate operation.
     *
     *@exception org.omg.Components.CCMException Any CCMException thrown by the
     * executor's ccm_passivate operation.
     *@exception org.omg.CORBA.SystemException Any SystemException thrown by the
     * executor's ccm_passivate operation.
     */ 
    public void ccm_passivate() 
        throws org.omg.Components.CCMException, 
               org.omg.CORBA.SystemException
    {
        // this is a session component, call ccm_passivate
        this.sessionLocator.ccm_passivate();
    }

    /**
     * In case of a session component, this operation will call 
     * it's executor's ccm_remove operation.
     *
     *@exception org.omg.Components.CCMException Any CCMException thrown by the
     * executor's ccm_remove operation.
     *@exception org.omg.CORBA.SystemException Any SystemException thrown by the
     * executor's ccm_remove operation.
     */ 
    public void ccm_remove() 
        throws org.omg.Components.CCMException, 
               org.omg.CORBA.SystemException
    {
        // this is a session component, call ccm_remove
        this.sessionLocator.ccm_remove();
    }

    // return true if configuration complete has already been called
    protected boolean is_configured() {
        return this.state == 
            cdmw.ccm.cif.DefaultCCMObjectStates.CCM_OBJECT_STATE_FULLY_ACTIVATED;
    }   
    

    // Return the component executor
    protected <%equivalentLocalInterface%> obtain_component_executor() {
        CDMW_LOG_FUNCTION(logger, "");
        org.omg.CORBA.Object obj = null;
        try {
            obj = this.executorLocator.obtain_executor(COMP_NAME);
         
            if (obj == null) {
                CDMW_ERROR(logger, "Component executor is nil", new Throwable());
                org.omg.CORBA.OBJECT_NOT_EXIST ex = new org.omg.CORBA.OBJECT_NOT_EXIST(
                    ExceptionMinorCodes.OBJECT_NOT_EXISTInvalidExecutor,
                    org.omg.CORBA.CompletionStatus.COMPLETED_NO);
                CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
                throw ex;
            }

            <%equivalentLocalInterface%> compExec = <%equivalentLocalInterface%>Helper.narrow(obj);

            if (compExec == null) {
                CDMW_ERROR(logger, 
                   "Component executor is not a <%equivalentLocalInterface%>",
                   new Throwable());
                org.omg.CORBA.OBJECT_NOT_EXIST ex = new org.omg.CORBA.OBJECT_NOT_EXIST(
                   ExceptionMinorCodes.OBJECT_NOT_EXISTInvalidExecutor, 
                   org.omg.CORBA.CompletionStatus.COMPLETED_NO);
                CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
                throw ex;
            }

            return compExec;
        } catch(org.omg.Components.CCMException ccme) {
            CDMW_ERROR(logger, 
                "CCMException raised, reason: " + ccme.toString(), 
                new Throwable());
            org.omg.CORBA.OBJECT_NOT_EXIST ex = new org.omg.CORBA.OBJECT_NOT_EXIST(
                ExceptionMinorCodes.OBJECT_NOT_EXISTInvalidExecutor,
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
            throw ex;
        } catch(org.omg.CORBA.BAD_PARAM bp) {
            CDMW_ERROR(logger, 
                "CORBA::BAD_PARAM obtaining component executor", 
                new Throwable());
            org.omg.CORBA.OBJECT_NOT_EXIST ex = new org.omg.CORBA.OBJECT_NOT_EXIST(
                ExceptionMinorCodes.OBJECT_NOT_EXISTInvalidExecutor,
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
            throw ex;
        }
    }
   
    // Change state to REMOVED; this will call ccm_passivate and ccm_remove on executor
    protected void advise_executor_of_remove_component() {
        CDMW_LOG_FUNCTION(logger, "");

        try {
            this.state = this.state.remove(this);
        } catch(org.omg.Components.CCMException ccme) {
            CDMW_ERROR(logger, "CCMException raised, reason: " + ccme, new Throwable());
            org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
                ExceptionMinorCodes.INTERNAL,
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
            throw ex;
        }
    }
   

    /**
     * This returns the local object for the receptacle specified by receptacle_name.
     * This operation is implemented by the well typed component servant.
     *
     * @param receptacle_name The Receptacle name
     * @param facet_object The remote facet reference 
     *
     * @return the receptacle local object or null if the component has no receptacles.
     */
    public org.omg.CORBA.LocalObject get_receptacle_object(String receptacle_name, 
        org.omg.CORBA.Object facet_object) 
    {
        CDMW_LOG_FUNCTION(logger, "receptacle name="+receptacle_name);
        org.omg.CORBA.LocalObject obj=null;
             
        <%if (allUsesPorts.nSize > 0){%>
        String component_id = get_component_identity();
        <%for (allUsesPorts){%>
        if(<%portNameConstName%>.equals(receptacle_name))
        {
            obj = new <%interface_type.generatedCOPIReceptacleFullClassname%>(receptacle_name, component_id,facet_object, this.context);
        }
        else
        <%}%>
        {
            CDMW_ERROR(logger, 
                "No '" + receptacle_name + "' receptacle defined for this component");
        }
        <%}else{%>
        CDMW_DEBUG(logger,"This component has no receptacles");  
        <%}%>
        return obj;
    }


    <%if (allSupportedInterfaces.nSize > 0){%>
    /**
     * COPI-enabled implementation of supported interfaces
     *
     */
    class InterceptedSupportedInterfacesImpl {
                    
        private <%generatedSessionServantClassname%> compServant;
        private com.thalesgroup.CdmwLogging.Logger logger;
        private cdmw.ccm.cif.Context context;
                    
        public InterceptedSupportedInterfacesImpl(cdmw.ccm.cif.Context context, 
            <%generatedSessionServantClassname%> component,
            com.thalesgroup.CdmwLogging.Logger logger)
        {
            this.compServant = component;
            this.logger = logger;
            this.context = context;
        }
    
        <%self.push()%>
        <%allSupportedInterfaces.operations.genInterceptedOperation%>
        <%pop()%>
    }  // end of InterceptedSupportedInterfacesImpl class
    <%}%>
}




<%script type="idlmm.ComponentPortDef" name="genPortConstantsDef"%>
public static final String <%portNameConstName%> = "<%name%>";
public static final String <%portRepIdConstName%> = "<%portTypeID%>";
    


<%script type="idlmm.ComponentPortDef" name="portNameConstName" post="trim()"%>
    <%portTypeConst%>_<%name.toUpperCase%>_NAME
    
<%script type="idlmm.ComponentPortDef" name="portRepIdConstName" post="trim()"%>
    <%portTypeConst%>_<%name.toUpperCase%>_REP_ID
    
    
<%script type="idlmm.InterfacePortDef" name="portTypeID" post="trim()"%>
    <%-- For provides and uses ports, 
         RepositoryId is the one of the interface type.
    --%>
    <%interface_type.ID%>
    
<%script type="idlmm.EmitsDef" name="portTypeID" post="trim()"%>
    <%-- For emits and publishes ports,
         RepositoryId is the one of the generated Consumer
         (<event_type_name>Consumer)
    --%>
    <%event.ID.replaceFirst(":1.0", "Consumer:1.0")%>
    
<%script type="idlmm.PublishesDef" name="portTypeID" post="trim()"%>
    <%-- For emits and publishes ports,
         RepositoryId is the one of the generated Consumer
         (<event_type_name>Consumer)
    --%>
    <%event.ID.replaceFirst(":1.0", "Consumer:1.0")%>
    
<%script type="idlmm.ConsumesDef" name="portTypeID" post="trim()"%>
    <%-- For consumes ports,
         RepositoryId is the one of Consumer class generated by Cardamom
         (com.thalesgroup.Cdmw_<scoped_event_type_name>Consumer)
    --%>
    IDL:<%generatedPrefix%>/Cdmw_<%event.absoluteName.replaceFirst("::", "").replaceAll("::", "/")%>Consumer:1.0
    
<%script type="idlmm.ComponentPortDef" name="portTypeID" post="trim()"%>
    <%-- fallback script, should not be called --%>
    UNKOWN_PORTTYPE_ERROR!!
    
    
<%script type="idlmm.ProvidesDef" name="portTypeConst" post="trim()"%>
    FACET
<%script type="idlmm.UsesDef" name="portTypeConst" post="trim()"%>
    RECEP
<%script type="idlmm.EmitsDef" name="portTypeConst" post="trim()"%>
    EMITTER
<%script type="idlmm.PublishesDef" name="portTypeConst" post="trim()"%>
    PUBLISHER
<%script type="idlmm.ConsumesDef" name="portTypeConst" post="trim()"%>
    CONSUMER
<%script type="idlmm.ComponentPortDef" name="portTypeConst" post="trim()"%>
    <%-- fallback script, should not be called --%>
    UNKOWN_PORTTYPE_ERROR!!



<%-- this template is used to generate the consumer executors classes --%>
<%script type="idlmm.ConsumesDef" name="genConsumerExecutor"%>
/**
 * the <%event.javaFullClassname%> consumer executor class 
 */
private <%consumerExecutorClassname%> <%consumerExecutorName%> = new <%consumerExecutorClassname%>();
private class <%consumerExecutorClassname%> extends org.omg.CORBA.LocalObject
    implements <%event.equivalentLocalConsumer%> {

    public <%consumerExecutorClassname%>() {
    }
    
    public void push(<%event.asInParameterDef%> event)
    {
        CDMW_LOG_FUNCTION(logger, "");
        push_<%name%>(event);
    }

    private void push_<%name%>(<%event.asInParameterDef%> event) {
        CDMW_LOG_FUNCTION(logger, "");
        compExecutor.push_<%name%>(event);
    }

}
    
    
<%script type="idlmm.ConsumesDef" name="consumerExecutorClassname" post="trim()"%>
    <%name.toU1Case%>ConsumerExecutorImpl
<%script type="idlmm.ConsumesDef" name="consumerExecutorName" post="trim()"%>
    <%name%>ConsumerExecutor
    
    
    
<%script type="idlmm.ProvidesDef" name="genProvidesDeclaration"%>
try {
    org.omg.CORBA.Object <%name%>_facet
        = declare_facet(compOid, 
                        <%portNameConstName%>, 
                        <%portRepIdConstName%>);
                         
    if (<%name%>_facet == null) {
        CDMW_ERROR(logger, 
            "Internal exception raised when declaring facet <%name%>!",
            new Throwable());
        org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNAL, 
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
        throw ex;
    }
} catch (AlreadyDoneException ade) {
    CDMW_ERROR(logger, "Facet <%name%> already declared!", new Throwable());
    // Don't propagate while its probably a code generation error!
} catch (InternalErrorException iee) {
    CDMW_ERROR(logger, 
        "Internal exception raised when declaring facet <%name%>!",
        new Throwable());
    org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
        ExceptionMinorCodes.INTERNAL, 
        org.omg.CORBA.CompletionStatus.COMPLETED_NO);
    CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
    throw ex;
}


<%script type="idlmm.AttributeDef" name="genAttributeOperations"%>
   <%-- REQUIRES parent component in context
        (containingComponent cannot be used since
         attribute could come from a supported interface) 
   --%>
public <%type.asReturnParameterDef%> <%name%>() 
    <%if (getExceptions.nSize > 0){%>
    throws <%getExceptions.javaFullClassname.sep(", ")%>
    <%}%>
{
    CDMW_LOG_FUNCTION(logger, "");
    <%peek.equivalentLocalInterface%> compExec = obtain_component_executor();
    <%type.asLocalVariable%> result = compExec.<%name%>();

    try {
        this.executorLocator.release_executor(compExec);
    } catch(org.omg.Components.CCMException ccme) {
        CDMW_ERROR(logger, 
            "Exception received: " + ccme, 
            new Throwable());
        org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNALCCMCIFError,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
        throw ex;
    }
    return result;
}
<%if (mode != "ATTR_READONLY"){%>
public void <%name%>(<%type.asInParameterDef%> <%name%>) 
    <%if (setExceptions.nSize > 0){%>
    throws <%setExceptions.javaFullClassname.sep(", ")%>
    <%}%>
{
    CDMW_LOG_FUNCTION(logger, "");
    <%peek.equivalentLocalInterface%>  compExec = obtain_component_executor();
    compExec.<%name%>(<%name%>);
    try {
        this.executorLocator.release_executor(compExec);
    } catch(org.omg.Components.CCMException ccme) {
        CDMW_ERROR(logger, 
            "Exception received: " + ccme, 
            new Throwable());
        org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNALCCMCIFError,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
            throw ex;
    }
    // set boolean to true (needed for configuration_completed)
    this.is<%name%>Configured = true;
}
<%}%>

    
<%script type="idlmm.OperationDef" name="genOperationImpl"%>
<%-- REQUIRES parent component in context
     (containingComponent cannot be used since
      operation could come from a supported interface) 
--%>
public <%genOperationSignature%>
{
    CDMW_LOG_FUNCTION(logger, "");
            
    <%peek.equivalentLocalInterface%> compExec = obtain_component_executor();
 
    if (cdmw.ccm.ccmcopi.COPIServiceInit.isInitialized()) {
        <%if (! type.isVoid){%>
        <%type.asLocalVariable%> __result =
        <%}%>
        interceptedSupportedInterfacesImpl.<%name%>(<%parameters.name.sep(", ")%>);
        <%if (! type.isVoid){%>
        return __result;
        <%}%>
    }
    
    <%if (! type.isVoid){%>
    <%type.asLocalVariable%> __result =
    <%}%>
    compExec.<%name%>(<%parameters.name.sep(", ")%>);

    try {
        this.executorLocator.release_executor(compExec);
    } catch(org.omg.Components.CCMException ccme) {
        CDMW_ERROR(logger, 
            "Exception received: " + ccme,
            new Throwable());
        org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNALCCMCIFError,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
        throw ex;
     }
     <%if (! type.isVoid){%>
     return __result;
     <%}%>
}


<%script type="idlmm.ProvidesDef" name="genEquivalentOperations"%>
public <%interface_type.asReturnParameterDef%> provide_<%name%>() {
    CDMW_LOG_FUNCTION(logger, "");
    org.omg.CORBA.Object obj;

    try {
        obj = super.provide_facet("<%name%>");
    } catch (org.omg.Components.InvalidName in) {
        CDMW_ERROR(logger, 
            "'<%name%>' is not a valid facet name", 
            new Throwable());
        org.omg.CORBA.OBJECT_NOT_EXIST ex = new org.omg.CORBA.OBJECT_NOT_EXIST(
            ExceptionMinorCodes.OBJECT_NOT_EXIST,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
        throw ex;
    }

    if (obj == null) {
        CDMW_ERROR(logger, 
            "Facet <%name%> is null", 
            new Throwable());
        org.omg.CORBA.OBJECT_NOT_EXIST ex = new org.omg.CORBA.OBJECT_NOT_EXIST(
            ExceptionMinorCodes.OBJECT_NOT_EXIST, 
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
        throw ex;
    }

    <%interface_type.asLocalVariable%> facetRef = <%interface_type.javaFullClassname%>Helper.narrow(obj);
       
    if (facetRef == null) {
        CDMW_ERROR(logger, 
            "Facet <%name%> is not a <%interface_type.javaFullClassname%>", 
            new Throwable());
        org.omg.CORBA.OBJECT_NOT_EXIST ex = new org.omg.CORBA.OBJECT_NOT_EXIST(
            ExceptionMinorCodes.OBJECT_NOT_EXIST, 
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
        throw ex;
    }
       
    return facetRef;
}


<%script type="idlmm.UsesDef" name="genEquivalentOperations"%>
public void connect_<%name%>(<%interface_type.asInParameterDef%> conxn)
    throws org.omg.Components.AlreadyConnected, org.omg.Components.InvalidConnection
{
    CDMW_LOG_FUNCTION(logger, "");
    try {
        super.connect(<%portNameConstName%>, conxn);
    } catch(org.omg.Components.InvalidName in) {
        CDMW_ERROR(logger, 
            "Invalid name for receptacle connection!", 
            new Throwable());
        org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNALCCMCIFError,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
        throw ex;
    } catch(org.omg.Components.ExceededConnectionLimit ecl) {
        CDMW_ERROR(logger, 
            "Exceeded connection limit reached for receptacle connection!", 
            new Throwable());
        org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNALCCMCIFError,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
        throw ex;
    }
}

public <%interface_type.asReturnParameterDef%> disconnect_<%name%>()
    throws org.omg.Components.NoConnection
{
    CDMW_LOG_FUNCTION(logger, "");
    <%interface_type.asLocalVariable%> result = get_connection_<%name%>();
    try {
        super.disconnect(<%portNameConstName%>, null);
    } catch(org.omg.Components.InvalidName in) {
        CDMW_ERROR(logger, 
            "Invalid name for receptacle disconnection!", 
            new Throwable());
        org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNALCCMCIFError,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
        throw ex;
    } catch(org.omg.Components.InvalidConnection ic) {
        CDMW_ERROR(logger, 
            "Invalid connection for receptacle disconnection!", 
            new Throwable());
        org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNALCCMCIFError,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
        throw ex;
    } catch(org.omg.Components.CookieRequired cr) {
        CDMW_ERROR(logger, 
            "Cookie required for receptacle disconnection!", 
            new Throwable());
        org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNALCCMCIFError,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
        throw ex;
    }
    return result;
}

public <%interface_type.asReturnParameterDef%> get_connection_<%name%>() {
    CDMW_LOG_FUNCTION(logger, "");
    org.omg.Components.ConnectionDescription[] compDesc = null;

    try {
        compDesc = super.get_suitable_connections(<%portNameConstName%>);
    } catch (org.omg.Components.InvalidName in) {
        CDMW_ERROR(logger, 
            "Invalid name getting receptacle!", 
            new Throwable());
        org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNAL, 
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
        throw ex;
    } catch (org.omg.CORBA.SystemException se) {
        CDMW_LOG_FUNCTION_EXCEPTION(logger, se);
        throw se;
    }
      
    <%interface_type.asLocalVariable%> result = null;
    if (compDesc.length == 1) {
        org.omg.CORBA.Object obj = compDesc[0].objref;
        result = <%interface_type.javaFullClassname%>Helper.narrow(obj);
    }
      
    return result;
}


<%script type="idlmm.ConsumesDef" name="genEquivalentOperations"%>
public <%event.equivalentConsumer%> get_consumer_<%name%>() {
    CDMW_LOG_FUNCTION(logger, "");
    org.omg.CORBA.Object obj = null;

    try {
         obj = super.get_consumer(<%portNameConstName%>);
    } catch (org.omg.Components.InvalidName in) {
         CDMW_ERROR(logger, 
             "Invalid consumer name", 
             new Throwable());
         org.omg.CORBA.OBJECT_NOT_EXIST ex = new org.omg.CORBA.OBJECT_NOT_EXIST(
             ExceptionMinorCodes.OBJECT_NOT_EXIST,
             org.omg.CORBA.CompletionStatus.COMPLETED_NO);
         CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
         throw ex;
    }

    if (obj == null) {
         CDMW_ERROR(logger, 
             "Consumer is null", 
             new Throwable());
         org.omg.CORBA.OBJECT_NOT_EXIST ex = new org.omg.CORBA.OBJECT_NOT_EXIST(
             ExceptionMinorCodes.OBJECT_NOT_EXIST, 
             org.omg.CORBA.CompletionStatus.COMPLETED_NO);
         CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
         throw ex;
    }

    <%event.equivalentConsumer%> consumerRef =
        <%event.equivalentConsumer%>Helper.narrow(obj);

    if (consumerRef == null) {
        CDMW_ERROR(logger, 
            "Consumer has wrong type", 
            new Throwable());
        org.omg.CORBA.OBJECT_NOT_EXIST ex = new org.omg.CORBA.OBJECT_NOT_EXIST(
            ExceptionMinorCodes.OBJECT_NOT_EXIST, 
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
        throw ex;
    }
       
    return consumerRef;
}



<%script type="idlmm.PublishesDef" name="genEquivalentOperations"%>
public org.omg.Components.Cookie subscribe_<%name%>(<%event.equivalentConsumer%> consumer)
    throws org.omg.Components.ExceededConnectionLimit
{
    CDMW_LOG_FUNCTION(logger, "");
    org.omg.Components.Cookie result = null;
      
    try {
        result = super.subscribe(<%portNameConstName%>, consumer);
    } catch (org.omg.Components.InvalidName in) {
        CDMW_ERROR(logger, 
            "Invalid name for publisher subscription!",
            new Throwable());
        org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNAL, 
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
            throw ex;
    } catch (org.omg.Components.InvalidConnection ic) {
        CDMW_ERROR(logger, "Invalid connection", new Throwable());
        // should never appear!
        org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNAL, 
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
        throw ex;
    } catch (org.omg.Components.ExceededConnectionLimit ecl) {
        CDMW_LOG_FUNCTION_EXCEPTION(logger, ecl);
        throw ecl;
    } catch (org.omg.CORBA.SystemException se) {
        CDMW_LOG_FUNCTION_EXCEPTION(logger, se);
        throw se;
    }
      
    return result;
}

public <%event.equivalentConsumer%> unsubscribe_<%name%>(org.omg.Components.Cookie ck)
    throws org.omg.Components.InvalidConnection
{
    CDMW_LOG_FUNCTION(logger, "");
    if (ck == null){
        CDMW_ERROR(logger, "Cookie is null", new Throwable());
        org.omg.CORBA.BAD_PARAM ex = new org.omg.CORBA.BAD_PARAM(
            ExceptionMinorCodes.BAD_PARAMNilObjectReference, 
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
        throw ex;
    }
       
    <%event.equivalentConsumer%> result = null;
    try {
        org.omg.Components.EventConsumerBase consumer 
            = super.get_consumer(<%portNameConstName%>, ck);

        result = <%event.equivalentConsumer%>Helper.narrow(consumer);

        super.unsubscribe(<%portNameConstName%>, ck);
    } catch (org.omg.Components.InvalidName in) {
        // internal error should not appear
        CDMW_ERROR(logger, "Invalid name for publisher unsubscription!", new Throwable());
        org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNAL, 
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
        throw ex;
    } catch (org.omg.Components.InvalidConnection ic) {
        CDMW_LOG_FUNCTION_EXCEPTION(logger, ic);
        throw ic;
    } catch (org.omg.CORBA.SystemException se) {
        CDMW_LOG_FUNCTION_EXCEPTION(logger, se);
        throw se;
    }

    return result;
}



<%script type="idlmm.EmitsDef" name="genEquivalentOperations"%>
public void connect_<%name%>(<%event.equivalentConsumer%> consumer)
    throws org.omg.Components.AlreadyConnected 
{
    CDMW_LOG_FUNCTION(logger, "");
    try {
        super.connect_consumer(<%portNameConstName%>, consumer);
    } catch (org.omg.Components.InvalidName in) {
        // can not appear!
        CDMW_ERROR(logger, "Invalid name for emitter conection!", new Throwable());
        org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNAL, 
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
        throw ex;
    } catch (org.omg.Components.InvalidConnection ic) {
        // can not appear!
        CDMW_ERROR(logger, "Invalid connection for emitter conection!", new Throwable());
        org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNAL, 
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
        throw ex;
    } catch (org.omg.CORBA.SystemException se) {
        CDMW_LOG_FUNCTION_EXCEPTION(logger, se);
        throw se;
    } 
}

public <%event.equivalentConsumer%> disconnect_<%name%>()
    throws org.omg.Components.NoConnection
{
    CDMW_LOG_FUNCTION(logger, "");
    try {
        org.omg.Components.EventConsumerBase consumer = 
            super.disconnect_consumer(<%portNameConstName%>);

        <%event.equivalentConsumer%> result = 
            <%event.equivalentConsumer%>Helper.narrow(consumer);

        if (result == null) {
            // can not appear!
            CDMW_ERROR(logger, "Old connection had wrong type", new Throwable());
            org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
                ExceptionMinorCodes.INTERNAL, 
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);
            CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
            throw ex;
        }

        return result;
    } catch (org.omg.Components.InvalidName in) {
        // can not appear!
        CDMW_ERROR(logger, "Invalid name for emitter disconection!", new Throwable());
        org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNAL, 
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
        throw ex;
    <%-- //TODO: remove this catch statement if not needed
    } catch (org.omg.Components.InvalidConnection ic) {
        // can not appear!
        throw new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNAL, 
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
    --%>
    } catch (org.omg.CORBA.SystemException se) {
        CDMW_LOG_FUNCTION_EXCEPTION(logger, se);
        throw se;
    } 
}



<%script type="idlmm.AttributeDef" name="genAttributeInitCheck"%>
// check if the attribute have been initialised only if not created by a factory op
if (!this.is<%name%>Configured) {
    // component is not well configured
    CDMW_ERROR(logger, 
        "Attribut <%name%> not initialised!",
        new Throwable());
    org.omg.Components.InvalidConfiguration ex = new org.omg.Components.InvalidConfiguration();
    CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
    throw ex;
}



    <%--  
    This template generates the code for an intercepted operation.
    Required in context (using <%push()%>):
      - The component owning this operation
        (containingComponent cannot be used since
         operation could come from a supported interface) 
    --%>
<%script type="idlmm.OperationDef" name="genInterceptedOperation"%>
public <%genOperationSignature%>
{
    CDMW_LOG_FUNCTION(logger, "");
            
    <%peek.equivalentLocalInterface%> compExec = compServant.obtain_component_executor();
            
    String feature_name = "";
    org.omg.CORBA.Object target = compExec;
    String component_identity = compServant.get_component_identity();

    <%genInterceptionCode("compExec")%>

    try {
        compServant.executorLocator.release_executor(compExec);
    } catch(org.omg.Components.CCMException ccme) {
        CDMW_ERROR(logger, 
            "Exception received: " + ccme,
            new Throwable());
        org.omg.CORBA.INTERNAL ex = new org.omg.CORBA.INTERNAL(
            ExceptionMinorCodes.INTERNALCCMCIFError,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        CDMW_LOG_FUNCTION_EXCEPTION(logger, ex);
        throw ex;
    }

    <%genInterceptionCode2%>

    <%if (!type.isVoid){%>
    return __result;
    <%}%>
}

<%genRequestClass("cdmw.ccm.ccmcopi.ContainerServantRequest")%>


