<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.cdmw.codegenerator.lifecycle.LifeCycleServices
import com.thalesgroup.cdmw.codegenerator.lifecycle.ModelServices
import com.thalesgroup.cdmw.codegenerator.lifecycle.Utils
import com.thalesgroup.cdmw.codegenerator.lifecycle.java.Utils
import com.thalesgroup.ccm.codegenerator.corba.CommonServices
import com.thalesgroup.ccm.codegenerator.corba.java.BasicTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.java.ComplexTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.java.IDLTypeFallback
import com.thalesgroup.ccm.codegenerator.corba.java.Utils
import com.thalesgroup.ccm.codegenerator.corba.java.JavaMappingServices
import com.thalesgroup.ccm.codegenerator.container.Utils
%>


<%script type="idlmm.Repository" name="javaFilePath" post="trim()"%>
<%if (factoryImplClassnameScope.length() > 0){%>
<%directoryPrefix%><%factoryImplClassnameScope.replaceAll("\.", "/")%>/<%factoryImplClassname%>.java
<%}else{%>
<%directoryPrefix%><%factoryImplClassname%>.java
<%}%>



<%--
  -- If directory attribute is specified for the <program>,
  -- this script returns the directory +"/"
  --%>
<%script type="idlmm.Repository" name="directoryPrefix" post="trim()"%>
<%if (factoryImplDirectory.length > 0){%>
<%factoryImplDirectory%>/
<%}%>



<%--
  -- Generation template  
  -- This template is not model-based (idlmm.Repository is just specified
  -- to access InterfaceDef data)
  -- All is based on LifeCycleServices which provides access to loaded data
  -- from XML file.
  --%>
<%script type="idlmm.Repository" name="ServiceFactory" file="<%javaFilePath%>"%>
<%copyrightHeader%>

<%if (factoryImplClassnameScope.length() > 0){%>
package <%factoryImplClassnameScope%>;
<%}%>

import cdmw.common.Assert;
import cdmw.common.BadParameterException;

import cdmw.orbsupport.ORBSupport;
import cdmw.orbsupport.StrategyList;
import cdmw.orbsupport.PolicyList;
import cdmw.orbsupport.ExceptionMinorCodes;

import cdmw.lifecycle.NoRetainObjectDeactivator;
import cdmw.lifecycle.POAThreadingPolicy;
import cdmw.lifecycle.ServantProviderBase;
import cdmw.lifecycle.ObjectUtil;

public class <%factoryImplClassname%>
    extends <%idlInterface.javaFullClassname%>POA {

    private org.omg.CORBA.ORB orb;

    private org.omg.PortableServer.POA poa;

    private org.omg.PortableServer.POA objectsPOA;

    private String factoryName;

    private NoRetainObjectDeactivator objectDeactivator;

    private <%javaScopedServantProviderClassname%> servantProvider;

    // ----------------------------------------------------------------------
    // Resource Servant locator
    // ----------------------------------------------------------------------

    public class TheServantLocator
        extends org.omg.CORBA.LocalObject 
        implements org.omg.PortableServer.ServantLocator {

        private ServantProviderBase servantProvider;

        public TheServantLocator(ServantProviderBase provider) {
            this.servantProvider = provider;
            Assert.check(this.servantProvider != null);
        }

        public org.omg.PortableServer.Servant preinvoke(
            byte[] oid,
            org.omg.PortableServer.POA poa,
            String operation,
            org.omg.PortableServer.ServantLocatorPackage.CookieHolder theCookie)
            throws org.omg.PortableServer.ForwardRequest {
            Assert.check(servantProvider != null);
            return servantProvider.lookupServant(oid);
        }

        public void postinvoke(
            byte[] oid,
            org.omg.PortableServer.POA poa,
            String operation,
            Object theCookie,
            org.omg.PortableServer.Servant theServant) {
            Assert.check(servantProvider != null);
            servantProvider.releaseServant(oid, poa, theServant);
        }

    }
    
    /**
     * Constructor
     *
     * @param orb
     * @param parent
     * @param factoryName
     * @param threadingPolicy
     * @param args
    
     * @exception BadParameterException
     * @exception org.omg.CORBA.SystemException
     */
    public <%factoryImplClassname%>(
        org.omg.CORBA.ORB orb,
        org.omg.PortableServer.POA parent,
        String factoryName,
        POAThreadingPolicy threadingPolicy,
        String[] args)
        throws BadParameterException, org.omg.CORBA.SystemException 
    {
        this.orb = orb;
        this.poa = parent;
        this.objectsPOA = null;
        this.factoryName = factoryName;
        this.objectDeactivator = new NoRetainObjectDeactivator(orb);
        this.servantProvider = null;

        //
        // Create POA for use by the factory
        //
        // Service Life cycle framework use the following POA policies
        //
        // Lifespan policy            = TRANSIENT
        // Id Assignment policy       = USER_ID
        // Id Uniqueness policy       = MULTIPLE_ID ** Not Relevant
        // Implicit Activation policy = NO_IMPLICIT_ACTIVATION
        // Request Processing policy  = USE_SERVANT_MANAGER;
        // Servant Retention policy   = NO_RETAIN;
        //
        org.omg.PortableServer.POAManager poaManager = parent.the_POAManager();
        PolicyList policies = new PolicyList();
        policies.insert(
            parent.create_id_assignment_policy(
                org.omg.PortableServer.IdAssignmentPolicyValue.USER_ID));
        policies.insert(
            parent.create_lifespan_policy(
                org.omg.PortableServer.LifespanPolicyValue.TRANSIENT));
        policies.insert(
            parent.create_servant_retention_policy(
                org.omg.PortableServer.ServantRetentionPolicyValue.NON_RETAIN));
        policies.insert(
            parent.create_id_uniqueness_policy(
                org.omg.PortableServer.IdUniquenessPolicyValue.MULTIPLE_ID));
        policies.insert(
            parent.create_request_processing_policy(
                org.omg.PortableServer.RequestProcessingPolicyValue.USE_SERVANT_MANAGER));
        policies.insert(
            parent.create_implicit_activation_policy(
                org.omg.PortableServer.ImplicitActivationPolicyValue.NO_IMPLICIT_ACTIVATION));

        StrategyList poaStrategies = new StrategyList();

        <%if (isMultithread){%>
            <%--
               MULTITHREAD
            --%>
        // Strategies with MULTITHREAD policy will accept Single Thread and
        // Multi Thread strategies. However, SERIALIZE policy will only allow
        // Single Thread policy.
        threadingPolicy.appendToStrategyList(poaStrategies);

        <%}else{%>
            <%--
               SERIALIZE
            --%>
        // For Single Thread policy, first check validity of 'threading_policy' using 
        // the code below : Begin Threading policy check
    
        // Check Multi-Threading Policy
        try {
            cdmw.lifecycle.SingleThreadPolicy singleThread
                = (cdmw.lifecycle.SingleThreadPolicy) threadingPolicy;
            singleThread.appendToStrategyList(poaStrategies);
        } catch (ClassCastException cce) {
            // Wrong policy
            String parameter = "cdmw.lifecycle.POAThreadingPolicy(" + factoryName + ")";
            throw new BadParameterException(parameter, threadingPolicy.getClass().getName());
        }
        // End Threading policy check
        <%}%>
        
        try {
            objectsPOA =
                ORBSupport.createPOA(
                    poa,
                    factoryName,
                    poaManager,
                    policies,
                    poaStrategies);

            //
            // Create and install servant provider
            //
            <%servantProviderAllocatorClassname%>  allocator =
                new <%servantProviderAllocatorClassname%>();
            cdmw.lifecycle.ServantProviderBase srvprvd = 
                allocator.allocate(orb,
                                   objectsPOA,
                                   objectDeactivator,
                                   args);
            Assert.check(srvprvd != null);
            try {
                servantProvider = (<%javaScopedServantProviderClassname%>) srvprvd;
            } catch (ClassCastException e) {
                // Shouldn't happen since <%servantProviderAllocatorClassname%>.allocate()
                // must return a <%javaScopedServantProviderClassname%>
                Assert.check(false);
            }

            //
            // Create and install servant locator
            //
            objectsPOA.set_servant_manager(
                new TheServantLocator(servantProvider));

        } catch (org.omg.PortableServer.POAPackage.AdapterAlreadyExists aae) {
            throw new org.omg.CORBA.INTERNAL(
                ExceptionMinorCodes.INTERNALLifeCycleFrameworkError,
                org.omg.CORBA.CompletionStatus.COMPLETED_YES);
        } catch (org.omg.PortableServer.POAPackage.InvalidPolicy ip) {
            throw new org.omg.CORBA.INTERNAL(
                ExceptionMinorCodes.INTERNALLifeCycleFrameworkError,
                org.omg.CORBA.CompletionStatus.COMPLETED_YES);
        } catch (org.omg.PortableServer.POAPackage.WrongPolicy wp) {
            throw new org.omg.CORBA.INTERNAL(
                ExceptionMinorCodes.INTERNALLifeCycleFrameworkError,
                org.omg.CORBA.CompletionStatus.COMPLETED_YES);
        }
    }

    /**
     * Returns the default POA.
     *
     * @return The default POA.
     */
    public org.omg.PortableServer.POA _default_POA() {
        return this.poa;
    }

    <%--                
      Create the operation declarations.
    --%>
    <%for (idlInterface.findAllFactoryOperations){%>
    <%generateOperation%>
    
    <%}%>

    //
    // IDL:thalesgroup.com/CdmwLifeCycle/FactoryBase/supports:1.0
    //
    /**
     * Tests if the servant provider supports an object
     * represented by its repositoryId
     *
     * @param repositoryId
     * @return True if the servant provider supports the object otherwise false.
     */
    public boolean supports(String repositoryId) {
        return this.servantProvider.supports(repositoryId);
    }

    //
    // IDL:thalesgroup.com/CdmwLifeCycle/FactoryBase/get_supported_objects:1.0
    //
    /**
     * Returns the supported objects by the servant provider
     *
     * @return List of the supported objects as a String table
     */
    public String[] get_supported_objects() {
        return this.servantProvider.getSupportedObjects();
    }

}





<%script type="idlmm.OperationDef" name="generateOperation"%>
<%checkCdmwLifeCycleKeyParameterForAnonymousFactory%>
public <%type.asReturnParameterDef%> <%name%>(<%parameters[mode == "PARAM_IN"].genParameterDef.sep(", ")%>)
    throws 
        <%for (exceptions){%>
        <%javaFullClassname%>,
        <%}%>
        org.omg.CORBA.SystemException
{
    // [I] Acquire oid from user for object_key
    // Operation may throw user exceptions that will re-thrown to caller
    byte[] oid = servantProvider.<%name%>(
        <%parameters[mode == "PARAM_IN" && !type.isCdmwLifeCycleKey].name.sep(", ")%>
        );
    // [II] Create its object reference
    org.omg.CORBA.Object obj =
        ObjectUtil.createObjectReference(objectsPOA, oid, servantProvider);
    return <%type.javaFullClassname%>Helper.narrow(obj);

}






    
    
