<%
metamodel http://www.prismtech.com/idlmm

import com.thalesgroup.cdmw.codegenerator.lifecycle.LifeCycleServices
import com.thalesgroup.cdmw.codegenerator.lifecycle.ModelServices
import com.thalesgroup.cdmw.codegenerator.lifecycle.Utils
import com.thalesgroup.cdmw.codegenerator.lifecycle.java.Utils
import com.thalesgroup.ccm.codegenerator.corba.CommonServices
import com.thalesgroup.ccm.codegenerator.corba.java.BasicTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.java.ComplexTypesMapping
import com.thalesgroup.ccm.codegenerator.corba.java.IDLTypeFallback
import com.thalesgroup.ccm.codegenerator.corba.java.Utils
import com.thalesgroup.ccm.codegenerator.corba.java.JavaMappingServices
import com.thalesgroup.ccm.codegenerator.container.Utils
%>


<%script type="idlmm.Repository" name="javaFilePath" post="trim()"%>
<%if (factoryImplClassnameScope.length() > 0){%>
<%directoryPrefix%><%factoryImplClassnameScope.replaceAll("\.", "/")%>/<%factoryImplClassname%>.java
<%}else{%>
<%directoryPrefix%><%factoryImplClassname%>.java
<%}%>



<%--
  -- If directory attribute is specified for the <program>,
  -- this script returns the directory +"/"
  --%>
<%script type="idlmm.Repository" name="directoryPrefix" post="trim()"%>
<%if (factoryImplDirectory.length > 0){%>
<%factoryImplDirectory%>/
<%}%>



<%--
  -- Generation template  
  -- This template is not model-based (idlmm.Repository is just specified
  -- to access InterfaceDef data)
  -- All is based on LifeCycleServices which provides access to loaded data
  -- from XML file.
  --%>
<%script type="idlmm.Repository" name="UnmanagedEntityFactory" file="<%javaFilePath%>"%>
<%copyrightHeader%>

<%if (factoryImplClassnameScope.length() > 0){%>
package <%factoryImplClassnameScope%>;
<%}%>

import cdmw.common.Assert;
import cdmw.common.BadParameterException;

import cdmw.orbsupport.ORBSupport;
import cdmw.orbsupport.StrategyList;
import cdmw.orbsupport.PolicyList;
import cdmw.orbsupport.ExceptionMinorCodes;

import cdmw.lifecycle.RetainObjectDeactivator;
import cdmw.lifecycle.POAThreadingPolicy;
import cdmw.lifecycle.ServantProviderBase;
import cdmw.lifecycle.ObjectUtil;
import cdmw.lifecycle.ObjectRegistrationGuard;

public class <%factoryImplClassname%>
    extends <%idlInterface.javaFullClassname%>POA {
    
    /**
     * Maximum number of retries on receiving TRANSIENT exception
     * for registering objects.
     */
    public final static int MAX_RETRIES = 1;

    private org.omg.CORBA.ORB orb;

    private org.omg.PortableServer.POA poa;

    private org.omg.PortableServer.POA objectsPOA;

    private com.thalesgroup.CdmwNamingAndRepository.NameDomain domain;

    private String domainName;

    private String factoryName;

    private RetainObjectDeactivator objectDeactivator;

    private <%javaScopedServantProviderClassname%> servantProvider;

    // ----------------------------------------------------------------------
    // Resource Servant activator
    // ----------------------------------------------------------------------

    public class TheServantActivator
        extends org.omg.CORBA.LocalObject
        implements org.omg.PortableServer.ServantActivator {

        private ServantProviderBase servantProvider;

        public TheServantActivator(ServantProviderBase provider) {
            this.servantProvider = provider;
            Assert.check(this.servantProvider != null);
        }

        public org.omg.PortableServer.Servant incarnate(
            byte[] oid,
            org.omg.PortableServer.POA poa)
            throws org.omg.PortableServer.ForwardRequest {
            Assert.check(this.servantProvider != null);
            return servantProvider.lookupServant(oid);
        }

        public void etherealize(
            byte[] oid,
            org.omg.PortableServer.POA poa,
            org.omg.PortableServer.Servant servant,
            boolean cleanupInProgress,
            boolean remainingActivations) {
            Assert.check(this.servantProvider != null);
            if (!remainingActivations) {
                this.servantProvider.releaseServant(oid, poa, servant);
            }
        }
    }


    /**
     * Constructor
     *
     * @param orb
     * @param parent
     * @param nameDomain
     * @param nameDomainName
     * @param factoryName
     * @param threadingPolicy
     * @param args
     *
     * @exception BadParameterException
     * @exception org.omg.CORBA.SystemException
     */
    public <%factoryImplClassname%>(
        org.omg.CORBA.ORB orb,
        org.omg.PortableServer.POA parent,
        com.thalesgroup.CdmwNamingAndRepository.NameDomain nameDomain,
        String nameDomainName,
        String factoryName,
        POAThreadingPolicy threadingPolicy,
        String[] args)
        throws BadParameterException, org.omg.CORBA.SystemException {

        this.orb = orb;
        this.poa = parent;
        this.objectsPOA = null;
        this.domain = nameDomain;
        this.domainName = nameDomainName;
        this.factoryName = factoryName;
        this.objectDeactivator = new RetainObjectDeactivator(orb);
        this.servantProvider = null;

        //
        // Create POA for use by the factory
        //
        // Entity Life cycle framework use the following POA policies
        //
        // Lifespan policy            = PERSISTENT
        // Id Assignment policy       = USER_ID
        // Id Uniqueness policy       = UNIQUE_ID
        // Implicit Activation policy = NO_IMPLICIT_ACTIVATION
        // Request Processing policy  = USE_SERVANT_MANAGER;
        // Servant Retention policy   = RETAIN;
        //

        org.omg.PortableServer.POAManager poaManager =
            this.poa.the_POAManager();
        PolicyList policies = new PolicyList();
        policies.insert(
            parent.create_id_assignment_policy(
                org.omg.PortableServer.IdAssignmentPolicyValue.USER_ID));
        policies.insert(
            parent.create_lifespan_policy(
                org.omg.PortableServer.LifespanPolicyValue.PERSISTENT));
        policies.insert(
            parent.create_servant_retention_policy(
                org.omg.PortableServer.ServantRetentionPolicyValue.RETAIN));
        policies.insert(
            parent.create_id_uniqueness_policy(
                org.omg.PortableServer.IdUniquenessPolicyValue.UNIQUE_ID));
        policies.insert(
            parent.create_request_processing_policy(
                org.omg.PortableServer.RequestProcessingPolicyValue.USE_SERVANT_MANAGER));
        policies.insert(
            parent.create_implicit_activation_policy(
                org.omg.PortableServer.ImplicitActivationPolicyValue.NO_IMPLICIT_ACTIVATION));

        StrategyList poaStrategies = new StrategyList();

        <%if (isMultithread){%>
            <%--
               MULTITHREAD
            --%>
        // Strategies with MULTITHREAD policy will accept Single Thread and
        // Multi Thread strategies. However, SERIALIZE policy will only allow
        // Single Thread policy.
        threadingPolicy.appendToStrategyList(poaStrategies);

        <%}else{%>
            <%--
               SERIALIZE
            --%>
        // For Single Thread policy, first check validity of 'threading_policy' using 
        // the code below : Begin Threading policy check
    
        // Check Multi-Threading Policy
        try {
            cdmw.lifecycle.SingleThreadPolicy singleThread
                = (cdmw.lifecycle.SingleThreadPolicy) threadingPolicy;
            singleThread.appendToStrategyList(poaStrategies);
        } catch (ClassCastException cce) {
            // Wrong policy
            String parameter = "cdmw.lifecycle.POAThreadingPolicy(" + factoryName + ")";
            throw new BadParameterException(parameter, threadingPolicy.getClass().getName());
        }
        // End Threading policy check
        <%}%>
        
        try {
            objectsPOA =
                ORBSupport.createPOA(
                    poa,
                    factoryName,
                    poaManager,
                    policies,
                    poaStrategies);
            //
            // Create and install servant provider
            //
            <%servantProviderAllocatorClassname%> allocator = 
                new <%servantProviderAllocatorClassname%>();
            cdmw.lifecycle.ServantProviderBase srvprvd = 
                allocator.allocate(orb,
                                   objectsPOA,
                                   objectDeactivator,
                                   args);
            Assert.check(srvprvd != null);
            try {
                servantProvider = (<%javaScopedServantProviderClassname%>) srvprvd;
            } catch (ClassCastException e) {
                // Shouldn't happen since <%servantProviderAllocatorClassname%>.allocate()
                // must return a <%javaScopedServantProviderClassname%>
                Assert.check(false);
            }

            // Hand Shaking with the Servant Provider
            // IDs should be unique
            if (servantProvider.mayIncarnateMultipleObjects()) {
                String parameter = "ObjectId Uniqueness(" + factoryName + ")";
                throw new BadParameterException(parameter);
            }

            //
            // Create and install servant activator
            //
            objectsPOA.set_servant_manager(
                new TheServantActivator(servantProvider));

        } catch (BadParameterException bpe) {
            throw bpe;
        } catch (org.omg.PortableServer.POAPackage.AdapterAlreadyExists aae) {
            throw new org.omg.CORBA.INTERNAL(
                ExceptionMinorCodes.INTERNALLifeCycleFrameworkError,
                org.omg.CORBA.CompletionStatus.COMPLETED_YES);
        } catch (org.omg.PortableServer.POAPackage.InvalidPolicy ip) {
            throw new org.omg.CORBA.INTERNAL(
                ExceptionMinorCodes.INTERNALLifeCycleFrameworkError,
                org.omg.CORBA.CompletionStatus.COMPLETED_YES);
        } catch (org.omg.PortableServer.POAPackage.WrongPolicy ip) {
            throw new org.omg.CORBA.INTERNAL(
                ExceptionMinorCodes.INTERNALLifeCycleFrameworkError,
                org.omg.CORBA.CompletionStatus.COMPLETED_YES);
        }

    }

    /**
     * Returns the default POA.
     *
     * @return The default POA.
     */
    public org.omg.PortableServer.POA _default_POA() {
        return this.poa;
    }


    <%--                
      Create the operation declarations.
    --%>
    <%for (idlInterface.findAllFactoryOperations){%>
    <%generateOperation%>
    
    <%}%>

    //
    // IDL:thalesgroup.com/CdmwLifeCycle/FactoryBase/supports:1.0
    //
    /**
     * Tests if the servant provider supports an object
     * represented by its repositoryId
     *
     * @param repositoryId
     * @return True if the servant provider supports the object otherwise false.
     */
    public boolean supports(String repositoryId) {
        return this.servantProvider.supports(repositoryId);
    }

    //
    // IDL:thalesgroup.com/CdmwLifeCycle/FactoryBase/get_supported_objects:1.0
    //
    /**
     * Returns the supported objects by the servant provider
     *
     * @return List of the supported objects as a String table
     */
    public String[] get_supported_objects() {
        return this.servantProvider.getSupportedObjects();
    }
    
    /**
     * Register the name objectKey within the NameDomain. This
     * will check validity of the name and whether it is already in use.
     *
     * @param objectKey
     * @exception com.thalesgroup.CdmwLifeCycle.AlreadyExistant
     * @exception org.omg.CORBA.SystemException
     * @exception com.thalesgroup.CdmwLifeCycle.InvalidName
     * @return Registration ID as a org.omg.CORBA.Any object
     */
    private org.omg.CORBA.Any registerName(String objectKey)
        throws
            com.thalesgroup.CdmwLifeCycle.AlreadyExistant,
            org.omg.CORBA.SystemException,
            com.thalesgroup.CdmwLifeCycle.InvalidName {

        org.omg.CORBA.Any regId;
        try {
            regId = domain.new_name(objectKey);
        } catch (com.thalesgroup.CdmwNamingAndRepository.NameDomainPackage.AlreadyExists ae) {
            // Add more information to help the caller in debuging
            String reason = domainName + "/" + objectKey;
            throw new com.thalesgroup.CdmwLifeCycle.AlreadyExistant(reason);
        } catch (com.thalesgroup.CdmwNamingAndRepository.InvalidName in) {
            throw new com.thalesgroup.CdmwLifeCycle.InvalidName(in.reason);
        } catch (org.omg.CORBA.OBJECT_NOT_EXIST one) {
            // Oops! CDMW Repository has been destroyed
            throw new org.omg.CORBA.INTERNAL(
                ExceptionMinorCodes.INTERNALCdmwRepositoryNotExists,
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        } catch (org.omg.CORBA.SystemException se) {
            // Cannot reach the CDMW Repository at the moment, retry later!
            throw new org.omg.CORBA.TRANSIENT(
                ExceptionMinorCodes.TRANSIENTCannotReachRepository,
                org.omg.CORBA.CompletionStatus.COMPLETED_NO);
        }
        return regId;

    }

    /**
     * Register (name,object) within the repository. The name has already been
     * registered, so this should succeed. In case of a TRANSIENT system
     * exception, there will be a retry max_retries times.
     * If max_retries == 0, then this will retry forever.
     *
     * @param regId
     * @param theObject
     * @param maxRetries
     * @exception org.omg.CORBA.SystemException
     */
    private void registerObject(
        org.omg.CORBA.Any regId,
        org.omg.CORBA.Object theObject,
        int maxRetries)
        throws org.omg.CORBA.SystemException {
        boolean forever = (maxRetries <= 0);
        int counter = maxRetries;

        do {
            try {
                domain.register_object(regId, theObject);
                break;
            } catch (com.thalesgroup.CdmwNamingAndRepository.NameDomainPackage.AlreadyExists ae) {
                // Registration will be cancelled by the ObjectRegistrationGuard
                throw new org.omg.CORBA.INTERNAL(
                    ExceptionMinorCodes.INTERNALCdmwRepositoryError,
                    org.omg.CORBA.CompletionStatus.COMPLETED_YES);
            } catch (com.thalesgroup.CdmwNamingAndRepository.NameDomainPackage.InvalidRegistration ir) {
                // Registration will be cancelled by the ObjectRegistrationGuard
                throw new org.omg.CORBA.INTERNAL(
                    ExceptionMinorCodes.INTERNALCdmwRepositoryError,
                    org.omg.CORBA.CompletionStatus.COMPLETED_YES);
            } catch (org.omg.CORBA.TRANSIENT t) {
                // Retry
            } catch (org.omg.CORBA.SystemException se) {
                // Cancel registration ????
                throw se;
            }
        } while (forever || (--counter > 0));

        if (!forever && (counter <= 0)) {
            throw new org.omg.CORBA.TRANSIENT(
                ExceptionMinorCodes.TRANSIENTCannotReachRepository,
                org.omg.CORBA.CompletionStatus.COMPLETED_YES);
        }

    }

}
             
                

<%script type="idlmm.OperationDef" name="generateOperation"%>
<%checkCdmwLifeCycleKeyParameterForNamedFactory%>
public <%type.asReturnParameterDef%> <%name%>(<%parameters[mode == "PARAM_IN"].genParameterDef.sep(", ")%>)
    throws 
        <%for (exceptions){%>
        <%javaFullClassname%>,
        <%}%>
        org.omg.CORBA.SystemException
{
    <%type.asLocalVariable%> ref = null;
    byte[] oid;
    // [I] Register the name object_key within the NameDomain. This
    // will check validity of the name and whether it is already in use.
    org.omg.CORBA.Any regId = registerName(object_key);
    // Object's name has been registered successfuly. From now on,
    // it should be unregistered if an exception has to be rethrown
    ObjectRegistrationGuard unreg =
        new ObjectRegistrationGuard(domain, object_key);
    try {
        // [II] Acquire oid from user for object_key
        // Operation may throw user exceptions that will rethrown to caller
        oid = servantProvider.<%name%>(
            <%parameters[mode == "PARAM_IN" && !type.isCdmwLifeCycleKey].name.sep(", ")%>
            );
        // [III] Activate the object immediately :
        //       [a] Acquire a servant from user for oid
        //       [b] Activate the object (using a servant activator)
        //       [c] Create the object reference
        //       [d] Assert the object is really of the expected type
        org.omg.CORBA.Object obj =
            ObjectUtil.activateObject(objectsPOA, oid, servantProvider);
        ref = <%type.javaFullClassname%>Helper.narrow(obj);
        // [IV] Register (name,object) within the repository. In case of
        // an exception ObjectRegistrationGuard will try to unregister
        // the name, even if there a high probability
        // that this may not work.
        registerObject(regId, ref, MAX_RETRIES);
        // [V] Return the object reference
        // Everything is OK, so we "do not rollback" the registration
        unreg.cancel();
    } finally {
        unreg.destroy();
    }

    return ref;
}





